<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Text;
use common\libraries\Hashing;
use common\libraries\Display;

//check if user is allowed here...
if ((intval($_uid) == 0) || !$is_platformadmin)
{// not allowed here!
    Display::normal_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $action = campus::get_POST_GET("action", "step1");
    $useridCol = campus::get_POST_GET("useridCol");
    $dbidCol = campus::get_POST_GET("dbidCol");
    $lastnameCol = campus::get_POST_GET("lastnameCol");
    $firstnameCol = campus::get_POST_GET("firstnameCol");
    $birthCol = campus::get_POST_GET("birthCol");
    $usernameCol = campus::get_POST_GET("usernameCol");
    $passwordCol = campus::get_POST_GET("passwordCol");
    $addressCol = campus::get_POST_GET("addressCol");
    $telCol = campus::get_POST_GET("telCol");
    $officialcodeCol = campus::get_POST_GET("officialcodeCol");
    $photoCol = campus::get_POST_GET("photoCol");
    $mailCol = campus::get_POST_GET("mailCol");
    $row1 = campus::get_POST_GET("row1", "off");

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if ((($lastnameCol == '') || ($firstnameCol == '') || ($birthCol == '')) && ($action == 'step2'))
    {

        Display::warning_message(get_lang('selectcolomsNIO'), false);
        $action = 'step1';
    }

    // create a list of teacherclasses off the department
    $classes = campus::get_teacherclasses($department_id);

    switch ($action)
    {
        case "step1" :
            {
                /*
                  ==============================================================================
                  Step 1: display importform.....
                  Select import-file and select cols....
                  ==============================================================================
                 */
                // reset session....
                unset($_SESSION['userdata']);
                echo '
			<form method="post" action="' . $this->get_campus_admin_url() . '" name="importform" enctype="multipart/form-data">
			<input type="hidden" name="action" value="step2" >
			<input type="hidden" name="page" value="addstudents" >
			<input type="hidden" name="MAX_FILE_SIZE" value="100000">
			<table>
				<tr valign="top">
					<td align="right">
					' . get_lang('labelUserIDCol') . '
                                        </td>
					<td>
						<input type="text" name="useridCol" size="2" maxlength="2" value="" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
					</td>
					<td align="right">
					' . get_lang('labelDisableRow1') . '
					</td>
					<td>
						<input type="checkbox" name="row1" value="on" checked>
					</td>
					<td width="50%" rowspan="10">
					' . get_lang('helpStudentImport') . '<br>
					<div style="color: #777777">
						<u>' . get_lang('txtCsvImport') . '</u><br>
						 Achternaam;Voornaam;geb.datum;gebruikersnaam;Adres;Telefoon;Stamnr.;fotonaam;e-mail<br>
						 xxx;xxx;yyyy-mm-dd;xxx;xxxx;xxx;xxx;xxx;xxx<br>
						 xxx;xxx;yyyy-mm-dd;xxx;xxxx;xxx;xxx;xxx;xxx<br>
						<br><u>' . get_lang('txtCsvExample') . '</u><br>
						 Achternaam;Voornaam;geb.datum;gebruikersnaam;Adres;Telefoon;Stamnr.;fotonaam;e-mail<br>
						 Vermeulen;Joske;1995-11-24;Trammesantlei 22, 2900 SCHOTEN ;011 79 72 04;2007000001;joske.jpg;joske.vermeulen@gmail.com<br>
						 Vermeulen;Josephine;1993-04-15;Trammesantlei 22, 2900 SCHOTEN ;011 79 72 04;2007000001;joske.jpg;josephineke@gmail.com<br>
					</div>
						</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelDbIDCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="dbidCol" size="2" maxlength="2" value="" />
					</td>
				</tr>
    			<tr valign="top">
					<td align="right">
						' . get_lang('labelNameCol') . '
					</td>
					<td	colspan="3">
						<input type="text" name="lastnameCol" size="2" maxlength="2" value="0" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
					</td>
				</tr>
				<tr	valign="top">
					<td align="right">
						' . get_lang('labelFirstNameCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="firstnameCol" size="2" maxlength="2" value="1" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelBirthCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="birthCol" size="2" maxlength="2" value="2" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelUsernameCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="usernameCol" size="2" maxlength="2" value="" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelPasswordCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="passwordCol" size="2" maxlength="2" value="" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelAddressCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="addressCol" size="2" maxlength="2" value="3" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelPhoneCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="telCol" size="2" maxlength="2" value="4" />
					</td>
				</tr>
					<tr valign="top">
					<td align="right">
						' . get_lang('labelMailCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="mailCol" size="2" maxlength="2" value="" />
					</td>
				</tr>
			<tr valign="top">
					<td align="right">
						' . get_lang('labelOfficialcodeCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="officialcodeCol" size="2" maxlength="2" value="5" />
					</td>	
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelPhotoCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="photoCol" size="2" maxlength="2" value="" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelSelectFile2Import') . '
					</td>
					<td colspan="3">
						<input type="file" name="uploadfile" >
						<br />
					</td>
				</tr>
				<tr valign="top">
					<td>
					</td>
					<td colspan="3">
						<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelUpload') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.importform.page.value=\'\';document.importform.action.value=\'list\';">
					</td>
				</tr>
				</table>
			</form>
			';
            }
            break;
        case "step2":
            {
                /*
                  ==============================================================================
                  Step 2: check new users with existing platform users...
                  Show import options....
                  ==============================================================================
                 */

                if (!empty($_FILES) || !empty($_SESSION['userdata'])) // het bestand lezen...
                {
                    if (!empty($_SESSION['userdata']))
                    {
                        //
                        $lines = $_SESSION['userdata'];
                    }
                    else
                    {
                        //Het bestand inlezen ....
                        $lines = file($_FILES['uploadfile']['tmp_name']);
                    }
                    // existing usernames in array...
                    $existingusernames = array();
                    $sql = 'SELECT `username`,concat(`lastname`, " ", `firstname`, " (", `birth`, " ", `address`, ")") as userdetail FROM `user_user` LEFT JOIN `campus_user` ON `user_user`.`id` = `campus_user`.`user_id`';
                    $result = mysql_query($sql);
                    while ($rij = mysql_fetch_array($result))
                    {
                        $existingusernames[$rij['username']] = $rij['userdetail'];
                    }
                    echo '
				<form method="post" action="' . $this->get_campus_admin_url() . '" name="importform">
				<input type="hidden" name="action" value="step3" >
				<input type="hidden" name="page" value="addstudents" >
				<input type="hidden" name="useridCol" size="2" maxlength="2" value="' . $useridCol . '" />
				<input type="hidden" name="dbidCol" size="2" maxlength="2" value="' . $dbidCol . '" />
				<input type="hidden" name="lastnameCol" size="2" maxlength="2" value="' . $lastnameCol . '" />
				<input type="hidden" name="firstnameCol" size="2" maxlength="2" value="' . $firstnameCol . '" />
				<input type="hidden" name="officialcodeCol" size="2" maxlength="2" value="' . $officialcodeCol . '" />
				<input type="hidden" name="usernameCol" size="2" maxlength="2" value="' . $usernameCol . '" />
				<input type="hidden" name="passwordCol" size="2" maxlength="2" value="' . $passwordCol . '" />
				<input type="hidden" name="birthCol" size="2" maxlength="2" value="' . $birthCol . '" />
				<input type="hidden" name="addressCol" size="2" maxlength="2" value="' . $addressCol . '" />
				<input type="hidden" name="mailCol" size="2" maxlength="2" value="' . $mailCol . '" />
				<input type="hidden" name="telCol" size="2" maxlength="2" value="' . $telCol . '" />
				<input type="hidden" name="photoCol" size="2" maxlength="2" value="' . $photoCol . '" />
				<input type="hidden" name="row1" size="2" maxlength="2" value="' . $row1 . '" />';
                    $_SESSION['userdata'] = $lines;
                    campus::display_complex_table_header($properties, array(get_lang("colheadID"), get_lang("colheadName"), get_lang("colheadFirstName"), get_lang("colheadBirth"),get_lang("colheadDB_ID"), get_lang("colheadOfficialCode"), get_lang("colheadAddress"), get_lang("colheadMail"), get_lang("colheadPhone"), get_lang("colheadPhoto"), get_lang("colheadUsername"), ""));
                    $records = 0;
                    $query = "SELECT `student_pics` FROM `campus_department` WHERE `id`=" . $department_id;
                    $result = mysql_query($query);
                    $foto_url = mysql_fetch_array($result);
                    foreach ($lines as $lijnnr => $value)
                    {
                        if ((($row1 == 'off') && ($lijnnr == 0)) || ($lijnnr > 0))
                        {
                            $records++;
                            $data = array();
                            $values = explode(";", $value);
                            // extract values...
                            $userid = (trim($useridCol) == "") ? 0 :intval(trim($values[intval($useridCol)]));
                            $valDbid = (trim($dbidCol) == "") ? "":intval(trim($values[intval($dbidCol)]));
                            $valName = (trim($values[intval($lastnameCol)]));
                            $valFirstName = (trim($values[intval($firstnameCol)]));
                            $valBirth = trim($values[intval($birthCol)]);
                            $valBirth = ($valBirth == "") ? "0000-00-00" : $valBirth;
                            $valOfficialcode = (trim($officialcodeCol) == "") ? "" : (trim($values[intval($officialcodeCol)]));
                            $valUsername = (trim($usernameCol) == "") ? "" : (trim($values[intval($usernameCol)]));
                            $valPassword = (trim($passwordCol) == "") ? "" :trim($values[intval($passwordCol)]);
                            $valAddress = (trim($addressCol) == "") ? "" : (trim($values[intval($addressCol)]));
                            $valMail = (trim($mailCol) == "") ? "" : (trim($values[intval($mailCol)]));
                            $valPhone = (trim($telCol) == "") ? "" : (trim($values[intval($telCol)]));
                            $valPhoto = ((trim($photoCol) == "") || (trim($values[intval($photoCol)]) == "")) ? "" : $foto_url['student_pics'] . '/' . str_replace(' ','_',trim($values[intval($photoCol)]));
                            if (($valName != "") AND ($valFirstName != "") AND ($valBirth != ""))
                            {
                                if ($userid > 0)
                                {
                                    $sql = 'SELECT `lastname`,`firstname`,`birth`,`db_id`,`address`,`email`,`phone`,`user_user`.`id`,`official_code`,`username`, `picture_uri` FROM `user_user` LEFT JOIN `campus_user` ON `user_user`.`id` = `campus_user`.`user_id` WHERE `user_user`.`id` = ' . $userid . ' ';
                                }
                                else
                                {
                                    $sql = 'SELECT `lastname`,`firstname`,`birth`,`db_id`, `address`,`email`, `phone`,`user_user`.`id`,`official_code`,`username`, `picture_uri` FROM `user_user` LEFT JOIN `campus_user` ON `user_user`.`id` = `campus_user`.`user_id` WHERE `lastname` = "' . $valName . '" AND `firstname`="' . $valFirstName . '" AND `birth`="' . $valBirth . '" LIMIT 1';
                                }
                                $data[] = $userid;
                                $data[] = $valName;
                                $data[] = $valFirstName;
                                $data[] = $valBirth;
                                // check user table if user already exists...
                                $result = mysql_query($sql);
                                $aantal = mysql_num_rows($result);
                                if ($aantal == 0)
                                { // New user, generate username....
                                    $inputusername = campus::get_POST_GET('username' . $lijnnr);
                                    if (trim($usernameCol) != "")
                                    {
                                        $suggestedusername = $valUsername;
                                        $generated = get_lang("txtImportUsername");
                                    }
                                    elseif ($inputusername == "")
                                    {
                                        // generate username...
                                        $first = campus::normalize($valFirstName);
                                        $last = campus::normalize($valName);
                                        $username = substr($first, 0, 2) . substr($first, -2) . substr($last, 0, 2) . substr($last, -2);
                                        $suggestedusername = strtoupper($username);
                                        $generated = get_lang("txtCampusUsername");
                                    }
                                    else
                                    {
                                        $suggestedusername = campus::get_POST_GET('username' . $lijnnr);
                                        $generated = "";
                                    }
                                    // check generated username....
                                    $exists = array_key_exists($suggestedusername, $existingusernames);
                                    if (!$exists)
                                    {
                                        $existingusernames[$suggestedusername] = $valName . ' ' . $valFirstName . ' (' . $valBirth . ', ' . $valAddress . ') **';
                                    }
                                    else
                                    {
                                        // if username is allready used, get user details
                                        $userdetail = $existingusernames[$suggestedusername];
                                    }
                                    $usernameline = '<input type="text" name="username' . $lijnnr . '" value="' . $suggestedusername . '" style="background-color:' . (($exists) ? 'red' : 'white') . '" ' . ($exists ? 'title="' . $userdetail . '" ' : 'READONLY') . '>' . $generated;
                                    if (!$exists)
                                    {
                                        $actionline = "<div>" . get_lang("txtInsertNewStudent") . "<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"insert\" CHECKED>" . get_lang("txtYes") . "&nbsp;<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"none\" >" . get_lang("txtNo") . "</div>";
                                    }
                                    else
                                    {
                                        $actionline = "<div >" . get_lang("txtNoAction") . "</div><input type=\"hidden\" name=\"queryaction" . $lijnnr . "\" value=\"none\">";
                                    }
                                }
                                else
                                { // de naam en voornaam bestaat al update of toevoegen...
                                    $rij = mysql_fetch_array($result);
                                    $changed = false;
                                    if (($rij['db_id'] != $valDbid) && (trim($dbidCol) != ""))
                                    {
                                        $valDbid = "<b style=\"background-color: red\" title=\"" . get_lang("txtOldValue") . " " . $rij['db_ide'] . "\">&nbsp;" . $valDbid . "&nbsp;</b>";
                                        $changed = true;
                                    }

                                    if (($rij['username'] != $valUsername) && (trim($usernameCol) != ""))
                                    {
                                        $usernameline = "<input type=\"text\" style=\"background-color: red\" name=\"username" . $lijnnr . "\" value=\"" . $valUsername . "\" title=\"" . get_lang("txtOldValue") . " " . $rij['username'] . "\" READONLY>";
                                        $changed = true;
                                    }
                                    else
                                    {
                                        $usernameline = "<input type=\"text\" name=\"username" . $lijnnr . "\" value=\"" . $rij['username'] . "\" READONLY>";
                                    }

                                    if (($rij['official_code'] != $valOfficialcode) && (trim($officialcodeCol) != ""))
                                    {
                                        $valOfficialcode = "<b style=\"background-color: red\" title=\"" . get_lang("txtOldValue") . " " . $rij['official_code'] . "\">&nbsp;" . $valOfficialcode . "&nbsp;</b>";
                                        $changed = true;
                                    }
                                    if (($rij['address'] != $valAddress) && (trim($addressCol) != ""))
                                    {
                                        $valAddress = "<b style=\"background-color: red\" title=\"" . get_lang("txtOldValue") . " " . $rij['address'] . "\">&nbsp;" . $valAddress . "&nbsp;</b>";
                                        $changed = true;
                                    }
                                    if (($rij['email'] != $valMail) && (trim($mailCol) != ""))
                                    {
                                        $valMail = "<b style=\"background-color: red\" title=\"" . get_lang("txtOldValue") . " " . $rij['email'] . "\">&nbsp;" . $valMail . "&nbsp;</b>";
                                        $changed = true;
                                    }
                                    if (($rij['phone'] != $valPhone) && (trim($telCol) != ""))
                                    {
                                        $valPhone = "<b style=\"background-color: red\" title=\"" . get_lang("txtOldValue") . " " . $rij['phone'] . "\">&nbsp;" . $valPhone . "&nbsp;</b>";
                                        $changed = true;
                                    }
                                    if (($rij['picture_uri'] != $valPhoto) && (trim($photoCol) != ""))
                                    {
                                        $valPhoto = "<b style=\"background-color: red\" title=\"" . get_lang("txtOldValue") . " " . $rij['picture_uri'] . "\">&nbsp;" . $valPhoto . "&nbsp;</b>";
                                        $changed = true;
                                    }
                                    if (($rij['password'] != Hashing::hash($valPassword))&& (trim($passwordCol) != ""))
                                    {
                                        $changed = TRUE;
                                    }

                                    //$actionline="<div>".get_lang("txtOverWriteUser")."<input type=\"radio\" name=\"queryaction".$lijnnr."\" value=\"update\" ".(($changed)?'CHECKED':'').">".get_lang("txtYes")."&nbsp;<input type=\"radio\" name=\"queryaction".$lijnnr."\" value=\"none\" ".(($changed)?'':'CHECKED').">".get_lang("txtNo")."<input type=\"hidden\" name=\"userid".$lijnnr."\" value=\"".$rij['user_id']."\"></div>";
                                    if ($changed)
                                    {
                                        $actionline = "<div>" . get_lang("txtOverWriteUser") . "<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"update\" CHECKED>" . get_lang("txtYes") . "&nbsp;<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"none\" >" . get_lang("txtNo") . "<input type=\"hidden\" name=\"userid" . $lijnnr . "\" value=\"" . $rij['id'] . "\"></div>";
                                    }
                                    else
                                    {
                                        $actionline = "<div >" . get_lang("txtNoChange") . "</div><input type=\"hidden\" name=\"queryaction" . $lijnnr . "\" value=\"none\">";
                                    }
                                }
                                $data[] = $valDbid;
                                $data[] = $valOfficialcode;
                                $data[] = $valAddress;
                                $data[] = $valMail;
                                $data[] = $valPhone;
                                $data[] = $valPhoto;
                                $data[] = $usernameline;
                                $data[] = $actionline;
                                campus::display_table_row($bgcolor, $data, true);
                            }
                            else
                            {
                                Display::error_message(get_lang("msgMissingData"), false);
                            }
                        }
                    }
                    campus::display_table_footer();
                    echo get_lang("txtNoRecords") . " " . $records;
                    echo '<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelExecute') . '">&nbsp;&nbsp;<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelRenew') . '" onMouseDown="javascript:document.importform.action.value=\'step2\';">&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.importform.page.value=\'\';document.importform.action.value=\'list\';">';
                    echo '</form>';
                }
            }
            break;
        case "step3":
            {
                /*
                  ============================================================================
                  Stap 3: Uitvoeren van de acties, geef het resultaat weer.
                  ============================================================================
                 */
                if (!empty($_SESSION['userdata'])) // het bestand lezen...
                {
                    //Het bestand inlezen ....
                    $lines = $_SESSION['userdata'];
                    $records = 0;
                    $change = 0;
                    $new = 0;
                    $query = "SELECT `student_pics` FROM `campus_department` WHERE `id`=" . $department_id;
                    $result = mysql_query($query);
                    $foto_url = mysql_fetch_array($result);
                    campus::display_complex_table_header($properties, array(get_lang("colheadName"), get_lang("colheadFirstName"), get_lang("colheadUsername"), get_lang("colheadPasswd"), ""));
                    foreach ($lines as $lijnnr => $value)
                    {
                        if ((($row1 == 'off') && ($lijnnr == 0)) || ($lijnnr > 0))
                        {
                            $records++;
                            $data = array();
                            $values = explode(";", $value);
                            // extract values...
                            $userid = (trim($useridCol) == "") ? 0 :intval(trim($values[intval($useridCol)]));
                            $valName = (trim($values[intval($lastnameCol)]));
                            $valFirstName = (trim($values[intval($firstnameCol)]));
                            $valBirth = trim($values[intval($birthCol)]);
                            $valBirth = ($valBirth == "") ? "0000-00-00" : $valBirth;
                            $valDbid = (trim($dbidCol) == "") ? "":intval(trim($values[intval($dbidCol)]));
                            $valUsername = campus::get_POST_GET('username' . $lijnnr);
                            $valPassword = ($passwordCol == "") ? "" :trim($values[intval($passwordCol)]);
                            $valOfficialcode = ($officialcodeCol == "") ? "" : (trim($values[intval($officialcodeCol)]));
                            $valAddress = ($addressCol == "") ? "" : (trim($values[intval($addressCol)]));
                            $valMail = ($mailCol == "") ? "" : (trim($values[intval($mailCol)]));
                            $valPhone = ($telCol == "") ? "" : (trim($values[intval($telCol)]));
                            $valPhoto = (($photoCol == "") || (trim($values[intval($photoCol)]) == "")) ? "" : $foto_url['student_pics'] . '/' . str_replace(' ','_',trim($values[intval($photoCol)]));
                            $data[] = $valName;
                            $data[] = $valFirstName;
                            $data[] = $valUsername;
                            $password = ($valPassword == '') ? Text::generate_password(8) : $valPassword;
                            $passwordhashed = Hashing :: hash($password);
                            switch (campus::get_POST_GET('queryaction' . $lijnnr))
                            {
                                case "insert":
                                    {
                                        $data[] = $passwordhashed;
                                        $sql = 'INSERT `user_user` SET
									' . (($userid != '') ? '`id`=' . $userid . ',' : ' ') . '
									`lastname`="' . $valName . '",
									`firstname`="' . $valFirstName . '",
									' . (($mailCol != '') ? '`email`="' . $valMail . '",' : ' ') . '
									' . (($telCol != '') ? '`phone`="' . $valPhone . '",' : ' ') . '
									' . (($officialcodeCol != '') ? '`official_code`="' . $valOfficialcode . '",' : ' ') . '
									' . (($photoCol != '') ? '`picture_uri`="' . $valPhoto . '",' : ' ') . '
									`username`="' . $valUsername . '",
									`password`="' . $passwordhashed . '", `active`=0';
                                        $result = mysql_query($sql) or die (mysql_error());
                                        if ($result != false)
                                        {
                                            $student_id = mysql_insert_id();
                                            $sql = 'INSERT `campus_user` SET
										`user_id`=' . $student_id . ',
                                                                                `initialpassword`="' . $password . '",
										' . (($addressCol != '') ? '`address`="' . $valAddress . '",' : ' ') . '
								    	' . (($dbidCol != '') ? '`db_id`=' . $valDbid . ',' : ' ') . '
										`birth`="' . $valBirth . '" ';
                                            $result = mysql_query($sql);

                                            $data[] = get_lang("txtUserInsertOK");
                                            // add user data to studenttracking....
                                            $query2 = "SELECT * FROM `campus_student_tracking` WHERE `student_id`=" . $student_id . " AND `department_code`=''";
                                            $result2 = mysql_query($query2);
                                            if (mysql_num_rows($result2) == 0)
                                            {
                                                $content = $valName . ';' . $valFirstName . ';' . $valUsername . ';' . $valBirth . ';' . $valAddress . ';' . $valPhone . ';' . $valMail;
                                                $query3 = 'INSERT `campus_student_tracking` SET
								`student_id`=' . $student_id . ',
								`tracking_category`="",
								`tracking_title`="",
								`date`=' . time() . ',
								`teacher_code`="' . $userinfo['official_code'] . '",
								`grouplist`="",
								`department_code`="",
								`public`=0,
								`attachment`="",
								`content`="' . addslashes($content) . '"';
                                                $result3 = mysql_query($query3);
                                            }
                                            $new++;
                                        }
                                        else
                                        {
                                            $data[] = '<b style="color:red">'.get_lang("txtUserInsertError").'</b>';
                                        }
                                        campus::display_table_row($bgcolor, $data, true);
                                    }
                                    break;
                                case "update":
                                    {
                                        $data[] = ($valPassword != '') ? get_lang("txtUserPasswdChanged") : get_lang("txtUserPasswdKept");

                                        $sql = 'UPDATE `user_user` SET
									' . (($mailCol != '') ? '`email`="' . $valMail . '",' : ' ') . '
									' . (($telCol != '') ? '`phone`="' . $valPhone . '",' : ' ') . '
									' . (($officialcodeCol != '') ? '`official_code`="' . $valOfficialcode . '",' : ' ') . '
									' . (($photoCol != '') ? '`picture_uri`="' . $valPhoto . '",' : ' ') . '
                                    ' . (($valPassword != '') ? '`password`="' . Hashing :: hash($valPassword) . '", ' : ' ') . '
									`username`="' . $valUsername . '"
									WHERE `id` = ' . intval(campus::get_POST_GET('userid' . $lijnnr)) . ' ';
                                        $result = mysql_query($sql);
                                        if ($result == 1)
                                        {
                                            $sql = 'INSERT INTO  `campus_user` SET ';
                                            $sql.=' ' . (($birthCol != '') ? '`birth`="' . $valBirth . '", ' : ' ');
                                            $sql.=' ' . (($addressCol != '') ? '`address`="' . $valAddress . '", ' : ' ');
                                            $sql.=' ' . (($valPassword != '') ? '`initialpassword`="' . $valPassword . '", ' : ' ');
                                            $sql.=' ' . (($dbidCol != '') ? '`db_id`=' . $valDbid . ',' : ' ');
										    $sql.='  `user_id` = ' . campus::get_POST_GET('userid' . $lijnnr) . ' ';
                                            $sql.=' ON DUPLICATE KEY UPDATE ';
                                            $sql.=' ' . (($birthCol != '') ? '`birth`="' . $valBirth . '" ' : ' ');
                                            $sql.=' ' . (($addressCol != '') ? ',`address`="' . $valAddress . '" ' : ' ');
                                            $sql.=' ' . (($valPassword != '') ? ',`initialpassword`="' . $valPassword . '" ' : ' ');
                                            $sql.=' ' . (($dbidCol != '') ? ',`db_id`=' . $valDbid . ' ' : ' ');
                                            $result = mysql_query($sql);
                                            if ($result == 1)
                                            {
                                                $data[] = get_lang("txtUserUpdateOK");
                                                $change++;
                                            }
                                            else
                                            {
                                                $data[] = get_lang("txtUserUpdateError");
                                            }
                                        }
                                        else
                                        {
                                            $data[] = get_lang("txtUserUpdateError");
                                        }
                                        campus::display_table_row($bgcolor, $data, true);
                                    }
                                    break;
                                case "none":
                                    {
                                        $data[] = "-";
                                        $data[] = "-";
                                        campus::display_table_row($bgcolor, $data, true);
                                    }
                                    break;
                            }
                        }
                    }
                    campus::display_table_footer();
                    echo get_lang("txtNoRecords") . " " . $records . "&nbsp;&nbsp;" . get_lang("txtNewRecords") . " " . $new . "&nbsp;&nbsp;" . get_lang("txtChangedRecords") . " " . $change;
                }
            }
            break;
    }
}
?>