<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Display;

/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */
//check if user is allowed here...
if ((intval($_uid) == 0) || !$is_platformadmin)
{// not allowed here!
    Display::warning_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...
//require_once (api_get_path(LIBRARY_PATH).'classmanager.lib.php');

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    // de department detail info ophalen.
    $action = campus::get_POST_GET("action", "step1");
    $lastnameCol = campus::get_POST_GET("lastnameCol");
    $firstnameCol = campus::get_POST_GET("firstnameCol");
    $birthCol = campus::get_POST_GET("birthCol");
    $classCol = campus::get_POST_GET("classCol");
    $orderCol = campus::get_POST_GET("orderCol");
    $row1 = campus::get_POST_GET("row1", "off");

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }


    // de verschillende klassen die tot een bepaalde department behoren ophalen....
    $classes = campus::get_studentclasses($department_id);
    switch ($action)
    {
        case "step1" :
            {
                // reset session....
                unset($_SESSION['classimport']);
                /*
                  ==============================================================================
                  Step 1: display importform.....
                  Select import-file and select cols....
                  ==============================================================================
                 */
                echo '
			<form method="post" action="' . $this->get_campus_admin_url() . '" name="importform" enctype="multipart/form-data">
			<input type="hidden" name="action" value="step2" >
			<input type="hidden" name="page" value="addstudents2classes" >
			<input type="hidden" name="MAX_FILE_SIZE" value="100000">
			<table>
				<tr valign="top">
					<td colspan="3">
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelNameCol') . '
					</td>
					<td>
						<input type="text" name="lastnameCol" size="2" maxlength="2" value="0" /><b style="color:red;font-weight:bold;font-size:18px;">*</b> 
					</td>
					<td align="right">
						' . get_lang('labelDisableRow1') . '
					</td>
					<td>
						<input type="checkbox" name="row1" value="on" checked>
					</td>
					<td width="50%" rowspan="8">
						' . get_lang('helpClassImport') . '<br>
					<div style="color: #3333333">
						<u>' . get_lang('txtCsvImport') . '</u><br>
						 Naam;Voornaam;Geb.Datum;Klas;Volgnr.<br>
						 xxx;xxx;yyyy-mm-dd;xxx;nnn<br>
						 xxx;xxx;yyyy-mm-dd;xxx;nnn<br>
						<br><u>' . get_lang('txtCsvExample') . '</u><br>
						 Naam;Voornaam;Geb.Datum;Klas;Volgnr.<br>
						 Vermeulen;Joske;1995-11-24;1A1;3<br>
						 Vermeulen;Josephine;1993-04-15;1A1;4<br>
					</div>
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelFirstNameCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="firstnameCol" size="2" maxlength="2" value="1" /><b style="color:red;font-weight:bold;font-size:18px;">*</b> 
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelBirthCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="birthCol" size="2" maxlength="2" value="2" /><b style="color:red;font-weight:bold;font-size:18px;">*</b> 
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelClassCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="classCol" size="2" maxlength="2" value="3" /><b style="color:red;font-weight:bold;font-size:18px;">*</b> 
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelOrderCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="orderCol" size="2" maxlength="2" value="4" />
					</td>
					</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelSelectFile2Import') . '
					</td>
					<td colspan="3">
						<input type="file" name="uploadfile" >
						<br />
					</td>	
				</tr>
				<tr valign="top">
					<td>
					</td>
					<td colspan="3">
						<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelUpload') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.importform.page.value=\'\';document.importform.action.value=\'list\';">
					</td>
				</tr>
			</table>
			</form>';
            }
            break;
        case "step2":
            {
                /*
                  ==============================================================================
                  Step 2: check new users with existing platform users...
                  Show import options....
                  ==============================================================================
                 */
                if (!empty($_FILES)) // het bestand lezen...
                {
                    //Het bestand inlezen ....
                    $lines = file($_FILES['uploadfile']['tmp_name']);
                    $_SESSION['classimport'] = $lines;
                    // existing students of department in array...
                    // Query van het gegevensbestand....
                    $query = 'SELECT `user_user`.`id`,`group_group`.`code`, `display_order`
					FROM `group_group_rel_user`
						LEFT JOIN `user_user`
							ON `user_user`.`id` = `group_group_rel_user`.`user_id`
						LEFT JOIN `group_group`
							ON `group_group`.`id` = `group_group_rel_user`.`group_id` WHERE ';
                    $filter = '';
                    foreach ($classes as $class_id => $value)
                    {
                        $filter.='`group_group_rel_user`.`group_id` = ' . $class_id . ' OR ';
                    }
                    $filter = substr($filter, 0, -3) . ' ';
                    $sql = $query . $filter . ' ORDER BY `group_group`.`code`, `display_order`, `lastname`, `firstname`';
                    $result = mysql_query($sql);
                    $enlistedstudents = array();
                    while ($rij = mysql_fetch_array($result))
                    {
                        $enlistedstudents[$rij['id']][$rij['code']] = $rij['display_order'];
                    }
                    echo '
					<form method="post" action="' . $this->get_campus_admin_url() . '" name="importform">
					<input type="hidden" name="action" value="step3" >
					<input type="hidden" name="page" value="addstudents2classes" >
					<input type="hidden" name="lastnameCol" size="2" maxlength="2" value="' . $lastnameCol . '" />
					<input type="hidden" name="firstnameCol" size="2" maxlength="2" value="' . $firstnameCol . '" />
					<input type="hidden" name="birthCol" size="2" maxlength="2" value="' . $birthCol . '" />
					<input type="hidden" name="classCol" size="2" maxlength="2" value="' . $classCol . '" />
					<input type="hidden" name="orderCol" size="2" maxlength="2" value="' . $orderCol . '" />
					<input type="hidden" name="row1" size="2" maxlength="2" value="' . $row1 . '" />
					';
                    campus::display_complex_table_header($properties, array(get_lang('colheadLineNr'), get_lang('colheadStudent'), get_lang('colheadExists'), get_lang('colheadClass'), get_lang('colheadExists'), get_lang('colheadNr'), get_lang('colheadClassStatus'), get_lang('colheadDepartmentStatus'), get_lang('colheadAction')));
                    $records = 0;
                    foreach ($lines as $lijnnr => $value)
                    {
                        if ((($row1 == 'off') && ($lijnnr == 0)) || ($lijnnr > 0))
                        {
                            $records++;
                            $data = array();
                            $values = explode(";", $value);
                            // extract values...
                            $data[] = $lijnnr;
                            $valClass = trim($values[intval($classCol)]);
                            $valName = trim($values[intval($lastnameCol)]);
                            $valFirstName = trim($values[intval($firstnameCol)]);
                            $valBirth = trim($values[intval($birthCol)]);
                            $data[] = $valName . " " . $valFirstName . "(" . $valBirth . ")";
                            $valOrder = ($orderCol == "") ? "" : intval(trim($values[intval($orderCol)]));
                            //  de gebruiker opzoeken op het platform...
                            $sql = 'SELECT `id` FROM `user_user` LEFT JOIN `campus_user` ON `user_user`.`id` = `campus_user`.`user_id` WHERE `lastname` = "' . $valName . '" AND `firstname` = "' . $valFirstName . '" AND `birth` = "' . $valBirth . '"';
                            $result = mysql_query($sql);
                            $aantal = mysql_num_rows($result);
                            $rijuser = mysql_fetch_array($result, MYSQL_ASSOC);
                            $data[] = (empty($rijuser) ? get_lang("txtFailed") : (($aantal > 1) ? get_lang("txtDoubleUserData") : get_lang("txtSucces")));
                            // class
                            $data[] = $valClass;
                            $found = FALSE;
                            foreach ($classes as $class_id => $value)
                            {
                                if ($value['code'] == $valClass)
                                {
                                    $found = TRUE;
                                    break;
                                }
                            }
                            $data[] = ($found) ? get_lang("txtSucces") : get_lang("txtFailed");
                            if (($aantal == 1) && ($found))
                            {
                                if (!empty($enlistedstudents[$rijuser['id']]))
                                {
                                    if ($enlistedstudents[$rijuser['id']][$valClass] != "")
                                    {
                                        if (($enlistedstudents[$rijuser['id']][$valClass] == $valOrder) || ($valOrder == ""))
                                        {
                                            $data[] = $valOrder;
                                            $actionline = "<input type=\"hidden\" name=\"queryaction" . $lijnnr . "\" value=\"none\">" . get_lang("txtNoAction");
                                        }
                                        else
                                        {
                                            $data[] = "<b style=\"background-color: red\" title=\"" . get_lang("txtOldValue") . " " . $enlistedstudents[$rijuser['id']][$valClass] . "\">" . $valOrder . "</b>";
                                            $actionline = "<div>" . get_lang("txtUpdateOrder") . "<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"update\"  CHECKED>" . get_lang("txtYes") . "&nbsp;<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"none\">" . get_lang("txtNo") . "</div>";
                                        }
                                        $data[] = get_lang('txtAllReadyInClass');
                                    }
                                    else
                                    {
                                        $data[] = $valOrder;
                                        $data[] = "<b style='color:red'>" . get_lang("txtNewInClass") . "</b>";
                                        $actionline = "<div>" . get_lang("txtSubscribe2Class") . "<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"insert\" CHECKED>" . get_lang("txtYes") . "&nbsp;<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"none\" >" . get_lang("txtNo") . "</div>";
                                    }
                                    $data[] = get_lang("txtAllReadyInDepartment");
                                    $enlistedstudents[$rijuser['id']][$valClass] = "found";
                                }
                                else
                                {
                                    $data[] = $valOrder;
                                    $data[] = "<b style='color:red'>" . get_lang("txtNewInClass") . "</b>";
                                    $data[] = "<b style='color:red'>" . get_lang("txtNewInDepartment") . "</b>";
                                    $actionline = "<div>" . get_lang("txtSubscribe2Class") . "<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"insert\" CHECKED>" . get_lang("txtYes") . "&nbsp;<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"none\" >" . get_lang("txtNo") . "</div>";
                                }
                            }
                            else
                            {
                                $data[] = "-";
                                $data[] = "<b style='color:red'>" . get_lang("txtCheckNotPossible") . "</b>";
                                $data[] = "<b style='color:red'>" . get_lang("txtCheckNotPossible") . "</b>";
                                $actionline = "<input type=\"hidden\" name=\"queryaction" . $lijnnr . "\" value=\"none\">" . get_lang("txtNoAction");
                            }
                            $data[] = $actionline;
                        }
                        campus::display_table_row($bgcolor, $data, true);
                    }
                    // students to delete from department.
                    foreach ($enlistedstudents as $user_id => $classarray)
                    {
                        foreach ($classarray as $classcode => $order)
                        {
                            $data = array();
                            if ($order != "found")
                            {
                                $lijnnr++;
                                $user2delete = campus::get_user_info($user_id);
                                $data[] = $lijnnr; //line number na
                                $data[] = $user2delete['lastname'] . " " . $user2delete['firstname'];
                                $data[] = ""; //usercheck na
                                $data[] = $classcode;
                                $data[] = ""; //classcheck na
                                $data[] = $order;
                                $data[] = get_lang("txt2deleteFromClass");
                                $data[] = ""; //department na
                                $data[] = '<div>' . get_lang('txtUnSubscribe') . '<input type="radio" name="queryaction' . $lijnnr . '" value="delete">' . get_lang('txtYes') . '&nbsp;<input type="radio" name="queryaction' . $lijnnr . '" value="none" CHECKED>' . get_lang('txtNo') . '</div>';
                                campus::display_table_row($bgcolor, $data, true);
                            }
                        }
                    }
                    campus::display_table_footer();
                    echo get_lang("txtNoRecords") . " " . $records;
                    echo '<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelExecute') . '">&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.importform.page.value=\'\';document.importform.action.value=\'list\';">';
                    echo "</form>";
                }
            }
            break;
        case "step3":
            {
                /*
                  ============================================================================
                  Stap 3: Uitvoeren van de acties, geef het resultaat weer.
                  ============================================================================
                 */
                if (!empty($_SESSION['classimport'])) // het bestand lezen...
                {
                    //Het bestand inlezen ....
                    $lines = $_SESSION['classimport'];
                    // existing students of department in array...
                    // Query van het gegevensbestand....
                    $query = "SELECT `user_user`.`id`,`group_group`.`code`, `display_order`
					FROM `group_group_rel_user`
						LEFT JOIN `user_user`
							ON `user_user`.`id` = `group_group_rel_user`.`user_id`
						LEFT JOIN `group_group`
							ON `group_group`.`id` = `group_group_rel_user`.`group_id` WHERE ";
                    $filter = "";
                    foreach ($classes as $class_id => $value)
                    {
                        $filter.="`group_group_rel_user`.`group_id` = " . $class_id . " OR ";
                    }
                    $filter = substr($filter, 0, -3) . " ";
                    $sql = $query . $filter . " ORDER BY `group_group`.`code`, `display_order`, `lastname`, `firstname`";
                    $result = mysql_query($sql) or die(mysql_error());
                    $enlistedstudents = array();
                    while ($rij = mysql_fetch_array($result))
                    {
                        $enlistedstudents[$rij['id']][$rij['code']] = $rij['order'];
                    }
                    campus::display_complex_table_header($properties, array(get_lang("colheadLineNr"), get_lang("colheadStudent"), get_lang("colheadClass"), get_lang("colheadNr"), get_lang("colheadResult")));
                    $records = 0;
                    foreach ($lines as $lijnnr => $value)
                    {
                        if ((($row1 == 'off') && ($lijnnr == 0)) || ($lijnnr > 0))
                        {
                            $records++;
                            $data = array();
                            $data[] = $lijnnr;
                            $values = explode(";", $value);
                            // extract values...
                            $valClass = trim($values[intval($classCol)]);
                            $valName = trim($values[intval($lastnameCol)]);
                            $valFirstName = trim($values[intval($firstnameCol)]);
                            $valBirth = trim($values[intval($birthCol)]);
                            //$valBirth=($valBirth=="")?"0000-00-00":$valBirth;
                            $data[] = $valName . " " . $valFirstName . "(" . $valBirth . ")";
                            $valOrder = ($orderCol == "") ? "" : intval(trim($values[intval($orderCol)]));
                            //  de gebruiker opzoeken op het platform...
                            $sql = 'SELECT `id` FROM `user_user` LEFT JOIN `campus_user` ON `user_user`.`id` = `campus_user`.`user_id` WHERE `lastname` = "' . $valName . '" AND `firstname` = "' . $valFirstName . '" AND `birth` = "' . $valBirth . '"';
                            $result = mysql_query($sql);
                            $aantal = mysql_num_rows($result);
                            $rijuser = mysql_fetch_array($result, MYSQL_ASSOC);
                            // class id bepalen
                            foreach ($classes as $class_id => $value)
                            {
                                if ($value['code'] == $valClass)
                                {
                                    break;
                                }
                                $class_id = 0;
                            }
                            $data[] = $valClass;
                            $data[] = $valOrder;
                            if (($aantal == 1) && ($class_id != 0))
                            {
                                if (!empty($enlistedstudents[$rijuser['id']]))
                                {
                                    $enlistedstudents[$rijuser['id']][$valClass] = "found";
                                }
                                switch (campus::get_POST_GET('queryaction' . $lijnnr))
                                {
                                    case "insert":
                                        {
                                            // insert order nummer...
                                            $result = mysql_query("INSERT `group_group_rel_user` SET  `display_order` =" . intval($valOrder) . " , `group_id`=" . $class_id . ", `user_id`=" . $rijuser['id']);

                                            //	set user active
                                            $result3 = mysql_query("UPDATE `user_user` SET `active`=1  WHERE `id`=" . $rijuser['id']);

                                            $data[] = "<b style='color:green'>" . get_lang("txtUpdateOK") . "> " . get_lang("txtCourses") . "</b>";
                                        }
                                        break;
                                    case "update":
                                        {
                                            // update order student to class.....
                                            $result4 = mysql_query("UPDATE `user_user` SET `active`=1 WHERE `id`=" . $rijuser['id']);
                                            $result = mysql_query("UPDATE `group_group_rel_user` SET `display_order` =" . intval($valOrder) . " WHERE `group_id`=" . $class_id . " AND `user_id`=" . $rijuser['id']);
                                            if ($result)
                                            {
                                                $data[] = "<b style='color:green'>" . get_lang("txtUpdateOK") . "</b>";
                                            }
                                            else
                                            {
                                                $data[] = "<b style='color:red'>" . get_lang("txtUpdateNIO") . "</b>";
                                            }
                                        }
                                        break;
                                    default :
                                        {
                                            $data[] = get_lang("txtNothingChanged");
                                        }
                                }
                            }
                            else
                            {
                                $data[] = get_lang("txtNothingChanged");
                            }
                        }
                        campus::display_table_row($bgcolor, $data, true);
                    }
                    // students to delete from department.
                    foreach ($enlistedstudents as $user_id => $classarray)
                    {
                        foreach ($classarray as $classcode => $order)
                        {
                            $data = array();
                            if ($order != "found")
                            {
                                $lijnnr++;
                                $user2delete = campus::get_user_info($user_id);
                                $data[] = $lijnnr; //line number na
                                $data[] = $user2delete['lastname'] . " " . $user2delete['firstname'];
                                $data[] = $classcode;
                                $data[] = $order;
                                switch (campus::get_POST_GET('queryaction' . $lijnnr))
                                {
                                    case "delete":
                                        {
                                            //
                                            foreach ($classes as $class_id => $classvalue)
                                            {
                                                if ($classvalue['code'] == $classcode)
                                                {
                                                    break;
                                                }
                                            }
                                            // remove user from class an courses  .....
                                            $result = mysql_query("DELETE FROM `group_group_rel_user` WHERE `group_id`=" . $class_id . " AND `user_id`=" . $user_id);
                                            $data[] = get_lang("txtDeleteOK");
                                        }
                                        break;
                                    default :
                                        {
                                            $data[] = get_lang("txtNothingChanged");
                                        }
                                }
                                campus::display_table_row($bgcolor, $data, true);
                            }
                        }
                    }
                }
                campus::display_table_footer();
                echo get_lang("txtNoRecords") . " " . $records;
            }
            break;
    }
}
?>
