<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Display;
use common\libraries\Text;
use common\libraries\Hashing;
use common\libraries\PlatformSetting;

//check if user is allowed here...
if ((intval($_uid) == 0) || !$is_platformadmin)
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $action = campus::get_POST_GET("action", "step1");
    $group_id = intval(campus::get_POST_GET("group_id"));
    $useridCol = campus::get_POST_GET("useridCol");
    $lastnameCol = campus::get_POST_GET("lastnameCol");
    $firstnameCol = campus::get_POST_GET("firstnameCol");
    $officialcodeCol = campus::get_POST_GET("officialcodeCol");
    $usernameCol = campus::get_POST_GET("usernameCol");
    $passwordCol = campus::get_POST_GET("passwordCol");
    $birthCol = campus::get_POST_GET("birthCol");
    $addressCol = campus::get_POST_GET("addressCol");
    $mailCol = campus::get_POST_GET("mailCol");
    $telCol = campus::get_POST_GET("telCol");
    $photoCol = campus::get_POST_GET("photoCol");
    $row1 = campus::get_POST_GET("row1", "off");

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */

    //display messages
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }


    switch ($action)
    {
        case "step1" :
            {
                /* ==============================================================================
                  Step 1: display importform.....
                  Select import-file and select cols....
                  ============================================================================== */
                // reset session....
                unset($_SESSION['userdata']);
                $teachergroup = campus::get_teacherclasses($department_id);
                echo '<form method="post" action="' . $this->get_campus_admin_url() . '" name="importform" enctype="multipart/form-data">
			<input type="hidden" name="action" value="step2" >
			<input type="hidden" name="page" value="addteachers" >
			<input type="hidden" name="MAX_FILE_SIZE" value="100000">
			<table>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelUserIDCol') . '
					</td>
					<td>
						<input type="text" name="useridCol" size="2" maxlength="2" value="" />
					</td>
					<td align="right">
						' . get_lang('labelDisableRow1') . '
					</td>
					<td>
						<input type="checkbox" name="row1" value="on" ' . (($row1 == 'on') ? 'checked' : '') . '>
					</td>
					<td width="50%" rowspan="11">
						' . get_lang("helpTeacherImport") . '<br>
					<div style="color: #777777">
						<u>' . get_lang('txtCsvImport') . '</u><br>
						 Voornaam;achternaam;geb.datum;gebruikersnaam;Adres;Telefoon;Afkorting;e-mail<br>
						 xxx;xxx;yyyy-mm-dd;xxx;xxxx;xxx;xxx;xxx;xxx<br>
						 xxx;xxx;yyyy-mm-dd;xxx;xxxx;xxx;xxx;xxx;xxx<br>
						<br><u>' . get_lang('txtCsvExample') . '</u><br>
						 Achternaam;Voornaam;geb.datum;gebruikersnaam;Adres;Telefoon;Afkorting;e-mail<br>
						 Edison;Thomas;1847-02-11;;;EDTH;edison.thomas@tussen.be<br>
						 Einstein;Albert;1879-03-14;;;EIAL;einstein.albert@tussen.be<br>
					</div>
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelNameCol') . '
					</td>
					<td	colspan="3">
						<input type="text" name="lastnameCol" size="2" maxlength="2" value="0" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelFirstNameCol') . '
					</td>
					<td	colspan="3">
						<input type="text" name="firstnameCol" size="2" maxlength="2" value="1" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelBirthCol') . '
					</td>
					<td	colspan="3">
						<input type="text" name="birthCol" size="2" maxlength="2" value="2" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelUsernameCol') . '
					</td>
					<td>
						<input type="text" name="usernameCol" size="2" maxlength="2" value="3" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
					</td>
				</tr>
			<tr valign="top">
					<td align="right">
						' . get_lang('labelPasswordCol') . '
					</td>
					<td>
						<input type="text" name="passwordCol" size="2" maxlength="2" value="" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelAddressCol') . '
					</td>
					<td>
						<input type="text" name="addressCol" size="2" maxlength="2" value="10" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelPhoneCol') . '
					</td>
					<td>
							<input type="text" name="telCol" size="2" maxlength="2" value="7" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelMailCol') . '
					</td>
					<td>
						<input type="text" name="mailCol" size="2" maxlength="2" value="8" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelOfficialcodeCol') . '
					</td>
					<td>
						<input type="text" name="officialcodeCol" size="2" maxlength="2" value="3" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelSelectFile2Import') . '
						</td>
					<td colspan="3">
						<input type="file" name="uploadfile" >
						<br />
					</td>
				</tr>
                                <tr valign="top">
					<td align="right">
						' . get_lang('labelSelectGroup') . '
						</td>
					<td colspan="3">
                                        <select name="group_id"> ';
                echo '<option value="0">' . get_lang('NoUpdate') . '</option>';
                foreach ($teachergroup as $groupid => $groupdetail)
                {
                    echo '<option value="' . $groupid . '">' . $groupdetail['code'] . '</option>';
                }

                echo '		</td>
				</tr><tr valign="top">
					<td>
					</td>
					<td colspan="5">
						<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelUpload') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang("buttonlabelCancel") . '" onMouseDown="javascript:document.importform.page.value=\'\';document.importform.action.value=\'list\';">
					</td>
				</tr>
			</table>
			</form>';
            }
            break;
        case "step2":
            {
                /*
                  ==============================================================================
                  Step 2: check new users with existing platform users...
                  Show import options....
                  ==============================================================================
                 */
                if (!empty($_FILES)) // het bestand lezen...
                {
                    if ((trim($lastnameCol) != "") AND (trim($firstnameCol) != "") AND (trim($usernameCol) != ""))
                    {
                        //Het bestand inlezen ....
                        $lines = file($_FILES['uploadfile']['tmp_name']);
                        echo '
				<form method="post" action="' . $this->get_campus_admin_url() . '" name="importform" >
				<input type="hidden" name="action" value="step3" >
				<input type="hidden" name="page" value="addteachers" >
				<input type="hidden" name="group_id" value="' . $group_id . '" >
				<input type="hidden" name="useridCol" size="2" maxlength="2" value="' . $useridCol . '" />
				<input type="hidden" name="lastnameCol" size="2" maxlength="2" value="' . intval($lastnameCol) . '" />
				<input type="hidden" name="firstnameCol" size="2" maxlength="2" value="' . intval($firstnameCol) . '" />
				<input type="hidden" name="usernameCol" size="2" maxlength="2" value="' . intval($usernameCol) . '" />
				<input type="hidden" name="passwordCol" size="2" maxlength="2" value="' . $passwordCol . '" />
				<input type="hidden" name="officialcodeCol" size="2" maxlength="2" value="' . $officialcodeCol . '" />
				<input type="hidden" name="birthCol" size="2" maxlength="2" value="' . $birthCol . '" />
				<input type="hidden" name="addressCol" size="2" maxlength="2" value="' . $addressCol . '" />
				<input type="hidden" name="mailCol" size="2" maxlength="2" value="' . $mailCol . '" />
				<input type="hidden" name="telCol" size="2" maxlength="2" value="' . $telCol . '" />
				<input type="hidden" name="listChar" size="2" maxlength="2" value="' . $listChar . '" />
				<input type="hidden" name="textChar" size="2" maxlength="2" value="' . htmlspecialchars(stripslashes($textChar)) . '" />
				<input type="hidden" name="row1" size="2" maxlength="2" value="' . $row1 . '" />';
                        $_SESSION['userdata'] = $lines;
                        campus::display_complex_table_header($properties, array(get_lang("colheadID"), get_lang("colheadName"), get_lang("colheadFirstName"), get_lang("colheadUsername"), get_lang("colheadOfficialCode"), get_lang("colheadBirth"), get_lang("colheadAddress"), get_lang("colheadMail"), get_lang("colheadPhone"), ""));
                        $records = 0;
                        foreach ($lines as $lijnnr => $value)
                        {
                            if ((($row1 == 'off') && ($lijnnr == 0)) || ($lijnnr > 0))
                            {
                                $records++;
                                $data = array();
                                $values = explode(";", $value);
                                // extract values...
                                $userid = (trim($useridCol) == "") ? 0 : intval(trim($values[intval($useridCol)]));
                                $valName = (trim($values[intval($lastnameCol)]));
                                $valFirstName = (trim($values[intval($firstnameCol)]));
                                if ($birthCol == '')
                                {
                                    $valBirth = '';
                                }
                                else
                                {
                                    $valBirth = trim($values[intval($birthCol)]);
                                    $valBirth = ($valBirth == "") ? "0000-00-00" : $valBirth;
                                }
                                $valOfficialcode = addslashes(trim($values[intval(((trim($officialcodeCol) == "") ? $usernameCol : $officialcodeCol))]));
                                $valUsername = addslashes(trim($values[intval($usernameCol)]));
                                $valPassword = ($passwordCol == "") ? "" : trim($values[intval($passwordCol)]);
                                $valAddress = ($addressCol == "") ? "" : (trim($values[intval($addressCol)]));
                                $valMail = (trim($mailCol) == "") ? "" : (trim($values[intval($mailCol)]));
                                $valPhone = (trim($telCol) == "") ? "" : (trim($values[intval($telCol)]));
                                if (($valName != "") AND ($valFirstName != "") AND ($valUsername != ""))
                                {
                                    if ($userid > 0)
                                    {
                                        $sql = 'SELECT `lastname`,`firstname`,`birth`,`address`,`email`,`phone`,`user_user`.`id`,`official_code`,`username`,`password` FROM `user_user` LEFT JOIN `campus_user` ON `user_user`.`id` = `campus_user`.`user_id` WHERE `user_user`.`id` = ' . $userid . ' ';
                                    }
                                    else
                                    {
                                        $sql = 'SELECT `lastname`,`firstname`,`birth`,`address`,`email`,`phone`,`user_user`.`id`,`official_code`,`username`,`password` FROM `user_user` LEFT JOIN `campus_user` ON `user_user`.`id` = `campus_user`.`user_id` WHERE `username`="' . $valUsername . '" LIMIT 1';
                                    }
                                    $result = mysql_query($sql) or die(mysql_error());
                                    $aantal = mysql_num_rows($result);
                                    if ($aantal == 0)
                                    { // de naam en voornaam bestaan nog niet dus worden deze toegevoegd.
                                        $actionline = "<div style=\"background-color:#99FF99;\">" . get_lang("txtNewRecords") . "</div><input type=\"hidden\" name=\"queryaction" . $lijnnr . "\" value=\"insert\">";
                                    }
                                    else
                                    { // de naam en voornaam bestaat al update of toevoegen...
                                        $rij = mysql_fetch_array($result);
                                        $changed = FALSE;
                                        if (($userid > 0) AND ($rij['username'] != $valUsername))
                                        {
                                            $valUsername = "<b style=\"background-color: red\" title=\"" . get_lang("txtOldValue") . " " . $rij['username'] . "\">&nbsp;" . $valUsername . "&nbsp;</b>";
                                            $changed = TRUE;
                                        }
                                        if (($rij['official_code'] != $valOfficialcode) && (trim($officialcodeCol) != ""))
                                        {
                                            $valOfficialcode = "<b style=\"background-color: red\" title=\"" . get_lang("txtOldValue") . " " . $rij['official_code'] . "\">&nbsp;" . $valOfficialcode . "&nbsp;</b>";
                                            $changed = TRUE;
                                        }
                                        if (($rij['birth'] != $valBirth))
                                        {
                                            $valBirth = "<b style=\"background-color: red\" title=\"" . get_lang("txtOldValue") . " " . $rij['birth'] . "\">&nbsp;" . $valBirth . "&nbsp;</b>";
                                            $changed = TRUE;
                                        }
                                        if (($rij['address'] != $valAddress) && (trim($addressCol) != ""))
                                        {
                                            $valAddress = "<b style=\"background-color: red\" title=\"" . get_lang("txtOldValue") . " " . $rij['address'] . "\">&nbsp;" . $valAddress . "&nbsp;</b>";
                                            $changed = TRUE;
                                        }
                                        if (($rij['email'] != $valMail) && (trim($mailCol) != ""))
                                        {
                                            $valMail = "<b style=\"background-color: red\" title=\"" . get_lang("txtOldValue") . " " . $rij['email'] . "\">&nbsp;" . $valMail . "&nbsp;</b>";
                                            $changed = TRUE;
                                        }
                                        if (($rij['phone'] != $valPhone) && (trim($telCol) != ""))
                                        {
                                            $valPhone = "<b style=\"background-color: red\" title=\"" . get_lang("txtOldValue") . " " . $rij['phone'] . "\">&nbsp;" . $valPhone . "&nbsp;</b>";
                                            $changed = TRUE;
                                        }
                                        if ($rij['password'] != Hashing::hash($valPassword))
                                        {
                                            //$changed = TRUE;
                                        }

                                        if ($changed)
                                        {
                                            $actionline = "<div>" . get_lang("txtOverWriteUser") . "<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"update\" CHECKED>" . get_lang("txtYes") . "&nbsp;<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"none\" >" . get_lang("txtNo") . "<input type=\"hidden\" name=\"userid" . $lijnnr . "\" value=\"" . $rij['id'] . "\"></div>";
                                        }
                                        elseif ($group_id > 0)
                                        {
                                            $actionline = "<div>" . get_lang("txtOverWriteUser") . "<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"update\" >" . get_lang("txtYes") . "&nbsp;<input type=\"radio\" name=\"queryaction" . $lijnnr . "\" value=\"none\" CHECKED>" . get_lang("txtNo") . "<input type=\"hidden\" name=\"userid" . $lijnnr . "\" value=\"" . $rij['id'] . "\"></div>";
                                        }
                                        else
                                        {
                                            $actionline = "<div >" . get_lang("txtNoChange") . "</div><input type=\"hidden\" name=\"queryaction" . $lijnnr . "\" value=\"none\">";
                                        }
                                    }
                                    $data[] = $userid;
                                    $data[] = $valName;
                                    $data[] = $valFirstName;
                                    $data[] = $valUsername;
                                    $data[] = $valOfficialcode;
                                    $data[] = $valBirth;
                                    $data[] = $valAddress;
                                    $data[] = $valMail;
                                    $data[] = $valPhone;
                                    $data[] = $actionline . '';
                                    campus::display_table_row($bgcolor, $data, true);
                                }
                            }
                        }
                        campus::display_table_footer();
                        echo get_lang("txtNoRecords") . " " . $records;
                        echo '<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelExecute') . '">&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.importform.page.value=\'\';document.importform.action.value=\'list\';">';
                        echo '</form>';
                    }
                    else
                    {
                        Display::error_message(get_lang("msgMissingData"), false);
                    }
                }
            }
            break;
        case "step3":
            {
                /*
                  ============================================================================
                  Stap 3: controleer of in het gebruikers bestand al gebruikers met
                  identieke naam en voornaam bestaan.....
                  Geeft de mogelijkheid om deze gegevens over te nemen....
                  ============================================================================
                 */
                if (!empty($_SESSION['userdata'])) // het bestand lezen...
                {
                    //Het bestand inlezen ....
                    $lines = $_SESSION['userdata'];
                    $records = 0;
                    $change = 0;
                    $new = 0;
                    $defaultPWD = PlatformSetting::get('defaultPasswd', __NAMESPACE__);
                    campus::display_complex_table_header($properties, array(get_lang("colheadID"), get_lang("colheadName"), get_lang("colheadFirstName"), get_lang("colheadDepartmentShort"), get_lang("colheadUsername"), get_lang("colheadPasswd")));
                    foreach ($lines as $lijnnr => $value)
                    {
                        if ((($row1 == 'off') && ($lijnnr == 0)) || ($lijnnr > 0))
                        {
                            $records++;
                            $data = array();
                            $values = explode(";", $value);
                            // extract values...
                            $userid = (trim($useridCol) == "") ? 0 : intval(trim($values[intval($useridCol)]));
                            $valName = (trim($values[intval($lastnameCol)]));
                            $valFirstName = (trim($values[intval($firstnameCol)]));
                            $valBirth = trim($values[intval($birthCol)]);
                            $valBirth = ($valBirth == "") ? "0000-00-00" : $valBirth;
                            $valOfficialcode = trim($values[intval($officialcodeCol)]);
                            $valUsername = trim($values[intval($usernameCol)]);
                            $valPassword = ($passwordCol == "") ? "" : trim($values[intval($passwordCol)]);
                            $valAddress = (trim($values[intval($addressCol)]));
                            $valMail = ($mailCol == "") ? "" : (trim($values[intval($mailCol)]));
                            $valPhone = ($telCol == "") ? "" : (trim($values[intval($telCol)]));
                            $data[0] = $valName;
                            $data[1] = $valFirstName;
                            $data[2] = $valOfficialcode;
                            $data[3] = $valUsername; //campus::get_POST_GET('username'.$lijnnr);
                            $data[4] = '';
                            $data[5] = '';

                            $queryaction = campus::get_POST_GET('queryaction' . $lijnnr);
                            switch ($queryaction)
                            {
                                case "insert":
                                    {
                                        $password = Hashing :: hash(($valPassword == '') ? (($defaultPWD == '') ? Text::generate_password(8) : $defaultPWD) : $valPassword);
                                        $sql = 'INSERT `user_user` SET
										' . (($userid != '') ? '`id`=' . $userid . ',' : ' ') . '
										`lastname`="' . $valName . '",
										`firstname`="' . $valFirstName . '",
										`username`="' . $valUsername . '",
										' . (($mailCol != '') ? '`email`="' . $valMail . '",' : ' ') . '
										' . (($telCol != '') ? '`phone`="' . $valPhone . '",' : ' ') . '
										' . (($officialcodeCol != '') ? '`official_code`="' . $valOfficialcode . '",' : ' ') . '
										`password`="' . $password . '", `status`=1 ';
                                        $result = mysql_query($sql);
                                        if ($result != false)
                                        {
                                            $userid = mysql_insert_id();
                                            $sql = 'INSERT `campus_user` SET
										`user_id`="' . $userid . '"
										' . (($addressCol != '') ? ', `address`="' . $valAddress . '" ' : '') . '
										' . (($birthCol != '') ? ', `birth`="' . $valBirth . '" ' : '') ;
                                            $result = mysql_query($sql);
                                            $data[4] = $password;

                                            $data[5] = get_lang("txtUserInsertOK");
                                            $new++;
                                        }
                                        else
                                        {
                                            $data[5] = get_lang("txtUserInsertError");
                                        }
                                    }
                                    break;
                                case "update":
                                    {
                                        $sql = 'UPDATE `user_user` SET
                                      		`lastname`="' . $valName . '",
										`firstname`="' . $valFirstName . '",
										`username`="' . $valUsername . '",';
                                        $sql.=' ' . (($mailCol != '') ? '`email`="' . $valMail . '", ' : ' ');
                                        $sql.=' ' . (($telCol != '') ? '`phone`="' . $valPhone . '", ' : ' ');
                                        $sql.=' ' . (($officialcodeCol != '') ? '`official_code`="' . $valOfficialcode . '", ' : ' ');
                                        $sql.=' `status` = 1';
                                        $sql.=' WHERE `id` = ' . campus::get_POST_GET('userid' . $lijnnr) . ' ';
                                        $result = mysql_query($sql);
                                        $sql = 'INSERT INTO  `campus_user` SET ';
                                        $sql.=' ' . (($addressCol != '') ? '`address`="' . $valAddress . '", ' : ' ');
                                        $sql.=' ' . (($birthCol != '') ? '`birth`="' . $valBirth . '", ' : ' ');
                                        $sql.=' `user_id` = ' . campus::get_POST_GET('userid' . $lijnnr) . ' ';
                                        $sql.=' ON DUPLICATE KEY UPDATE ';
                                        $sql.=' ' . (($addressCol != '') ? '`address`="' . $valAddress . '" ' : ' ');
                                        $sql.= (($birthCol != '')&&($addressCol != ''))? ', ':'';
                                        $sql.=' ' . (($birthCol != '') ? '`birth`="' . $valBirth . '" ' : ' ');
                                        $result = mysql_query($sql) or die(mysql_error());
                                        $data[4] = get_lang('txtUserPasswdKept');
                                        if ($result == 1)
                                        {
                                            $data[5] = get_lang('txtUserUpdateOK');
                                            $change++;
                                        }
                                        else
                                        {
                                            $data[5] = get_lang('txtUserUpdateError');
                                        }
                                    }
                                    break;
                            }
                            if (($group_id > 0) && (($queryaction == 'insert') || ($queryaction == 'update')))
                            {
                                $sql = 'INSERT `group_group_rel_user` SET `user_id`=' . $userid . ', `group_id`=' . $group_id . ' ';
                                $result = mysql_query($sql);

                                if ($result == 1)
                                {
                                    $data[5] .= ' ' . get_lang('txtaddtogroup');
                                }
                                else
                                {
                                    $data[5] .= get_lang('txtnotabletoaddtogroup');
                                }
                            }
                            campus::display_table_row($bgcolor, $data, true);
                        }
                    }
                    campus::display_table_footer();
                    echo get_lang('txtNoRecords') . ' ' . $records . '&nbsp;
                                        &nbsp;
                                        ' . get_lang('txtNewRecords') . ' ' . $new . '&nbsp;
                                        &nbsp;
                                        ' . get_lang('txtChangedRecords') . ' ' . $change;
                }
            }
            break;
    }
}
?>