<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\WebApplication;
use common\libraries\Display;
use common\libraries\Text;
use common\libraries\Hashing;
use common\libraries\PlatformSetting;

//check if user is allowed here...
if ((intval($_uid) == 0) || !$is_platformadmin)
{// not allowed here!
    Display::display_error_message(get_lang("msgNoDepartmentMember"), false);
}
else
{//only teachers and platform administrator are allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $archive = campus::get_POST_GET("archive");
//	$rosternumber=campus::get_rosternumber($department_id);
    $activeroster = campus::get_activeroster($department_id, $dateselect);
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);


//=============================================================================
// Determine Discipline Agendas for selection...
//=============================================================================
// Discipline Agendas from roster ...
    if ($archive != TRUE)
    {
        $message = get_lang("msgAgenda2archive1") . $departmentStruc[$department_id]['code'] . ",<br>";
        $message.= get_lang("msgAgenda2archive2");
        $message.= '<a href="' . $this->get_campus_admin_url() . '&page=agenda2archive&archive=TRUE">' . get_lang("txtYes") . '</a>';
        Display::warning_message($message, false);
    }
    else
    {
        $agendasarchived = FALSE;


        // ===================================================================================
        //   Read in agenda's
        // ===================================================================================
        //$start = substr($academicYear, 0, 4) . '-09-01';
        //$end = substr($academicYear, 5, 4) . '-08-31';
        $start = mktime(0, 0, 0, 9, 1, substr($academicYear, 0, 4));
        $end = mktime(0, 0, 0, 8, 31, substr($academicYear, 5, 4));
        echo time() . "<br>";
        $agendasarchived = FALSE;
        $period_array = campus::get_department2period($department_id);


        /*
          // discipline search array
          $discipline_code2id = array();
          $discipline_id2code = array();
          $result = mysql_query("SELECT `id`, `code`,`name` FROM `campus_discipline` WHERE `department_id` = " . $department_id);
          while ($rij = mysql_fetch_array($result))
          {
          $discipline_id2code[$rij['id']] = $rij['code'];
          $discipline_code2id[$rij['code']] = $rij['name'];
          }

          $query = 'SELECT `id`,`discipline`,`assignment_code`
          FROM `campus_agenda_archive`
          WHERE `department_code`="' . $departmentStruc[$department_id]['code'] . '" AND `academic_year`="' . $academicYear . '"';

          $result = mysql_query($query) or die("test2:" . mysql_error());
          while ($rij = mysql_fetch_array($result))
          {
          $temp = explode('_',  $rij['assignment_code']);

          $combination=($rij['discipline']=='')?$academicYear:$rij['discipline'].','.$temp[1];
          echo $rij['discipline'].'=>'. $discipline_code2id[$rij['discipline']]. ' ' .$rij['assignment_code'].'=>'.  $combination;
          $query2 = 'UPDATE `campus_agenda_archive` SET
          `assignment_code` = "' . $combination . '",
          `discipline` = "' .  $discipline_code2id[$rij['discipline']] . '"
          WHERE `id`=' . $rij['id'] . '
          ';
          $result2 = mysql_query($query2) or die('TEST' . mysql_error());
          if ($result2)
          {
          echo "OK";

          }
          else
          {
          echo "FOUT";
          }
          echo '<br>';
          }
         */

        $query = "SELECT `campus_agenda`.`id`,`campus_discipline`.`name`,`campus_discipline`.`code`,`assignment_id`, `user_user`.`official_code`,`date`,`period_id`,`content`,`tasks`,`comment`
          FROM `campus_agenda`
          LEFT JOIN `user_user` ON `user_user`.`id`=`campus_agenda`.`user_id`
          LEFT JOIN `campus_assignment` ON `campus_assignment`.`id`=`campus_agenda`.`assignment_id`
          LEFT JOIN `campus_discipline` ON `campus_discipline`.`id`=`campus_assignment`.`discipline_id`
          WHERE (`campus_agenda`.`department_id`=" . $department_id . " OR `campus_discipline`.`department_id`=" . $department_id . ")
          AND `date`>=" . $start . " AND `date`<=" . $end . "
          ORDER BY `assignment_id`";






        $prev_id = 0;
        $agendacombi = $academicYear;
        $result = mysql_query($query) or die("test2:" . mysql_error());
        $s_c = 0;
        $t_c = 0;
        $t_c_e = 0;
        $d_c = 0;
        $d_c_e = 0;
        mysql_query('START TRANSACTION');
        while ($rij = mysql_fetch_array($result))
        {
            if ($prev_id <> $rij['assignment_id'])
            { //only get info once for each assignment (to improve performance...
                mysql_query('COMMIT');

                echo $agendacombi . "=> COPIED " . $s_c . ' :: ' . $t_c . ' :: ' . $t_c_e . ' :: ' . $d_c . ' :: ' . $d_c_e . "<br>";
                flush();
                ob_flush();
                $prev_id = $rij['assignment_id'];
                $agendacombi = $rij['code'] . ',' . $rij['assignment_id'];
                mysql_query('START TRANSACTION');
            }
            $s_c++;
            $grouplist = campus::get_agenda2grouplist($rij['id']);
            $studentlist = "";
            $students = campus::get_agenda2student($rij['id']);
            foreach ($students as $student_id => $studentinfo)
            {
                $studentlist.=substr($studentinfo['firstname'], 0, 1) . ". " . $studentinfo['lastname'] . ", ";
            }
            $studentlist = substr($studentlist, 0, -2);
            $query2 = "INSERT `campus_agenda_archive` SET
          `academic_year`= '" . $academicYear . "',
          `department_code` = '" . $departmentStruc[$department_id]['code'] . "',
          `teacher_code` = '" . $rij['official_code'] . "',
          `assignment_code` = '" . $agendacombi . "',
          `discipline` = '" . $rij['name'] . "',
          `date` = " . $rij['date'] . ",
          `period_code` = '" . $period_array[$rij['period_id']]['code'] . "',
          `grouplist` = '" . $grouplist . "',
          `studentlist` = '" . $studentlist . "',
          `content` = '" . addslashes($rij['content']) . "',
          `tasks` = '" . addslashes($rij['tasks']) . "',
          `comment` = '" . addslashes($rij['comment']) . "'
          ";
            $result2 = mysql_query($query2) or die('TEST' . mysql_error());
            if ($result2)
            {
                $t_c++;
                $agendasarchived = TRUE;
                $query3 = "DELETE `campus_agenda`, `campus_agenda_rel_group`, `campus_agenda_rel_student`  FROM `campus_agenda`
          LEFT JOIN `campus_agenda_rel_group` ON `campus_agenda_rel_group`.`agenda_id` = `campus_agenda`.`id`
          LEFT JOIN `campus_agenda_rel_student` ON `campus_agenda_rel_student`.`agenda_id` = `campus_agenda`.`id`
          WHERE  `campus_agenda`.`id`=" . $rij['id'] . " ";
                $result3 = mysql_query($query3) or die('DELETE' . mysql_error());
                if ($result3)
                {
                    $d_c++;
                }
                else
                {
                    $d_c_e++;
                }
            }
            else
            {
                $t_c_e++;
                $agendasarchived = FALSE;
            }
        }

        mysql_query('COMMIT');
        echo $agendacombi . " COPIED";
        echo $s_c . ' :: ' . $t_c . ' :: ' . $t_c_e . ' :: ' . $d_c . ' :: ' . $d_c_e . '<br>';

        echo time();
        if ($agendasarchived)
        {
            // ===================================================================================
            //  	 Clear agenda's
            // ===================================================================================
            // delete agenda all agenda data from department where classes students are linked to.

            $query = "DELETE `campus_agenda`, `campus_agenda_rel_group`, `campus_agenda_rel_student`  FROM `campus_agenda`, `campus_agenda_rel_group`, `campus_agenda_rel_student`
          WHERE  `campus_agenda`.`id`=`campus_agenda_rel_group`.`agenda_id` AND `campus_agenda`.`id` = `campus_agenda_rel_student`.`agenda_id`
          AND `department_id`=" . $department_id . "
          ";
            $result = mysql_query($query) or die(mysql_error());
            // delete agenda all agenda data from department where only classes are linked to.
            $query = "DELETE `campus_agenda`, `campus_agenda_rel_group` FROM `campus_agenda`, `campus_agenda_rel_group`
          WHERE  `campus_agenda`.`id`=`campus_agenda_rel_group`.`agenda_id`
          AND `department_id`=" . $department_id . "
          ";
            $result = mysql_query($query) or die(mysql_error());
            // delete agenda all agenda data from department where with nothing linked to.
            $query = "DELETE `campus_agenda` FROM `campus_agenda`
          WHERE `department_id`=" . $department_id . "
          ";
            $result = mysql_query($query) or die(mysql_error());
            echo "<br><br>DELETION OK";
        }
        else
        {
            echo "<br><br>NOTHING DELETED";
        }
    }
}
?>
