<?php
/*
==============================================================================
  plugin: campus for Chamilo 1.8.X
	  by Ludwig Theunis (email: ludwig@openelo.be)
==============================================================================
*/
/*
==============================================================================
	Chamilo - E-earning & Collaboration Software

	Copyright (c) various contributors

	For a full list of contributors detaining copyrights over parts of
	the Chamilo software, see "documentation/credits.html".
	The full license can be read in "documentation/license.html".

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	See the GNU General Public License for more details.

	Mail: info@chamilo.org
==============================================================================
*/
/*
==============================================================================
	This is a content file included in the index.php file in this directory. 
==============================================================================
*/

//check if user is allowed here...
if ((intval($_uid)==0) || (empty($departmentStruc) || empty($is_teacher)) && !($is_platformadmin)) 
{// not allowed here!
	Display::display_error_message(get_lang("msgNoDepartmentMember"),false);
}
else
{//only teachers and platform administrator are allowed here...

/*
============================================================================== 
	POST & GET vars, check for default value?.
============================================================================== 
*/
	$teacher_id=intval(campus::get_POST_GET("teacher_id"));
	$teacher2_id=intval(campus::get_POST_GET("teacher2_id"));
	$startdate=campus::get_POST_GET("startdate");
	$enddate=campus::get_POST_GET("enddate");
	$agendaselect=campus::get_POST_GET("agendaselect");
	list($agendadiscipline,$agendaclass)=explode("�",$agendaselect);
	$action=campus::get_POST_GET("action", "list");
	

/*
-----------------------------------------------------------
	execute actions....
-----------------------------------------------------------
*/	
	$message="";
	$errormessage="";
	switch ($action) 
	{
		case "movecomplete" :
		{
			if ($teacher2_id==0)
			{
				$errormessage=get_lang("msgNoTeacherSelected");
				$display="move";
			}
			else
			{			
				// select agenda ID's....		
				$query=	"UPDATE `".$campusDb."`.`campus_agenda` SET `teacher_id`=".$teacher2_id."
    	    	  	WHERE  `teacher_id`=".$teacher_id." AND `department_id`=".$department_id." ";
				$result = mysql_query($query);
				if ($result)
				{	
					$message=get_lang("msgAgendaMoved");
					$teacher_id=$teacher2_id;
					$display="list";
				}
				else
				{	
					$errormessage=get_lang("msgAgendaMoveErrors");
					$display="move";
				}
			}			
		}
		break;
		case "move2" :
		{
			$display="move";
			if ($startdate=="")
			{ // no date selected 				
				$datefilter="";
			}
			else
			{ // startdate selected, check date-structure
				$dateNumber=strtotime(ereg_replace("/","-",($startdate)));
				if ($dateNumber!=null)
				{// date=ok add to filter
					$datefilter=" AND `date`>='".strftime('%Y-%m-%d',$dateNumber)."'";
				}
				else
				{// date NIO
					$errormessage=get_lang("msgWrongDate");
				}
			}
			if ($enddate=="")
			{ // no date selected 				
				$datefilter.="";
			}
			else
			{ // enddate selected, check date-structure
				$dateNumber=strtotime(ereg_replace("/","-",($enddate)));
				if ($dateNumber!=null)
				{// date=ok add to filter
					$datefilter.=" AND `date`<='".strftime('%Y-%m-%d',$dateNumber)."'";
				}
				else
				{// date NIO
					$errormessage=get_lang("msgWrongDate");
				}
			}
			if ($errormessage=="")
			{
				if ($teacher2_id==0)
				{
					$errormessage=get_lang("msgNoTeacherSelected");
				}
				else
				{	
					$message=get_lang("msgNothingMoved");
					// select agenda ID's....		
					$query=	"SELECT `agenda_id` FROM `".$campusDb."`.`campus_agenda`
	    	    	  	WHERE  `teacher_id`=".$teacher_id." AND `department_id`=".$department_id." AND `discipline_id`=".$agendadiscipline.$datefilter." ORDER BY `discipline_id`";
					$result = mysql_query($query);
					while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
					{
						$classes_array=campus::get_agenda2classes ($rij['agenda_id']);
						$classcombi="";
						foreach ($classes_array as $class_id => $classinfo)
						{
							$classcombi.=$class_id."_";
						}
						if ($agendaclass==$classcombi)
						{
							$query2= "UPDATE `".$campusDb."`.`campus_agenda` SET `teacher_id`=".$teacher2_id."
			    	    	  	WHERE `agenda_id`=".$rij['agenda_id']."";
							$result2 = mysql_query($query2);
							if ($result2)
							{	
								$message=get_lang("msgAgendaMoved");
								$display="list";
							}
							else
							{	
								$errormessage=get_lang("msgAgendaMoveErrors");
								$display="move";
							}
						}
					}
				}			
			}
		}
		break;
		case "move" :
		{
			$display="move";
			$message="Met deze functie kan je bepaalde agenda inhouden toewijzen aan een andere leerkracht van de school.";
		}
		break;
 		default :
		{
			$display="list";
		}
		break;
	}
/*
============================================================================== 
		display ...
============================================================================== 
*/
	campus::display_departments ($departmentStruc,$department_id,$page."&teacher_id=".$teacher_id);


	if (!empty($errormessage))
	{		
		Display::display_error_message($errormessage,false);
	}
	elseif (!empty($message))
	{
		Display::display_normal_message($message,false);
	}

	$teacher=api_get_user_info($teacher_id);
	echo "<b>".get_lang("txtTeachersAgenda").": ".$teacher['firstName']." ".$teacher['lastName']."</b><br><br>";
	echo "<br>";
	if ($display=="list")
	{
		echo '		
		<form method="post" action="'.$_SERVER['PHP_SELF'].'" name="myform">
		<input type="hidden" name="page" value="agendaadmin" >
		<input type="hidden" name="agendaselect" value="'.$agendaselect.'" >
		<input type="hidden" name="teacher_id" value="'.$teacher_id.'" >
		<input type="hidden" name="action" value="'.$action.'" >
		'.get_lang('labelMoveCompleteAgenda').'
		<select name="teacher2_id">
		<option value="">'.get_lang('txtSelectTeacher').'</option>
		';
		$teachers=campus::get_teachers ($department_id);
		foreach ($teachers as $teacherid=>$value)
		{
			if (empty($teachers_array[$teacherid]) && ($value['official_code']!=""))
			{
				echo '<option value="'.$teacherid.'">'.$value['official_code'].': '.$value['fullname'].'</option>';
			}
		}
 		echo '</select>
			<input type="submit" name="submitmessage" value="'.get_lang('buttonlabelExecute').'" onmousedown="javascript:document.myform.action.value=\'movecomplete\'">
			</form>';
		echo '<br><b>'.get_lang('txtAgendaDetails').':</b><br>';
		$query=	"SELECT `discipline_id`, `agenda_id` , `department_id`
				FROM `".$campusDb."`.`campus_agenda`
          	WHERE  `teacher_id`=".$teacher_id." AND `department_id`=".$department_id." ORDER BY `discipline_id`";
		$result = mysql_query($query);
		while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
		{
			$classes_array=campus::get_agenda2classes ($rij['agenda_id']);
			$classcombi="";
			$grouplist="";
			foreach ($classes_array as $class_id => $classinfo)
			{
				$classcombi.=$class_id."_";
				$grouplist.=$classinfo['code']." ";
			}
			$grouplist=trim($grouplist);
			$discipline_agendas[$rij['discipline_id']][$classcombi]['classes']=$classes_array;
			$discipline_agendas[$rij['discipline_id']][$classcombi]['grouplist']=($grouplist=="")?"<i>".get_lang("txtPersonalAgenda")."</i>":$grouplist;
		}
		echo "<ul>";
		foreach ($discipline_agendas as $discipline_id=>$array)
		{
			$discipline_array=campus::get_discipline_info ($discipline_id);
			foreach ($array as $classcombi => $roster_id_array)
			{
				echo "<li>".$discipline_array[$discipline_id]['name']." (".$discipline_array[$discipline_id]['code'].") ".$roster_id_array['grouplist']." <a href=\"".$_configuration['root_web']."plugin/campus/agenda/disciplineagenda2pdf.php?department_id=".$department_id."&teacher_id=".$teacher_id."&agendaselect=".$discipline_id."�".$classcombi."\" target=\"_blank\" >".get_lang("txtAgenda2Pdf")."</a>";
				echo "&nbsp<a href=\"".$_SERVER['PHP_SELF']."?page=agendaadmin&action=move&teacher_id=".$teacher_id."&agendaselect=".$discipline_id."�".$classcombi."\" >".get_lang("txtMoveAgenda")."</a></li>"; 
			}
		}
		echo "</ul>";
	}
	else
	{
		$discipline=campus::get_discipline_info ($agendadiscipline);
		$classes=explode("_",$agendaclass);
		echo $discipline[$agendadiscipline]['name'].": ";
		foreach ($classes as $class_id)
		{
			$classinfo=campus::get_class_info($class_id);
			echo $classinfo[$class_id]['code']." ";
		}
		echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" name="myform">
			<input type="hidden" name="page" value="agendaadmin" >
			<input type="hidden" name="agendaselect" value="'.$agendaselect.'" >
			<input type="hidden" name="teacher_id" value="'.$teacher_id.'" >
			<input type="hidden" name="action" value="'.$action.'" >
			'.get_lang('labelTeacher').'
			<select name="teacher2_id">
			<option value="">'.get_lang('txtSelectTeacher').'</option>';
		$teachers=campus::get_teachers ($department_id);
		foreach ($teachers as $teacherid=>$value)
		{
			if (empty($teachers_array[$teacherid]) && ($value['official_code']!=""))
			{
				echo '<option value="'.$teacherid.'">'.$value['official_code'].': '.$value['fullname'].'</option>';
			}
		}
		echo '</select><br><br>'.
			get_lang('txtDateHint').'<br>'.
			get_lang('labelStartDate').': <input type="text" name="startdate" value="'.$startdate.'" >(yyyy-mm-dd)<br>'.
			get_lang('labelEndDate').': <input type="text" name="enddate" value="'.$enddate.'" ><br>
			<input type="submit" name="submitmessage" value="'.get_lang('buttonlabelExecute').'" onmousedown="javascript:document.myform.action.value=\'move2\'">
			<input type="submit" name="cancel" value="'.get_lang('buttonlabelCancel').'" onMouseDown="javascript:document.myform.action.value=\'list\';">
			</form>';
	}
}
?>
