<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Display;
use common\libraries\DatetimeUtilities;
use common\libraries\PlatformSetting;


//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['roster']) && empty($admin['info']) && !$is_platformadmin))
{// not allowed here!
    echo "NOT ALLOWED!!!"; //get_lang("msgNoRights4ThisDepartment");
}
else
{//only teachers and platform administrator are allowed here...
    $department_id = intval(campus::get_SESSION("department_id", key($departmentStruc)));
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);
    $selectAcYear = campus::get_POST_GET("selectAcYear", $academicYear);

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */

    // ===============================================================
    // kalenderlijst weergeven........
    // ===============================================================
    $query = 'SELECT `id`, `date`, `content`, `vacation`, `public`
		FROM `campus_calender`
			WHERE `department_id`= ' . $department_id . '
				AND `date` >=' . mktime(0, 0, 0, 9, 1, substr($selectAcYear, 0, 4)) . '
				AND `date` <=' . mktime(0, 0, 0, 8, 31, substr($selectAcYear, 5, 4)) . '
			ORDER BY `date`';
    $result = mysql_query($query);
    $content = array();
    $vacation = array();
    $public = array();
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        $content[$rij['date']][$rij['id']] = $rij['content'];
        $vacation[$rij['date']][$rij['id']] = $rij['vacation'];
        $public[$rij['date']][$rij['id']] = $rij['public'];
    }
    $D = DatetimeUtilities::get_days_short();
    $mnd1 = 9;
    $mnd2 = 12;
    $kolom = 0;
    for ($t = 1; $t <= 2; $t++)
    {
        for ($mnd = $mnd1; $mnd <= $mnd2; $mnd++)
        {
            if ($kolom > 5)
            {
                //$kolom=0;
                //newpage
            }
            if ($mnd >= 9)
            {
                $year = substr($selectAcYear, 0, 4); // ???
            }
            else
            {
                $year = substr($selectAcYear, 5, 4); // ???
            }
            $testdate = strtotime($year . '-' . $mnd . '-1');
            // weekdag van de eerstedag van de maand bepalen.
            $dag1 = strftime('%w', $testdate);
            // het aantaldagen in de maand bepalen.
            for ($dag2 = 31; $dag2 >= 28; $dag2--)
            {
                if (strftime('%m', $testdate) == strftime('%m', strtotime($year . '-' . $mnd . '-' . $dag2)))
                {
                    break;
                }
            }
            // Maandschrijven...
            $data[0][$mnd]['colhead'] = DatetimeUtilities::format_locale_date('%B %Y', $testdate);
            $dataOK = false;
            $dag = 6;
            $dagteller = 1;
            for ($n = 1; $n <= 37; $n++)
            {
                $date = strtotime($year . "-" . $mnd . "-" . $dagteller);
                if ($dag == $dag1)
                {
                    $dataOK = true;
                }
                //weekdag schrijven ...
                $data[$n][$mnd]['dag'] = strtoupper(substr($D[$dag], 0, 1));
                if ($dataOK)
                {
                    $data[$n][$mnd]['date'] = $date;
                    $data[$n][$mnd]['dagno'] = $dagteller;
                    $data[$n][$mnd]['content'] = $content[$date];
                    $data[$n][$mnd]['vacation'] = $vacation[$date];
                    $data[$n][$mnd]['public'] = $public[$date];
                    $dagteller++;
                    if ($dagteller > $dag2)
                    {
                        $dag1 = 99;
                        $dataOK = false;
                    }
                }
                $dag++;
                if ($dag > 6)
                {
                    $dag = 0;
                }
            }
            $kolom++;
        }
        $mnd1 = 1;
        $mnd2 = 8;
    }

    /*
      -----------------------------------------------------------
      Header
      -----------------------------------------------------------
     */
    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment; filename=calender' . $selectAcYear . '.xls');
    header('Pragma: no-cache');
    header('Expires: 0');
    echo '<style type="text/css">
				body         {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: normal; }
				TD.CEL       {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size:14px;font-weight:bold; border-left: 1px solid #000000;border-top: 1px solid #000000;border-right: 1px solid #000000;border-bottom: 1px solid #000000; }
				TD.KOLOMKOP  {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 24px; font-weight: bold;  border-left: 1px solid #000000;border-top: 1px solid #000000;border-right: 1px solid #000000;border-bottom: 1px solid #000000; background-color:#ffccff;}
				TD.KOLOMKOPb  {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: bold;  border-left: 1px solid #000000;border-top: 1px solid #000000;border-right: 1px solid #000000;border-bottom: 1px solid #000000; background-color:#ccccff;}
				TD.KOLOMKOP1  {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: bold;  border-left: 1px solid #000000;border-top: 1px solid #000000;border-right: none;border-bottom: 1px solid #000000; padding-left: 3px;background-color:#ccccff;}
				TD.KOLOMKOP2  {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: bold;  border-left: none ;border-top: 1px solid #000000;border-right: 1px solid #000000;border-bottom: 1px solid #000000; padding-left: 3px;}
				TABLE        {border-left: 2px solid #000000;border-top: 2px solid #000000;border-right: 2px solid #000000;border-bottom: 2px solid #000000;}
			</style>';
    echo '<table style="border-spacing: 0px;">';
    $brdr = "border: solid 1px #777777;";
    echo '<tr>' .
    '<td COLSPAN=36 class="KOLOMKOP" >' . $selectAcYear . '</td>' .
    '</tr>';
    foreach ($data as $tr => $data1)
    {
        echo'<tr>';
        foreach ($data1 as $td => $data2)
        {
            if ($tr == 0)
            {
                echo '<td COLSPAN=3 class="KOLOMKOPb">' . $data2['colhead'];
                echo '</td>';
            }
            else
            {
                $content = '';
                $vacation = '';
                $public = '';
                if ($data2['dagno'] != '')
                {
                    $date = $data2['date'];
                    $bkgd = ((strftime('%w', $date) == 0) || (strftime('%w', $date) == 6)) ? "background-color:#cceecc;" : "background-color:#eeeeee;";
                    if (is_array($data2['content']))
                    {
                        foreach ($data2['content'] as $key => $value)
                        {
                            $bkgd = ($data2['vacation'][$key] == 'on') ? 'background-color:#cceecc;' : $bkgd;
                            $content.=$data2['content'][$key] . '&nbsp;';
                            $date++; //
                        }
                    }
                    else
                    {
                        $content = ' ';
                        $vacation = '';
                        $public = '';
                    }
                }
                else
                {
                    $bkgd = 'background-color:#cccccc;';
                    //$data2['dag']="";
                }
                echo'<td valign="top" width="20" style="border: solid 1px #777777;' . $bkgd . '">' . $data2['dag'] . '</td>';
                echo'<td valign="top" width="20" style="border: solid 1px #777777;' . $bkgd . '">' . $data2['dagno'] . '</td>';
                echo'<td valign="top" width="200" style="border: solid 1px #777777;' . $bkgd . '">' . $content . '</td>';
            }
        }
        echo'</tr>';
    }
    echo'
			</table>
		';
}
?>