<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Theme;
use common\libraries\Display;


//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */

    /*
      ==============================================================================
      MAIN CODE
      ==============================================================================
     */
    //campus::display_departments ($departmentStruc,$department_id,$page);

    if (!empty($message))
    {
        Display::normal_message($message, false);
    }
    if ($is_platformadmin)
    {
         echo '
				<div class="admin_section">
					<h4><img src="' . Theme::get_image_path('application\campus') . '/departments.gif" border=0 align="absmiddle"> ' . get_lang("txtDepartmentsAdmin") . '</h4>
					<ul>
						<li><a href="' . $this->get_campus_admin_url() . '&page=editdepartment">' . get_lang("page_editdepartment") . '<b>*</b></a></li>
						<li><a href="' . $this->get_campus_admin_url() . '&page=teacherclass2department">' . get_lang("page_teacherclass2department") . '<b>*</b></a></li>
						<li><a href="' . $this->get_campus_admin_url() . '&page=studentclass2department">' . get_lang("page_studentclass2department") . '<b>*</b></a></li>
						<li><a href="' . $this->get_campus_admin_url() . '&page=parentclass2department">' . get_lang("page_parentclass2department") . '<b>*</b></a></li>
						<li><a href="' . $this->get_campus_admin_url() . '&page=editcampusrights">' . get_lang("page_editcampusrights") . '<b>*</b></a></li>
						<li><a href="' . $this->get_campus_admin_url() . '&page=viewcampusrights">' . get_lang("page_viewcampusrights") . '<b>*</b></a></li>
					</ul>
				</div>
		';
    }
    if (($department_id != 0) && ((isset($admin['roster']) && $admin['roster']) || (isset($admin['info']) && $admin['info']) || $is_platformadmin))
    {
        echo '<div class="admin_section">
					<h4><img src="' . Theme::get_image_path('application\campus') . '/raster.gif" border=0 align="absmiddle"> ' . get_lang("txtRosterAdmin") . '</h4>
					<ul>';
        if ((isset($admin['roster']) && $admin['roster']) || $is_platformadmin)
        {
            echo "		<li><a href=\"" . $this->get_campus_admin_url() . "&page=editcurriculum\">" . get_lang("page_editcurriculum") . "</a></li>
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=editperiod&action=list\">" . get_lang("page_edittimetable") . "</a></li>
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=editresource&action=list\">" . get_lang("page_editresource") . "</a></li>
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=editdiscipline\">" . get_lang("page_editdiscipline") . "</a></li>
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=importagendacontent&action=step1\">" . get_lang("page_importagendacontent") . "</a></li>";
        }
        echo "			<li><a href=\"" . $this->get_campus_admin_url() . "&page=editcalender&action=list\">" . get_lang("page_editcalender") . "</a></li>";
        echo ($is_platformadmin) ? "<li><a href=\"" . $this->get_campus_admin_url() . "&page=agenda2archive\">" . get_lang("page_agenda2archive") . "<b>*</b></a>" : "";
        echo "</ul>";
        echo "</div>";
        /*         * ** REPORT DISABLE *** */
        if ($is_platformadmin) //1.5.x
        {
            echo "<div class=\"admin_section\">
					<h4><img src=\"" . Theme::get_image_path('application\campus') . "/report.gif\" border=0 align=\"absmiddle\"> " . get_lang("txtReportAdmin") . "</h4>
					<ul>
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=editreport2assignment\">" . get_lang("page_editreport2assignment") . "</a></li>
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=editreporttree\">" . get_lang("page_editreporttree") . "</a></li>
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=editevaluationtree\">" . get_lang("page_editevaluationtree") . "</a></li>
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=editconstantlist\">" . get_lang("page_editconstantlist") . "</a></li>
					</ul>
			";
            echo "</div>";
        }
        /*         * ** REPORT DISABLE *** */
    }
    if (($department_id != 0) && ((isset($admin['student']) && $admin['student']) || (isset($admin['studentTrackingLevel3']) && $admin['studentTrackingLevel3']) || $is_platformadmin))
    {
        echo '<div class="admin_section"><h4><img src="' . Theme::get_image_path('application\campus') . '/students.gif" border=0 align="absmiddle"> ' . get_lang('txtStudentAdmin') . '</h4>
					<ul>';

        if ((isset($admin['student']) && $admin['student']) || $is_platformadmin)
        {
            echo '	<li><a href="' . $this->get_campus_admin_url() . '&page=studentpassword">' . get_lang('page_studentpassword') . '</a></li>
				<li><a href="' . $this->get_campus_admin_url() . '&page=studentadmin">' . get_lang('page_studentadmin') . '</a></li>
				<li><a href="' . $this->get_campus_admin_url() . '&page=photoadmin">' . get_lang('page_photoadmin') . '</a></li>';
        }
	echo '	<li><a href="' . $this->get_campus_admin_url() . '&page=studentarchive">' . get_lang("page_studentarchive") . '</a></li>';
         echo '	<li><a href="' . $this->get_campus_admin_url() . '&page=editteacher2studentclass">' . get_lang('page_editteacher2studentclass') . '</a></li>';
        if ($is_platformadmin)
        {
            echo "
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=addstudents\">" . get_lang("page_addstudents") . "<b>*</b></a></li>
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=addstudents2classes\">" . get_lang("page_addstudents2classes") . "<b>*</b></a></li>
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=class2csv\">" . get_lang("page_class2csv") . "*</a></li>
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=clearclasses\">" . get_lang("page_clearclasses") . "<b>*</b></a></li>
                		";
        }
       echo '</ul></div>';
        if ((isset($admin['student']) && $admin['student']) || $is_platformadmin)
        {
            echo '	<div class="admin_section"><h4><img src="' . Theme::get_image_path('application\campus') . '/parent.gif" border=0 align="absmiddle"> ' . get_lang('txtParentAdmin') . '</h4>
					<ul>';
            echo '	<li><a href="' . $this->get_campus_admin_url() . '&page=parentadmin">' . get_lang('page_parentadmin') . '</a></li>';
            if ($is_platformadmin)
            {
                echo '	<li><a href="' . $this->get_campus_admin_url() . '&page=addparents">' . get_lang('page_addparents') . '<b>*</b></a></li>';
            }
            echo '	</ul></div>';
        }
    }

    if (($department_id != 0) && ((isset($admin['student']) && $admin['student']) || (isset($admin['studentTrackingLevel3']) && $admin['studentTrackingLevel3']) || ($is_platformadmin)))
    {
        echo "
				<div class=\"admin_section\">
					<h4><img src=\"" . Theme::get_image_path('application\campus') . "/studenttracking.gif\" border=0 align=\"absmiddle\"> " . get_lang("txtTrackingAdmin") . "</h4>
					<ul>
				";
        if ($is_platformadmin)
        {
            echo "
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=studentdetail2tracking\">" . get_lang("page_studentdetail2tracking") . "<b>*</b></a></li>
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=editstudenttrackingcategory\">" . get_lang("page_editstudenttrackingcategory") . "<b>*</b></a></li>
				";
        }
        if ((isset($admin['studentTrackingLevel3']) && $admin['studentTrackingLevel3']) || ($is_platformadmin))
        {
            echo "
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=editstudenttrackingtitle\">" . get_lang("page_editstudenttrackingtitle") . "<b></b></a></li>
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=editstudenttrackingform\">" . get_lang("page_editstudenttrackingform") . "<b></b></a></li>
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=editcoach\">" . get_lang("page_editcoach") . "<b></b></a></li>";
        }
        echo "
					</ul>
				</div>
			";
    }
    if (($department_id != 0) && ((isset($admin['objectiveTrackingLevel0']) && $admin['objectiveTrackingLevel0']) || (isset($admin['objectiveTrackingLevel1']) && $admin['objectiveTrackingLevel1']) || $is_platformadmin))
    {
        echo '
				<div class="admin_section">
					<h4><img src="' . Theme::get_image_path('application\campus') . '/objective.png" border=0 align="absmiddle"> ' . get_lang('txtobjectiveAdmin') . '</h4>
					<ul>';
        if ($is_platformadmin)
        {
            echo '		<li><a href="' . $this->get_campus_admin_url() . '&page=editobjective">' . get_lang('page_editobjective') . '<b>*</b></a></li>';
        }
        echo '		<li><a href="' . $this->get_campus_admin_url() . '&page=editobjectiveview">' . get_lang('page_editobjectiveview') . '<b>*</b></a></li>';
        echo '			<li><a href="' . $this->get_objectivetracking_url() . '">' . get_lang('page_objectivetracking') . '</a></li>
					</ul>
				</div>';
    }
    if (($department_id != 0) && $is_platformadmin)
    {
        echo "
				<div class=\"admin_section\">
					<h4><img src=\"" . Theme::get_image_path('application\campus') . "/teachers.gif\" border=0 align=\"absmiddle\"> " . get_lang("txtTeacherAdmin") . "</h4>
					<ul>
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=teacherpassword\">" . get_lang("page_teacherpassword") . "<b>*</b></a></li>
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=teacheradmin\">" . get_lang("page_teacheradmin") . "<b>*</b></a></li>
						<li><a href=\"" . $this->get_campus_admin_url() . "&page=addteachers\">" . get_lang("page_addteachers") . "<b>*</b></a></li>
	                    <li><a href=\"" . $this->get_campus_admin_url() . "&page=teacherclassupdategroups\" >Mijn administratie update</a></li>
				    </ul>
				</div>
		";
    }
    if (($department_id != 0) && ((isset($admin['IT']) && $admin['IT']) || $is_platformadmin))
    {
  
     echo '<div class="admin_section">
      <h4><img src="' . Theme::get_image_path('application\campus') . '/IT.gif" border=0 align="absmiddle"> ' . get_lang("txtITAdmin") . '</h4>
      <ul>
      <li><a href="' . $this->get_it_support_url() . '&page=ITdevicelist">' . get_lang("page_manageITdevices") . '</a></li>';
        if ($is_platformadmin)
        {
            echo '  <li><a href="' . $this->get_it_support_url() . '&page=device_info_category">' . get_lang("device_info_category") . '<b>*</b></a></li>
      <li><a href="' . $this->get_it_support_url() . '&page=device_info">' . get_lang("device_info") . '</a></li>
      <li><a href="' . $this->get_it_support_url() . '&page=ITdefectcategorys">' . get_lang("page_manageITdefectcategorys") . '<b>*</b></a></li>';
        }
        else
        {
            echo '  <li><a href="' . $this->get_it_support_url() . '&page=device_info">' . get_lang("page_manageITstats") . '</a></li>';
        }
        echo '      <li><a href="' . $this->get_it_support_url() . '&page=ITerrorlog">' . get_lang("page_ITerrorlog") . '</a></li>
      </ul>
      </div>';
    }

    if ($is_platformadmin)
    {
    echo '<div class="admin_section">
      <h4><img src="' .  Theme::get_image_path('application\campus') . '/IT.gif" border=0 align="absmiddle"> ' . get_lang("txtCourseAdmin") . '</h4>
      <ul>';
           //	<li><a href=\"".$this->get_campus_admin_url()."?page=showcourses\">". get_lang("page_showcourses")."<b>*</b></a></li>
            echo '  <li><a href="' . $this->get_campus_admin_url(). '&page=managedropboxes">' . get_lang("page_manageDropboxes") . '</a></li>';
            echo '  <li><a href="' . $this->get_campus_admin_url(). '&page=managedokeoscourse">' . get_lang("page_manageDokeosCourses") . '</a></li>';
       
            echo '</ul></div>';
 
 /*     echo "
				<div class=\"admin_section\">
					<h4><img src=\"" . Theme::get_image_path('application\campus') . "/import.gif\" border=0 align=\"absmiddle\"> " . get_lang("txtImportOld") . "</h4>
					<ul>
						<li><a href=\"" . $this->get_url() . "&page=importagendaarchive\">" . get_lang("importagendaarchive") . "</a></li>
						<li><a href=\"" . $this->get_url() . "&page=importstudenttracking\">" . get_lang("importstudenttracking") . "</a></li>
						<li><a href=\"" . $this->get_url() . "&page=importtrackingforms\">" . get_lang("importtrackingforms") . "</a></li>
						<li><a href=\"" . $this->get_url() . "&page=importtrackingformlines\">" . get_lang("importtrackingformlines") . "</a></li>
						<li><a href=\"" . $this->get_url() . "&page=importtrackingformsubforms\">" . get_lang("importtrackingformsubforms") . "</a></li>
						<li><a href=\"" . $this->get_url() . "&page=importobjectivetracking\">" . get_lang("importobjectivetracking") . "</a></li>
						<li><a href=\"" . $this->get_url() . "&page=importobjectivetrackinginfo\">" . get_lang("importobjectivetrackinginfo") . "</a></li>
						<li><a href=\"" . $this->get_url() . "&page=importobjectivetrackinggroup\">" . get_lang("importobjectivetrackinggroup") . "</a></li>
						<li><a href=\"" . $this->get_url() . "&page=importobjectivetrackingteacher\">" . get_lang("importobjectivetrackingteacher") . "</a></li>
						<li><a href=\"" . $this->get_url() . "&page=importobjectivetrackingobjective\">" . get_lang("importobjectivetrackingobjective") . "</a></li>
						<li><a href=\"" . $this->get_url() . "&page=importinfo\">" . get_lang("importinfo") . "</a></li>
						<li><a href=\"" . $this->get_url() . "&page=importattention\">" . get_lang("importattention") . "</a></li>
						<li><a href=\"" . $this->get_url() . "&page=importitdefect\">" . get_lang("importitdefect") . "</a></li>
						<li><a href=\"" . $this->get_url() . "&page=importitdefectcategory\">" . get_lang("importitdefectcategory") . "</a></li>
						<li><a href=\"" . $this->get_url() . "&page=importitdeviceinfo\">" . get_lang("importitdeviceinfo") . "</a></li>
						<li><a href=\"" . $this->get_url() . "&page=importitdeviceinfocategory\">" . get_lang("importitdeviceinfocategory") . "</a></li>
						<li><a href=\"" . $this->get_url() . "&page=importitdevicerelinfo\">" . get_lang("importitdevicerelinfo") . "</a></li>
						<li><a href=\"" . $this->get_url() . "&page=importitdevice\">" . get_lang("importitdevice") . "</a></li>
					</ul>
				</div>
			";
  */
    }
}
?>