<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Display;
use common\libraries\Theme;
use common\libraries\DatetimeUtilities;
use common\libraries\PlatformSetting;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['roster']) && empty($admin['info']) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $action = campus::get_POST_GET("action");
    $submitmessage = campus::get_POST_GET("submitmessage");
    $calender_id = intval(campus::get_POST_GET("calender_id"));
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);
    $selectAcYear = campus::get_POST_GET("selectAcYear", $academicYear);

    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */
    Switch ($action)
    {
        case "new" :
            {
                $calender_id = "";
                $date = "";
                $content = "";
                $public = 0;
                $vacation = 0;
                $display = "form";
            }
            break;
        case "import" :
            {
                $display = "import";
            }
            break;
        case "editlist" :
            {
                $display = "editlist";
            }
            break;
        case "writenew" :
            {
                $date = strtotime(ereg_replace("/", "-", (campus::get_POST_GET("date"))));
                if ($date != null)
                {
                    $query = "INSERT `campus_calender` SET
							`date`=" . $date . ",
							`content`='" . campus::get_POST_GET("content") . "',
							`public`=" . intval(campus::get_POST_GET("public")) . ",
							`vacation`=" . intval(campus::get_POST_GET("vacation")) . ",
							`department_id`= " . $department_id . " 	";
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemAddError");
                        $display = "form";
                    }
                    else
                    {
                        $calender_id = mysql_insert_id();
                        $message = get_lang("msgItemAddSucces");
                        $display = "list";
                    }
                }
                else
                {
                    $message = get_lang("msgDateErrors");
                    $display = "form";
                }
            }
            break;
        case "update" :
            {
                $calender_id = campus::get_POST_GET("calender_id");
                $content_array = campus::get_POST_GET("content");
                $public_array = campus::get_POST_GET("public");
                $vacation_array = campus::get_POST_GET("vacation");
                foreach ($content_array as $date => $content)
                {
                    if ($calender_id[$date] == "")
                    { // no calender id = new record
                        if (($content != "") || ($public_array[$date] != "") || ($vacation_array[$date] != ""))
                        { // if something is added write new record...
                            //    intval($date/100)* is to insure that the stored exactly date is the same for every record on this day
                            $query = "INSERT `campus_calender` SET
							`date`=" .  (intval($date/100)*100) . ",
							`content`='" . $content . "',
							`public`=" . intval($public_array[$date]) . ",
							`vacation`=" . intval($vacation_array[$date]) . ",
							`department_id`= " . $department_id . "
						";
                            $result = mysql_query($query);
                        }
                    }
                    else
                    {
                        if (($content == "") && ($public_array[$date] != 1) && ($vacation_array[$date] != 1))
                        { // if nothing is added delete record...
                            $query = "DELETE FROM `campus_calender` WHERE `id`=" . $calender_id[$date] . "";
                            $result = mysql_query($query);
                        }
                        else
                        {
                            //    intval($date/100)* is to insure that the stored exactly date is the same for every record on this day
                            $query = "UPDATE `campus_calender` SET
							`date`=" . (intval($date/100)*100) . ",
							`content`='" . $content . "',
							`public`=" . intval($public_array[$date]) . ",
							`vacation`=" . intval($vacation_array[$date]) . ",
							`department_id`= " . $department_id . "
							WHERE `id`=" . $calender_id[$date] . "
						";
                            $result = mysql_query($query);
                        }
                    }
                }
                $display = "list";
            }
            break;
        case "writeimport" :
            {
                $row1 = campus::get_POST_GET("row1", "off");
                if (!empty($_FILES))
                {
                    $lines = file($_FILES['uploadfile']['tmp_name']);
                    $i = 1;
                    foreach ($lines as $key => $value)
                    {
                        if ((($row1 == 'off') && ($i == 1)) || ($i > 1))
                        {
                            $values = explode(";", $value);
                            $date = strtotime(ereg_replace("/", "-", $values[0]));
                            if ($date != null)
                            {
                                $result = mysql_query("INSERT INTO `campus_calender` SET `date`=" . $date . ", `content`='" . trim(addslashes($values[1])) . "', `public`='" . ((trim(addslashes($values[3])) == "on") ? 1 : 0) . "', `vacation`='" . ((trim(addslashes($values[2])) == "on") ? 1 : 0) . "', `department_id`=" . $department_id);
                                if (!$result)
                                {
                                    $message = get_lang("msgImportErrors");
                                }
                            }
                            else
                            {
                                $message = get_lang("msgDateErrors");
                            }
                        }
                        $i++;
                    }
                }
                $display = "list";
            }
            break;
        default :
            {
                $display = "list";
            }
            break;
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */

    if (!empty($message))
    {
        Display::normal_message($message, false);
    }
    switch ($display)
    {
        case "form" :
            {
                // ===============================================================
                // Het calender formulier weergeven.........
                // ===============================================================
                echo "<b>" . get_lang("page_addcalendar") . "</b><br>";
                echo '<form method="post" action="' . $this->get_url() . '" name="myform">
				<input type="hidden" name="page" value="editcalender" >
				<input type="hidden" name="action" value="writenew" >
				<table>
					<tr valign="top">
						<td colspan="2">
						</td>
					</tr>
					<tr valign="top">
						<td  align="right">
						' . get_lang('labelDate') . '
						</td>
						<td>
							<input type="text" name="date" size="12" maxlength="10" value="" />
						</td>
					</tr>
					<tr valign="top">
						<td  align="right">
						' . get_lang('labelInfo') . '
						</td>
						<td>
							<input type="text" name="content" size="20" maxlength="32" value="" />
						</td>
					</tr>
					<tr valign="top">
						<td  align="right">
						' . get_lang('labelPublic') . '
						</td>
						<td>
							<input type="checkbox" name="public" value="1">
						</td>
					</tr>
					<tr valign="top">
						<td  align="right">
						' . get_lang('labelVacation') . '
						</td>
						<td>
							<input type="checkbox" name="vacation" value="1">
						</td>
					</tr>
					<tr valign="top">
						<td>
						</td>
						<td>
							<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
						</td>
					</tr>
				</table>
			</form>';
            }
            break;
        case "import" :
            {
                // ===============================================================
                // Calender importform
                // ===============================================================
                echo '<b>' . get_lang('page_importcalendar') . '</b><br>';
                echo '<form method="post" action="' . $this->get_url() . '" name="importform" enctype="multipart/form-data">
				<input type="hidden" name="page" value="editcalender" >
				<input type="hidden" name="action" value="writeimport" >
				<input type="hidden" name="MAX_FILE_SIZE" value="100000">
				<table>
					<tr valign="top">
						<td align="right">
						' . get_lang("labelDisableRow1") . '
						</td>
						<td >
							<input type="checkbox" name="row1" value="on" checked>
						</td>
					</tr>
					<tr valign="top">
						<td align="right">
						' . get_lang('labelSelectFile2Import') . '
						</td>
						<td >
							<input type="file" name="uploadfile" ><br />
						</td>
					</tr>
					<tr valign="top">
						<td>
						</td>
						<td >
							<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelUpload') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.importform.action.value=\'list\';">
						</td>
					</tr>
					<tr valign="top">
						<td colspan="2">
						' . get_lang('helpCalenderImport') . '<br>
						<div style="color: #777777">
						<u>' . get_lang('txtCsvImport') . '</u><br>
						 Datum;comment;vrijaf;publiek<br>
						 yyyy-mm-dd;xxx;on/off;on/off<br>
						 yyyy-mm-dd;xxx;on/off;on/off<br>
						<br><u>' . get_lang('txtCsvExample') . '</u><br>
						 Datum;comment;vrijaf;publiek<br>
						 2007-12-25;Kerstmist;on;on<br>
						 2008-03-14;klassenraden;off;on<br>
						 2008-03-08;Personeelsfeest;off;off<br>
						</div>
						</td>
					</tr>
				</table>
			</form>';
            }
            break;
        case "editlist" :
        case "list" :
            {
                // ===============================================================
                // kalenderlijst weergeven........
                // ===============================================================
                echo "<span  style=\"float:right;\">";
                if ($display == 'list')
                {
                    echo '&nbsp;<a href="' . $this->get_url() . '&page=editcalender&action=editlist&selectAcYear=' . $selectAcYear . '">' . get_lang('txtChangeCalender') . '</a>&nbsp;';
                    echo '|&nbsp;<a href="' . $this->get_url() . '&page=calender2excel&selectAcYear=' . $selectAcYear . '" target="_blank" title="' . get_lang('tooltipCalender2Excell') . '">' . get_lang('txtCalender2Excell') . '</a>&nbsp;';
                    echo '|&nbsp;<a href="' . $this->get_agenda_url() . '&page=calender2pdf&select=teacher&selectAcYear=' . $selectAcYear . '" target="_blank" title="' . get_lang('tooltipCalender2Pdf') . '">' . get_lang('txtCalender2Pdf') . '</a>&nbsp;';
                    echo '|&nbsp;<a href="' . $this->get_url() . '&page=editcalender&action=list&selectAcYear=' . substr($selectAcYear, 5, 4) . '-' . (substr($selectAcYear, 5, 4) + 1) . '" title="' . substr($selectAcYear, 5, 4) . '-' . (substr($selectAcYear, 5, 4) + 1) . '">&gt;&gt;&gt;</a>&nbsp;';
                }
                else
                {
                    echo '&nbsp;<a href="#" onclick="javascript:calenderlist.submit();" onmousedown="javascript:document.agendaform.submitmessage.value=\'ok\';" title="' . get_lang('tooltipSaveChanges') . '">' . get_lang('txtSaveChanges') . '</a>&nbsp;';
                }
                echo "</span>";
                echo "<div >";
                echo "&nbsp";
                if ($display == 'list')
                {
                    echo '<a href="' . $this->get_url() . '&page=editcalender&action=list&selectAcYear=' . (substr($selectAcYear, 0, 4) - 1) . '-' . substr($selectAcYear, 0, 4) . '" title="' . (substr($selectAcYear, 0, 4) - 1) . '-' . substr($selectAcYear, 0, 4) . '">&lt;&lt;&lt;</a>&nbsp;|&nbsp';
                    echo '<a href="' . $this->get_url() . '&page=editcalender&action=new">' . get_lang("txtAddCalenderItem") . '</a>&nbsp;|&nbsp;';
                    echo '<a href="' . $this->get_url() . '&page=editcalender&action=import">' . get_lang("txtImportCalender") . '</a>&nbsp;|&nbsp;';
                    echo '<a href="' . $this->get_url() . '&page=calender2csv&selectAcYear=' . $selectAcYear . '" target="_blank">' . get_lang("txtExportCalender") . '</a>&nbsp;';
                }
                echo '</div>';
                $query = "SELECT `id`, `date`, `content`, `vacation`, `public`
						FROM `campus_calender`
					WHERE `department_id`= " . $department_id . "
						AND `date` >=" . mktime(0, 0, 0, 9, 1, substr($selectAcYear, 0, 4)) . "
						AND `date` <=" . mktime(0, 0, 0, 9, 1, substr($selectAcYear, 5, 4)) . "
						ORDER BY `date`";
                $result = mysql_query($query) or die(mysql_error());
                $content = array();
                $vacation = array();
                $public = array();
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    $content[$rij['date']][$rij['id']] = $rij['content'];
                    $vacation[$rij['date']][$rij['id']] = $rij['vacation'];
                    $public[$rij['date']][$rij['id']] = $rij['public'];
                }
                $D = DatetimeUtilities::get_days_long();

                $mnd1 = 9;
                $mnd2 = 12;
                $kolom = 0;
                $data=array();
                for ($t = 1; $t <= 2; $t++)
                {
                    for ($mnd = $mnd1; $mnd <= $mnd2; $mnd++)
                    {
                        if ($kolom > 5)
                        {
                            //$kolom=0;
                            //newpage
                        }
                        if ($mnd >= 9)
                        {
                            $year = substr($selectAcYear, 0, 4); // ???
                        }
                        else
                        {
                            $year = substr($selectAcYear, 5, 4); // ???
                        }
                        $testdate = strtotime($year . '-' . $mnd . '-1');
                        // weekdag van de eerstedag van de maand bepalen.
                        $dag1 = strftime('%w', $testdate);
                        // het aantaldagen in de maand bepalen.
                        for ($dag2 = 31; $dag2 >= 28; $dag2--)
                        {
                            if (DatetimeUtilities::format_locale_date('%m', $testdate) == DatetimeUtilities::format_locale_date('%m', strtotime($year . '-' . $mnd . '-' . $dag2)))
                            {
                                break;
                            }
                        }
                        // Maandschrijven...
                        $data[0][$mnd]['colhead'] =DatetimeUtilities::format_locale_date('%B %Y', $testdate);
                        $dataOK = false;
                        $dag = 6;
                        $dagteller = 1;
                        for ($n = 1; $n <= 37; $n++)
                        {
                            if ($dag == $dag1)
                            {
                                $dataOK = true;
                            }
                             //weekdag schrijven ...
                            $data[$n][$mnd]['dag'] = strtoupper(substr($D[$dag], 0, 1));
                            if ($dataOK)
                            {
                                $date = mktime(0, 0, 0, $mnd, $dagteller, $year);
                                $data[$n][$mnd]['date'] =$date;
                                $data[$n][$mnd]['dagno'] = $dagteller;
                                $data[$n][$mnd]['content'] = $content[$date];
                                $data[$n][$mnd]['vacation'] = $vacation[$date];
                                $data[$n][$mnd]['public'] = $public[$date];
                                $dagteller++;
                                if ($dagteller > $dag2)
                                {
                                    $dag1 = 99;
                                    $dataOK = false;
                                }
                            }
                            $dag++;
                            if ($dag > 6)
                            {
                                $dag = 0;
                            }
                        }
                        $kolom++;
                    }
                    $mnd1 = 1;
                    $mnd2 = 8;
                }
                //   dump($data);
                echo "<form method='post' action='" . $this->get_url() . "' name='calenderlist' enctype='multipart/form-data'>";
                echo '<input type="hidden" name="page" value="editcalender" >';
                echo '<input type="hidden" name="action" value="update" >';
                echo '<input type="hidden" name="selectAcYear" value="' . $selectAcYear . '" >';
                echo "<table style='border-spacing: 0px;'>";
                $brdr = ($display == 'list') ? "border: solid 1px #ffffff;" : "border: solid 1px #777777;";
                echo "<tr>";
                echo "<td COLSPAN=72 style='text-align:center;" . $brdr . "background-color:#ffccff;'><div style='font-size:24px;font-weight:bold;'>" . $selectAcYear . "</div></td>";
                echo "</tr>";
                foreach ($data as $tr => $data1)
                {
                    echo "<tr>";
                    foreach ($data1 as $td => $data2)
                    {
                        if ($tr == 0)
                        {
                            echo "<td COLSPAN=5 style='" . $brdr . "background-color:#ccccff;'><div style='width:200px;font-weight:bold;'>" . $data2['colhead'] . "</div>";
                            if ($display == "editlist")
                            {
                                echo "<div align='right'>";
                                echo '<img src="' . Theme::get_image_path('application\campus') . 'vacation.gif" width="24px">';
                                echo '<img src="' . Theme::get_image_path('application\campus') . 'public.gif" width="24px">';
                                echo "</div>";
                            }
                            echo "</td>";
                            echo "<td >&nbsp;</td>";
                        }
                        else
                        {
                            $content = "";
                            $vacation = "";
                            $public = "";
                            if ($data2['dagno'] != "")
                            {
                                $date = $data2['date'];
                                $bkgd = ((strftime('%w',$date) == 0)||(strftime('%w',$date) == 6)) ? "background-color:#cceecc;" : "background-color:#eeeeee;";

                                 if (is_array($data2['content']))
                                {
                                    foreach ($data2['content'] as $key => $value)
                                    {
                                        $bkgd = ($data2['vacation'][$key] == 1) ? 'background-color:#cceecc;' : $bkgd;
                                        $content.= ( $display == 'list') ? '' : '<input type="hidden" name="calender_id[' . $date . ']" value="' . $key . '">';
                                        $content.= ( $display == 'list') ? '<div>' . $data2['content'][$key] . '&nbsp;</div>' : '<input type="text" name="content[' . $date . ']" size="20" maxlength="32" value="' . $data2['content'][$key] . '">';
                                        $vacation.= ( $display == 'list') ? (($data2['vacation'][$key] == 1) ? ('<div><img src="' . Theme::get_image_path('application\campus') . 'setting_true.gif" width="14"></div>') : '<div>&nbsp;&nbsp;</div>') : '<input type="checkbox" name="vacation[' . $date . ']" ' . (($data2['vacation'][$key] == 1) ? 'checked' : '') . ' value="1">';
                                        $public.= ( $display == 'list') ? (($data2['public'][$key] == 1) ? ('<div><img src="' . Theme::get_image_path('application\campus') . 'setting_true.gif" width="14"></div>') : '<div>&nbsp;&nbsp;</div>') : '<input type="checkbox" name="public[' . $date . ']" ' . (($data2['public'][$key] == 1) ? 'checked' : '') . ' value="1">';
                                        $date++; //
                                    }
                                }
                                else
                                {
                                    $content = ($display == 'list') ? ' ' : '<input type="hidden" name="calender_id[' . $date . ']" value="">';
                                    $content.= ( $display == 'list') ? ' ' : '<input type="text" name="content[' . $date . ']" size="20" maxlength="32" value="">';
                                    $vacation = ($display == 'list') ? ' ' : '<input type="checkbox" name="vacation[' . $date . ']"  value="1">';
                                    $public = ($display == 'list') ? '' : '<input type="checkbox" name="public[' . $date . ']"  value="1">';
                                }
                            }
                            else
                            {
                                $bkgd = "background-color:#cccccc;";
                                //$data2['dag']="";
                            }
                            echo "<td valign='top' style='width:5px;" . $brdr . $bkgd . "'>" . $data2['dag'] . "</td>";
                            echo "<td valign='top' style='width:5px;" . $brdr . $bkgd . "'>" . $data2['dagno'] . "</td>";
                            echo "<td valign='top' style='width:200px;" . $brdr . $bkgd . "'>" . $content . "</td>";
                            echo "<td valign='top' style='width:5px;" . $brdr . $bkgd . "'>" . $vacation . "</td>";
                            echo "<td valign='top' style='width:5px;" . $brdr . $bkgd . "'>" . $public . "</td>";
                            echo "<td >&nbsp;</td>";
                        }
                    }
                    echo '</tr>';
                }
                echo '</table>';
                if ($display == 'editlist')
                {
                    echo '<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" >&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.calenderlist.action.value=\'list\';">';
                }
                echo '</form>';
            }
    }
}
?>