<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Theme;
use common\libraries\PlatformSetting;
use common\libraries\Path;
use common\libraries\Display;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['studentTrackingLevel3']) && !$is_platformadmin))
{// not allowed here!
    Display::display_error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    // het actieve uurrooster van de department bepalen...
    $action = campus::get_POST_GET("action");
    $submitmessage = campus::get_POST_GET("submitmessage");
    $teacher_id = intval(campus::get_POST_GET("teacher_id"));
    $student_id = intval(campus::get_POST_GET("student_id"));

    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */

    if ($submitmessage == "")
    { //
        // de scholen ophalen waar de gebruiker deel van uitmaakt.
        switch ($action)
        {
            case "new" :
                {
                    $teacher_id = "";
                    $student_id = "";
                    $display = "form";
                }
                break;
            case "delete" :
                {
                    $result = mysql_query("DELETE FROM `campus_coach_rel_student` WHERE `teacher_id`=" . $teacher_id . " AND `student_id`=" . $student_id);
                    $message = get_lang("msgItemDeleted");
                    $display = "list";
                }
                break;
            default :
                {
                    $display = "list";
                }
                break;
        }
    }
    else
    {
        switch ($action)
        {
            case "new" :
                {
                    $query = "INSERT `campus_coach_rel_student` SET
						`teacher_id`=" . $teacher_id . ",
						`student_id`=" . $student_id . "
					";
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemAddError");
                        $display = "form";
                    }
                    else
                    {
                        $message = get_lang("msgItemAddSucces");
                        $display = "list";
                    }
                }
                break;
            default :
                {
                    $display = "list";
                }
                break;
        }
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }

    switch ($display)
    {
        case "form" :
            {
                // ===============================================================
                // Form to add/edit line in roster
                // ===============================================================
                $teachers_array = campus::get_teachers($department_id);
                echo '<form method="post" action="' . $this->get_url() . '" name="myform">
				<input type="hidden" name="page" value="editcoach" >
				<input type="hidden" name="action" value="' . $action . '" >
				<table>
				 <tr valign="top">
				  <td colspan="2">
				  </td>
				 </tr>
				 <tr valign="top">
				  <td align="right">
				  ' . get_lang('labelSelectTeachers') . '
				  </td>
				  <td>
				   <select name="teacher_id">';
                foreach ($teachers_array as $id => $value)
                {
                    echo '<option value="' . $id . '">' . $value['official_code'] . ': ' . $value['name'] . '</option>';
                }
                echo ' 	    </select>
				   </td>
				  </tr>
				  <tr valign="top">
				   <td align="right">
				    ' . get_lang('labelSelectStudent') . '
				   </td>
				   <td>
				    <select name="student_id">';
                //select students from class selection
                $sql = "SELECT DISTINCT `user_user`.`id`, `group_group`.`code`, `firstname`, `lastname`
			            FROM `group_group_rel_user`
			            	INNER JOIN `group_group`
			                   ON `group_group`.`id` = `group_group_rel_user`.`group_id`
			                LEFT JOIN `user_user`
			                   ON `user_user`.`id` = `group_group_rel_user`.`user_id` WHERE ";
                $classes = campus::get_studentclasses($department_id);
                foreach ($classes as $key => $value)
                {
                    $sql.=" `group_group_rel_user`.`group_id`=" . $key . " OR";
                }
                $sql = substr($sql, 0, -3) . " ORDER BY `lastname`, `firstname`";
                $result = mysql_query($sql);
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    echo '<option value="' . $rij['id'] . '">' . $rij['lastname'] . ' ' . $rij['firstname'] . ' (' . $rij['code'] . ')</option>';
                }
                echo '		</select>
				       </td>
				      </tr>
				      <tr valign="top">
					<td>
					</td>
					<td colspan="2">
					 <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
					</td>
				       </tr>
				      </table>
				     </form>';
            }
            break;
        case "list" :
            {
                $query = "SELECT DISTINCT `teacher_id`, `student_id`
					FROM `campus_coach_rel_student`
                                            INNER JOIN `group_group_rel_user` ON `campus_coach_rel_student`.`student_id`=`group_group_rel_user`.`user_id`
				  	    INNER JOIN `campus_department_rel_group` ON `campus_department_rel_group`.`group_id`=`group_group_rel_user`.`group_id` AND `type` = 2
                   			WHERE `department_id`=" . $department_id;
                $result = mysql_query($query);
                echo "<div >";
                echo '<a href="' . $this->get_url() . '&page=editcoach&action=new">' . get_lang('txtAddCoach') . '</a>&nbsp;';
                echo "</div>";
                campus::display_complex_table_header($properties, array(get_lang("colheadTeacher"), get_lang("colheadStudent"), ""));
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    $data = array();
                    $userinfo = campus::get_user_info($rij['teacher_id']);
                    $data['teacher'] = $userinfo['firstname'] . " " . $userinfo['lastname'] . "(" . $userinfo['official_code'] . ")";
                    $userinfo = campus::get_user_info($rij['student_id']);
                    $classes = campus::get_classes($rij['student_id']);
                    $class = "";
                    foreach ($classes as $key => $value)
                    {
                        $class.=$value['code'] . " ";
                    }
                    $data['student'] = $userinfo['firstname'] . " " . $userinfo['lastname'] . "( " . $class . ")";
                    $data['link'] = '&nbsp;<a href="' . $this->get_url() . '&page=editcoach&action=delete&teacher_id=' . $rij['teacher_id'] . '&student_id=' . $rij['student_id'] . '" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmDeleteCoach") . '\')) return false;" title="' . get_lang("tooltipDeleteCoach") . '"><img src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="absmiddle" /></a>';
                    campus::display_table_row($bgcolor, $data, true);
                }
                campus::display_table_footer();
            }
            break;
    }
}
?>
