<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\Theme;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['roster']) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
// het actieve uurrooster van de department bepalen...
    $activeroster = campus::get_activeroster($department_id);
    $action = campus::get_POST_GET("action");
    $submitmessage = campus::get_POST_GET("submitmessage");
    $curriculum_id = intval(campus::get_POST_GET("curriculum_id"));
    $roster_id = intval(campus::get_POST_GET("roster_id"));
    $assignment_id = intval(campus::get_POST_GET("assignment_id"));
    $schedule_id = intval(campus::get_POST_GET("schedule_id"));
    $college_id = intval(campus::get_POST_GET("college_id"));
    $filter = campus::get_POST_GET("filter");
    $week = DatetimeUtilities::get_days_long();

    /*
      ==============================================================================
      Update query's execute actions...
      ==============================================================================
     */

    if ($submitmessage == "")
    { //
    // de scholen ophalen waar de gebruiker deel van uitmaakt.
        switch ($action)
        {
            case "newcurriculum" :
                {
                    $start_time = time();
                    $curriculum_id = 0;
                    $roster_id = 0;
                    $college_id = 0;
                    $schedule_id = 0;
                    $name = "";
                    $display = "formcurriculum";
                }
                break;
            case "updatecurriculum" :
                {
                    $result = mysql_query('SELECT `name`,`start_time` FROM `campus_curriculum` WHERE `id` = ' . $curriculum_id);
                    list($name, $start_time) = mysql_fetch_row($result);
                    $display = "formcurriculum";
                }
                break;
            case "newroster" :
                {
                    $start_time = time();
                    $schedule_id = 0;
                    $roster_id = 0;
                    $name = "";
                    $display = "formroster";
                }
                break;
            case "newschedule" :
                {
                    $start_time = time();
                    $schedule_id = 0;
                    $result = mysql_query('SELECT `campus_roster`.`id` as `roster_id`, `name` FROM `campus_roster` WHERE `campus_roster`.`id` = ' . $roster_id);
                    list($roster_id, $name) = mysql_fetch_row($result);
                    $display = "formroster";
                }
                break;
            case "updateroster" :
                {
                    $result = mysql_query('SELECT `campus_roster`.`id` as `roster_id`, `campus_roster_schedule`.`id` as `schedule_id`, `name`,`start_time` FROM `campus_roster` INNER JOIN `campus_roster_schedule` ON `campus_roster`.`id`=`campus_roster_schedule`.`roster_id` WHERE `campus_roster_schedule`.`id` = ' . $schedule_id);
                    list($roster_id, $schedule_id, $name, $start_time) = mysql_fetch_row($result);
                    $display = "formroster";
                }
                break;
            case "newassignment" :
                {
                    $assignment_id = 0;
                    $discipline_id = 0;
                    $display = "formassignment";
                }
                break;
            case "updateassignment" :
                {
                    if ($assignment_id != 0)
                    {

                        $query = "select `discipline_id` FROM `campus_assignment` WHERE `id`=" . $assignment_id . "";
                        $result = mysql_query($query);
                        list($discipline_id) = mysql_fetch_row($result);
                        $roster_id = campus::get_schedule2roster($schedule_id);
                        $currriculum_id = campus::get_roster2curriculum($roster_id);
                        $display = "formassignment";
                    }
                    else
                    {
                        $display = "list";
                    }
                }
                break;
            case "newcollege" :
                {
                    $college_id = 0;
                    $period_id = 0;
                    $duration = 1;
                    $display = "formcollege";
                }
                break;
            case "updatecollege" :
                {
                    $query = 'select `id`, `period_id`, `duration`, `assignment_id` FROM `campus_college` WHERE `id`=' . $college_id;
                    $result = mysql_query($query);
                    list($college_id, $period_id, $duration, $assignment_id) = mysql_fetch_row($result);
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $currriculum_id = campus::get_roster2curriculum($roster_id);
                    $display = "formcollege";
                }
                break;
            case "delete" :
                {
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    if ($assignment_id != 0)
                    {//remove assignment
                        $result = mysql_query('SELECT * FROM `campus_agenda` WHERE `assignment_id`=' . $assignment_id);
                        if (mysql_num_rows($result) == 0)
                        {
                            $result = mysql_query('SELECT * FROM `campus_objective_view_rel_assignment` WHERE `assignment_id`=' . $assignment_id);
                            if (mysql_num_rows($result) == 0)
                            {
                                $result = mysql_query('SELECT * FROM `campus_reportcard` WHERE `assignment_id`=' . $assignment_id);
                                if (mysql_num_rows($result) == 0)
                                {

                                    $result = mysql_query("DELETE `campus_college_rel_resource` FROM `campus_college`
                                                              LEFT JOIN `campus_college_rel_resource` ON `campus_college`.`id`= `campus_college_rel_resource`.`college_id` WHERE `assignment_id`=" . $assignment_id);
                                    $result = mysql_query("DELETE  FROM `campus_college` WHERE `assignment_id`=" . $assignment_id);
                                    // de gelinkte leerkrachten verwijderen...
                                    $result = mysql_query("DELETE FROM `campus_assignment_rel_teacher` WHERE `assignment_id`=" . $assignment_id);
                                    // de gelinkte klassen verwijderen...
                                    $result = mysql_query("DELETE FROM `campus_assignment_rel_group` WHERE `assignment_id`=" . $assignment_id);
                                    // de gelinkte lokalen verwijderen...
                                    $result = mysql_query("DELETE FROM `campus_assignment` WHERE `id`=" . $assignment_id . " ");
                                    $message = get_lang("msgAssignmentDeleted");
                                }
                                else
                                {
                                    $errormessage = get_lang("msgAssignmentNotDeleted") . '<br>' . get_lang("msgReportExists4Assignment");
                                }
                            }
                            else
                            {
                                $errormessage = get_lang("msgAssignmentNotDeleted") . '<br>' . get_lang("msgObjectiveViewExists4Assignment");
                            }
                        }
                        else
                        {
                            $errormessage = get_lang("msgAssignmentNotDeleted") . '<br>' . get_lang("msgAgendaExists4Assignment");
                        }
                    }
                    elseif ($college_id != 0)
                    {
                        // college details verwijderen...
                        $result = mysql_query("DELETE `campus_college_rel_resource` FROM `campus_college`
                                                              LEFT JOIN `campus_college_rel_resource` ON `campus_college`.`id`= `campus_college_rel_resource`.`college_id` WHERE `id`=" . $college_id);
                        $result = mysql_query("DELETE  FROM `campus_college` WHERE `id`=" . $college_id);
                        $message = get_lang("msgRosterLineDeleted");
                    }
                    else
                    {
                        $errormessage = get_lang("msgNothingDeleted");
                    }
                    $display = "list";
                }
                break;
            case "cpteacher" :
                {
                    $display = "cpteacher";
                }
                break;
            case "cproster" :
                {
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $display = "formcproster";
                }
                break;
            case "rmteacher" :
                {
                    $display = "rmteacher";
                }
                break;
            case "deletecurriculum" :
                {
                    if ($curriculum_id != 0)
                    {
                        $result = mysql_query('SELECT `id`  FROM `campus_roster` WHERE `curriculum_id`=' . $curriculum_id);
                        if (mysql_num_rows($result) == 1)
                        {
                            list($roster_id) = mysql_fetch_row($result);

                            // check if roster delete is allowed, is agenda already filled in?
                            $result = mysql_query('SELECT * FROM `campus_assignment`
                                                        INNER JOIN `campus_agenda` ON `campus_assignment`.`id`= `campus_agenda`.`assignment_id` AND `curriculum_id`=' . $curriculum_id);
                            if (mysql_num_rows($result) == 0)
                            {
                                // check if report exists
                                $result = mysql_query('SELECT * FROM `campus_assignment`
                                                        INNER JOIN `campus_reportcard` ON `campus_assignment`.`id`= `campus_reportcard`.`assignment_id` AND `curriculum_id`=' . $curriculum_id);
                                if (mysql_num_rows($result) == 0)
                                {

                                    $error = FALSE;
                                    $result = mysql_query("DELETE `campus_college_rel_resource`,`campus_college` FROM `campus_college`
                                                              LEFT JOIN `campus_college_rel_resource` ON `campus_college`.`id`= `campus_college_rel_resource`.`college_id` WHERE `roster_id`=" . $roster_id);

                                    if ($result)
                                    {
                                        $message .= '<br>' . get_lang("msgCollegesDeleted");
                                    }
                                    else
                                    {
                                        $errormessage .= '<br>' . get_lang("msgCollegesDeleted");
                                        $error = TRUE;
                                    }

                                    // delete teachers
                                    $result = mysql_query("DELETE FROM `campus_assignment_rel_teacher` WHERE `roster_id`=" . $roster_id);
                                    if ($result)
                                    {
                                        $message .= '<br>' . get_lang("msgTeachersDeleted");
                                    }
                                    // delete schedule
                                    $result = mysql_query("DELETE FROM `campus_roster_schedule` WHERE `roster_id`=" . $roster_id);
                                    if ($result)
                                    {
                                        $message .= '<br>' . get_lang("msgRosterSchedulesDeleted");
                                    }

                                    // delete assignments
                                    $result = mysql_query('DELETE `campus_assignment`,`campus_assignment_rel_group` FROM `campus_assignment`
                                                              LEFT JOIN `campus_assignment_rel_group` ON `campus_assignment`.`id`= `campus_assignment_rel_group`.`assignment_id` WHERE `curriculum_id`=' . $curriculum_id);
                                    if ($result)
                                    {
                                        $message .= '<br>' . get_lang("msgAssignmentsDeleted");
                                    }

                                    $result = mysql_query("DELETE FROM `campus_roster` WHERE `id`=" . $roster_id);
                                    if ($result)
                                    {
                                        $message .= '<br>' . get_lang("msgRosterSchedulesDeleted");
                                    }


                                    $result = mysql_query("DELETE FROM `campus_curriculum` WHERE `id`=" . $curriculum_id);
                                    if ($result)
                                    {
                                        $message = get_lang("msgDeleteSucces");
                                        // reread active roster because selected schedule is deleted...
                                        $activeroster = campus::get_activeroster($department_id);
                                    }
                                    else
                                    {
                                        $errormessage = get_lang("msgDeleteFailed");
                                    }
                                }
                                else
                                {
                                    $errormessage = get_lang("msgOptimalizationNotPossible") . '<br>' . get_lang("msgReportExist");
                                }
                            }
                            else
                            {
                                $errormessage = get_lang("msgOptimalizationNotPossible") . '<br>' . get_lang("msgFilledinAgendasExist");
                            }
                        }
                        else
                        {
                            $errormessage = get_lang("msgOptimalizationNotPossible") . '<br>' . get_lang("msgMoreThen1RosterExist");
                        }
                    }
                    else
                    {
                        $errormessage = get_lang("msgDeleteNotPossible");
                    }

                    $display = "list";
                }
                break;
            case "deleteschedule" :
                {
                    if ($schedule_id != 0)
                    {
                        $roster_id = campus::get_schedule2roster($schedule_id);
                        $curriculum_id = campus::get_roster2curriculum($roster_id);

                        if (($curriculum_id != 0) && ($roster_id != 0))
                        {
                            $result = mysql_query('SELECT * FROM `campus_roster_schedule` WHERE `roster_id`=' . $roster_id);
                            if (mysql_num_rows($result) > 1)
                            {// more then 1 schedule, only delete current schedule...
                                $result = mysql_query("DELETE FROM `campus_roster_schedule` WHERE `id`=" . $schedule_id);
                                if ($result)
                                {
                                    $message = get_lang("msgRosterScheduleDeleted");
                                }
                                else
                                {
                                    $errormessage = get_lang("msgDeleteFailed");
                                }
                            }
                            elseif (mysql_num_rows($result) == 1)
                            { //only 1 schedule also delete currentroster
                                // delete schedule
                                $message = get_lang("msgRosterScheduleDeleted");
                                // delete college's
                                $error = FALSE;
                                $result = mysql_query("DELETE `campus_college_rel_resource`,`campus_college` FROM `campus_college`
                                                              LEFT JOIN `campus_college_rel_resource` ON `campus_college`.`id`= `campus_college_rel_resource`.`college_id` WHERE `roster_id`=" . $roster_id);

                                if ($result)
                                {
                                    $message .= '<br>' . get_lang("msgCollegesDeleted");
                                }
                                else
                                {
                                    $errormessage .= '<br>' . get_lang("msgCollegesDeleted");
                                    $error = TRUE;
                                }

                                // delete teachers
                                $result = mysql_query("DELETE FROM `campus_assignment_rel_teacher` WHERE `roster_id`=" . $roster_id);
                                if ($result)
                                {
                                    $message .= '<br>' . get_lang("msgTeachersDeleted");
                                }

                                $activeroster = campus::get_activeroster($department_id);
                                $schedule_id = $activeroster['schedule_id'];
                                $roster_id = $activeroster['roster_id'];
                                $curriculum_id = $activeroster['curriculum_id'];
                            }
                            else
                            {
                                $errormessage = get_lang("msgDeleteNotPossible") . "1";
                            }
                        }
                        else
                        {
                            $errormessage = get_lang("msgDeleteNotPossible") . "2";
                        }
                    }
                    else
                    {
                        $errormessage = get_lang("msgDeleteNotPossible") . "3";
                    }
                    $display = "list";
                }
                break;
            case "duplicate" :
                {
                    if (($schedule_id != 0) && ($assignment_id != 0))
                    {
                        // combine college houres in blocks.. when groups, discipline and teachers are the same!!!!
                        $roster_id = campus::get_schedule2roster($schedule_id);
                        $curriculum_id = campus::get_roster2curriculum($roster_id);
                        $update_college = array();
                        $delete_college = array();
                        $update_display_order = 0;
                        $update_college_id = 0;
                        $t = 0;

                        // copy assignment.
                        $result = mysql_query('SELECT `discipline_id`, `curriculum_id`  FROM `campus_assignment` WHERE `id`=' . $assignment_id);
                        list( $discipline_id, $curriculum_id) = mysql_fetch_row($result);
                        $result = mysql_query('INSERT `campus_assignment` SET `discipline_id`=' . $discipline_id . ', `curriculum_id`=' . $curriculum_id . '');
                        if ($result)
                        {
                            $new_assignment_id = mysql_insert_id();

                            // copy groups rel
                            $result2 = mysql_query('SELECT `group_id` FROM `campus_assignment_rel_group` WHERE `assignment_id`=' . $assignment_id);
                            while (list($group_id) = mysql_fetch_row($result2))
                            {
                                $result3 = mysql_query('INSERT `campus_assignment_rel_group` SET `group_id`=' . $group_id . ', `assignment_id`=' . $new_assignment_id . '');
                            }

                            //copy teacher rel
                            $result2 = mysql_query('SELECT `user_id` FROM `campus_assignment_rel_teacher` WHERE `assignment_id`=' . $assignment_id . ' AND `roster_id`=' . $roster_id);
                            while (list($user_id) = mysql_fetch_row($result2))
                            {
                                $result3 = mysql_query('INSERT `campus_assignment_rel_teacher` SET `user_id`=' . $user_id . ', `assignment_id`=' . $new_assignment_id . ', `roster_id`=' . $roster_id);
                            }

                            //copy college's
                            $result2 = mysql_query('SELECT `id`, `period_id`, `duration` FROM `campus_college` WHERE `assignment_id`=' . $assignment_id . ' AND `roster_id`=' . $roster_id);
                            while (list($college_id, $period_id, $duration) = mysql_fetch_row($result2))
                            {
                                $result3 = mysql_query('INSERT `campus_college` SET `assignment_id`=' . $new_assignment_id . ', `period_id`=' . $period_id . ', `duration`=' . $duration . ', `roster_id`=' . $roster_id);
                                if ($result3)
                                {
                                    $new_college_id = mysql_insert_id();
                                    // copy resources
                                    $result3 = mysql_query('SELECT `resource_id` FROM `campus_college_rel_resource` WHERE `college_id`=' . $college_id);
                                    while (list($resource_id) = mysql_fetch_row($result3))
                                    {
                                        $result4 = mysql_query('INSERT `campus_college_rel_resource` SET `college_id`=' . $new_college_id . ', `resource_id`=' . $resource_id);
                                    }
                                }
                            }
                            $message = get_lang("msgAssignmentCopied");
                        }
                        else
                        {
                            $errormessage = get_lang("msgScheeError");
                        }
                    }
                    else
                    {
                        $errormessage = get_lang("msgScheduleError");
                    }

                    $display = "list";
                }
                break;
            case "removeduplicate" :
                {
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $curriculum_id= campus::get_roster2curriculum($roster_id);
                    $warningmessage = get_lang("msgConfirmRemoveCollegeDuplicates");
                    $warningmessage.= '<br><a href="' . $this->get_url() . '&page=optimizecurriculum&action=optimize2&schedule_id=' . $schedule_id . '">' . get_lang("txtYes") . '</a> /
							<a href="' . $this->get_url() . '&page=editcurriculum&schedule_id=' . $schedule_id . '">' . get_lang("txtNo") . '</a>';
                    $display = "list";
                }
                break;
            case "combineassignment" :
                {
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $curriculum_id= campus::get_roster2curriculum($roster_id);
                     $warningmessage = get_lang("msgConfirmCombineAssignmentGroup");
                    $warningmessage.= '<br><a href="' . $this->get_url() . '&page=optimizecurriculum&action=optimize3&schedule_id=' . $schedule_id . '">' . get_lang("txtYes") . '</a> /
							<a href="' . $this->get_url() . '&page=editcurriculum&schedule_id=' . $schedule_id . '">' . get_lang("txtNo") . '</a>';
                    $display = "list";
                }
                break;
            case "combinecollege" :
                {
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $curriculum_id= campus::get_roster2curriculum($roster_id);
                    $warningmessage = get_lang("msgConfirmCombineAssignmentCollege");
                    $warningmessage.= '<br><a href="' . $this->get_url() . '&page=optimizecurriculum&action=optimize1&schedule_id=' . $schedule_id . '">' . get_lang("txtYes") . '</a> /
							<a href="' . $this->get_url() . '&page=editcurriculum&schedule_id=' . $schedule_id . '">' . get_lang("txtNo") . '</a>';
                    $display = "list";
                }
                break;
            case "optimizecollege" :
                {
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $curriculum_id= campus::get_roster2curriculum($roster_id);
                    $warningmessage = get_lang("msgConfirmOptimizeColleges");
                    $warningmessage.= '<br><a href="' . $this->get_url() . '&page=optimizecurriculum&action=optimize4&schedule_id=' . $schedule_id . '">' . get_lang("txtYes") . '</a> /
							<a href="' . $this->get_url() . '&page=editcurriculum&schedule_id=' . $schedule_id . '">' . get_lang("txtNo") . '</a>';
                    $display = "list";
                }
                break;
            case "cleanupassignment" :
                {
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $curriculum_id= campus::get_roster2curriculum($roster_id);
                    $warningmessage = get_lang("msgConfirmCleanUpAssignments");
                    $warningmessage.= '<br><a href="' . $this->get_url() . '&page=optimizecurriculum&action=cleanup&schedule_id=' . $schedule_id . '">' . get_lang("txtYes") . '</a> /
							<a href="' . $this->get_url() . '&page=editcurriculum&schedule_id=' . $schedule_id . '">' . get_lang("txtNo") . '</a>';
                    $display = "list";
                }
                break;
            default :
                {
                    if (($curriculum_id = intval(campus::get_POST_GET("curriculum_id"))) == 0)
                    {
                        if (($roster_id = intval(campus::get_POST_GET("roster_id"))) == 0)
                        {
                            $schedule_id = intval(campus::get_POST_GET("schedule_id", $activeroster['schedule_id']));
                            $roster_id = intval(campus::get_POST_GET("roster_id", (($schedule_id > 0) ? campus::get_schedule2roster($schedule_id) : $activeroster['roster_id'])));
                        }
                        $curriculum_id = intval(campus::get_POST_GET("curriculum_id", (($roster_id > 0) ? campus::get_roster2curriculum($roster_id) : $activeroster['curriculum_id'])));
                          
                        }
                    else
                    {
                       
                        //$curriculum_id = $activeroster['curriculum_id'];
                        $schedule_id = campus::get_curriculum2schedule($curriculum_id);
                        $roster_id = campus::get_schedule2roster($schedule_id);
                    }

                    $display = "list";
                }
                break;
        }
    }
    else
    {
        switch ($action)
        {
            case "newcurriculum" :
                {
                    $query = 'INSERT `campus_curriculum` SET `start_time`=' . strtotime(campus::get_POST_GET("start_time")) . ', `name`="' . campus::get_POST_GET("name") . '",`department_id`=' . $department_id;
                    $result = mysql_query($query);
                    $display = "list";
                    $curriculum_id = mysql_insert_id();
                    $schedule_id = campus::get_curriculum2schedule($curriculum_id);
                    $roster_id = campus::get_schedule2roster($schedule_id);
                }
                break;
            case "updatecurriculum" :
                {
                    $query = 'UPDATE `campus_curriculum` SET `start_time`=' . strtotime(campus::get_POST_GET("start_time")) . ',`name`="' . campus::get_POST_GET("name") . '"  WHERE `id`=' . $curriculum_id;
                    $result = mysql_query($query);
                    $schedule_id = campus::get_curriculum2schedule($curriculum_id);
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $display = "list";
                }
                break;
            case "newroster" :
                {
                    $query = 'INSERT `campus_roster` SET  `name`="' . campus::get_POST_GET("name") . '", `curriculum_id`=' . $curriculum_id;
                    $result = mysql_query($query);
                    $roster_id = mysql_insert_id();
                    $query = 'INSERT `campus_roster_schedule` SET  `start_time`=' . strtotime(campus::get_POST_GET("start_time")) . ', `roster_id`=' . $roster_id;
                    $result = mysql_query($query);
                    $schedule_id = mysql_insert_id();
                    $display = "list";
                }
                break;
            case "updateroster" :
                {
                    $query = 'UPDATE `campus_roster`,`campus_roster_schedule` SET start_time=' . strtotime(campus::get_POST_GET("start_time")) . ', name="' . campus::get_POST_GET("name") . '" WHERE `campus_roster`.`id`=`campus_roster_schedule`.`roster_id` AND `campus_roster_schedule`.`id`=' . $schedule_id;
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $currriculum_id = campus::get_roster2curriculum($roster_id);
                    $result = mysql_query($query);
                    $display = "list";
                }
                break;
            case "newschedule" :
                {
                    $query = 'INSERT `campus_roster_schedule` SET  `start_time`=' . strtotime(campus::get_POST_GET("start_time")) . ', `roster_id`=' . $roster_id;
                    $result = mysql_query($query);
                    $schedule_id = mysql_insert_id();
                    $currriculum_id = campus::get_roster2curriculum($roster_id);
                    $display = "list";
                }
                break;
            case "newassignment" :
                {
                    $discipline_id = intval(campus::get_POST_GET("discipline_id"));
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $curriculum_id = campus::get_roster2curriculum($roster_id);
                    $query = 'INSERT `campus_assignment` SET `curriculum_id`=' . $curriculum_id . ', `discipline_id` = ' . $discipline_id;
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $errormessage = get_lang("msgItemAddError");
                        $display = "form";
                    }
                    else
                    {
                        $assignment_id = mysql_insert_id();
                        $message = get_lang("msgItemAddSucces");
                        foreach (campus::get_POST_GET("groups") as $key)
                        {
                            $result = mysql_query('INSERT `campus_assignment_rel_group` SET `assignment_id`=' . $assignment_id . ', `group_id`=' . $key);
                            if (!$result)
                            {
                                $errormessage = get_lang("msgItemAddErrors");
                                $message = '';
                            }
                        }
                        foreach (campus::get_POST_GET("teachers") as $key)
                        {
                            $result = mysql_query('INSERT `campus_assignment_rel_teacher` SET `assignment_id`=' . $assignment_id . ', `user_id`=' . $key . ', `roster_id`=' . $roster_id);
                            if (!$result)
                            {
                                $errormessage = get_lang("msgItemAddErrors");
                                $message = '';
                            }
                        }
                        $display = "list";
                    }
                }
                break;
            case "updateassignment" :
                {
                    $discipline_id = intval(campus::get_POST_GET("discipline_id"));
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $curriculum_id = campus::get_roster2curriculum($roster_id);
                    $query = 'UPDATE `campus_assignment` SET  `discipline_id` = ' . $discipline_id . ' WHERE `id`=' . $assignment_id;
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $errormessage = get_lang("msgUpdateError");
                        $display = "form";
                    }
                    else
                    {

                        $result = mysql_query('DELETE FROM `campus_assignment_rel_group` WHERE `assignment_id`=' . $assignment_id);
                        foreach (campus::get_POST_GET("groups") as $key)
                        {
                            $result = mysql_query('INSERT `campus_assignment_rel_group` SET `assignment_id`=' . $assignment_id . ', `group_id`=' . intval($key));
                        }
                        $result = mysql_query('DELETE FROM `campus_assignment_rel_teacher` WHERE `assignment_id`=' . $assignment_id . ' AND `roster_id`=' . $roster_id);
                        foreach (campus::get_POST_GET("teachers") as $key)
                        {
                            $result = mysql_query('INSERT `campus_assignment_rel_teacher` SET `assignment_id`=' . $assignment_id . ', `user_id`=' . $key . ', `roster_id`=' . $roster_id);
                        }
                        $message = get_lang("msgAssignmentChanged");
                        $display = "list";
                    }
                }
                break;
            case "newcollege" :
                {
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $query = 'INSERT `campus_college` SET
						`period_id`=' . intval(campus::get_POST_GET("period_id")) . ',
						`duration`=' . intval(campus::get_POST_GET("duration")) . ',
						`assignment_id`=' . $assignment_id . ',
                                                `roster_id`=' . $roster_id . ' ';
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $errormessage = get_lang("msgItemAddError");
                        $display = "formassignment";
                    }
                    else
                    {
                        $college_id = mysql_insert_id();
                        $message = get_lang("msgItemAddSucces");
                        foreach (campus::get_POST_GET("resources") as $key)
                        {
                            $result = mysql_query("INSERT `campus_college_rel_resource` SET `college_id`=" . $college_id . ", `resource_id`=" . $key);
                            if (!$result)
                            {
                                $errormessage = get_lang("msgItemAddErrors");
                                $message = '';
                            }
                        }
                        $display = "list";
                    }
                    $currriculum_id = campus::get_roster2curriculum($roster_id);
                }
                break;
            case "updatecollege" :
                {
                    $query = 'UPDATE `campus_college` SET
					`period_id`=' . intval(campus::get_POST_GET("period_id")) . ',
					`duration`=' . intval(campus::get_POST_GET("duration")) . '
					WHERE `id`=' . $college_id . '';
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $errormessage = get_lang("msgCollegeNotChanged");
                        $display = "formrosterline";
                    }
                    else
                    {
                        $result = mysql_query("DELETE FROM `campus_college_rel_resource` WHERE `college_id`=" . $college_id);
                        foreach (campus::get_POST_GET("resources") as $key)
                        {
                            $result = mysql_query("INSERT `campus_college_rel_resource` SET `college_id`=" . $college_id . ", `resource_id`=" . $key);
                        }
                        $message = get_lang("msgCollegeChanged");
                        $display = "list";
                    }
                    $roster_id = campus::get_college2roster($college_id);
                    $curriculum_id = campus::get_roster2curriculum($roster_id);
                }
                break;
            case "cpteacher" :
                {
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $query = "SELECT `campus_assignment_rel_teacher`.`assignment_id` FROM `campus_assignment_rel_teacher`
							WHERE `roster_id` = " . $roster_id . " AND `user_id`=" . intval(campus::get_POST_GET("teacher_src"));
                    $result = mysql_query($query);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $result2 = mysql_query("INSERT `campus_assignment_rel_teacher` SET `roster_id` = " . $roster_id . ", `assignment_id`=" . $rij['assignment_id'] . ", `user_id`=" . campus::get_POST_GET("teacher_dest"));
                    }
                    $message = get_lang("msgTeacherRosterCopied");
                    $display = "list";
                    $currriculum_id = campus::get_roster2curriculum($roster_id);
                }
                break;
            case "cproster" :
                {
                    $destination_roster_id = intval(campus::get_POST_GET("destination_roster_id"));
                    if (($destination_roster_id > 0) && ($roster_id > 0))
                    {
                        // copy assignment rel teacher...
                        $query = 'SELECT * FROM `campus_assignment_rel_teacher` WHERE `roster_id` = ' . $roster_id;
                        $result = mysql_query($query);
                        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                        {
                            $result2 = mysql_query("INSERT `campus_assignment_rel_teacher` SET `roster_id` = " . $destination_roster_id . ", `assignment_id`=" . $rij['assignment_id'] . ", `user_id`=" . $rij['user_id']);
                        }
                        // copy colleges
                        $query = 'SELECT * FROM `campus_college` WHERE `roster_id` = ' . $roster_id;
                        $result = mysql_query($query);
                        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                        {
                            $result2 = mysql_query('INSERT `campus_college` SET `roster_id` = ' . $destination_roster_id . ', `assignment_id`=' . $rij['assignment_id'] . ', `period_id`=' . $rij['period_id'] . ', `duration`=' . $rij['duration']);
                            $college_id = mysql_insert_id();
                            // copy resources...
                            $result3 = mysql_query('SELECT * FROM `campus_college_rel_resource` WHERE `college_id` = ' . $rij['id']);
                            while ($rij3 = mysql_fetch_array($result3, MYSQL_ASSOC))
                            {
                                $result4 = mysql_query('INSERT `campus_college_rel_resource` SET `college_id` = ' . $college_id . ', `resource_id`=' . $rij3['resource_id']);
                            }

                            $message = get_lang("msgTeacherRosterCopied");
                            $display = "list";
                        }
                    }
                    $currriculum_id = campus::get_roster2curriculum($roster_id);
                }
                break;
            case "rmteacher" :
                {
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $query = "DELETE `campus_assignment_rel_teacher` FROM `campus_assignment_rel_teacher`
							INNER JOIN `campus_assignment`
								ON  `campus_assignment_rel_teacher`.`assignment_id`=`campus_assignment`.`id`
							WHERE `roster_id` = " . $roster_id . " AND `user_id`=" . intval(campus::get_POST_GET("teacher_dest"));
                    $result = mysql_query($query);
                    $message = get_lang("msgTeacherRemoved");
                    $display = "list";
                    $currriculum_id = campus::get_roster2curriculum($roster_id);
                }
                break;
            default :
                {
                    $display = "list";
                }
                break;
        }
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }

    if (!empty($warningmessage))
    {
        Display::warning_message($warningmessage, false);
    }

    if (!empty($errormessage))
    {
        Display::error_message($errormessage, false);
    }

    switch ($display)
    {
        case "formassignment" :
            {
// ===============================================================
// Form to add/edit assignment
// ===============================================================
                $teacher_array = campus::get_assignment2teacher($assignment_id, $roster_id);
                $group_array = campus::get_assignment2group($assignment_id);
                echo "<b>" . get_lang("page_addassignment") . "</b><br>";
                echo '<form method="post" action="' . $this->get_url() . '" name="myform">
				<input type="hidden" name="page" value="editcurriculum" >
                        	<input type="hidden" name="action" value="' . $action . '" >
				<input type="hidden" name="assignment_id" value="' . $assignment_id . '" >
				<input type="hidden" name="schedule_id" value="' . $schedule_id . '" >
				<input type="hidden" name="filter" value="' . $filter . '" >
				<table>
				 <tr valign="top">
				  <td colspan="2">
				  </td>
				 </tr>
			  <tr valign="top">
				   <td align="right">
				    ' . get_lang('labelSelectDisciplines') . '
				   </td>
				   <td>
				    <select name="discipline_id" >
                                    <option value="0"> </option>';
                $query = "SELECT `id`,`code`,`name`
					FROM `campus_discipline`
				WHERE `department_id` = " . $department_id . " ORDER BY `code`";
                $result = mysql_query($query);
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    echo '<option value="' . $rij['id'] . '" ' . (($rij['id'] == $discipline_id) ? 'selected' : '') . '>' . $rij['code'] . ': ' . $rij['name'] . '</option>';
                }
                echo '	      </select>
				     </td>
				    </tr>
				 <tr valign="top">
				  <td align="right">
				   ' . get_lang('labelSelectClasses') . '
				  </td>
				  <td>
				   <select name="groups[]" multiple="multiple" SIZE="5">';
                foreach ($group_array as $id => $value)
                {
                    echo "<option value=\"" . $id . "\" SELECTED>" . $value['code'] . "</option>";
                }
                echo "        <option value=\"\"> </option>";
                $groups = campus::get_studentclasses($department_id);
                foreach ($groups as $key => $value)
                {
                    if (empty($group_array[$key]))
                    {
                        echo "<option value=\"" . $key . "\">" . $groups[$key]['code'] . "</OPTION>";
                    }
                }
                echo '	    </select>
				   </td>
				  </tr>
				 <tr valign="top">
				  <td align="right">
				   ' . get_lang('labelSelectTeachers') . '
				  </td>
				  <td>
				   <select name="teachers[]" multiple="multiple" SIZE="5">';
                foreach ($teacher_array as $id => $userinfo)
                {
                    // $userinfo = campus::get_user_info($id);
                    echo "<option value=\"" . $id . "\" SELECTED>" . $userinfo['official_code'] . ": " . $userinfo['name'] . "</option>";
                }
                echo "<option value=\"\"> </option>";
                $teachers = campus::get_teachers($department_id);
                foreach ($teachers as $teacherid => $teacherinfo)
                {
                    if (empty($teacher_array[$teacherid]) && ($teacherinfo['official_code'] != ""))
                    {
                        echo "<option value=\"" . $teacherid . "\">" . $teacherinfo['official_code'] . ": " . $teacherinfo['fullname'] . "</option>";
                    }
                }
                echo '     </select>
				  </td>
				 </tr>
				    <tr valign="top">
				     <td>
				     </td>
				     <td colspan="2">
					<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
				     </td>
				    </tr>
				   </table>
				  </form>';
            }
            break;
        case "formcollege" :
            {
                // ===============================================================
                // Form to add/edit line in roster
                // ===============================================================
                $resource_array = campus::get_college2resource($college_id);
                echo "<b>" . get_lang("page_addrosterline") . "</b><br>";
                echo '<form method="post" action="' . $this->get_url() . '" name="myform">
				<input type="hidden" name="page" value="editcurriculum" >
				<input type="hidden" name="action" value="' . $action . '" >
				<input type="hidden" name="schedule_id" value="' . $schedule_id . '" >
				<input type="hidden" name="assignment_id" value="' . $assignment_id . '" >
				<input type="hidden" name="college_id" value="' . $college_id . '" >
				<input type="hidden" name="filter" value="' . $filter . '" >
				<table>
				 <tr valign="top">
				  <td colspan="2">
				  </td>
				 </tr>
				 <tr valign="top">
				  <td align="right">
				   ' . get_lang('labelSelectHour') . '
				  </td>
				  <td>
				   <select name="period_id">';
                $query = "SELECT `id`,`code`,`weekday`
					FROM `campus_period`
				WHERE `department_id` = " . $department_id . " ORDER BY `weekday`, `display_order`";
                $result = mysql_query($query);
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    echo '<option value="' . $rij['id'] . '" ' . (($period_id == $rij['id']) ? 'SELECTED' : '') . '>' . $rij['code'] . ' (' . $week[$rij['weekday']] . ')</option>';
                }
                echo ' 	   </select>
				  </td>
				 </tr>
				 <tr valign="top">
				  <td align="right">
				   ' . get_lang('labelSelectDuration') . '
				   </td>
				   <td>
				    <input type="text" name="duration" size="2" maxlength="2" value="' . $duration . '" />
				   </td>
				  </tr>
				  <tr valign="top">
				   <td align="right">
				    ' . get_lang('labelSelectResources') . $department_id . '
				   </td>
				   <td>
				    <select name="resources[]" multiple="multiple" SIZE="5">';
                foreach ($resource_array as $id => $value)
                {
                    echo "<option value=\"" . $id . "\" SELECTED>" . $value['code'] . ": " . $value['comment'] . "</option>";
                }
                echo "<option value=\"\"> </option>";
                $query = 'SELECT `id`,`code`, `comment` FROM `campus_resource`
               			WHERE `department_id` = ' . $department_id . ' ORDER BY `display_order`,`code`';
                $result = mysql_query($query);
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    if (empty($resource_array[$rij['id']]))
                    {
                        echo "<option value=\"" . $rij['id'] . "\" >" . $rij['code'] . ": " . $rij['comment'] . "</option>";
                    }
                }
                echo '	     </select>
				    </td>
				   </tr>
				   <tr valign="top">
				    <td>
				    </td>
				    <td colspan="2">
				     <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
				    </td>
				   </tr>
				  </table>
				 </form>';
            }
            break;
        case "cpteacher" :
        case "rmteacher" :
            {
                // ===============================================================
                // Form to copy, delete teacher from roster
                // ===============================================================
                echo "<b>" . (($action == 'cpteacher') ? get_lang("page_copyteacher") : get_lang("page_removeteacher")) . "</b><br>";
                echo '<form method="post" action="' . $this->get_url() . '" name="myform">
				<input type="hidden" name="page" value="editcurriculum" >
                                <input type="hidden" name="action" value="' . $action . '" >
				<input type="hidden" name="schedule_id" value="' . $schedule_id . '" >
				<input type="hidden" name="filter" value="' . $filter . '" >
				<table>
				 <tr valign="top">
				  <td colspan="2">
				  </td>
				 </tr>
				 <tr valign="top">
				  <td align="right">
				   ' . (($action == 'cpteacher') ? get_lang('labelTeacherSrc') : '') . '
				  </td>
				  <td align="right">
				   ' . (($action == 'cpteacher') ? get_lang('labelTeacherDest') : get_lang('labelTeacher2Remove')) . '
				  </td>
				</tr>
				<tr valign="top">
				 <td>';
                if ($action == 'cpteacher')
                {
                    echo "<select name='teacher_src'>";
                    $teachers = campus::get_teachers($department_id);
                    foreach ($teachers as $teacherid => $teacherinfo)
                    {
                        echo "<option value=\"" . $teacherid . "\">" . $teacherinfo['official_code'] . ": " . $teacherinfo['fullname'] . "</option>";
                    }
                    echo "</select>";
                }
                echo '	  </td>
				  <td>
				   <select name="teacher_dest">';
                $teachers = campus::get_teachers($department_id);
                foreach ($teachers as $teacherid => $teacherinfo)
                {
                    echo "<option value=\"" . $teacherid . "\">" . $teacherinfo['official_code'] . ": " . $teacherinfo['fullname'] . "</option>";
                }
                echo '	      </select>
				     </td>
				    </tr>
				    <tr valign="top">
				     <td>
				     </td>
				     <td colspan="2">
				      <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
				     </td>
				    </tr>
				   </table>
				  </form>';
            }
            break;
        case "formcurriculum" :
            {
                echo "<b>" . get_lang("page_newcurriculum") . "</b><br>";
                echo '<form method="post" action="' . $this->get_url() . '" name="myform">
                		<input type="hidden" name="page" value="editcurriculum" >
				<input type="hidden" name="curriculum_id" value="' . $curriculum_id . '" >
				<input type="hidden" name="action" value="' . $action . '" >
				<table>
				 <tr valign="top">
				  <td colspan="2">
				  </td>
				 </tr>
				 <tr valign="top">
				  <td align="right">
				   ' . get_lang('labelName') . '
				  </td>
				  <td>
				   <input type="text" name="name" size="12"  value="' . $name . '" />
				  </td>
				 </tr>
				 <tr valign="top">
				  <td align="right">
				   ' . get_lang('labelCurriculumStartDate') . '
				  </td>
				  <td>
				   <input type="text" name="start_time" size="12"  value="' . DatetimeUtilities::format_locale_date('%Y-%m-%d', $start_time) . '" />(' . DatetimeUtilities::format_locale_date('%Y-%m-%d', $start_time) . ')
				  </td>
				 </tr>
				 <tr valign="top">
				  <td>
				  </td>
				  <td colspan="2">
				   <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
				  </td>
				 </tr>
				</table>
				</form>';
            }
            break;
        case "formcproster" :
            {
                // ===============================================================
                // Het uurrooster formulier weergeven.........
                // ===============================================================

                $roster_id = campus::get_schedule2roster($schedule_id);
                $curriculum_id = campus::get_roster2curriculum($roster_id);
                if ($curriculum_id > 0)
                {
                    $query = 'SELECT `id`, `name` FROM `campus_roster` WHERE `curriculum_id` = ' . $curriculum_id . ' ORDER BY `name`';
                    $result = mysql_query($query);
                    if (mysql_num_rows($result) > 0)
                    {
                        $options = '';
                        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                        {
                            if ($rij['id'] == $roster_id)
                            {
                                $source_roster = $rij['name'];
                            }
                            else
                            {
                                $options.='<option value="' . $rij['id'] . '" >' . $rij['name'] . '</option>';
                            }
                        }
                        echo '<form method="post" action="' . $this->get_url() . '" name="myform">';
                        echo '<input type="hidden" name="page" value="editcurriculum" >
                                <input type="hidden" name="curriculum_id" value="' . $curriculum_id . '" >
				<input type="hidden" name="roster_id" value="' . $roster_id . '" >
				<input type="hidden" name="schedule_id" value="' . $schedule_id . '" >
				<input type="hidden" name="action" value="' . $action . '" >';
                        echo get_lang("source_Roster") . ': ' . $source_roster;

                        echo get_lang("destination_Roster") . ': ' . $source_roster . '&nbsp;&nbsp;=&gt;&gt;&nbsp;';
                        echo '<select name="destination_roster_id" >';
                        echo $options;
                        echo '</select><br><br>
    			  	   <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
				</form>';
                    }
                }
            }
            break;
        case "formroster" :
            {
                // ===============================================================
                // Het uurrooster formulier weergeven.........
                // ===============================================================
                echo "<b>" . get_lang("page_newroster") . "</b><br>";
                echo '<form method="post" action="' . $this->get_url() . '" name="myform">
                		<input type="hidden" name="page" value="editcurriculum" >
				<input type="hidden" name="curriculum_id" value="' . $curriculum_id . '" >
				<input type="hidden" name="roster_id" value="' . $roster_id . '" >
				<input type="hidden" name="schedule_id" value="' . $schedule_id . '" >
				<input type="hidden" name="action" value="' . $action . '" >
				<table>
				 <tr valign="top">
				  <td colspan="2">
				  </td>
				 </tr>
				 <tr valign="top">
				  <td align="right">
				   ' . get_lang('labelName') . '
				  </td>
				  <td>
				   <input type="text" name="name" size="12"  value="' . $name . '" ' . (($action == 'newschedule') ? 'READONLY' : '') . '/>
				  </td>
				 </tr>
                                 <tr valign="top">
				  <td align="right">
				   ' . get_lang('labelRosterStartDate') . '
				  </td>
				  <td>
				   <input type="text" name="start_time" size="12"  value="' . DatetimeUtilities::format_locale_date('%Y-%m-%d', $start_time) . '" />
				  </td>
				 </tr>
				 <tr valign="top">
				  <td>
				  </td>
				  <td colspan="2">
				   <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
				  </td>
				 </tr>
				</table>
				</form>';
            }
            break;
        case "list" :
            {

                echo '<form method="post" action="' . $this->get_url() . '" name="formcurriculum">';
                echo '<input type="hidden" name="page" value="editcurriculum" >';
                echo '<input type="hidden" name="action" value="list" >';
                $query = 'SELECT `id`,`name`, `start_time` FROM `campus_curriculum` WHERE `department_id` = ' . $department_id . ' ORDER BY `start_time`';
                $result = mysql_query($query);
                if (mysql_num_rows($result) > 0)
                {
                    echo "<div>";
                    echo '<select name="curriculum_id" SIZE="1" OnChange="javascript:document.formcurriculum.submit();" >';
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        if ($curriculum_id == 0)
                        {
                            $curriculum_id = $rij['id'];
                        }
                        echo '<option value="' . $rij['id'] . '" ' . (($curriculum_id == $rij['id']) ? 'SELECTED' : '') . '>' . $rij['name'] . '&nbsp;' . get_lang("txtActiveFrom") . '&nbsp;' . DatetimeUtilities::format_locale_date('%Y-%m-%d', $rij['start_time']) . '</option>';
                    }
                    echo "</select>&nbsp;";
                    echo get_lang("item_Curriculum") . ': ';
                    echo "<a href=\"" . $this->get_url() . "&page=editcurriculum&action=updatecurriculum&curriculum_id=" . $curriculum_id . "\" >" . get_lang("action_Change") . "</a>&nbsp;|&nbsp;";
                    echo "<a href=\"" . $this->get_url() . "&page=editcurriculum&action=deletecurriculum&curriculum_id=" . $curriculum_id . "\" onclick=\"javascript:if(!confirm('" . get_lang("msgboxConfirmDeleteCurriculum") . "')) return false;\" title=\"" . get_lang("tooltipDeleteCurriculum") . "\">" . get_lang("action_Delete") . "</a>&nbsp;|&nbsp;";
                }
                else
                {
                    echo "<div>";
                    echo get_lang("item_Curriculum") . ' ';
                    echo get_lang("txtNotExisting") . ': ';
                }
                echo '&nbsp;&nbsp;<a href="' . $this->get_url() . '&page=editcurriculum&action=newcurriculum" title="' . get_lang("tooltipAddCurriculum") . '">' . get_lang("action_Add") . '</a></div>';
                echo "</form>";
                if ($roster_id > 0)
                {
                    echo "<div >";
                    echo '<a href="' . $this->get_url() . '&page=importcurriculum&schedule_id=' . $schedule_id . '" title="' . get_lang('tooltip_ImportAssignmentsAndRoster') . '">' . get_lang("action_Import") . ' ' . get_lang("item_curriculum") . '</a>&nbsp;| ';
                    echo '<a href="' . $this->get_url() . '&page=editcurriculum&action=combineassignment&schedule_id=' . $schedule_id . '" >' . get_lang("txtCombineParallelClasses") . '</a>&nbsp;| ';
                    echo '<a href="' . $this->get_url() . '&page=editcurriculum&action=combinecollege&schedule_id=' . $schedule_id . '" >' . get_lang("txtCombineCollege") . '</a>&nbsp;| ';
                    echo '<a href="' . $this->get_url() . '&page=editcurriculum&action=cleanupassignment&schedule_id=' . $schedule_id . '" >' . get_lang("txtCleanUpAssignments") . '</a>';
                    echo '</div>';
                }
                if ($curriculum_id > 0)
                {
                    echo '<form method="post" action="' . $this->get_url() . '" name="formroster">';
                    echo '<input type="hidden" name="page" value="editcurriculum" >';
                    echo '<input type="hidden" name="action" value="list" >';
                    $query = 'SELECT `campus_roster`.`id` as "roster_id", `campus_roster_schedule`.`id` as "schedule_id", `name`, `start_time` FROM `campus_roster`
                                INNER JOIN `campus_roster_schedule` ON `campus_roster`.`id` = `campus_roster_schedule`.`roster_id`
                        WHERE `curriculum_id` = ' . $curriculum_id . ' ORDER BY `start_time`';
                    $result = mysql_query($query) or die(mysql_error());
                    if (mysql_num_rows($result) > 0)
                    {
                        echo '<div style="float:right;">';
                        echo '&nbsp;' . get_lang("txtFilter") . ': <input type="tekst" name="filter" OnChange="javascript:formroster.submit();" value="' . $filter . '">';
                        echo '</div>';
                        echo '<div>';
                        echo '<select name="schedule_id" SIZE="1" OnChange="javascript:document.formroster.submit();" >';
                        if ($roster_id==0)
                        {
                            echo '<option value="0" >&nbsp;</option>';
                        }
                        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                        {
                            $selected = '';
                            // if ($schedule_id == 0)
                            // {
                            //     $schedule_id = $rij['schedule_id'];
                            // }
                            if ($schedule_id == $rij['schedule_id'])
                            {
                                //$roster_id = $rij['roster_id'];
                                $selected = 'selected';
                                $roster_name = $rij['name'];
                            }
                            echo '<option value="' . $rij['schedule_id'] . '" ' . $selected . '>' . $rij['name'] . '&nbsp;' . get_lang("txtRosterFrom") . DatetimeUtilities::format_locale_date("%Y-%m-%d", $rij['start_time']) . '</option>';
                        }
                        echo '</select>&nbsp;';
                        echo get_lang("item_Roster") . ': ';
                        echo '<a href="' . $this->get_url() . '&page=editcurriculum&action=updateroster&schedule_id=' . $schedule_id . '" title="' . get_lang("tooltipEditRoster") . '">' . get_lang("action_Change") . '</a>&nbsp;|&nbsp;';
                        echo '<a href="' . $this->get_url() . '&page=editcurriculum&action=deleteschedule&schedule_id=' . $schedule_id . '" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmDeleteRoster") . '\')) return false;" title="' . get_lang("tooltipDeleteRoster") . '">' . get_lang("action_Delete") . '</a>&nbsp;|&nbsp;';
                    }
                    else
                    {
                        echo "<div>";
                        echo get_lang("item_Roster") . ' ';
                        echo get_lang("txtNotExisting") . ': ';
                    }
                    echo '<a href="' . $this->get_url() . '&page=editcurriculum&action=newroster&curriculum_id=' . $curriculum_id . '" title="' . get_lang("tooltipAddRoster") . '">' . get_lang("action_Add") . '</a>';
                    if ($roster_id > 0)
                    {
                        echo '&nbsp;|&nbsp;<a href="' . $this->get_url() . '&page=editcurriculum&action=newschedule&roster_id=' . $roster_id . '" title="' . get_lang("tooltipAddStartdate4thisRoster") . '">' . get_lang("txtAddStartDate") . '</a>';
                    }
                    echo '</div></form>';
                    echo '<div style="clear:both"></div>';
                }

                if ($roster_id > 0)
                {
                    // ===============================================================
                    // generate Assignment list details........
                    // ===============================================================
                    // TEACHER ARRAY...
                    $sql = "SELECT `assignment_id`, `user_id`, `official_code`, `lastname`, `firstname`
					FROM `campus_assignment_rel_teacher`
						INNER JOIN `user_user`
							ON `user_user`.`id`=`campus_assignment_rel_teacher`.`user_id`
						INNER JOIN `campus_assignment`
							ON `campus_assignment`.`id` = `campus_assignment_rel_teacher`.`assignment_id`
						WHERE `campus_assignment_rel_teacher`.`roster_id`=" . $roster_id . " ORDER BY `lastname`";
                    $result = mysql_query($sql);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $teacher_array[$rij['assignment_id']][$rij['user_id']]['official_code'] = $rij['official_code'];
                    }
                    // GROUP ARRAY...
                    $sql = "SELECT  `assignment_id`, `group_id`, `code`, `name`
					FROM `campus_assignment_rel_group`
						INNER JOIN `group_group`
							ON `campus_assignment_rel_group`.`group_id` = `group_group`.`id`
						INNER JOIN `campus_assignment`
							ON `campus_assignment`.`id` = `campus_assignment_rel_group`.`assignment_id`
						WHERE `campus_assignment`.`curriculum_id`=" . $curriculum_id . " ORDER BY `code`";
                    $result = mysql_query($sql);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $group_array[$rij['assignment_id']][$rij['group_id']]['code'] = $rij['code'];
                    }

                    // RESOURCE ARRAY...
                    $sql = "SELECT `college_id`,`resource_id`, `code`, `comment`
					FROM `campus_college_rel_resource`
						INNER JOIN `campus_resource`
							ON `campus_resource`.`id` = `campus_college_rel_resource`.`resource_id`
						INNER JOIN `campus_college`
							ON `campus_college`.`id` = `campus_college_rel_resource`.`college_id`
						WHERE `roster_id`=" . $roster_id . " ORDER BY `code`";
                    $result = mysql_query($sql) or die(mysql_error());
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $resource_array[$rij['college_id']][$rij['resource_id']]['code'] = $rij['code'];
                    }

                    $query = "SELECT `campus_assignment`.`id` as assignment_id, `roster_id`, `campus_period`.`code`,`campus_discipline`.`code` as discipline_code, `campus_discipline`.`name` as tooltip, `weekday`, `duration`, `campus_college`.`id` as `college_id`
						FROM `campus_assignment`
							LEFT JOIN `campus_discipline`
                                                                ON `campus_discipline`.`id`= `campus_assignment`.`discipline_id`
                                                        INNER JOIN `campus_roster`
								ON `campus_roster`.`curriculum_id`= `campus_assignment`.`curriculum_id`
							LEFT JOIN `campus_college`
								ON `campus_assignment`.`id`=`campus_college`.`assignment_id` AND `campus_college`.`roster_id` = `campus_roster`.`id`
							LEFT JOIN `campus_period`
								ON `campus_period`.`id` = `campus_college`.`period_id`
						WHERE `campus_roster`.`id`=" . $roster_id . " ORDER BY  `campus_discipline`.`display_order`,`assignment_id`";
                    $result = mysql_query($query);
                    echo "<div >";
                    echo '<a href="' . $this->get_url() . '&page=importroster&schedule_id=' . $schedule_id . '" title="' . get_lang('tooltip_ImportRoster') . '">' . get_lang("action_Import") . ' ' . get_lang("item_roster") . '</a>&nbsp;| ';
                    echo '<a href="' . $this->get_url() . '&page=roster2csv&schedule_id=' . $schedule_id . '">' . get_lang("txtExportRoster") . '</a>&nbsp;| ';
                    echo '<a href="' . $this->get_url() . '&page=editcurriculum&action=cproster&schedule_id=' . $schedule_id . '" title="' . get_lang('tooltip_ImportRoster') . '">' . get_lang("action_Copy") . ' ' . get_lang("item_roster") . '</a>&nbsp;| ';
                    echo '<a href="' . $this->get_url() . '&page=editcurriculum&action=optimizecollege&schedule_id=' . $schedule_id . '" >' . get_lang("txtOptimizeCollege") . '</a>&nbsp;| ';
                    echo '<a href="' . $this->get_url() . '&page=editcurriculum&action=removeduplicate&schedule_id=' . $schedule_id . '" >' . get_lang("txtRemoveDuplicates") . '</a> ';
                    echo '</div>';
                    echo "<div style=\"float:right;\">";
                    echo "<a href=\"" . $this->get_roster_url() . "&page=roster2pdf&compact=&rooster=teacher&select=complete&roster_id=" . $roster_id . "\" target=\"_blank\" title=\"" . get_lang("tooltipTchrRosters2Pdf") . "\">" . get_lang("txtRoster") . "</a>";
                    echo "&nbsp;<a href=\"" . $this->get_roster_url() . "&page=roster2pdf&compact=on&rooster=teacher&select=complete&roster_id=" . $roster_id . "\" target=\"_blank\" title=\"" . get_lang("tooltipTchrRosters2PdfCompact") . "\">" . get_lang("txtCompact") . "</a>&nbsp;|";
                    echo "&nbsp;<a href=\"" . $this->get_roster_url() . "&page=roster2pdf&compact=&rooster=class&select=complete&roster_id=" . $roster_id . "\" target=\"_blank\" title=\"" . get_lang("tooltipStdntRosters2Pdf") . "\">" . get_lang("txtStudentRoster") . "</a>";
                    echo "&nbsp;<a href=\"" . $this->get_roster_url() . "&page=roster2pdf&compact=on&rooster=class&select=complete&roster_id=" . $roster_id . "\" target=\"_blank\" title=\"" . get_lang("tooltipStdntRosters2PdfCompact") . "\">" . get_lang("txtCompact") . "</a>&nbsp;|";
                    echo "&nbsp;<a href=\"" . $this->get_roster_url() . "&page=roster2pdf&compact=on&rooster=resource&select=complete&roster_id=" . $roster_id . "\" target=\"_blank\" title=\"" . get_lang("tooltipReservRosters2PdfCompact") . "\">" . get_lang("txtResourceRoster") . "</a>&nbsp;";
                    echo "</div>";
                    echo "<div >";
                    echo '<a href="' . $this->get_url() . '&page=editcurriculum&action=newassignment&schedule_id=' . $schedule_id . '">' . get_lang("item_Assignment") . ' ' . get_lang("action_Add") . '</a>&nbsp;| ';
                    echo '<a href="' . $this->get_url() . '&page=editcurriculum&action=cpteacher&schedule_id=' . $schedule_id . '">' . get_lang("txtCopyTeacherRoster") . '</a>&nbsp;| ';
                    echo '<a href="' . $this->get_url() . '&page=editcurriculum&action=rmteacher&schedule_id=' . $schedule_id . '">' . get_lang("txtRemoveTeacherRoster") . '</a>&nbsp;| ';
                    echo '</div>';
                    $prev_assignment = "";
                    campus::display_complex_table_header($properties, array(get_lang("colheadClasses"), get_lang("colheadDiscipline"), $roster_name . ':' . get_lang("colheadTeachers"), "", "<table width='100%' cellspacing=0 cellpadding=0>" .
                        "<tr><td width=50>" . get_lang("colheadHour") . "</td><td width=50>" . get_lang("colheadDuration") . "</td><td width=100>" . get_lang("colheadResource") . "</td><td></td></tr>" .
                        "</table>"));
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $teacher = "";
                        foreach ($teacher_array[$rij['assignment_id']] as $teacher_id => $value)
                        {
                            $teacher.=" " . $value['official_code'];
                        }
                        $group = "";
                        foreach ($group_array[$rij['assignment_id']] as $class_id => $value)
                        {
                            $group.=" " . $value['code'];
                        }
                        /* $discipline = "";
                          foreach ($discipline_array[$rij['assignment_id']] as $discipline_id => $value)
                          {
                          $discipline.=" " . $value['code'];
                          } */
                        $discipline = '<span title="' . $rij['tooltip'] . '">' . $rij['discipline_code'] . '</ span>';
                        $resource = "";
                        foreach ($resource_array[$rij['college_id']] as $resource_id => $value)
                        {
                            $resource.=" " . $value['code'];
                        }
                        if ((strstr($teacher, $filter) != false) OR (strstr($group, $filter) != false) OR (strstr($discipline, $filter) != false) OR (strstr($resource, $filter) != false) OR (strstr($hour, $filter) != false) OR $filter == '')
                        {

                            if ($rij['assignment_id'] <> $prev_assignment)
                            {
                                if (!empty($data))
                                {
                                    $data['roster'] = "<table width='100%' cellspacing=0 cellpadding=0>" . $data2 . "</table>";
                                    campus::display_table_row($bgcolor, $data, true);
                                }
                                $data2 = "";
                                $prev_assignment = $rij['assignment_id'];
                                $data = array();
                                $data['group'] = $group;
                                $data['discipline'] = $discipline;
                                $data['teacher'] = $teacher;
                                $data['link'] = '<pre><a href="' . $this->get_url() . '&page=editcurriculum&schedule_id=' . $schedule_id . '&assignment_id=' . $rij['assignment_id'] . '&action=updateassignment&filter=' . $filter . '" title="' . get_lang("tooltipEditAssignment") . '"><img src="' . Theme::get_image_path('application\campus') . 'edit.gif" border=0 align="absmiddle" ></a>' .
                                        '&nbsp;<a href="' . $this->get_url() . '&page=editcurriculum&schedule_id=' . $schedule_id . '&assignment_id=' . $rij['assignment_id'] . '&action=delete&filter=' . $filter . '" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmDeleteAssignment") . '\')) return false;" title="' . get_lang("tooltipDeleteAssignment") . '"/><img src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="absmiddle" ></a>' .
                                        '&nbsp;<a href="' . $this->get_url() . '&page=editcurriculum&schedule_id=' . $schedule_id . '&assignment_id=' . $rij['assignment_id'] . '&action=duplicate&filter=' . $filter . '" title="' . get_lang('tooltipCopyAssignment') . '"/><img src="' . Theme::get_image_path('application\campus') . 'action_reuse.png" border=0 align="absmiddle" ></a>' .
                                        '&nbsp;<a href="' . $this->get_url() . '&page=editcurriculum&assignment_id=' . $rij['assignment_id'] . '&schedule_id=' . $schedule_id . '&action=newcollege&filter=' . $filter . '" title="' . get_lang("tooltipNewCollege") . '"/><img src="' . Theme::get_image_path('application\campus') . 'addrosterline.gif" border=0 align="absmiddle" ></a></pre>';
                            }
                            if (($hour != '') || ($rij['duration'] != '') || ($resource != ''))
                            {
                                $data2 .='<tr><td width=50>' . $rij['code'] . '</td><td width=50>' . $rij['duration'] . '</td><td width=100>' . $resource . '</td><td><a href="' . $this->get_url() . '&page=editcurriculum&schedule_id=' . $schedule_id . '&college_id=' . $rij['college_id'] . '&action=updatecollege&filter=' . $filter . '" title="' . get_lang('tooltipEditRosterline') . '"><img src="' . Theme::get_image_path('application\campus') . 'edit.gif" border=0 align="absmiddle" ></a>' .
                                        '&nbsp;<a href="' . $this->get_url() . '&page=editcurriculum&schedule_id=' . $schedule_id . '&college_id=' . $rij['college_id'] . '&action=delete&filter=' . $filter . '" onclick="javascript:if(!confirm(\'' . get_lang('msgboxConfirmDeleteRosterline') . '\')) return false;" title="' . get_lang('tooltipDeleteRosterline') . '"><img src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="absmiddle" ></a></td></tr>';
                            }
                        }
                    }
                    if (!empty($data))
                    {
                        $data['roster'] .= "<table width='100%' cellspacing=0 cellpadding=0>" . $data2 . "</table>";
                        campus::display_table_row($bgcolor, $data, true);
                    }
                    campus::display_table_footer();
                }
                else
                {
                    Display::normal_message(get_lang("msgNoActiveRoster"), false);
                }
            }
            break;
        case "terug" :
            {
                echo "<div><p><a href=\"" . $this->get_url() . "&page=editcurriculum&action=list\">" . get_lang("txtBack2RosterList") . "</a></p></div>";
            }
            break;
    }
}