<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\Theme;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['roster']) && !$is_platformadmin))
{// not allowed here!
    Display::display_error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $activeroster = campus::get_activeroster($department_id);
    $action = campus::get_POST_GET("action");
    $submitmessage = campus::get_POST_GET("submitmessage");
    $reportcard_id = intval(campus::get_SESSION("reportcard_id"));
    $report_id = intval(campus::get_POST_GET("report_id"));
    $assignment_id = intval(campus::get_POST_GET("assignment_id"));
    $list_id = intval(campus::get_POST_GET("list_id"));
    $filter = campus::get_POST_GET("filter");

    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */
    if ($activeroster['curriculum_id'] > 0)
    {
        // ===============================================================
        // generate Assignment list details........
        // ===============================================================
        // TEACHER ARRAY...
        $sql = 'SELECT `campus_assignment`.`id`, `campus_assignment_rel_teacher`.`user_id`, `official_code`, `lastname`, `firstname`,`campus_roster`.`id` as roster_id, `campus_roster`.`name`, SUM(`duration`) as houres
			FROM `campus_assignment`
				INNER JOIN `campus_assignment_rel_teacher`
					ON `campus_assignment`.`id`=`campus_assignment_rel_teacher`.`assignment_id`
				INNER JOIN `user_user`
					ON `user_user`.`id`=`campus_assignment_rel_teacher`.`user_id`
                          	INNER JOIN `campus_college`
					ON `campus_assignment`.`id`=`campus_college`.`assignment_id` AND `campus_college`.`roster_id`=`campus_assignment_rel_teacher`.`roster_id`
                                INNER JOIN `campus_roster`
                                	ON `campus_roster`.`id`=`campus_college`.`roster_id`
    			WHERE `campus_assignment`.`curriculum_id`=' . $activeroster['curriculum_id'] . ' GROUP BY `campus_assignment`.`id` , `campus_assignment_rel_teacher`.`roster_id`,`campus_assignment_rel_teacher`.`user_id` ORDER BY `campus_roster`.`name`,`lastname`';
        $result = mysql_query($sql) or die(mysql_error());
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $teacher_array[$rij['id']][$rij['roster_id']][$rij['user_id']]['official_code'] = $rij['official_code'];
            $teacher_array[$rij['id']][$rij['roster_id']][$rij['user_id']]['houres'] = $rij['houres'];
            $teacher_array[$rij['id']][$rij['roster_id']][$rij['user_id']]['roster'] = $rij['name'];
        }
        // CLASSES ARRAY...
        $sql = "SELECT `campus_assignment`.`id`, `campus_assignment_rel_group`.`group_id`, `code`, `name`
			FROM `campus_assignment`
				INNER JOIN `campus_assignment_rel_group`
					ON `campus_assignment`.`id`=`campus_assignment_rel_group`.`assignment_id`
				INNER JOIN `group_group`
					ON `campus_assignment_rel_group`.`group_id` = `group_group`.`id`
			WHERE `campus_assignment`.`curriculum_id`=" . $activeroster['curriculum_id'] . " ORDER BY `code`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $group_array[$rij['id']][$rij['group_id']]['code'] = $rij['code'];
        }
        // DISCIPLINE ARRAY...
        $sql = "SELECT `campus_assignment`.`id`, `discipline_id`, `code`, `name`
			FROM  `campus_assignment`
                            INNER JOIN `campus_discipline`
				ON `campus_assignment`.`discipline_id`=`campus_discipline`.`id`
				WHERE `campus_assignment`.`curriculum_id`=" . $activeroster['curriculum_id'] . " ORDER BY `code`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $discipline_array[$rij['id']][$rij['discipline_id']]['code'] = $rij['code'];
        }
    }
    if ($submitmessage == "")
    { //
        // de scholen ophalen waar de gebruiker deel van uitmaakt.
        switch ($action)
        {
            case "addreportcards" :
                {
                    $evaluation_id = "";
                    $display = "form";
                }
                break;
            case "delete" :
                {
                    // het vak verwijderen.....
                    $result = mysql_query("DELETE FROM `campus_evaluation` WHERE `id`=" . $evaluation_id . " ");
                    $message = get_lang("msgItemDeleted");
                    $display = "list";
                }
                break;
            default :
                {
                    $display = "list";
                }
                break;
        }
    }
    else
    {
        switch ($action)
        {
            case "editreportcards" :
                {
                    $result = mysql_query("DELETE FROM `campus_reportcard` WHERE `assignment_id`=" . $assignment_id);
                    foreach (campus::get_POST_GET("reports") as $key)
                    {
                        $result = mysql_query("INSERT `campus_reportcard` SET `assignment_id`=" . $assignment_id . ", `report_id`=" . $key);
                    }
                    if (!$result)
                    {
                        $message = get_lang("msgItemAddError");
                        $display = "form";
                    }
                    else
                    {
                        $report_id = mysql_insert_id();
                        $message = get_lang("msgItemAddSucces");
                        $action = "";
                        $display = "list";
                    }
                }
                break;
            case "addreportcards" :
                {
                    $query = "SELECT `campus_assignment`.`id` , `campus_discipline`.`code`, `campus_discipline`.`name` FROM `campus_assignment`
			      INNER JOIN `campus_discipline`
				ON `campus_assignment`.`discipline_id`=`campus_discipline`.`id`
			WHERE `curriculum_id`=" . $activeroster['curriculum_id'] . " ";
                    $result = mysql_query($query)or die (mysql_error());
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                              $groups = "";
                        foreach ($group_array[$rij['id']] as $group_id => $value)
                        {
                            $groups.=" " . $value['code'];
                        }
                        $assignment_detail = "";
                        foreach ($teacher_array[$rij['id']] as $roster_id => $teacherinfo)
                        {
                            $teachers = "";
                            foreach ($teacherinfo as $teacher_id => $value)
                            {
                                $teachers.=' ' . $value['official_code'] . ' (' . $value['houres'] . ')';
                                $rostername = $value['roster'];
                            }
                            $assignment_detail.=$rostername . ': ' . $teachers . '<br>';
                        }
                        if ((strstr($rij['code'], $filter) != false) OR (strstr($groups, $filter) != false) OR (strstr( $assignment_detail, $filter) != false) OR $filter == '')
                        {
                            $display = "list";
                            if ($report_id == 0)
                            {
                                $result2 = mysql_query("DELETE FROM `campus_reportcard` WHERE `assignment_id`=" . $rij['id'] . " ");
                            }
                            else
                            {
                                $result2 = mysql_query("SELECT * FROM `campus_reportcard` WHERE `assignment_id`=" . $rij['id'] . " AND `report_id`=" . $report_id);
                                $nbrLines = mysql_num_rows($result2);
                                if ($nbrLines == 0)
                                {
                                    $result2 = mysql_query("INSERT `campus_reportcard` SET `assignment_id`=" . $rij['id'] . ", `report_id`=" . $report_id);
                                    if (!$result2)
                                    {
                                        $message = get_lang("msgItemAddError");
                                        $display = "form";
                                    }
                                    else
                                    {
                                        $message = get_lang("msgItemAddSucces");
                                        $action = "";
                                    }
                                }
                            }
                        }
                    }
                }
                break;
        }
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message);
    }
//	echo "<b>".get_lang("page_addreport2assignment")."</b><br>";
    switch ($display)
    {
        case "form" :
            {
                echo '<form method="post" action="' . $this->get_url() . '#' . $rij['id'] . '" name="myform">';
                echo '<input type="hidden" name="page" value="editreport2assignment" >';
                echo '<input type="hidden" name="action" value="' . $action . '" >';
                echo '<input type="hidden" name="filter" value="' . $filter . '" >';
                echo '<select name="report_id" style="width:200px"/>';
                $query2 = "SELECT `id`,`title` FROM `campus_report`
					WHERE `department_id`=" . $department_id . " AND `parent_id`=0 ORDER BY `title`";
                $result2 = mysql_query($query2);
                echo '<option value="0">' . get_lang('txtClearReportCards') . '</option>';
                while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                {
                    echo '<option value="' . $rij2['id'] . '" >' . $rij2['title'] . '</option>';
                }
                echo '</select>';
                echo '<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';">';
                echo '</form>';
            }
            break;
        case "list" :
            {
                echo '<form method="post" action="' . $this->get_url() . '" name="myform">';
                echo '<input type="hidden" name="page" value="editreport2assignment" >';
                echo '<input type="hidden" name="action" value="list" >';
                echo '<div style="float:right;">';
                echo '&nbsp;' . get_lang("txtFilter") . ': <input type="tekst" name="filter" OnChange="javascript:myform.submit();" value="' . $filter . '">';
                echo '</div>';
                echo '<div >';
                echo '<a href="' . $this->get_url() . '&page=editreport2assignment&action=addreportcards&filter=' . $filter . '">' . get_lang("txtAddReport2Assignments") . '</a>&nbsp;|&nbsp;';
                echo '<a href="' . $this->get_url() . '&page=assignment2csv">' . get_lang("txtAssignments2Csv") . '</a>&nbsp;|&nbsp;';
                echo '</div>';
                echo '</form>';
            }
            break;
    }
    echo '<div style="clear:both"></div>';
    if ($activeroster['curriculum_id'] > 0)
    {
        $query = 'SELECT `campus_assignment`.`id`, `campus_discipline`.`code`, `campus_discipline`.`name` FROM `campus_assignment`
			      INNER JOIN `campus_discipline`
				ON `campus_assignment`.`discipline_id`=`campus_discipline`.`id`
				WHERE `curriculum_id`=' . $activeroster['curriculum_id'] . ' ORDER BY `display_order`';
        $result = mysql_query($query) or die(mysql_error());
        campus::display_complex_table_header($properties, array(get_lang("colheadAssignment"), get_lang("colheadTeachers"), "", get_lang("colheadReports")));
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $assignment_detail = "";
            foreach ($teacher_array[$rij['id']] as $roster_id => $teacherinfo)
            {
                $teachers = "";
                foreach ($teacherinfo as $teacher_id => $value)
                {
                    $teachers.=' ' . $value['official_code'] . ' (' . $value['houres'] . ')';
                    $rostername = $value['roster'];
                }
                $assignment_detail.=$rostername . ': ' . $teachers . '<br>';
            }
            $groups = "";
            foreach ($group_array[$rij['id']] as $group_id => $value)
            {
                $groups.=" " . $value['code'];
            }
            if ((strstr($rij['code'], $filter) != false) OR (strstr($groups, $filter) != false) OR (strstr($assignment_detail, $filter) != false) OR $filter == '')
            {
                $data = array();
                $reportslist = "";
                $reports = array();
                $data['assignment'] = '<span title="' . $rij['name'] . '">' . $rij['code'] . '</span> ' . $groups;
                $data['teachers'] = $assignment_detail;
                $data['link'] = '&nbsp;<a href="' . $this->get_url() . '&page=editreport2assignment&assignment_id=' . $rij['id'] . '&action=editreportcards&filter=' . $filter . '#' . $rij['id'] . '" title="' . get_lang("tooltipAddReport2Assignment") . '"/><img src="' . Theme::get_image_path('application\campus') . 'addreport.gif" border=0 align="absmiddle" ></a>';
                $query2 = 'SELECT `assignment_id`,`report_id`, `title`,`comment` FROM `campus_reportcard`
						INNER JOIN `campus_report`
						ON `campus_report`.`id`=`campus_reportcard`.`report_id`
					WHERE `assignment_id`=' . $rij['id'] . ' ';
                $result2 = mysql_query($query2) or die(mysql_error());
                while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                {
                    $reportslist.='<span title="' . $rij2['comment'] . '">' . $rij2['title'] . '</span><br>';
                    $reports[] = $rij2['report_id'];
                }
                if (($rij['id'] == $assignment_id) && ($action == "editreportcards"))
                {
                    $data['form'] = '<a name="' . $rij['id'] . '"></a><form method="post" action="' . $this->get_url() . '#' . $rij['id'] . '" name="frmaddreport">';
                    $data['form'].='<input type="hidden" name="page" value="editreport2assignment" >';
                    $data['form'].='<input type="hidden" name="assignment_id" value="' . $assignment_id . '" >';
                    $data['form'].='<input type="hidden" name="action" value="' . $action . '" >';
                    $data['form'].='<input type="hidden" name="filter" value="' . $filter . '" >';

                    $data['form'].='<select name="reports[]" multiple="multiple" SIZE="5" style="width:200px"/>';
                    $query2 = 'SELECT `id`,`title` FROM `campus_report` WHERE `department_id`=' . $department_id . ' AND `parent_id`=0 ORDER BY `title`';
                    $result2 = mysql_query($query2);
                    $data['form'].='<option value="0">&nbsp;</option>';
                    while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                    {
                        $data['form'].='<option value="' . $rij2['id'] . '" ' . (in_array($rij2['id'], $reports) ? 'SELECTED' : '') . '>' . $rij2['title'] . '</option>';
                    }
                    $data['form'].='</select><br>';
                    $data['form'].='<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.frmaddreport.action.value=\'list\';">';
                    $data['form'].='</form>';
                }
                else
                {
                    $data['reports'] = '<a name="' . $rij['id'] . '"></a>' . $reportslist;
                }
                campus::display_table_row($bgcolor, $data, true);
            }
        }
        campus::display_table_footer();
    }
    else
    {
        Display::normal_message(get_lang("msgNoActiveRoster"), false);
    }
}
?>