<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Theme;
use common\libraries\Display;

/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */

//check if user is allowed here...
if ((intval($_uid) == 0) || !$is_platformadmin)
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $action = campus::get_POST_GET("action");
    $submitmessage = campus::get_POST_GET("submitmessage");
    $category_id = intval(campus::get_POST_GET("category_id"));
    $tracking_category = campus::get_POST_GET("tracking_category");
    $restricted = intval(campus::get_POST_GET("restricted"));
    $display_order = campus::get_POST_GET("display_order");

    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */
    if ($submitmessage == "")
    { //_
        // de scholen ophalen waar de gebruiker deel van uitmaakt.
        switch ($action)
        {
            case "new" :
                {
                    $category_id = "";
                    $tracking_category = "";
                    $restricted = 0;
                    $display_order = 0;
                    $display = "form";
                }
                break;
            case "update" :
                {
                    // De gegevens van het bericht inlezen.
                    $query = "select `id`,`tracking_category`,`restricted`,`display_order` FROM `campus_tracking_category` WHERE `id`=" . $category_id . "";
                    $result = mysql_query($query);
                    while (list($category_id, $tracking_category, $restricted, $display_order) = mysql_fetch_row($result))
                    {
                        break;
                    }
                    $display = "form";
                }
                break;
            case "delete" :
                {
                    // het vak verwijderen.....
                    $result = mysql_query("DELETE FROM `campus_tracking_category` WHERE `id`=" . $category_id . "");
                    $message = get_lang("msgItemDeleted");
                    $display = "list";
                }
                break;
            case "moveup" :
                { // move the selected line in the form list one up
                    $query = 'SELECT * FROM `campus_tracking_category` WHERE `department_id`=' . $department_id . ' ORDER BY `display_order`, `id`';
                    $result = mysql_query($query);
                    $line = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $category_id)
                        {
                            $result2 = mysql_query('UPDATE `campus_tracking_category` SET `display_order`=' . $line . ' WHERE `department_id`=' . $department_id . ' AND `display_order`=' . ($line - 1) . ' '); //move previous down..
                            $result2 = mysql_query('UPDATE `campus_tracking_category` SET `display_order`=' . ($line - 1) . ' WHERE `id`=' . $rij['id'] . ' ');
                        }
                        else
                        {
                            $result2 = mysql_query('UPDATE `campus_tracking_category` SET `display_order`=' . $line . ' WHERE `id`=' . $rij['id'] . ' ');
                        }
                    }
                    $display = "list";
                }
                break;
            case 'movedown' :
                { // move the selected line in the form list one down
                    $query = 'SELECT * FROM `campus_tracking_category` WHERE `department_id`=' . $department_id . ' ORDER BY `display_order`,`id`';
                    $result = mysql_query($query);
                    $line = 0;
                    $moveup = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $category_id)
                        {
                            $result2 = mysql_query('UPDATE `campus_tracking_category` SET `display_order`=' . ($line + 1) . ' WHERE `id`=' . $rij['id'] . ' ');
                            $moveup = -1; //next record move 1 up
                        }
                        else
                        {
                            $result2 = mysql_query('UPDATE `campus_tracking_category` SET `display_order`=' . ($line + $moveup) . ' WHERE `id`=' . $rij['id'] . ' ');
                            $moveup = 0;
                        }
                    }
                    $display = "list";
                }
                break;
            case "import" :
                {
                    $display = "import";
                }
                break;
            default :
                {
                    $display = "list";
                }
                break;
        }
    }
    else
    {
        switch ($action)
        {
            case "new" :
                {
                    $query = 'SELECT `display_order` FROM `campus_tracking_category` WHERE `department_id`='.$department_id.'
		 						ORDER BY `display_order` DESC LIMIT 1';
                    $result = mysql_query($query);
                    list($display_order) = mysql_fetch_row($result);
                    $query = 'INSERT
				`campus_tracking_category` SET
					`tracking_category`="' . $tracking_category . '",
					`restricted`=' . $restricted . ',
					`department_id`=' . $department_id . ',
					`display_order`=' . ($display_order+1) . ' ';
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemAddError");
                        $display = "form";
                    }
                    else
                    {
                        $category_id = mysql_insert_id();
                        $message = get_lang("msgItemAddSucces");
                        $display = "list";
                    }
                }
                break;
            case "update" :
                {
                    $query = "UPDATE
				`campus_tracking_category` SET
					`tracking_category`='" . $tracking_category . "',
					`restricted`=" . $restricted . ",
					`department_id`=" . $department_id . "
					WHERE `id`='" . $category_id . "'
			";
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemEditError");
                        $display = "form";
                    }
                    else
                    {
                        $message = get_lang("msgItemEditSucces");
                        $display = "list";
                    }
                }
                break;
            case "import" :
                {
                    $row1 = campus::get_POST_GET("row1", "off");
                    if (!empty($_FILES))
                    {
                        $lines = file($_FILES['uploadfile']['tmp_name']);
                        $i = 1;
                        foreach ($lines as $key => $value)
                        {
                            if ((($row1 == 'off') && ($i == 1)) || ($i > 1))
                            {
                                $values = explode(";", $value);
                                $tracking_category = trim(addslashes($values[0]));
                                if ($tracking_category != "")
                                {
                                    $result = mysql_query("INSERT INTO `campus_tracking_category` SET
                                                        " . ((intval($values[3]) > 0) ? "`id`=" . intval($values[3]) . ", " : "") . "
								`tracking_category`='" . $tracking_category . "',
								`restricted`=" . ((trim(addslashes($values[1])) == 'on') ? "1" : "0") . ",
								`display_order`=" . intval(trim(addslashes($values[2]))) . ",
								`department_id`=" . $department_id);
                                }
                                else
                                {
                                    $result = false;
                                }
                                if (!$result)
                                {
                                    $message = get_lang("msgImportErrors");
                                }
                            }
                            $i++;
                        }
                    }
                    $display = "list";
                }
                break;
        }
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }

    switch ($display)
    {
        case "form" :
            {
// ===============================================================
// tracking type .........
// ===============================================================
                echo '<b>' . get_lang("page_studenttrackingcategory") . '</b><br>';
                echo '<form method="post" action="' . $this->get_campus_admin_url() . '" name="myform">
                        <input type="hidden" name="page" value="editstudenttrackingcategory" >
			<input type="hidden" name="category_id" value="' . $category_id . '" >
			<input type="hidden" name="action" value="' . $action . '" >
			<table>
			 <tr valign="top">
			  <td colspan="2">
			  </td>
			 </tr>
			 <tr valign="top">
			  <td  align="right">
			   ' . get_lang('labelTrackingCategory') . '
			  </td>
			  <td>
			   <input type="text" name="tracking_category" size="32" maxlength="64" value="' . $tracking_category . '" />
			   <br />
			  </td>
			 </tr>
			 <tr valign="top">
			  <td  align="right">
			   ' . get_lang('labelNormal') . '
			  </td>
			  <td>
			   <input type="radio" name="restricted" value="0" ' . (($restricted == '0') ? 'checked' : '') . ' />
			   <br />
			  </td>
			 </tr>
			 </tr>
			 <tr valign="top">
			  <td  align="right">
			   ' . get_lang('labelRestricted') . '
			  </td>
			  <td>
			   <input type="radio" name="restricted" value="1" ' . (($restricted == '1') ? 'checked' : '') . ' />
			   <br />
			  </td>
			 </tr>
			 </tr>
			 <tr valign="top">
			  <td  align="right">
			   ' . get_lang('labelStudentTrackingTag') . '
			  </td>
			  <td>
			   <input type="radio" name="restricted" value="2" ' . (($restricted == '2') ? 'checked' : '') . ' />
			   <br />
			  </td>
			 </tr>
			 <tr valign="top">
			  <td>
			  </td>
			  <td>
			   <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang("buttonlabelCancel") . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
			  </td>
			 </tr>
			</table>
		       </form>';
            }
            break;
        case "import" :
            {
                // ===============================================================
                // trackingtype importform
                // ===============================================================
                echo "<b>" . get_lang("page_importstudenttrackingcategory") . "</b><br>";
                echo '<form method="post" action="' . $this->get_campus_admin_url() . '" name="importform" enctype="multipart/form-data">
				<input type="hidden" name="page" value="editstudenttrackingcategory" >
				<input type="hidden" name="action" value="import" >
				<input type="hidden" name="MAX_FILE_SIZE" value="100000">
				<table>
				 <tr valign="top">
				  <td align="right">
				   ' . get_lang('labelDisableRow1') . '
				  </td>
				  <td >
				   <input type="checkbox" name="row1" value="on">
				  </td>
				 </tr>
				 <tr valign="top">
				  <td align="right">
				   ' . get_lang("labelSelectFile2Import") . '
				  </td>
				  <td >
				   <input type="file" name="uploadfile" >
				   <br />
				  </td>
				 </tr>
				 <tr valign="top">
				  <td>
				  </td>
				  <td >
				   <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelUpload') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.importform.action.value=\'list\';">
				  </td>
				 </tr>
				 <tr valign="top">
				  <td colspan=2>
				   <div style="color: #777777">
				    <u>' . get_lang('txtCsvImport') . '</u><br>
				    <b style="color: #444">trackingcategory</b>;<b style="color: #444">restricted</b>;<b style="color: #444">display_order</b>;ID<br>
				    <b>xxx</b>;<b>on/off</b>;<b>nnn</b>;n<br>
				    <b>xxx</b>;<b>on/off</b>;<b>nnn</b>;n<br>
				    <br><u>' . get_lang('txtCsvExample') . '</u><br>
				    <b style="color: #444">trackingcategory</b>;<b style="color: #444">restricted</b>;<b style="color: #444">display_order</b>;ID<br>
				    Beginsituatie;off;1<br>
				    Leerbegeleiding;off;2<br>
				    Schoolloopbaan;on;3<br>
				    Orde en tucht;on;4<br>
				   </div>
				  </td>
				 </tr>
			        </table>
 			       </form>';
            }
            break;
        case "list" :
            {
                // ===============================================================
                // vaklijst weergeven........
                // ===============================================================
                $query = "SELECT *
  					FROM `campus_tracking_category`
  					WHERE `department_id`=" . $department_id . " ORDER BY `display_order`";
                $result = mysql_query($query);
                echo "<div >";
                echo '<a href="' . $this->get_campus_admin_url() . '&page=editstudenttrackingcategory&action=new">' . get_lang("txtAddTrackingCategory") . '</a>&nbsp;|&nbsp;';
                echo '<a href="' . $this->get_campus_admin_url() . '&page=editstudenttrackingcategory&action=import">' . get_lang("txtImportTrackingCategory") . '</a>';
                echo "</div>";
                campus::display_complex_table_header($properties, array(get_lang("colheadTrackingCategory"), ""));
                $nbrLines = mysql_num_rows($result);
                $line = 0;
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    $line++;
                    $data = array();
                    $data[] = $rij['tracking_category'];
                    if ($line == 1)
                    {
                        $link = '<img src="' . Theme::get_image_path('application\campus') . 'up_na.gif" border=0 align="absmiddle">';
                    }
                    else
                    {
                        $link = '<a href="' . $this->get_url() . '&page=editstudenttrackingcategory&category_id=' . $rij['id'] . '&action=moveup"><img src="' . Theme::get_image_path('application\campus') . 'up.gif" border=0 align="absmiddle"></a>';
                    }
                    if ($line == $nbrLines)
                    {
                        $link.= '<img src="' . Theme::get_image_path('application\campus') . 'down_na.gif" border=0 align="absmiddle">';
                    }
                    else
                    {
                        $link.= '<a href="' . $this->get_url() . '&page=editstudenttrackingcategory&category_id=' . $rij['id'] . '&action=movedown"><img src="' . Theme::get_image_path('application\campus') . 'down.gif" border=0 align="absmiddle"></a>';
                    }
                    $data[] = '<a href="' . $this->get_campus_admin_url() . '&page=editstudenttrackingcategory&category_id=' . $rij['id'] . '&action=update" title="' . get_lang("tooltipEditTrackingCategory") . '"><img src="' . Theme::get_image_path('application\campus') . '/edit.gif" border=0 align="absmiddle" /></a>' .
                            '&nbsp;<a href="' . $this->get_campus_admin_url() . '&page=editstudenttrackingcategory&category_id=' . $rij['id'] . '&action=delete" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmDeleteTrackingCategory") . '\')) return false;" title="' . get_lang("tooltipDeleteTrackingCategory") . '"><img src="' . Theme::get_image_path('application\campus') . '/delete.gif" border=0 align="absmiddle" /></a>' . $link;
                    campus::display_table_row($bgcolor, $data, true);
                }
                campus::display_table_footer();
            }
    }
}
?>