<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Theme;
use common\libraries\Display;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['studentTrackingLevel3']) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $trackingform_id = intval(campus::get_POST_GET("trackingform_id"));
    $trackingsubform_id = intval(campus::get_POST_GET("trackingsubform_id"));
    $line_id = intval(campus::get_POST_GET("line_id"));
    $action = campus::get_POST_GET("action");
    $submitmessage = campus::get_POST_GET("submitmessage");
    $classes = campus::get_studentclasses($department_id);
    $linebegin = campus::get_POST_GET("linebegin", '', false);
    $linebegin_type = intval(campus::get_POST_GET("linebegin_type", 1));
    $linebegin_value = campus::get_POST_GET("linebegin_value", '', false);
    $linemid = campus::get_POST_GET("linemid", '', false);
    $linemid_type = intval(campus::get_POST_GET("linemid_type", 1));
    $linemid_value = campus::get_POST_GET("linemid_value", '', false);
    $lineend = campus::get_POST_GET("lineend", '', false);
    $lineend_type = intval(campus::get_POST_GET("lineend_type", 1));
    $lineend_value = campus::get_POST_GET("lineend_value", '', false);
    $newform = FALSE;

    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */

    if ($submitmessage == "")
    { //
        switch ($action)
        {
            case "newform" :
                {
                    $trackingform_id = "";
                    $subject = "";
                    $title_id = "";
                    $formstart = "";
                    $formend = "";
                    $form_type = 0; //***
                    //***$single_use="";
                    $selectclasses = array();
                    $newform = TRUE;
                    $display = "trackingform";
                }
                break;
            case "updateform" :
                {
                    // read data
                    $query = "SELECT `id`, `subject`,`title_id`, `formstart`, `formend`, `form_type`  FROM `campus_trackingform`
 						WHERE `id`=" . $trackingform_id . " "; //***
                    $result = mysql_query($query);
                    list($trackingform_id, $subject, $title_id, $formstart, $formend, $form_type) = mysql_fetch_row($result); //***
                    $query = "SELECT `group_id` FROM `campus_trackingform_rel_group`
 						WHERE `trackingform_id`=" . $trackingform_id . " ";
                    $result = mysql_query($query);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $selectclasses[] = $rij['group_id'];
                    }
                    $display = "trackingform";
                }
                break;
            case "deleteform" :
                {
                    // delete form lines
                    $result = mysql_query("DELETE FROM `campus_trackingform_line` WHERE `trackingform_id`=" . $trackingform_id);
                    // delete form rel classes....
                    $result = mysql_query("DELETE FROM `campus_trackingform_rel_group` WHERE `trackingform_id`=" . $trackingform_id);
                    // delete form subform
                    $result = mysql_query("DELETE FROM `campus_trackingform_rel_subform` WHERE `trackingform_id`=" . $trackingform_id);
                    // delete form subform
                    $result = mysql_query("DELETE FROM `campus_trackingform_rel_subform` WHERE `trackingsubform_id`=" . $trackingform_id);
                    // delete form
                    $result = mysql_query("DELETE FROM `campus_trackingform` WHERE `id`=" . $trackingform_id);
                    $message = get_lang("msgItemDeleted");
                    $display = "formlist";
                }
                break;
            case "editline" :
                {
                    if ($line_id == 0)
                    { // new form line....
                        $linebegin = "";
                        $linebegin_type = "1";
                        $linebegin_value = "";
                        $linemid = "";
                        $linemid_type = "1";
                        $linemid_value = "";
                        $lineend = "";
                        $lineend_type = "1";
                        $lineend_value = "";
                        $display = "editline";
                    }
                    else
                    {// read existing line data
                        $query = "SELECT `trackingform_id`, `linebegin`, `linebegin_type`, `linebegin_value`, `linemid`, `linemid_type`, `linemid_value`, `lineend`, `lineend_type`, `lineend_value`  FROM `campus_trackingform_line`
 							WHERE `id`=" . $line_id . " ";
                        $result = mysql_query($query);
                        list($trackingform_id, $linebegin, $linebegin_type, $linebegin_value, $linemid, $linemid_type, $linemid_value, $lineend, $lineend_type, $lineend_value) = mysql_fetch_row($result);
                        $display = "editline";
                    }
                }
                break;
            case "deleteline" :
                {
                    // delete form line
                    $result = mysql_query("DELETE FROM `campus_trackingform_line` WHERE `id`=" . $line_id);
                    $message = get_lang("msgItemDeleted");
                    $display = "linelist";
                }
                break;
            case "linelist" :
                {
                    $display = "linelist";
                }
                break;
            case "deletesubform" :
                {
                    // delete form line
                    $result = mysql_query("DELETE FROM `campus_trackingform_rel_subform` WHERE `trackingform_id`=" . $trackingform_id . " AND `trackingsubform_id`=" . $trackingsubform_id);
                    $message = get_lang("msgItemDeleted");
                    $display = "subformlist";
                }
                break;
            case "subformlist" :
                {
                    $display = "subformlist";
                }
                break;
            case "addsubform" :
                {
                    $display = "addsubform";
                }
                break;
            case "moveup" :
                { // move the selected line in the form list one up
                    $query = "SELECT * FROM `campus_trackingform_line`
		 						WHERE `trackingform_id`=" . $trackingform_id . " ORDER BY `display_order`, `id`";
                    $result = mysql_query($query);
                    $line = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $line_id)
                        {
                            $result2 = mysql_query("UPDATE `campus_trackingform_line` SET
								`display_order`=" . $line . " WHERE `trackingform_id`=" . $trackingform_id . " AND `display_order`=" . ($line - 1) . " "); //move previous down..
                            $result2 = mysql_query("UPDATE `campus_trackingform_line` SET
								`display_order`=" . ($line - 1) . " WHERE `trackingform_id`=" . $trackingform_id . " AND `id`=" . $rij['id'] . " ");
                        }
                        else
                        {
                            $result2 = mysql_query("UPDATE `campus_trackingform_line` SET
								`display_order`=" . $line . " WHERE `trackingform_id`=" . $trackingform_id . " AND `id`=" . $rij['id'] . " ");
                        }
                    }
                    $display = "linelist";
                }
                break;
            case "movedown" :
                { // move the selected line in the form list one down
                    $query = "SELECT * FROM `campus_trackingform_line`
		 						WHERE `trackingform_id`=" . $trackingform_id . " ORDER BY `display_order`, `id`";
                    $result = mysql_query($query);
                    $line = 0;
                    $moveup = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $line_id)
                        {
                            $result2 = mysql_query("UPDATE `campus_trackingform_line` SET
								`display_order`=" . ($line + 1) . " WHERE `trackingform_id`=" . $trackingform_id . " AND `id`=" . $rij['id'] . " ");
                            $moveup = -1; //next record move 1 up
                        }
                        else
                        {
                            $result2 = mysql_query("UPDATE `campus_trackingform_line` SET
								`display_order`=" . ($line + $moveup) . " WHERE `trackingform_id`=" . $trackingform_id . " AND `id`=" . $rij['id'] . " ");
                            $moveup = 0;
                        }
                    }

                    $display = "linelist";
                }
                break;
            case "moveformup" :
                { // move the selected line in the form list one up
                    $query = "SELECT * FROM `campus_trackingform` WHERE `department_id`=" . $department_id . " ORDER BY `display_order`, `id`";
                    $result = mysql_query($query);
                    $line = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $trackingform_id)
                        {
                            $result2 = mysql_query("UPDATE `campus_trackingform` SET `display_order`=" . $line . " WHERE `department_id`=" . $department_id . " AND `display_order`=" . ($line - 1) . " "); //move previous down..
                            $result2 = mysql_query("UPDATE `campus_trackingform` SET `display_order`=" . ($line - 1) . " WHERE `department_id`=" . $department_id . " AND `id`=" . $rij['id'] . " ");
                        }
                        else
                        {
                            $result2 = mysql_query("UPDATE `campus_trackingform` SET `display_order`=" . $line . " WHERE `department_id`=" . $department_id . " AND `id`=" . $rij['id'] . " ");
                        }
                    }
                    $display = "formlist";
                }
                break;
            case "moveformdown" :
                { // move the selected line in the form list one down
                    $query = "SELECT * FROM `campus_trackingform` WHERE `department_id`=" . $department_id . " ORDER BY `display_order`, `id`";
                    $result = mysql_query($query);
                    $line = 0;
                    $moveup = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $trackingform_id)
                        {
                            $result2 = mysql_query("UPDATE `campus_trackingform` SET `display_order`=" . ($line + 1) . " WHERE `department_id`=" . $department_id . " AND `id`=" . $rij['id'] . " ");
                            $moveup = -1; //next record move 1 up
                        }
                        else
                        {
                            $result2 = mysql_query("UPDATE `campus_trackingform` SET `display_order`=" . ($line + $moveup) . " WHERE `department_id`=" . $department_id . " AND `id`=" . $rij['id'] . " ");
                            $moveup = 0;
                        }
                    }

                    $display = "formlist";
                }
                break;
            case "movesubformup" :
                { // move the selected line in the form list one up
                    $query = "SELECT * FROM `campus_trackingform_rel_subform` WHERE `department_id`=" . $department_id . " ORDER BY `display_order`, `trackingsubform_id`";
                    $result = mysql_query($query);
                    $line = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['trackingsubform_id'] == $trackingsubform_id)
                        {
                            $result2 = mysql_query("UPDATE `campus_trackingform_rel_subform` SET `display_order`=" . $line . " WHERE `department_id`=" . $department_id . " AND `display_order`=" . ($line - 1) . " "); //move previous down..
                            $result2 = mysql_query("UPDATE `campus_trackingform_rel_subform` SET `display_order`=" . ($line - 1) . " WHERE `department_id`=" . $department_id . " AND `trackingsubform_id`=" . $rij['trackingsubform_id'] . " ");
                        }
                        else
                        {
                            $result2 = mysql_query("UPDATE `campus_trackingform_rel_subform` SET `display_order`=" . $line . " WHERE `department_id`=" . $department_id . " AND `trackingsubform_id`=" . $rij['trackingsubform_id'] . " ");
                        }
                    }
                    $display = "subformlist";
                }
                break;
            case "movesubformdown" :
                { // move the selected line in the form list one down
                    $query = "SELECT * FROM `campus_trackingform_rel_subform` WHERE `department_id`=" . $department_id . " ORDER BY `display_order`, `trackingsubform_id`";
                    $result = mysql_query($query);
                    $line = 0;
                    $moveup = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['trackingsubform_id'] == $trackingsubform_id)
                        {
                            $result2 = mysql_query("UPDATE `campus_trackingform_rel_subform` SET `display_order`=" . ($line + 1) . " WHERE `department_id`=" . $department_id . " AND `trackingsubform_id`=" . $rij['trackingsubform_id'] . " ");
                            $moveup = -1; //next record move 1 up
                        }
                        else
                        {
                            $result2 = mysql_query("UPDATE `campus_trackingform_rel_subform` SET `display_order`=" . ($line + $moveup) . " WHERE `department_id`=" . $department_id . " AND `trackingsubform_id`=" . $rij['trackingsubform_id'] . " ");
                            $moveup = 0;
                        }
                    }

                    $display = "subformlist";
                }
                break;
            case "lineform" :
                {
                    $display = "editline";
                }
                break;
            case "copytrackingform" :
                {
                    $trackingform_old_id = $trackingform_id;
                    // get latest form to add the new form
                    $query = "SELECT `display_order` FROM `campus_trackingform` WHERE `department_id`=" . $department_id . " ORDER BY `display_order` DESC LIMIT 1";
                    $result = mysql_query($query) or die(mysql_error());
                    list($nbrLines) = mysql_fetch_row($result);
                    //copy campus_trackingform
                    $query = "SELECT `subject`,`title_id`, `formstart`, `formend`, `form_type`  FROM `campus_trackingform`
 						WHERE `id`=" . $trackingform_old_id . " "; //***
                    $result = mysql_query($query);
                    list( $subject, $title_id, $formstart, $formend, $form_type) = mysql_fetch_row($result); //***
                    $query = "INSERT `campus_trackingform` SET
					`subject`='" . $subject . "',
					`title_id`=" . $title_id . ",
					`formstart`=" . $formstart . ",
					`formend`=" . $formend . ",
					`form_type`=" . $form_type . ",
					`department_id`=" . $department_id . ",
					`display_order`= " . ($nbrLines + 1) . "
						"; //***
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemAddError");
                        $display = "formlist";
                    }
                    else
                    {
                        $trackingform_id = mysql_insert_id();
                        // copy class selection
                        $query = "SELECT `group_id` FROM `campus_trackingform_rel_group`
 						WHERE `trackingform_id`=" . $trackingform_old_id . " ";
                        $result = mysql_query($query);
                        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                        {
                            $result2 = mysql_query("INSERT `campus_trackingform_rel_group` SET `trackingform_id`=" . $trackingform_id . ", `group_id`=" . $rij['group_id']);
                        }
                        // copy campus_trackingform_line
                        $query = "SELECT `linebegin`, `linebegin_type`, `linebegin_value`, `linemid`, `linemid_type`, `linemid_value`, `lineend`, `lineend_type`, `lineend_value`, `display_order`  FROM `campus_trackingform_line`
 							WHERE `trackingform_id`=" . $trackingform_old_id . " ";
                        $result = mysql_query($query);
                        while (list($linebegin, $linebegin_type, $linebegin_value, $linemid, $linemid_type, $linemid_value, $lineend, $lineend_type, $lineend_value, $position) = mysql_fetch_row($result))
                        {
                            $query = "INSERT
							`campus_trackingform_line` SET
							`trackingform_id`=" . $trackingform_id . ",
							`linebegin` ='" . $linebegin . "',
							`linebegin_type` ='" . $linebegin_type . "',
							`linebegin_value` ='" . $linebegin_value . "',
							`linemid` ='" . $linemid . "',
							`linemid_type` ='" . $linemid_type . "',
							`linemid_value` ='" . $linemid_value . "',
							`lineend` ='" . $lineend . "',
							`lineend_type` ='" . $lineend_type . "',
							`lineend_value` ='" . $lineend_value . "',
							`display_order`= " . $position . "
						";
                            $result2 = mysql_query($query);
                        }

                        // copy campus_trackingsubforms
                        $query = "SELECT `trackingsubform_id`, `display_order` FROM `campus_trackingform_rel_subform` WHERE `trackingform_id`=" . $trackingform_old_id . " ";
                        $result = mysql_query($query);
                        while (list($trackingsubform_id, $position) = mysql_fetch_row($result))
                        {
                            $query = "INSERT `campus_trackingform_rel_subform` SET
							`trackingform_id`=" . $trackingform_id . ",
							`trackingsubform_id`=" . $trackingsubform_id . ",
							`department_id`=" . $department_id . ",
							`display_order`= " . $position . "
						
						"; //***
                            $result2 = mysql_query($query);
                            if (!$result2)
                            {
                                $message = get_lang("msgItemAddError");
                                $display = "addsubform";
                            }
                            else
                            {
                                $message = get_lang("msgItemAddSucces");
                                $display = "subformlist";
                            }
                        }

                        $display = "formlist";
                    }
                }
                break;
            default :
                {
                    $display = "formlist";
                }
                break;
        }
    }
    else
    {

        $subject = campus::get_POST_GET("subject");
        $title_id = intval(campus::get_POST_GET("title_id"));
        $formstart = intval(strtotime(campus::get_POST_GET("formstart")));
        $formend = intval(strtotime(campus::get_POST_GET("formend")));
        $form_type = intval(campus::get_POST_GET("form_type")); //***
        //***$single_use=intval(campus::get_POST_GET("single_use"));
        $selectclasses = campus::get_POST_GET("classes");
        if (in_array("all", $selectclasses))
        {
            $selectclasses = array_keys($classes);
        }
        switch ($action)
        {
            case "newform" :
                {
                    $query = "SELECT `display_order` FROM `campus_trackingform` WHERE `department_id`=" . $department_id . " ORDER BY `display_order` DESC LIMIT 1";
                    $result = mysql_query($query);
                    intval(list($nbrLines) = mysql_fetch_row($result));
                    $query = "INSERT `campus_trackingform` SET
						`subject`='" . $subject . "',
						`title_id`=" . (($form_type == 3) ? '0' : $title_id) . ",
						`formstart`=" . $formstart . ",
						`formend`=" . $formend . ",
						`form_type`=" . $form_type . ",
						`department_id`=" . $department_id . ",
						`display_order`= " . ($nbrLines + 1) . " "; //***
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemAddError");
                        $display = "trackingform";
                    }
                    else
                    {
                        $trackingform_id = mysql_insert_id();
                        foreach ($selectclasses as $key)
                        {
                            $result = mysql_query("INSERT `campus_trackingform_rel_group` SET `trackingform_id`=" . $trackingform_id . ", `group_id`=" . $key);
                        }
                        $message = get_lang("msgItemAddSucces");
                        if ($form_type == 3)
                        {
                            $display = "subformlist";
                        }
                        else
                        {
                            $display = "linelist";
                        }
                    }
                }
                break;
            case "updateform" :
                {
                    $query = "UPDATE
						`campus_trackingform` SET
						`subject`='" . $subject . "',
						`title_id`=" . $title_id . ",
						`formstart`=" . $formstart . ",
						`formend`=" . $formend . ",
						`form_type`=" . $form_type . ",
						`department_id`=" . $department_id . "
						WHERE `id`=" . $trackingform_id . "
				"; //***
                    $result = mysql_query($query) or die(mysql_error());
                    if (!$result)
                    {
                        $message = get_lang("msgItemEditError");
                        $display = "trackingform";
                    }
                    else
                    {
                        // delete existing form rel classes....
                        $result = mysql_query("DELETE FROM `campus_trackingform_rel_group` WHERE `trackingform_id`=" . $trackingform_id);
                        //add new relations
                        foreach ($selectclasses as $key)
                        {
                            $result = mysql_query("INSERT `campus_trackingform_rel_group` SET `trackingform_id`=" . $trackingform_id . ", `group_id`=" . $key);
                        }
                        $message = get_lang("msgItemEditSucces");
                        $display = "formlist";
                    }
                }
                break;
            case "editline" :
                {
                    if ($line_id == 0)
                    { // new form line....
                        $query = "SELECT * FROM `campus_trackingform_line`
		 						WHERE `trackingform_id`=" . $trackingform_id . " ORDER BY `display_order`, `id`";
                        $result = mysql_query($query);
                        $nbrLines = mysql_num_rows($result);
                        $query = "INSERT
						`campus_trackingform_line` SET
						`trackingform_id`=" . $trackingform_id . ",
						`linebegin` ='" . $linebegin . "',
						`linebegin_type` ='" . $linebegin_type . "',
						`linebegin_value` ='" . $linebegin_value . "',
						`linemid` ='" . $linemid . "',
						`linemid_type` ='" . $linemid_type . "',
						`linemid_value` ='" . $linemid_value . "',
						`lineend` ='" . $lineend . "',
						`lineend_type` ='" . $lineend_type . "',
						`lineend_value` ='" . $lineend_value . "',
						`display_order`= " . ($nbrLines + 1) . "
					";
                        $result = mysql_query($query) or die(mysql_error());
                        if (!$result)
                        {
                            $message = get_lang("msgItemAddError");
                            $display = "editline";
                        }
                        else
                        {
                            $message = get_lang("msgItemAddSucces");
                            $display = "linelist";
                        }
                    }
                    else
                    {
                        $query = "UPDATE
						`campus_trackingform_line` SET
						`trackingform_id`=" . $trackingform_id . ",
						`linebegin` ='" . $linebegin . "',
						`linebegin_type` ='" . $linebegin_type . "',
						`linebegin_value` ='" . $linebegin_value . "',
						`linemid` ='" . $linemid . "',
						`linemid_type` ='" . $linemid_type . "',
						`linemid_value` ='" . $linemid_value . "',
						`lineend` ='" . $lineend . "',
						`lineend_type` ='" . $lineend_type . "',
						`lineend_value` ='" . $lineend_value . "'
						WHERE `id`=" . $line_id . "
					";
                        $result = mysql_query($query) or die(mysql_error());
                        if (!$result)
                        {
                            $message = get_lang("msgItemEditError");
                            $display = "editline";
                        }
                        else
                        {
                            $message = get_lang("msgItemEditSucces");
                            $display = "linelist";
                        }
                    }
                }
                break;
            case "addsubform" :
                {
                    $query = "SELECT * FROM `campus_trackingform_rel_subform`
		 						WHERE `trackingform_id`=" . $trackingform_id . " ";
                    $result = mysql_query($query);
                    $nbrLines = mysql_num_rows($result);
                    $query = "INSERT
						`campus_trackingform_rel_subform` SET
						`trackingform_id`=" . $trackingform_id . ",
						`trackingsubform_id`=" . $trackingsubform_id . ",
						`department_id`=" . $department_id . ",
						`display_order`= " . ($nbrLines + 1) . "
						
				"; //***
                    $result = mysql_query($query) or die(mysql_error());
                    if (!$result)
                    {
                        $message = get_lang("msgItemAddError");
                        $display = "addsubform";
                    }
                    else
                    {
                        $message = get_lang("msgItemAddSucces");
                        $display = "subformlist";
                    }
                }
                break;
            case "preview" :
                {
                    $display = "preview";
                }
                break;
        }
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }

    switch ($display)
    {
        case "editline" :
            {
                // ===============================================================
                // Form to add/edit line in trackingform
                // ===============================================================
                $disable = (($linebegin_type == 2) || ($linebegin_type == 4)) ? 'disabled' : '';
                echo '<b>' . get_lang('page_studenttrackingform_line') . '</b><br>';
                echo '<form method="post" action=' . $this->get_url() . ' name="myform">';
                echo '<input type="hidden" name="page" value="editstudenttrackingform" >';
                echo '<input type="hidden" name="action" value="lineform" >';
                echo '<input type="hidden" name="trackingform_id" value="' . $trackingform_id . '" >';
                echo '<input type="hidden" name="line_id" value="' . $line_id . '" >';
                echo '<table>';
                echo '<tr valign="top"><td colspan="2"><i>' . get_lang('labelFormline_begin') . '</i></td></tr>';
                echo '<tr valign="top">
					<td  align="right">
						' . get_lang('labelFormline_type') . '
					</td>
					<td>
						<select name="linebegin_type" onchange="javascript:document.myform.submit();" />
						';
                for ($value = 1; $value < 11; $value++)
                {
                    echo "<option value=\"" . $value . "\" " . (($value == $linebegin_type) ? 'SELECTED' : '') . ">" . get_lang("enumValue_forminputtype_" . $value) . "</option>";
                }
                echo "		</select>
					</td>
				</tr>";
                echo "<tr valign='top'>
					<td align='right'>
						" . get_lang('labelFormline_label_' . $linebegin_type) . "
					</td>
					<td>";
                if ($linebegin_type == 2)
                {
                    echo '	<textarea name="linebegin" cols="80" rows="4" >' . $linebegin . '</textarea>';
                }
                else
                {
                    echo '	<input type="text" name="linebegin" size="32" maxlength="64" value="' . $linebegin . '" />';
                }
                echo "	</td>
				</tr>";
                echo "<tr valign='top'>
					<td align='right'>
						" . get_lang('labelFormline_value_' . $linebegin_type) . "
					</td>
					<td>";
                if ($linebegin_type == 2)
                {
                    echo '	<textarea name="linebegin_value" cols="80" rows="4" >' . $linebegin_value . '</textarea>';
                }
                else
                {
                    echo '	<input type="text" name="linebegin_value" size="64" maxlength="255" value="' . $linebegin_value . '" />';
                }
                echo "	</td>
				</tr>";
                echo "<tr valign='top'><td colspan='2'><i>" . get_lang('labelFormline_mid') . "</i></td></tr>";
                echo "<tr valign='top'>
					<td  align='right'>
						" . get_lang('labelFormline_type') . "
					</td>
					<td>
						<select name='linemid_type' " . $disable . " onchange='javascript:document.myform.submit();'/>";
                for ($value = 1; $value < 11; $value++)
                {
                    echo "<option value=\"" . $value . "\" " . (($value == $linemid_type) ? 'SELECTED' : '') . ">" . get_lang("enumValue_forminputtype_" . $value) . "</option>";
                }
                echo '		</select>
					</td>
				</tr>';
                echo '<tr valign="top">
					<td align="right">
						' . get_lang('labelFormline_label_' . $linemid_type) . '
					</td>
					<td>
						<input type="text" name="linemid" size="32" maxlength="64" value="' . $linemid . '" ' . $disable . '/>
					</td>
				</tr>';
                echo '<tr valign="top">
					<td align="right">
						' . get_lang('labelFormline_value_' . $linemid_type) . '
					</td>
					<td>
						<input type="text" name="linemid_value" size="64" maxlength="255" value="' . $linemid_value . '" ' . $disable . '/>
					</td>
				</tr>';
                echo '<tr valign="top"><td colspan="2"><i>' . get_lang('labelFormline_end') . '</i></td></tr>';
                echo '<tr valign="top">
					<td  align="right">
						' . get_lang('labelFormline_type') . '
					</td>
					<td>
						<select name="lineend_type" ' . $disable . ' onchange="javascript:document.myform.submit();"/>';
                for ($value = 1; $value < 11; $value++)
                {
                    echo '<option value="' . $value . '" ' . (($value == $lineend_type) ? 'SELECTED' : '') . '>' . get_lang('enumValue_forminputtype_' . $value) . '</option>';
                }
                echo '</select>
					</td>
				</tr>';
                echo '<tr valign="top">
					<td align="right">
						' . get_lang('labelFormline_label_' . $lineend_type) . '
					</td>
					<td>
						<input type="text" name="lineend" size="32" maxlength="64" value="' . $lineend . '" ' . $disable . '/>
					</td>
				</tr>';
                echo '<tr valign="top">
					<td align="right">
						' . get_lang('labelFormline_value_' . $lineend_type) . '
					</td>
					<td>
						<input type="text" name="lineend_value" size="64" maxlength="255" value="' . $lineend_value . '" ' . $disable . '/>
					</td>
				</tr>';
                echo '<tr valign="top">
					<td>
					</td>
					<td colspan="2">
						<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" OnmouseDown="javascript:document.myform.action.value=\'editline\';" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'linelist\';">
					</td>
				</tr>';
                echo '</table></form>';
            }
            break;
        case 'trackingform' :
            {
                // ===============================================================
                // H........
                // ===============================================================
                echo "<b>" . get_lang("page_studenttrackingform") . "</b><br>";
                $sql = "SELECT `campus_tracking_title`.`id`,`tracking_category`,`tracking_title` FROM `campus_tracking_title`
						INNER JOIN `campus_tracking_category`
							ON `campus_tracking_title`.`category_id`=`campus_tracking_category`.`id`
			  			 WHERE `department_id`=" . $department_id . " ORDER BY `campus_tracking_category`.`display_order`, `campus_tracking_title`.`display_order`";
                $result = mysql_query($sql);
                if (mysql_num_rows($result) > 0)
                {
                    echo '<form method="post" action="' . $this->get_url() . '" name="myform">
					<input type="hidden" name="page" value="editstudenttrackingform" >
					<input type="hidden" name="action" value="' . $action . '" >
					<input type="hidden" name="trackingform_id" value="' . $trackingform_id . '" >
					 <table>
					  <tr valign="top">
					   <td colspan="2">
					   </td>
					  </tr>
					  <tr valign="top">
					   <td align="right">
					    ' . get_lang('labelStudenttrackingFormSubject') . '
					   </td>
					   <td>
					    <input type="text" name="subject" size="12"  value="' . $subject . '" />
					   </td>
					  </tr>';
                    if ($newform || ($form_type != 3))
                    {
                        echo '<tr valign="top">
					   <td  align="right">
					    ' . get_lang('labelSelectTrackingTitle') . '
					   </td>
					   <td>
					    <select name="title_id" />';
                        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                        {
                            echo "<option value=\"" . $rij['id'] . "\" " . (($rij['id'] == $title_id) ? 'SELECTED' : '') . ">" . $rij['tracking_category'] . " &rArr; " . $rij['tracking_title'] . "</option>";
                        }
                        echo '	   </select>
					  </td>
					 </tr>';
                    }
                    echo ' <tr valign="top">
					  <td align="right">
					   ' . get_lang('labelStartDate') . '
					  </td>
	 				  <td>
					   <input type="text" name="formstart" size="10"  value="' . (($formstart == 0) ? '' : DatetimeUtilities::format_locale_date('%Y-%m-%d', $formstart)) . '" />(yyyy-mm-dd)
					  </td>
					 </tr>
					 <tr valign="top">
					  <td align="right">
					   ' . get_lang("labelEndDate") . '
					  </td>
					  <td>
					   <input type="text" name="formend" size="10"  value="' . (($formend == 0) ? '' : DatetimeUtilities::format_locale_date('%Y-%m-%d', $formend)) . '" />(yyyy-mm-dd)
					  </td>
					 </tr>';
                    if ($newform || ($form_type != 3))
                    {
                        echo '
					 <tr valign="top">
					  <td  align="right">
					   ' . get_lang('labelNormalForm') . '
					  </td>
					  <td>
					   <input type="radio" name="form_type" value="0" ' . (($form_type == '0') ? 'checked' : '') . '>';
                        if ($newform)
                        {
                            echo '&nbsp;&nbsp;&nbsp;&nbsp;' . get_lang('labelCombinedForm') . '
						   <input type="radio" name="form_type" value="3" ' . (($form_type == '3') ? 'checked' : '') . '>';
                        }
                        echo '
					   <br />
					  </td>
					 </tr>
					 <tr valign="top">
					  <td  align="right">
					  ' . get_lang('labelStudentForm') . '
					  </td>
					  <td>
					   <input type="radio" name="form_type" value="1" ' . (($form_type == '1') ? 'checked' : '') . '>&nbsp;&nbsp;&nbsp;&nbsp;
					   ' . get_lang('labelSingleUse') . '
					   <input type="radio" name="form_type" value="2" ' . (($form_type == '2') ? 'checked' : '') . '>
					   <br />
					  </td>
					 </tr>';
                    }
                    else
                    {
                        echo '<input type="hidden" name="form_type" value="' . $form_type . '">';
                    }
                    echo '
					 <tr valign="top">
					  <td align="right">
					   ' . get_lang('labelSelectClasses') . '
					  </td>
					  <td>
					   <select name="classes[]" multiple="multiple" SIZE="5">';
                    foreach ($selectclasses as $id)
                    {
                        echo "<option value=\"" . $id . "\" SELECTED>" . $classes[$id]['code'] . "</option>";
                    }
                    echo "<option value=\"all\">" . get_lang("txtAllClasses") . "</option>";
                    foreach ($classes as $key => $value)
                    {
                        if (!in_array($key, $selectclasses))
                        {
                            echo ("<option value=\"" . $key . "\">" . $classes[$key]['code'] . "</OPTION>");
                        }
                    }
                    echo '     </select>
					  </td>
					 </tr>
					 <tr valign="top">
					  <td>
					  </td>
					  <td colspan="2">
					   <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'\';">
					  </td>
					 </tr>
					</table>
					</form>';
                }
                else
                {
                    Display::error_message(get_lang("msgNoStudenttrackingTitlesDefined"), false);
                }
            }
            break;
        case 'addsubform' :
            {
                // ===============================================================
                // H........
                // ===============================================================
                echo "<b>" . get_lang("page_addsubtrackingform") . "</b><br>";
                $sql = "SELECT DISTINCT `subject`,`campus_trackingform`.`id`, `trackingsubform_id` FROM `campus_trackingform`
						LEFT JOIN `campus_trackingform_rel_subform`
							ON `campus_trackingform`.`id`=`campus_trackingform_rel_subform`.`trackingsubform_id` AND `campus_trackingform_rel_subform`.`trackingform_id`=" . $trackingform_id . "
			  			 WHERE `campus_trackingform`.`department_id`=" . $department_id . " AND `form_type`=0 AND `trackingsubform_id` is NULL ORDER BY `campus_trackingform`.`display_order`";
                $result = mysql_query($sql) or die(mysql_error());
                if (mysql_num_rows($result) > 0)
                {
                    echo '<form method="post" action="' . $this->get_url() . '" name="myform">
					<input type="hidden" name="page" value="editstudenttrackingform" >
					<input type="hidden" name="action" value="' . $action . '" >
					<input type="hidden" name="trackingform_id" value="' . $trackingform_id . '" >
					 <table>
					  <tr valign="top">
					   <td colspan="2">
					   </td>
					  </tr>
					  <tr valign="top">
					   <td align="right">
					    ' . get_lang('labelSelectForm') . '
					   </td>
					   <td>
					    <select name="trackingsubform_id" />';
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        echo "<option value=\"" . $rij['id'] . "\">" . $rij['subject'] . "</option>";
                    }
                    echo '	   </select>
					  </td>
					 </tr>
					 <tr valign="top">
					  <td>
					  </td>
					  <td colspan="2">
					   <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'subformlist\';">
					  </td>
					 </tr>
					</table>
					</form>';
                }
                else
                {
                    Display::error_message(get_lang("msgNoTrackingformsDefined"), false);
                }
            }
            break;
        case "formlist" :
            {
                // ===============================================================
                // show trackingform list
                // ===============================================================
                $form_type=array(0=>'labelNormalForm',1=>'labelStudentForm',2=>'labelStudentForm',3=>'labelCombinedForm');

                $query = "SELECT `subject`,`tracking_title`, `tracking_category`, `formstart`, `formend`, `campus_trackingform`.`id`, `form_type`, `campus_trackingform`.`display_order` FROM `campus_trackingform`
							LEFT JOIN `campus_tracking_title` ON `campus_tracking_title`.`id`= `campus_trackingform`.`title_id`
							LEFT JOIN `campus_tracking_category` ON `campus_tracking_category`.`id`=`campus_tracking_title`.`category_id`
 						WHERE `campus_trackingform`.`department_id`=" . $department_id . " ORDER BY `campus_trackingform`.`display_order`, `subject`";
                $result = mysql_query($query) or die(mysql_error());
                echo "<div style=\"float:right;\">";
                echo "&nbsp;";
                echo "</div>";
                echo "<div >";
                echo "<a href=\"" . $this->get_url() . "&page=editstudenttrackingform&action=newform\">" . get_lang("txtAddStudenttrackingform") . "</a>&nbsp;";
                echo "</div>";
                campus::display_complex_table_header($properties, array(get_lang("colheadTitle"), get_lang("colheadTrackingForm"), get_lang("colheadStartTiming"), get_lang("colheadEndTiming"), get_lang("colheadClasses"), ""));
                $nbrLines = mysql_num_rows($result);
                $line = 0;
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    $line++;
                    $data = array();
                    //$teachers_array=campus::get_roster2teachers ($rij['roster_id']);
                    $data['subject'] = $rij['subject'];
                    $data['title'] = '<b>'. get_lang($form_type[$rij['form_type']]).':</b> '.(($rij['form_type'] == 3) ? '' : ($rij['tracking_category'] . " &rArr; " . $rij['tracking_title']));
                    $data['formstart'] = ($rij['formstart'] == 0) ? '-' : DatetimeUtilities::format_locale_date('%Y-%m-%d', $rij['formstart']);
                    $data['formend'] = ($rij['formend'] == 0) ? '-' : DatetimeUtilities::format_locale_date('%Y-%m-%d', $rij['formend']);
                    $data['classes'] = "";
                    $query2 = "select `group_id` FROM `campus_trackingform_rel_group` WHERE `trackingform_id`=" . $rij['id'] . " ";
                    $result2 = mysql_query($query2);
                    while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                    {
                        $data['classes'].=$classes[$rij2['group_id']]['code'] . " ";
                    }
                    if ($rij['form_type'] == 3)
                    {
                        $link = '<a href="' . $this->get_url() . '&page=editstudenttrackingform&trackingform_id=' . $rij['id'] . '&action=subformlist" title="' . get_lang("tooltipShowTrackingFormDetails") . '"><img src="' . Theme :: get_common_image_path() .  'action_build.png" border=0 align="absmiddle" /></a>&nbsp;';
                    }
                    else
                    {
                        $link = '<a href="' . $this->get_url() . '&page=editstudenttrackingform&trackingform_id=' . $rij['id'] . '&action=linelist" title="' . get_lang("tooltipShowTrackingFormDetails") . '"><img src="' . Theme :: get_common_image_path() .  'action_build.png" border=0 align="absmiddle" /></a>&nbsp;';
                    }
                    if ($line == 1)
                    {
                        $link .= '<img src="' . Theme::get_image_path('application\campus') . 'up_na.gif" border=0 align="absmiddle">';
                    }
                    else
                    {
                        $link .= '<a href="' . $this->get_url() . '&page=editstudenttrackingform&trackingform_id=' . $rij['id'] . '&action=moveformup"><img src="' . Theme::get_image_path('application\campus') . 'up.gif" border=0 align="absmiddle"></a>';
                    }
                    if ($line == $nbrLines)
                    {
                        $link.= '<img src="' . Theme::get_image_path('application\campus') . 'down_na.gif" border=0 align="absmiddle">';
                    }
                    else
                    {
                        $link.= '<a href="' . $this->get_url() . '&page=editstudenttrackingform&trackingform_id=' . $rij['id'] . '&action=moveformdown"><img src="' . Theme::get_image_path('application\campus') . 'down.gif" border=0 align="absmiddle"></a>';
                    }
                    $data['link'] = '<pre><a href="' . $this->get_url() . '&page=editstudenttrackingform&trackingform_id=' . $rij['id'] . '&action=updateform" title="' . get_lang("tooltipEditTrackingForm") . '"><img src="' . Theme :: get_common_image_path() . 'action_edit.png" border=0 align="absmiddle" /></a>&nbsp;' .
                            '<a href="' . $this->get_url() . '&page=editstudenttrackingform&trackingform_id=' . $rij['id'] . '&action=copytrackingform" title="' . get_lang('tooltipCopyTrackingForm') . '"><img src="' .Theme :: get_common_image_path() .  'action_reuse.png" border=0 align="absmiddle" /></a>&nbsp;' .
                            $link .
                            '<a href="' . $this->get_url() . '&page=editstudenttrackingform&trackingform_id=' . $rij['id'] . '&action=deleteform" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmDeleteTrackingForm") . '\')) return false;" title="' . get_lang("tooltipDeleteTrackingForm") . '"><img src="' . Theme :: get_common_image_path() . 'action_delete.png" border=0 align="absmiddle" /></a>' .
                             '</pre>';
                    campus::display_table_row($bgcolor, $data, true);
                }
                campus::display_table_footer();
            }
            break;
        case "subformlist" :
            {
                // ===============================================================
                // show trackingform list
                // ===============================================================
                $query = "SELECT * FROM `campus_trackingform_rel_subform`
						INNER JOIN `campus_trackingform`
							ON `campus_trackingform`.`id`=`campus_trackingform_rel_subform`.`trackingsubform_id`
                                                LEFT JOIN `campus_tracking_title` ON `campus_tracking_title`.`id`= `campus_trackingform`.`title_id`
						LEFT JOIN `campus_tracking_category` ON `campus_tracking_category`.`id`=`campus_tracking_title`.`category_id`
 		  			 WHERE `campus_trackingform_rel_subform`.`trackingform_id`=" . $trackingform_id . " ORDER BY `campus_trackingform_rel_subform`.`display_order`";
                $result = mysql_query($query);
                echo "<div style=\"float:right;\">";
                echo "&nbsp;";
                echo "<a href=\"" . $this->get_url() . "&page=editstudenttrackingform\">" . get_lang("page_editstudenttrackingform") . "</a>&nbsp;";
                echo "</div>";
                echo "<div >";
                echo "<a href=\"" . $this->get_url() . "&page=editstudenttrackingform&action=addsubform&trackingform_id=" . $trackingform_id . "\">" . get_lang("txtAddStudenttrackingform_subform") . "</a>&nbsp;";
                echo "</div>";
                campus::display_complex_table_header($properties, array(get_lang("colheadSubject"), get_lang("colheadTrackingTitle"), get_lang("colheadStartTiming"), get_lang("colheadEndTiming"), get_lang("colheadClasses"), ""));
                $nbrLines = mysql_num_rows($result);
                $line = 0;
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    $line++;
                    $data = array();
                    //$teachers_array=campus::get_roster2teachers ($rij['roster_id']);
                    $data['subject'] = $rij['subject'];
                    $data['title'] = $rij['tracking_category'] . " &rArr; " . $rij['tracking_title'];
                    $data['formstart'] = ($rij['formstart'] == 0) ? '-' : DatetimeUtilities::format_locale_date('%Y-%m-%d', $rij['formstart']);
                    $data['formend'] = ($rij['formend'] == 0) ? '-' : DatetimeUtilities::format_locale_date('%Y-%m-%d', $rij['formend']);
                    $data['classes'] = "";
                    $query2 = "select `group_id` FROM `campus_trackingform_rel_group`
								WHERE `trackingform_id`=" . $rij['trackingsubform_id'] . " ";
                    $result2 = mysql_query($query2);
                    while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                    {
                        $data['classes'].=$classes[$rij2['group_id']]['code'] . " ";
                    }
                    if ($line == 1)
                    {
                        $link = "<img src=\"" . Theme::get_image_path('application\campus') . "up_na.gif\" border=0 align=\"absmiddle\">";
                    }
                    else
                    {
                        $link = "<a href=\"" . $this->get_url() . "&page=editstudenttrackingform&trackingform_id=" . $trackingform_id . "&trackingsubform_id=" . $rij['trackingsubform_id'] . "&action=movesubformup\"><img src=\"" . Theme::get_image_path('application\campus') . "up.gif\" border=0 align=\"absmiddle\"></a>";
                    }
                    if ($line == $nbrLines)
                    {
                        $link.= "<img src=\"" . Theme::get_image_path('application\campus') . "down_na.gif\" border=0 align=\"absmiddle\">";
                    }
                    else
                    {
                        $link.= "<a href=\"" . $this->get_url() . "&page=editstudenttrackingform&trackingform_id=" . $trackingform_id . "&trackingsubform_id=" . $rij['trackingsubform_id'] . "&action=movesubformdown\"><img src=\"" . Theme::get_image_path('application\campus') . "down.gif\" border=0 align=\"absmiddle\"></a>";
                    }

                    $data['link'] = "<pre><a href=\"" . $this->get_url() . "&page=editstudenttrackingform&trackingform_id=" . $trackingform_id . "&trackingsubform_id=" . $rij['trackingsubform_id'] . "&action=deletesubform\" title='" . get_lang("tooltipRemoveTrackingForm") . "'><img src=\"" . Theme::get_image_path('application\campus') . "delete.gif\" border=0 align=\"absmiddle\" /></a>" .
                            $link . "</pre>";
                    campus::display_table_row($bgcolor, $data, true);
                }
                campus::display_table_footer();
            }
            break;
        case "linelist" :
            {
                // ===============================================================
                // show trackingform list
                // ===============================================================
                $query = "SELECT * FROM `campus_trackingform_line` WHERE `trackingform_id`=" . $trackingform_id . " ORDER BY `display_order`, `id`";
                $result = mysql_query($query);
                echo "<div style=\"float:right;\">";
                echo "&nbsp;";
                echo "<a href=\"" . $this->get_url() . "&page=editstudenttrackingform\">" . get_lang("page_editstudenttrackingform") . "</a>&nbsp;";
                echo "</div>";
                echo "<div >";
                echo "<a href=\"" . $this->get_url() . "&page=editstudenttrackingform&action=editline&trackingform_id=" . $trackingform_id . "\">" . get_lang("txtAddStudenttrackingform_line") . "</a>&nbsp;";
                echo "</div>";
                echo '<form method="post" action="' . $this->get_url() . '" name="myform">
				<input type="hidden" name="page" value="editstudenttrackingform" >
				<input type="hidden" name="action" value="preview" >
				<input type="hidden" name="trackingform_id" value="' . $trackingform_id . '" >
				<table>';
                $nbrLines = mysql_num_rows($result);
                $line = 0;
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    $line++;
                    echo "<tr><td>";
                    campus::display_inlineform($rij['linebegin'], $rij['linebegin_type'], $rij['linebegin_value'], 'begin_' . $line, $line);
                    if (($rij['linebegin_type'] != 'textarea') && ($rij['linebegin_type'] != 'mtext'))
                    {
                        echo " ";
                        campus::display_inlineform($rij['linemid'], $rij['linemid_type'], $rij['linemid_value'], 'mid_' . $line, $line);
                        echo " ";
                        campus::display_inlineform($rij['lineend'], $rij['lineend_type'], $rij['lineend_value'], 'end_' . $line, $line);
                    }
                    echo "</td><td>";
                    echo "<a href=\"" . $this->get_url() . "&page=editstudenttrackingform&trackingform_id=" . $trackingform_id . "&line_id=" . $rij['id'] . "&action=editline\"><img src=\"" . Theme::get_image_path('application\campus') . "edit.gif\" border=0 align=\"absmiddle\"></a>" .
                    "&nbsp;<a href=\"" . $this->get_url() . "&page=editstudenttrackingform&trackingform_id=" . $trackingform_id . "&line_id=" . $rij['id'] . "&action=deleteline\" onclick=\"javascript:if(!confirm('" . get_lang("msgboxConfirmDeleteFormLine") . "')) return false;\"><img src=\"" . Theme::get_image_path('application\campus') . "delete.gif\" border=0 align=\"absmiddle\" /></a>";
                    if ($line == 1)
                    {
                        echo "<img src=\"" . Theme::get_image_path('application\campus') . "up_na.gif\" border=0 align=\"absmiddle\">";
                    }
                    else
                    {
                        echo "<a href=\"" . $this->get_url() . "&page=editstudenttrackingform&trackingform_id=" . $trackingform_id . "&line_id=" . $rij['id'] . "&action=moveup\"><img src=\"" . Theme::get_image_path('application\campus') . "up.gif\" border=0 align=\"absmiddle\"></a>";
                    }
                    if ($line == $nbrLines)
                    {
                        echo "<img src=\"" . Theme::get_image_path('application\campus') . "down_na.gif\" border=0 align=\"absmiddle\">";
                    }
                    else
                    {
                        echo "<a href=\"" . $this->get_url() . "&page=editstudenttrackingform&trackingform_id=" . $trackingform_id . "&line_id=" . $rij['id'] . "&action=movedown\"><img src=\"" . Theme::get_image_path('application\campus') . "down.gif\" border=0 align=\"absmiddle\"></a>";
                    }
                    echo '</td></tr>';
                }
                echo '</table>';
                echo '<input type="hidden" name="lines" value="' . $line . '">';
                if ($line > 0)
                {
                    echo '<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelPreview') . '" >';
                }
                echo "</form>";
            }
            break;
        case "preview" :
            {
                echo "<div style=\"float:right;\">";
                echo "&nbsp;";
                echo "<a href=\"" . $this->get_url() . "&page=editstudenttrackingform&trackingform_id=" . $trackingform_id . "&action=linelist\">" . get_lang("txtStudentTrackingForm_lines") . "</a>&nbsp;";
                echo "</div>";
                echo "<div >";
                echo "&nbsp;";
                echo "</div>";
                $data = "";
                for ($line = 1; $line <= campus::get_POST_GET("lines"); $line++)
                {
                    $begin = is_array(campus::get_POST_GET('begin_' . $line, '', false)) ? implode(", ", campus::get_POST_GET('begin_' . $line, '', false)) : campus::get_POST_GET('begin_' . $line, '', false);
                    $mid = is_array(campus::get_POST_GET('mid_' . $line, '', false)) ? implode(", ", campus::get_POST_GET('mid_' . $line, '', false)) : campus::get_POST_GET('mid_' . $line, '', false);
                    $end = is_array(campus::get_POST_GET('end_' . $line, '', false)) ? implode(", ", campus::get_POST_GET('end_' . $line, '', false)) : campus::get_POST_GET('end_' . $line, '', false);
                    $data.=$begin . " " . $mid . " " . $end . "\n";
                }
                echo "<pre>" . wordwrap($data, 90) . "</pre>";
            }
            break;
        case "terug" :
            {
                echo "<div><p><a href=\"" . $this->get_url() . "&page=editroster&action=list\">" . get_lang("txtBack2RosterList") . "</a></p></div>";
            }
            break;
    }
}
?>
