<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Theme;
use common\libraries\Display;

/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['studentTrackingLevel3']) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $action = campus::get_POST_GET("action");
    $submitmessage = campus::get_POST_GET("submitmessage");
    $title_id = intval(campus::get_POST_GET("title_id"));
    $category_id = intval(campus::get_POST_GET("category_id"));
    $tracking_title = campus::get_POST_GET("tracking_title");
    $display_order = campus::get_POST_GET("display_order");
    $silent_tracking = intval(campus::get_POST_GET("silent_tracking"));

    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */
    if ($submitmessage == "")
    { //
        // de scholen ophalen waar de gebruiker deel van uitmaakt.
        switch ($action)
        {
            case "new" :
                {
                    $title_id = "";
                    $category_id = "";
                    $tracking_title = "";
                    $silent_tracking = 0;
                    $display_order = "";
                    $display = "form";
                }
                break;
            case "update" :
                {
                    // De gegevens van het bericht inlezen.
                    $query = "select `id`,`category_id`,`tracking_title`,`display_order`,`silent_tracking` FROM `campus_tracking_title` WHERE `id`=" . $title_id . "";
                    $result = mysql_query($query);
                    while (list($title_id, $category_id, $tracking_title, $display_order, $silent_tracking) = mysql_fetch_row($result))
                    {
                        break;
                    }
                    $display = "form";
                }
                break;
           case "moveup" :
                { // move the selected line in the form list one up
                    $query = 'SELECT * FROM `campus_tracking_title` WHERE `category_id`=' . $category_id . ' ORDER BY `display_order`, `id`';
                    $result = mysql_query($query) or die (mysql_error());
                    $line = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $title_id)
                        {
                            $result2 = mysql_query('UPDATE `campus_tracking_title` SET `display_order`=' . $line . ' WHERE `category_id`=' . $category_id . ' AND `display_order`=' . ($line - 1) . ' '); //move previous down..
                            $result2 = mysql_query('UPDATE `campus_tracking_title` SET `display_order`=' . ($line - 1) . ' WHERE `id`=' . $rij['id'] . ' ');
                        }
                        else
                        {
                            $result2 = mysql_query('UPDATE `campus_tracking_title` SET `display_order`=' . $line . ' WHERE `id`=' . $rij['id'] . ' ');
                        }
                    }
                    $display = "list";
                }
                break;
            case 'movedown' :
                { // move the selected line in the form list one down
                    $query = 'SELECT * FROM `campus_tracking_title` WHERE `category_id`=' . $category_id . ' ORDER BY `display_order`,`id`';
                    $result = mysql_query($query);
                    $line = 0;
                    $moveup = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        if ($rij['id'] == $title_id)
                        {
                            $result2 = mysql_query('UPDATE `campus_tracking_title` SET `display_order`=' . ($line + 1) . ' WHERE `id`=' . $rij['id'] . ' ');
                            $moveup = -1; //next record move 1 up
                        }
                        else
                        {
                            $result2 = mysql_query('UPDATE `campus_tracking_title` SET `display_order`=' . ($line + $moveup) . ' WHERE `id`=' . $rij['id'] . ' ');
                            $moveup = 0;
                        }
                    }
                    $display = "list";
                }
                break;
            case "import" :
                {
                    $display = "import";
                }
                break;
            case "delete" :
                {
                    // het vak verwijderen.....
                    $result = mysql_query("DELETE FROM `campus_tracking_title` WHERE `id`=" . $title_id . "");
                    $message = get_lang("msgItemDeleted");
                    $display = "list";
                }
                break;
            default :
                {
                    $display = "list";
                }
                break;
        }
    }
    else
    {
        switch ($action)
        {
            case "new" :
                {
                    $query = "INSERT
				    `campus_tracking_title` SET
					`category_id`='" . $category_id . "',
					`tracking_title`='" . $tracking_title . "',
					`display_order`='" . $display_order . "',
					`silent_tracking`=" . $silent_tracking . "
			";
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemAddError");
                        $display = "form";
                    }
                    else
                    {
                        $category_id = mysql_insert_id();
                        $message = get_lang("msgItemAddSucces");
                        $display = "list";
                    }
                }
                break;
            case "update" :
                {
                    $query = "UPDATE
				`campus_tracking_title` SET
					`category_id`='" . $category_id . "',
					`tracking_title`='" . $tracking_title . "',
					`display_order`='" . $display_order . "',
					`silent_tracking`=" . $silent_tracking . "
					WHERE `id`=" . $title_id . "
			";
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgItemEditError");
                        $display = "form";
                    }
                    else
                    {
                        $message = get_lang("msgItemEditSucces");
                        $display = "list";
                    }
                }
                break;
            case "import" :
                {
                    $row1 = campus::get_POST_GET("row1", "off");
                    if (!empty($_FILES))
                    {
                        $lines = file($_FILES['uploadfile']['tmp_name']);
                        $i = 1;
                        foreach ($lines as $key => $value)
                        {
                            if ((($row1 == 'off') && ($i == 1)) || ($i > 1))
                            {
                                $values = explode(";", $value);
                                $tracking_title = trim(addslashes($values[1]));
                                if ($tracking_title != "")
                                {
                                    $result = mysql_query("INSERT INTO `campus_tracking_title` SET
                                                        " . (($values[4] > 0) ? "`id`=" . intval($values[4]) . ", " : "") . "
                                                                `category_id`=" . intval($values[0]) . ",
								`tracking_title`='" . $tracking_title . "',
								`display_order`=" . intval($values[2]) . ",
								`silent_tracking`=" . ((trim($values[3]) == 'on') ? "1" : "0") . " ");
                                }
                                else
                                {
                                    $result = false;
                                }
                                if (!$result)
                                {
                                    $message = get_lang("msgImportErrors");
                                }
                            }
                            $i++;
                        }
                    }
                    $display = "list";
                }
                break;
        }
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }

    $trackingcategorys = campus::get_trackingcategorys($department_id);

    switch ($display)
    {
        case "form" :
            {
// ===============================================================
// tracking type .........
// ===============================================================
                echo "<b>" . get_lang("page_studenttrackingtitle") . "</b><br>";
                echo '<form method="post" action="' . $this->get_campus_admin_url() . '" name="myform">';
                echo '<input type="hidden" name="page" value="editstudenttrackingtitle" >';
                echo '<input type="hidden" name="title_id" value="' . $title_id . '" >';
                echo '<input type="hidden" name="action" value="' . $action . '" >';
                echo '<input type="hidden" name="display_order" value="' . $display_order . '" >';
            echo '<table>
			<tr valign="top">
			 <td colspan="2">
			 </td>
			</tr>
			<tr valign="top">
			 <td  align="right">
			  ' . get_lang('labelTrackingTitle') . '
			 </td>
			 <td>
			  <input type="text" name="tracking_title" size="32" maxlength="64" value="' . $tracking_title . '" />
			  <br />
			 </td>
			</tr>
			<tr valign="top">
			 <td  align="right">
			  ' . get_lang('labelTrackingCategory') . '
			 </td>
			 <td>
			  <select name="category_id" />';
                foreach ($trackingcategorys as $key => $value)
                {
                    echo '<option value="' . $key . '" ' . (($key == $category_id) ? 'SELECTED' : '') . '>' . $value['name'] . '</option>';
                }
                echo'	  </select>
			 </td>
			</tr>
				<tr valign="top">
			 <td  align="right">
			  ' . get_lang('labelSilentTracking') . '
			 </td>
			 <td>
			  <input type="checkbox" name="silent_tracking" value="1" ' . (($silent_tracking == '1') ? "checked" : "") . '>
			  <br />
			 </td>
			</tr>
			<tr valign="top">
			 <td>
			 </td>
			 <td>
			  <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
			 </td>
			</tr>
		      </table>
		     </form>';
            }
            break;
        case "import" :
            {
                // ===============================================================
                // trackingtype importform
                // ===============================================================
                 echo "<b>" . get_lang("page_studenttrackingtitle") . "</b><br>";
                echo '<form method="post" action="' . $this->get_campus_admin_url() . '" name="importform" enctype="multipart/form-data">
				<input type="hidden" name="page" value="editstudenttrackingtitle" >
				<input type="hidden" name="action" value="import" >
				<input type="hidden" name="MAX_FILE_SIZE" value="100000">
				<table>
				 <tr valign="top">
				  <td align="right">
				   ' . get_lang('labelDisableRow1') . '
				  </td>
				  <td >
				   <input type="checkbox" name="row1" value="on">
				  </td>
				 </tr>
				 <tr valign="top">
				  <td align="right">
				   ' . get_lang("labelSelectFile2Import") . '
				  </td>
				  <td >
				   <input type="file" name="uploadfile" >
				   <br />
				  </td>
				 </tr>
				 <tr valign="top">
				  <td>
				  </td>
				  <td >
				   <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelUpload') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.importform.action.value=\'list\';">
				  </td>
				 </tr>
				 <tr valign="top">
				  <td colspan=2>
				   <div style="color: #777777">
				    <u>' . get_lang('txtCsvImport') . '</u><br>
				    <b style="color: #444">trackingcategory_id</b>;<b style="color: #444">title</b>;<b style="color: #444">display order</b>;<b style="color: #444">silent tracking</b>;ID<br>
				    <b>nnn</b>;<b>xxx</b>;<b>nnn</b>;<b>on/off</b>;n<br>
				    <b>nnn</b>;<b>xxx</b>;<b>nnn</b>;<b>on/off</b>;n<br>
				    <br><u>' . get_lang('txtCsvExample') . '</u><br>
				    <b style="color: #444">trackingcategory_id</b>;<b style="color: #444">title</b>;<b style="color: #444">display order</b>;<b style="color: #444">silent tracking</b>;ID<br>
				    1;Klassenraden;1;off<br>
				    1;Leerbegeleiding;2;off<br>
				    2;Klassenraden;1;off<br>
				    Schoolloopbaan;on;3<br>
                                    3;Klassenraden;1;off<br>
				    4;Klassenraden;1;off<br>
				   </div>
				  </td>
				 </tr>
			        </table>
 			       </form>';
            }
            break;
        case "list" :
            {
                // ===============================================================
                // vaklijst weergeven........
                // ===============================================================
                /*$query = "SELECT `id`, `campus_tracking_title`.`display_order`, `tracking_category`, `tracking_title`
  					FROM `campus_tracking_title`
						INNER JOIN `campus_tracking_category`
							ON `campus_tracking_title`.`category_id`=`campus_tracking_category`.`id`
  					WHERE `department_id`=" . $department_id . " ORDER BY `campus_tracking_category`.`display_order`,`campus_tracking_title`.`display_order`";
                $result = mysql_query($query);*/
                echo "<div >";
                echo "<a href=\"" . $this->get_campus_admin_url() . "&page=editstudenttrackingtitle&action=new\">" . get_lang("txtAddTrackingTitle") . "</a>&nbsp;|&nbsp;";
                echo '<a href="' . $this->get_campus_admin_url() . '&page=editstudenttrackingtitle&action=import">' . get_lang("txtImportTrackingTitle") . '</a>';
                echo "</div>";
                campus::display_complex_table_header($properties, array(get_lang("colheadOrder"), get_lang("colheadTrackingCategory"), get_lang("colheadTrackingTitle"), ""));
                $query1 = 'SELECT `id`, `tracking_category` FROM `campus_tracking_category`
  					WHERE `department_id`=' . $department_id . ' ORDER BY `display_order`';
                $result1 = mysql_query($query1);
                while ($rij1 = mysql_fetch_array($result1, MYSQL_ASSOC))
                {
                    $query = 'SELECT `id`, `category_id`, `tracking_title`, `display_order`
  					FROM `campus_tracking_title`
  					WHERE `category_id`=' . $rij1['id'] . ' ORDER BY `display_order`';
                    $result = mysql_query($query);
                    $nbrLines = mysql_num_rows($result);
                    $line = 0;
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $line++;
                        $data = array();

                        $data[] = '<a name="row'.$rij['id'].'"></a>'.$rij1['tracking_category'];
                        $data[] = $rij['tracking_title'];
                        if ($line == 1)
                        {
                            $link = '<img src="' . Theme::get_image_path('application\campus') . 'up_na.gif" border=0 align="absmiddle">';
                        }
                        else
                        {
                            $link = '<a href="' . $this->get_url() . '&page=editstudenttrackingtitle&category_id=' . $rij['category_id'] . '&title_id=' . $rij['id'] . '&action=moveup#row'.$rij['id'].'"><img src="' . Theme::get_image_path('application\campus') . 'up.gif" border=0 align="absmiddle"></a>';
                        }
                        if ($line == $nbrLines)
                        {
                            $link.= '<img src="' . Theme::get_image_path('application\campus') . 'down_na.gif" border=0 align="absmiddle">';
                        }
                        else
                        {
                            $link.= '<a href="' . $this->get_url() . '&page=editstudenttrackingtitle&category_id=' . $rij['category_id'] . '&title_id=' . $rij['id'] . '&action=movedown#row'.$rij['id'].'"><img src="' . Theme::get_image_path('application\campus') . 'down.gif" border=0 align="absmiddle"></a>';
                        }
                        $data[] = "<a href=\"" . $this->get_campus_admin_url() . "&page=editstudenttrackingtitle&title_id=" . $rij['id'] . "&action=update\" title='" . get_lang("tooltipEditTrackingTitle") . "'><img src=\"" . Theme::get_image_path('application\campus') . "/edit.gif\" border=0 align=\"absmiddle\" /></a>" .
                                "&nbsp;<a href=\"" . $this->get_campus_admin_url() . "&page=editstudenttrackingtitle&title_id=" . $rij['id'] . "&action=delete\" onclick=\"javascript:if(!confirm('" . get_lang("msgboxConfirmDeleteTrackingTitle") . "')) return false;\" title='" . get_lang("tooltipDeleteTrackingTitle") . "'><img src=\"" . Theme::get_image_path('application\campus') . "/delete.gif\" border=0 align=\"absmiddle\" /></a>" . $link;
                        campus::display_table_row($bgcolor, $data, true);
                    }
                }
                campus::display_table_footer();
            }
    }
}
?>