<?php
/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Theme;
use common\libraries\Display;

/*
==============================================================================
	This is a content file included in the index.php file in this directory. 
==============================================================================
*/

//check if user is allowed here...
if ((intval($_uid)==0) || (empty($admin['student']) && !(isset($admin['studentTrackingLevel3']) && $admin['studentTrackingLevel3']) && !$is_platformadmin)) 
{// not allowed here!
	Display::error_message(get_lang("msgNoRights4ThisDepartment"),false);
}
else
{//only departmentadmins and platform administrator is allowed here...

/*
============================================================================== 
		POST & GET vars, check for default value?.
============================================================================== 
*/
	// het actieve uurrooster van de department bepalen...
	$action=campus::get_POST_GET("action");
	$submitmessage=campus::get_POST_GET("submitmessage");
	$teacher_id=intval(campus::get_POST_GET("teacher_id"));
	$group_id=intval(campus::get_POST_GET("group_id"));
	
/*
============================================================================== 
		Read, write and update database......
============================================================================== 
*/ 

	if ($submitmessage=="")
	{ //
		// de scholen ophalen waar de gebruiker deel van uitmaakt.
		switch ($action) 
		{
			case "new" :
			{ 
				$teacher_id="";
				$group_id="";
				$display="form";
			}
			break;
			case "edit" :
			{
				// De gegevens van het bericht inlezen.
				$display="form";
			}
			break;
			case "delete" :
			{
				// de gelinkte vakken verwijderen...
				$result=mysql_query("DELETE FROM `campus_teacher_rel_group` WHERE `teacher_id`=".$teacher_id." AND `group_id`=".$group_id);
				// de gelinkte leerkrachten verwijderen...
				$message = get_lang("msgDeleted");
				$display="list";
			}
			break;
			default :
			{
				$display="list";
			}
			break;
		} 
	}
	else
	{
		switch ($action) 
		{
			case "new" :
			{ 
				$query="INSERT `campus_teacher_rel_group` SET
						`teacher_id`=".$teacher_id.",
						`group_id`=".$group_id.",
						`department_id`=".$department_id."
					";
				$result=mysql_query($query);
				if (!$result)
				{
					$message = get_lang("msgItemAddError");
					$display="form";
				}
				else
				{
					$message = get_lang("msgItemAddSucces");
					$display="list";
				}
			}
			break;
			case "edit" :
			{ 
				$query="UPDATE `campus_teacher_rel_group` SET
						`teacher_id`=".intval(campus::get_POST_GET("new_teacher_id"))."
					WHERE `group_id`=".$group_id." AND `teacher_id`=".$teacher_id." AND `department_id`=".$department_id;
				$result=mysql_query($query);
				if (!$result)
				{
					$message = get_lang("msgItemEditError");
 					$display="form";
				}
				else
				{
					$message = get_lang("msgItemEditSucces");
 					$display="list";
				}
			}
			break;
			default :
			{
		 		$display="list";
			}
			break;
		}
	} 
/*
============================================================================== 
		display ...
============================================================================== 
*/
	if (!empty($message))
	{		
		Display::normal_message($message,false);
	}
	
	switch ($display)
	{
		case "form" :
		{ 
			// ===============================================================
			// Form to add/edit teacher 2 studentclass
			// ===============================================================
			echo "<b>".get_lang("page_addteacher2studentclass")."</b><br>";
	 		echo '<form method="post" action="'.$this->get_url().'" name="myform">';
	                echo '<input type="hidden" name="page" value="editteacher2studentclass" >';
			echo '<input type="hidden" name="action" value="'.$action.'" >';
			echo '<table>
				<tr valign="top">
					<td colspan="2">
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						'.get_lang('labelSelectTeacher').':
					</td>
					<td>';
			if ($action=='new')
			{
				echo "<select name='teacher_id'>";
			}
			else
			{
				echo '<input type="hidden" name="teacher_id" value="'.$teacher_id.'">';
				echo '<select name="new_teacher_id">';
			}
			// Al de leerkrachten van de department selecteren...
			$query="SELECT DISTINCT `user_user`.`id`,`lastname`, `firstname`, `official_code`
				FROM `group_group_rel_user`
               				LEFT JOIN `user_user`
                  				ON `user_user`.`id` = `group_group_rel_user`.`user_id`
           				WHERE (";
			// al de personeelsklassen van de department selecteren....
			$filter="";
 			$classes=campus::get_teacherclasses ($department_id);
			foreach ($classes as $key=>$value)
 			{
 				$filter.=" `group_group_rel_user`.`group_id` = ".$key." OR ";
			}
			$filter=substr($filter,0,-3);
			$sql=$query.$filter.") ORDER BY `lastname`,`firstname`";
			$result = mysql_query($sql) ;
			while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
			{
				echo "<option value=\"".$rij['id']."\" ".(($teacher_id==$rij['id'])?'SELECTED':'').">".$rij['official_code'].": ".$rij['lastname']." ".$rij['firstname']."</option>";
			}
			echo "</select>";
			echo '	  </td>
				</tr>
				<tr valign="top">
					<td align="right">
						'.get_lang('labelSelectClass').':
					</td>
					<td>';
			$classes=campus::get_studentclasses ($department_id);
			if ($action=='new')
			{
				echo "<select name='group_id'>";
				foreach ($classes as $key=>$value) 
				{
					if (empty($classes_array[$key]))
					{
						echo ("<option value=\"".$key."\" ".(($group_id==$key)?'SELECTED':'').">".$classes[$key]['code']."</OPTION>");
					}
				}
				echo "</select>";
			}
			else
			{
				echo '<input type="hidden" name="group_id" value="'.$group_id.'">';
				echo '<input name="" READONLY value="'.$classes[$group_id]['code'].'">';
			}
			echo '		</td>
				</tr>
				<tr valign="top">
					<td>
					</td>
					<td colspan="2">
						<input type="submit" name="submitmessage" value="'.get_lang('buttonlabelOK').'" />&nbsp;&nbsp;<input type="submit" name="cancel" value="'.get_lang('buttonlabelCancel').'" onMouseDown="javascript:document.myform.action.value=\'list\';">
					</td>
				</tr>
				</table>
				</form>';
 		}
 		break;
		case "list" :
 		{
			// ===============================================================
			//  Teacher???.
			// ===============================================================
			echo '<a href="'.$this->get_url().'&page=editteacher2studentclass&action=new">'.get_lang("txtAddTeacher2studentclass").'</a>&nbsp;|&nbsp;';
			echo '<a href="'.$this->get_url().'&page=importteacher2studentclasses">'.get_lang("txtImportTeacher2Studentclass").'</a>&nbsp;';
			$sql = 'SELECT `user_user`.`id`,`lastname`, `firstname`, `official_code`,`group_id`,`group_group`.`code`, `group_group`.`name`
					FROM `campus_teacher_rel_group`
						LEFT JOIN `user_user`
							ON `campus_teacher_rel_group`.`teacher_id` = `user_user`.`id`
						LEFT JOIN `group_group`
							ON `campus_teacher_rel_group`.`group_id` = `group_group`.`id`
						WHERE `campus_teacher_rel_group`.`department_id`='.$department_id.' ORDER BY `code`';
			$result = mysql_query($sql);
			campus::display_complex_table_header($properties, array(get_lang("colheadClass"),get_lang("colheadTeacher"),""));
			while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
			{
				$data['class']=$rij['name'].' ('.$rij['code'].')';
				$data['teacher']=$rij['firstname'].' '.$rij['lastname'].' ('.$rij['official_code'].')';
				$data['link']=	'<a href="'.$this->get_url().'&page=editteacher2studentclass&teacher_id='.$rij['id'].'&group_id='.$rij['group_id'].'&action=edit" title="'.get_lang("tooltipEditClassCoach").'"><img src="'.Theme::get_image_path('application\campus').'/edit.gif" border=0 align="absmiddle" ></a>'.
			  		'&nbsp;<a href="'.$this->get_url().'&page=editteacher2studentclass&teacher_id='.$rij['id'].'&group_id='.$rij['group_id'].'&action=delete" onclick="javascript:if(!confirm(\''.get_lang("msgboxConfirmDeleteClassCoach").'\')) return false;" title="'.get_lang("tooltipDeleteClassCoach").'"><img src="'.Theme::get_image_path('application\campus').'/delete.gif" border=0 align="absmiddle" /></a>';
				campus::display_table_row($bgcolor, $data, true);
			}
			campus::display_table_footer();
			echo "</form>";
		}
		break;
	}
}
?>