<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Display;
use common\libraries\Theme;
use common\libraries\Path;
use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['roster']) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...


    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $action = campus::get_POST_GET("action", "list");
    $import_id = campus::get_POST_GET("import_id", 0);
    $agenda_id = campus::get_POST_GET("agenda_id", 0);
    $submitmessage = campus::get_POST_GET("submitmessage");
    $row1 = campus::get_POST_GET("row1", "off");

    $content = campus::get_POST_GET("content","EXAMEN");
    $classCol = campus::get_POST_GET("classCol", 0);
    $dateCol = campus::get_POST_GET("dateCol", 1);
    $hourCol = campus::get_POST_GET("hourCol", 2);
    $durationCol = campus::get_POST_GET("durationCol", 3);
    $disciplineCol = campus::get_POST_GET("disciplineCol", 4);
    $teachersCol = campus::get_POST_GET("teachersCol", 5);
    $contentCol = campus::get_POST_GET("contentCol", 6);
    $classroomCol = campus::get_POST_GET("classroomCol", 7);

    $simulate = campus::get_POST_GET("simulation", "off");
    $activeroster = campus::get_activeroster($department_id);

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if ($action == 'delete')
    {
        $result = mysql_query('DELETE `campus_agenda`,	`campus_agenda_rel_group`
					FROM `campus_agenda` LEFT JOIN	`campus_agenda_rel_group`  ON `campus_agenda`.`id`=`campus_agenda_rel_group`.`agenda_id`
					WHERE `department_id` = ' . $department_id . ' AND `import_id`="' . $import_id . '"');
        if ($result)
        {
            $message = get_lang("txtDeleteOK");
        }
        $action = "list";
    }
    elseif ($action == 'deleteline')
    {
        $result = mysql_query('DELETE `campus_agenda`,	`campus_agenda_rel_group`
					FROM `campus_agenda` LEFT JOIN	`campus_agenda_rel_group`  ON `campus_agenda`.`id`=`campus_agenda_rel_group`.`agenda_id`
					WHERE `campus_agenda`.`id`="' . $agenda_id . '"');
        if ($result)
        {
            $message = get_lang("msgDeleted");
        }
        $action = "details";
    }


    if ($submitmessage != "")
    {
        echo "<p><u><b>" . get_lang("txtImportReport") . "</b></u></p>";
        if ($simulate == 'off')
        {
            $action = "details";
        }
        if (!empty($_FILES) || !empty($_SESSION['agendadata'])) // het bestand lezen...
        {
            if (!empty($_SESSION['agendadata']))
            {
                $lines = $_SESSION['agendadata'];
            }
            else
            {
                $lines = file($_FILES['uploadfile']['tmp_name']);
            }
            $_SESSION['agendadata'] = $lines;
            //generate importID department code + date + time
            $import_id = $departmentStruc[$department_id]['code'] . strftime("%Y%m%d%H%M%S", time());
            if ($simulate == 'on')
            {
                campus::display_complex_table_header($properties, array(get_lang("colheadLineNr"), get_lang("colheadDate"), get_lang("colheadHour"), get_lang("colheadTeacher"), get_lang("colheadDiscipline"), get_lang("colheadComment"), get_lang("colheadClass"), ""));
            }
            $i = 1;
            if ((trim($dateCol) != "") AND (trim($hourCol) != "") AND (trim($durationCol) != "") AND (trim($classCol) != ""))
            {
                foreach ($lines as $key => $value)
                {
                    if ((($row1 == 'off') && ($i == 1)) || ($i > 1))
                    {
                        $values = explode(";", $value);
                        // extract values...
                        if ((trim($values[$dateCol]) != "") AND (trim($values[$hourCol]) != "") AND (trim($values[$durationCol]) != ""))
                        {
                            $classroom = (trim($classroomCol) == "") ? "" : ('Lokaal: ' . trim($values[intval($classroomCol)]));
                            $agendacontent = ((trim($contentCol) == "") ? "" : trim($content) . " " . trim($values[intval($contentCol)]));
                            $date = strtotime(trim($values[$dateCol]));

                            // check groups
                            $groups = explode(" ", trim($values[intval($classCol)]));
                            $groupselect = ' ( `group_group`.`code`="' . implode('" OR `group_group`.`code`="', $groups) . '") ';
                            $groups = array_flip($groups);
                            $query = 'SELECT DISTINCT `id`, `code` FROM `group_group`
                                                INNER JOIN `campus_department_rel_group`
                                                    ON `group_group`.`id` = `campus_department_rel_group`.`group_id` AND `type`=2
		  				WHERE ' . $groupselect . ' AND  `department_id` = ' . $department_id . ' ';
                            $result = mysql_query($query);
                            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                            {
                                $groups[$rij['code']] = $rij['id'];
                            }
                            // check teachers
                            $teachers = explode(" ", trim($values[intval($teachersCol)]));
                            $teacherselect = ' ( `user_user`.`official_code`="' . implode('" OR `user_user`.`official_code`="', $teachers) . '") ';
                            $teachers = array_flip($teachers);
                            $query = 'SELECT DISTINCT `id`, `official_code` FROM `user_user`
                                                INNER JOIN `group_group_rel_user`
                                                    ON `group_group_rel_user`.`user_id` = `user_user`.`id`
		                                INNER JOIN `campus_department_rel_group`
                                                    ON `group_group_rel_user`.`group_id` = `campus_department_rel_group`.`group_id` AND `type`=1
		  				WHERE ' . $teacherselect . ' AND  `department_id` = ' . $department_id . ' ';
                            $result = mysql_query($query);
                            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                            {
                                $teachers[$rij['official_code']] = $rij['id'];
                            }

                            // check discipline
                            $discipline = (trim($disciplineCol) == "") ? "" : trim($values[intval($disciplineCol)]);
                            $result = mysql_query('SELECT `id` FROM `campus_discipline` WHERE `code` = "' . $discipline . '" AND  `department_id` = ' . $department_id . ' LIMIT 1');
                            $discipline_id = mysql_result($result, 0, 0);

                            // find assignment...
                            if (intval($discipline_id > 0))
                            {
                                $query = 'SELECT DISTINCT `campus_assignment`.`id` FROM `campus_assignment`
                                                INNER JOIN `campus_assignment_rel_group`
                                                    ON `campus_assignment`.`id`=`campus_assignment_rel_group`.`assignment_id`
                                                INNER JOIN `group_group`
                                                    ON `group_group`.`id`=`campus_assignment_rel_group`.`group_id` 
                                                WHERE `discipline_id` = "' . $discipline_id . '" AND  `curriculum_id` = ' . $activeroster['curriculum_id'] . ' AND ' . $groupselect;
                                $result = mysql_query($query);

                                $assignment_id = mysql_result($result, 0, 0);
                            }
                            else
                            {
                                $assignment_id = 0;
                            }

                            // find periods
                            $hours = array();
                            $query = 'SELECT * FROM `campus_period` WHERE `weekday`=' . strftime('%w', $date) . '  AND `display_order` >= ' . intval($values[intval($hourCol)]) . ' AND `display_order`<' . (intval($values[intval($hourCol)]) + intval($values[intval($durationCol)])) . '
                                      AND `department_id`=' . $department_id . ' ORDER BY `display_order`';
                            $result = mysql_query($query) or die(mysql_error());
                            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                            {
                                $hours[$rij['id']] = $rij['code'];
                            }
                            if (empty($hours))
                            {
                                $period = DatetimeUtilities::format_locale_date('%A', $date) . ' ' . intval($values[intval($hourCol)]);
                                if ($simulate == 'on')
                                {
                                    campus::display_table_row($bgcolor, array(get_lang("txtLine") . $i, trim($values[intval($dateCol)]), $period . '=' . get_lang("txtFailed"), '-', '-', '-', '-', '-'), true);
                                }
                            }
                            else
                            {

                                foreach ($hours as $period_id => $period_code)
                                {
                                    $data = array();
                                    $data[0] = get_lang("txtLine") . $i;
                                    $data[1] = trim($values[intval($dateCol)]); //DatetimeUtilities::format_locale_date($dateFormat, $date);
                                    // vakleerkrachten opzoeken om in de agenda te importeren.
                                    $data[2] = $period_code;
                                    $data[3] = "";
                                    $agendaids = array();
                                    if ($assignment_id > 0)
                                    {
                                        $data[3] = get_lang('txtAssignmentFound') . "=" . get_lang("txtSucces");
                                        if ($simulate == 'off')
                                        {
                                            $query = 'INSERT INTO `campus_agenda` SET
							`date` = ' . $date . ',
							`period_id` = ' . $period_id . ',
							`assignment_id` = ' . $assignment_id . ',
                                  			`content` = "' . $agendacontent . (($classroom != "") ? ('\n' . $classroom) : '') . '",
							`department_id` = ' . $department_id . ',
							`import_id`="' . $import_id . '"';
                                            $result = mysql_query($query) or die(mysql_error());
                                            if (!$result)
                                            {
                                                $errormessage = get_lang("msgImportErrors");
                                            }
                                            else
                                            {
                                                $message = get_lang("msgFileImported");
                                                $agendaids[] = mysql_insert_id();
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (!empty($teachers))
                                        {
                                            foreach ($teachers as $teacher_code => $teacher_id)
                                            {
                                                 $data[3].=(($teacher_id == 0)?('<b style="color: red">' . get_lang('txtNoTeacher') . '</b>'): $teacher_code). '='.get_lang("txtSucces");
                                                    if ($simulate == 'off')
                                                    {
                                                        $message = get_lang("msgFileImported");
                                                        $query = 'INSERT INTO `campus_agenda` SET
								`date` = ' . $date . ',
								`period_id` = ' . $period_id . ',
								`user_id` = ' . $teacher_id . ',
                                  				`content` = "' . $agendacontent . (($classroom != "") ? ('\n' . $classroom) : '') . '",
								`department_id` = ' . $department_id . ',
								`import_id`="' . $import_id . '"';
                                                        $result = mysql_query($query);
                                                        if (!$result)
                                                        {
                                                            $errormessage = get_lang("msgImportErrors");
                                                            $message = "";
                                                        }
                                                        else
                                                        {
                                                            $agendaids[] = mysql_insert_id();
                                                        }
                                                    }
                                             }
                                        }
                                        else
                                        {
                                            $data[3] = "<b style='color: red'>" . get_lang('txtNoTeacher') . "</b>=" . get_lang("txtSucces");
                                        }
                                    }

                                    $data[4] = ($discipline != "") ? ($discipline . "=" . (($discipline_id == 0) ? get_lang("txtFailed") : get_lang("txtSucces"))) : get_lang("txtSucces");
                                    $data[5] = $agendacontent . (($classroom != "") ? ('<br>' . $classroom) : '');
                                    //klassen ophalen en de agendalijn toekennen
                                    $data[6] = "";
                                    foreach ($groups as $group_code => $group_id)
                                    {
                                        $data[6].=$group_code . "=" . (($group_id > 0) ? get_lang("txtSucces") : get_lang("txtFailed") ) . " ";
                                        if (($simulate == 'off') && ($group_id > 0))
                                        {
                                            foreach ($agendaids as $agenda_id)
                                            {
                                                $query2 = 'INSERT INTO `campus_agenda_rel_group` SET ' .
                                                        '`agenda_id` =' . $agenda_id . ', ' .
                                                        '`group_id` =' . $group_id;
                                                $result2 = mysql_query($query2);
                                                if (!$result2)
                                                {
                                                    $message = "";
                                                    $errormessage = get_lang("msgImportErrors");
                                                }
                                            }
                                        }
                                    }
                                    if ($simulate == 'on')
                                    {
                                        $data[7] = get_lang("txtImportSim");
                                        campus::display_table_row($bgcolor, $data, true);
                                    }
                                }
                            }
                        }
                    }
                    $i++;
                }
                if ($simulate == 'on')
                {
                    campus::display_table_footer();
                }
            }
            else
            {
                Display::error_message(get_lang("msgMissingData"), false);
            }
        }
    }
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }
    elseif (!empty($errormessage))
    {
        Display::error_message($errormessage, false);
        $action = 'import';
    }
    if ($action == "import")
    {
        // ===============================================================
        // het importformulier weergeven.....
        // Het import bestand wordt geselecteerd en ingesteld....
        // ===============================================================
        // reset session....
        echo "<b>" . get_lang("page_importagendacontent") . "</b><br>";
        echo '<form method="post" action="' . $this->get_url() . '" name="importform" enctype="multipart/form-data">';
        echo '<input type="hidden" name="page" value="importagendacontent">';
        echo '<input type="hidden" name="action" value="import">';
        echo '<input type="hidden" name="MAX_FILE_SIZE" value="1000000">';
        echo '	<table>
				<tr valign="top">
					<td colspan="2">
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelClassCol') . '
					</td>
					<td>
						<input type="text" name="classCol" size="2" maxlength="2" value="' . $classCol . '" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
					</td>
					<td align="right">
						' . get_lang('labelDisableRow1') . '
					</td>
					<td>
						<input type="checkbox" name="row1" value="on" ' . (($_POST['row1'] == 'on') ? "checked" : "") . '>
					</td>
					<td width="50%" rowspan="10">
						' . get_lang('helpAgendaImport') . '<br>
						<div style="color: #777777">
							<u>' . get_lang('txtCsvImport') . '</u><br>
							 klas(sen);datum;lesuur;duur;vak;leerkracht(en);inhoud;lokaal<br>
							 xxx;yyyy-mm-dd;nnn;nnn;xxx;xxx;xxx;xxx<br>
							 xxx;yyyy-mm-dd;nnn;nnn;xxx;xxx;xxx;xxx<br>
							<br><u>' . get_lang('txtCsvExample') . '</u><br>
							 klas(sen);datum;lesuur;duur;vak;leerkracht(en);inhoud;lokaal<br>
							 1A1;2008-02-28;1;2;INF;THLU;;A001<br>
							 1A2 1A1;2008-02-28;3;2;INF;THLU LKR2;PRAKTISCH;A001<br>
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelDateCol') . '
					</td>
					<td>
						<input type="text" name="dateCol" size="2" maxlength="2" value="' . $dateCol . '" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
					</td>
					<td align="right">
						' . get_lang('labelSimulation') . '
					</td>
					<td>
						<input type="checkbox" name="simulation" value="on" checked/>
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelHourCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="hourCol" size="2" maxlength="2" value="' . $hourCol . '" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelDurationCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="durationCol" size="2" maxlength="2" value="' . $durationCol . '" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelDisciplineCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="disciplineCol" size="2" maxlength="2" value="' . $disciplineCol . '" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelTeacherCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="teachersCol" size="2" maxlength="2" value="' . $teachersCol . '" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelContentCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="contentCol" size="2" maxlength="2" value="' . $contentCol . '" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelExtraContent') . '
					</td>
					<td colspan="3">
						<input type="text" name="content" size="16" value="' . $content . '" />
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						' . get_lang('labelClassroomCol') . '
					</td>
					<td colspan="3">
						<input type="text" name="classroomCol" size="2" maxlength="2" value="' . $classroomCol . '" />
					</td>
				</tr>';
        if (empty($lines))
        {
            // reset session....
            unset($_SESSION['agendadata']);
            echo '	<tr valign="top">
				<td align="right">
					' . get_lang('labelSelectFile2Import') . '
				</td>
				<td colspan="3">
					<input type="file" name="uploadfile" >
					<br />
				</td>
				</tr>';
        }
        else
        {
            echo "<tr><td colspan=3>" . get_lang("txtImportSameFile") . "</td></tr>";
        }
        echo '		<tr valign="top">
					<td>	
					</td>
					<td colspan="3">
						<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelUpload') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang("buttonlabelCancel") . '" onMouseDown="javascript:document.importform.action.value=\'list\';">
					</td>
				</tr>
			</table>
			</form>';
    }
    elseif ($action == 'details')
    {
        echo '<a href="' . $this->get_url() . '&page=importagendacontent">' . get_lang("txtBack") . '</a>';
        campus::display_complex_table_header($properties, array(get_lang("colheadDate"), get_lang("colheadHour"), get_lang("colheadTeacher"), get_lang("colheadDiscipline"), get_lang("colheadComment"), get_lang("colheadClass"), ""));
        $query = 'SELECT `date`, `campus_period`.`code` as period_code, "" as `official_code`, `campus_discipline`.`code`,`content`,  `campus_agenda`.`id`,`campus_agenda`.`assignment_id`
			FROM `campus_agenda`
                        	INNER JOIN `campus_period`
					ON `campus_agenda`.`period_id`=`campus_period`.`id`
				LEFT JOIN `campus_assignment`
					ON `campus_agenda`.`assignment_id`=`campus_assignment`.`id`
				LEFT JOIN `campus_discipline`
					ON `campus_assignment`.`discipline_id`=`campus_discipline`.`id`
				WHERE `import_id`="' . $import_id . '"
				ORDER BY `date`, `campus_period`.`display_order`';
        $result = mysql_query($query) or die(mysql_error());
        while ($rij = mysql_fetch_array($result, MYSQL_NUM))
        {
            $grouplist = campus::get_agenda2grouplist($rij[5]);
            $teacherlist = campus::get_agenda2teacherlist($rij[5]);
            $rij[0] = DatetimeUtilities::format_locale_date('%Y-%m-%d', $rij[0]);
            $rij[2] = $teacherlist;
            $rij[6] = '<a href="' . $this->get_url() . '&page=importagendacontent&action=deleteline&agenda_id=' . $rij[5] . '&import_id=' . $import_id . '" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmDeleteAgendaImportLine") . '\')) return false;" title="' . get_lang("tooltipDeleteAgendaImportLine") . '"/><img src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="absmiddle" ></a>';
            $rij[5] = $grouplist;
            campus::display_table_row($bgcolor, $rij, true);
        }
        campus::display_table_footer();
    }
    else
    {
        $query = 'SELECT DISTINCT `import_id` FROM `campus_agenda`
					WHERE `department_id`=' . $department_id;
        $result = mysql_query($query);
        echo '<a href="' . $this->get_url() . '&page=importagendacontent&action=import">' . get_lang("txtImportAgendaContent") . '</a>';
        campus::display_complex_table_header($properties, array(get_lang("colheadImportID"), ''));
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            if ($rij['import_id'] != "")
            {
                campus::display_table_row($bgcolor, array('<a href="' . $this->get_url() . '&page=importagendacontent&action=details&import_id=' . $rij['import_id'] . '">' . $rij['import_id'] . '</a>', '<a href="' . $this->get_url() . '&page=importagendacontent&action=delete&import_id=' . $rij['import_id'] . '" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmDeleteAgendaImport") . '\')) return false;"  title="' . get_lang("tooltipDeleteAgendaImport") . '"><img src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="absmiddle"></a><br>'), true);
            }
        }
        campus::display_table_footer();
    }
}
?>