<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['roster']) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    // het actieve uurrooster van de department bepalen...
    $action = campus::get_POST_GET("action", "import");
    $submitmessage = campus::get_POST_GET("submitmessage");
    $schedule_id = intval(campus::get_POST_GET("schedule_id"));

    $week = DatetimeUtilities::get_days_long();
    if ($schedule_id != 0)
    {
        // combine college houres in blocks.. when groups, discipline and teachers are the same!!!!
        $roster_id = campus::get_schedule2roster($schedule_id);
        $curriculum_id = campus::get_roster2curriculum($roster_id);

        /*
          ==============================================================================
          Actualiseer de gegevens van het formulier en de database......
          ==============================================================================
         */

        if ($submitmessage == "")
        { //
            switch ($action)
            {
                case "import" :
                    {
                        $display = "import";
                    }
                    break;
                default :
                    {
                        $display = "list";
                    }
                    break;
            }
        }
        else
        {
            switch ($action)
            {
                case "import" :
                    {
                        // while importing, display import-report....
                        $row1 = campus::get_POST_GET("row1", "off");
                        $simulate = campus::get_POST_GET("simulation", "off");
                        if ($simulate != 'off')
                        {
                            echo "<div style=\"font-size: 18px;color: red;\">" . get_lang("txtImportSim") . "</div>";
                        }
                        $curriculum_assignment = array();
                        $query = 'SELECT  `discipline_id`,`campus_assignment`.`id`, `user_id`,`group_id`  FROM `campus_assignment`
					INNER JOIN `campus_assignment_rel_teacher`
						ON `campus_assignment_rel_teacher`.`assignment_id`= `campus_assignment`.`id`
					INNER JOIN `campus_assignment_rel_group`
						ON `campus_assignment_rel_group`.`assignment_id`= `campus_assignment`.`id`
					WHERE `curriculum_id` = ' . $curriculum_id . ' ';
                        $result = mysql_query($query);
                        while ($rij = mysql_fetch_array($result))
                        {
                            $curriculum_assignment[$rij['discipline_id'] . ',' . $rij['user_id'] . ',' . $rij['group_id']] = $rij['id'];
                        }
                        // import the file...
                        if (!empty($_FILES) || !empty($_SESSION['rosterlines']))
                        {
                            if (!empty($_SESSION['rosterlines']))
                            {
                                //
                                $lines = $_SESSION['rosterlines'];
                            }
                            else
                            {
                                //Het bestand inlezen ....
                                $lines = file($_FILES['uploadfile']['tmp_name']);
                            }
                            $_SESSION['rosterlines'] = $lines;

                            $assignments = array();
                            $i = 1;
                            foreach ($lines as $key => $value)
                            {
                                if ((($row1 == 'off') && ($i == 1)) || ($i > 1))
                                {
                                    echo get_lang("txtLine") . $i++ . " ";
                                    $assignmentOK = FALSE;
                                    $values = explode(";", $value);
                                    // extract values...
                                    $valPeriodcode = trim($values[intval(campus::get_POST_GET("timeCol"))]);
                                    $duration = intval(trim($values[intval(campus::get_POST_GET("durationCol"))]));
                                    $discipline_code = trim($values[intval(campus::get_POST_GET("disciplineCol"))]);
                                    $valGroups = trim($values[intval(campus::get_POST_GET("classesCol"))]);
                                    $valTeachers = trim($values[intval(campus::get_POST_GET("teachersCol"))]);
                                    $valResources = trim($values[intval(campus::get_POST_GET("resourceCol"))]);

                                    //check teachers and get IDs
                                    $teachers = explode(" ", $valTeachers);
                                    sort($teachers);
                                    $teacher_ids = array();
                                    echo get_lang("txtTeachers") . ":";
                                    foreach ($teachers as $official_code)
                                    {
                                        $query = "SELECT `user_user`.`id` FROM `user_user`
										INNER JOIN `group_group_rel_user`
											ON `group_group_rel_user`.`user_id`= `user_user`.`id`
										INNER JOIN `campus_department_rel_group`
											ON `group_group_rel_user`.`group_id`= `campus_department_rel_group`.`group_id` AND `type`=1
										WHERE `official_code` = '" . $official_code . "' AND `department_id`=" . $department_id . " LIMIT 1";
                                        $result = mysql_query($query) or die(mysql_error());
                                        $teacher_id = mysql_result($result, 0, 0);
                                        echo " " . $official_code . "=";
                                        if (intval($teacher_id) == 0)
                                        {
                                            echo "<b style='color: red'>" . get_lang("txtFailed") . "</b> ";
                                        }
                                        else
                                        {
                                            echo "<b style='color: green'>" . get_lang("txtSucces") . "</b> ";
                                            $teacher_ids[] = intval($teacher_id);
                                        }
                                    }

                                    //check classes and get IDs
                                    $groups = explode(" ", $valGroups);
                                    sort($groups);
                                    $group_ids = array();
                                    echo get_lang("txtClasses") . ":";
                                    foreach ($groups as $group_code)
                                    {
                                        $query = "SELECT `id` FROM `group_group` INNER JOIN `campus_department_rel_group`
							ON `group_group`.`id` = `campus_department_rel_group`.`group_id` AND `type`=2
		  				WHERE `code` = '" . $group_code . "' AND  `department_id` = " . $department_id . " LIMIT 1";
                                        $result = mysql_query($query);
                                        $group_id = mysql_result($result, 0, 0);
                                        echo " " . $group_code . "=";
                                        if (intval($group_id) == 0)
                                        {
                                            echo "<b style='color: red'>" . get_lang("txtFailed") . "</b> ";
                                        }
                                        else
                                        {
                                            echo "<b style='color: green'>" . get_lang("txtSucces") . "</b> ";
                                            $group_ids[] = intval($group_id);
                                        }
                                    }

                                    //check disciplines and get IDs
                                    echo get_lang("txtDiscipline") . ":";
                                    $result = mysql_query("SELECT `id` FROM `campus_discipline` WHERE `code` = '" . $discipline_code . "' AND  `department_id` = " . $department_id . " LIMIT 1");
                                    $discipline_id = mysql_result($result, 0, 0);
                                    echo " " . $discipline_code . "=";
                                    if (intval($discipline_id) == 0)
                                    {
                                        echo "<b style='color: red'>" . get_lang("txtFailed") . "</b> ";
                                    }
                                    else
                                    {
                                        echo "<b style='color: green'>" . get_lang("txtSucces") . "</b> ";
                                        $assignmentOK = TRUE; // when at least one discipline is found an assignment can be added
                                    }

                                    // check timing and get ID

                                    $result = mysql_query('SELECT `id` FROM `campus_period` WHERE `department_id` = ' . $department_id . ' AND `code`="' . $valPeriodcode . '"');
                                    $period_id = mysql_result($result, 0, 0);
                                    echo get_lang("txtHour") . " " . $valPeriodcode . "=" . (($period_id == "") ? ("<b style='color: red'>" . get_lang("txtFailed") . "</b>") : ("<b style='color: green'>" . get_lang("txtSucces") . "</b>")) . " ";
                                    echo get_lang("txtDuration") . " " . $duration . "=" . ( ($duration > 0) ? ("<b style='color: green'>" . get_lang("txtSucces") . "</b>") : ("<b style='color: red'>" . get_lang("txtFailed") . "</b>")) . " ";

                                    // check resources and get IDs
                                    $resources = explode(" ", $valResources);
                                    echo get_lang("txtResources") . ":";
                                    $resource_ids = array();
                                    foreach ($resources as $resource_code)
                                    {
                                        $result = mysql_query("SELECT `id` FROM `campus_resource` WHERE `code` = '" . $resource_code . "' AND `department_id`= " . $department_id . " LIMIT 1");
                                        $resource_id = mysql_result($result, 0, 0);
                                        echo " " . $resource_code . "=";
                                        if (intval($resource_id) == 0)
                                        {
                                            echo "<b style='color: red'>" . get_lang("txtFailed") . "</b> ";
                                        }
                                        else
                                        {
                                            echo "<b style='color: green'>" . get_lang("txtSucces") . "</b> ";
                                            $resource_ids[] = intval($resource_id);
                                        }
                                    }

                                    if (($simulate == 'off') && ($assignmentOK))
                                    {
                                        //**************** IMPORT **********
                                        $assignment_id = 0;
                                        foreach ($group_ids as $group_id)
                                        {
                                            foreach ($teacher_ids as $teacher_id)
                                            {

                                                if (intval($assignment_id) == 0)
                                                { //
                                                    if ($curriculum_assignment[$discipline_id . ',' . $teacher_id . ',' . $group_id] > 0)
                                                    {//check if assignment exists.
                                                        $assignment_id = $curriculum_assignment[$discipline_id . ',' . $teacher_id . ',' . $group_id];
                                                        echo "<b style='color: green'>" . get_lang("txtFound") . "</b> " . $assignment_id;
                                                    }
                                                    else
                                                    { // make assignment
                                                        $query = 'INSERT `campus_assignment` SET `curriculum_id`=' . $curriculum_id . ', `discipline_id`=' . $discipline_id;
                                                        $result = mysql_query($query);
                                                        if ($result)
                                                        {
                                                            $assignment_id = mysql_insert_id();
                                                            $curriculum_assignment[$discipline_id . ',' . $teacher_id . ',' . $group_id] = $assignment_id;
                                                            echo "<b style='color: green'>" . get_lang("txtSucces") . "</b> ";
                                                        }
                                                        else
                                                        {
                                                            $assignment_id = 0;
                                                            echo "<b style='color: red'>" . get_lang("txtFailed") . "</b> ";
                                                        }
                                                    }
                                                }
                                                if (intval($assignment_id) != 0)
                                                {
                                                    // the assigment exists continue import of information
                                                    if ($teacher_id > 0)
                                                    { // add teacher to assignment for selected roster....
                                                        $result = mysql_query('SELECT * FROM `campus_assignment_rel_teacher` WHERE `assignment_id`=' . $assignment_id . ' AND `user_id`=' . $teacher_id . ' AND `roster_id`=' . $roster_id);
                                                        if (mysql_num_rows($result) == 0)
                                                        { // ADD only when not allready exists
                                                            $result = mysql_query('INSERT `campus_assignment_rel_teacher` SET `assignment_id`=' . $assignment_id . ', `user_id`=' . $teacher_id . ', `roster_id`=' . $roster_id);
                                                        }
                                                    }
                                                    if ($group_id > 0)
                                                    { // add group to assignment
                                                        $result = mysql_query("SELECT * FROM `campus_assignment_rel_group` WHERE `assignment_id`=" . $assignment_id . " AND `group_id`=" . $group_id);
                                                        if (mysql_num_rows($result) == 0)
                                                        { // ADD only when not allready exists
                                                            $result = mysql_query("INSERT `campus_assignment_rel_group` SET `assignment_id`=" . $assignment_id . ", `group_id`=" . $group_id);
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        if (intval($assignment_id) != 0)
                                        {
                                            // add college
                                            // add classes to assignment
                                            //add rosterline.
                                            if (($period_id > 0) && ($duration > 0))
                                            {
                                                $query = 'INSERT INTO `campus_college` SET
 							   				`period_id`=' . $period_id . ',
    											`duration`=' . $duration . ',
    											`assignment_id`=' . $assignment_id . ',
 											`roster_id`=' . $roster_id . '';
                                                $result = mysql_query($query);
                                                if ($result)
                                                {
                                                    $college_id = mysql_insert_id();
                                                    echo get_lang("txtCollegeAdded") . "=<b style='color: green'>" . get_lang("txtSucces") . "</b> ";
                                                    if (intval($roster_id) != 0)
                                                    {
                                                        foreach ($resource_ids as $resource_id)
                                                        {
                                                            $result = mysql_query('SELECT * FROM `campus_college_rel_resource` WHERE `college_id`=' . $college_id . ' AND `resource_id`=' . $resource_id);
                                                            if (mysql_num_rows($result) == 0)
                                                            { // ADD only when not allready exists
                                                                $result = mysql_query('INSERT `campus_college_rel_resource` SET `college_id`=' . $college_id . ', `resource_id`=' . $resource_id);
                                                            }
                                                        }
                                                    }
                                                }
                                                else
                                                {
                                                    echo "<b style='color: red'>" . get_lang("txtCollegeNotAdded") . "</b> ";
                                                }
                                            }
                                            else
                                            {
                                                echo "<b style='color: red'>" . get_lang("txtCollegeNotAdded") . "</b> ";
                                            }
                                        }
                                        else
                                        {
                                            echo "<b style='color: red'>" . get_lang("txtAssignmentNotAdded") . "</b> ";
                                        }
                                    }
                                    else
                                    {
                                        echo "<b style='color: red'>" . get_lang("txtAssignmentNotAdded") . "</b> ";
                                    }
                                    echo "<br>";
                                }
                                else
                                {
                                    $i++;
                                    echo get_lang("txtLine1Ignored");
                                    echo "<br>";
                                }
                            }
                        }
                        echo "<hr>";
                        if ($simulate == 'off')
                        {
                            if ($result)
                            {
                                $message = get_lang("msgRosterFileImported");
                                $display = "terug";
                            }
                        }
                        else
                        {
                            $display = "import";
                        }
                    }
                    break;
                default :
                    {
                        $display = "list";
                    }
                    break;
            }
        }
        /*
          ==============================================================================
          display ...
          ==============================================================================
         */
        if (!empty($message))
        {
            Display::normal_message($message, false);
        }

        switch ($display)
        {
            case "import" :
                {
                    // ===============================================================
                    // Het rooster import formulier weergeven.........
                    // ===============================================================
                    echo '<form method="post" action="' . $this->get_url() . '" name="importform" enctype="multipart/form-data">';
                    echo '<input type="hidden" name="schedule_id" value="' . $schedule_id . '" >';
                    echo '<input type="hidden" name="page" value="importcurriculum" >';
                    echo '<input type="hidden" name="action" value="import" >';
                    echo '<input type="hidden" name="MAX_FILE_SIZE" value="100000">';
                    echo '<table>
				<tr valign="top">
				<td align="right">
				' . get_lang('labelTeacherCol') . '
				</td>
				<td>
					<input type="text" name="teachersCol" size="2" maxlength="2" value="' . campus::get_POST_GET("teachersCol", 0) . '" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
				</td>
				<td align="right">
				' . get_lang('labelDisableRow1') . '
				</td>
				<td>
					<input type="checkbox" name="row1" value="on" ' . (($_POST['row1'] == 'on') ? "checked" : "") . '>
				</td>
				<td width="50%" rowspan="9">
					' . get_lang('helpRosterImport') . '<br>
					<div style="color: #777777">
						<u>' . get_lang('txtCsvImport') . '</u><br>
						 leerkracht;klas;vak;duur;lesuur;lokalen<br>
						 xxx;xxx;xxx;nnn;xxn;xxx<br>
						 xxx;xxx;xxx;nnn;xxn;xxx<br>
						<br><u>' . get_lang('txtCsvExample') . '</u><br>
						 leerkracht;klas;vak;duur;lesuur;lokalen<br>
						 THLU;1A1;INF;2;ma1;A001<br>
						 THLU LKRA;1A2 1A1;INF WIS;1;do5;A001 B101<br>
						 LKRC;1A3 1A4;NED;2;vr5;A001<br>
					</div>
				</td>
				</tr>
				<tr valign="top">
				<td align="right">
				' . get_lang('labelClassCol') . '
				</td>
				<td>
					<input type="text" name="classesCol" size="2" maxlength="2" value="' . campus::get_POST_GET('classesCol', 1) . '" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
				</td>
				<td align="right">
				' . get_lang('labelSimulation') . '
				</td>
				<td>
					<input type="checkbox" name="simulation" value="on" checked/>
				</td>
				</tr>
				<tr valign="top">
				<td align="right">
				' . get_lang("labelDisciplineCol") . '
				</td>
				<td colspan="3">
					<input type="text" name="disciplineCol" size="2" maxlength="2" value="' . campus::get_POST_GET('disciplineCol', 2) . '" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
				</td>
				</tr>
				<tr valign="top">
				<td align="right">
				' . get_lang('labelScheduleCol') . '
				</td>
				<td colspan="3">
					<input type="text" name="timeCol" size="2" maxlength="2" value="' . campus::get_POST_GET('timeCol', 3) . '" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
				</td>
				</tr>
				<tr valign="top">
				<td align="right">
				' . get_lang('labelDurationCol') . '
				</td>
				<td colspan="3">
					<input type="text" name="durationCol" size="2" maxlength="2" value="' . campus::get_POST_GET('durationCol', 4) . '" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
				</td>
				</tr>
				<tr valign="top">
				<td align="right">
				' . get_lang('labelResourceCol') . '
				</td>
				<td colspan="3">
					<input type="text" name="resourceCol" size="2" maxlength="2" value="' . campus::get_POST_GET('resourceCol', 5) . '" />
				</td>
				</tr>
				<tr valign="top">
				</tr>';
                    if (empty($lines))
                    {
                        // reset session....
                        unset($_SESSION['rosterlines']);
                        echo '<tr valign="top">
					<td align="right">
					' . get_lang('labelSelectFile2Import') . '
					</td>
					<td colspan="3">
					<input type="file" name="uploadfile" >
					<br />
					</td>
					</tr>';
                    }
                    else
                    {
                        echo "<tr><td>" . get_lang("txtImportSameFile") . "</td></tr>";
                    }
                    echo '<tr valign="top">
				<td>
				</td>
				<td colspan="5">
					<input type="submit" name="submitmessage" value="' . get_lang("buttonlabelUpload") . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.importform.page.value=\'editcurriculum\';document.importform.action.value=\'\';">
				</td>
				</tr>
				</table>
				</form>';
                }
                break;
            case "terug" :
                {
                    echo '<div><p><A href="' . $this->get_url() . '&page=editcurriculum&action=list">' . get_lang("txtBack2RosterList") . '</A></p></div>';
                }
                break;
        }
    }
    else
    {
        $errormessage = get_lang("msgScheduleError");
    }
}
?>