<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['roster']) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    // het actieve uurrooster van de department bepalen...
    $activeroster = campus::get_activeroster($department_id);
    $action = campus::get_POST_GET("action", "step1");
    $submitmessage = campus::get_POST_GET("submitmessage");
    $schedule_id = intval(campus::get_POST_GET("schedule_id"));

    $week = DatetimeUtilities::get_days_long();
    if ($schedule_id != 0)
    {
        // 
        $roster_id = campus::get_schedule2roster($schedule_id);
        $curriculum_id = campus::get_roster2curriculum($roster_id);

        /*
          ==============================================================================
          Actualiseer de gegevens van het formulier en de database......
          ==============================================================================
         */

        switch ($action)
        {
            case "step1" :
                {
                    // ===============================================================
                    // Het rooster import formulier weergeven.........
                    // ===============================================================
                    echo '<form method="post" action="' . $this->get_url() . '" name="importform" enctype="multipart/form-data">';
                    echo '<input type="hidden" name="schedule_id" value="' . $schedule_id . '" >';
                    echo '<input type="hidden" name="page" value="importroster" >';
                    echo '<input type="hidden" name="action" value="step2" >';
                    echo '<input type="hidden" name="MAX_FILE_SIZE" value="100000">';
                    echo '<table>
				<tr valign="top">
				<td align="right">
				' . get_lang('labelTeacherCol') . '
				</td>
				<td>
					<input type="text" name="teachersCol" size="2" maxlength="2" value="' . campus::get_POST_GET("teachersCol", 0) . '" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
				</td>
				<td align="right">
				' . get_lang('labelDisableRow1') . '
				</td>
				<td>
					<input type="checkbox" name="row1" value="on" ' . (($_POST['row1'] == 'on') ? "checked" : "") . '>
				</td>
				<td width="50%" rowspan="9">
					' . get_lang('helpRosterImport') . '<br>
					<div style="color: #777777">
						<u>' . get_lang('txtCsvImport') . '</u><br>
						 leerkracht;klas;vak;duur;lesuur;lokalen<br>
						 xxx;xxx;xxx;nnn;xxn;xxx<br>
						 xxx;xxx;xxx;nnn;xxn;xxx<br>
						<br><u>' . get_lang('txtCsvExample') . '</u><br>
						 leerkracht;klas;vak;duur;lesuur;lokalen<br>
						 THLU;1A1;INF;2;ma1;A001<br>
						 THLU LKRA;1A2 1A1;INF WIS;1;do5;A001 B101<br>
						 LKRC;1A3 1A4;NED;2;vr5;A001<br>
					</div>
				</td>
				</tr>
				<tr valign="top">
				<td align="right">
				' . get_lang('labelClassCol') . '
				</td>
				<td colspan="3">
					<input type="text" name="classesCol" size="2" maxlength="2" value="' . campus::get_POST_GET('classesCol', 1) . '" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
				</td>
				</tr>
				<tr valign="top">
				<td align="right">
				' . get_lang("labelDisciplineCol") . '
				</td>
				<td colspan="3">
					<input type="text" name="disciplineCol" size="2" maxlength="2" value="' . campus::get_POST_GET('disciplineCol', 2) . '" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
				</td>
				</tr>
				<tr valign="top">
				<td align="right">
				' . get_lang('labelScheduleCol') . '
				</td>
				<td colspan="3">
					<input type="text" name="timeCol" size="2" maxlength="2" value="' . campus::get_POST_GET('timeCol', 3) . '" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
				</td>
				</tr>
				<tr valign="top">
				<td align="right">
				' . get_lang('labelDurationCol') . '
				</td>
				<td colspan="3">
					<input type="text" name="durationCol" size="2" maxlength="2" value="' . campus::get_POST_GET('durationCol', 4) . '" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>
				</td>
				</tr>
				<tr valign="top">
				<td align="right">
				' . get_lang('labelResourceCol') . '
				</td>
				<td colspan="3">
					<input type="text" name="resourceCol" size="2" maxlength="2" value="' . campus::get_POST_GET('resourceCol', 5) . '" />
				</td>
				</tr>
				<tr valign="top">
				</tr>';
                    echo '<tr valign="top">
					<td align="right">
					' . get_lang('labelSelectFile2Import') . '
					</td>
					<td colspan="3">
					<input type="file" name="uploadfile" >
					<br />
					</td>
					</tr>';
                    echo '<tr valign="top">
				<td>
				</td>
				<td colspan="5">
					<input type="submit" name="submitmessage" value="' . get_lang("buttonlabelUpload") . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.importform.page.value=\'editcurriculum\';document.importform.action.value=\'\';">
				</td>
				</tr>
				</table>
				</form>';
                }
                break;
            case "step2" :
                {
                    $row1 = campus::get_POST_GET("row1", "off");

                    // teacher search array
                    $query = "SELECT `user_user`.`id`, `official_code` FROM `user_user`
										INNER JOIN `group_group_rel_user`
											ON `group_group_rel_user`.`user_id`= `user_user`.`id`
										INNER JOIN `campus_department_rel_group`
											ON `group_group_rel_user`.`group_id`= `campus_department_rel_group`.`group_id` AND `type`=1
										WHERE `department_id`=" . $department_id;
                    $result = mysql_query($query) or die(mysql_error());
                    while ($rij = mysql_fetch_array($result))
                    {
                        $teacher_id2code[$rij['id']] = $rij['official_code'];
                        $teacher_code2id[strtoupper($rij['official_code'])] = $rij['id'];
                    }

                    // group search array
                    $query = "SELECT `id`, `code` FROM `group_group` INNER JOIN `campus_department_rel_group`
							ON `group_group`.`id` = `campus_department_rel_group`.`group_id` AND `type`=2
		  				WHERE `department_id` = " . $department_id;
                    $result = mysql_query($query) or die(mysql_error());
                    while ($rij = mysql_fetch_array($result))
                    {
                        $group_id2code[$rij['id']] = $rij['code'];
                        $group_code2id[$rij['code']] = $rij['id'];
                    }

                    // discipline search array
                    $result = mysql_query("SELECT `id`, `code` FROM `campus_discipline` WHERE `department_id` = " . $department_id);
                    while ($rij = mysql_fetch_array($result))
                    {
                        $discipline_id2code[$rij['id']] = $rij['code'];
                        $discipline_code2id[$rij['code']] = $rij['id'];
                    }

                    $curriculum_assignment = array();
                    $result = mysql_query('SELECT `id`,`discipline_id`  FROM `campus_assignment` WHERE `curriculum_id`=' . $curriculum_id . ' ORDER BY `discipline_id`') or die(mysql_error());
                    $assignments = array();
                    while (list($assignment_id, $discipline_id) = mysql_fetch_row($result))
                    {
                        // put discipline in info
                        $info = $discipline_id2code[$discipline_id];
                        // GROUP ARRAY...
                        $groups = array();
                        $groups_key = '';
                        $result2 = mysql_query('SELECT DISTINCT `group_id` FROM `campus_assignment_rel_group` WHERE `assignment_id`=' . $assignment_id . ' ORDER BY `group_id`');
                        while (list($group_id) = mysql_fetch_row($result2))
                        {
                            $info.=' ' . $group_id2code[$group_id];
                            $groups_key.=$group_id . '_';
                            $groups[] = $group_id;
                        }

                        //create string from TEACHERs LINKED TO THIS assignment
                        $teacherlist = "";
                        $query2 = 'SELECT `user_id`,`name` FROM `campus_assignment_rel_teacher`
					  INNER JOIN `campus_roster`
						ON `campus_assignment_rel_teacher`.`roster_id`= `campus_roster`.`id`
                                          WHERE `assignment_id`=' . $assignment_id . '  ORDER BY `user_id`';
                        $result2 = mysql_query($query2);
                        while (list($user_id, $roster) = mysql_fetch_row($result2))
                        {
                            $info.=' ' . $roster . ': ' . $teacher_id2code[intval($user_id)];
                            $teacherlist.=$user_id . ',';
                        }
                        $assignment_rel_teacher[$assignment_id] = substr($teacherlist, 0, -1);
                        // add group combination assignment to array;
                        $curriculum_assignment[$discipline_id . ',' . substr($groups_key, 0, -1)][$assignment_id] = $info;
                        foreach ($groups as $key => $group_id)
                        {
                            $curriculum_assignment[$discipline_id . ',' . $group_id][$assignment_id] = $info;
                        }
                    }
                    // import the file...
                    if (!empty($_FILES))
                    {
                        //Het bestand inlezen ....
                        $lines = file($_FILES['uploadfile']['tmp_name']);
                        $assignments = array();
                        $i = 1;

                        unset($_SESSION['roster_import']);
                        echo '<form method="post" action="' . $this->get_url() . '" name="importform" enctype="multipart/form-data">';
                        echo '<input type="hidden" name="schedule_id" value="' . $schedule_id . '" >';
                        echo '<input type="hidden" name="page" value="importroster" >';
                        echo '<input type="hidden" name="action" value="step3" >';
                        echo '<table border="0">';

                        foreach ($lines as $key => $value)
                        {
                            if ((($row1 == 'off') && ($i == 1)) || ($i > 1))
                            {
                                echo '<tr>';
                                echo '<td>' . get_lang("txtLine") . $i++ . '</td>';
                                $assignmentOK = FALSE;
                                $values = explode(";", $value);
                                // extract values...
                                $valPeriodcode = trim($values[intval(campus::get_POST_GET("timeCol"))]);
                                $duration = trim($values[intval(campus::get_POST_GET("durationCol"))]);
                                $discipline_code = trim($values[intval(campus::get_POST_GET("disciplineCol"))]);
                                $valGroups = trim($values[intval(campus::get_POST_GET("classesCol"))]);
                                $valTeachers = trim($values[intval(campus::get_POST_GET("teachersCol"))]);
                                $valResources = trim($values[intval(campus::get_POST_GET("resourceCol"))]);


                                //check discipline and get IDs
                                echo '<td>' . get_lang("txtDiscipline") . ':';
                                echo " " . $discipline_code . "=";
                                if (intval($discipline_code2id[$discipline_code]) == 0)
                                {
                                    echo "<b style='color: red'>" . get_lang("txtFailed") . "</b> ";
                                    $discipline_id = 0;
                                }
                                else
                                {
                                    echo "<b style='color: green'>" . get_lang("txtSucces") . "</b> ";
                                    $discipline_id = intval($discipline_code2id[$discipline_code]);
                                }
                                echo '</td><td>';
                                //check classes and get IDs
                                $groups = explode(" ", $valGroups);
                                sort($groups);
                                $group_ids = array();
                                echo get_lang("txtClasses") . ":";
                                foreach ($groups as $group_code)
                                {
                                    echo " " . $group_code . "=";
                                    if (intval($group_code2id[$group_code]) == 0)
                                    {
                                        echo "<b style='color: red'>" . get_lang("txtFailed") . "</b> ";
                                    }
                                    else
                                    {
                                        echo "<b style='color: green'>" . get_lang("txtSucces") . "</b> ";
                                        $group_ids[] = intval($group_code2id[$group_code]);
                                    }
                                }
                                echo '</td><td>';


                                //check teachers and get IDs
                                $teachers = explode(" ", $valTeachers);
                                sort($teachers);
                                $teacher_ids = array();
                                echo get_lang("txtTeachers") . ":";
                                foreach ($teachers as $official_code)
                                {
                                    echo " " . $official_code . "=";
                                    if (intval($teacher_code2id[strtoupper($official_code)]) == 0)
                                    {
                                        echo "<b style='color: red'>" . get_lang("txtFailed") . "</b> ";
                                    }
                                    else
                                    {
                                        echo "<b style='color: green'>" . get_lang("txtSucces") . "</b> ";
                                        $teacher_ids[] = intval($teacher_code2id[strtoupper($official_code)]);
                                    }
                                }
                                sort($teacher_ids);
                                $teacherlist = implode(',', $teacher_ids);
                                echo '</td><td>';

                                // check timing and get ID

                                $result = mysql_query('SELECT `id` FROM `campus_period` WHERE `department_id` = ' . $department_id . ' AND `code`="' . $valPeriodcode . '"');
                                $period_id = mysql_result($result, 0, 0);

                                echo get_lang("txtHour") . " " . $valPeriodcode . "=" . (($period_id == "") ? ("<b style='color: red'>" . get_lang("txtFailed") . "</b>") : ("<b style='color: green'>" . get_lang("txtSucces") . "</b>")) . " ";
                                echo get_lang("txtDuration") . " " . $duration . "=" . ((is_numeric($duration) && (intval($duration) == $duration)) ? ("<b style='color: green'>" . get_lang("txtSucces") . "</b>") : ("<b style='color: red'>" . get_lang("txtFailed") . "</b>")) . " ";
                                echo '</td><td>';

                                // check resources and get IDs
                                $resources = explode(" ", $valResources);
                                echo get_lang("txtResources") . ":";
                                $resource_ids = array();
                                foreach ($resources as $resource_code)
                                {
                                    $result = mysql_query("SELECT `id` FROM `campus_resource` WHERE `code` = '" . $resource_code . "' AND `department_id`= " . $department_id . " LIMIT 1");
                                    $resource_id = mysql_result($result, 0, 0);
                                    echo " " . $resource_code . "=";
                                    if (intval($resource_id) == 0)
                                    {
                                        echo "<b style='color: red'>" . get_lang("txtFailed") . "</b> ";
                                    }
                                    else
                                    {
                                        echo "<b style='color: green'>" . get_lang("txtSucces") . "</b> ";
                                        $resource_ids[] = intval($resource_id);
                                    }
                                }
                                echo '</td><td>';

                                if ($discipline_id > 0)
                                {
                                    //**************** IMPORT **********
                                    $assignment_ids = array();
                                    // check possible assignments....
                                    if (empty($group_ids))
                                    {
                                        foreach ($curriculum_assignment[$discipline_id . ',' ] as $assignment_id => $value)
                                        {
                                            $assignment_ids[$assignment_id] = $value;
                                        }
                                    }
                                    else
                                    {
                                        foreach ($group_ids as $group_id)
                                        {
                                            foreach ($curriculum_assignment[$discipline_id . ',' . $group_id] as $assignment_id => $value)
                                            {
                                                $assignment_ids[$assignment_id] = $value;
                                            }
                                        }
                                    }
                                    if (!empty($assignment_ids))
                                    {//check if assignment exists.
                                        echo '<b style="color: green">' . get_lang("txtFound") . '</b> ';

                                        if (count($assignment_ids) == 1)
                                        {
                                            echo current($assignment_ids);
                                            $assignment_id = key($assignment_ids);
                                            //echo '<input type="hidden" name="import_assignment[' . $i . ']" value="' . $assignment_id . '">';
                                        }
                                        else
                                        {
                                            echo '<select name="assignment_selection[' . $i . ']">';
                                            $found = 0;
                                            foreach ($assignment_ids as $assignment_id => $value)
                                            {
                                                if ($teacherlist == $assignment_rel_teacher[$assignment_id])
                                                    $found = 1;
                                                echo '<option value="' . $assignment_id . '" ' . (($teacherlist == $assignment_rel_teacher[$assignment_id]) ? 'selected' : '') . '>' . $value . '</option>';
                                            }
                                            echo '</select>';
                                            echo $found ? '' : "<b style='color: redorange'>" . get_lang("txtTeacherChange") . "</b> ";
                                        }

                                        $_SESSION['roster_import'][$i] = array('assignment_id' => $assignment_id, 'info' => $info, 'teachers' => $teacher_ids, 'period_id' => $period_id, 'duration' => $duration, 'resources' => $resource_ids);
                                        //echo '<input type="hidden" name="import_assignment[' . $i . '][assignment_id]" value="' . $teacher_id . '">';
                                    }
                                    else
                                    {
                                        echo "<b style='color: red'>" . get_lang("txtNoAssignmentFound") . "</b> ";
                                    }
                                }
                                else
                                {
                                    echo "<b style='color: red'>" . get_lang("txtAssignmentNotAddedNoDiscipline") . "</b> ";
                                }
                                echo '</td>';
                            }
                            else
                            {
                                $i++;
                                echo '<td colspan="7">';
                                echo get_lang("txtLine1Ignored");
                                echo '</td>';
                            }
                            echo '</tr>';
                        }
                        echo '</table>';
                        echo '<tr valign="top">
				<td>
				</td>
				<td colspan="5">
					<input type="submit" name="submitmessage" value="' . get_lang("buttonlabelImport") . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.importform.page.value=\'editcurriculum\';document.importform.action.value=\'\';">
				</td>
				</tr>
				</table>
				</form>';
                    }
                }
                break;
            case "step3" :
                {


                    if (!empty($_SESSION['roster_import']))
                    {
                        $assignment_selection = campus::get_POST_GET('assignment_selection');
                        foreach ($_SESSION['roster_import'] as $key => $values)
                        {
                            echo $values['info'] . ' ';
                            $assignment_id = (array_key_exists($key, $assignment_selection)) ? $assignment_selection[$key] : intval($values['assignment_id']);
                            echo '(' . $assignment_id . ')';
                            if ($assignment_id > 0)
                            {
                                // add teacher to assignment for this roster....
                                foreach ($values['teachers'] as $teacher_id)
                                {  //// the assigment exists continue import of information
                                    if ($teacher_id > 0)
                                    { // add teacher to assignment for selected roster....
                                        $result = mysql_query('SELECT * FROM `campus_assignment_rel_teacher` WHERE `assignment_id`=' . $assignment_id . ' AND `user_id`=' . $teacher_id . ' AND `roster_id`=' . $roster_id);
                                        if (mysql_num_rows($result) == 0)
                                        { // ADD only when not allready exists
                                            $result = mysql_query('INSERT `campus_assignment_rel_teacher` SET `assignment_id`=' . $assignment_id . ', `user_id`=' . $teacher_id . ', `roster_id`=' . $roster_id);
                                        }
                                    }
                                }
                                if (($values['period_id'] > 0) && ($values['duration'] > 0))
                                {
                                    $query = 'INSERT INTO `campus_college` SET
                                                    `period_id`=' . $values['period_id'] . ',
                                                    `duration`=' . $values['duration'] . ',
                                                    `assignment_id`=' . $assignment_id . ',
                                                    `roster_id`=' . $roster_id . '';
                                    $result = mysql_query($query);
                                    if ($result)
                                    {
                                        $college_id = mysql_insert_id();
                                        echo get_lang("txtCollegeAdded") . "=<b style='color: green'>" . get_lang("txtSucces") . "</b> ";
                                        foreach ($values['resources'] as $resource_id)
                                        {
                                            if ($resource_id > 0)
                                            {
                                                $result = mysql_query('SELECT * FROM `campus_college_rel_resource` WHERE `college_id`=' . $college_id . ' AND `resource_id`=' . $resource_id);
                                                if (mysql_num_rows($result) == 0)
                                                { // ADD only when not allready exists
                                                    $result = mysql_query('INSERT `campus_college_rel_resource` SET `college_id`=' . $college_id . ', `resource_id`=' . $resource_id);
                                                }
                                            }
                                        }
                                    }
                                    else
                                    {
                                        echo "<b style='color: red'>" . get_lang("txtCollegeNotAdded") . "</b> ";
                                    }
                                }
                                else
                                {
                                    echo "<b style='color: red'>" . get_lang("txtCollegeNotAdded") . "</b> ";
                                }
                            }
                            else
                            {
                                echo "<b style='color: red'>" . get_lang("txtCollegeNotAdded") . "</b> ";
                            }
                            echo "<br>";
                        }
                        unset($_SESSION['roster_import']);

                        $message = get_lang("msgRosterFileImported");
                    }
                    else
                    {
                        $errormessage = get_lang("msgEmptyRosterFile");
                    }
                }
                break;
            default :
                {
                    $display = "list";
                }
                break;
        }
    }
    else
    {
        $errormessage = get_lang("msgScheduleError");
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }

    if (!empty($warningmessage))
    {
        Display::warning_message($warningmessage, false);
    }

    if (!empty($errormessage))
    {
        Display::error_message($errormessage, false);
    }
}
?>