<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Text;
use common\libraries\Display;
use common\libraries\PlatformSetting;

//check if user is allowed here...
if ((intval($_uid) == 0) ||  (empty($admin['student']) && !$is_platformadmin))
{// not allowed here!
	Display::warning_message(get_lang("msgNoRights4ThisDepartment"),false);
}
else
{//only departmentadmins and platform administrator is allowed here...

/*
============================================================================== 
		POST & GET vars, check for default value?.
============================================================================== 
*/
	// de department detail info ophalen.
	$action=campus::get_POST_GET("action","step1");
	$teacherCol=campus::get_POST_GET("teacherCol");
	$classCol=campus::get_POST_GET("classCol");
	$row1=campus::get_POST_GET("row1","off");


/*
============================================================================== 
		display ...
============================================================================== 
*/
	
	if (!empty($message))
	{		
		Display::normal_message($message,false);
	}

	
	// de verschillende klassen die tot een bepaalde department behoren ophalen....
	$classes=campus::get_studentclasses ($department_id);

	switch ($action)
	{
		case "step1" :
		{ 
			// reset session....
			unset($_SESSION['classimport']);
			/*
			============================================================================== 
				Step 1: display importform.....
				Select import-file and select cols....
			============================================================================== 
			*/
			echo '<form method="post" action="'.$this->get_url().'" name="importform" enctype="multipart/form-data">';
			echo '<input type="hidden" name="action" value="step2" >';
			echo '<input type="hidden" name="page" value="importteacher2studentclasses" >';
			echo '<input type="hidden" name="MAX_FILE_SIZE" value="100000">';
			echo ' <table>
				<tr valign="top">
					<td align="right">
						'.get_lang('labelDisableRow1').':					
					</td>
					<td>
						<input type="checkbox" name="row1" value="on" checked>
					</td>
				</tr>
				<tr valign="top">
					<td align="right">
						'.get_lang('labelSelectFile2Import').':
					</td>
					<td>
						<input type="file" name="uploadfile" >
						<br />
					</td>	
				</tr>
				<tr valign="top">
					<td>
					</td>
					<td>
						<input type="submit" name="submitmessage" value="'.get_lang('buttonlabelUpload').'" />&nbsp;&nbsp;<input type="submit" name="cancel" value="'.get_lang("buttonlabelCancel").'" onMouseDown="javascript:document.importform.page.value=\'editteacher2studentclass\';document.importform.action.value=\'list\';">
					</td>
				</tr>
				<tr>
					<td colspan=3>
						'.get_lang('helpTeacher2StudentclassImport').'<br>
						<div style="color: #777777">
							<u>'.get_lang('txtCsvImport').'</u><br>
							 klas;Leerkracht<br>
							 xxx;xxx<br>
							 xxx;xxx<br>
							<br><u>'.get_lang('txtCsvExample').'</u><br>
							 klas;Leerkracht<br>
							 1A1;THLU<br>
							 1A2;LKR2<br>
						</div>
					</td>
				</tr>
			       </table>
			      </form>';
		}
		break;
		case "step2":
		{
/*
============================================================================== 
			Step 2: check new users with existing platform users...
			Show import options....
============================================================================== 
*/
			if (!empty($_FILES)) // het bestand lezen...
			{
				//Het bestand inlezen ....
				$lines=file($_FILES['uploadfile']['tmp_name']); 
				$_SESSION['classimport']=$lines;
				echo '<form method="post" action="'.$this->get_url().'" name="importform">';
				echo '<input type="hidden" name="action" value="step3" >';
				echo '<input type="hidden" name="page" value="importteacher2studentclasses" >';
				echo '<input type="hidden" name="row1" size="2" maxlength="2" value="'.$row1.'" />';
				campus::display_complex_table_header($properties, array(get_lang("colheadLineNr"),get_lang("colheadClass"),get_lang("colheadExists"),get_lang("colheadTeacher"),get_lang("colheadExists")));
				$records=0;
				foreach ($lines as $lijnnr => $value) 
				{
					if ((($row1=='off') && ($lijnnr==0)) || ($lijnnr>0))
					{
						$records++;
						$data=array();
						// als textChar leeg is een 
						$values=explode(";",$value);	
						// extract values...
						$data[]=$lijnnr;
						// extract values...
						$valClass=trim($values[0]);
						$valTeacher= trim($values[1]);
						// class
						$data[]=$valClass;
						$msg=get_lang("txtFailed");
						foreach($classes as $class_id => $value) 
						{
							if ($value['code']== $valClass) 
							{
								$msg=get_lang("txtSucces");
								break;
							} 
						} 
						$data[]=$msg;
						//  de gebruiker opzoeken op het platform...
						$sql = 'SELECT `lastname`, `firstname` FROM `user_user` WHERE `official_code` = "'.$valTeacher.'" ';
						$result = mysql_query($sql);
						$aantal=mysql_num_rows($result);
						$rijuser=mysql_fetch_array($result,MYSQL_ASSOC);
						$data[]=$rijuser['firstname']." ".$rijuser['lastname']." (".$valTeacher.")";
						$data[]=(empty($rijuser) ? get_lang("txtFailed") : (($aantal>1) ? "<b style='color:red'>".get_lang("txtDoubleUserData")."</b>" : get_lang("txtSucces")));
					}
					campus::display_table_row($bgcolor, $data, true);
				}
				campus::display_table_footer();
				echo get_lang('txtNoRecords').' '.$records;
				echo '<input type="submit" name="submitmessage" value="'.get_lang('buttonlabelExecute').'">&nbsp;&nbsp;<input type="submit" name="cancel" value="'.get_lang('buttonlabelCancel').'" onMouseDown="javascript:document.importform.page.value=\'editteacher2studentclass\';document.importform.action.value=\'list\';">';
				echo '</form>';
			}
		}
		break;
		case "step3":
		{
/*
============================================================================
		 Stap 3: Uitvoeren van de acties, geef het resultaat weer.
============================================================================
*/
			if (!empty($_SESSION['classimport'])) // het bestand lezen...
			{	
				//Het bestand inlezen ....
				$lines=$_SESSION['classimport']; 
				campus::display_complex_table_header($properties, array(get_lang("colheadLineNr"),get_lang("colheadClass"),get_lang("colheadTeacher"),get_lang("colheadResult")));
				$records=0;
				foreach ($lines as $lijnnr => $value) 
				{
					if ((($row1=='off') && ($lijnnr==0)) || ($lijnnr>0))
					{
						$records++;
						$data=array();
						$data[]=$lijnnr;
						$values=explode(";",$value);	
						// extract values...
						$valClass=trim($values[0]);
						$valTeacher=trim($values[1]);
						// class id bepalen
						foreach($classes as $class_id => $value) 
						{
							if ($value['code']== $valClass) 
							{
								break;
							} 
							$class_id=0;
						} 
						$sql = 'SELECT `id`, `lastname`, `firstname` FROM `user_user` WHERE `official_code` = "'.$valTeacher.'" ';
						$result = mysql_query($sql);
						$aantal=mysql_num_rows($result);
						$rijuser=mysql_fetch_array($result,MYSQL_ASSOC);
						$data[]=$valClass;
						$data[]=$rijuser['firstname']." ".$rijuser['lastname']." (".$valTeacher.")";
						if (($aantal==1)&&($class_id!=0))
						{
							// add teacher to studentclass.....			// set student active
							$query="INSERT `campus_teacher_rel_group` SET
									`teacher_id`=".$rijuser['id'].",
									`group_id`=".$class_id.",
									`department_id`=".$department_id."
							";
							$result=mysql_query($query);
							if ($result)
							{
								$data[]="<b style='color:green'>".get_lang("msgItemAddSucces")."</b>";
							}
							else
							{	
								$data[]= "<b style='color:red'>".get_lang("msgItemAddError")."</b>";
							}
						}
						else
						{
							$data[]=get_lang("msgItemNotAdded");
						}
					}
					campus::display_table_row($bgcolor, $data, true);
				}
			}
			campus::display_table_footer();
			echo get_lang("txtNoRecords")." ".$records;
                        echo '<br><a href="'.$this->get_url().'&page=editteacher2studentclass">'.get_lang("txtBack").'</a>';

                        }
		break;
	}
}
?>
