<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['roster']) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    // het actieve uurrooster van de department bepalen...
    $activeroster = campus::get_activeroster($department_id);
    $action = campus::get_POST_GET("action");
    $submitmessage = campus::get_POST_GET("submitmessage");
    $curriculum_id = intval(campus::get_POST_GET("curriculum_id"));
    $roster_id = intval(campus::get_POST_GET("roster_id"));
    $assignment_id = intval(campus::get_POST_GET("assignment_id"));
    $schedule_id = intval(campus::get_POST_GET("schedule_id"));
    $college_id = intval(campus::get_POST_GET("college_id"));
    $filter = campus::get_POST_GET("filter");
    $week = DatetimeUtilities::get_days_long();

    /*
      ==============================================================================
      Update query's execute actions...
      ==============================================================================
     */
    $message = '';
    $errormessage = '';
    $warningmessage = '';

    switch ($action)
    {
        case "optimize1" :
            {
                if ($schedule_id != 0)
                {
                    // combine assignment when groups, discipline and teachers are the same!!!!
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $curriculum_id = campus::get_roster2curriculum($roster_id);

                    $result = mysql_query('SELECT *  FROM `campus_roster` WHERE `curriculum_id`=' . $curriculum_id);
                    if (mysql_num_rows($result) == 1)
                    {
                        // check if roster delete is allowed, is agenda already filled in?
                        $result = mysql_query('SELECT * FROM `campus_assignment`
                                                        INNER JOIN `campus_agenda` ON `campus_assignment`.`id`= `campus_agenda`.`assignment_id` AND `curriculum_id`=' . $curriculum_id);

                        if (mysql_num_rows($result) == 0)
                        {
                            // check if report exists
                            $result = mysql_query('SELECT * FROM `campus_assignment`
                                                        INNER JOIN `campus_reportcard` ON `campus_assignment`.`id`= `campus_reportcard`.`assignment_id` AND `curriculum_id`=' . $curriculum_id);
                            if (mysql_num_rows($result) == 0)
                            {
                                $result = mysql_query('SELECT `id`,`discipline_id`  FROM `campus_assignment` WHERE `curriculum_id`=' . $curriculum_id . ' ORDER BY `discipline_id`') or die(mysql_error());
                                $assignments = array();
                                while (list($assignment_id, $discipline_id) = mysql_fetch_row($result))
                                {
                                    // put discipline in key...
                                    $key = $discipline_id . ',';

                                    //create string from TEACHERs LINKED TO THIS assignment
                                    $result2 = mysql_query('SELECT `user_id` FROM `campus_assignment_rel_teacher` WHERE `assignment_id`=' . $assignment_id . ' AND `roster_id`=' . $roster_id . ' ORDER BY `user_id`');
                                    while (list($user_id) = mysql_fetch_row($result2))
                                    {
                                        $key.=intval($user_id) . "_";
                                    }
                                    $key = substr($key, 0, -1) . ",";
                                    // CLASSES ARRAY...
                                    $result2 = mysql_query('SELECT `group_id` FROM `campus_assignment_rel_group` WHERE `assignment_id`=' . $assignment_id . ' ORDER BY `group_id`');
                                    while (list($group_id) = mysql_fetch_row($result2))
                                    {
                                        $key.=intval($group_id) . "_";
                                    }
                                    $assignments[$key][] = $assignment_id;
                                }

                                $message = get_lang("msgNoOptimizingNeeded");
                                foreach ($assignments as $key => $values)
                                {
                                    $assignment_id = 0;
                                    foreach ($values as $key2 => $assignment_ids)
                                    {
                                        if ($assignment_id == 0)
                                        {
                                            $assignment_id = $assignment_ids;
                                        }
                                        if ($assignment_id <> $assignment_ids)
                                        {
                                            $message = get_lang("msgAssignmentsOptimized");
                                            $query = 'UPDATE `campus_college` SET `assignment_id`=' . $assignment_id . ' WHERE `roster_id`=' . $roster_id . ' AND `assignment_id`=' . $assignment_ids;
                                            $result = mysql_query($query);
                                        }
                                    }
                                }
                            }
                            else
                            {
                                $errormessage = get_lang("msgOptimalizationNotPossible") . '<br>' . get_lang("msgReportExist");
                            }
                        }
                        else
                        {
                            $errormessage = get_lang("msgOptimalizationNotPossible") . '<br>' . get_lang("msgFilledinAgendasExist");
                        }
                    }
                    else
                    {
                        $errormessage = get_lang("msgOptimalizationNotPossible") . '<br>' . get_lang("msgMoreThen1RosterExist");
                    }
                }
                else
                {
                    $errormessage = get_lang("msgScheduleError");
                }


                $display = "list";
            }
            break;
        case "optimize2" :
            {
                if ($schedule_id != 0)
                {
                    // remove duplicate college's
                    $message = get_lang("msgNoOptimizingNeeded");
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $curriculum_id = campus::get_roster2curriculum($roster_id);

                    $result = mysql_query('SELECT `id`  FROM `campus_assignment` WHERE `curriculum_id`=' . $curriculum_id);
                    while (list($assignment_id) = mysql_fetch_row($result))
                    {
                        //Check colleges
                        $result2 = mysql_query('SELECT `id`, `period_id`, `duration` FROM `campus_college` WHERE `assignment_id`=' . $assignment_id . ' AND `roster_id`=' . $roster_id . ' ORDER BY `period_id`,  `duration`');
                        $prevcollege = "";
                        while (list($college_id, $period_id, $duration) = mysql_fetch_row($result2))
                        {
                            //create string from RESOURCEs LINKED TO THIS roster
                            $result3 = mysql_query('SELECT `resource_id` FROM `campus_college_rel_resource` WHERE `college_id`=' . $college_id . ' ORDER BY `resource_id`');
                            $collegeresource = "";
                            while (list($resource_id) = mysql_fetch_row($result3))
                            {
                                $collegeresource.=intval($resource_id) . '_';
                            }
                            $college = $period_id . '_' . $duration . '_' . $collegeresource;
                            if ($prevcollege == $college)
                            {
                                $message = get_lang('msgDuplicatesRemoved');
                                $result4 = mysql_query('DELETE `campus_college`, `campus_college_rel_resource`
                                                        FROM `campus_college`
                                                            LEFT JOIN `campus_college_rel_resource`
                                                                ON `campus_college`.`id`=`campus_college_rel_resource`.`college_id`
                                                        WHERE `id`=' . $college_id);
                            }
                            $prevcollege = $college;
                        }
                    }
                }
                else
                {
                    $errormessage = get_lang("msgScheduleError");
                }
                $display = "list";
            }
            break;
        case "optimize3" :
            {
                if ($schedule_id != 0)
                {
                    // combine assignment when groups, discipline and teachers are the same!!!!
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $curriculum_id = campus::get_roster2curriculum($roster_id);

                    $result = mysql_query('SELECT *  FROM `campus_roster` WHERE `curriculum_id`=' . $curriculum_id);
                    if (mysql_num_rows($result) == 1)
                    {
                        // check if roster delete is allowed, is agenda already filled in?
                        $result = mysql_query('SELECT * FROM `campus_assignment`
                                                        INNER JOIN `campus_agenda` ON `campus_assignment`.`id`= `campus_agenda`.`assignment_id` AND `curriculum_id`=' . $curriculum_id);

                        if (mysql_num_rows($result) == 0)
                        {
                            // check if report exists
                            $result = mysql_query('SELECT * FROM `campus_assignment`
                                                        INNER JOIN `campus_reportcard` ON `campus_assignment`.`id`= `campus_reportcard`.`assignment_id` AND `curriculum_id`=' . $curriculum_id);
                            if (mysql_num_rows($result) == 0)
                            {
                                $result = mysql_query('SELECT `id`,`discipline_id`, `group_id`  FROM `campus_assignment`
                                                        INNER JOIN `campus_assignment_rel_group` ON `campus_assignment`.`id` = `campus_assignment_rel_group`.`assignment_id`
                                                     WHERE `curriculum_id`=' . $curriculum_id . ' ORDER BY `discipline_id`, `group_id`');
                                $assignments = array();
                                while (list($assignment_id, $discipline_id, $group_id) = mysql_fetch_row($result))
                                {
                                    // put discipline in key...
                                    $key = $discipline_id . ',';

                                    //create string from TEACHERs LINKED TO THIS assignment
                                    $result2 = mysql_query('SELECT `user_id` FROM `campus_assignment_rel_teacher` WHERE `assignment_id`=' . $assignment_id . ' AND `roster_id`=' . $roster_id . ' ORDER BY `user_id`, `assignment_id`') or die(mysql_error());
                                    while (list($user_id) = mysql_fetch_row($result2))
                                    {
                                        $key.=intval($user_id) . "_";
                                    }
                                    $key = substr($key, 0, -1) . ",";

                                    //COLLEGE...

                                    $result2 = mysql_query('SELECT `id`, `period_id`, `duration` FROM `campus_college` WHERE `assignment_id`=' . $assignment_id . ' ORDER BY `period_id`,  `duration`');
                                    while (list($college_id, $period_id, $duration) = mysql_fetch_row($result2))
                                    {
                                        //create string from RESOURCEs LINKED TO THIS roster
                                        $result3 = mysql_query('SELECT `resource_id` FROM `campus_college_rel_resource` WHERE `college_id`=' . $college_id . ' ORDER BY `resource_id`');
                                        $collegeresource = "";
                                        while (list($resource_id) = mysql_fetch_row($result3))
                                        {
                                            $collegeresource.=intval($resource_id) . '_';
                                        }
                                        $key.=intval($period_id) . '_' . intval($duration) . '_' . intval($collegeresource) . ',';
                                    }
                                    $key = substr($key, 0, -1);
                                    $assignments[$key][] = array('assignment_id' => $assignment_id, 'group_id' => $group_id);
                                }
                                //ksort($assignments);
                                $message = get_lang("msgNoOptimizingNeeded");
                                foreach ($assignments as $assignmentkey => $details)
                                {
                                    $assignment_id = 0;
                                    foreach ($details as $key => $value)
                                    {
                                        if ($assignment_id == 0)
                                        {
                                            $assignment_id = $value['assignment_id'];
                                        }
                                        if ($assignment_id <> $value['assignment_id'])
                                        {
                                            $message = get_lang("msgAssignmentsOptimized");

                                            $result = mysql_query('SELECT * FROM `campus_assignment_rel_group` WHERE `assignment_id`=' . $assignment_id . ' AND `group_id` =' . $value['group_id']);
                                            if (mysql_num_rows($result) == 0)
                                            {

                                                $query = 'UPDATE `campus_assignment_rel_group` SET `assignment_id`=' . $assignment_id . ' WHERE `assignment_id`=' . $value['assignment_id'] . ' AND `group_id` =' . $value['group_id'];
                                                $result = mysql_query($query);
                                            }
                                            $query = 'DELETE  FROM `campus_college` WHERE `roster_id`=' . $roster_id . ' AND `assignment_id`=' . $value['assignment_id'];
                                            $result = mysql_query($query);
                                        }
                                    }
                                }
                            }
                            else
                            {
                                $errormessage = get_lang("msgOptimalizationNotPossible") . '<br>' . get_lang("msgReportExist");
                            }
                        }
                        else
                        {
                            $errormessage = get_lang("msgOptimalizationNotPossible") . '<br>' . get_lang("msgFilledinAgendasExist");
                        }
                    }
                    else
                    {
                        $errormessage = get_lang("msgOptimalizationNotPossible") . '<br>' . get_lang("msgMoreThen1RosterExist");
                    }
                }
                else
                {
                    $errormessage = get_lang("msgScheduleError");
                }

                $display = "list";
            }
            break;
        case "optimize4" :
            {
                if ($schedule_id != 0)
                {
                    // combine college houres in blocks.. when groups, discipline and teachers are the same!!!!
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $curriculum_id = campus::get_roster2curriculum($roster_id);
                    $update_college = array();
                    $delete_college = array();
                    $update_display_order = 0;
                    $update_college_id = 0;

                    $result = mysql_query('SELECT `id`  FROM `campus_assignment` WHERE `curriculum_id`=' . $curriculum_id);
                    while (list($assignment_id) = mysql_fetch_row($result))
                    {
                        //Check colleges
                        $query2 = 'SELECT `campus_college`.`id`, `weekday`,`display_order`,`duration` FROM `campus_college`
                                        INNER JOIN `campus_period`
                                            ON `campus_period`.`id`= `campus_college`.`period_id`
                                        WHERE `assignment_id`=' . $assignment_id . ' AND `roster_id`=' . $roster_id . '
                                            ORDER BY `weekday`,`display_order`,`duration`';
                        $result2 = mysql_query($query2) or die(mysql_error());
                        $prevcollege = "";
                        $prev_display_order = 0;
                        $new_duration = 1;
                        while (list($college_id, $weekday, $display_order, $duration) = mysql_fetch_row($result2))
                        {
                            //create string from RESOURCEs LINKED TO THIS roster
                            $result3 = mysql_query('SELECT `resource_id` FROM `campus_college_rel_resource` WHERE `college_id`=' . $college_id . ' ORDER BY `resource_id`');
                            $collegeresource = "";
                            while (list($resource_id) = mysql_fetch_row($result3))
                            {
                                $collegeresource.=intval($resource_id) . '_';
                            }
                            $college = $weekday . '_' . $collegeresource;
                            if ($prevcollege == $college)
                            {
                                if (($prev_display_order + 1) >= $display_order)
                                {
                                    $new_duration+=$duration;
                                    $delete_college[] = $college_id;
                                    $update_college[$update_college_id] = $new_duration;
                                }
                                else
                                {
                                    $update_college_id = $college_id;
                                    $new_duration = 1;
                                }
                                $prev_display_order = $display_order + ($duration - 1);
                            }
                            else
                            {
                                $update_college_id = $college_id;
                                $prev_display_order = $display_order;
                                $new_duration = 1;
                            }
                            $prevcollege = $college;
                        }
                    }
                    //echo $query4;

                    foreach ($delete_college as $key => $college_id)
                    {
                        $query = 'DELETE `campus_college`,`campus_college_rel_resource` FROM `campus_college`
                                    LEFT JOIN `campus_college_rel_resource` ON `campus_college`.`id`=`campus_college_rel_resource`.`college_id`
                                        WHERE `campus_college`.`id`=' . $college_id;
                        $result = mysql_query($query);
                    }
                    foreach ($update_college as $college_id => $duration)
                    {
                        $query = 'UPDATE `campus_college` SET `duration`=' . $duration . '
                                        WHERE `campus_college`.`id`=' . $college_id;
                        $result = mysql_query($query);
                    }
                }
                else
                {
                    $errormessage = get_lang("msgScheduleError");
                }

                $display = "list";
            }
            break;
        case "cleanup" :
            {
                if ($schedule_id != 0)
                {// cleanup assignments without college ....
                    $message = get_lang("msgNothingDeleted");
                    $roster_id = campus::get_schedule2roster($schedule_id);
                    $curriculum_id = campus::get_roster2curriculum($roster_id);
                    $result = mysql_query('SELECT `campus_assignment`.`id` as assignment_id, `campus_college`.`id` as college_id FROM `campus_assignment`
                                                 LEFT JOIN `campus_college` ON `campus_assignment`.`id`=`campus_college`.`assignment_id` 
                                                 WHERE `curriculum_id`=' . $curriculum_id . ' AND `campus_college`.`id` is null') or die(mysql_error());
                    while (list($assignment_id) = mysql_fetch_row($result))
                    {
                        $result2 = mysql_query('SELECT * FROM `campus_agenda` WHERE `assignment_id`=' . $assignment_id);
                        if (mysql_num_rows($result2) == 0)
                        {
                            $result2 = mysql_query('SELECT * FROM `campus_objective_view_rel_assignment` WHERE `assignment_id`=' . $assignment_id);
                            if (mysql_num_rows($result2) == 0)
                            {
                                $result2 = mysql_query('SELECT * FROM `campus_reportcard` WHERE `assignment_id`=' . $assignment_id);
                                if (mysql_num_rows($result2) == 0)
                                {
                                    // delete teacher from assignment
                                    $result2 = mysql_query("DELETE FROM `campus_assignment_rel_teacher` WHERE `assignment_id`=" . $assignment_id);
                                    // de gelinkte klassen verwijderen...
                                    $result2 = mysql_query("DELETE FROM `campus_assignment_rel_group` WHERE `assignment_id`=" . $assignment_id);
                                    // de gelinkte lokalen verwijderen...
                                    $result2 = mysql_query("DELETE FROM `campus_assignment` WHERE `id`=" . $assignment_id . " ");
                                    $message = get_lang("msgAssignmentsDeleted");
                                }
                                else
                                {
                                    $errormessage = get_lang("msgNotAlAssignmentsDeleted");
                                }
                            }
                            else
                            {
                                $errormessage = get_lang("msgNotAlAssignmentsDeleted");
                            }
                        }
                        else
                        {
                            $errormessage = get_lang("msgNotAlAssignmentsDeleted");
                        }
                    }
                }
                else
                {
                    $errormessage = get_lang("msgScheduleError");
                }

                $display = "list";
            }
            break;
        default :
            {
                $display = "list";
            }
            break;
    }

    include("editcurriculum.php");
}
?>