<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Theme;
use common\libraries\Display;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['student']) && !$is_platformadmin))
{// not allowed here!
    Display::display_error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */

    $action = campus::get_POST_GET("action");
    $select = intval(campus::get_POST_GET("select"));
    $user_id = intval(campus::get_POST_GET("user_id"));
    $group_id = intval(campus::get_POST_GET("class_id"));
    $addstudent = intval(campus::get_POST_GET("addstudent"));
    $removestudent = intval(campus::get_POST_GET("removestudent"));
    $addparent = intval(campus::get_POST_GET("addparent"));
    $removeparent = intval(campus::get_POST_GET("removeparent"));
    $search = campus::get_POST_GET("search");
    $userinfo = campus::get_user_info($user_id);
    $result = mysql_query("SELECT `id`,`name` FROM `campus_department_rel_group`
				INNER JOIN `group_group`
					ON `group_group`.`id` = `campus_department_rel_group`.`group_id` AND `type`=3
				WHERE `campus_department_rel_group`.`department_id` = '" . $department_id . "'
					 LIMIT 1");
    list ($parentgroupid, $parentgroupname) = mysql_fetch_row($result);


    if (intval($parentgroupid) == 0)
    {
        Display::error_message(get_lang('msgNoParentClass'), false);
    }
    else
    {

        /*
          -----------------------------------------------------------
          execute actions....
          -----------------------------------------------------------
         */
        $message = "";
        switch ($action)
        {
            case "studentform" :
                {
                    $display = "addstudentform";
                }
                break;
            case "add" :
                {
                    if (($user_id > 0) || ($addstudent > 0))
                    {
                        $result = mysql_query("INSERT `campus_parent_rel_student` SET  `parent_id`=" . $user_id . ", `student_id`=" . $addstudent);
                    }
                    else
                    {
                        $message = get_lang("msg");
                    }
                    $display = "addstudentform";
                }
                break;
            case "delete" :
                {
                    if (($user_id > 0) || ($removestudent > 0))
                    {
                        $result = mysql_query("DELETE FROM `campus_parent_rel_student` WHERE  `parent_id`=" . $user_id . " AND `student_id`=" . $removestudent);
                        $display = "addstudentform";
                    }
                    else
                    {
                        $display = "addstudentform";
                    }
                }
                break;
            case "release" :
                {
                    // first delete de student from courses connected to old class
                    $result = mysql_query("UPDATE `user_user` SET `active`=1 WHERE `id`=" . $user_id);
                    $message = get_lang("msgUserActivated");
                    $display = "list";
                }
                break;
            case "block" :
                {
                    // first delete de student from courses connected to old class
                    $result = mysql_query("UPDATE `user_user` SET `active`=0 WHERE `id`=" . $user_id);
                    $message = get_lang("msgUserDeActivated");
                    $display = "list";
                }
                break;
            case "parentform" :
                {
                    $display = 'addparentform';
                }
                break;
            case "addparent" :
                {
                    // insert order nummer...
                    $result = mysql_query("INSERT `group_group_rel_user` SET  `group_id`=" . $parentgroupid . ", `user_id`=" . $addparent);
                    //set user active
                    $result3 = mysql_query("UPDATE `user_user` SET `active`=1  WHERE `id`=" . $addparent);

                    $display = "addparentform";
                }
                break;
            case "deleteparent" :
                {
                    // ClassManager :: unsubscribe_user($user_id, $select);
                    $result = mysql_query("DELETE FROM `group_group_rel_user` WHERE `group_id`=" . $parentgroupid . " AND `user_id`=" . $removeparent) or die(mysql_error());
                    $display = "addparentform";
                }
                break;
            default :
                {
                    $display = "list";
                }
                break;
        }
        /*
          ==============================================================================
          display ...
          ==============================================================================
         */
        if (!empty($message))
        {
            Display::normal_message($message, false);
        }
        // create a list of studentclasses off the department
        $classes = campus::get_studentclasses($department_id);
        switch ($display)
        {
            case "list":
                {
                    // De klaslijst tonen.....
                    echo '<div style="width:75%;float:right; ">';
                    echo '<FORM ACTION="' . $this->get_campus_admin_url() . '" METHOD="POST" NAME="Selectklas">';
                    echo '<input type="hidden" name="page" value="parentadmin">';
                    echo '<div style="float:right">';
                    echo get_lang('Search') . ': <input type="tekst" name="search" OnChange="javascript:Selectklas.submit();" value="' . $search . '">';
                    echo '&nbsp;&nbsp;</div>';
                    echo '<b style="vertical-align:text-bottom;">' . get_lang('txtQuickSelect') . '<BR></b>';
                    echo ' <a href="' . $this->get_campus_admin_url() . '&page=parentadmin&select=free" >' . get_lang('txtParentPool') . '</a>';
                    foreach ($classes as $key => $value)
                    {
                        echo " <a href=\"" . $this->get_campus_admin_url() . "&page=parentadmin&select=" . $key . "\" title=\"" . get_lang("tooltipShowParents") . " " . $classes[$key]['name'] . "\">" . $classes[$key]['code'] . "</a>";
                    }
                    echo "</FORM>";
                    echo "</div>";
                    if ($select != 0)
                    {
                        $classinfo = campus::get_class_info($select);
                        echo "<b style=\"font-size: 24px;\">" . $classinfo[$select]['code'] . "</b>";
                        // Query van het gegevensbestand....
                        $query = "SELECT DISTINCT `lastname`,`firstname`,`username`, `user_user`.`id`,`user_user`.`active`
		 		           FROM `user_user`
					       INNER JOIN `group_group_rel_user` as parentgroup
		 		               	   ON  `parentgroup`.`user_id`=`user_user`.`id`
		 		               INNER JOIN `campus_parent_rel_student`
		 		                  ON `user_user`.`id` = `campus_parent_rel_student`.`parent_id`
					       INNER JOIN `group_group_rel_user` as studentgroup
		 		                  ON `studentgroup`.`user_id` = `campus_parent_rel_student`.`student_id`
				               WHERE `parentgroup`.`group_id` = " . $parentgroupid . " AND  `studentgroup`.`group_id`=" . $select . "
		 		            ORDER BY  `lastname`, `firstname`";
                    }
                    elseif ($search == "")
                    {
                        echo "<b style=\"font-size: 24px;\">" . get_lang("txtParents") . "</b><br>";
                        echo "<a href=\"" . $this->get_campus_admin_url() . "&page=parentadmin&action=parentform\" >" . get_lang("txtAddParents") . "</a>";
                        // Query van het gegevensbestand....
                        $query = "SELECT DISTINCT `lastname`,`firstname`,`username`,  `user_user`.`id`,`user_user`.`active`
		 		           FROM `user_user`
		 				INNER JOIN `group_group_rel_user` as parentgroup
		 		               	   ON  `parentgroup`.`user_id`=`user_user`.`id`
                                                LEFT JOIN (SELECT `student_id`,`parent_id` FROM `campus_parent_rel_student`
								INNER JOIN `group_group_rel_user` as `studentgroup`
									ON `campus_parent_rel_student`.`student_id` = `studentgroup`.`user_id`
								INNER JOIN `campus_department_rel_group`
									ON `studentgroup`.`group_id`=`campus_department_rel_group`.`group_id` AND `department_id`=" . $department_id . " AND `type`=2) as `children`
 				        		ON `user_user`.`id` = `children`.`parent_id`
 					       WHERE `parentgroup`.`group_id` = " . $parentgroupid . " 
  					           ORDER BY `lastname`, `firstname`";
                    }
                    else
                    {
                        // Query van het gegevensbestand....
                        $query = "SELECT DISTINCT `lastname`,`firstname``username`,  `user_user`.`id`,`user_user`.`active`
  				      	     FROM `user_user`
					       INNER JOIN `group_group_rel_user` as parentgroup
		 		               	   ON  `parentgroup`.`user_id`=`user_user`.`id`
		 		         	WHERE `group_group_rel_user`.`group_id` = " . $parentgroupid . " AND (`lastname` like '%" . $search . "%' OR
							`firstname` like '%" . $search . "%' OR
							concat(`lastname`,' ',`firstname`) like '%" . $search . "%' OR
							concat(`firstname`,' ',`lastname`) like '%" . $search . "%')
						ORDER BY  `lastname`, `firstname`";
                    }

                    $result = mysql_query($query) or die(mysql_error());
                    echo "<div style='width:100%;'></div><br clear=\"all\">";
                    campus::display_complex_table_header($properties, array(get_lang("colheadName"), get_lang("colheadFirstName"), get_lang("colheadChildren"), ""));
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $data = array();
                        $data[] = $rij['lastname'];
                        $data[] = $rij['firstname'];
                        $query2 = "SELECT DISTINCT `user_user`.`id`, `lastname`, `firstname`
					            FROM `user_user`
					                INNER JOIN `campus_parent_rel_student`
					                   ON `user_user`.`id` = `campus_parent_rel_student`.`student_id`
							WHERE `campus_parent_rel_student`.`parent_id`=" . $rij['id'] . "
								ORDER BY `lastname`,`firstname`";
                        $result2 = mysql_query($query2);
                        $children = "";
                        while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                        {
                            $sql3 = "SELECT `code` FROM `group_group`
 		 				INNER JOIN `group_group_rel_user`
                                                    ON  `group_group`.`id`=`group_group_rel_user`.`group_id`
 						INNER JOIN `campus_department_rel_group`
                                                    ON `group_group_rel_user`.`group_id`=`campus_department_rel_group`.`group_id` AND `department_id`=" . $department_id . " AND `type`=2
 		 			 			WHERE `user_id` = " . $rij2['id'] . " ORDER BY `code`";
                            $result3 = mysql_query($sql3);
                            $grouplist = "";
                            while ($rij3 = mysql_fetch_array($result3, MYSQL_ASSOC))
                            {
                                $grouplist.=$rij3['code'] . " ";
                            }
                            if ($grouplist != "")
                            {
                                $children.= '<i  >' . $rij2['lastname'] . ' ' . $rij2['firstname'] . '(' . $grouplist . ') </i><br>';
                            }
                        }
                        $data[] = $children;
                        $links = '<a href="' . $this->get_campus_admin_url() . '&page=parentadmin&user_id=' . $rij['id'] . '&select=' . $select . '&action=studentform" title="' . get_lang("tooltipAddStudents") . '"><img src="' . Theme::get_image_path('application\campus') . 'group_add.gif" border=0 align="absmiddle" ></a>';
                        if ($is_platformadmin)
                        {
                            //$links.='&nbsp;<a href="' . $_configuration['root_web'] . "main/admin/user_edit.php?user_id=" . $rij['id'] . "\" title=\"" . get_lang("tooltipEditUser") . "\"><img src=\"" .  Theme::get_image_path('application\campus')  . "plugin/campus/img/edit.gif\" border=0 align=\"absmiddle\"></a>";
                            if ($rij['active'])
                            {
                                $links.='&nbsp;<a href="' . $this->get_campus_admin_url() . '&page=parentadmin&user_id=' . $rij['id'] . '&select=' . $select . '&action=block" title="' . get_lang("tooltipBlockUser") . '"><img src="' . Theme::get_image_path('application\campus') . 'right.gif" border=0 align="absmiddle"></a>';
                            }
                            else
                            {
                                $links.='&nbsp;<a href="' . $this->get_campus_admin_url() . '&page=parentadmin&user_id=' . $rij['id'] . '&select=' . $select . '&action=release" title="' . get_lang("tooltipReleaseUser") . '"><img src="' . Theme::get_image_path('application\campus') . 'wrong.gif" border=0 align="absmiddle"></a>';
                            }
                        }
                        $data[] = $links;
                        campus::display_table_row($bgcolor, $data, true);
                    }
                    campus::display_table_footer();
                }
                break;
            case "addstudentform":
                {
                    // Het formulier tonen.....
                    // gegevens selecteren
                    echo '<form method="post" action="' . $this->get_campus_admin_url() . '" name="myform">';
                    echo '<input type="hidden" name="page" value="parentadmin" >';
                    echo '<input type="hidden" name="select" value="' . $select . '" >';
                    echo '<input type="hidden" name="user_id" value="' . $user_id . '" >';
                    echo '<input type="hidden" name="action" value="' . $action . '" >';
                    echo '<table>
					<tr valign="top" >
						<td  align="right">
						</td>
						<td colspan="4">
							<h1>' . get_lang('labelParent') . ': ' . $userinfo['firstname'] . ' ' . $userinfo['lastname'] . '</h1>
						</td>
					</tr>
					<tr valign="top" >
						<td>
						</td>
						<td  colspan="2" align="right">
							<b>' . get_lang('txtStudents2SelectFrom') . '</b>
						</td>
						<td>
							&nbsp;&nbsp;&nbsp;
						</td>
						<td>
							<b>' . get_lang('txtChildrenOffParent') . '</b>
						</td>
					</tr>
					<tr valign="top">
						<td align="right">
						</td>
						<td align="right">
							<select name="class_id" size=8 style="width:70px;" onchange="javascript:submit();">';
                    foreach ($classes as $key => $value)
                    {
                        $group_id = ($group_id == 0) ? $key : $group_id;
                        echo '<option value="' . $key . '" ' . (($group_id == $key) ? 'SELECTED' : '') . '>' . $classes[$key]['code'] . '</option>';
                    }
                    echo '	          </select>
						</td>
						<td align="left">
							<select name="addstudent" size=8 style="width:250px;" onchange="javascript:myform.action.value=\'add\'; submit();"> 
							<option value="" selected >' . get_lang('txtSelectStudent2Add') . '</option>';
                    $query = 'SELECT DISTINCT `user_user`.`id`, `lastname`, `firstname`
			            FROM `user_user`
			                INNER JOIN `group_group_rel_user`
			                   ON `user_user`.`id` = `group_group_rel_user`.`user_id`
			                LEFT JOIN `campus_parent_rel_student`
			                   ON `user_user`.`id` = `campus_parent_rel_student`.`student_id` AND `campus_parent_rel_student`.`parent_id`=' . $user_id . '
					WHERE `group_group_rel_user`.`group_id`=' . $group_id . '  AND `student_id` is null
						ORDER BY `lastname`,`firstname`';
                    $result = mysql_query($query);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        echo '<option value="' . $rij['id'] . '" >' . $rij['lastname'] . ' ' . $rij['firstname'] . ' </option>';
                    }
                    echo '	          </select>
						</td>
						<td>
						</td>
						<td align="right">
							<select name="removestudent" size=8 style="width:250px;" onchange="javascript:myform.action.value=\'delete\'; submit();">
							<option value="" selected>' . get_lang('txtSelectStudent2Remove') . '</option>';
                    $query = 'SELECT DISTINCT `user_user`.`id`, `lastname`, `firstname`
			            FROM `user_user`
			                INNER JOIN `campus_parent_rel_student`
			        		ON `user_user`.`id` = `campus_parent_rel_student`.`student_id`
					INNER JOIN `group_group_rel_user`
 				               	ON `group_group_rel_user`.`user_id`=`user_user`.`id`
 					INNER JOIN `campus_department_rel_group`
			 			ON `group_group_rel_user`.`group_id`=`campus_department_rel_group`.`group_id` AND  `type`=2 AND `department_id`=' . $department_id . '
 					WHERE `campus_parent_rel_student`.`parent_id`=' . $user_id . '
						ORDER BY `lastname`,`firstname`';
                    $result = mysql_query($query);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        echo '<option value="' . $rij['id'] . '" >' . $rij['lastname'] . ' ' . $rij['firstname'] . ' </option>';
                    }
                    echo '	          </select>
						</td>
					</tr>
					<tr valign="top">
						<td colspan="5">
							<a href="' . $this->get_campus_admin_url() . '&page=parentadmin&user_id=' . $user_id . '&select=' . $select . '" title="">' . get_lang('txtBack') . '</a>
						</td>
					</tr>
					</table>
				</form>';
                }
                break;
            case 'addparentform';
                {
                    // gegevens selecteren
                    echo '<form method="post" action="' . $this->get_campus_admin_url() . '" name="myform">';
                    echo '<input type="hidden" name="page" value="parentadmin" >';
                    echo '<input type="hidden" name="select" value="' . $select . '" >';
                    echo '<input type="hidden" name="user_id" value="' . $user_id . '" >';
                    echo '<input type="hidden" name="action" value="' . $action . '" >';
                    echo '<table>
					<tr valign="top" >
						<td>
						</td>
						<td  colspan="2" align="right">
							<b>' . get_lang('txtUsers2SelectFrom') . '</b>
						</td>
						<td>
							&nbsp;&nbsp;&nbsp;
						</td>
						<td>
							<b>' . get_lang('txtSelectedParents') . '</b>
						</td>
					</tr>
					<tr valign="top">
						<td align="right">
						</td>
						<td align="right">
						</td>
						<td align="left">
							<select name="addparent" size=8 style="width:250px;" onchange="javascript:myform.action.value=\'addparent\'; submit();"> 
							<option value="" selected >' . get_lang('txtSelectUser2Add') . '</option>';
                    $query = "SELECT `id`, `lastname`, `firstname`,`username`, `status`, `official_code`
						FROM `user_user`
							Left JOIN (SELECT `user_id` FROM`group_group_rel_user`
							INNER JOIN `campus_department_rel_group`
								ON `group_group_rel_user`.`group_id`=`campus_department_rel_group`.`group_id` AND `type`=3)
                                                                as test
								ON `test`.`user_id` = `user_user`.`id`
                                                WHERE `test`.`user_id` is null
	 					ORDER BY `status` DESC, `lastname`,`firstname`";
                    $result = mysql_query($query);
                    $prevgroup = "5";
                    echo '<optgroup label="' . get_lang('txtPlatformStudents') . '">';
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        if ($rij['status'] != $prevgroup)
                        {
                            $prevgroup = $rij['status'];
                            echo "</optgroup>";
                            echo '<optgroup label="' . get_lang('txtPlatformTeachers') . '">';
                        }
                        echo '<option value="' . $rij['id'] . '" >' . $rij['lastname'] . ' ' . $rij['firstname'] . ' (' . $rij['official_code'] . ')</option>';
                    }
                    echo "</optgroup>";
                    echo '	          </select>
						</td>
						<td>
						</td>
						<td align="right">
							<select name="removeparent" size=8 style="width:250px;" onchange="javascript:myform.action.value=\'deleteparent\'; submit();">
							<option value="" selected>' . get_lang('txtSelectParent2Remove') . '</option>';
                    $query = "SELECT DISTINCT `id`, `lastname`, `firstname`,`username`, `status`
						FROM `user_user`
							INNER JOIN `group_group_rel_user`
								ON `group_group_rel_user`.`user_id` = `user_user`.`id`
							INNER JOIN `campus_department_rel_group`
								ON `group_group_rel_user`.`group_id`=`campus_department_rel_group`.`group_id` AND `type`=3
	 					WHERE `department_id`=" . $department_id . "
						ORDER BY `status`,`lastname`,`firstname`";
                    $result = mysql_query($query);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        echo '<option value="' . $rij['id'] . '">' . $rij['lastname'] . ' ' . $rij['firstname'] . ' </option>';
                    }
                    echo '	          </select>
						</td>
					</tr>
					<tr valign="top">
						<td colspan="5">
							<a href="' . $this->get_campus_admin_url() . '&page=parentadmin&user_id=' . $user_id . '&select=' . $select . '" title="">' . get_lang('txtBack') . '</a>
						</td>
					</tr>
					</table>
				</form>';
                }
                break;
        }
    }
}
?>