<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Text;
use common\libraries\Theme;
use common\libraries\Hashing;
use common\libraries\Display;
use common\libraries\Path;
use common\libraries\Filesystem;
use common\libraries\Filecompression;
use common\libraries\ImageManipulation;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['student']) && !$is_platformadmin))
{// not allowed here!
    Display::display_error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...


    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */

    $action = campus::get_POST_GET("action");
    $select = intval(campus::get_POST_GET("select"));
    $user_id = intval(campus::get_POST_GET("user_id"));
    $newclass = intval(campus::get_POST_GET("newclass"));
    $classinfo = campus::get_class_info($select);
    $classinfo[0]['code'] = get_lang("txtOtherPhotos");
    /*
      -----------------------------------------------------------
      execute actions....
      -----------------------------------------------------------
     */

    $query = "SELECT `student_pics` FROM `campus_department` WHERE `id`=" . $department_id;
    $result = mysql_query($query);
    list ($photo_url) = mysql_fetch_array($result);

    if (is_dir(Path :: get(SYS_USER_PATH) . $photo_url))
    {
        //Display::normal_message('map bestaat');
    }
    else
    {
        FileSystem::create_dir(Path::get(SYS_USER_PATH) . $photo_url);
        Display::normal_message('dirCreated');
    }


    $message = "";
    switch ($action)
    {
        case "selectphoto" :
            {
                $uri = campus::get_POST_GET("uri");
                $result = mysql_query('UPDATE `user_user` SET `picture_uri` ="' . $uri . '" WHERE `id`=' . $user_id);
                if (!$result)
                {
                    $message = get_lang("msgItemEditError");
                }
                else
                {
                    $message = get_lang("msgItemEditSucces");
                }
                $display = "form";
            }
            break;
        case "deletephoto" :
            {
                $uri = campus::get_POST_GET("uri");
                //echo $base_work_dir;
                $result = Filesystem::remove(Path :: get(SYS_USER_PATH) . $uri);

                if ($result)
                {
                    Display::normal_message(get_lang('msgPhotoDeleted'));
                }
                else
                {
                    Display::error_message(get_lang('msgPhotoNotDeleted'));
                }
                $display = "list";
            }
            break;
        case "cleanup" :
            {
                // delete photo with dokeos funtions...
                // read photos from directory...
                // read photos from directory...
                $directory = Filesystem::get_directory_content(Path::get(SYS_USER_PATH) . $photo_url, Filesystem::LIST_FILES, false);
                $photo = array();

                foreach ($directory as $key => $file)
                {
                    if ((strtolower(substr($file, -3)) == "jpg") || (strtolower(substr($file, -4)) == "jpeg"))
                    {
                        $photo[ $photo_url . '/' . $file]['image'] =  $photo_url . '/' . $file;
                        $photo[ $photo_url . '/' . $file]['found'] = FALSE;
                    }
                }

                // check if users uses picture....
                $query = "SELECT `id`, `picture_uri` FROM `user_user`";
                $result = mysql_query($query);
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    if (array_key_exists($rij['picture_uri'], $photo))
                    {// found in current photo directory
                        $photo[ $rij['picture_uri']]['found'] = TRUE;
                    }
                }
                foreach ($photo as $image => $info)
                {
                    if (!$info['found'])
                    {// delete foto's with no user attached...
                        $result = Filesystem::remove(Path :: get(SYS_USER_PATH) .'/'. $info['image']);

                        if ($result)
                        {
                            $message = get_lang('msgPhotosDeleted');
                        }
                    }
                }
                $display = "list";
            }
            break;
        case "editphoto" :
            {
                $display = "form";
            }
            break;
        case "upload" :
            {
                $uploadfile = $_FILES['uploadfile'];
                if (file_exists($uploadfile['tmp_name']))
                {
                    $ext = strtolower(substr($uploadfile['name'], -4));
                    if (($ext == '.jpg') || ($ext == '.png'))
                    {
                        $path = Path :: get(SYS_USER_PATH);
                        $img_file = $photo_url . '/' . str_replace(' ', '_' , $uploadfile['name']);
                        //Filesystem :: remove($path.$img_file);
                        
                        if (move_uploaded_file($uploadfile['tmp_name'], $path . $img_file))
                        {
                            $image_manipulation = ImageManipulation :: factory($path . $img_file);
                            // Scale image to fit in 400x400 box. Should be configurable somewhere
                            $image_manipulation->scale(200, 200);
                            $image_manipulation->write_to_file();
                            Filesystem :: chmod($path . $img_file, '660');
                        }
                        else
                        {
                            $message = 'FAIL' . $path . $img_file;
                        }

                        $result = mysql_query('UPDATE `user_user` SET `picture_uri` ="' . $img_file . '" WHERE `id`=' . $user_id) or die(mysql_error());
                    }
                    else
                    {
                        $message = 'imagetypenotallowed';
                    }
                }

                $display = "form";
            }
            break;
        case "zipupload" :
            {

                $filecompression = Filecompression :: factory();
                // Fix to make sure files can be unzipped
                $zipuploadfile = $_FILES['zipuploadfile'];
                if (file_exists($zipuploadfile['tmp_name']) && substr($zipuploadfile['name'], -4) == '.zip')
                {
                    $path = Path :: get(SYS_USER_PATH);

                    $dir = $filecompression->extract_file($zipuploadfile['tmp_name'], false);
                    $entries = Filesystem :: get_directory_content($dir);

                    foreach ($entries as $entry)
                    {
                        if (is_file($entry))
                        {
                            $ext = strtolower(substr($entry, -4));
                            if (($ext == '.jpg') || ($ext == '.png'))
                            {
                                $image_manipulation = ImageManipulation :: factory($entry);
                                // Scale image to fit in 400x400 box. Should be configurable somewhere
                                $image_manipulation->scale(200, 200);
                                $image_manipulation->write_to_file();
                                $filename = str_replace(' ', '_', basename($entry));
                                if (!mb_check_encoding($filename, 'UTF-8'))
                                {
                                    $filename = iconv(mb_detect_encoding($filename), "UTF-8", $filename);
                                }
                                Filesystem :: copy_file($entry, $path . '/' . $photo_url . '/' . $filename);
                                Filesystem :: chmod($path . '/' . $photo_url . '/' . $filename, '660');
                            }
                        }
                    }

                    Filesystem :: remove($dir);
                }
                else
                {
                    $message = get_lang('msgNotaZip');
                }
                $display = "list";
            }
            break;


        default :
            {
                $display = "list";
                $message = ($select == 0) ? ($deleteEnable ? get_lang('msgDeletePhoto') : '') : get_lang('msgChangePhoto');
            }
            break;
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }
    // read photos from directory...
    $directory = Filesystem::get_directory_content(Path::get(SYS_USER_PATH) . $photo_url, Filesystem::LIST_FILES, false);
    $student = array();
    $photo = array();
    foreach ($directory as $key => $file)
    {
        //$file=Filesystem::  ($path);
        // echo read($path);
        //read
        $photo[ $photo_url . '/' . $file]['image'] = trim( $photo_url . '/' . $file);
        $photo[ $photo_url . '/' . $file]['found'] = FALSE;
    }
    // create a list of studentclasses off the department
    $classes = campus::get_studentclasses($department_id);
    if ($display == "list")
    {
        // De klaslijst tonen.....
        echo "<table width=100%><tr>";
        echo '<td><b style="font-size: 24px;">' . $classinfo[$select]['code'] . '</b></td>';
        echo '<td style="width:80%; ">';
        echo '<b style="vertical-align:text-bottom;">' . get_lang("txtQuickSelect") . '<br></b>';
        echo '<a href="' . $this->get_url() . '&page=photoadmin&select=free" >' . get_lang("txtOtherPhotos") . '</a>';
        foreach ($classes as $key => $value)
        {
            echo ' <a href="' . $this->get_url() . '&page=photoadmin&select=' . $key . '" title="' . get_lang("tooltipShow") . ' ' . $classes[$key]['name'] . '">' . $classes[$key]['code'] . '</a>';
        }
        echo '</td></tr>';
        if ($select == 0)
        {
            echo '<tr><td>';
            echo '<a href="' . $this->get_url() . '&page=photoadmin&action=cleanup" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmCleanUpPhotoDir") . '\')) return false;" title="' . get_lang("tooltipCleanUpPhotoDir") . '">' . get_lang("txtCleanUpPhotoDir") . '</a>';
            echo '</td><td align="right">';
            echo '<form method="post" action="' . $this->get_url() . '" name="importform" enctype="multipart/form-data">';
            echo '<input type="hidden" name="page" value="photoadmin">';
            echo '<input type="hidden" name="action" value="zipupload">';
            echo '<input type="hidden" name="user_id" value="' . $userinfo['id'] . '">';
            echo '<input type="hidden" name="MAX_FILE_SIZE" value="20000000">';
            echo '' . get_lang('labelSelectZipfile2UploadPhoto') . '
					<input type="file" name="zipuploadfile" >
					<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelUpload') . '" />&nbsp;&nbsp;
				</form>';
            echo '</td></tr>';
        }
        echo '</table><hr>';
    }
    else
    {
        // get student details....
        $userinfo = campus::get_user_info($user_id);
        echo "<table width='100%' align='center'>";
        // ************* display student information ***
        echo "<tr>";
        echo "<td width='75%' valign='top'>";
        echo "<div style='border:1px solid #999999'  >";
        echo "<table width=100%><tr>";
        echo "<td align='right'><b>" . get_lang("colheadFirstName") . ":</b></td>";
        echo "<td>" . $userinfo['firstname'] . "</td>";
        echo "<td align='right'><b>" . get_lang("colheadBirth") . ":</b></td>";
        echo "<td>" . $userinfo['birth'] . "</td>";
        echo "</tr><tr>";
        echo "<td align='right'><b>" . get_lang("colheadLastName") . ":</b></td>";
        echo "<td>" . $userinfo['lastname'] . "</td>";
        echo "<td align='right'><b>" . get_lang("colheadAdress") . ":</b></td>";
        echo "<td>" . $userinfo['adress'] . "</td>";
        echo "</tr><tr>";
        echo "<td align='right'><b>" . get_lang("colheadStudentCode") . ":</b></td>";
        echo "<td>" . $userinfo['official_code'] . "</td>";
        echo "<td align='right'><b>" . get_lang("colheadPhone") . ":</b></td>";
        echo "<td>" . $userinfo['phone'] . "</td>";
        echo "</tr><tr>";
        echo "<td align='right' valign='top'><b>" . get_lang("colheadClasses") . ":</b></td>";
        echo "<td>";
        $classes = campus::get_classes($user_id);
        foreach ($classes as $class_id => $value)
        {
            echo "" . $value['code'] . " <b>" . get_lang("colheadNr") . "</b> " . $value['order'];
            echo "<br>";
        }
        echo "</td>";
        echo "<td align='right'><b>" . get_lang("colheadEmail") . ":</b></td>";
        echo "<td>" . $userinfo['email'] . "<td>";
        echo "</tr><tr>";
        echo "<td align='right'><b>" . get_lang("colheadUsername") . ":</b></td>";
        echo "<td>" . $userinfo['username'] . "</td>";
        echo "<td></td>";
        echo "<td></td>";
        echo "</tr></table>";
        echo "</div>";
        Display::normal_message(get_lang("msgSelectPhoto"), false);
        echo "</td><td valign='top'>";
        if (is_file(Path :: get(SYS_USER_PATH) . $userinfo['picture_uri']))
        {
            echo '<img src="' . Path :: get(WEB_USER_PATH) . $userinfo['picture_uri'] . '" height="100">';
        }
        else
        {
            echo '<img src="' . Theme :: get_common_image_path() . 'unknown.jpg" height="100" >';
        }
        echo '<form method="post" action="' . $this->get_url() . '" name="importform" enctype="multipart/form-data">';
        echo '<input type="hidden" name="page" value="photoadmin">';
        echo '<input type="hidden" name="action" value="upload">';
        echo '<input type="hidden" name="user_id" value="' . $userinfo['id'] . '">';
        echo '<input type="hidden" name="MAX_FILE_SIZE" value="1000000">';
        echo '' . get_lang('labelSelectFile2Import') . '
					<input type="file" name="uploadfile" >
					<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelUpload') . '" />&nbsp;&nbsp;
				<br /></form>';

        echo "</td></tr>";
        echo "</table><br>";
        echo ' <a href="' . $this->get_url() . '&page=photoadmin" >' . get_lang("txtBack") . '</a>';
        echo "<hr>";
    }

    //dump($photo);
    // Query van het gegevensbestand....
    $query = "SELECT DISTINCT `display_order`,`lastname`,`firstname`,`birth`,`username`,`group_group_rel_user`.`group_id`,  `user_user`.`id`, `picture_uri`, `department_id`,`code`
                FROM `user_user`
                    LEFT JOIN `campus_user`
                        ON `user_user`.`id`=`campus_user`.`user_id`
                    INNER JOIN `group_group_rel_user`
                        ON `user_user`.`id`=`group_group_rel_user`.`user_id`
                    LEFT JOIN `campus_department_rel_group`
         		ON `group_group_rel_user`.`group_id`=`campus_department_rel_group`.`group_id` AND `type`=2
                    INNER JOIN `group_group`
                        ON `group_group`.`id` = `group_group_rel_user`.`group_id`
			ORDER BY  `department_id`, `code`, `display_order`, `lastname`, `firstname`";
    $result = mysql_query($query) or die(mysql_error());
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        //dump($rij);
        if (array_key_exists( $rij['picture_uri'], $photo))
        {// found in current photo directory
            $photo[$rij['picture_uri']]['found'] = TRUE;
            if ($rij['department_id'] != $department_id)
            {
                if ($student[$rij['id']]['department'] == '')
                    $student[$rij['id']]['found'] = "other department";
            }
            else
            {
                $student[$rij['id']]['found'] =  $rij['picture_uri'];
            }
            //$student[$rij['id']]['user_id']=$rij['id'];
            $student[$rij['id']]['image'] = $photo[ $rij['picture_uri']]['image'];
            $student[$rij['id']]['class_id'].=$rij['group_id'] . ";";
            $student[$rij['id']]['classcode'] = $rij['code'];
            $student[$rij['id']]['name'] = $rij['lastname'] . " " . $rij['firstname'];
            $student[$rij['id']]['department'] = $departmentStruc[$rij['department_id']]['code'];
        }
        else
        {// not found in current photo directory
            if ($rij['department_id'] == $department_id)
            {
                if (is_file(Path :: get(SYS_USER_PATH) . $rij['picture_uri']))
                {
                    $student[$rij['id']]['found'] = get_lang("txtPhotoFromOtherDepartment");
                    $student[$rij['id']]['image'] = $rij['picture_uri'];
                }
                else
                {
                    $temp = $rij['picture_uri'];
                    $rij['picture_uri'] = $rij['id'];
                    $student[$rij['id']]['found'] = (trim($temp) == '') ? "no picture " : $temp;
                }
                //$student[$rij['id']]['user_id']=$rij['id'];
                $student[$rij['id']]['class_id'].=$rij['group_id'] . ";";
                $student[$rij['id']]['classcode'] = $rij['code'];
                $student[$rij['id']]['name'] = $rij['lastname'] . " " . $rij['firstname'];
                $student[$rij['id']]['department'] = $departmentStruc[$rij['department_id']]['code'];
            }
        }
    }
    //dump($photo);

    foreach ($photo as $image => $info)
    {
        if (!$info['found'])
        {// put foto's with no student attached to, also in array.
            $student[$image]['image'] = $photo[$image]['image'];
        }
    }
    echo "<table>";
    echo "<tr>";
    $i = 0;
    foreach ($student as $id => $info)
    {// all students and photo's...
        $classes = explode(";", $info['class_id']);
        if (($select != 0) && in_array($select, $classes))
        { // Only show pictures of selected class....
            $i++;
            echo '<td>';
            echo '<a href="' . $this->get_url() . '&page=photoadmin&user_id=' . $id . '&action=editphoto" >';
            if (is_file(Path :: get(SYS_USER_PATH) . $info['image']))
            {
                echo '<img src="' . Path :: get(WEB_USER_PATH) . $info['image'] . '" height="150" style="border:1px solid #999999" title="' . $info['found'] . '">';
            }
            else
            {
                echo '<img src="' . Theme :: get_common_image_path() . 'unknown.jpg" height="150" style="border:1px solid #999999" title="' . $info['found'] . '">';
            }
            echo '</a><br>';
            echo $info['name'];
            echo '</td>';
        }
        elseif (($user_id != 0) && (empty($info['name'])))
        { // When user selected show photo
            $ext = strtolower(substr($info['image'], -4));
            if (($ext == '.jpg') || ($ext == '.png'))
            {
                $i++;

                echo '<td>';
                echo '<a href="' . $this->get_url() . '&page=photoadmin&user_id=' . $user_id . '&action=selectphoto&uri=' . $info['image'] . '" >';
                echo '<img src="' . Path :: get(WEB_USER_PATH) . $info['image'] . '" height="150" style="border:1px solid #999999" title="' . $info['image'] . '">';
                echo "</a><br>";
                echo ((trim($info['name']) == "") ? substr($info['image'],8) : $info['name']) . "<br>" . $info['width'] . "x" . $info['height'];
                echo "</td>";
            }
        }
        elseif (($user_id == 0) && ($select == 0) && (($info['found'] == "other department") || (empty($info['name']))))
        { // pictures with no users attached....
            $i++;
            echo '<td >';
            echo (empty($info['name'])) ? '<a href="' . $this->get_url() . '&page=photoadmin&action=deletephoto&uri=' . $info['image'] . '" onclick="javascript:if(!confirm(\'' . get_lang('msgboxConfirmDeletePhoto') . '\')) return false;" title="' . get_lang('tooltipClick2DeletePhoto') . '">' : '';
            echo '<img src="' . Path :: get(WEB_USER_PATH) . $info['image'] . '" height="150" style="border:1px solid #999999" title="' . $info['image'] . '">';
            echo (empty($info['name'])) ? '</a>' : '';
            echo '<br>';
            echo ((empty($info['name'])) ? ( substr($info['image'],8)) : '<span title="' . $info['department'] . '">' . $info['name']) . '<br>' . $info['width'] . 'x' . $info['height'] . '</span>';
            echo '</td>';
        }
        if ($i == 8)
        {
            $i = 0;
            echo '</tr><tr>';
        }
    }
    echo '</tr>';
    echo '</table>';
}
?>