<?php
/*
==============================================================================
  plugin: campus for Chamilo 1.8.X
	  by Ludwig Theunis (email: ludwig@openelo.be)
==============================================================================
*/
/*
==============================================================================
	Chamilo - E-earning & Collaboration Software

	Copyright (c) various contributors

	For a full list of contributors detaining copyrights over parts of
	the Chamilo software, see "documentation/credits.html".
	The full license can be read in "documentation/license.html".

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	See the GNU General Public License for more details.

	Mail: info@chamilo.org
==============================================================================
*/
/*
==============================================================================
	   INIT SECTION
==============================================================================
*/
// the language file
	$language_file = array ('courses','index');
	$cidReset = true; /* Flag forcing the 'current course' reset,
							as we're not inside a course anymore  */


/*
-----------------------------------------------------------
	Included libraries
-----------------------------------------------------------
*/
	// language file automatically included in global.inc.php 
	// $language_file = array('campus');

	//this includes main_api too:
	include ("../../../main/inc/global.inc.php");
	
	//campus.conf.php is automatically include too.
	include ('../inc/campus.lib.php');

	include(api_get_path(SYS_PLUGIN_PATH).'campus/lang/'.$language_interface.'/admin.inc.php');

	require_once(api_get_path(LIBRARY_PATH).'xajax/xajax.inc.php');
	require_once (api_get_path(LIBRARY_PATH).'usermanager.lib.php');
	require_once (api_get_path(LIBRARY_PATH).'classmanager.lib.php');

	// the section (for the tabs)
	$this_section = SECTION_CAMPUS;
	// login required...
	$_uid=api_get_user_id();
	if (intval($_uid)==0) 
	{
		header('location: '.$_configuration['root_web']);
	}
	
	$is_teacher = campus::is_department_teacher($_uid);
	$is_platformadmin = api_is_platform_admin();
	// get department from user
	$departmentStruc=campus::get_department ($_uid);
/*
-----------------------------------------------------------
	Specials
-----------------------------------------------------------
*/	
	$xajax = new xajax();
	$xajax->setCharEncoding('iso-8859-15');
	$xajax->registerFunction('courses_of_user');
	$xajax->registerFunction('courses_of_class');
	$xajax->registerFunction('students_of_class');
	$xajax->processRequests();
	function courses_of_user($arg)
	{
		// do some stuff based on $arg like query data from a database and
		// put it into a variable like $newContent
	    //$newContent = 'werkt het? en met een beetje meer text, wordt dat goed opgelost? ';    
	    $personal_course_list = UserManager::get_personal_session_course_list($arg);
	    $newContent = '';
	    if(count($personal_course_list)>0)
	    {
		    foreach ($personal_course_list as $key=>$course)
		    {
		    	$newContent .= htmlentities($course['i']).'<br />';
		    }
		}
    		else
	    	{
	    		$newContent .= '- '.get_lang('None').' -<br />';
	    	} 
		// Instantiate the xajaxResponse object
		$objResponse = new xajaxResponse();
	        
		// add a command to the response to assign the innerHTML attribute of
		// the element with id="SomeElementId" to whatever the new content is
		$objResponse->addAssign("user".$arg,"title", $newContent);
        
		//return the  xajaxResponse object
		return $objResponse;
	}
	function courses_of_class($arg)
	{
		// do some stuff based on $arg like query data from a database and
		// put it into a variable like $newContent
		$query='SELECT DISTINCT `course`.`title`,`tutor_name`
           	 FROM `'.Database::get_main_database().'`.`course`				   
				INNER JOIN `'.Database::get_main_database().'`.`course_rel_class`
					ON `course`.`code` = `course_rel_class`.`course_code` 
         	   WHERE `class_id`='.$arg.' ORDER BY  `course`.`code`';
		$result=mysql_query($query) or die (mysql_error());
	   	$newContent = '';
		while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
		{
	    		$newContent .= htmlentities($rij['title']." (".$rij['tutor_name'].")").'<br />';
	    	}

		// Instantiate the xajaxResponse object
		$objResponse = new xajaxResponse();
	        
		// add a command to the response to assign the innerHTML attribute of
		// the element with id="SomeElementId" to whatever the new content is
		$objResponse->addAssign('class'.$arg,'innerHTML', $newContent);
       
		//return the  xajaxResponse object
		return $objResponse;
	}
	function students_of_class($arg)
	{
		// do some stuff based on $arg like query data from a database and
		// put it into a variable like $newContent
		$query="SELECT `user_id`, `lastname`, `firstname`, COUNT(course_code) as 'n_courses'
		       	FROM `".Database::get_main_database()."`.`user`
		        	INNER JOIN `".Database::get_main_database()."`.`class_user`				   
		        		USING (`user_id`)
					LEFT JOIN `".Database::get_main_database()."`.`course_rel_user`
						USING (`user_id`)
           		WHERE `class_id`=".$arg." GROUP BY `user_id` ORDER BY  `lastname`,`firstname`";
		$result = mysql_query($query) or die (mysql_error());
	    	$newContent = '';
		while ($rij=mysql_fetch_array($result,MYSQL_ASSOC))
		{
			$newContent.=' '.htmlentities($rij['lastname'].' '.$rij['firstname']).' ';
			$newContent.=api_is_platform_admin()?' <a href="'.$_SERVER['PHP_SELF'].'?action=addcourse&user_id='.$rij['user_id'].'&class_id='.$arg.'">':'';
			$newContent.='('.$rij['n_courses'].' '.get_lang('txtCourses').')';
			$newContent.=api_is_platform_admin()?'</a>':'';
			$newContent.='<br>'; 
		}

		// Instantiate the xajaxResponse object
		$objResponse = new xajaxResponse();
	        
		// add a command to the response to assign the innerHTML attribute of
		// the element with id="SomeElementId" to whatever the new content is
		$objResponse->addAssign('studentclass'.$arg,'innerHTML', $newContent);
        
		//return the  xajaxResponse object
		return $objResponse;
	}

	$htmlHeadXtra[] = $xajax->getJavascript('../../../main/inc/lib/xajax/');
	$htmlHeadXtra[] = '<SCRIPT LANGUAGE="javascript" TYPE="text/javascript">
			function hideID(DIVID) { 
			 if (document.getElementById) { // DOM3 = IE5, NS6 
			  document.getElementById(DIVID).style.display = "none"; 
			 }else { 
			  if (document.layers) { // Netscape 4 
			   document.DIVID.display = "none"; 
			  }else { // IE 4 
			   document.all.DIVID.style.display = "none"; 
			  } 
			 } 
			} 
			function showID(DIVID) { 
			 if (document.getElementById) { // DOM3 = IE5, NS6 
			  document.getElementById(DIVID).style.display = ""; 
			 }else { 
			  if (document.layers) { // Netscape 4 
			   document.DIVID.display = ""; 
			  }else { // IE 4 
			   document.all.DIVID.style.display = ""; 
			  } 
			 } 
			}
		</script>';
	$htmlHeadXtra[] = '	
	<style>
	a.campus_tooltip{
    	position:relative; /*this is the key*/
    	z-index:24; 
    	color:#000;
    	text-decoration:none}

	a.campus_tooltip:hover{z-index:25; background-color:#ff0}

	a.campus_tooltip span{display: none}

	a.campus_tooltip:hover span{ /*the span will display just on :hover state*/
    	display:block;
    	position:absolute;
    	top:12px; left:12px; width:200px;
    	border:1px solid #0cf;
    	background-color:#cff; color:#000;
    	padding: 3px;
    	margin-left: -100px;
    	text-align: left}
    	
	a.campus_tooltip2{
    	position:relative; /*this is the key*/
    	z-index:24; 
    	color:#000;
    	text-decoration:none}

	a.campus_tooltip2:hover{z-index:25; background-color:#ff0}

	a.campus_tooltip2 div{display: none}

	a.campus_tooltip2:hover div{ /*the span will display just on :hover state*/
    	display:block;
    	position:absolute;
    	top:12px; left:12px; width:200px;
    	border:1px solid #0cf;
    	background-color:#cff; color:#000;
    	padding: 3px;
    	margin-left: -100px;
    	text-align: left}
		</style>';

/*
============================================================================== 
	POST & GET vars, check for default value?.
============================================================================== 
*/
	$department_id=intval(campus::get_SESSION('department_id', key($departmentStruc)));
	$showcourses=intval(campus::get_POST_GET('showcourses'));
	$showstudents=intval(campus::get_POST_GET('showstudents'));
	$action=campus::get_POST_GET('action');
	$user_id=intval(campus::get_POST_GET('user_id'));
	$class_id=intval(campus::get_POST_GET('class_id'));

	// get rights of user in campus plugin .....
	$admin=campus::get_rights ($_uid,$department_id);
/*
============================================================================== 
	display header & breadcrumb...
============================================================================== 
*/
	$nameTools = get_lang('namecampusAdmin');

	$interbreadcrumb[]=array('url'=>'index.php', 'name'=> $nameTools);
	Display :: display_header(get_lang('page_showstudentcourses'),false);

	echo '<div class="maincontent" id="content">';

	campus::display_departments ($departmentStruc,$department_id,$page);

//check if user is allowed here...
if ((intval($_uid)==0) || (empty($admin['student']) && !$is_platformadmin)) 
{// not allowed here!
	Display::display_error_message(get_lang('msgNoRights4ThisDepartment'),false);
}
else
{//only departmentadmins and platform administrator is allowed here...
/*
============================================================================== 
		display ...
============================================================================== 
*/
	switch ($action)
	{
		case 'addcourse' :
		{ 
			ClassManager :: add_user($user_id, $class_id);
			$message=get_lang('msgUserAdded2Courses');
		}
		break;
		case 'class2courses' :
		{ 
			$query='SELECT `user_id` FROM `'.$_configuration['main_database'].'`.`class_user`
						WHERE `class_id`='.$class_id.'';
			$result = mysql_query($query);
			while ($rij=mysql_fetch_array($result))
			{
				ClassManager :: add_user($rij['user_id'], $class_id);
			}
			$message=get_lang('msgClassAdded2Courses');
		}
		break;
	}
	//display messages
	if (!empty($message))
	{		
		Display::display_normal_message($message,false);
	}
	// de verschillende klassen die tot een bepaalde department behoren ophalen....
	$classes=campus::get_studentclasses ($department_id);

	echo '<b>'.get_lang('page_showcourses').'</b><br>';



	// existing students of department in array...
	Display::display_complex_table_header($properties, array(get_lang("colheadClass"),get_lang("colheadClassName"),get_lang("colheadCourses")));
	// Query van het gegevensbestand....
	foreach ($classes as $key => $classinfo)
	{
		$data=array();
		$data[]=$classinfo['code'].'('.$classinfo['aantal'].' '.get_lang('txtStudents').')';
		$data[]='<a class="campus_tooltip" href="#" onmouseover="xajax_students_of_class('.$key.');">
									'.$classinfo['name'].'
									<span id="studentclass'.$key.'">
								<img src="../img/anim-loader.gif" height="20" /></span></a>';
		$query='SELECT DISTINCT `course_code` FROM `'.$_configuration['main_database'].'`.`course_rel_class`
       	        WHERE `class_id`='.$key.' ';
		$result=mysql_query($query) or die (mysql_error());
		$data[]=mysql_num_rows($result).' '.get_lang('txtCourses').
				 '<a class="campus_tooltip"  href="'.$_SERVER['PHP_SELF'].'?action=class2courses&class_id='.$key.'" onmouseover="xajax_courses_of_class('.$key.');">
					<img src="../img/course_info.gif" style="vertical-align:middle; z-index:1;" >
					<span id="class'.$key.'" style="width:300px">
					<img src="../img/anim-loader.gif" height="20" /></span></a>';
		//"<img src=\"../img/course_info.gif\" border=0 height=21px align=\"absmiddle\"></div>";
		Display::display_table_row($bgcolor, $data, true);
 	}

	// Teacherclasses from department...
	$classes=campus::get_teacherclasses($department_id);
	// Query van het gegevensbestand....
	foreach ($classes as $key => $classinfo)
	{
		$data=array();
		$data[]=$classinfo['code']."(".$classinfo['aantal']." ".get_lang("txtStudents").")";
		$data[]="<a class='campus_tooltip2' href='#' onmouseover=\"xajax_students_of_class(".$key.");\">
									".$classinfo['name']."
									<span id='studentclass".$key."'>
								<img src='../img/anim-loader.gif' height='20' /></span></a>";
		$query="SELECT DISTINCT `course_code` FROM `".$_configuration['main_database']."`.`course_rel_class`
       	        WHERE `class_id`=".$key." ";
		$result=mysql_query($query) or die (mysql_error());
		$data[]=mysql_num_rows($result)." ".get_lang("txtCourses").
				 "<a class='campus_tooltip' href='".$_SERVER['PHP_SELF']."?action=class2courses&class_id=".$key."' onmouseover=\"xajax_courses_of_class(".$key.");\">
					<img src='../img/course_info.gif' style='vertical-align:middle; z-index:1;' >##
					<span id='class".$key."'>
					<img src='../img/anim-loader.gif' height='20' /></span></a>";
		//"<img src=\"../img/course_info.gif\" border=0 height=21px align=\"absmiddle\"></div>";
		Display::display_table_row($bgcolor, $data, true);
 	}
 	Display::display_table_footer();
}
	echo '</div>';

/*
==============================================================================
			campus RIGHT MENU
==============================================================================
*/
	// display right menu: language form, login section + useful weblinks
	echo '<div class="menu" id="menu">';
	if ($_user['user_id'] && api_number_of_plugins('campushomepage_menu') > 0)
	{
		echo '<div class="menusection" style="background: none">';
		// TL CAMPUS plugin
		if (is_array($_plugins['campushomepage_menu']))
		{
			foreach ($_plugins['campushomepage_menu'] as $this_plugin)
			{
				include (api_get_path(SYS_PLUGIN_PATH)."$this_plugin/index.php");
			}
		}
		//api_plugin('campushomepage_menu');
		echo '</div>';
	}
	/**
	 * User section
	 */
	if(isset($_SESSION['_user']['user_id']) && $_SESSION['_user']['user_id']!=0)
	{
		// tabs that are deactivated are added here
		if (!empty($menu_navigation))
		{
			echo '<div class="menusection">';
			echo '<span class="menusectioncaption">'.get_lang('MainNavigation').'</span>';
			echo '<ul class="menulist">';
			foreach($menu_navigation as $section => $navigation_info)
			{
				$current = ($section == $GLOBALS['this_section'] ? ' id="current"' : '');
				echo '<li'.$current.'>';
				echo '<a href="'.$navigation_info['url'].'" target="_top">'.$navigation_info['title'].'</a>';
				echo '</li>';
				echo "\n";
			}
			echo '</ul>';
			echo '</div>';
		}

		echo '<div class="menusection">';
		echo '<span class="menusectioncaption">'.get_lang('MenuUser').'</span>';
		echo '<ul class="menulist">';

		$display_add_course_link = api_is_allowed_to_create_course() && ($_SESSION['studentview'] != 'studentenview');
		if ($display_add_course_link)
			echo '<li><a href="'.api_get_path(WEB_PATH).'main/create_course/add_course.php">'.get_lang('CourseCreate').'</a></li>';
		echo '<li><a href="'.api_get_path(WEB_PATH).'main/auth/courses.php">'.get_lang('CourseManagement').'</a></li>';
		echo '</ul>';
		echo '</div>';
	}
	echo '</div>';

/*
==============================================================================
		FOOTER
==============================================================================
*/
	Display :: display_footer();

?>
