<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Theme;
use common\libraries\Display;

/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */
/*
  ==============================================================================
  MAIN CODE
  ==============================================================================
 */

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($admin['student']) && ! $is_platformadmin))
{ // not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{ //only departmentadmins and platform administrator is allowed here...
//require_once (api_get_path(LIBRARY_PATH).'classmanager.lib.php');

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */

    $action = campus::get_POST_GET("action");
    $select = intval(campus::get_POST_GET("select"));
    $user_id = intval(campus::get_POST_GET("user_id"));
    $newclass = intval(campus::get_POST_GET("newclass"));
    $display_order = intval(campus::get_POST_GET("display_order"));
    $search = campus::get_POST_GET("search");
    $userinfo = campus:: get_user_info($user_id);

    /*
      -----------------------------------------------------------
      execute actions....
      -----------------------------------------------------------
     */
    $message = "";
    switch ($action)
    {
        case "update" :
        {
            if ($select != 0)
            {
                if ($select == $newclass)
                {
                    // the student stay in the same class, only order is changed.
                    $result = mysql_query(
                        "UPDATE `group_group_rel_user` SET `display_order` =" . $display_order . " WHERE `group_id`=" .
                        $select . " AND `user_id`=" . $user_id
                    );
                    if (! $result)
                    {
                        $message = get_lang("msgOrderEditError") . " ";
                    }
                    else
                    {
                        $classinfo = campus::get_class_info($select);
                        $message =
                            $userinfo['firstname'] . " " . $userinfo['lastname'] . " " . get_lang("msgOrderChanged") .
                            " " .
                            $order . " (" . $classinfo[$select]['code'] . ")";
                    }
                }
                else
                {
                    $result = mysql_query(
                        "DELETE FROM `group_group_rel_user` WHERE `group_id`=" . $select . " AND `user_id`=" . $user_id
                    );

                    $classinfo = campus::get_class_info($select);
                    $message =
                        $userinfo['firstname'] . " " . $userinfo['lastname'] . " " . get_lang("msgDeletedFromClass") .
                        " " .
                        $classinfo[$select]['code'] . ". ";
                }
            }
        }
        // no break !!!!!
        case "new" :
        {
            if ($select != $newclass)
            { //add user to new class and connect to courses connected to new class
                //ClassManager :: add_user($user_id, $newclass);

                // insert order nummer...
                $result = mysql_query(
                    "INSERT `group_group_rel_user` SET  `display_order` =" . intval($display_order) . " , `group_id`=" .
                    $newclass . ", `user_id`=" . $user_id
                );
                //set user active
                $result3 = mysql_query("UPDATE `user_user` SET `active`=1  WHERE `id`=" . $user_id);
                $classinfo = campus::get_class_info($newclass);
                $message .=
                    $userinfo['firstname'] . " " . $userinfo['lastname'] . " " . get_lang("msgAdded2Class") . " " .
                    $classinfo[$newclass]['code'] . ". ";
                $message .= ($result3) ? get_lang("msgUserActivated") . "<br>" : "";
                $display = "list";
            }
            else
            {
                $display = "list";
            }
        }
            break;
        case "delete" :
        {
            // ClassManager :: unsubscribe_user($user_id, $select);
            $result = mysql_query(
                "DELETE FROM `group_group_rel_user` WHERE `group_id`=" . $select . " AND `user_id`=" . $user_id
            );

            $classinfo = campus::get_class_info($select);
            // first delete de student from courses connected to old class
            $message = $userinfo['firstname'] . " " . $userinfo['lastname'] . " " . get_lang("msgDeletedFromClass") .
                " " . $classinfo[$select]['code'];
            $sql2 = "SELECT `user_id` FROM `group_group_rel_user`
					WHERE  `user_id` = " . $user_id . " ";
            $result2 = mysql_query($sql2);
            $checkclasses = mysql_num_rows($result2);
            if ($checkclasses == 0)
            {
                $result4 = mysql_query("UPDATE `user_user` SET `active`=0 WHERE `id`=" . $user_id);
                $message .= ($checkclasses == 0) ? "<br>" . get_lang("msgUserDeActivated") . "<br>" : "";
            }
            $display = "list";
        }
            break;
        case "release" :
            {
                // first delete de student from courses connected to old class
                $result = mysql_query("UPDATE `user_user` SET `active`=1 WHERE `id`=" . $user_id);
                $message = get_lang("msgUserActivated");
                $display = "list";
            }
            break;
        case "block" :
        {
            // first delete de student from courses connected to old class
            $result = mysql_query("UPDATE `user_user` SET `active`=0 WHERE `id`=" . $user_id);
            $message = get_lang("msgUserDeActivated");
            $display = "list";
        }
            break;
        case "releaseall" :
        {
            // first delete de student from courses connected to old class
            $classes = campus::get_studentclasses($department_id);
            $query = "UPDATE `user_user`
						INNER JOIN `group_group_rel_user`
 							ON `group_group_rel_user`.`user_id`=`user_user`.`id`
						INNER JOIN `campus_department_rel_group`
							ON `group_group_rel_user`.`group_id`=`campus_department_rel_group`.`group_id` AND `type`=2
						SET `active`=1 WHERE `department_id`=" . $department_id;
            $result = mysql_query($query);
            $message = get_lang("msgAllStudentsReleased");
            $display = "list";
        }
            break;
        case "blockall" :
        {
            // first delete de student from courses connected to old class
            $classes = campus::get_studentclasses($department_id);
            $query = "UPDATE `user_user`
						INNER JOIN `group_group_rel_user`
 							ON `group_group_rel_user`.`user_id`=`user_user`.`id`
						INNER JOIN `campus_department_rel_group`
							ON `group_group_rel_user`.`group_id`=`campus_department_rel_group`.`group_id` AND `type`=2
						SET `active`=0 WHERE `department_id`=" . $department_id;
            $result = mysql_query($query);
            $message = get_lang("msgAllStudentsBlocked");
            $display = "list";
        }
            break;
        case "sort" :
        {
            $query = "SELECT `id` FROM `user_user`
							INNER JOIN `group_group_rel_user`
 							ON `group_group_rel_user`.`user_id`=`user_user`.`id`
									WHERE `group_id`=" . $select . "  ORDER BY `lastname`, `firstname`";
            $result = mysql_query($query);
            $nr = 0;
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $nr ++;
                $result2 = mysql_query(
                    "UPDATE `group_group_rel_user` SET  `display_order` =" . intval($nr) . " WHERE `group_id`=" .
                    $select . " AND `user_id`=" . $rij['id']
                );
            }
            $display = "list";
        }
            break;
        case "editform" :
        {
        }
            break;
        default :
            {
            $display = "list";
            }
            break;
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }
    // create a list of studentclasses off the department
    $classes = campus::get_studentclasses($department_id);
    if ($display == "list")
    {
        // De klaslijst tonen.....
        echo '<div style="width:75%;float:right; ">';
        echo '<FORM ACTION="' . $this->get_campus_admin_url() . '" METHOD="POST" NAME="Selectklas">';
        echo '<input type="hidden" name="page" value="studentadmin">';
        echo '<div style="float:right">';
        echo get_lang('Search') .
            ': <input type="tekst" name="search" OnChange="javascript:Selectklas.submit();" value="' . $search . '">';
        echo '&nbsp;&nbsp;</div>';
        echo '<b style="vertical-align:text-bottom;">' . get_lang('txtQuickSelect') . '<BR></b>';
        echo ' <a href="' . $this->get_campus_admin_url() . '&page=studentadmin&select=free" title="' .
            get_lang('tooltipStudentPool') . '">' . get_lang('txtStudentPool') . '</a>';
        foreach ($classes as $key => $value)
        {
            echo " <a href=\"" . $this->get_campus_admin_url() . "&page=studentadmin&select=" . $key . "\" title=\"" .
                get_lang("tooltipShow") . " " . $classes[$key]['name'] . "\">" . $classes[$key]['code'] . "</a>";
        }
        echo "</FORM>";
        echo "</div>";
        if ($select != 0)
        {
            $classinfo = campus::get_class_info($select);
            echo "<b style=\"font-size: 24px;\">" . $classinfo[$select]['code'] . "</b>";
            // Query van het gegevensbestand....
            $query = "SELECT  `display_order`,`lastname`,`firstname`,`username`,'' as `classcode`, `user_user`.`id`,`user_user`.`active`
 		           FROM `group_group_rel_user`
 		               LEFT JOIN `user_user`
		                   ON `user_user`.`id` = `group_group_rel_user`.`user_id`
 		               WHERE `group_group_rel_user`.`group_id` = " . $select . "
 		            ORDER BY `display_order`, `lastname`, `firstname`";
        }
        elseif ($search == "")
        {
            echo "<b style=\"font-size: 24px;\">" . get_lang("txtStudentPool") . "</b>";
            // Query van het gegevensbestand....
            $query = "SELECT '' as `display_order`,`lastname`,`firstname`,`username`,'' as `classcode`,  `user_user`.`id`,`user_user`.`active`
 		           FROM `user_user`
 		               LEFT JOIN `group_group_rel_user`
		                  ON `user_user`.`id` = `group_group_rel_user`.`user_id`
 		               WHERE `group_group_rel_user`.`group_id` is NULL AND `user_user`.`status`=5
  		           ORDER BY `lastname`, `firstname`";
        }
        else
        {
            // Query van het gegevensbestand....
            $query = "SELECT DISTINCT '' as `display_order`,`lastname`,`firstname`,`username`,'' as `classcode`,  `user_user`.`id`,`user_user`.`active`
  		      	    FROM `user_user`
				LEFT JOIN `group_group_rel_user`
					ON `user_user`.`id` = `group_group_rel_user`.`user_id`
				LEFT JOIN `campus_department_rel_group`
					ON `group_group_rel_user`.`group_id` = `campus_department_rel_group`.`group_id` AND `type`=2
				WHERE (`lastname` like '%" . $search . "%' OR
					`firstname` like '%" . $search . "%' OR
					concat(`lastname`,' ',`firstname`) like '%" . $search . "%' OR
					concat(`firstname`,' ',`lastname`) like '%" . $search . "%') AND `status` = 5
					
				ORDER BY  `lastname`, `firstname`";
        }
        $result = mysql_query($query) or die(mysql_error());
        echo ("<div style='width:100%;'></div><br clear=\"all\">");
        echo "<div style='float:right'>";
        if ($is_platformadmin)
        {
            echo "|&nbsp;<a href=\"" . $this->get_campus_admin_url() .
                "&page=studentadmin&action=blockall\" onclick=\"javascript:if(!confirm('" .
                get_lang("msgboxConfirmBlockAllStudents") . "')) return false;\" title=\"" .
                get_lang("tooltipBlockAllStudents") . "\">" . get_lang("txtBlockAllStudents") . "</a>&nbsp;|&nbsp;";
            echo "<a href=\"" . $this->get_campus_admin_url() .
                "&page=studentadmin&action=releaseall\" onclick=\"javascript:if(!confirm('" .
                get_lang("msgboxConfirmReleaseAllStudents") . "')) return false;\" title=\"" .
                get_lang("tooltipReleaseAllStudents") . "\">" . get_lang("txtReleaseAllStudents") . "</a>&nbsp;";
        }
        if ($select > 0)
        {
            echo "<a href=\"" . $this->get_campus_admin_url() . "&page=studentadmin&select=" . $select . "&action=sort\" onclick=\"javascript:if(!confirm('" . get_lang("msgboxConfirmSortStudents") . "')) return false;\" title=\"" . get_lang("tooltipSortStudents") . "\">" . get_lang("txtSortStudents") . "</a>&nbsp;";
        }
        echo "</div>";
        campus::display_complex_table_header($properties, array(get_lang("colheadNr"), get_lang("colheadName"), get_lang("colheadFirstName"), get_lang("colheadUsername"), get_lang("colheadClass"), ""));
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $data = array();
            $data[] = $rij['display_order'];
            $data[] = $rij['lastname'];
            $data[] = $rij['firstname'];
            $data[] = $rij['username'];
            $grouplist = "";
            $sql2 = "SELECT `code` FROM `group_group` LEFT JOIN `group_group_rel_user`
 	 		 						ON  `group_group`.`id`=`group_group_rel_user`.`group_id`
 	 		 						WHERE `user_id` = " . $rij['id'];
            $result2 = mysql_query($sql2);
            while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
            {
                $grouplist.=$rij2['code'] . " ";
            }
            $data[] = $grouplist;
            $links =
                "<a href=\"" . $this->get_campus_admin_url() . "&page=studentadmin&user_id=" . $rij['id'] . "&select=" .
                $select . "&action=editform\" title=\"" . get_lang("tooltipChangeClass") . "\"><img src=\"" .
                Theme::get_image_path('application\campus') . "/group_add.gif\" border=0 align=\"absmiddle\" ></a>";
            if (($search == "") && ($grouplist != ""))
            {
                $links .=
                    "&nbsp;<a href=\"" . $this->get_campus_admin_url() . "&page=studentadmin&user_id=" . $rij['id'] .
                    "&select=" . $select . "&action=delete\" onclick=\"javascript:if(!confirm('" .
                    get_lang("msgboxConfirmRemoveFromClass") . $classinfo[$select]['code'] .
                    ".')) return false;\" title=\"" . get_lang("tooltipDeleteFromClass") . "\"><img src=\"" .
                    Theme::get_image_path(
                        'application\campus'
                    ) . "/group_delete.gif\" border=0 align=\"absmiddle\" ></a>";
            }
            if ($is_platformadmin)
            {
                $links .=
                    '&nbsp;<a href="' . $this->get_studenttracking_url() . '&student_id=' . $rij['id'] . '&classid=' .
                    $select . '" title="' . get_lang("tooltipStudentTracking") . '"><img src="' . Theme::get_image_path(
                        'application\campus'
                    ) . '/studenttracking.gif" border=0 align="absmiddle" /></a>';
                //$links.='&nbsp;<a href="' . '&user_edit&user_id=' . $rij['id'] . '" title="' . get_lang("tooltipEditUser") . '"><img src="' . Theme::get_image_path('application\campus') . '/edit.gif" border=0 align="absmiddle"></a>';
            }
            if ($rij['active'])
            {
                $links .= "&nbsp;" . (($is_platformadmin) ?
                        "<a href=\"" . $this->get_campus_admin_url() . "&page=studentadmin&user_id=" . $rij['id'] .
                        "&select=" . $select . "&action=block\" title=\"" . get_lang("tooltipBlockUser") . "\">" : "") .
                    "<img src=\"" . Theme::get_image_path('application\campus') .
                    "/right.gif\" border=0 align=\"absmiddle\">" . (($is_platformadmin) ? "</a>" : "");
            }
            else
            {
                $links .= "&nbsp;" . (($is_platformadmin) ?
                        "<a href=\"" . $this->get_campus_admin_url() . "&page=studentadmin&user_id=" . $rij['id'] .
                        "&select=" . $select . "&action=release\" title=\"" . get_lang("tooltipReleaseUser") . "\">" :
                        "") . "<img src=\"" . Theme::get_image_path('application\campus') .
                    "/wrong.gif\" border=0 align=\"absmiddle\">" . (($is_platformadmin) ? "</a>" : "");
            }
            $data[] = $links;
            campus::display_table_row($bgcolor, $data, true);
        }
        campus::display_table_footer();
    }
    else
    {
        // Het formulier tonen.....
        // gegevens selecteren
        $sql = "SELECT `group_id`,`display_order` FROM `group_group_rel_user` WHERE `user_id` = " . $user_id . " LIMIT 1";
        $result = mysql_query($sql);
        $rij = mysql_fetch_array($result, MYSQL_ASSOC);
        echo '<form method="post" action="' . $this->get_campus_admin_url() . '" name="myform">';
        echo '<input type="hidden" name="page" value="studentadmin" >';
        echo '<input type="hidden" name="select" value="' . $select . '" >';
        echo '<input type="hidden" name="user_id" value="' . $user_id . '" >';
        echo '<input type="hidden" name="action" value="' . $action . '" >';
        echo '<table>
			<tr valign="top">
				<td colspan="2">
				</td>
			</tr>
			<tr valign="top">
				<td  align="right">
					' . get_lang('labelStudent') . ':
				</td>
				<td>
					' . $userinfo['firstname'] . ' ' . $userinfo['lastname'] . '
					<br />
				</td>
			</tr>
			<tr valign="top">
				<td  align="right">
					' . get_lang('labelClass') . '
				</td>
				<td>
					<select name="newclass" size=5 style="width:150px;"> 
					<option value=""> </option>';
        foreach ($classes as $key => $value)
        {
            echo '<option value="' . $key . '" ' . (($select == $key) ? 'SELECTED' : '') . '>' . $classes[$key]['code'] . ' </option>';
        }
        echo '	          </select>
				</td>
			</tr>
			<tr valign="top">
				<td  align="right">
					' . get_lang('labelOrder') . '
				</td>
				<td>
					<input type="text" name="display_order" size="3" value="' . $rij['display_order'] . '" />
				</td>
			</tr>
			<tr valign="top">
				<td>
				</td>
				<td>
					<input type="submit" name="submitmessage" value="' . get_lang('buttonlabelChange') . '" onmousedown="javascript:document.myform.action.value=\'update\';">
					<input type="submit" name="submitmessage2" value="' . get_lang('buttonlabelNew') . '" onmousedown="javascript:document.myform.action.value=\'new\';">
					<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
				</td>
			</tr>
			</table>
		</form>';
    }
}
?>
