<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Hashing;
use common\libraries\Theme;
use common\libraries\Display;

/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */

//check if user is allowed here...
if (!isset($_uid) || (empty($admin['student']) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $action = campus::get_POST_GET("action", "show");
    $select = campus::get_POST_GET("select");
    $studentid = intval(campus::get_POST_GET("studentid"));
    $search = campus::get_POST_GET("search");

    if (is_array($select))
    {
        $selectie = "";
        foreach ($select as $key)
        {
            $selectie.=$key . ",";
        }
        $selectie = substr($selectie, 0, -1);
    }
    else
    {
        $selectie = $select;
    }
    if (($action == "reset_passwd") && ($studentid > 0))
    {
        $sql = "SELECT `initialpassword` FROM `campus_user` WHERE `user_id` = " . $studentid;
        $result = mysql_query($sql);
        list($initialpassword) = mysql_fetch_row($result);
        if ($initialpassword == '')
        {
            // if no initial password exists generate new password and save this as initial password...
            $newpasswd = Text::generate_password(8);
            $sql = 'INSERT INTO  `campus_user` SET `initialpassword`="' . $newpasswd . '", ';
            $sql.=' `user_id` = ' . $studentid . ' ';
            $sql.=' ON DUPLICATE KEY UPDATE ';
            $sql.=' `initialpassword`="' . $newpasswd . '" ';
            $result = mysql_query($sql);
        }
        else
        {
            // load the initial password back 
            $newpasswd = $initialpassword;
        }
        $sql = "UPDATE `user_user` SET `password` = '" . Hashing :: hash($newpasswd) . "' WHERE `id` = " . $studentid;
        $result = mysql_query($sql);
        $userinfo = campus::get_user_info($studentid);
        $message = get_lang("txtNewPassword") . $userinfo['lastname'] . ' ' . $userinfo['firstname'] . ': ' . $newpasswd;
    }
    elseif (($action == "new_passwd") && ($studentid > 0))
    {
            $passwd = Text::generate_password(8);
            $sql2 = "UPDATE `user_user` SET `password` = '" . Hashing :: hash($passwd) . "' WHERE `id` = " . $studentid;
            $result2 = mysql_query($sql2);
            $sql2 = 'INSERT INTO  `campus_user` SET `initialpassword`="' . $passwd . '", ';
            $sql2.=' `user_id` = ' .$studentid . ' ';
            $sql2.=' ON DUPLICATE KEY UPDATE ';
            $sql2.=' `initialpassword`="' . $passwd . '" ';
            $result2 = mysql_query($sql2);

        }


    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    //display title and messages
    if (!empty($message))
    {
        Display::warning_message($message, false);
    }
    // create a list of studentclasses off the department
    $classes = campus::get_studentclasses($department_id);
    echo "<FORM ACTION=\"" . $this->get_campus_admin_url() . "\" METHOD=\"POST\" NAME=\"Selectklas\">";
    echo "<input type=\"hidden\" name=\"page\" value=\"studentpassword\">";
    echo "<table width=100%><tr>";
    echo "<td width='75%' valign='top'>";
    echo "<div style='float:right'>";
    echo get_lang('Search') . ': <input type="tekst" name="search" OnChange="javascript:Selectklas.submit();" value="' . $search . '">';
    echo '&nbsp;&nbsp;</div>';
    echo '<b style="vertical-align:text-bottom;">' . get_lang('txtQuickSelect') . '<BR></b>';
    foreach ($classes as $key => $value)
    {
        echo " <a href=\"" . $this->get_campus_admin_url() . "&select=" . $key . "&page=studentpassword\" title=\"" . get_lang("tooltipShow") . " " . $classes[$key]['name'] . "\">" . $classes[$key]['code'] . "</a>";
    }
    echo "</td>";
    echo "<td width='25%' valign='top'>";
    echo "	<b>" . get_lang("txtMultiple") . "<BR></b><div style='Z-index:1'>
   				<SELECT name=\"select[]\" OnChange='javascript:document.Selectklas.submit();' multiple=\"multiple\" size=5 style=\"width:150px;display:inline;Z-index:0;\"> ";
    foreach ($classes as $key => $value)
    {
        echo '<OPTION VALUE="' . $key . '" ' . ((is_array($select)) ? ((in_array($key, $select)) ? 'SELECTED' : '') : (($select == $key) ? 'SELECTED' : '')) . '>' . $classes[$key]['code'] . ' (' . $classes[$key]['aantal'] . ' ' . get_lang("txtStudents") . ')</OPTION>';
    }
    echo "</SELECT></div>";
    echo "</td>";
    echo "</tr></table>";
    echo "</FORM> ";
    echo "<div style=\"clear:both\"></div>";

    /*
      -----------------------------------------------------------
      Geselecteerde lijst....
      -----------------------------------------------------------
     */
    if (($select != "") && ($search == ""))
    {
        // afdruk mogelijkheden functies met de lijsten....
        echo "<div style=\"clear:both\"></div>";
        echo '<div style="float:right;">';
        echo '<a href="#" onclick="javascript:excell.submit()">' . get_lang("txt2Xls") . '</a>';
        echo '</div>';
        // Query van het gegevensbestand....
        $query = "SELECT `user_user`.`id`, `display_order`, `lastname`, `firstname`, `email`,`username`, `password`, `initialpassword`,`group_group`.`code`
            FROM `group_group_rel_user`
                LEFT JOIN `user_user`
                   ON `user_user`.`id` = `group_group_rel_user`.`user_id`
                   LEFT JOIN `campus_user`
                        ON `user_user`.`id` = `campus_user`.`user_id`
                LEFT JOIN `group_group`
                   ON `group_group`.`id` = `group_group_rel_user`.`group_id` WHERE ";
        if (is_array($select))
        {
            $filter = "";
            // meervoudige selectie doormiddel van array.
            foreach ($select as $conditie)
            {
                $filter.="`group_group_rel_user`.`group_id` = " . $conditie . " OR ";
            }
            $filter = substr($filter, 0, -3) . " ";
        }
        else
        {
            echo '<a href="' . $this->get_campus_admin_url() . '&page=studentpassword&select=' . $select . '&action=reset_passwd" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmResetPasswds") . '\')) return false;">' . get_lang("txtResetPasswds") . '</a>';
            if ($is_platformadmin)
            {
                echo '<a href="' . $this->get_campus_admin_url() . '&page=studentpassword&select=' . $select . '&action=new_passwd" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmNewPasswds") . '\')) return false;">' . get_lang("txtGenerateNewPasswds") . '</a>';
            }
            // enkelvoudige selectie.
            $filter = " `group_group_rel_user`.`group_id` = " . $select . " ";
        }
        $sql = $query . $filter . " ORDER BY `group_group`.`code`, `display_order`, `lastname`, `firstname`";
    }
    else
    {
        echo '<a href="' . $this->get_campus_admin_url() . '&page=studentpasswd2csv" >' . get_lang("txtStudentLogin2csv") . '</a>';

    }
    if ($search != "")
    {
        // Query van het gegevensbestand....
        $sql = "SELECT `user_user`.`id`, `display_order`, `lastname`, `firstname`, `email`, `username`, `password`, `initialpassword`, `group_group`.`code`
                FROM `user_user`
                    LEFT JOIN `campus_user`
                        ON `user_user`.`id` = `campus_user`.`user_id`
                    INNER JOIN `group_group_rel_user`
                        ON `user_user`.`id` = `group_group_rel_user`.`user_id`
                    INNER JOIN `group_group`
                        ON `group_group`.`id` = `group_group_rel_user`.`group_id`
                    INNER JOIN `campus_department_rel_group`
                        ON `group_group`.`id` = `campus_department_rel_group`.`group_id` AND `type`=2
                    WHERE (`lastname` like '%" . $search . "%' OR
			`firstname` like '%" . $search . "%' OR
			concat(`lastname`,' ',`firstname`) like '%" . $search . "%' OR
			concat(`firstname`,' ',`lastname`) like '%" . $search . "%') AND
				`department_id`=" . $department_id . "
		ORDER BY  `group_group`.`code`,`display_order`, `lastname`, `firstname`";
    }
    echo "<div style=\"clear:both\"></div>";
    echo '
			<form method="post" action="' . $this->get_campus_admin_url() . '" name="excell" >
			<input type="hidden" name="action" value="file" >
			<input type="hidden" name="page" value="studentpasswd2excel" >';
    campus::display_complex_table_header($properties, array(get_lang("colheadNr"), get_lang("colheadName"), get_lang("colheadFirstName"), get_lang("colheadEmail"), get_lang("colheadUsername"), get_lang("colheadPasswd"), get_lang("colheadClass"), ""));
    if (($select != "") || ($search != ""))
    {
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $data = array();
            $data[] = '<input type="hidden" name="display_order[' . $rij['id'] . ']" value="' . $rij['display_order'] . '">' . $rij['display_order'] . '';
            $data[] = '<input type="hidden" name="lastname[' . $rij['id'] . ']" value="' . $rij['lastname'] . '">' . $rij['lastname'] . '';
            $data[] = '<input type="hidden" name="firstname[' . $rij['id'] . ']" value="' . $rij['firstname'] . '">' . $rij['firstname'] . '';
            $data[] = '<input type="hidden" name="email[' . $rij['id'] . ']" value="' . $rij['email'] . '"><a href="mailto:' . $rij['email'] . '">' . $rij['email'] . '</a>';
            $data[] = '<input type="hidden" name="username[' . $rij['id'] . ']" value="' . $rij['username'] . '">' . $rij['username'] . '';
            if (($action == "new_passwd")&&($studentid==0))
            {
                $passwd = $showpasswd = Text::generate_password(8);
                $sql2 = "UPDATE `user_user` SET `password` = '" . Hashing :: hash($passwd) . "' WHERE `id` = " . $rij['id'];
                $result2 = mysql_query($sql2);
                $sql2 = 'INSERT INTO  `campus_user` SET `initialpassword`="' . $passwd . '", ';
                $sql2.=' `user_id` = ' . $rij['id'] . ' ';
                $sql2.=' ON DUPLICATE KEY UPDATE ';
                $sql2.=' `initialpassword`="' . $passwd . '" ';
                $result2 = mysql_query($sql2);
            }
            elseif (($action=="reset_passwd")&&($studentid==0))
            {
                $passwd = $showpasswd = $rij['initialpassword'];
                $sql2 = "UPDATE `user_user` SET `password` = '" . Hashing :: hash( $passwd) . "' WHERE `id` = " . $rij['id'];
                $result2 = mysql_query($sql2);
            }
            else
            {
                if ($rij['password'] == Hashing::hash($rij['initialpassword']))
                {
                    $passwd = '';
                    $showpasswd = '<big title="' . $rij['initialpassword'] . '">&bull;&bull;&bull;&bull;&bull;&bull;</big>';
                }
                else
                {
                    $passwd =get_lang('txtPasswdChanged');
                    $showpasswd =  '<span title="'.get_lang('tooltipPasswdChanged').'">'.get_lang('txtPasswdChanged').'</span>';
                }
            }
            $data[] = '<input type="hidden" name="password[' . $rij['id'] . ']" value="' .$rij['initialpassword'] . '"><input type="hidden" name="changed[' . $rij['id'] . ']" value="' . $passwd . '">' . $showpasswd;
            $data[] ='<input type="hidden" name="group_code[' . $rij['id'] . ']" value="' . $rij['code'] . '">' . $rij['code'];

            $data[] =   '<a href="' . $this->get_campus_admin_url() . '&page=studentpassword&select=' . $select . '&action=reset_passwd&studentid=' . $rij['id'] . '" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmResetPasswd") . '\')) return false;" title="' . get_lang("tooltipResetPasswd2") . ' ' . $rij['initialpassword'] . '"><img src="' . Theme::get_image_path('application\campus') . '/passwd.gif" border=0 align="absmiddle"></a>'.
                (($is_platformadmin)?('<a href="' . $this->get_campus_admin_url() . '&page=studentpassword&select=' . $select . '&action=new_passwd&studentid=' . $rij['id'] . '" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmNewPasswd") . '\')) return false;" title="' . get_lang("tooltipNewPasswd") . '"><img src="' . Theme::get_image_path('application\campus') . '/passwd.gif" border=0 align="absmiddle"></a>'):'');
            campus::display_table_row($bgcolor, $data, true);
        }
    }
    campus::display_table_footer();
    echo '</form>';
}
?>