<?php
/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Theme;
use common\libraries\Display;

/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */
/*
  ==============================================================================
  MAIN CODE
  ==============================================================================
 */

//check if user is allowed here...
if ((intval($_uid) == 0) || !$is_platformadmin)
{// not allowed here!
    Display::display_error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...
//require_once (api_get_path(LIBRARY_PATH).'classmanager.lib.php');

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */

    $action = campus::get_POST_GET("action");
    $select = intval(campus::get_POST_GET("select"));
    $user_id = intval(campus::get_POST_GET("user_id"));
    $newclass = intval(campus::get_POST_GET("newclass"));
    $order = intval(campus::get_POST_GET("order"));

    $userinfo = campus::get_user_info($user_id);
    $search = campus::get_POST_GET("search");
    /*
      -----------------------------------------------------------
      execute actions....
      -----------------------------------------------------------
     */
    $message = "";
    switch ($action)
    {
        case "update" :
            {
                if ($select != 0)
                {
                    if ($select == $newclass)
                    {
                        // the steacher stays in the same class, only order is changed.
                        $result = mysql_query("UPDATE `group_group_rel_user` SET `display_order` =" . intval($order) . " WHERE `group_id`=" . $select . " AND `user_id`=" . $user_id);
                        if (!$result)
                        {
                            $message = get_lang("msgOrderEditError") . " ";
                        }
                        else
                        {
                            $classinfo = campus::get_class_info($select);
                            $message = $userinfo['firstname'] . " " . $userinfo['lastname'] . " " . get_lang("msgOrderChanged") . " " . $order . " (" . $classinfo[$select]['code'] . ")";
                        }
                    }
                    else
                    {
                
                        $result = mysql_query("DELETE FROM `group_group_rel_user` WHERE `group_id`=" . $select . " AND `user_id`=" . $user_id);
                        $classinfo = campus::get_class_info($select);
                        $message = $userinfo['firstname'] . " " . $userinfo['lastname'] . " " . get_lang("msgDeletedFromClass") . " " . $classinfo[$select]['code'] . ". ";
                    }
                }
            }
        // no break !!!!!
        case "new" :
            {
                if ($select != $newclass)
                { //add user to new class and connect to courses connected to new class

                    // insert order nummer...
                    $result = mysql_query("INSERT `group_group_rel_user` SET  `display_order` =" . intval($order) . " , `group_id`=" . $newclass . ", `user_id`=" . $user_id);
                    //set user active
                    $result3 = mysql_query("UPDATE `user_user` SET `active`=1  WHERE `id`=" . $user_id);
                    $classinfo = campus::get_class_info($newclass);
                    $message.=$userinfo['firstname'] . " " . $userinfo['lastname'] . " " . get_lang("msgAdded2Class") . " " . $classinfo[$newclass]['code'] . ". ";
                    $message.= ( $result3) ? get_lang("msgUserActivated") . "<br>" : "";
                    $display = "list";
                }
                else
                {
                    $display = "list";
                }
            }
            break;
        case "delete" :
            {
                // Delete user from class.....
                //ClassManager :: unsubscribe_user($user_id, $select);
                $result = mysql_query("DELETE FROM `group_group_rel_user` WHERE `group_id`=" . $select . " AND `user_id`=" . $user_id);

                $classinfo = campus::get_class_info($select);
                $message = $userinfo['firstname'] . " " . $userinfo['lastname'] . " " . get_lang("msgDeletedFromClass") . " " . $classinfo[$select]['code'];

                $departments = campus::get_department($user_id);
                if (!isset($departments[$department_id]))
                { // user is no member of this department anymore....
                    // remove teacher from roster....
                    $message.="<br>" . get_lang("msgDeletedFromDepartment");
                    $query = "DELETE `campus_assignment_rel_teacher`
							FROM `campus_curriculum`,`campus_assignment`,`campus_assignment_rel_teacher`
							WHERE 	`campus_curriculum`.`id`=`campus_assignment`.`curriculum_id` AND
									`campus_assignment`.`id`=`campus_assignment_rel_teacher`.`assignment_id` AND
									`user_id`=" . $user_id . " AND `department_id`=" . $department_id;
                    $result = mysql_query($query) or die("1" . mysql_error());
                    if (mysql_affected_rows() > 0)
                        $message.= "<br>" . get_lang("msgDeletedFromRoster");
                    // remove teacher from rights....
                    $query = "DELETE FROM `campus_rights` WHERE `user_id`=" . $user_id . " AND `department_id`=" . $department_id;
                    $result = mysql_query($query) or die("2" . mysql_error());
                    if (mysql_affected_rows() > 0)
                        $message.= "<br>" . get_lang("msgDeletedFromCampusAdministrators");
                    $query = "DELETE FROM `campus_teacher_rel_group`
							WHERE `teacher_id`=" . $user_id . " AND `department_id`=" . $department_id;
                    $result = mysql_query($query) or die("3" . mysql_error());
                    if (mysql_affected_rows() > 0)
                        $message.= "<br>" . get_lang("msgDeletedAsClasscoach");
                    // delete individual coachings from department....
                    $query = "SELECT * FROM `campus_coach_rel_student` WHERE `teacher_id`=" . $user_id;
                    $result = mysql_query($query);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $departments = campus::get_department($rij['student_id']);
                        if (isset($departments[$department_id]))
                        { // check if the student and thus the individual coachin is from this department, delete when this is the case...
                            $query2 = "DELETE FROM `campus_coach_rel_student`
									WHERE `teacher_id`=" . $user_id . " AND `student_id`=" . $rij['student_id'];
                            $result2 = mysql_query($query2) or die("4" . mysql_error());
                            if (mysql_affected_rows() > 0)
                                $message.="<br>" . get_lang("msgDeletedAsIndividualcoach");
                        }
                    }
                }
                if (empty($departments))
                { // user is no member of any department anymore...
                    // de activate account....
                    $result = mysql_query("UPDATE `user_user` SET `active`=0 WHERE `id`=" . $user_id);
                    $message.= ( $checkclasses == 0) ? "<br>" . get_lang("msgUserDeActivated") . "<br>" : "";
                }
                $display = "list";
            }
            break;
        case "editform" :
            {
                
            }
            break;
        default :
            {
                $display = "list";
            }
            break;
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }
    if ($display == "list")
    {
        // create a list of studentclasses off the department
        $classes = campus::get_teacherclasses($department_id);
        // De klaslijst tonen.....
        echo '<div style="width:75%;float:right; ">';
        echo '<FORM ACTION="' . $this->get_campus_admin_url() . '" METHOD="POST" NAME="SearchTeacher">';
        echo '<input type="hidden" name="page" value="teacheradmin">';
        echo '<div style="float:right">';
        echo get_lang('Search') . ': <input type="tekst" name="search" OnChange="javascript:SearchTeacher.submit();" value="' . $search . '">';
        echo '&nbsp;&nbsp;</div>';
        echo '</FORM> ';
        echo '<b style="vertical-align:text-bottom;">' . get_lang('txtQuickSelect') . '<BR></b>';
        echo ' <a href="' . $this->get_campus_admin_url() . '&page=teacheradmin&select=free" title="' . get_lang('tooltipTeacherPool') . '">' . get_lang('txtTeacherPool') . '</a>';
        foreach ($classes as $key => $value)
        {
            echo" <a href=\"" . $this->get_campus_admin_url() . "&page=teacheradmin&select=" . $key . "\" title=\"" . get_lang("tooltipShow") . " " . $classes[$key]['code'] . "\">" . $classes[$key]['code'] . "</a>";
        }
        echo '</div>';
        if ($select != 0)
        {
            $classinfo = campus::get_class_info($select);
            echo "<b style=\"font-size: 24px;\">" . $classinfo[$select]['code'] . "</b>";
            // Query van het gegevensbestand....
            $query = "SELECT `user_user`.`id`, `lastname`, `firstname`, `official_code`, `username`
                    FROM `group_group_rel_user`
                        INNER JOIN `user_user`
                            ON `user_user`.`id` = `group_group_rel_user`.`user_id`
                        INNER JOIN `group_group`
                            ON `group_group`.`id` = `group_group_rel_user`.`group_id`
                    WHERE `group_group_rel_user`.`group_id` = " . $select . "
                        ORDER BY `lastname`, `firstname`";
        }
        elseif ($search == "")
        {
            echo "<b style=\"font-size: 24px;\">" . get_lang("txtTeacherPool") . "</b>";
            // Query van het gegevensbestand....
            $query = "SELECT DISTINCT `user_user`.`id`, `lastname`, `firstname`, `official_code`, `username`
	            FROM `user_user`
                     WHERE (
                        NOT EXISTS (SELECT `department_id` FROM `campus_department_rel_group`
		                INNER JOIN `group_group_rel_user`
                   			ON `campus_department_rel_group`.`group_id` = `group_group_rel_user`.`group_id` AND  `type`=1
                	WHERE  `user_user`.`id` = `group_group_rel_user`.`user_id`))
                   AND `status`<>5 ORDER BY `lastname`, `firstname`";
        }
        else
        {
            // Query van het gegevensbestand....
            $query = "SELECT DISTINCT `user_user`.`id`, `lastname`, `firstname`, `official_code`, `username`
        	    FROM `user_user`
                LEFT JOIN `group_group_rel_user`
                   ON `user_user`.`id` = `group_group_rel_user`.`user_id`
           		LEFT JOIN `campus_department_rel_group`
				   ON `campus_department_rel_group`.`group_id` = `group_group_rel_user`.`group_id` AND `type`=1
	 			WHERE (`lastname` like '%" . $search . "%' OR
					`firstname` like '%" . $search . "%' OR
					`username` like '%" . $search . "%' OR
					`official_code` like '%" . $search . "%' OR
					concat(`lastname`,' ',`firstname`) like '%" . $search . "%' OR
					concat(`firstname`,' ',`lastname`) like '%" . $search . "%') AND `status`<>5
				ORDER BY `lastname`,`firstname`";
        }
        $result = mysql_query($query) or die(mysql_error());
        echo "<div style='width:100%;'></div><br clear=\"all\">";
        campus::display_complex_table_header($properties, array(get_lang("colheadId"), get_lang("colheadName"), get_lang("colheadFirstName"), get_lang("colheadOfficialCode"), get_lang("colheadUsername"), get_lang("colheadClass"), ""));
        while ($rij = mysql_fetch_array($result, MYSQL_NUM))
        {
            $rij[5] = " ";
            $rij[6] = "<a href=\"" . $this->get_campus_admin_url() . "&page=teacheradmin&user_id=" . $rij[0] . "&select=" . $select . "&action=editform\" title=\"" . get_lang("tooltipChangeClass") . "\"><img src=\"" . Theme::get_image_path('application\campus') . "/group_add.gif\" border=0 align=\"absmiddle\" ></a>";
            $classesarray = campus::get_classes($rij['0']);
            foreach ($classesarray as $classid => $classinfo)
            {
                $rij[5].="<b title='" . $classinfo['name'] . "'>" . str_replace(" ", "_", $classinfo['code']) . "</b> ";
            }
            if (($search == "") && ($rij[5] != " "))
            {
                $rij[6].="&nbsp;<a href=\"" . $this->get_campus_admin_url() . "&page=teacheradmin&user_id=" . $rij[0] . "&select=" . $select . "&action=delete\" onclick=\"javascript:if(!confirm('" . get_lang("msgboxConfirmDeleteTeacher") . "')) return false;\" title=\"" . get_lang("tooltipDeleteFromClass") . "\"><img src=\"" . Theme::get_image_path('application\campus') . "/group_delete.gif\" border=0 align=\"absmiddle\" ></a>";
            }
            $query2 = "SELECT * FROM `" . $campusDb . "`.`campus_agenda` WHERE  `teacher_id`=" . $rij[0] . "";
            $result2 = mysql_query($query2);
            if (mysql_num_rows($result2) > 0)
            {
                $rij[6].="&nbsp;<a href=\"" . $this->get_campus_admin_url() . "&page=agendaadmin&teacher_id=" . $rij[0] . "\" title=\"" . get_lang("tooltipTeacherAgenda") . "\"><img src=\"" . Theme::get_image_path('application\campus') . "/agenda.gif\" border=0 align=\"absmiddle\" /></a>";
            }
            else
            {
                $rij[6].="&nbsp;<img src=\"" . Theme::get_image_path('application\campus') . "/agenda_na.gif\" border=0 align=\"absmiddle\" />";
            }
            //$rij[6].="&nbsp;<a href=\"" . $this->get_campus_admin_url() . "main/admin/user_edit.php?user_id=" . $rij[0] . "\" title=\"" . get_lang("tooltipEditUser") . "\"><img src=\"" . Theme::get_image_path('application\campus') . "/edit.gif\" border=0 align=\"absmiddle\"></a>";
            campus::display_table_row($bgcolor, $rij, true);
        }
        campus::display_table_footer();
    }
    else
    {
        // Het formulier tonen.....
        $userinfo = campus::get_user_info($user_id);
        // gegevens selecteren
        $sql = "SELECT `group_id`,`display_order` FROM `group_group_rel_user` WHERE `user_id` = " . $user_id . " AND `group_id`=" . $select . "";
        $result = mysql_query($sql) or die(mysql_error());
        $rij = mysql_fetch_array($result, MYSQL_ASSOC);
        echo "<b>" . get_lang("page_editteacher2class") . "</b><br>";
        echo '<form method="post" action="' . $this->get_campus_admin_url() . '" name="myform">';
        echo '<input type="hidden" name="page" value="teacheradmin" >';
        echo '<input type="hidden" name="select" value="' . $select . '" >';
        echo '<input type="hidden" name="user_id" value="' . $user_id . '" >';
        echo '<input type="hidden" name="action" value="' . $action . '" >';
        echo '<table>
			<tr valign="top">
				<td colspan="2">
				</td>
			</tr>
			<tr valign="top">
				<td  align="right">
					' . get_lang('labelTeacher') . '
				</td>
				<td>
					' . $userinfo['firstname'] . ' ' . $userinfo['lastname'] . '
					<br />
				</td>
			</tr>
			<tr valign="top">
				<td  align="right">
					' . get_lang("labelClass") . '
				</td>
				<td>
					<select name="newclass" size=5 style="width:250px;"> 
					<option value=""> </option>';
        foreach ($departmentStruc as $departmentid => $departmentinfo)
        {
            // create a list of studentclasses off the department
            $classes = campus::get_teacherclasses($departmentid);
            foreach ($classes as $key => $value)
            {
                echo ("<option value=\"" . $key . "\" " . (($select == $key) ? 'SELECTED' : '') . ">" . $classes[$key]['code'] . "=> " . $departmentinfo['code'] . " </option>");
            }
        }
        echo '			</select>
				</td>
			</tr>
			<tr valign="top">
				<td  align="right">
					' . get_lang('labelOrder') . '
				</td>
				<td>
					<input type="text" name="order" size="3" value="' . $rij['order'] . '" />
				</td>
			</tr>
			<tr valign="top">
				<td>
				</td>
				<td>
					<input type="submit" name="submitmessage" value="' . get_lang("buttonlabelChange") . '" onmousedown="javascript:document.myform.action.value=\'update\'">
					<input type="submit" name="submitmessage2" value="' . get_lang("buttonlabelNew") . '" onmousedown="javascript:document.myform.action.value=\'new\'">
					<input type="submit" name="cancel" value="' . get_lang("buttonlabelCancel") . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
				</td>
			</tr>
			</table>
			</form>';
    }
}
?>