<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Display;
use common\libraries\DatetimeUtilities;
use common\libraries\PlatformSetting;
use common\libraries\ResourceManager;
use common\libraries\Path;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($departmentStruc) || empty($is_teacher)) && ! ($is_platformadmin))
{ // not allowed here!
    Display::display_error_message(get_lang("msgNoDepartmentMember"), false);
}
else
{ //only teachers and platform administrator are allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $department_id = intval(campus::get_SESSION("department_id"));
    $selectAcYear = campus::get_POST_GET("selectAcYear");
    $selectType = campus::get_POST_GET("selectType");
    $user_code = $this->get_user()->get_official_code();
    $department_code = $departmentStruc[$department_id]['code'];

    $activeroster = campus::get_activeroster($department_id);

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (! empty($message))
    {
        Display::normal_message($message, false);
    }
    echo '<form method="post" action="' . $this->get_url() . '" name="agendaform" >
            <input type="hidden" name="page" value="agendaarchive">
			<input type="hidden" name="department_id" value="' . $department_id . '">';

    echo
        get_lang("txtSelectAgendaType") . ': <select name="selectType"  onchange=\'javascript:agendaform.submit();\' >';
    echo '<option value="discipline" ' . (($selectType == "discipline") ? 'SELECTED' : '') . '>' .
        get_lang("txtDisciplineAgenda") . '</option>';
    echo '<option value="student" ' . (($selectType == "student") ? 'SELECTED' : '') . '>' .
        get_lang("txtGroupAgenda") . '</option>';
    echo '</select>';

    echo get_lang("txtSelectAcademicYear") .
        ': <select name="selectAcYear"  onchange=\'javascript:agendaform.submit();\' >';
    $query = 'SELECT DISTINCT `academic_year` FROM `campus_agenda_archive`
             	WHERE  `department_code`="' .
        $departmentStruc[$department_id]['code'] . '" ORDER BY `academic_year` DESC';

    $result = mysql_query($query);
    while (list($year) = mysql_fetch_row($result))
    {
        $selectAcYear = ($selectAcYear == '') ? $year : $selectAcYear;
        echo
            '<option value="' . $year . '" ' . (($year == $selectAcYear) ? 'SELECTED' : '') . '>' . $year . '</option>';
    }
    echo '</select>';

    echo '</form>';
    if ($selectType == 'student')
    {
        $groups = array();
        $query = 'SELECT DISTINCT `grouplist`,`assignment_code` FROM `campus_agenda_archive`
             	WHERE  `department_code`="' . $department_code . '" AND `academic_year`="' .
            $selectAcYear . '" ORDER BY `assignment_code` ';
        $result = mysql_query($query) or die (mysql_error());
        while (list($grouplist, $assignment_code) = mysql_fetch_row($result))
        {
            if ($grouplist == '')
            {
                $assignment = explode(",", $assignment_code);
            }
            else
            {
                $assignment = array();
            }
            $groups = array_unique(
                array_merge($groups, explode("_", $assignment[1]), explode("_", str_replace(' ', '_', $grouplist)))
            );
        }
        sort($groups);
        campus::display_complex_table_header(
            $properties, array(get_lang("colheadAgenda"), get_lang("colheadDownload"), get_lang("colheadDownload"))
        );
        foreach ($groups as $value)
        {
            //echo $value . '=' . $department_code . '<br>';
            if ($value != '')
            {
                $column = array();
                $column[] = get_lang("txtGroupAgenda") . $value;
                $column[] = '<a href="' . $this->get_url() . '&page=agendaarchive2pdf&selectAcYear=' . $selectAcYear .
                    '&group_code=' . $value . '" target="_blank">Pdf</a>';
                $column[] =
                    '&nbsp;&nbsp;<a href="' . $this->get_url() . '&page=agendaarchive2csv&selectAcYear=' .
                    $selectAcYear .
                    '&group_code=' . $value . '" target="_blank">Excel/Csv</a>';
                campus::display_table_row($bgcolor, $column, true);
            }
        }
        campus::display_table_footer();
    }
    else
    {
        //construct special order for similar assignments...
        $teacher_assignment = campus::get_teacher2assignment($_uid, $activeroster['roster_id']);
        if (! empty($teacher_assignment))
        {
            $filter = 'IF(';

            foreach ($teacher_assignment as $key => $discipline)
            {
                $filter .= '( `discipline` like "%' . $discipline['name'] . '%" AND (';

                foreach ($discipline['group'] as $group)
                {
                    $filter .=
                        '`grouplist` like "%' . $group . '%" OR SUBSTRING_INDEX(`assignment_code`,",",-1)  like "%' .
                        $group . '%" OR ';
                }
                $filter = substr($filter, 0, - 3) . ')) OR ';
            }
            $filter = substr($filter, 0, - 3) . ', 0,1 ) ';
        }
        else
        {
            $filter = '1';
        }

        $query = 'SELECT `assignment_code`,`discipline`,`grouplist`,`teacher_code`, ' . $filter . ' as primary_order FROM `campus_agenda_archive`
             	WHERE  `department_code`="' . $department_code . '" AND `academic_year`="' .
            $selectAcYear . '"  GROUP BY `assignment_code` ORDER BY primary_order,`discipline`';
        $result = mysql_query($query) or die (mysql_error());
        campus::display_complex_table_header(
            $properties, array(get_lang("colheadAgenda"), get_lang("colheadDownload"), get_lang("colheadDownload"))
        );
        while (
        list($assignment_code, $discipline, $grouplist, $teacher_code, $primary_order) = mysql_fetch_row($result))
        {
            $assignment = explode(",", $assignment_code);
            $column = array();
            $showagenda = true;
            if (($assignment[0] == '') && ($assignment[1] == ''))
            { // personal agenda
                if ($teacher_code == $user_code)
                {
                    $agendatitle = get_lang("txtPersonalAgenda") . ' ' . $teacher_code;
                }
                else
                {
                    $agendatitle = get_lang("txtAgendaGhost");
                    $showagenda = false;
                }
            }
            elseif (($assignment[1] == '') || ($assignment[0] == ''))
            {
                if ($teacher_code == $user_code)
                {
                    $agendatitle = get_lang("txtPersonalAgenda") . ' ' . $teacher_code;
                }
                else
                { // if no teacher code is given this is a general agenda this is not shown in this list
                    $agendatitle = get_lang("txtGeneralAgenda") . ' ' . $assignment[0];
                    $showagenda = false;
                }
            }
            else
            {
                $agendatitle = get_lang("txtDisciplineAgenda");
                $teacher_code = ''; // remove teacher code to select complete discipline agenda...
            }
            if ($showagenda)
            {
                $column[] = ($primary_order ? '' : '<b>!!!</b> ') . $agendatitle . ' =>' .
                    $discipline . ' ' . (($grouplist == '') ? $assignment[1] : $grouplist);
                // '(' . $assignment_code . ') ' . $grouplist;
                $column[] = '<a href="' . $this->get_url() . '&page=agendaarchive2pdf&selectAcYear=' . $selectAcYear .
                    '&assignment_code=' . $assignment_code . '&teacher_code=' .
                    $teacher_code . '" target="_blank">Pdf</a>';
                $column[] =
                    '&nbsp;&nbsp;<a href="' . $this->get_url() . '&page=agendaarchive2csv&selectAcYear=' .
                    $selectAcYear .
                    '&assignment_code=' . $assignment_code . '&teacher_code=' .
                    $teacher_code . '" target="_blank">Excel/Csv</a>';
                campus::display_table_row($bgcolor, $column, true);
            }
        }
        campus::display_table_footer();
    }

    if (($selectAcYear == '') && ($agendaselect == ""))
    {
        Display::normal_message(get_lang("msgNoAgendaInArchive"), false);
    }
}
?>