<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Theme;
use common\libraries\Path;
use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($is_teacher)) && ! ($is_platformadmin))
{ // not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{ //only teachers and platform administrator are allowed here...

    /* ==============================================================================
      Instellingen ophalen voor de geselecteerde dag department etc......
      ============================================================================== */
    $department_id = intval(campus::get_SESSION("department_id"));
    $department_code = $departmentStruc[$department_id]['code'];
    $assignment_code = campus::get_POST_GET("assignment_code");
    $selectAcYear = campus::get_POST_GET("selectAcYear");
    $teacher_code = campus::get_POST_GET("teacher_code"); //$this->get_user()->get_official_code();
    $group_code = campus::get_POST_GET("group_code"); //$this->get_user()->get_official_code();
    if (($assignment_code != '')||($teacher_code!='')||($group_code!=''))
    {
        $departmentStruc = campus::get_department_info($department_code);
        if (! empty($departmentStruc))
        {
            $assignment = explode(",", $assignment_code);
             // Pagina instellingen
            include(Path :: get_web_application_path('campus') . '/old_php/php_pdf/class.ezpdf.php');
            $pdf = & new \Cezpdf('a4', 'landscape');
            $pdf->ezSetMargins(75, 40, 30, 30);
            $pdf->selectFont(Path :: get_web_application_path('campus') . '/old_php/php_pdf/fonts/Helvetica.afm');
            //koptekst en voettekst
            $pdf->ezStartPageNumbers(790, 15, 10, 'left', 'pagina {PAGENUM} van {TOTALPAGENUM}', 1);
            $pdf->ezStartPageNumbers(40, 15, 10, 'right', $departmentStruc[$department_id]['name'], 1);
            $all = $pdf->openObject();
            $pdf->saveState();
            $pdf->setStrokeColor(0.6, 0.6, 0.6);
            $pdf->setLineStyle(2, null);
            $pdf->line(50, 545, 790, 545);
            $ext = strtolower(substr($departmentStruc[$department_id]['logo'], - 4));
            if ($ext == '.jpg')
            {
                $pdf->addJpegFromFile(
                    Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 50,
                    550, 90
                );
            }
            elseif ($ext == '.png')
            {
                $pdf->addPngFromFile(
                    Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 50,
                    550, 90
                );
            }
            $pdf->setColor(0, 0, 0);
            $pdf->addText(350, 570, 14, "AGENDA  " . $selectAcYear);

            if ($teacher_code != '')
            {

                $result = mysql_query(
                    'SELECT `lastname`,`firstname`,`official_code` FROM `user_user` WHERE `official_code`="' .
                    $teacher_code . '"'
                );
                $user = mysql_fetch_array($result, MYSQL_ASSOC);
                $document_title=$user['firstname'] . " " . $user['lastname'];
                $selection=' AND `assignment_code`="' . $assignment_code . '" AND `teacher_code`="' . $teacher_code . '" ';
                $document_subtitle=($grouplist == '') ? $assignment[1] : $grouplist;
            }
            elseif ($assignment_code!='')
            {

                $selection=' AND `assignment_code`="' . $assignment_code . '" ';
                $query = 'SELECT `discipline`,`grouplist` FROM `campus_agenda_archive`
						WHERE `academic_year`= "' . $selectAcYear . '" AND `department_code` = "' . $department_code .'"
                         ' . $selection . '
						LIMIT 1';
                $result = mysql_query($query) or die (mysql_error());
                list($discipline, $grouplist)= mysql_fetch_row($result);

                $document_title=$discipline;
                $document_subtitle=($grouplist == '') ? $assignment[1] : $grouplist;
            }
            elseif ($group_code!='')
            {
                $selection=' AND (`grouplist` like  "%' . trim($group_code) . '%" OR  `assignment_code` like  "%' . trim($group_code) . '%")';
                $document_title=$group_code;
            }

            $pdf->addTextwrap(20, 570, 770, 14, utf8_decode($document_title), 'right');
            $pdf->addTextwrap(20, 550, 770, 12, utf8_decode($document_subtitle),'right');

            $pdf->addText(50, 530, 10, "Uur");
            $pdf->addText(80, 530, 10, "Inhoud.");
            $pdf->addText(410, 530, 10, "Taken/lessen.");
            $pdf->addText(605, 530, 10, "Opmerkingen.");
            $pdf->setLineStyle(1, null);
            $pdf->line(50, 525, 790, 525);
            $pdf->line(75, 545, 75, 30);
            $pdf->line(405, 545, 405, 30);
            $pdf->line(600, 545, 600, 30);
            $pdf->restoreState();
            $pdf->closeObject();
            $pdf->addObject($all, 'all');
            // de gegevens van de agenda gesorteerd per week in een array inlezen.
            $data = array();
            $query = 'SELECT `date`,`period_code`,`content`,`tasks`,`comment`,`grouplist`,`studentlist`, discipline FROM `campus_agenda_archive`
						WHERE `academic_year`= "' . $selectAcYear . '" AND `department_code` = "' . $department_code .'"
                         ' . $selection . '
						ORDER BY `date`,`period_code`';

             $result = mysql_query($query) or die (mysql_error());
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $data[$rij['date']][] = $rij;
            }
            campus::document2pdf_footer($pdf, 842, 1.5);
            foreach ($data as $id => $row)
            {
                $pdf->transaction('start');
                $lus = true;
                while ($lus)
                {
                    $pos1 = $pdf->ezPosY();
                    $date = DatetimeUtilities::format_locale_date("%d %B %Y", $id);
                    $pdf->setStrokeColor(0.95, 0.95, 0.95);
                    $pdf->setLineStyle(12);
                    $pdf->line(50, $pdf->ezPosY() - 6, 790, $pdf->ezPosY() - 6);
                    $pdf->setColor(0.3, 0.3, 0.55);
                    $pdf->ezSetDy(2);
                    $pdf->eZText($date . ".", 10, array('aleft' => 80));
                    $pdf->ezSetDy(- 4);
                    foreach ($row as $key => $rij)
                    {
                        $pos = $pdf->ezPosY() - 2;
                        $pdf->setColor(0, 0, 0);
                        $pdf->addText(50, $pos - 10, 12, $rij['period_code'], 0);
                        if ($group_code!='')
                        {
                            $pdf->ezText("<b>" . utf8_decode($rij['discipline']) . "</b>", 8, array('aleft' => 80,), 0);
                        }
                        elseif ($rij['grouplist'] != "")
                        {
                            $pdf->ezText("<b>" . utf8_decode($rij['grouplist']) . "</b>", 8, array('aleft' => 80,), 0);
                        }

                        $pos = $pdf->ezPosY();
                        $pdf->ezText(
                            "<i>" . utf8_decode($rij['content']) . "</i>", 10, array('aleft' => 85, 'aright' => 400), 0
                        );
                        $endcontent = $pdf->ezPosY();
                        $pdf->ezSetY($pos);
                        $pdf->ezText(
                            "<i>" . utf8_decode($rij['tasks']) . "</i>", 10, array('aleft' => 410, 'aright' => 595), 0
                        );
                        $endtasks = $pdf->ezPosY();
                        $pdf->ezSetY($pos);
                        if ($rij['studentlist'] != "")
                        {
                            $pdf->ezText(
                                "LLN: <i>" . utf8_decode($rij['studentlist']) . "</i>", 9,
                                array('aleft' => 605, 'aright' => 790), 0
                            );
                        }
                        $pdf->ezText("<i>" . $rij['comment'] . "</i>", 10, array('aleft' => 605, 'aright' => 790), 0);
                        $endcomment = $pdf->ezPosY();
                        $minpos = (($endcontent > $endtasks) ? (($endtasks > $endcomment) ? $endcomment : $endtasks) :
                                (($endcontent > $endcomment) ? $endcomment : $endcontent)) - 5;
                        $pdf->ezSetY($minpos);
                        $pdf->setLineStyle(1);
                        $pdf->line(50, $minpos - 1, 790, $minpos - 1);
                    }
                    if (($endcontent > $pos1) || ($endtasks > $pos1) || ($endcomment > $pos1))
                    {
                        $pdf->transaction('rewind');
                        $pdf->ezNewPage();
                        campus::document2pdf_footer($pdf, 842, 1.5);
                    }
                    else
                    {
                        $lus = false;
                    }
                }
                $pdf->transaction('commit');
            }
            $pdf->ezText("\n");
            $fileoption = array(
                'Content-Disposition' =>
                $selectAcYear . '_' . $department_code . '_' . ereg_replace(", ", "_", $assignment_code) . '_' .
                $teacher_coder . '.pdf'
            );
            $pdf->ezStream($fileoption);
        }
    }
}
?>