<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;
use common\libraries\Theme;
use common\libraries\Path;

//check if user is allowed here...
if (intval($_uid) == 0)
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $department_id = intval(campus::get_SESSION("department_id"));
    $user_id = $_uid;
    $select = campus::get_POST_GET("select", "student");
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);
    $selectAcYear = campus::get_POST_GET("selectAcYear", $academicYear);

    if (($select == 'teacher') && ($department_id != 0))
    { // leerkracht kalender.... via $department wordt bepaald welke kalender
        $classes = campus::get_teacherclasses($department_id); //get_classes ($user_id);
        $departmentStruc = campus::get_department_info($department_id);
    }
    else
    { // geen student kalender
        if ($select == 'student')
        { // De student open zijn kalender
            $classes = campus::get_classes($user_id);
            $departmentStruc = campus::get_department($user_id);
        }
        else
        { // de leerkracht kiest de student kalender...
            foreach (explode(',', $select) as $selectclass)
            {
                $classinfo = campus::get_class_info($selectclass);
                $classes[$selectclass]['code'] = $classinfo[$selectclass]['code'];
            }
            // de department wordt gekozen uit de eerste van de geselecteerde klasen....
            $query = "SELECT `department_id` FROM `campus_department_rel_group`
                WHERE `type`=2 `group_id` = " . key($classes) . " LIMIT 1";
            $result = mysql_query($query);
            $rij = mysql_fetch_array($result, MYSQL_ASSOC);
            $departmentStruc = campus::get_department_info($department_id);
        }
    }
    if (!empty($departmentStruc))
    {

        /*
          !!!  enkele variabelen zijn niet gedeclareerd
          daarom moeten de waarschuwingsmeldingen van php uitgeschakeld zijn
          PHP.INI
          error_reporting = E_ALL & ~E_NOTICE
         */
        /*
          ==============================================================================
          Verjaardagen invoegen
          ==============================================================================
         */
        $D = DatetimeUtilities::get_days_short();
        // Query van het gegevensbestand....
        $query = "SELECT DISTINCT `lastname`, `firstname`, `official_code`, `birth`
           FROM `group_group_rel_user`
              LEFT JOIN `user_user`
                  ON `user_user`.`id` = `group_group_rel_user`.`user_id`
              LEFT JOIN `campus_user`
                  ON `user_user`.`id` = `campus_user`.`user_id`
                LEFT JOIN `group_group`
                   ON `group_group`.`id` = `group_group_rel_user`.`group_id` WHERE (";
        $classcodes = "";
        foreach ($classes as $class_id => $value)
        {
            $classcodes.=$classes[$class_id]['code'] . " ";
            $query.="`group_group_rel_user`.`group_id`=" . $class_id . " OR ";
        }
        $query = substr($query, 0, -3) . ") ORDER BY `group_group`.`code`, `display_order`,`lastname`,`firstname`";

        $result = mysql_query($query);
        $aantal = mysql_num_rows($result);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            if ($rij['birth'] != '0000-00-00')
            {
                $geb_datum = explode("-", $rij['birth']);
                $jarige[strtotime(substr($selectAcYear, 0, 4) . "-" . intval($geb_datum[1]) . "-" . intval($geb_datum[2]))].= " " . (($select != 'teacher') ? ($rij['firstname'] . " " . substr($rij['lastname'], 0, 1)) : $rij['official_code']);
                $jarige[strtotime(substr($selectAcYear, 5, 4) . "-" . intval($geb_datum[1]) . "-" . intval($geb_datum[2]))].= " " . (($select != 'teacher') ? ($rij['firstname'] . " " . substr($rij['lastname'], 0, 1)) : $rij['official_code']);
            }
        }

        /*
          ==============================================================================
          kalender invoegen
          ==============================================================================
         */
        // Query van het gegevensbestand....
        $query = "SELECT `date`, `content`, `vacation` FROM `campus_calender`  WHERE `department_id`= " . key($departmentStruc);
        if ($select != 'teacher')
        {
            $query.=" AND `public`=1";
        }
        $tekst = array();
        $query.=" AND `date` >=" . mktime(0, 0, 0, 9, 1, substr($selectAcYear, 0, 4)) . " AND `date` <=" . mktime(0, 0, 0, 8, 31, substr($selectAcYear, 5, 4)) . " ";
        $result = mysql_query($query);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $tekst[$rij['date']].=$rij['content'] . ' ';
            $vrijaf[$rij['date']] = $rij['vacation'];
        }

        // Pagina instellingen
        include(Path :: get_web_application_path('campus') . '/old_php/php_pdf/class.ezpdf.php');
        $pdf = & new \Cezpdf('a4', 'landscape');
        $pdf->ezSetCmMargins(2, 2, 2, 2);
        $pdf->selectFont(Path :: get_web_application_path('campus') . '/old_php/php_pdf/fonts/Helvetica.afm');
        $phoogte = 842;
        $pbreedte = 575;
        //footer en headers of the document
        $pdf->ezStartPageNumbers(820, 15, 8, 'left', 'pagina {PAGENUM} van {TOTALPAGENUM}', 1);
        $pdf->ezStartPageNumbers(120, 565, 12, 'right', $departmentStruc[key($departmentStruc)]['name'] . (($select != 'teacher') ? ": " . $classcodes : ""), 1);
        $pdf->ezStartPageNumbers(820, 565, 12, 'left', 'KALENDER:' . $selectAcYear, 1);
        $ext=strtolower(substr($departmentStruc[key($departmentStruc)]['logo'], -4));
        if ($ext == '.jpg')
        {
            $pdf->addJpegFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[key($departmentStruc)]['logo'], 50, 563, 50);
        }
        elseif ($ext == '.png')
        {
            $pdf->addPngFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[key($departmentStruc)]['logo'], 50, 563, 50);
        }
        $filename = 'KALENDER' . $selectAcYear;
        $pdf->ezStartPageNumbers(60, 15, 8, 'right', 'website: http://www.de-spil.be', 1);
        $mnd1 = 9;
        $mnd2 = 12;
        $kolom = 0;
        $pdf->setColor(0.75, 0.75, 0.75);
        $pdf->filledRectangle(50, 512, 774, 28);
        $pdf->filledRectangle(50, 414, 774, 28);
        $pdf->filledRectangle(50, 316, 774, 28);
        $pdf->filledRectangle(50, 218, 774, 28);
        $pdf->filledRectangle(50, 120, 774, 28);
        $pdf->filledRectangle(50, 22, 774, 28);
        $pdf->setColor(0.1, 0.1, 0.1);
        for ($t = 1; $t <= 2; $t++)
        {
            for ($mnd = $mnd1; $mnd <= $mnd2; $mnd++)
            {
                if ($kolom > 5)
                {
                    $kolom = 0;
                    for ($n = 0; $n <= 37; $n++)
                    {
                        $pdf->line(50, 22 + ($n * 14), 50 + 774, 22 + ($n * 14));
                    }
                    for ($n = 0; $n <= 5; $n++)
                    {
                        $pdf->line(50 + ($n * 129), 22, 50 + ($n * 129), 540);
                        $pdf->line(50 + ($n * 129) + 11, 22, 50 + ($n * 129) + 11, 540);
                        $pdf->line(50 + ($n * 129) + 25, 22, 50 + ($n * 129) + 25, 540);
                    }
                    $pdf->line(824, 22, 824, 540);
                    $pdf->ezNewPage();
                    $pdf->setColor(0.75, 0.75, 0.75);
                    $pdf->filledRectangle(50, 512, 774, 28);
                    $pdf->filledRectangle(50, 414, 774, 28);
                    $pdf->filledRectangle(50, 316, 774, 28);
                    $pdf->filledRectangle(50, 218, 774, 28);
                    $pdf->filledRectangle(50, 120, 774, 28);
                    $pdf->filledRectangle(50, 22, 774, 28);
                    $pdf->setColor(0.1, 0.1, 0.1);
                }
                if ($mnd >= 9)
                {
                    $jaar = substr($selectAcYear, 0, 4); // ???
                }
                else
                {
                    $jaar = substr($selectAcYear, 5, 4); // ???
                }
                $testdatum = strtotime($jaar . '-' . $mnd . '-1');
                // weekdag van de eerstedag van de maand bepalen.
                $dag1 = strftime('%w', $testdatum);
                // het aantaldagen in de maand bepalen.
                for ($dag2 = 31; $dag2 >= 28; $dag2--)
                {
                    if (strftime('%m', $testdatum) == strftime('%m', strtotime($jaar . '-' . $mnd . '-' . $dag2)))
                    {
                        break;
                    }
                }
                // Maandschrijven...
                $pdf->setColor(0.7, 0.7, 0.9);
                $pdf->filledRectangle(50 + ($kolom * 129), 540, 129, 20);
                $pdf->setColor(0.1, 0.1, 0.1);
                $pdf->Rectangle(50 + ($kolom * 129), 540, 129, 20);
                $pdf->addText(115 + ($kolom * 129) - ($pdf->getTextWidth(11, DatetimeUtilities::format_locale_date('%B %Y', $testdatum))) / 2, 545, 11, DatetimeUtilities::format_locale_date('%B %Y', $testdatum));
                $dataOK = false;
                $dag = 6;
                $dagteller = 1;
                for ($n = 1; $n <= 37; $n++)
                {
                    $datum = strtotime($jaar . "-" . $mnd . "-" . $dagteller);
                    if ($dag == $dag1)
                    {
                        $dataOK = true;
                    }
                    if (($vrijaf[$datum] == 1) && (($dag != 0) && ($dag != 6)))
                    {
                        $pdf->setColor(0.7, 0.9, 0.7);
                        $pdf->filledRectangle(50 + ($kolom * 129), 540 - ($n * 14), 129, 14);
                        $pdf->setColor(0.1, 0.1, 0.1);
                    }
                    //weekdag schrijven ...
                    $pdf->addText(51 + ($kolom * 129), 545 - ($n * 14), 10, strtoupper(substr($D[$dag], 0, 1)));
                    if ($dataOK)
                    {
                        $pdf->addText(62 + ($kolom * 129), 545 - ($n * 14), 10, $dagteller);
                    }
                    if ($dataOK)
                    {
                        if (!empty($tekst[$datum]))
                        {
                            if ($tekst[$datum] != '')
                            {
                                $pdf->addText(76 + ($kolom * 129), 548 - ($n * 14), 6, $tekst[$datum]);
                            }
                        }
                        if (!empty($jarige[$datum]))
                        {
                            $pdf->addText(174 + ($kolom * 129) - ($pdf->getTextWidth(6, $jarige[$datum])), 542 - ($n * 14), 6, $jarige[$datum]);
                        }
                        $dagteller++;
                        if ($dagteller > $dag2)
                        {
                            $dag1 = 99;
                            $dataOK = false;
                        }
                    }
                    $dag++;
                    if ($dag > 6)
                    {
                        $dag = 0;
                    }
                }
                $kolom++;
            }
            $mnd1 = 1;
            $mnd2 = 8;
        }
        for ($n = 0; $n <= 37; $n++)
        {
            $pdf->line(50, 22 + ($n * 14), 50 + 774, 22 + ($n * 14));
        }
        for ($n = 0; $n <= 5; $n++)
        {
            $pdf->line(50 + ($n * 129), 22, 50 + ($n * 129), 540);
            $pdf->line(50 + ($n * 129) + 11, 22, 50 + ($n * 129) + 11, 540);
            $pdf->line(50 + ($n * 129) + 25, 22, 50 + ($n * 129) + 25, 540);
        }
        $pdf->line(824, 22, 824, 540);
        $pdf->ezText("\n");
        $fileoption = array('Content-Disposition' => $filename . '.pdf');
        $pdf->ezStream($fileoption);
    }
}
?>
