<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Display;
use common\libraries\DatetimeUtilities;
use common\libraries\PlatformSetting;
use common\libraries\ResourceManager;
use common\libraries\Path;

//check if user is allowed here...
if ((intval($_uid) == 0) || empty($departmentStruc) && !($is_platformadmin))
{// not allowed here!
    Display::display_error_message(get_lang("msgNoDepartmentMember"), false);
}
else
{//only teachers and platform administrator are allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $dateselect = intval(campus::get_POST_GET("dateselect", mktime(0, 0, 0, date('m', time()), date('d', time()), date('Y', time()))));
    $selectclass = intval(campus::get_POST_GET("group_id", 0));
    $student_id = intval(campus::get_POST_GET("student_id", 0));
    $agenda = campus::get_POST_GET("agenda", array());

    /* ==============================================================================
      Instellingen ophalen voor de geselecteerde dag department etc......
      ============================================================================== */
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/javascript/campus_agenda_ajax.js');
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/css/tooltip.css');
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_PLUGIN_PATH) . 'jquery/jquery.tooltip.min.js');
    
    if (($selectclass == 0) && (!$is_teacher))
    {
        $children = campus::parent2student($_uid);
        if (!empty($children))
        {
              $student_id = key($children);
        }
        else
        {
            $student_id = ($student_id == 0) ? $_uid : $student_id;
        }
        $groups = campus::get_classes($student_id);
       
    }
    else
    {
        $groups = campus::get_group_info($selectclass);
    }

    if ((strftime('%w', $dateselect) == 6) || (strftime('%w', $dateselect) == 0))
    {
        $dateselect = strtotime('next Monday', $dateselect);
    }
    // het uurrooster bepalen wat bij de datum en de department hoort ...
    $activeroster = campus::get_activeroster($department_id, $dateselect);

    $agenda_layout = $departmentStruc[$department_id]['agenda_layout'];


    if (strftime('%w', $dateselect) == 5)
    {
        $nextday = strtotime('next Monday', $dateselect);
    }
    else
    {
        $nextday = strtotime('+1 day', $dateselect);
    }
    if (strftime('%w', $dateselect) == 1)
    {
        $prevday = strtotime('last Friday', $dateselect);
    }
    else
    {
        $prevday = strtotime('-1 day', $dateselect);
    }

    $prevweek = strtotime('-1 week', $dateselect);
    $nextweek = strtotime('+1 week', $dateselect);


// ===================================================================================
    //   Read calendar info ...`
    // ===================================================================================
    $query = 'SELECT `id`, `date`, `content`, `public`, `vacation`
			FROM `campus_calender`
				WHERE `campus_calender`.`date`=' . $dateselect . ' AND `public`=1 AND `department_id`=' . $department_id;
    $result = mysql_query($query);
    $agendacontent = "";
    $calendercontent = "";
    $vrijaf = false;
    while ($rij = mysql_fetch_array($result))
    {
        if ($rij['vacation'] == 1)
        {
            $agendacontent = "\n\n\t\t" . get_lang("txtVacationDay") . ": " . $rij['content'];
            $vrijaf = true;
        }
        if ($rij['content'] != "")
        {
            $calendercontent.=$rij['content'];
        }
    }
    // ===================================================================================
    //   het uurrooster invullen in de agenda ...`
    // ===================================================================================
    if (!empty($groups))
    {
        $groupfilter = "";
        foreach ($groups as $group_id => $value)
        {
            $groupfilter.="`group_id`=" . $group_id . " OR ";
        }
        $rooster = campus::get_rosterarray($department_id);

        foreach ($rooster as $display_order => $day)
        {
            if ($day[strftime('%w', $dateselect)]['period_id'] != '')
            {
                $temp_agenda[$display_order]['period_id'] = $day[strftime('%w', $dateselect)]['period_id'];
                $temp_agenda[$display_order]['period_code'] = $day[strftime('%w', $dateselect)]['code'];
                //$temp_agenda[$display_order]['display_order'] = $display_order;
                $temp_agenda[$display_order]['date'] = $dateselect;
            }
        }
        $query = 'SELECT `campus_college`.`assignment_id`,`campus_college`.`id` as college_id, `weekday`,`code`, `display_order`,`duration`
                                        FROM `campus_period`
                                            INNER JOIN `campus_college`
                                                ON `campus_period`.`id`=`campus_college`.`period_id`  AND `campus_college`.`roster_id`=' . $activeroster['roster_id'] . '
                                               INNER JOIN `campus_assignment_rel_group`
                                                ON `campus_assignment_rel_group`.`assignment_id`=`campus_college`.`assignment_id` AND (' . substr($groupfilter, 0, -3) . ')
                                        WHERE `campus_period`.`department_id`=' . $department_id . ' AND `weekday`=' . strftime('%w', $dateselect) . ' ORDER BY `display_order`';
        $result = mysql_query($query) or die(mysql_error());
        while ($rij = mysql_fetch_array($result))
        {
            while ($rij['duration'] > 0)
            {

                if (!$vrijaf)
                {
                    $temp_agenda[$rij['display_order']]['assignment_select'][$rij['assignment_id']] = $rij['college_id']; //$assignment_id;
                    if (($rij['assignment_id'] == $agenda[$rij['display_order']]['assignment_id']) || (empty($agenda[$rij['display_order']]['assignment_id'])))
                    {
                        $temp_agenda[$rij['display_order']]['assignment_id'] = $rij['assignment_id'];
                    }
                    $temp_agenda[$rij['display_order']]['agenda_id'] = '';
                    $temp_agenda[$rij['display_order']]['content'] = '';
                    $temp_agenda[$rij['display_order']]['tasks'] = '';
                    $temp_agenda[$rij['display_order']]['comment'] = '';
                }
                else
                {
                    $temp_agenda[$rij['display_order']]['content'] = $agendacontent;
                }
                $rij['display_order']++;
                $rij['duration']--;
            }
        }
        $query = 'SELECT `campus_agenda`.`id` as agenda_id, `display_order`, `campus_agenda`.`assignment_id`, `date`, `period_id`,`code`, `content`, `tasks`, `comment`
                                    FROM `campus_agenda`
                                        INNER JOIN `campus_period`
                                            ON  `campus_period`.`id`= `campus_agenda`.`period_id`
                                        INNER JOIN `campus_agenda_rel_group`
                                            ON  `campus_agenda`.`id`= `campus_agenda_rel_group`.`agenda_id`
                                    WHERE `campus_period`.`department_id`=' . $department_id . ' AND (' . substr($groupfilter, 0, -3) . ') AND `date`=' . $dateselect . ' ORDER BY `display_order` ';
        $result = mysql_query($query);
        $prev_row = 0;
        $tabs = 1;
        $recordfound = FALSE;
        while ($rij = mysql_fetch_array($result))
        {
            $assignment_id = ($rij['assignment_id'] == 0) ? -1 : $rij['assignment_id'];
            $temp_agenda[$rij['display_order']]['assignment_select'][$assignment_id] = 0; 
            // only keep agenda whats filled in the agenda for this row...
            foreach ($temp_agenda[$rij['display_order']]['assignment_select'] as $assignmentid => $collegeid)
            {
                if ($collegeid>0)
                {
                    unset($temp_agenda[$rij['display_order']]['assignment_select'][$assignmentid]);
                }
            }
            
            /* if (!array_key_exists($temp_agenda[$rij['display_order']]['assignment_select'], $assignment_id))
              { // add assignment to select list when not existing...
              $temp_agenda[$rij['display_order']]['assignment_select'][$rij['assignment_id']] = 'test'; //$assignment_id;
              } */
            //if (($rij['agenda_id'] == $agenda[$rij['display_order']]['agenda_id']) || ( $assignment_id == $agenda[$rij['display_order']]['assignment_id']) || (empty($temp_agenda[$rij['display_order']]['assignment_id']) && empty($agenda[$rij['display_order']]['assignment_id']) && (empty($temp_agenda[$rij['display_order']]['agenda_id']) || ($rij['agenda_id'] == $temp_agenda[$rij['display_order']]['agenda_id']))))
            if (($rij['agenda_id'] == $agenda[$rij['display_order']]['agenda_id']) || ( $assignment_id == $agenda[$rij['display_order']]['assignment_id']) || ( empty($agenda[$rij['display_order']]['assignment_id']) && (empty($temp_agenda[$rij['display_order']]['agenda_id']) || ($rij['agenda_id'] == $temp_agenda[$rij['display_order']]['agenda_id']))))
            {
                $temp_agenda[$rij['display_order']]['assignment_id'] = $assignment_id;
            }

            if ($temp_agenda[$rij['display_order']]['assignment_id'] == $assignment_id)
            {

                if (($rij['display_order'] == $prev_row))//&&($agendaselect==0))
                {
                    $tabs++;
                }
                else
                {
                    $tabs = 1;
                }
                $temp_agenda[$rij['display_order']]['tab'][$tabs] = $rij['agenda_id'];
                if (empty($temp_agenda[$rij['display_order']]['agenda_id']) || ($rij['agenda_id'] == $agenda[$rij['display_order']]['agenda_id']) || (($agenda[$rij['display_order']]['agenda_id'] == '') && ($agenda[$rij['display_order']]['assignment_id'] == $assignment_id) ))
                {
                    // $temp_agenda[$rij['display_order']]['assignment_id'] = $assignment_id;
                    $temp_agenda[$rij['display_order']]['agenda_id'] = $rij['agenda_id'];
                    $temp_agenda[$rij['display_order']]['content'] = $rij['content'];
                    $temp_agenda[$rij['display_order']]['tasks'] = $rij['tasks'];
                    $temp_agenda[$rij['display_order']]['comment'] = $rij['comment'];
                }
            }
            $prev_row = $rij['display_order'];
        }

        $agenda = $temp_agenda;
    }
    echo "<div id='campus_agenda' >";
    echo '<form method="post" action="' . $this->get_url() . '" name="agendaform" >
		<input type="hidden" name="page" value="studentagenda">
		<input type="hidden" name="dateselect" value="' . $dateselect . '">
		<input type="hidden" name="department_id" value="' . $department_id . '">
		<input type="hidden" name="action" value="show">
		<input type="hidden" name="group_id" value="' . $selectclass . '">';
//	echo("<div>");
    if ($is_teacher)
    {
        // de verschillende klassen die tot een bepaalde department behoren ophalen....
        $selectclasses = campus::get_studentclasses($department_id);
        echo "<div style='width:98%; '>";
        foreach ($selectclasses as $id => $classarray)
        {
            echo ' <a href="' . $this->get_url() . '&department_id=' . $department_id . '&group_id=' . $id . '&page=studentagenda"  class="campus_tooltip_tasks" title="" grouplist="' . $id . '"  . ">' . $classarray['code'] . '</a>';
        }
        echo "</div>";
    }
    else
    {
        $query = "SELECT DISTINCT `user_user`.`id`, `lastname`, `firstname`
	            FROM `user_user`
	                INNER JOIN `campus_parent_rel_student`
	                   ON `user_user`.`id` = `campus_parent_rel_student`.`student_id`
	                INNER JOIN `group_group_rel_user`
	                   ON `user_user`.`id` = `group_group_rel_user`.`user_id`
			INNER JOIN `campus_department_rel_group`
				ON `group_group_rel_user`.`group_id`=`campus_department_rel_group`.`group_id` AND `department_id`=" . $department_id . " AND `type`=2
 			WHERE `campus_parent_rel_student`.`parent_id`=" . $_uid . "
				ORDER BY `lastname`,`firstname`";
        $result = mysql_query($query) or die(mysql_error());
        if (mysql_num_rows($result) >= 1)
        { // is parent....
            $is_parent = TRUE;
            echo "<div style='width:98%; '>";
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                echo " <a href=\"" . $this->get_url() . "&student_id=" . $rij['id'] . "&department_id=" . $department_id . "&group_id=" . $id . "&page=studentagenda\" title=\"" . get_lang("tooltipDisplay") . " " . $rij['lastname'] . ' ' . $rij['firstname'] . ".\">" . $rij['lastname'] . ' ' . $rij['firstname'] . "</a>";
            }
            echo "</div>";
        }
        else
        {
            $is_parent = FALSE;
        }
    }
    if (($selectclass == 0) && $is_teacher)
    {

        Display::normal_message(get_lang('msgStudentAgendaHint'), false);
    }
    else
    {
        if (($selectclass != 0) || ($student_id != 0))
        {
            echo "<center style=\"width:98%;\" ><span style=\" float:right; \">";
            echo "<a href=\"" . $this->get_url() . "&page=calender2pdf&select=" . (($is_teacher) ? $selectclass : 'student') . "&uid=" . $student_id . " \" target=\"_blank\" title=\"" . get_lang("tooltipCalender2Pdf") . "\">" . get_lang("txtCalender2Pdf") . "</a> | ";
            echo "<a href=\"" . $this->get_url() . "&page=studentagenda2pdf&dateselect=" . $dateselect . "&group_id=" . $selectclass . "&uid=" . $student_id . "\" target=\"_blank\" title=\"" . get_lang("tooltipAgenda2Pdf") . "\">" . get_lang("txtAgenda2Pdf") . "</a> | ";
            echo "<a href=\"" . $this->get_url() . "&page=studentagenda2pdf&dateselect=" . $dateselect . "&group_id=" . $selectclass . "&uid=" . $student_id . "&complete=1\" target=\"_blank\" title=\"" . get_lang("tooltipAgenda2Pdf") . "\">" . get_lang("txtAgenda2Pdf") . " volledig</a>";
            echo "</span><div align='left'>";
            if ($is_teacher)
            {
                echo "<b style=\"font-size: 18px;\"><i title=\"" . $groups[$selectclass]['name'] . "\">" . $groups[$selectclass]['code'] . "</i></b>";
            }
            else
            {
                foreach ($groups as $id => $value)
                {
                    echo "&nbsp;&nbsp;<b style=\"font-size: 18px;color:#4171b5;\" title=\"" . $groups[$id]['name'] . "\">" . $groups[$id]['code'] . "</b>";
                }
            }
            echo "</div></center>";
        }
        // ---------------------------------- KNOPPEN om te navigeren -----------------------------
        echo '  	<table align="center">
				<tr  class="campus_middle" style="font-size: 14px">
					<td >
						<a href="' . $this->get_url() . '&dateselect=' . $prevweek . '&group_id=' . $selectclass . '&student_id=' . $student_id . '&page=studentagenda&department_id=' . $department_id . '" TITLE="' . get_lang("tooltip1WeekBack") . '"><<<</a>
					</td>
	 				<td >
						<a href="' . $this->get_url() . '&dateselect=' . $prevday . '&group_id=' . $selectclass . '&student_id=' . $student_id . '&page=studentagenda&department_id=' . $department_id . '" TITLE="' . get_lang("tooltip1DayBack") . '"><</a>
					</td>';
        if ($agenda_layout == 1)
        {
            echo '  			<td style="width:30%;">
						<b title="' . get_lang("colheadAgendaTasks") . ': ' . strtoupper(DatetimeUtilities::format_locale_date('%A %d %B %Y', $dateselect)) . '">' . get_lang("colheadAgendaTasks") . '</b>
					</td>';
            echo '  			<td width="100%" colspan="2">
                                                <b style="float:right;">' . get_lang("colheadAgendaContent") . '</b>
                  				<b >' . strtoupper(DatetimeUtilities::format_locale_date('%A %d %B %Y', $dateselect)) . '</b>

                      			</td> ';
        }
        else
        {
            echo '  			<td width="50%" >
                                                <b>' . get_lang("colheadAgendaContent") . '</b>

                      			</td> ';
            echo '  			<td style="width:100%;"  colspan="2">
						<b style="float:right;" title="' . get_lang("colheadAgendaTasks") . ': ' . strtoupper(DatetimeUtilities::format_locale_date('%A %d %B %Y', $dateselect)) . '">' . get_lang("colheadAgendaTasks") . '</b>
                  				<b >' . strtoupper(DatetimeUtilities::format_locale_date('%A %d %B %Y', $dateselect)) . '</b>
					</td>';
        }
        echo '  			<td  >
						<a  href="' . $this->get_url() . '&dateselect=' . $nextday . '&group_id=' . $selectclass . '&student_id=' . $student_id . '&page=studentagenda&department_id=' . $department_id . '" TITLE="' . get_lang("tooltip1DayForward") . '">></a>
					</td>
					<td >
						<a  href="' . $this->get_url() . '&dateselect=' . $nextweek . '&group_id=' . $selectclass . '&student_id=' . $student_id . '&page=studentagenda&department_id=' . $department_id . '" TITLE="' . get_lang("tooltip1WeekForward") . '">>>></a>
					</td>
				</tr>';
        if ($calendercontent != "")
        {
            echo '<tr><td colspan=7 id="campus_calender_info">';
            echo get_lang("txtCalenderInfo");
            echo $calendercontent;
            echo '</td></tr>';
        }

        // ----------------------------- Het eigenlijke agenda formulier  ------------------------------
        foreach ($agenda as $row => $array)
        {

            $assignment_id = $array['assignment_id']; // : campus::get_POST_GET('assignment_select_'.$row);
            $college_id = intval($array['assignment_select'][$assignment_id]);
            $tab = campus::get_POST_GET("tab" . $row, 1);
            echo "\n<tr>"; //
            if ($agenda_layout == 1)
            {
                echo '<td class="td_campus_studentagenda" style="width:30%;" colspan=3><textarea READONLY>' . stripslashes($agenda[$row]['tasks']) . '</textarea></td>';
            }
            else
            {
                echo '<td class="td_campus_studentagenda" style="width:50%;" colspan=3><textarea READONLY>' . stripslashes($agenda[$row]['content']) . '</textarea></td>';
            }

            echo '<td class="campus_middle" style="width:10%;" align="left" valign="top">';
            echo '<b>' . $row . '</b>&nbsp; ';
            echo '<input type="hidden" name="agenda[' . $row . '][agenda_id]" value="' . $array['agenda_id'] . '">';
            echo '<input type="hidden" name="agenda[' . $row . '][assignment_id]" value="' . $array['assignment_id'] . '">';
            echo '<div>';
            $resource_array = campus::get_college2resource($college_id);
            foreach ($resource_array as $key => $value)
            {
                echo ' <i title="' . $value['comment'] . '">' . $value['code'] . '</i>';
            }
            echo '&nbsp;</div><div  align="center" >';
            foreach ($agenda[$row]['assignment_select'] as $assignmentid => $collegeid)
            { // Display all disciplines corresponding to the assignments for this period.. In 99% a theacher only has one assignment at the same time...
                $discipline = ($assignmentid < 0) ? array('-1' => array('name' => get_lang('txtGeneral'), 'code' => get_lang('txtGeneral'))) : campus::get_assignment2discipline($assignmentid);
                echo '<i title="' . $discipline[key($discipline)]['name'] . '">';
                if (($assignmentid == $assignment_id) || empty($agenda[$row]['assignment_id']))
                {
                    $assignment_id = $agenda[$row]['assignment_id'] = $assignmentid;
                    echo $discipline[key($discipline)]['code'];
                }
                else
                {
                    echo '<a class="campus_tooltip_info2" title=""  href="#"  onclick="javascript:agendaform.submit();" onmousedown="javascript:document.agendaform[\'agenda[' . $row . '][assignment_id]\'].value=\'' . $assignmentid . '\';document.agendaform[\'agenda[' . $row . '][agenda_id]\'].value=\'\';" >' . $discipline[key($discipline)]['code'] . '</a>';
                }
                echo '</i> ';
            }
            echo '</div><div align="right">';
            if (empty($agenda[$row]['tab']))
            {
                $teachers = campus::get_assignment2teacher($assignment_id);
                if (!empty($teachers))
                {
                    $teacherlist = "";
                    foreach ($teachers as $teacherid => $teacherinfo)
                    { //only on tab????
                        $teacherlist.=' <i title="' . $teacherinfo['name'] . '.">' . $teacherinfo['official_code'] . '</i>';
                    }
                    echo substr($teacherlist, 1);
                }
            }
            else
            {


                foreach ($agenda[$row]['tab'] as $tab => $id)
                { // als er voor een bepaald vak meerdere lesinhouden zijn ingegeven... de links naar de verschillende lesinhouden weergeven.
                    echo '<a class="campus_tooltip_info" title="" agenda_id="' . $id . '" href="#" ' . (($id != $agenda[$row]['agenda_id']) ? ' onclick="javascript:agendaform.submit();" onmousedown="javascript:document.agendaform[\'agenda[' . $row . '][agenda_id]\'].value=\'' . $id . '\';" ' : ' ID="campus_agenda_info_current" ') . ' >';
                    echo campus::get_agenda2teacherlist($id);
                    echo '</a> ';
                }
            }
            echo '</div>';
            echo '</td>';
            if ($agenda_layout == 1)
            {
                echo '<td class="td_campus_studentagenda" style="width:50%;" colspan=3><textarea READONLY>' . stripslashes($agenda[$row]['content']) . '</textarea></td>';
            }
            else
            {
                echo '<td class="td_campus_studentagenda" style="width:30%;" colspan=3><textarea READONLY>' . stripslashes($agenda[$row]['tasks']) . '</textarea></td>';
            }


            echo '</tr>';
        }

        echo '</table>';
    }
    echo '</form></div>';


    echo '<br clear="all">';
}
?>