<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Display;
use common\libraries\Theme;
use common\libraries\DatetimeUtilities;
use common\libraries\PlatformSetting;
use common\libraries\ResourceManager;
use common\libraries\Path;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($departmentStruc) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoDepartmentMember"), false);
}
else
{//only teachers and platform administrator are allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $dateselect = intval(campus::get_POST_GET("dateselect", mktime(0, 0, 0, date('m', time()), date('d', time()), date('Y', time()))));
    if ((strftime('%w', $dateselect) == 6) || (strftime('%w', $dateselect) == 0))
    {
        $dateselect = strtotime('next Monday', $dateselect);
    }

    $agenda = campus::get_POST_GET("agenda", array());
    $action = campus::get_POST_GET("action", "show");
    $agendainfo = campus::get_POST_GET("agendainfo");
    $agenda2student = campus::get_POST_GET("agenda2student");
    $agendaselect = intval(campus::get_POST_GET("agendaselect"));
    /* ==============================================================================
      Instellingen ophalen voor de geselecteerde dag department etc......
      ============================================================================== */
    // The roster structure determins how many rows a day there are...
    // $agenda = campus::get_rosterarray($department_id);
    // het uurrooster bepalen wat bij de datum en de department hoort ...
    $activeroster = campus::get_activeroster($department_id, $dateselect);
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/javascript/campus_agenda_ajax.js');
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/css/tooltip.css');
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_PLUGIN_PATH) . 'jquery/jquery.tooltip.min.js');
    if ((intval($activeroster['roster_id']) > 0))
    {
        /* ==============================================================================
          write 2 agenda depending of action......
          ============================================================================== */
        switch ($action)
        {
            case "2e_page" : //
            case "write" : //
                {
                    foreach ($agenda as $row => $array)
                    {
                        $assignment_id = intval($array['assignment_id']);
                        //$agenda[$row] = $agenda[$row][$assignment_id];
                        $agenda_id = intval($array['agenda_id']);
                        if ((trim($array['content']) != '') || (trim($array['tasks']) != '') || (trim($array['comment']) != ''))
                        { // als er tekst is ingegeven in de lesnhoud of bij de taken wordt er een agenda record toegevoegd.
                            if ($agenda_id == 0)
                            { // als er geen agenda_id is meegegeven wordt er een nieuwe record toegevoegd.
                                $query = 'INSERT INTO `campus_agenda` SET
 								`date` = ' . $array['date'] . ',
 								`period_id` = ' . $array['period_id'] . ',
 								`content` = "' . addslashes($array['content']) . '",
 								`tasks` = "' . addslashes($array['tasks']) . '",
 								`comment` = "' . addslashes($array['comment']) . '", ';
                                if ($assignment_id > 0)
                                {
                                    $query.='`assignment_id` = ' . $assignment_id;
                                }
                                else
                                {
                                    $query.='`user_id` = ' . $_uid;
                                }
                                $result = mysql_query($query) or die(mysql_error());
                                $agenda_id = mysql_insert_id();
                                foreach ($array['groups'] as $key => $group_id)
                                {
                                    $query2 = "INSERT INTO `campus_agenda_rel_group` SET
                                                    `agenda_id` =" . $agenda_id . ",
                                                    `group_id` =" . $group_id . " ";
                                    $result2 = mysql_query($query2);
                                }
                                foreach ($array['students'] as $key => $user_id)
                                {
                                    $query2 = "INSERT INTO `campus_agenda_rel_student` SET
                                                    `agenda_id` =" . $agenda_id . ",
                                                    `user_id` =" . $user_id . " ";
                                    $result2 = mysql_query($query2);
                                }
                            }
                            else
                            {  // if agenda id exists record need to be updated
                                $query = 'UPDATE `campus_agenda` SET
                        			`date` = ' . $array['date'] . ',
 						`period_id` = ' . $array['period_id'] . ',
 						`content` = "' . addslashes($agenda[$row]['content']) . '",
 						`tasks` = "' . addslashes($agenda[$row]['tasks']) . '",
 						`comment` = "' . addslashes($agenda[$row]['comment']) . '", ';
                                if ($assignment_id > 0)
                                {
                                    $query.='`assignment_id` = ' . $assignment_id;
                                }
                                else
                                {
                                    $query.='`user_id` = ' . $_uid;
                                }
                                $query.=' WHERE `id`=' . $agenda_id;
                                $result = mysql_query($query) or die(mysql_error());
                                $check_groups = campus::get_agenda2group($agenda_id);
                                $classdeleted = FALSE;
                                // delete existing groups from agenda item
                                $query2 = "DELETE FROM `campus_agenda_rel_group` WHERE `agenda_id` =" . $agenda_id . " ";
                                $result2 = mysql_query($query2);
                                foreach ($array['groups'] as $key => $group_id)
                                {
                                    if (!array_key_exists($group_id, $check_groups))
                                    {
                                        $classdeleted = TRUE;
                                    }
                                    // nieuwe links toe te voegen.....
                                    $query2 = "INSERT INTO `campus_agenda_rel_group` SET
                                                    `agenda_id` =" . $agenda_id . ",
                                                    `group_id` =" . $group_id . " ";
                                    $result2 = mysql_query($query2);
                                }
                                // delete existing students from agenda item
                                $query2 = "DELETE FROM `campus_agenda_rel_student` WHERE `agenda_id` =" . $agenda_id . " ";
                                $result2 = mysql_query($query2);
                                if (!($classdeleted))
                                {

                                    foreach ($array['students'] as $key => $user_id)
                                    {
                                        // nieuwe links toe te voegen.....
                                        if ($user_id <> "")
                                        {
                                            $query2 = "INSERT INTO `campus_agenda_rel_student` SET `agenda_id` =" . $agenda_id . ", `user_id` =" . $user_id . " ";
                                            $result2 = mysql_query($query2);
                                        }
                                    }
                                }
                            }
                        }
                        elseif ($agenda_id > 0)
                        { // delete agenda item when content is erased
                            $query = "DELETE FROM `campus_agenda_rel_student` WHERE `agenda_id` =" . $agenda_id;
                            $result = mysql_query($query);
                            $query = "DELETE FROM `campus_agenda_rel_group` WHERE `agenda_id` =" . $agenda_id;
                            $result = mysql_query($query);
                            $query = "DELETE FROM `campus_agenda` WHERE `id` =" . $agenda_id;
                            $result = mysql_query($query);
                        }
                    }
                    $action = ($action != "2e_page") ? "show" : $action;
                }
                break;
            case "delete" :
                {
                    // bestaande links met de klassen verwijderen om ...
                    $query = "DELETE FROM `campus_agenda_rel_student` WHERE `agenda_id` =" . intval(campus::get_POST_GET('delete_id'));
                    $result = mysql_query($query);
                    $query = "DELETE FROM `campus_agenda_rel_group` WHERE `agenda_id` =" . intval(campus::get_POST_GET('delete_id'));
                    $result = mysql_query($query);
                    $query = "DELETE FROM `campus_agenda` WHERE `id` =" . intval(campus::get_POST_GET('delete_id'));
                    $result = mysql_query($query);
                    $action = "show";
                }
                break;
        }
//=============================================================================
// Determine assignment agendas for selection...
//=============================================================================
// Discipline Agendas from curriculum ...
        $assignment_agenda_list = array();
        $query = "SELECT `assignment_id`, `roster_id`, `discipline_id`
				FROM `campus_assignment`
					INNER JOIN `campus_assignment_rel_teacher`
						ON `campus_assignment_rel_teacher`.`assignment_id`=`campus_assignment`.`id`
                                        WHERE `user_id`=" . $_uid . " AND `curriculum_id`=" . $activeroster['curriculum_id'];
        $result = mysql_query($query);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $groups_array = campus::get_assignment2group($rij['assignment_id']);
            $classcombi = "";
            $grouplist = "";
            foreach ($groups_array as $id => $value)
            {
                $grouplist.=$value['code'] . " ";
            }
            $classcombi = substr($classcombi, 0, -1);
            $assignment_agenda_list[$rij['assignment_id']]['discipline_id'] = $rij['discipline_id'];
            $assignment_agenda_list[$rij['assignment_id']]['groups'] = $groups_array;
            $assignment_agenda_list[$rij['assignment_id']]['grouplist'] = (trim(substr($grouplist, 0, -1)) == '') ? get_lang("txtPersonalAgenda") : substr($grouplist, 0, -1);
        }


        /* ==============================================================================
          Read agenda depending of action......
          ============================================================================== */
        switch ($action)
        {
            case "2e_page":
                {
                    foreach ($agenda as $row => $array)
                    {
                        $agenda[$row]['agenda_id'] = '';
                        $agenda[$row]['groups'] = '';
                        $agenda[$row]['students'] = '';
                        $agenda[$row]['content'] = '';
                        $agenda[$row]['comment'] = '';
                        $agenda[$row]['tasks'] = '';
                    }
                }
                break;
            case "show":
                {
                    // Clear agenda data
                    $calender = array();
                    $agenda = array();
                }
            case "refresh":
                {
                    $t = 0;
                    $date = $dateselect;
                    $prevday = strtotime('-1 day', $date);
                    $prevweek = strtotime('-1 week', $date);
                    $startfrombegin = FALSE;
                    $agendacontent = "";
                    do
                    { // this loop is excuted only once when agenda-by-day view is active
                        $temp_agenda = array();
                        $t++; // loop counter (loop may be executed maximum 56 times to fill 8 rows. (1 teaching period a week = (7*8)
                        //
                        // ===================================================================================
                        //   Read calendar info ...`
                        // ===================================================================================
                        $query = "SELECT `id`, `date`, `content`, `public`, `vacation`
								FROM `campus_calender`
							WHERE `campus_calender`.`date`=" . $date . " AND `campus_calender`.`department_id`=" . $department_id . " ";
                        $result = mysql_query($query);
                        $calendercontent = "";
                        $vrijaf = false;
                        while ($rij = mysql_fetch_array($result))
                        {
                            if ($rij['vacation'] == 1)
                            {
                                $agendacontent[$rij['date']] = "\n\n\t\t" . get_lang("txtVacationDay") . ": " . $rij['content'];
                                $vrijaf = true;
                            }
                            if ($rij['content'] != "")
                            {
                                $calendercontent.=$rij['content'];
                            }
                        }
                        // ===================================================================================
                        //   Read roster ...`
                        // ===================================================================================
                        $college_id = 0;
                        $assignment_id = 0;
                        $duration = 0;
                        if (($agendaselect == 0))
                        {
                            $rooster = campus::get_rosterarray($department_id);

                            foreach ($rooster as $display_order => $day)
                            {
                                if ($day[strftime('%w', $date)]['period_id'] != '')
                                {
                                    $temp_agenda[$date . ',' . $display_order]['period_id'] = $day[strftime('%w', $date)]['period_id'];
                                    $temp_agenda[$date . ',' . $display_order]['period_code'] = $day[strftime('%w', $date)]['code'];
                                    $temp_agenda[$date . ',' . $display_order]['display_order'] = $display_order;
                                    $temp_agenda[$date . ',' . $display_order]['date'] = $date;
                                }
                            }
                        }
                        $query = 'SELECT `campus_college`.`assignment_id`,`campus_college`.`id` as college_id, `weekday`,`code`, `display_order`,`duration`, `campus_period`.`id` as `period_id`
                                        FROM `campus_period`
                                            INNER JOIN `campus_college`
                                                ON `campus_period`.`id`=`campus_college`.`period_id`  AND `campus_college`.`roster_id`=' . $activeroster['roster_id'] . '
                                            INNER JOIN `campus_assignment_rel_teacher`
                                                ON `campus_assignment_rel_teacher`.`assignment_id`=`campus_college`.`assignment_id` AND `user_id`=' . $_uid . ' AND `campus_assignment_rel_teacher`.`roster_id`=' . $activeroster['roster_id'] . '
                                           WHERE `campus_period`.`department_id`=' . $department_id . ' AND `weekday`=' . strftime('%w', $date) . ' ORDER BY `display_order`';
                        $result = mysql_query($query);
                        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                        {
                            while ($rij['duration'] > 0)
                            {
                                if (( ($agendaselect == 0) || ($agendaselect == $rij['assignment_id'])))
                                {
                                    if (($agendaselect > 0))
                                    {
                                        $temp_agenda[$date . ',' . $rij['display_order']]['period_id'] = $rij['period_id'];
                                        $temp_agenda[$date . ',' . $rij['display_order']]['period_code'] = $rij['code'];
                                        $temp_agenda[$date . ',' . $rij['display_order']]['display_order'] = $rij['display_order'];
                                        $temp_agenda[$date . ',' . $rij['display_order']]['date'] = $date;
                                    }
                                    $temp_agenda[$date . ',' . $rij['display_order']]['assignment_select'][$rij['assignment_id']] = $rij['college_id']; //$assignment_id;
                                    if (($rij['assignment_id'] == $agenda[$date . ',' . $rij['display_order']]['assignment_id']) || ($agendaselect == $rij['assignment_id']) || (empty($agenda[$date . ',' . $rij['display_order']]['assignment_id']) && ($agendaselect == 0)))
                                    {
                                        $temp_agenda[$date . ',' . $rij['display_order']]['assignment_id'] = $rij['assignment_id'];
                                    }
                                    $temp_agenda[$date . ',' . $rij['display_order']]['agenda_id'] = '';
                                    $temp_agenda[$date . ',' . $rij['display_order']]['content'] = '';
                                    $temp_agenda[$date . ',' . $rij['display_order']]['tasks'] = '';
                                    $temp_agenda[$date . ',' . $rij['display_order']]['comment'] = '';
                                }
                                $rij['display_order']++;
                                $rij['duration']--;
                            }
                        }

                        // ===================================================================================
                        //   Read agenda
                        // ===================================================================================
                        if ($action != '2e_page')
                        {
                            // when discipline agenda filter on discipline
                            $assignmentfilter = ( ($agendaselect > 0) ? ' AND `campus_agenda`.`assignment_id`=' . $agendaselect : ' AND (`campus_assignment_rel_teacher`.`user_id`=' . $_uid . ' OR `campus_agenda`.`user_id`= ' . $_uid . ')');
                            $query = 'SELECT `campus_agenda`.`id` as agenda_id, `display_order`, `campus_agenda`.`assignment_id`, `date`, `period_id`,`code`, `content`, `tasks`, `comment`
                                    FROM `campus_agenda`
                                        INNER JOIN `campus_period`
                                            ON  `campus_period`.`id`= `campus_agenda`.`period_id` AND `campus_period`.`department_id`=' . $department_id . '
                                        LEFT JOIN `campus_assignment_rel_teacher`
                                            ON  `campus_agenda`.`assignment_id`= `campus_assignment_rel_teacher`.`assignment_id` AND `roster_id`= ' . $activeroster['roster_id'] . '
                                    WHERE  `date`=' . $date . ' ' . $assignmentfilter . ' ORDER BY `display_order` ';
                            $result = mysql_query($query);
                            $prev_row = 0;
                            $tabs = 1;
                            $recordfound = FALSE;
                            while ($rij = mysql_fetch_array($result))
                            {
                                $assignment_id = ($rij['assignment_id'] == 0) ? -1 : $rij['assignment_id'];
                                $temp_agenda[$date . ',' . $rij['display_order']]['assignment_select'][$assignment_id] = 0; //$assignment_id;

                                if (($rij['agenda_id'] == $agenda[$date . ',' . $rij['display_order']]['agenda_id']) || ($assignment_id == $agenda[$date . ',' . $rij['display_order']]['assignment_id']) || (empty($agenda[$date . ',' . $rij['display_order']]['assignment_id']) && (empty($temp_agenda[$date . ',' . $rij['display_order']]['agenda_id']) || ($rij['agenda_id'] == $temp_agenda[$date . ',' . $rij['display_order']]['agenda_id']))))
                                {
                                    $temp_agenda[$date . ',' . $rij['display_order']]['assignment_id'] = $assignment_id;
                                }

                                if ($temp_agenda[$date . ',' . $rij['display_order']]['assignment_id'] == $assignment_id)
                                {
                                    if (($rij['display_order'] == $prev_row))//&&($agendaselect==0))
                                    {
                                        $tabs++;
                                    }
                                    else
                                    {
                                        $tabs = 1;
                                    }
                                    $temp_agenda[$date . ',' . $rij['display_order']]['tab'][$tabs] = $rij['agenda_id'];
                                    if (empty($temp_agenda[$date . ',' . $rij['display_order']]['agenda_id']) || ($rij['agenda_id'] == $agenda[$date . ',' . $rij['display_order']]['agenda_id']) || ( ($agenda[$date . ',' . $rij['display_order']]['agenda_id'] == '') && ($agenda[$date . ',' . $rij['display_order']]['assignment_id'] == $assignment_id)))
                                    {
                                        $temp_agenda[$date . ',' . $rij['display_order']]['period_id'] = $rij['period_id'];
                                        $temp_agenda[$date . ',' . $rij['display_order']]['period_code'] = $rij['code'];
                                        $temp_agenda[$date . ',' . $rij['display_order']]['display_order'] = $rij['display_order'];
                                        $temp_agenda[$date . ',' . $rij['display_order']]['date'] = $date;
                                        $temp_agenda[$date . ',' . $rij['display_order']]['agenda_id'] = $rij['agenda_id'];
                                        $temp_agenda[$date . ',' . $rij['display_order']]['content'] = $rij['content'];
                                        $temp_agenda[$date . ',' . $rij['display_order']]['tasks'] = $rij['tasks'];
                                        $temp_agenda[$date . ',' . $rij['display_order']]['comment'] = $rij['comment'];
                                    }
                                }
                                $prev_row = $rij['display_order'];
                            }
                        }
                        // re arange agenda content...
                        if ($agendaselect > 0)
                        {
                            foreach ($temp_agenda as $id => $array)
                            {
                                $agenda[$id] = $array; //temp_agenda[$id];
                            }
                        }
                        else
                        { // no need to rearrange just copy the content.*/
                            $agenda = $temp_agenda;
                        }

                        $date = strtotime('+1 day', $date);
                        $activeroster = campus::get_activeroster($department_id, $date);
                    }
                    while (((count($agenda) <= 8) && ($agendaselect > 0)) && ($t < 56)); // loop counter (loop may be executed maximum 56 times to fill 8 rows. (1 teaching period a week = (7*8)
                    //*****NEXT DAY BEPALEN BIJ VAK AGENDA!!!!
                    if ($agendaselect == 0)
                    {
                        $nextday = $date;
                    }
                    else
                    {
                        $t = 0;
                        $firstelement = reset($agenda);
                        foreach ($agenda as $id => $array)
                        {
                            $t++;
                            if ($t >= 8)
                            {
                                $nextday = empty($array['date']) ? $date : (($array['date'] == $firstelement) ? $date : $array['date']);
                            }
                        }
                    }
                    //$nextday = ($agendaselect == 0) ? $date : (empty($agenda[8]['date'])) ? $date : (($agenda[1]['date'] == $agenda[8]['date']) ? $date : $agenda[8]['date']);
                    $nextweek = strtotime('+1 week', strtotime('-1 day', $date));
                    if ($action != '2e_page')
                    {
                        $action = 'show';
                    }
                }
        }
        // ===================================================================================
        //   Display agenda ....
        // ===================================================================================
        if (!empty($message))
        {
            Display::normal_message($message);
        }
        echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/javascript/hide_show.js');

        echo '<div id="campus_agenda" >';
        echo '<form method="post" action="' . $this->get_url() . '" name="agendaform" >
			<input type="hidden" name="dateselect" value="' . $dateselect . '">
			<input type="hidden" name="page" value="teacheragenda">
			<input type="hidden" name="action" value="' . $action . '">
			<input type="hidden" name="agendainfo" value="0">
			<input type="hidden" name="agenda2student" value="0">';
        $disciplinename = campus::get_assignment2discipline($agendaselect);
        $disciplinename = $disciplinename[$agendaselect]['name'];
        if ($action == "show")
        { // display navigation and modify-buttons in 'show' modus...
            if (strftime('%w', $nextday) == 6)
            {
                $nextday = strtotime('next Monday', $dateselect);
            } //de volgende dag na vrijdag is maandag niet zaterdag...
            if (strftime('%w', $prevday) == 0)
            {
                $prevday = strtotime('last Friday', $dateselect);
            } // de dag voor maandag is vrijdag niet zondag...
            echo "<center style=\"width:98%;\" ><span  style=\"float:right;\">";
            echo "&nbsp<a href=\"#\" onclick=\"javascript:agendaform.submit();\" onmousedown=\"javascript:document.agendaform.action.value='update';\" title=\"" . get_lang("tooltipEditAgenda") . "\">" . get_lang("txtChangeAgenda") . "</a>&nbsp|";
            echo "&nbsp<a href=\"" . $this->get_url() . "&page=calender2pdf&select=teacher \" target=\"_blank\" title=\"" . get_lang("tooltipCalender2Pdf") . "\">" . get_lang("txtCalender2Pdf") . "</a>&nbsp|";
            if ($agendaselect > 0)
            {
                echo "&nbsp<a href=\"" . $this->get_url() . "&page=disciplineagenda2csv&agendaselect=" . $agendaselect . "\" target=\"_blank\" title=\"" . get_lang("tooltipAgenda2Csv") . "\">" . get_lang("txtAgenda2Csv") . "</a>&nbsp|";
                echo "&nbsp<a href=\"" . $this->get_url() . "&page=disciplineagenda2pdf&agendaselect=" . $agendaselect . "\" target=\"_blank\" title=\"" . get_lang("tooltipAgenda2Pdf") . "\">" . get_lang("txtAgenda2Pdf") . "</a>&nbsp";
            }
            else
            {
                echo "&nbsp<a href=\"" . $this->get_url() . "&page=teacheragenda2pdf&dateselect=" . $dateselect . "\" target=\"_blank\" title=\"" . get_lang("tooltipAgenda2Pdf") . "\">" . get_lang("txtAgenda2Pdf") . "</a>&nbsp";
            }
            echo "</span><div align='left'>";
            echo " <a href=\"" . $this->get_url() . "&select=&page=studentagenda\" title=\"" . get_lang("tooltip2StudentAgenda") . "\">" . get_lang("txt2StudentAgenda") . "</a>";
            echo "&nbsp;|&nbsp;<a href=\"" . $this->get_url() . "&page=agendaarchive\" title='" . get_lang("tooltipAgendaArchive") . "'>" . get_lang("txtAgendaArchive") . "</a>";
            echo "</div></center>";
        }
        else
        { // display navigation and buttons in other modus..
            echo "<span  style=\"float:right;\">";
            echo "&nbsp;<a href=\"#\" onclick=\"javascript:agendaform.submit();\" onmousedown=\"javascript:document.agendaform.action.value='write';\" title=\"" . get_lang("tooltipSaveChanges") . "\">" . get_lang("txtSaveChanges") . "</a>&nbsp;|";
            echo "&nbsp;<a href=\"#\" onclick=\"javascript:agendaform.submit();\" onmousedown=\"javascript:document.agendaform.action.value='2e_page';\" title=\"" . get_lang("tooltipAgendaPage2") . "\">" . get_lang("txtAgendaPage2") . "</a>&nbsp;|";
            echo "&nbsp;<a href=\"" . $this->get_url() . "&page=teacheragenda&dateselect=" . $dateselect . "&agendaselect=" . $agendaselect . "\" title=\"" . get_lang("tooltipCancel2Agenda") . "\">" . get_lang("txtCancel") . "</a>";
            echo "</span>";
            echo ($agendaselect == 0) ? "&nbsp;<a href=\"#\" onclick=\"javascript:agendaform.submit();\" onmousedown=\"javascript:document.agendaform.action.value='selectplus';\" title=\"" . get_lang("tooltipAgendaExtended") . "\">" . get_lang("txtAgendaExtended") . "</a>&nbsp;" : "<br>";
        }
// ---------------------------------- KNOPPEN om te navigeren en BEWERKEN -----------------------------


        if ($agenda2student > 0)
        { // display 'select students to periode' form
            $query = "SELECT `user_user`.`id`, `display_order`, `lastname`, `firstname`, `group_group`.`code`
                            FROM `user_user`
                                INNER JOIN `group_group_rel_user`
                                    ON `user_user`.`id` = `group_group_rel_user`.`user_id`
                                INNER JOIN `group_group`
                                    ON `group_group`.`id` = `group_group_rel_user`.`group_id` WHERE ";
            $filter = "";
            // meervoudige selectie doormiddel van array.
            foreach ($agenda[$agenda2student]['groups'] as $id)
            {
                $filter.="`group_group`.`id` = " . $id . " OR ";
            }
            $filter = substr($filter, 0, -3) . " ";
            $sql = $query . $filter . " ORDER BY `group_group`.`code`, `display_order`, `lastname`, `firstname`";
            $result = mysql_query($sql) or die(mysql_error());
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $student_select[$rij['id']]['lastname'] = $rij['lastname'];
                $student_select[$rij['id']]['firstname'] = $rij['firstname'];
            }
            echo "<div id=\"overlay\" ></div>";
            echo "<div style='position: absolute;left: 450px;top: 200px;border: solid 2px #FFFF33;background-color:#FFFFAA;padding: 10px;width:200px; height: 170px; z-index:1001;'>";
            echo "<b>" . get_lang("txtSelectStudent2Agenda") . $agenda[$agenda2student]['period_code'] . " (" . DatetimeUtilities::format_locale_date('%A %d/%m', $agenda[$agenda2student]['date']) . ")</b><br>";
            echo '<select name="agenda[' . $agenda2student . '][students][]"  style="width: 180px;" multiple="multiple" size="8" >';
            echo "<option value=\"\">" . get_lang("txtNoStudentSelected") . "</option> ";
            foreach ($agenda[$agenda2student]['students'] as $student_id)
            {
                if (array_key_exists($student_id, $student_select))
                {
                    echo "<option value=\"" . $student_id . "\" SELECTED>" . $student_select[$student_id]['firstname'] . " " . $student_select[$student_id]['lastname'] . "</option> ";
                }
            }
            foreach ($student_select as $key => $value)
            {
                if (!in_array($key, ($agenda[$agenda2student]['students'])))
                {
                    echo '<option value="' . $key . '" >' . $student_select[$key]['firstname'] . ' ' . $student_select[$key]['lastname'] . '</option> ';
                }
            }
            echo "</select>";
            echo "<br><input type=\"submit\" name=\"submitmessage\" value=\"" . get_lang("buttonlabelOK") . "\" onmousedown=\"javascript:document.agendaform.action.value='update';\" >";
            echo "</div>";
        }



        echo '<table align="center" style="width:100%">';
        echo '<tr class="campus_middle" style="font-size: 14px"><td>';
        echo  (((!$startfrombegin || ($agendaselect == 0)) && ($action == "show")) ? '<a class="campus_middle" href="' . $this->get_url() . '&page=teacheragenda&dateselect=' . $prevweek . '&agendaselect=' . $agendaselect . '" title="' . DatetimeUtilities::format_locale_date('%A %d %B %Y', $prevweek) . '"><<<</a>' : '') . '&nbsp;&nbsp;';
        echo  ((($agendaselect == 0) && ($action == "show")) ? '<a href="' . $this->get_url() . '&page=teacheragenda&dateselect=' . $prevday . '&agendaselect=' . $agendaselect . '" title="' . DatetimeUtilities::format_locale_date('%A %d %B %Y', $prevday) . '"><</a>' : '') . '&nbsp;&nbsp;';
        echo '</td> ';
        echo '<td  width="100%" colspan="4">';
        echo '<input type="hidden" name="agendaselect" value="' . $agendaselect . '">';
        $selected = strtoupper(DatetimeUtilities::format_locale_date('%A %d %B %Y', $dateselect));
        $selectbox = '<ul class="campus_select_agenda" id="IdSlctAgnda" style="position:absolute; left:0px; top: 0px; display:none;">';
        $selectbox.='<li ' . (($agendaselect == 0) ? 'class="campus_light"' : '') . '><a href="#" onclick="javascript:agendaform.submit();" title="' . get_lang("tooltipSelectAgenda") . '" onmousedown="javascript:document.agendaform.agendaselect.value=\'\'" >' . strtoupper(DatetimeUtilities::format_locale_date('%A %d %B %Y', $dateselect)) . '</a></li>';

        foreach ($assignment_agenda_list as $assignment_id => $array)
        {
            $discipline_array = campus::get_discipline_info($array['discipline_id']);
            if ($assignment_id == $agendaselect)
            {
                $selectbox.='<li class="campus_light">';
                $selected = $discipline_array[$array['discipline_id']]['name'] . " " . $array['grouplist'];
            }
            else
            {
                $selectbox.="<li>";
            }
            $selectbox.="<a href='#' style='white-space: nowrap;' onclick='javascript:agendaform.submit();' title='" . get_lang("tooltipSelectAgenda") . "' onmousedown=\"javascript:document.agendaform.agendaselect.value='" . $assignment_id . "'\" >" . $discipline_array[$array['discipline_id']]['name'] . " " . $array['grouplist'] . "</a></li>";
        }
        $selectbox.='</ul>';
        echo ((($agendaselect == 0) && ($action == "show")) ? '<a style="float:right;" href="' . $this->get_url() . '&page=teacheragenda&dateselect=' . $nextweek . '&agendaselect=' . $agendaselect . '" title="' . DatetimeUtilities::format_locale_date('%A %d %B %Y', $nextweek) . '">&nbsp;&nbsp;>>></a>' : '');
        echo (($action == "show") ? '<a style="float:right;" href="' . $this->get_url() . '&page=teacheragenda&dateselect=' . $nextday . '&agendaselect=' . $agendaselect . '" title="' . DatetimeUtilities::format_locale_date('%A %d %B %Y', $nextday) . '">&nbsp;&nbsp;></a>' : '') ;
        echo "<span style='position:relative;display:block;width:50%;z-index:300;' onmouseover=\"javascript: showID('IdSlctAgnda');\" onmouseout=\"javascript: hideID('IdSlctAgnda');\"><i style='float:right; font-size:10px;'>" . get_lang("tooltipSelectAgenda") . "</i><b title=\"" . get_lang("tooltipSelectAgenda") . "\">" . $selected . "</b>";
        if ($action == "show")
        {
            echo $selectbox;
        }
        echo '</span>';

        echo '</td> ';
        echo '</tr>';

        if (($calendercontent != "") && ($agendaselect == 0))
        { // display calender info when not discipline agenda
            echo "<tr><td colspan=7 id='campus_calender_info'>";
            echo get_lang("txtCalenderInfo");
            echo $calendercontent;
            echo "</td></tr>";
        }


        echo '<tr class="campus_middle" style="font-size: 14px">';
        echo '<td> ';
        echo '<b title="' . get_lang("colheadAgendaTasks") . ': ' . strtoupper(DatetimeUtilities::format_locale_date('%A %d %B %Y', $dateselect)) . '">' . get_lang("colheadAgendaTasks") . ((DatetimeUtilities::format_locale_date('%Y-%m-%d', $dateselect) == DatetimeUtilities::format_locale_date('%Y-%m-%d', time())) ? ' ' . get_lang("colheadToday") : "") . '</b>';
        echo '</td> ';
        echo '<td> ';
        echo '</td> ';
        echo '<td> ';
        echo '<b >' . get_lang("colheadAgendaContent") . '</b>';
        echo '</td> ';
        echo '<td> ';
        echo '<b >' . get_lang("colheadAgendaComment") . '</b>';
        echo '</td> ';
        echo '<td> ';
        echo '</td> ';
        echo '</tr>';

        ksort($agenda);
        // The agenda form .....
        $t = 0;

        foreach ($agenda as $row => $array)
        {
            if ($t++ > 7)
                break;
            $assignment_id = $array['assignment_id']; // : campus::get_POST_GET('assignment_select_'.$row);
            $college_id = intval($array['assignment_select'][$assignment_id]);
            if (($agendaselect > 0) && ($row == (count($agenda) + 1)))
                break;
            // $tab = campus::get_POST_GET("tab" . $row, 1);
            echo '<tr>'; //
            if (($action == 'show') || (($assignment_id == 0) && ($action != 'selectplus')))
            {
                $style = 'td_campus_agenda';
                $readonly = TRUE;
            }
            else
            {
                $style = 'td_campus_agenda_edit';
                $readonly = FALSE;
            }

            echo '<td class="' . $style . '" style="width:20%;" ><textarea name="agenda[' . $row . '][tasks]" ' . (($readonly) ? 'READONLY' : '') . '>' . stripslashes($agenda[$row]['tasks']) . '</textarea></td>';

            echo '<td class="campus_middle" style="width:10%;" align="left" valign="top">';
            if (($action == "show") || (!$readonly))
            {
                echo '<b>' . (($agendaselect == 0) ? $array['display_order'] : $array['period_code']) . '</b>&nbsp; ' . ((($agendaselect == 0) || empty($array['date'])) ? '' : '<i title="' . DatetimeUtilities::format_locale_date('%A %d %B %Y', $array['date']) . '">' . DatetimeUtilities::format_locale_date('%e/%m/%Y', $array['date']) . '</i>');
            }
            echo '<input type="hidden" name="agenda[' . $row . '][agenda_id]" value="' . $array['agenda_id'] . '">';
            echo '<input type="hidden" name="agenda[' . $row . '][date]" value="' . (empty($array['date']) ? $dateselect : $array['date']) . '">';
            echo '<input type="hidden" name="agenda[' . $row . '][period_id]" value="' . (empty($array['period_id']) ? $row : $array['period_id']) . '">';
            echo '<input type="hidden" name="agenda[' . $row . '][period_code]" value="' . $array['period_code'] . '">';
        //    if ($agendainfo != $row)
        //    {
        //        echo '<input type="hidden" name="agenda[' . $row . '][comment]" value="' . $array['comment'] . '">';
        //    }
            if (($action == "show") || ($action == "comment") || ($action == "student"))//|| ($disciplineagenda))
            {
                echo '<div >';
                foreach ($agenda[$row]['assignment_select'] as $assignmentid => $collegeid)
                { // Display all disciplines corresponding to the assignments for this period.. In 99% a theacher only has one assignment at the same time...
                    $discipline = ($assignmentid < 0) ? array('-1' => array('name' => get_lang('txtGeneral'), 'code' => get_lang('txtGeneral'))) : campus::get_assignment2discipline($assignmentid);
                    echo '<i title="' . $discipline[key($discipline)]['name'] . '">';
                    if (($assignmentid == $assignment_id) || empty($array['assignment_id']))
                    {
                        $assignment_id = $array['assignment_id'] = $assignmentid;
                        echo $discipline[key($discipline)]['code'];
                    }
                    else
                    {
                        echo '<a class="campus_tooltip_info2" title=""  href="#"  onclick="javascript:agendaform.submit();" onmousedown="javascript:document.agendaform[\'action\'].value=\'refresh\';document.agendaform[\'agenda[' . $row . '][assignment_id]\'].value=\'' . $assignmentid . '\';document.agendaform[\'agenda[' . $row . '][agenda_id]\'].value=\'\';" >' . $discipline[key($discipline)]['code'] . '</a>';
                    }
                    echo '</i> ';
                }
                echo '<input type="hidden" name="agenda[' . $row . '][assignment_id]" value="' . $assignment_id . '">';
                echo '</div><div align="center">';
                if ((!empty($array['tab'])) && ($action != "comment") && ($action != 'student'))
                {
                    foreach ($array['tab'] as $tab => $id)
                    { // als er voor een bepaald vak meerdere lesinhouden zijn ingegeven... de links naar de verschillende lesinhouden weergeven.
                        echo '<a class="campus_tooltip_info" title="" agenda_id="' . $id . '" href="#" ' . (($id != $array['agenda_id']) ? ' onclick="javascript:agendaform.submit();" onmousedown="javascript:document.agendaform.action.value=\'refresh\';document.agendaform[\'agenda[' . $row . '][agenda_id]\'].value=\'' . $id . '\';" ' : ' ID="campus_agenda_info_current" ') . ' >';
                        $grouplist_tab = campus::get_agenda2group($id);
                        $students_tab = campus::get_agenda2student($id);
                        if (!empty($grouplist_tab))
                        {
                            $grouplist = "";
                            foreach ($grouplist_tab as $groupid => $groupinfo)
                            { //only on tab????
                                echo ($id != $array['agenda_id']) ? '' : '<input type="hidden" name="agenda[' . $row . '][groups][]" value="' . $groupid . '">';
                                $grouplist.= '_' . $groupinfo['code'];
                            }
                            echo '<i>' . substr($grouplist, 1, 7) . (strlen($grouplist) > 9 ? '...' : '') . '</i>';
                        }
                        else
                        {
                            echo " |i|";
                        }
                        if (!empty($students_tab) && ($agenda2student != $row))
                        {
                            foreach ($students_tab as $studentid => $value)
                            {
                                echo ($id != $array['agenda_id']) ? '' : '<input type="hidden" name="agenda[' . $row . '][students][]" value="' . $studentid . '">';
                            }
                            echo "<strong>+</strong>";
                        }
                        echo '</a> ';
                    }
                }
                else
                {
                    $grouplist = '';
                    $grouplistid = '';
                    $groups = campus::get_assignment2group($assignment_id); //($agenda[$row]['agenda_id'] == "") ? campus::get_assignment2group($assignment_id) : campus::get_agenda2group($agenda[$row]['agenda_id']);
                    foreach ($groups as $group_id => $group_info)
                    {
                        $grouplist.="_" . $group_info['code'];
                        $grouplistid.=';' . $group_id;
                    }
                    echo '<div class="campus_tooltip_tasks" title="" grouplist="' . substr($grouplistid, 1) . '">';
                    echo '<i>' . substr($grouplist, 1) . '</i>';
                    $students = ($array['agenda_id'] == "") ? "" : campus::get_agenda2student($array['agenda_id']);
                    if (!empty($students) && ($agenda2student != $row))
                    {
                        foreach ($students as $student_id => $id)
                        {
                            echo '<input type="hidden" name="agenda[' . $row . '][students][]" value="' . $student_id . '">';
                        }
                        echo '<strong>+</strong>';
                    }
                }
                echo '</div><div >';
                if (($action != 'comment') && ($action != 'student'))
                {
                    $resource_array = campus::get_college2resource($college_id);
                    foreach ($resource_array as $key => $value)
                    {
                        echo " <i style=\"float:right;\" title=\"" . $value['comment'] . "\">" . $value['code'] . "</i>";
                    }
                }
                echo "</div>";
            }
            else
            {   // =====================
                // The AGENDA FORM
                //======================
                $discipline = campus::get_assignment2discipline($assignment_id);

                if ($action != 'selectplus')
                {
                    echo '<input type="hidden" name="agenda[' . $row . '][assignment_id]" value="' . $assignment_id . '">';
                    echo '<input style="width:70%" type="' . ($readonly ? 'hidden' : 'text') . '" READONLY value="' . $discipline[key($discipline)]['code'] . '"><br>';
                }
                else
                {
                    echo '<select style="width:80%" name="agenda[' . $row . '][assignment_id]" height="1" onchange="javascript:agendaform.submit();">';

                    echo ($assignment_id == 0) ? "" : '<option value="' . $assignment_id . '" SELECTED>' . $discipline[key($discipline)]['code'] . '</option> ';
                    echo '<option value="-1" ' . (($assignment_id > 0) ? '' : 'SELECTED') . '>' . get_lang('txtGeneral') . '</option> ';
                    $assignments = campus::get_teacher2assignment($_uid, $activeroster['roster_id']);
                    foreach ($assignments as $assignmentid => $assignmentinfo)
                    { // Display all disciplines corresponding to the assignments for this period.. In 99% a theacher only has one assignment at the same time...
                        if ($assignment_id != $assignmentid)
                        { // only assigments keys
                            echo '<option value="' . $assignmentid . '" title="' . $assignmentinfo['name'] . ' ' . implode(' ', $assignmentinfo['group']) . '" >' . $assignmentinfo['code'] . ' ' . implode(' ', $assignmentinfo['group']) . '</option> ';
                        }
                    }
                    echo '</select><br>';
                }

                $assignment_groups = ($assignment_id > 0) ? campus::get_assignment2group($assignment_id) : campus::get_studentclasses($department_id);
                $groups_selected = array();
                if (!empty($array['groups']))
                { // select groups from FORM
                    $groups_selected = $array['groups'];
                }
                elseif (!empty($array['agenda_id']))
                { // select groups from agenda
                    $groups_selected = array_keys(campus::get_agenda2group($array['agenda_id']));
                }
                // if group is not part of assignment deselect group....
                $groups_selected = array_intersect($groups_selected, array_keys($assignment_groups));
                if (empty($groups_selected) && $assignment_id > 0)
                {// only groups part of the assignment can be selected....
                    $groups_selected = array_keys($assignment_groups);
                }
                if (($assignment_id != 0) || ($action == 'selectplus'))
                {
                    echo '<select style="width:100%" name="agenda[' . $row . '][groups][]" multiple="multiple" size="3" onchange="javascript:agendaform.submit();" ' . (($action == 'selectplus') ? '' : 'onmousedown="javascript:document.agendaform.action.value=\'new\';"') . '>';
                    foreach ($groups_selected as $key => $groupid)
                    {
                        $groupinfo = campus::get_group_info($groupid);
                        //    if (array_key_exists($groupid, $assignment_groups))
                        //  { // only groups part of the assignment can be selected....
                        echo '<option value="' . $groupid . '" SELECTED>' . $groupinfo[$groupid]['code'] . '</option> ';
                        //}
                    }
                    if (($agendaselect == 0) && ($assignment_id <= 0))
                    {
                        echo '<option value="" ' . (empty($groups_selected) ? 'SELECTED' : '') . ' >' . get_lang('txtPersonalAgenda') . '</option> ';
                    }
                    foreach ($assignment_groups as $key => $value)
                    { // the other possible groups....
                        if (!in_array($key, $groups_selected))
                        {
                            echo '<option value="' . $key . '" >' . $value['code'] . '</option> ';
                        }
                    }
                }
                echo "</select>";
                foreach ($array['students'] as $student_id)
                {
                    echo '<input type="hidden" name="agenda[' . $row . '][students][]" value="' . $student_id . '">';
                }
            }
            echo "</td>";

            if (($action == 'show') && ($array['content'] == ""))
            {
                echo '<td class="td_campus_agenda" style="width:30%;" ><textarea Readonly>' . $agendacontent[$array['date']] . '</textarea></td>';
            }
            else
            {
                echo '<td class="' . $style . '" style="width:30%;" ><textarea name="agenda[' . $row . '][content]" ' . (($readonly) ? 'READONLY' : '') . '>' . stripslashes($array['content']) . '</textarea></td>';
            }

            echo '<td class="' . $style . '" style="width:30%;" ><textarea name="agenda[' . $row . '][comment]" ' . (($readonly) ? 'READONLY' : '') . '>' . stripslashes($array['comment']) . '</textarea></td>';
            echo '<td  class="' . $style . '" style="width:1%;"> ';

            if ($action == "show")
            {
               echo (!empty($array['agenda_id'])) ? "<a href=\"" . $this->get_url() . "&page=teacheragenda&delete_id=" . $array['agenda_id'] . "&action=delete&dateselect=" . $dateselect . "&agendaselect=" . $agendaselect . "\" onclick=\"javascript:if(!confirm('" . get_lang("msgboxConfirmAgendaDeleteLine") . "')) return false;\"  title=\"" . get_lang("tooltipDeleteAgendaLine") . "\"><img src=\"" . Theme::get_image_path('application\campus') . "delete.gif\" border=0  height=16px  align=\"absmiddle\"></a><br>" : "";
                //echo (!empty($array['agenda_id'])) ? "<a href=\"" . $this->get_url() . "&page=agenda2vcs&agenda_id=" . $array['agenda_id'] . "\" TARGET='_blank' title=\"" . get_lang("tooltipExport2Outlook") . "\"><img src=\"" . Theme::get_image_path('application\campus') . "outlook.gif\" height=16px border=0 align=\"absmiddle\"></a>" : "";
            }
            elseif (($action != "show") && ($action != "comment") && ($action != "student") && !(empty($groups_selected)))// && (($action=="update") || ($action=="selectplus") || ($action=="selectplus_2e_page")))
            {
                echo '<a href="#" onclick="javascript:agendaform.submit();" onmousedown="javascript:document.agendaform.agenda2student.value=\'' . $row . '\';document.agendaform.action.value=\'student\';" title ="' . get_lang("tooltipAddStudent2Agenda") . '">
						<img src="' . Theme::get_image_path('application\campus') . 'add_user.gif" border=0 height=16px align="absmiddle" >
							</a>';
            }
            echo '</td></tr>';
        }
        if (($action != "show") && ($action != "comment") && ($action != "student"))
        {
            echo "<tr>"; //
            echo "<td></td><td colspan=\"5\" valign=\"middle\"><input type=\"submit\" onmousedown=\"javascript:document.agendaform.action.value='write';\" value=\"" . get_lang("buttonlabelSave") . "\" /><input type=\"submit\" onmousedown=\"javascript:document.agendaform.action.value='2e_page';\" value=\"" . get_lang("buttonlabelSaveNext") . "\" /><input type=\"submit\" onmousedown=\"javascript:document.agendaform.action.value='';\" value=\"" . get_lang("buttonlabelCancel") . "\" ></td>";
            echo "</tr>";
        }
        elseif ($action == "show")
        {
            echo "<tr>"; //
            echo "<td></td><td colspan=\"5\" align=\"right\"><a href=\"" . $this->get_url() . "&page=agendaarchive\" title='" . get_lang("tooltipAgendaArchive") . "'>" . get_lang("txtAgendaArchive") . "</a></td>";
            echo "</tr>";
        }

        echo "</table>";
        echo "</form></div>";
//echo ("<br clear=\"all\">");
    }
    else
    {
        Display::error_message(get_lang("msgNoRoster"), false);
    }
}
?>
