<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Theme;
use common\libraries\Path;
use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if (((intval($_uid) == 0) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...

    /* ==============================================================================
      Instellingen ophalen voor de geselecteerde dag department etc......
      ============================================================================== */
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);

    $dateselect = intval(campus::get_POST_GET("dateselect", time()));
    $department_id = intval(campus::get_SESSION("department_id"));
    $monday = strtotime('Next Monday', strtotime('-1 Week', $dateselect));
    $departmentStruc = campus::get_department($_uid);

    if (!empty($departmentStruc))
    { // enkel als de gebruiker is toegewezen aan een klas/department wordt de pagina weergegeven.
        // klas info inlezen...
        $result = mysql_query("SELECT `lastname`,`firstname` FROM `user_user` WHERE `id`=" . $_uid . "");
        $user = mysql_fetch_array($result, MYSQL_ASSOC);
        $data = array();
        $query = 'SELECT DISTINCT `date`,`campus_period`.`code`, `content`, `tasks`, `discipline_id`, `campus_agenda`.`id` as agenda_id, `comment`
                        FROM `campus_agenda`
                            INNER JOIN `campus_period` ON `campus_period`.`id`=`campus_agenda`.`period_id` AND `campus_period`.`department_id`=' . $department_id . '
                            LEFT JOIN `campus_assignment` ON `campus_assignment`.`id`=`campus_agenda`.`assignment_id`
                            LEFT JOIN `campus_assignment_rel_teacher` ON `campus_agenda`.`assignment_id`=`campus_assignment_rel_teacher`.`assignment_id`
    	         	WHERE (`campus_assignment_rel_teacher`.`user_id`=' . $_uid . ' OR `campus_agenda`.`user_id`=' . $_uid . ') AND date>=' . $monday . ' AND date<' . ($monday + 604800) . ' order by date, display_order';
        $result = mysql_query($query);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $found = FALSE;
            $all = TRUE;
            $groupcombi = "";
            $rij['students'] = "";
            $groups = campus::get_agenda2group($rij['agenda_id']);
            $students = campus::get_agenda2student($rij['agenda_id']);
            $discipline = campus::get_discipline_info($rij['discipline_id']);
            $rij['discipline_id'] = ($discipline[$rij['discipline_id']]['name'] == '') ? 'Algemeen' : $discipline[$rij['discipline_id']]['name'];
            foreach ($groups as $group_id => $groupinfo)
            {
                $groupcombi.=$groupinfo['code'] . " ";
            }
            $rij['groups'] = ($groupcombi == '') ? "" : "(" . substr($groupcombi, 0, -1) . ")";
            foreach ($students as $student_id => $studentinfo)
            {
                $rij['students'].=$studentinfo['firstname'] . " " . $studentinfo['lastname'] . "\n ";
            }
            $rij['students'] = substr($rij['students'], 0, -2);
            $data[$rij['date']][] = $rij;
        }
        //sort ($data);
        // Pagina instellingen
        include(Path :: get_web_application_path('campus') . '/old_php/php_pdf/class.ezpdf.php');
        $pdf = & new \Cezpdf('a4', 'landscape');
        $pdf->ezSetMargins(50, 35, 30, 30);
        $pdf->selectFont(Path :: get_web_application_path('campus') . '/old_php/php_pdf/fonts/Helvetica.afm');
        //koptekst en voettekst
        $pdf->ezStartPageNumbers(775, 15, 10, 'left', 'pagina {PAGENUM} van {TOTALPAGENUM}', 1);
        $pdf->ezStartPageNumbers(40, 15, 10, 'right', $departmentStruc[$department_id]['name'], 1);
        $all = $pdf->openObject();
        $pdf->saveState();
        $pdf->setStrokeColor(0.6, 0.6, 0.6);
        $pdf->setLineStyle(2);
        $pdf->line(50, 545, 790, 545);
        $ext = strtolower(substr($departmentStruc[$department_id]['logo'], -4));
        if ($ext == '.jpg')
        {
            $pdf->addJpegFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 50, 550, 75);
        }
        elseif ($ext == '.png')
        {
            $pdf->addPngFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 50, 550, 75);
        }
        $pdf->setColor(0.6, 0.6, 0.6);
        $pdf->addTextwrap(20, 560, 770, 18, "AGENDA  " . $academicYear, 'right');
        $pdf->addTextwrap(20, 560, 800, 14, utf8_decode($user['firstname'] . " " . $user['lastname']), 'center');
        //$pdf->addText(50,530,10,"Uur");
        //$pdf->addText(75,530,10,"Inhoud.");
        $pdf->setLineStyle(1);
        $pdf->line(70, 545, 70, 30);
        $pdf->line(400, 545, 400, 30);
        $pdf->line(600, 545, 600, 30);
        $pdf->restoreState();
        $pdf->closeObject();
        // note that object can be told to appear on just odd or even pages by changing 'all' to 'odd'
        // or 'even'.
        $pdf->addObject($all, 'all');
        campus::document2pdf_footer($pdf, 842, 1.5);

        foreach ($data as $id => $row)
        {
            $pdf->transaction('start');
            $lus = true;
            while ($lus)
            {
                $pos1 = $pdf->ezPosY();
                $pdf->ezSetDy(-3);
                $date = DatetimeUtilities::format_locale_date("%A %d %B %Y", $row[0]['date']);
                $pdf->setStrokeColor(0.95, 0.95, 0.95);
                $pdf->setLineStyle(12);
                $pdf->line(50, $pdf->ezPosY() - 6, 790, $pdf->ezPosY() - 6);
                $pdf->setColor(0.3, 0.3, 0.55);
                $pdf->ezSetDy(2);
                $pdf->eZText($date . ".", 10, array('aleft' => 75));
                $pdf->ezSetDy(-3);
                foreach ($row as $key => $rij)
                {
                    $pos = $pdf->ezPosY() - 2;
                    $pdf->setColor(0.96, 0.96, 0.96);
                    $pdf->filledRectangle(72, $pos, 718, -10);
                    $pdf->setColor(0, 0, 0);
                    //$pdf->addText(55,$pos-10,15,$rij['hour'],0);
                    $pdf->ezText("<b>" . utf8_decode($rij['discipline_id'] . " " . $rij['groups']) . "</b>", 8, array('aleft' => 135,), 0);
                    $pdf->addText(75, $pos - 8, 10, "Lesinhoud:");
                    $pdf->addText(405, $pos - 8, 10, "Taken/lessen.");
                    $pdf->addText(605, $pos - 8, 10, "Opmerkingen.");
                    $pdf->ezText("<i>" . utf8_decode($rij['content']) . "</i>", 10, array('aleft' => 75, 'aright' => 395), 0);
                    $endcontent = $pdf->ezPosY();
                    $pdf->ezSetY($pos - 12);
                    $pdf->ezText("<i>" . utf8_decode($rij['tasks']) . "</i>", 10, array('aleft' => 405, 'aright' => 595), 0);
                    $endtasks = $pdf->ezPosY();
                    $pdf->ezSetY($pos - 12);
                    if ($rij['students'] != "")
                    {
                        $pdf->ezText("LLN: <i>" . utf8_decode($rij['students']) . "</i>", 9, array('aleft' => 605, 'aright' => 790), 0);
                    }
                    $pdf->ezText("<i>" . utf8_decode($rij['comment']) . "</i>", 10, array('aleft' => 605, 'aright' => 790), 0);
                    $endcomment = $pdf->ezPosY();
                    $minpos = (($endcontent > $endtasks) ? (($endtasks > $endcomment) ? $endcomment : $endtasks) : (($endcontent > $endcomment) ? $endcomment : $endcontent)) - 5;
                    $minpos = ($minpos > ($pos - 50)) ? ($pos - 50) : $minpos;
                    $pdf->ezSetY($minpos);
                    $pdf->setColor(0.96, 0.96, 0.96);
                    $pdf->filledRectangle(50, $pos, 20, $minpos - $pos);
                    $pdf->setColor(0.6, 0.6, 0.6);
                    $pdf->addText(63, $pos - $pdf->getTextWidth(8, $rij['code']), 8, $rij['code'], -90);
                    $pdf->setColor(0, 0, 0);
                }
                if (($endcontent > $pos1) || ($endtasks > $pos1) || ($endcomment > $pos1) || ($minpos > $pos1))
                {
                    $pdf->transaction('rewind');
                    $pdf->ezNewPage();
                    campus::document2pdf_footer($pdf, 842, 1.5);
                }
                else
                {
                    $lus = false;
                }
            }
            $pdf->transaction('commit');
        }
        $pdf->ezText("\n");
        $fileoption = array('Content-Disposition' => 'agenda' . DatetimeUtilities::format_locale_date('%Y%m%d', $monday) . '.pdf');
        $pdf->ezStream($fileoption);
     }
}
?>