<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Utilities;
use common\libraries\Mdb2Connection;
use common\libraries\Configuration;
use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;

$thisVerbsion = "1.7.0";

/*
  ==============================================================================
  INIT SECTION
  ==============================================================================
 */
//$database = new Mdb2Database();
$config = Configuration :: get_instance();
$db = Mdb2Connection::connection_from_config($config);
//dump($db);
//echo($db->database_name);

$dbcampusplugin = mysql_connect($db->dsn["hostspec"], $db->dsn["username"], $db->dsn["password"]);
mysql_select_db($db->database_name, $dbcampusplugin);
mysql_set_charset('utf8');

//$mdb2conn = $this->db->get_connection();
//$this->connection = Mdb2Connection :: get_instance()->get_connection();
//dump($config);


function get_lang($string)
{
    Return Translation::get($string, null, 'application/campus');
}

//functions used in 
class campus
{

    function connect_db()
    {
        //calling this dummy function will make connection to db as these functions are outside the class...
        return true;
    }

    function normalize($string)
    {
        $safestring = strtr(utf8_decode($string), utf8_decode('ÀÁÂÃÄÅàáâãäåÒÓÔÕÖØòóôõöøÈÉÊËèéêëÇçÌÍÎÏìíîïÙÚÛÜùúûüÿÑñ'), 'AAAAAAaaaaaaOOOOOOooooooEEEEeeeeCcIIIIiiiiUUUUuuuuyNn');
        return $safestring;
    }

    function is_department_teacher($_uid)
    {
        if (intval($_SESSION['_campus']['department_id']) != 0)
        {
            $sql = "SELECT * FROM `group_group_rel_user`
				 INNER JOIN `campus_department_rel_group`
					ON `group_group_rel_user`.`group_id`=`campus_department_rel_group`.`group_id`
				 WHERE `type`=1 AND `department_id`=" . intval($_SESSION['_campus']['department_id']) . " AND `user_id`=" . $_uid . "";
            $result = mysql_query($sql);
            return (mysql_num_rows($result) >= 1);
        }
        else
        {

            return false;
        }
    }

    function parent2student($_uid)
    {
        $student_array=array();
        if (intval($_SESSION['_campus']['department_id']) != 0)
        {
            $department_id=intval($_SESSION['_campus']['department_id']);
            $query = "SELECT DISTINCT `user_user`.`id`, `lastname`, `firstname`
	            FROM `user_user`
	                INNER JOIN `campus_parent_rel_student`
	                   ON `user_user`.`id` = `campus_parent_rel_student`.`student_id`
	                INNER JOIN `group_group_rel_user`
	                   ON `user_user`.`id` = `group_group_rel_user`.`user_id`
			INNER JOIN `campus_department_rel_group`
				ON `group_group_rel_user`.`group_id`=`campus_department_rel_group`.`group_id` AND `department_id`=" . $department_id . " AND `type`=2
 			WHERE `campus_parent_rel_student`.`parent_id`=" . $_uid . "
				ORDER BY `lastname`,`firstname`";
            $result = mysql_query($query);
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $student_array[$rij['id']]['lastname'] = $rij['lastname'];
                $student_array[$rij['id']]['firstname'] = $rij['firstname'];
            }
        }
        return $student_array;
    }

    function get_user_info($_uid)
    {
        // get complete user info...
        $query = 'SELECT * FROM `user_user`
                    LEFT JOIN `campus_user`
                        ON `user_user`.`id` = `campus_user`.`user_id`
                    WHERE `id`=' . $_uid . ' ';
        $result = mysql_query($query);
        $userinfo = mysql_fetch_array($result, MYSQL_ASSOC);
        return $userinfo;
    }

    function get_userid_from_session()
    {
        session_name('dk_sid');
        session_start();
        $_uid = $_SESSION['_user']['user_id'];
        return $_uid;
    }

    function display_departments($departmentStruc, $department_id, $page = "")
    {
        echo '<div id="department_tabs">';
        if (!empty($departmentStruc))
        {
            $departmentlinks = '';
            foreach ($departmentStruc as $departmentlink_id => $departmentinfo)
            {
                if ($departmentStruc[$department_id]['code'] == '')
                {
                    // if active $department id is not part of struc select first member of struc.
                    $department_id = $departmentlink_id;
                    $_SESSION['_campus']['department_id'] = $department_id;
                }
                if ($departmentlink_id != $department_id)
                {
                    $departmentlinks.= '<li ><a href="' . $this->get_url() . '&department_id=' . $departmentlink_id . '&page=' . $page . '" title="' . Translation :: get("tooltipShow") . ' ' . $departmentinfo['name'] . '">' . $departmentinfo['code'] . '</a></li>' . "\n";
                }
            }
            echo '<ul style="float:right;">' . $departmentlinks . '</ul>';
            /*  if ($department_id == 0)
              {
              echo "<ul>\n<li id='current' style='font-size: 14px; '><a href='" . $campus['url'] . "' target='_blank' >" . $campus['name'] . "TTTT</a></li></ul>&nbsp;";
              }
              else
              { */
            echo "<ul>\n<li id='current' style='font-size: 14px; '><a href='" . $departmentStruc[$department_id]['url'] . "' target='_blank' title='" . Translation :: get("tooltip2DepartmentHomePage") . "'>" . $departmentStruc[$department_id]['name'] . "</a></li>\n</ul>&nbsp;";
            //}
        }
        echo "</div><br clear=\"all\">";
    }

    function get_POST_GET($var, $default = '', $nohtml = true)
    {
        if (is_array($_POST[$var]) || is_array($default))
        {
            if (empty($_POST[$var]))
            {
                return $default;
            }
            else
            {
                return $_POST[$var];
            }
        }
        else
        {
            $string = ($_POST[$var] != "") ? $_POST[$var] : (($_GET[$var] != "") ? $_GET[$var] : $default);
            if ($nohtml)
            {
                return strip_tags($string);
            }
            else
            {
                return $string;
            }
        }
    }

    function get_SESSION($var, $default = '', $nohtml = true)
    {
        // same as get_POST_GET but now also $_SESSION is uses...
        if (is_array($_POST[$var]) || is_array($default))
        {
            if (empty($_POST[$var]))
            {
                return $default;
            }
            else
            {
                return $_POST[$var];
            }
        }
        else
        {
            $default = ($_SESSION['_campus'][$var] != "") ? $_SESSION['_campus'][$var] : $default;
            $string = ($_POST[$var] != "") ? $_POST[$var] : (($_GET[$var] != "") ? $_GET[$var] : $default);
            $_SESSION['_campus'][$var] = $string;
            if ($nohtml)
            {
                return strip_tags($string);
            }
            else
            {
                return $string;
            }
        }
    }

    function get_department($user_id = -1)
    {
        // stop al de scholen waarvan de gebruiker via de klasgroep waartoe hij/zij behoort lid is in een array....
        $department_array = array();

        // platformadmin heeft al de scholen in zijn lijst en is automatisch lid van al de scholen....
        $result = mysql_query("SELECT `id` FROM `user_user` WHERE `id` = " . $user_id . " AND `admin`=1");
        $numrows = mysql_num_rows($result);
        if (($numrows == 1) || ($user_id == -1))
        { // selecteer al de scholen
            $sql = "SELECT DISTINCT `id`,`code`,`name`,`department_url`,`logo`,`department_admin_course`,`department_students_course`,`department_address`, `department_phone`, `agenda_layout`
				FROM `campus_department`
				ORDER BY `id`";
        }
        else
        { // selecteer de scholen waarvan de leerkracht lid is
            $sql = "SELECT DISTINCT `campus_department`.`id`,`code`,`name`,`department_url`,`logo`, `department_admin_course`,`department_students_course`,`department_address`, `department_phone`, `agenda_layout`
				FROM `campus_department`
					LEFT JOIN `campus_department_rel_group`
						ON `campus_department`.`id`=`campus_department_rel_group`.`department_id`
					LEFT JOIN `group_group_rel_user`
						ON `group_group_rel_user`.`group_id` = `campus_department_rel_group`.`group_id`
					WHERE `group_group_rel_user`.`user_id` = " . $user_id . " ORDER BY `group_group_rel_user`.`display_order`";
        }
        $result = mysql_query($sql) or die(mysql_error());
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $department_array[$rij['id']]['code'] = $rij['code'];
            $department_array[$rij['id']]['name'] = $rij['name'];
            $department_array[$rij['id']]['url'] = $rij['department_url'];
            $department_array[$rij['id']]['logo'] = $rij['logo'];
            $department_array[$rij['id']]['admin_course'] = $rij['department_admin_course'];
            $department_array[$rij['id']]['student_course'] = $rij['department_students_course'];
            $department_array[$rij['id']]['address'] = $rij['department_address'];
            $department_array[$rij['id']]['phone'] = $rij['department_phone'];
            $department_array[$rij['id']]['agenda_layout'] = $rij['agenda_layout'];
        }
        return $department_array;
    }

    function get_department_info($department_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        $department_array = array();
        if (is_int($department_id))
        {
            $filter = '`id` = ' . $department_id;
        }
        else
        {
            $filter = '`code` = "' . $department_id . '"';
        }
        // selecteer de department info
        $sql = 'SELECT `id`, `code`, `name`, `department_url`, `logo`, `department_admin_course`, `department_students_course`, `department_address`, `department_phone`
			FROM `campus_department`
			WHERE ' . $filter . ' LIMIT 1';
        $result = mysql_query($sql);
        $rij = mysql_fetch_array($result, MYSQL_ASSOC);
        $department_array[$rij['id']]['code'] = $rij['code'];
        $department_array[$rij['id']]['name'] = $rij['name'];
        $department_array[$rij['id']]['url'] = $rij['department_url'];
        $department_array[$rij['id']]['logo'] = $rij['logo'];
        $department_array[$rij['id']]['admin_course'] = $rij['department_admin_course'];
        $department_array[$rij['id']]['student_course'] = $rij['department_students_course'];
        $department_array[$rij['id']]['address'] = $rij['department_address'];
        $department_array[$rij['id']]['phone'] = $rij['department_phone'];

        return $department_array;
    }

    function get_teacherclasses($department_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        // stop al de klassen waartoe de gebruiker hoort in een array....
        $classes_array = array();
        $sql = "SELECT DISTINCT `id`,`code`, `name`
			FROM `group_group`
				LEFT JOIN `campus_department_rel_group`
					ON `group_group`.`id` = `campus_department_rel_group`.`group_id`
			WHERE `type`=1 AND `campus_department_rel_group`.`department_id` = " . $department_id . " ORDER BY `code`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $classes_array[$rij['id']]['code'] = $rij['code'];
            $classes_array[$rij['id']]['name'] = $rij['name'];
        }
        return $classes_array;
    }

    function get_teachers($department_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        // stop al de leerkachten van een department in een array....
        $query = "SELECT DISTINCT `user_user`.`id`,`lastname`, `firstname`, `official_code`, `status`
					FROM `group_group_rel_user`
           				LEFT JOIN `user_user`
           					ON `user_user`.`id` = `group_group_rel_user`.`user_id`
					WHERE (";
        // al de personeelsklassen van de department selecteren....
        $filter = "";
        $classes = campus::get_teacherclasses($department_id);
        foreach ($classes as $class_id => $classinfo)
        {
            $filter.=" `group_group_rel_user`.`group_id` = " . $class_id . " OR ";
        }
        $filter = substr($filter, 0, -3);
        $sql = $query . $filter . ") ORDER BY `lastname`,`firstname`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $teachers_array[$rij['id']]['official_code'] = $rij['official_code'];
            $teachers_array[$rij['id']]['name'] = $rij['lastname'] . " " . substr($rij['firstname'], 0, 1);
            $teachers_array[$rij['id']]['fullname'] = $rij['firstname'] . " " . $rij['lastname'];
            $teachers_array[$rij['id']]['status'] = $rij['status'];
        }
        return $teachers_array;
    }

    function get_studentclasses($department_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        // stop al de klassen waartoe de gebruiker hoort in een array....
        $classes_array = array();
        $sql = "SELECT DISTINCT `id`,`code`, `name`
        FROM `group_group`
  	      INNER JOIN `campus_department_rel_group`
                   ON `group_group`.`id` = `campus_department_rel_group`.`group_id`
                   WHERE `type`=2
        " . (($department_id == 0) ? " " : (" AND `department_id` = " . $department_id)) . " ORDER BY `code`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $result2 = mysql_query("SELECT DISTINCT * FROM `group_group_rel_user`  WHERE `group_group_rel_user`.`group_id` = '" . $rij['id'] . "'");
            $aantal_lln = mysql_num_rows($result2);
            $classes_array[$rij['id']]['code'] = $rij['code'];
            $classes_array[$rij['id']]['name'] = $rij['name'];
            $classes_array[$rij['id']]['aantal'] = $aantal_lln;
        }
        return $classes_array;
    }

    function get_classes($user_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        // stop al de klassen waartoe de gebruiker hoort in een array....
        $classes_array = array();
        $sql = "SELECT DISTINCT `id`,`code`, `name`, `display_order`
        FROM `group_group`
  	      LEFT JOIN `group_group_rel_user`
                   ON `group_group`.`id` = `group_group_rel_user`.`group_id`
        WHERE `group_group_rel_user`.`user_id` = " . $user_id . " ORDER BY `code`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $result2 = mysql_query("SELECT DISTINCT * FROM `group_group_rel_user`  WHERE `group_group_rel_user`.`group_id` = '" . $rij['id'] . "'");
            $aantal_lln = mysql_num_rows($result2);
            $classes_array[$rij['id']]['code'] = $rij['code'];
            $classes_array[$rij['id']]['name'] = $rij['name'];
            $classes_array[$rij['id']]['order'] = $rij['display_order'];
            $classes_array[$rij['id']]['aantal'] = $aantal_lln;
        }
        return $classes_array;
    }

    function get_class_info($class_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        // zoek de detail informatie van een klas op via het id van de klas...
        $class_array = array();
        $sql = "SELECT `id`,`code`, `name` FROM `group_group` WHERE `id` = " . $class_id;
        $result = mysql_query($sql);
        $rij = mysql_fetch_array($result, MYSQL_ASSOC);
        $result2 = mysql_query("SELECT DISTINCT * FROM `group_group_rel_user`  WHERE `group_group_rel_user`.`group_id` = '" . $rij['id'] . "'");
        $aantal_lln = mysql_num_rows($result2);
        $class_array[$rij['id']]['code'] = $rij['code'];
        $class_array[$rij['id']]['name'] = $rij['name'];
        $class_array[$rij['id']]['aantal'] = $aantal_lln;

        return $class_array;
    }

    function get_group_info($group_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        // zoek de detail informatie van een klas op via het id van de klas...
        $group_array = array();
        if (intval($group_id) > 0)
        {
            $sql = "SELECT `id`,`code`, `name` FROM `group_group` WHERE `id` = " . $group_id;
            $result = mysql_query($sql);
            $rij = mysql_fetch_array($result, MYSQL_ASSOC);
            $result2 = mysql_query("SELECT DISTINCT * FROM `group_group_rel_user`  WHERE `group_group_rel_user`.`group_id` = '" . $rij['id'] . "'");
            $aantal_lln = mysql_num_rows($result2);
            $group_array[$rij['id']]['code'] = $rij['code'];
            $group_array[$rij['id']]['name'] = $rij['name'];
            $group_array[$rij['id']]['aantal'] = $aantal_lln;
        }
        return $group_array;
    }

    function get_rosterarray($department_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        $week = DatetimeUtilities::get_days_long();
        // Week uurrooster structuur opbouwen
        foreach ($week as $key => $day)
        {
            $query = "SELECT `id`, `weekday`, `code`, `start_time`, `end_time`,`display_order` FROM `campus_period` WHERE `department_id` = " . $department_id . " AND `weekday` = " . $key . " ORDER BY `weekday`,`display_order`";
            $result = mysql_query($query) or die(mysql_error());
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $rosterStruc[$rij['display_order']][$rij['weekday']]['period_id'] = $rij['id'];
                $rosterStruc[$rij['display_order']][$rij['weekday']]['code'] = $rij['code'];
                $rosterStruc[$rij['display_order']][$rij['weekday']]['start_time'] = $rij['start_time'];
                $rosterStruc[$rij['display_order']][$rij['weekday']]['end_time'] = $rij['end_time'];
            }
        }
        return $rosterStruc;
    }

    function get_activeroster($department_id, $date = '')
    {
        /*         * * Chamilo 2.0.x Ready ** */
        // zoek op welk het actieve uurroosternummer is van de gegeven department.....
        $date = ($date == '') ? time() : $date;
        $activeroster=array();
        $query = 'SELECT `campus_curriculum`.`id` as "curriculum_id", "0" as "roster_id", "0" as "schedule_id"  FROM `campus_curriculum`
                    WHERE `department_id` = ' . $department_id . ' AND
                        `campus_curriculum`.`start_time`<=' . $date . ' 
                            ORDER BY `campus_curriculum`.`start_time` DESC LIMIT 1';
        $result = mysql_query($query) or die(mysql_error());
        $activeroster = mysql_fetch_array($result, MYSQL_ASSOC);
        if (! (empty($activeroster)))
        {
            $query = 'SELECT `campus_roster`.`curriculum_id` as "curriculum_id", `campus_roster`.`id` as "roster_id", `campus_roster_schedule`.`id` as "schedule_id"  FROM `campus_roster`
                        INNER JOIN `campus_roster_schedule` ON `campus_roster`.`id`=`campus_roster_schedule`.`roster_id`
                    WHERE `campus_roster`.`curriculum_id` = ' . $activeroster['curriculum_id'] . ' AND
                         `campus_roster_schedule`.`start_time`<=' . $date . ' 
                             ORDER BY `campus_roster_schedule`.`start_time` DESC LIMIT 1';
            $result = mysql_query($query) or die(mysql_error());
            if (mysql_num_rows($result) > 0)
            {
                $activeroster = array_merge($activeroster, mysql_fetch_array($result, MYSQL_ASSOC));
            }
        }
        return $activeroster;
    }

    function get_curriculum2schedule($curriculum_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        // zoek op welk het actieve uurroosternummer is van de gegeven department.....
        $query = 'SELECT `campus_roster_schedule`.`id` FROM `campus_curriculum`
                        INNER JOIN `campus_roster` ON `campus_roster`.`curriculum_id`=`campus_curriculum`.`id`
                        INNER JOIN `campus_roster_schedule` ON `campus_roster`.`id`=`campus_roster_schedule`.`roster_id`
                    WHERE `campus_curriculum`.`id` = ' . $curriculum_id . '
                        ORDER BY `campus_roster_schedule`.`start_time` DESC LIMIT 1';
        $result = mysql_query($query);
        list($schedule_id) = mysql_fetch_row($result);
        return $schedule_id;
    }

    function get_roster2curriculum($roster_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        // zoek op welk het actieve uurroosternummer is van de gegeven department.....
        $query = 'SELECT `curriculum_id` FROM `campus_roster`
                    WHERE `id` = ' . $roster_id . '';
        $result = mysql_query($query) or die(mysql_error());
        list($curriculum_id) = mysql_fetch_row($result);
        return $curriculum_id;
    }

    function get_schedule2roster($schedule_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        // zoek op welk het actieve uurroosternummer is van de gegeven department.....
        $query = 'SELECT `roster_id` FROM `campus_roster_schedule`
                    WHERE `id` = ' . $schedule_id . '';
        $result = mysql_query($query);
        list($roster_id) = mysql_fetch_row($result);
        return $roster_id;
    }

    function get_college2roster($college_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        // zoek op welk het actieve uurroosternummer is van de gegeven department.....
        $query = 'SELECT `roster_id` FROM `campus_college`
                    WHERE `id` = ' . $college_id . '';
        $result = mysql_query($query);
        list($roster_id) = mysql_fetch_row($result);
        return $roster_id;
    }

    function get_college2resource($college_id, $resource_array = array())
    {
        /*         * * Chamilo 2.0.x Ready ** */
        $sql = "SELECT DISTINCT `resource_id`, `code`, `comment`
			FROM `campus_college_rel_resource`
				INNER JOIN `campus_resource`
					ON `resource_id`= `campus_resource`.`id`
			WHERE `college_id` = " . $college_id . " ORDER BY `display_order`, `code`";
        $result = mysql_query($sql) or die(mysql_error());
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $resource_array[$rij['resource_id']]['code'] = $rij['code'];
            $resource_array[$rij['resource_id']]['comment'] = $rij['comment'];
        }
        return $resource_array;
    }

    function get_resource_info($resource_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        // zoek de detail informatie van een resource (klaslokaal, ...) op via het id van het resource ...
        $resource_array = array();
        $sql = "SELECT `id`,`code`, `comment` FROM `campus_resource` WHERE `id` = " . $resource_id;
        $result = mysql_query($sql);
        if ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $resource_array['resource_id'] = $rij['id'];
            $resource_array['code'] = $rij['code'];
            $resource_array['comment'] = $rij['comment'];
        }
        return $resource_array;
    }

    function get_discipline_info($discipline_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        // zoek de detail informatie van het vak op via het id van het vak...
        $discipline_array = array();
        $sql = "SELECT `id`,`code`, `name` FROM `campus_discipline` WHERE `id` = " . $discipline_id;
        $result = mysql_query($sql);
        if ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $discipline_array[$rij['id']]['code'] = $rij['code'];
            $discipline_array[$rij['id']]['name'] = $rij['name'];
        }
        return $discipline_array;
    }

    function get_rights($user_id, $department_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        // Zoek de rechten op van de gegeven gebruiker binnen campus ...

        $item = array(
            1 => 'info',
            2 => 'roster',
            3 => 'student',
            4 => 'IT',
            5 => 'studentTrackingLevel0',
            6 => 'studentTrackingLevel1',
            7 => 'studentTrackingLevel2',
            8 => 'studentTrackingLevel3',
            9 => 'studentTracking2Pdf',
            10 => 'studentTrackingShowHidden',
            11 => 'objectiveTrackingLevel0',
            12 => 'objectiveTrackingLevel1');

        $sql = "SELECT `campus_rights`.`item`
			FROM `campus_rights`
			WHERE `campus_rights`.`user_id` = " . $user_id . " AND `campus_rights`.`department_id` = " . $department_id . " ";
        $result = mysql_query($sql);
        $admin = array();
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $admin[$item[$rij['item']]] = true;
        }
        return $admin;
    }

    function get_trackingrights($user_id, $department_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        // Zoek de rechten op van de gegeven gebruiker binnen campus ...
        $classrights = array();
        $activeroster = campus::get_activeroster($department_id);
        $sql = "SELECT DISTINCT `campus_assignment_rel_group`.`group_id`
					FROM `campus_assignment_rel_teacher`
						INNER JOIN `campus_assignment_rel_group`
							ON `campus_assignment_rel_teacher`.`assignment_id`=`campus_assignment_rel_group`.`assignment_id`
						INNER JOIN `campus_assignment`
							ON `campus_assignment_rel_teacher`.`assignment_id`=`campus_assignment`.`id`
					WHERE `curriculum_id` = " . $activeroster['curriculum_id'] . " AND `user_id`=" . $user_id;
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $classrights[$rij['group_id']] = "Teacher";
        }
        $sql = "SELECT DISTINCT `group_id`
					FROM `campus_teacher_rel_group`
					WHERE `teacher_id` = " . $user_id . " AND `department_id` = " . $department_id . " ";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $classrights[$rij['group_id']] = "classTeacher";
        }
        return $classrights;
    }

    function get_trackingcategorys($department_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        // Zoek de rechten op van de gegeven gebruiker binnen campus ...
        $trackingcategorys = array();
        // read tracking types...
        $sql = "SELECT * FROM `campus_tracking_category` WHERE `department_id`=" . $department_id . " ORDER BY `display_order`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $trackingcategorys[$rij['id']]['name'] = $rij['tracking_category'];
            $trackingcategorys[$rij['id']]['restricted'] = $rij['restricted'];
            $trackingcategorys[$rij['id']]['sort'] = $rij['display_order'];
        }
        return $trackingcategorys;
    }

    function set_message_to($to, $message_id)
    {
        // koppel al de geadresseerden van een bericht met het gegeven bericht.....
        /*         * * Chamilo 2.0.x Ready ** */
        $department_id = campus::get_SESSION('department_id');
        $departmentStruc = campus::get_department_info($department_id);
        if (is_array($to))
        {
            // al de verwijzigen naar het bericht wissen zodat de nieuwe verwijzing geschreven kan worden.....
            $result = mysql_query("DELETE FROM `campus_message_rel_group` WHERE `message_id`='" . $message_id . "'");
            $result = mysql_query("DELETE FROM `campus_message_rel_user` WHERE `message_id`='" . $message_id . "'");
            foreach ($to as $key)
            {
                if ($key == "complete")
                {  // de personeelsleden van al de scholen toevoegen.
                    $query2 = "SELECT DISTINCT `group_id` FROM `campus_department_rel_group` WHERE `type`=1";
                    $result2 = mysql_query($query2);
                    while ($rij = mysql_fetch_array($result2, MYSQL_ASSOC))
                    {
                        $result = mysql_query("INSERT `campus_message_rel_group` SET `message_id`='" . $message_id . "', `group_id`='" . $rij['group_id'] . "'");
                    }
                }
                else
                {
                    // de gebruikers
                    switch (substr($key, 0, 1))
                    {
                        case "u" : // user selectie
                            {
                                $result = mysql_query("INSERT `campus_message_rel_user` SET `message_id`='" . $message_id . "', `user_id`='" . substr($key, 1) . "'");
                            }
                            break;
                        case "c" : // class selectie
                            {
                                $result = mysql_query("INSERT `campus_message_rel_group` SET `message_id`='" . $message_id . "', `group_id`='" . substr($key, 1) . "'");
                            }
                            break;
                        case "l" : // leerlingen van de department x .....
                            {
                                $query2 = "SELECT DISTINCT `group_id`	FROM `campus_department_rel_group`
									LEFT JOIN `group_group`
										ON `group_group`.`id` = `campus_department_rel_group`.`group_id`
										WHERE `type`=2 AND `department_id`=" . substr($key, 1);
                                $result2 = mysql_query($query2);
                                while ($rij = mysql_fetch_array($result2, MYSQL_ASSOC))
                                {
                                    $result = mysql_query("INSERT `campus_message_rel_group` SET `message_id`='" . $message_id . "', `group_id`='" . $rij['group_id'] . "'");
                                }
                            }
                            break;
                    }
                }
            }
        }
    }

    function get_message_to($message_id)
    {
        // deze functie leest al de bestemmelingen van een bepaald bericht in......
        /*         * * Chamilo 2.0.x Ready ** */
        $to_array = array();
        $sql = "SELECT `group_group`.`id`, `group_group`.`code`
        FROM `group_group`
        LEFT JOIN `campus_message_rel_group`
                   ON `group_group`.`id` = `campus_message_rel_group`.`group_id`
        WHERE `campus_message_rel_group`.`message_id` = " . $message_id . " ORDER BY `group_group`.`code`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $to_array['class'][$rij['id']] = $rij['code'];
        }
        $sql = "SELECT `user_user`.`id`, `user_user`.`official_code`
        FROM `campus_message_rel_user`
        LEFT JOIN `user_user`
                   ON `user_user`.`id` = `campus_message_rel_user`.`user_id`
        WHERE `campus_message_rel_user`.`message_id` = " . $message_id . " ORDER BY `user_user`.`official_code`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $to_array['user'][$rij['id']] = $rij['official_code'];
        }
        return $to_array;
    }

    function get_assignment2teacher($assignment_id, $roster_id, $teachers_array = array())
    {
        /*         * * Chamilo 2.0.x Ready ** */
        $sql = 'SELECT DISTINCT `assignment_id`, `user_id`, `official_code`, `lastname`, `firstname`
					FROM `campus_assignment_rel_teacher`
						INNER JOIN `user_user`
							ON `user_user`.`id`=`campus_assignment_rel_teacher`.`user_id`
						WHERE `campus_assignment_rel_teacher`.`assignment_id`=' . $assignment_id . ' AND `roster_id`=' . $roster_id . ' ORDER BY `official_code`';
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $teachers_array[$rij['user_id']]['official_code'] = $rij['official_code'];
            $teachers_array[$rij['user_id']]['name'] = $rij['lastname'] . " " . substr($rij['firstname'], 0, 1);
        }
        return $teachers_array;
    }

    function get_student2teachers($student_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        $classes = campus::get_classes($student_id);
        $department_id = campus::get_SESSION('department_id');
        $activeroster = campus::get_activeroster($department_id);
        $teachers_array = array();
        if (!empty($classes) && !empty($activeroster))
        {
            $query = "SELECT DISTINCT `campus_assignment_rel_teacher`.`user_id`, `official_code`, `lastname`, `firstname`
				FROM `user_user`
					INNER JOIN `campus_assignment_rel_teacher`
						ON `user_user`.`id` = `campus_assignment_rel_teacher`.`user_id`
					INNER JOIN `campus_assignment_rel_group`
						ON `campus_assignment_rel_group`.`assignment_id`= `campus_assignment_rel_teacher`.`assignment_id`
					INNER JOIN `campus_assignment`
						ON `campus_assignment_rel_teacher`.`assignment_id`=`campus_assignment`.`id`
					WHERE `curriculum_id` = " . $activeroster['curriculum_id'] . " AND (`group_id`=";
            $query.=implode(" OR `group_id`=", array_keys($classes));
            $query.=") ORDER BY `official_code`";
            $result = mysql_query($query) or die(mysql_error());
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $teachers_array[$rij['user_id']]['official_code'] = $rij['official_code'];
                $teachers_array[$rij['user_id']]['name'] = $rij['lastname'] . " " . substr($rij['firstname'], 0, 1);
            }
        }
        return $teachers_array;
    }

    function get_assignment2group($assignment_id, $group_array = array())
    {
        /*         * * Chamilo 2.0.x Ready ** */
        $sql = "SELECT DISTINCT `id`, `code`, `name`
            FROM `campus_assignment_rel_group`
            INNER JOIN `group_group`
            ON `campus_assignment_rel_group`.`group_id` = `group_group`.`id`
            WHERE `assignment_id`=" . $assignment_id . " ORDER BY `code`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $result2 = mysql_query("SELECT DISTINCT * FROM `group_group_rel_user` WHERE `group_group_rel_user`. `group_id` = '" . $rij['id'] . "'");
            $aantal_lln = mysql_num_rows($result2);
            $group_array[$rij['id']]['code'] = $rij['code'];
            $group_array[$rij['id']]['name'] = $rij['name'];
            $group_array[$rij['id']]['aantal'] = $aantal_lln;
        }
        return $group_array;
    }

    function get_agenda2group($agenda_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        $group_array = array();
        $sql = "SELECT DISTINCT `group_group`.`id`, `code`, `name`
            FROM `campus_agenda_rel_group`
            LEFT JOIN `group_group`
            ON `campus_agenda_rel_group`.`group_id` = `group_group`.`id`
            WHERE `agenda_id` = " . $agenda_id . " ORDER BY `code`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $result2 = mysql_query("SELECT DISTINCT * FROM `group_group_rel_user` WHERE `group_group_rel_user`. `group_id` = '" . $rij['id'] . "'");
            $aantal_lln = mysql_num_rows($result2);
            $group_array[$rij['id']]['code'] = $rij['code'];
            $group_array[$rij['id']]['name'] = $rij['name'];
            $group_array[$rij['id']]['aantal'] = $aantal_lln;
        }
        return $group_array;
    }

    function get_agenda2grouplist($agenda_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        $grouplist = '';
        $sql = "SELECT DISTINCT `group_group`.`id`, `code`, `name`
            FROM `campus_agenda_rel_group`
            LEFT JOIN `group_group`
            ON `campus_agenda_rel_group`.`group_id` = `group_group`.`id`
            WHERE `agenda_id` = " . $agenda_id . " ORDER BY `code`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $grouplist.=' ' . $rij['code'];
        }
        return substr($grouplist, 1);
    }

    function get_agenda2student($agendaid)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        $student_array = array();
        $sql = "SELECT DISTINCT `campus_agenda_rel_student`.`user_id`, `lastname`, `firstname`
            FROM `campus_agenda_rel_student`
            LEFT JOIN `user_user`
            ON `campus_agenda_rel_student`.`user_id` = `user_user`.`id`
            WHERE `agenda_id` = " . $agendaid . " ORDER BY `lastname`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $student_array[$rij['user_id']]['lastname'] = $rij['lastname'];
            $student_array[$rij['user_id']]['firstname'] = $rij['firstname'];
        }
        return $student_array;
    }

    function get_agenda2teacher($agendaid)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        $teachers_array = array();
        $sql = "SELECT DISTINCT `user_user`.`id`, `official_code`, `lastname`, `firstname`
            FROM `campus_agenda`
            LEFT JOIN `campus_assignment_rel_teacher`
            ON `campus_assignment_rel_teacher`.`assignment_id`=`campus_agenda`.`assignment_id`
            INNER JOIN `user_user`
            ON `campus_agenda`.`user_id` = `user_user`.`id` OR `campus_assignment_rel_teacher`.`user_id`=`user_user`.`id`
            WHERE `campus_agenda`.`id` = " . $agendaid . " ORDER BY `lastname`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $teachers_array[$rij['id']]['official_code'] = $rij['official_code'];
            $teachers_array[$rij['id']]['name'] = $rij['lastname'] . " " . substr($rij['firstname'], 0, 1);
        }
        return $teachers_array;
    }

    function get_agenda2teacherlist($agendaid)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        $teacherlist = '';
        $sql = "SELECT DISTINCT `user_user`.`id`, `official_code`, `lastname`, `firstname`
            FROM `campus_agenda`
            LEFT JOIN `campus_assignment_rel_teacher`
            ON `campus_assignment_rel_teacher`.`assignment_id`=`campus_agenda`.`assignment_id`
            INNER JOIN `user_user`
            ON `campus_agenda`.`user_id` = `user_user`.`id` OR `campus_assignment_rel_teacher`.`user_id`=`user_user`.`id`
            WHERE `campus_agenda`.`id` = " . $agendaid . " ORDER BY `lastname`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $teacherlist.=' <i title="' . $rij['lastname'] . " " . substr($rij['firstname'], 0, 1) . '.">' . $rij['official_code'] . '</i>';
        }
        return substr($teacherlist, 1);
    }

    function get_teacher2group($user_id, $curriculum_id = 0)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        $group_array = array();
        if ($curriculum_id > 0)
        {
            $sql = "SELECT DISTINCT `group_group`.`id`, `code`, `name`
            FROM `group_group`
            INNER JOIN `campus_assignment_rel_group`
            ON `campus_assignment_rel_group`.`group_id` = `group_group`.`id`
            INNER JOIN `campus_assignment_rel_teacher`
            ON `campus_assignment_rel_group`.`assignment_id` =`campus_assignment_rel_teacher`.`assignment_id`
            INNER JOIN `campus_assignment`
            ON `campus_assignment`.`id`=`campus_assignment_rel_group`.`assignment_id`
            WHERE `user_id` = " . $user_id . " AND `curriculum_id`=" . $curriculum_id . "
            ORDER BY `code`";
            $result = mysql_query($sql);
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $result2 = mysql_query("SELECT DISTINCT * FROM `group_group_rel_user` WHERE `group_group_rel_user`. `group_id` = '" . $rij['id'] . "'");
                $aantal_lln = mysql_num_rows($result2);
                $group_array[$rij['id']]['code'] = $rij['code'];
                $group_array[$rij['id']]['name'] = $rij['name'];
                $group_array[$rij['id']]['aantal'] = $aantal_lln;
            }
        }
        return $group_array;
    }

    function get_assignment2discipline($assignmentid, $discipline_array = array())
    {
        /*         * * Chamilo 2.0.x Ready ** */
        $sql = "SELECT DISTINCT `discipline_id`, `code`, `name`
            FROM `campus_assignment`
            INNER JOIN `campus_discipline`
            ON `campus_discipline`.`id`=`campus_assignment`.`discipline_id`
            WHERE `campus_assignment`.`id` = " . $assignmentid . " ORDER BY `display_order`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $discipline_array[$rij['discipline_id']]['code'] = $rij['code'];
            $discipline_array[$rij['discipline_id']]['name'] = $rij['name'];
        }
        return $discipline_array;
    }

    function get_teacher2assignment($user_id, $roster_id = 0)
    {
        /*         * * Chamilo 2.0.x Ready ** */

        $assignment_array = array();
        if ($roster_id > 0)
        {
            $sql = 'SELECT DISTINCT `campus_assignment`.`id`,`discipline_id`, `campus_discipline`.`code`, `campus_discipline`.`name`,`group_group`.`code` as group_code
			FROM `campus_assignment`
        			INNER JOIN `campus_assignment_rel_teacher`
                                    ON  `campus_assignment`.`id`=`campus_assignment_rel_teacher`.`assignment_id`
                        	INNER JOIN `campus_discipline`
                                    ON  `campus_assignment`.`discipline_id`=`campus_discipline`.`id`
                                LEFT JOIN `campus_assignment_rel_group`
                                    ON  `campus_assignment`.`id`=`campus_assignment_rel_group`.`assignment_id`
                                INNER JOIN `group_group`
                                    ON  `group_group`.`id`=`campus_assignment_rel_group`.`group_id`
                                WHERE `user_id` = ' . $user_id . ' AND `campus_assignment_rel_teacher`.`roster_id`=' . $roster_id . '
			ORDER BY `campus_discipline`.`display_order`';
            $result = mysql_query($sql) or die(mysql_error());
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $assignment_array[$rij['id']]['code'] = $rij['code'];
                $assignment_array[$rij['id']]['name'] = $rij['name'];
                $assignment_array[$rij['id']]['discipline_id'] = $rij['discipline_id'];
                $assignment_array[$rij['id']]['group'][] = $rij['group_code'];
            }
        }
        return $assignment_array;
    }

    function get_teacher2discipline($user_id, $curriculum_id = 0)
    {
        /*         * * Chamilo 2.0.x Ready ** */

        $discipline_array = array();
        if ($curriculum_id > 0)
        {
            $sql = 'SELECT DISTINCT `discipline_id`, `code`, `name`,`campus_assignment`.`id`
			FROM `campus_assignment` 
        			INNER JOIN `campus_assignment_rel_teacher`
                                    ON  `campus_assignment`.`id`=`campus_assignment_rel_teacher`.`assignment_id`
                        	INNER JOIN `campus_discipline`
                                    ON  `campus_assignment`.`discipline_id`=`campus_discipline`.`id`
                        WHERE `user_id` = ' . $user_id . ' AND `curriculum_id`=' . $curriculum_id . '
			ORDER BY `display_order`';
            $result = mysql_query($sql);
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $discipline_array[$rij['discipline_id']]['code'] = $rij['code'];
                $discipline_array[$rij['discipline_id']]['name'] = $rij['name'];
                $discipline_array[$rij['discipline_id']]['assignment_id'] = $rij['id'];
            }
        }
        return $discipline_array;
    }

    function get_department2discipline($department_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        $discipline_array = array();
        $sql = "SELECT DISTINCT `id`, `code`, `name`
            FROM `campus_discipline`
            WHERE `department_id`=" . $department_id . " ORDER BY `code`";
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $discipline_array[$rij['id']]['code'] = $rij['code'];
            $discipline_array[$rij['id']]['name'] = $rij['name'];
        }
        return $discipline_array;
    }
   function get_department2period($department_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        $period_array = array();
        $sql = "SELECT DISTINCT `id`, `code`, `weekday` , `start_time`, `end_time`
            FROM `campus_period`
            WHERE `department_id`=" . $department_id . " ORDER BY `display_order`";
     
        $result = mysql_query($sql);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $period_array[$rij['id']]['code'] = $rij['code'];
            $period_array[$rij['id']]['weekday'] = $rij['weekday'];
            $period_array[$rij['id']]['start_time'] = $rij['start_time'];
            $period_array[$rij['id']]['end_time'] = $rij['end_time'];
        }
        return $period_array;
    }

    function get_student2discipline($student_id)
    {
        /*         * * Chamilo 2.0.x Ready ** */
        $classes = campus::get_classes($student_id);
        $department_id = campus::get_SESSION('department_id');
        $activeroster = campus::get_activeroster($department_id);
        $discipline_array = array();
        if (!empty($classes))
        {
            $query = "SELECT DISTINCT `campus_discipline`.`id`, `code`, `name`
                        FROM `campus_discipline`
                            INNER JOIN `campus_assignment`
                                ON `campus_discipline`.`id`=`campus_assignment`.`discipline_id`
                            INNER JOIN `campus_assignment_rel_group`
                                ON `campus_assignment`.`id`=`campus_assignment_rel_group`.`assignment_id`
                        WHERE `curriculum_id`=" . $activeroster['curriculum_id'] . " AND (`group_id`=";
            $query.=implode(" OR `group_id`=", array_keys($classes));
            $query.=")";
            $result = mysql_query($query);
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $discipline_array[$rij['id']]['code'] = $rij['code'];
                $discipline_array[$rij['id']]['name'] = $rij['name'];
            }
        }
        return $discipline_array;
    }

    function display_inlineform($label, $type, $value, $var, $line = 0, $student_id)
    {
        $department_id = campus::get_SESSION('department_id');

        switch ($type)
        {
            case 1://"text":
                {
                    echo $label;
                    echo "<input type='hidden' name='$var' value='" . $value . "'>";
                }
                break;
            case 2://"mtext":
                {
                    echo "<pre>" . wordwrap($label, 90) . "</pre>";
                    echo "<input type='hidden' name='$var' value='" . $value . "'>";
                }
                break;
            case 3://"input":
                {
                    echo $label;
                    echo "<input type=\"text\" name=\"$var\" size=" . ((intval($value) == 0) ? 16 : intval($value)) . " maxsize=" . ((intval($value) == 0) ? 16 : intval($value)) . " value=\"" . stripslashes(ereg_replace("\"", "'", campus::get_POST_GET($var))) . "\">";
                }
                break;
            case 4://"textarea":
                {
                    echo $label . (($label != "") ? "<br>" : "");
                    echo '<textarea name="' . $var . '" cols="80" style ="height:' . ((intval($value) == 0) ? '68' : ((intval($value) * 16) + 4)) . 'px;">' . stripslashes(campus::get_POST_GET($var)) . '</textarea>';
                }
                break;
            case 5://"select":
                {
                    echo $label;
                    echo "<select name='$var'>";
                    $values = explode(";", $value);
                    foreach ($values as $key)
                    {
                        echo "<option value='" . trim($key) . "' " . ((trim(campus::get_POST_GET($var)) == trim($key)) ? 'selected' : '') . ">" . trim($key) . "</option>";
                    }
                    echo "</select>";
                }
                break;
            case 6://"mselect":
                {
                    echo $label;
                    $values = explode(";", $value);
                    foreach ($values as $key)
                    {
                        echo "<input type='checkbox'  name='" . $var . "[]' value='" . trim($key) . "' " . (in_array(trim($key), campus::get_POST_GET($var)) ? 'CHECKED' : '') . ">" . trim($key);
                    }
                }
                break;
            case 7://"mteachers":
                {
                    $teachers1 = campus::get_student2teachers($student_id);
                    $teachers2 = campus::get_teachers($department_id);
                    echo $label;
                    echo "<div style='display:inline;position:relative; z-index:" . (1000 - $line) . ";margin-right:160px;'>&nbsp;";
                    echo "<select style='position:absolute;top:0px; left:0px;padding:0px;margin:0px; width:150px;' id='$var' name='" . $var . "[]' size=1 multiple onmouseover=\"javascript:document.myform.$var.style.height='" . (16 * ((intval($value) == 0) ? 4 : intval($value))) . "px'\" onmouseout=\"javascript:document.myform.$var.style.height=''\">";
                    echo "<option value=''>&nbsp;</option>";
                    echo "<optgroup label=\"" . Translation :: get('txtTeachersFromClass') . "\">";
                    foreach ($teachers1 as $key => $value)
                    {
                        $option_value = $value['official_code'];
                        echo "<option value='" . $option_value . "' " . (in_array($option_value, campus::get_POST_GET($var)) ? 'SELECTED' : '') . ">" . $value['official_code'] . "</option>";
                    }
                    echo "</optgroup>";
                    echo "<optgroup label=\"" . Translation :: get('txtOtherTeachers') . "\">";
                    foreach ($teachers2 as $key => $value)
                    {
                        if (!array_key_exists($key, $teachers1))
                        {
                            $option_value = $value['official_code'];
                            echo "<option value='" . $option_value . "' " . (in_array($option_value, campus::get_POST_GET($var)) ? 'SELECTED' : '') . ">" . $value['official_code'] . "</option>";
                        }
                    }
                    echo "</optgroup>";
                    echo "</select></div>";
                }
                break;
            case 8://"teachers":
                {
                    $teachers1 = campus::get_student2teachers($student_id);
                    $teachers2 = campus::get_teachers($department_id);
                    echo $label;
                    echo "<select name='" . $var . "' size=" . ((intval($value) == 0) ? 0 : intval($value)) . " >";
                    echo "<option value=''>&nbsp;</option>";
                    echo "<optgroup label=\"" . Translation :: get('txtTeachersFromClass') . "\">";
                    foreach ($teachers1 as $key => $value)
                    {
                        $option_value = $value['official_code'];
                        echo "<option value='" . $option_value . "' " . (($option_value == campus::get_POST_GET($var)) ? 'SELECTED' : '') . ">" . $value['official_code'] . "</option>";
                    }
                    echo "</optgroup>";
                    echo "<optgroup label=\"" . Translation :: get('txtOtherTeachers') . "\">";
                    foreach ($teachers2 as $key => $value)
                    {
                        if (!array_key_exists($key, $teachers1))
                        {
                            $option_value = $value['official_code'];
                            echo "<option value='" . $option_value . "' " . (($option_value == campus::get_POST_GET($var)) ? 'SELECTED' : '') . ">" . $value['official_code'] . "</option>";
                        }
                    }
                    echo "</optgroup>";
                    echo "</select></div>";
                }
                break;
            case 9://"disciplines":
                {
                    $disciplines = campus::get_student2discipline($student_id);
                    if (empty($disciplines))
                    {
                        $disciplines = campus::get_department2discipline($department_id);
                    }
                    echo $label;
                    echo "<select name='$var' size=" . ((intval($value) == 0) ? 0 : intval($value)) . " >";
                    echo "<option value='' " . ((campus::get_POST_GET($var) == '') ? 'selected' : '') . "> </option>";
                    foreach ($disciplines as $key => $value)
                    {
                        echo '<option value="' . trim($value['name'] . ' (' . $value['code'] . ')') . '" ' . ((trim(campus::get_POST_GET($var)) == trim($value['name'] . ' (' . $value['code'] . ')')) ? 'selected' : '') . '>' . $value['name'] . ' (' . $value['code'] . ')</option>';
                    }
                    echo "</select>";
                }
                break;
            case 10://"mdisciplines":
                {
                    $disciplines = campus::get_student2discipline($student_id);
                    if (empty($disciplines))
                    {
                        $disciplines = campus::get_department2discipline($department_id);
                    }
                    echo $label;
                    echo "<div style='display:inline;position:relative; z-index:" . (1001 - $line) . ";margin-right:260px;'>&nbsp;";
                    echo "<select style='position:absolute;top:0px; left:0px;padding:0px;margin:0px;width:250px;' id='$var' name='" . $var . "[]' size=1 multiple onmouseover=\"javascript:document.myform.$var.style.height='" . (16 * ((intval($value) == 0) ? 4 : intval($value))) . "px'\" onmouseout=\"javascript:document.myform.$var.style.height=''\">";
                    echo "<option value=''>&nbsp;</option>";
                    foreach ($disciplines as $key => $value)
                    {
                        $option_value = $value['name'] . " (" . $value['code'] . ")";
                        echo "<option value='" . $value['name'] . " (" . $value['code'] . ")' " . (in_array($option_value, campus::get_POST_GET($var)) ? 'SELECTED' : '') . ">" . $value['name'] . " (" . $value['code'] . ")</option>";
                    }
                    echo "</select></div>";
                }
                break;
        }
    }

    function get_enumvalues($table, $field)
    {
        $query = " SHOW COLUMNS FROM `$table` LIKE '$field' ";
        $result = mysql_query($query);
        $row = mysql_fetch_array($result, MYSQL_NUM);
        #extract the values
        #the values are enclosed in single quotes
        #and separated by commas
        $regex = "/'(.*?)'/";
        preg_match_all($regex, $row[1], $enum_array);
        $enum_fields = $enum_array[1];
        return( $enum_fields );
    }

    function show_arrays($ar)
    { // function for dev. purposes to display content off complex array.
        echo "<table width='100%' border='1' bordercolor='#6699CC' cellspacing='0' cellpadding='5'><tr valign='top'>";
        foreach ($ar as $k => $v)
        {
            echo "<td align='center' bgcolor='#EEEEEE'>
					<table border='2' cellpadding='3'><tr><td bgcolor='#FFFFFF'><font face='verdana' size='1'> 
					" . $k . " 
					</font></td></tr></table>";
            if (is_array($ar[$k]))
            {
                campus::show_arrays($ar[$k]);
            }
            else
            {
                echo $ar[$k];
            }
            echo "</td>";
        }
        echo "</tr></table>";
    }

    function remove_emptylines($content)
    {
        $newcontent = '';
        $emptyline = FALSE;
        $contentlines = explode("\n", $content);
        foreach ($contentlines as $contentline)
        {
            $line = trim($contentline);
            if ($line == '')
            {
                if (!$emptyline)
                {
                    $emptyline = TRUE;
                    $newcontent.="\n";
                }
            }
            else
            {
                $emptyline = FALSE;
                $newcontent.=$line . "\n";
            }
        }
        return $newcontent;
    }

    /**
     * 	Display simple html header of table.
     */
    function display_table_header()
    {
        $bgcolor = "bgcolor='white'";
        echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"4\" width=\"85%\"><tbody>";
        return $bgcolor;
    }

    /**
     * 	Display html header of table with several options.
     *
     * 	@param $properties, array with elements, all of which have defaults
     * 	"width" - the table width, e.g. "100%", default is 85%
     * 	"class"	 - the class to use for the table, e.g. "class=\"data_table\""
     *   "cellpadding"  - the extra border in each cell, e.g. "8",default is 4
     *   "cellspacing"  - the extra space between cells, default = 0
     *
     * 	@param column_header, array with the header elements.
     * 	@author Roan Embrechts
     * 	@version 1.01
     */
    function display_complex_table_header($properties, $column_header)
    {
        $width = $properties["width"];
        if (!isset($width))
            $width = "85%";
        $class = $properties["class"];
        if (!isset($class))
            $class = "class=\"data_table\"";
        $cellpadding = $properties["cellpadding"];
        if (!isset($cellpadding))
            $cellpadding = "4";
        $cellspacing = $properties["cellspacing"];
        if (!isset($cellspacing))
            $cellspacing = "0";
        //... add more properties as you see fit
        //api_display_debug_info("Dokeos light grey is " . DOKEOSLIGHTGREY);
        $bgcolor = "bgcolor='" . DOKEOSLIGHTGREY . "'";
        echo "<table $class border=\"0\" cellspacing=\"$cellspacing\" cellpadding=\"$cellpadding\" width=\"$width\">\n";
        echo "<thead><tr $bgcolor>";
        foreach ($column_header as $table_element)
        {
            echo "<th>" . $table_element . "</th>";
        }
        echo "</tr></thead>\n";
        echo "<tbody>\n";
        $bgcolor = "bgcolor='" . HTML_WHITE . "'";
        return $bgcolor;
    }

    /**
     * 	Displays a table row.
     *
     * 	@param $bgcolor the background colour for the table
     * 	@param $table_row an array with the row elements
     * 	@param $is_alternating true: the row colours alternate, false otherwise
     */
    function display_table_row($bgcolor, $table_row, $is_alternating = true)
    {
        echo "<tr $bgcolor>";
        foreach ($table_row as $table_element)
        {
            echo "<td>" . $table_element . "</td>";
        }
        echo "</tr>\n";
        if ($is_alternating)
        {
            if ($bgcolor == "bgcolor='" . HTML_WHITE . "'")
            {
                $bgcolor = "bgcolor='" . DOKEOSLIGHTGREY . "'";
            }
            else
            {
                if ($bgcolor == "bgcolor='" . DOKEOSLIGHTGREY . "'")
                {
                    $bgcolor = "bgcolor='" . HTML_WHITE . "'";
                }
            }
        }
        return $bgcolor;
    }

    /**
     * 	Displays a table row.
     * 	This function has more options and is easier to extend than display_table_row()
     *
     * 	@param $properties, array with properties:
     * 	["bgcolor"] - the background colour for the table
     * 	["is_alternating"] - true: the row colours alternate, false otherwise
     * 	["align_row"] - an array with, per cell, left|center|right
     * 	@todo add valign property
     */
    function display_complex_table_row($properties, $table_row)
    {
        $bgcolor = $properties["bgcolor"];
        $is_alternating = $properties["is_alternating"];
        $align_row = $properties["align_row"];
        echo "<tr $bgcolor>";
        $number_cells = count($table_row);
        for ($i = 0; $i < $number_cells; $i++)
        {
            $cell_data = $table_row[$i];
            $cell_align = $align_row[$i];
            echo "<td align=\"$cell_align\">" . $cell_data . "</td>";
        }
        echo "</tr>\n";
        if ($is_alternating)
        {
            if ($bgcolor == "bgcolor='" . HTML_WHITE . "'")
                $bgcolor = "bgcolor='" . DOKEOSLIGHTGREY . "'";
            else
            if ($bgcolor == "bgcolor='" . DOKEOSLIGHTGREY . "'")
                $bgcolor = "bgcolor='" . HTML_WHITE . "'";
        }
        return $bgcolor;
    }

    /**
     * 	display html footer of table
     */
    function display_table_footer()
    {
        echo "</tbody></table>";
    }

    /**
     * 	display html footer of table
     */
    function document2pdf_header()
    {
        
    }

    function document2pdf_footer($pdf, $width = 840, $scale = 1)
    {
        $pdf->setStrokeColor(0.75, 0.75, 0.75);
        $pdf->setLineStyle(12, 'round');
        $pdf->line($width - (175.250 * $scale), 0, $width - (160.450 * $scale), (32.838 * $scale));
        $pdf->line($width - (160.450 * $scale), (32.838 * $scale), $width - (109.194 * $scale), (44.519 * $scale));
        $pdf->line($width - (109.194 * $scale), (44.519 * $scale), $width - (96.538 * $scale), (18.225 * $scale));
        $pdf->line($width - (96.538 * $scale), (18.225 * $scale), $width - (16.850 * $scale), 0);
        $pdf->line($width - (16.850 * $scale), 0, $width, (3.825 * $scale));
        $pdf->line($width - (16.850 * $scale), 0, $width, (13.475 * $scale));
        $pdf->line($width - (16.850 * $scale), 0, $width - (52.297 * $scale), (73.683 * $scale));
        $pdf->line($width - (52.297 * $scale), (73.683 * $scale), $width - (16.778 * $scale), (147.326 * $scale));
        $pdf->line($width, (151 * $scale), $width - (16.778 * $scale), (147.326 * $scale));
        $pdf->setLineStyle(1, 'butt');
        $pdf->setStrokeColor(0, 0, 0);
    }

}

?>