<?php
namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Display;
use common\libraries\DatetimeUtilities;
use common\libraries\Path;
use common\libraries\Theme;
use common\libraries\ResourceManager;
use common\libraries\Session;
use common\libraries\PlatformSetting;

//check if user is allowed here...
if ((intval ($_uid) == 0) || (empty($departmentStruc) && !$is_platformadmin))
{ // not allowed here!
    Display::display_error_message (get_lang ("msgNoDepartmentMember"), false);
}
else
{ //only users assigned to a department and platform administrator is allowed here...


    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $action = campus::get_POST_GET ("action");
    $info = campus::get_POST_GET ("info", "thisweek", FALSE);
    $attent = campus::get_POST_GET ("attent", "now", FALSE);
    $classes = campus::get_classes ($_uid);
    $academicYear = PlatformSetting::get ('active_academic_year', __NAMESPACE__);

    if ($action == "delete")
    {
        if (!empty($_GET["message_id"]))
        {
            $query = "DELETE FROM `campus_message_rel_user` WHERE `message_id`=" . intval ($_GET['message_id']) . " AND `user_id`=" . $_uid;
            $result = mysql_query ($query);
            if ($result)
            {
                $message = get_lang ("msgMsgDeleted");
            }
        }
    }

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */

    if (!empty($_SESSION['message']))
    {
        $base->display_normal_message ($_SESSION['message'], true);
    }

    /*     * ******************************************************************************
     *
     * 	Infoboard .... .... (Messageboard)
     *
     * ******************************************************************************* */
    $monday = strtotime ('Next Monday', strtotime ('-1 Week', time ()));

    //--- de info's worden per department weergegeven.
    echo ResourceManager :: get_instance ()->get_resource_html (Path :: get (WEB_APP_PATH) . 'campus/resources/javascript/hide_show.js');
    echo "<div class=\"info\">";
    //=============================================================================
    // info's....
    //=============================================================================
    switch ($info)
    {
        case "archive":
        {
            $startdate = 0; // before this, there is no info!!
            $enddate = time (); // till now...
            $result2 = mysql_query ("SELECT * FROM `campus_calender` WHERE `department_id`=" . $department_id . " AND `date`>=" . $startdate . " AND `date`<" . $enddate . " " . ((!$is_teacher) ? "AND `public`=1" : "") . " ORDER BY date"); // or die( mysql_error());
            $result = mysql_query ("SELECT * FROM `campus_info` WHERE `department_id`=" . $department_id . " AND `date`>=" . $startdate . " AND `date`<" . $enddate . " ORDER BY date"); // or die( mysql_error());
        }
            break;
        case "thisweek":
        {
            $startdate = mktime (0, 0, 0, date ('m', time ()), date ('d', time ()), date ('Y', time ()));
            $enddate = ($monday + 604800);
            $result2 = mysql_query ("SELECT * FROM `campus_calender` WHERE `department_id`=" . $department_id . " AND `date`>=" . $startdate . " AND `date`<" . $enddate . " " . ((!$is_teacher) ? "AND `public`=1" : "") . " ORDER BY date"); // or die( mysql_error());
            $result = mysql_query ("SELECT * FROM `campus_info` WHERE `department_id`=" . $department_id . " AND `date`>=" . $startdate . " AND `date`<" . $enddate . " ORDER BY date"); // or die( mysql_error());
            if ((mysql_num_rows ($result) > 0) || (mysql_num_rows ($result2) > 0))
                break;
        }
        case "nextweek":
        {
            $info = "nextweek";
            $startdate = ($monday + 432000); // start on saturday
            $enddate = ($monday + 1209600); // end on sunday (9 days...)
            $result2 = mysql_query ("SELECT * FROM `campus_calender` WHERE `department_id`=" . $department_id . " AND `date`>=" . $startdate . " AND `date`<" . $enddate . " " . ((!$is_teacher) ? "AND `public`=1" : "") . " ORDER BY date"); // or die( mysql_error());
            $result = mysql_query ("SELECT * FROM `campus_info` WHERE `department_id`=" . $department_id . " AND `date`>=" . $startdate . " AND `date`<" . $enddate . " ORDER BY date"); // or die( mysql_error());
            if ((mysql_num_rows ($result) > 0) || (mysql_num_rows ($result2) > 0)) //
            break;
        }
        case "future":
        {
            $info = "future";
            $startdate = ($monday + 1036800); // start on saturday
            $enddate = ($monday + (86400 * 365)); // the next year ....
            $result2 = mysql_query ("SELECT * FROM `campus_calender` WHERE `department_id`=" . $department_id . " AND `date`>=" . $startdate . ((!$is_teacher) ? " AND `public`='on'" : "") . " ORDER BY date");
            $result = mysql_query ("SELECT * FROM `campus_info` WHERE `department_id`=" . $department_id . " AND `date`>=" . $startdate . " ORDER BY date"); // AND `date`<" . $enddate . " ORDER BY date"); // or die( mysql_error());
        }
            break;
    }
    // read calendar databank...
    $infodata = array();

    while ($rij = mysql_fetch_array ($result2))
    {
        if ($rij['content'] != "")
        {
            $infodata[$rij['date']] .= "<div class='infocalender'>" . get_lang ("txtCalenderInfo") . " <i>" . $rij['content'] . "</i></div><br>";
        }
    }
    // read info databank...
    while ($rij = mysql_fetch_array ($result, MYSQL_ASSOC))
    {
        if (($rij['studentinfo'] != "") || ($is_teacher))
        {
            $infodata[$rij['date']] .= "<li ><div >";
            if ($info == "archive")
            {
                $infodata[$rij['date']] .= '<a href="' . $this->get_url () . '&page=archive2pdf&info_id=' . $rij['id'] . '" TARGET="_blank" title="' . get_lang ("tooltip2Pdf") . '"><img src="' . Theme::get_image_path('application\campus') . 'file_pdf.gif" border=0 align="right"></a>';
            }
            if ((isset($admin['info']) && $admin['info']) || $is_platformadmin)
            {
                $infodata[$rij['date']] .= '<a href="' . $this->get_url () . '&page=editinfo&info_id=' . $rij['id'] . '&action=delete&department_id=' . $department_id . '" onclick="javascript:if(!confirm(\'' . get_lang ("msgboxConfirmDeleteInfo") . '\')) return false;" title="' . get_lang ("tooltipDeleteInfo") . '"><img src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="right"></a>';
                $infodata[$rij['date']] .= '<a href="' . $this->get_url () . '&page=editinfo&info_id=' . $rij['id'] . '&action=update&department_id=' . $department_id . '" title="' . get_lang ("tooltipEditInfo") . '"><img src="' . Theme::get_image_path('application\campus') . 'edit.gif" border=0 align="right" /></a>';
            }
            if ($rij['studentinfo'] != "")
            {
                $infodata[$rij['date']] .= "<span style='color:#17306a'>" . ereg_replace (13, '<BR>', ereg_replace ("  ", '&nbsp;&nbsp;', $rij['studentinfo'])) . "</span><BR>";
            }
            if ($is_teacher)
            {
                $infodata[$rij['date']] .= "<span style='color:darkred'>" . ereg_replace (13, '<BR>', ereg_replace ("  ", '&nbsp;&nbsp;', $rij['teacherinfo'])) . "</span>";
            }
            $infodata[$rij['date']] .= "</div></li><br>";
        }
    }
    ksort ($infodata);
    if ($is_teacher)
    {
        echo "<span  class='infocaption' style=\"float:right;\">";
        if ((isset($admin['info']) && $admin['info']) || $is_platformadmin)
        {
            //echo "&nbsp<a href=\"".$_SERVER['PHP_SELF']."?page=editinfo&action=import&department_id=".$department_id."\" title=\"".get_lang("tooltipImportInfo")." ".$departmentStruc[$department_id]['name']."\">".get_lang("txtImportInfo")."</a>&nbsp|"; //OLLIE
            echo '&nbsp<a href="' . $this->get_url () . '&page=editinfo&action=new&department_id=' . $department_id . '" title="' . get_lang ("tooltipAddInfo") . ' ' . $departmentStruc[$department_id]['name'] . '">' . get_lang ("txtAddInfo") . '</a>&nbsp|';
            echo '&nbsp<a href="' . $this->get_url () . '&page=info2pdfsettings&department_id=' . $department_id . '" title="' . get_lang ("tooltipInfo2Pdf") . $departmentStruc[$department_id]['name'] . '">' . get_lang ("txtInfo2Pdf") . '</a>';
        }
        else
        {
            echo '&nbsp<a href="' . $this->get_url () . '&page=info2pdf&department_id=' . $department_id . '" title="' . get_lang ("tooltipInfo2Pdf") . $departmentStruc[$department_id]['name'] . '" target="_blank">' . get_lang ("txtInfo2Pdf") . '</a>';
        }
        echo '</span>';
    }
    echo '<span class="infocaption">' . $departmentStruc[$department_id]['code'] . ' ' . get_lang ("captionInfo") . '</span>';

    // de info's van het archief weergeven...
    echo '<div class="infosection"><span class="infosectioncaption">' . get_lang ("captionInfoArchive");
    if ($info != "archive")
    {
        echo '&nbsp;<a href="' . $this->get_url () . '&info=archive&department_id=' . $department_id . '" title="' . get_lang ("tooltipShowInfoArchive") . '"><img src="' .Theme::get_image_path('application\campus') . 'invisible.gif" border=0 align="middle"/></a>';
        echo '</span></div>';
        echo '<div class="infosection"><span class="infosectioncaption">' . get_lang ("captionInfoNow");
        if ($info != "thisweek")
        {
            echo '&nbsp;<a href="' . $this->get_url () . '&info=thisweek&department_id=' . $department_id . '" title="' . get_lang ("tooltipShowInfoNow") . '"><img src="' . Theme::get_image_path('application\campus') . 'invisible.gif" border=0 align="middle"/></a>';
            echo '</span></div>';
            echo '<div class="infosection"><span class="infosectioncaption">' . get_lang ("captionInfoNextWeek");
            if ($info != "nextweek")
            {
                echo '&nbsp;<a href="' . $this->get_url () . '&info=nextweek&department_id=' . $department_id . '" title="' . get_lang ("tooltipShowInfoNextWeek") . '"><img src="' . Theme::get_image_path('application\campus') . 'invisible.gif" border=0 align="middle"/></a>';
                echo '</span></div>';
                echo '<div class="infosection"><span class="infosectioncaption">' . get_lang ("captionInfoFuture");
            }
        }
    }
    echo '</span><ul class="infolist">';
    // display information......
    foreach ($infodata as $date => $content)
    {
        echo '<u >' . DatetimeUtilities::format_locale_date ('%A %d %B %Y', $date) . '</u><br><br>';
        echo $content;
    }
    echo '</ul></div>';
    switch ($info)
    {
        case "archive":
        {
            echo '<div class="infosection"><span class="infosectioncaption">' . get_lang ("captionInfoNow");
            echo '&nbsp;<a href="' . $this->get_url () . '&info=thisweek&department_id=' . $department_id . '" title="' . get_lang ("tooltipShowInfoNow") . '"><img src="' . Theme::get_image_path('application\campus') . 'invisible.gif" border=0 align="middle"/></a>';
            echo '</span></div>';
        }
        case "thisweek":
        {
            echo '<div class="infosection"><span class="infosectioncaption">' . get_lang ("captionInfoNextWeek");
            echo '&nbsp;<a href="' . $this->get_url () . '&info=nextweek&department_id=' . $department_id . '" title="' . get_lang ("tooltipShowInfoNextWeek") . '"><img src="' . Theme::get_image_path('application\campus') . 'invisible.gif" border=0 align="middle"/></a>';
            echo '</span></div>';
        }
        case "nextweek":
        {
            echo '<div class="infosection"><span class="infosectioncaption">' . get_lang ("captionInfoFuture");
            echo '&nbsp;<a href="' . $this->get_url () . '&info=future&department_id=' . $department_id . '" title="' . get_lang ("tooltipShowInfoFuture") . '"><img src="' . Theme::get_image_path('application\campus') . 'invisible.gif" border=0 align="middle"/></a>';
            echo "</span></div>";
        }
    }
    //=============================================================================
    // aandachtspunten....
    //=============================================================================
    if ($is_teacher) // de aandachtspunten zijn niet bedoelt voor de studenten....
    {
        if ($attent == "archive")
        {
            $nextattention = 1;
            $query = "SELECT `order` FROM `campus_attentionpoint` WHERE `department_id`=" . $department_id . " AND `display_order`>0 ORDER BY `display_order` DESC";
            $result = mysql_query ($query);
            // het laatste volgnummer selecteren
            list($nextattention) = mysql_fetch_row ($result);
            $nextattention++;
            $query = "select * FROM `campus_attentionpoint` WHERE `department_id`=" . $department_id . " AND `display_order`<1 ORDER BY `display_order`";
        }
        else
        {
            $query = "select * FROM `campus_attentionpoint` WHERE `department_id`=" . $department_id . " AND `display_order`>0 ORDER BY `display_order`";
        }
        $result = mysql_query ($query);
        echo '<br><span class="infocaption" style="float:right;">';
        if ((isset($admin['info']) && $admin['info']) || $is_platformadmin)
        {
            echo '&nbsp<a href="' . $this->get_url () . '&page=editattention&action=new&department_id=' . $department_id . '" title="' . get_lang ("tooltipAddAttention") . ' ' . $departmentStruc[$department_id]['name'] . '">' . get_lang ("txtAddAttention") . '</a>&nbsp';
        }
        echo '</span>';
        echo '<span class="infocaption">' . $departmentStruc[$_id]['code'] . ' ' . get_lang ("captionAttention") . '</span>';
        $kop0 = false;
        $kop1 = false;
        $attentdata = "";
        while ($rij = mysql_fetch_array ($result, MYSQL_ASSOC))
        {
            $attentdata .= '<div><b>' . $rij['display_order'] . '&nbsp;&nbsp;&nbsp;&nbsp;' . $rij['title'];
            if ((isset($admin['info']) && $admin['info']) || $is_platformadmin)
            {
                $attentdata .= '<a href="' . $this->get_url () . '&page=editattention&attention_id=' . $rij['id'] . '&action=delete&attent=' . $attent . '&department_id=' . $department_id . '" onclick="javascript:if(!confirm(\'' . get_lang ("msgboxConfirmDeleteAttention") . '\')) return false;" title="' . get_lang ("tooltipDeleteAttention") . '"><img src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="right" /></a>';
                $attentdata .= '<a href="' . $this->get_url () . '&page=editattention&attention_id=' . $rij['id'] . '&action=update&attent=' . $attent . '&department_id=' . $department_id . '" title="' . get_lang ("tooltipEditAttention") . '"><img src="' . Theme::get_image_path('application\campus') . 'edit.gif" border=0 align="right" ></a>';
                if ($attent == "archive")
                {
                    $attentdata .= '<a href="' . $this->get_url () . '&page=editattention&attention_id=' . $rij['id'] . '&action=show&next=' . $nextattention . '&department_id=' . $department_id . '" title="' . get_lang ("tooltipShowAttentionPoint") . $nextattention . '"><img src="' . Theme::get_image_path('application\campus') . 'invisible.gif" border=0 align="right"></a>';
                }
                else
                {
                    $attentdata .= '<a href="' . $this->get_url () . '&page=editattention&attention_id=' . $rij['id'] . '&action=hide&department_id=' . $department_id . '" title="' . get_lang ("tooltipHideAttentionPoint") . '"><img src="' . Theme::get_image_path('application\campus') . 'visible.gif" border=0 align="right" ></a>';
                }
            }
            $attentdata .= '</b><br><br>';
            $attentdata .= ereg_replace (13, '<BR>', ereg_replace ("  ", '&nbsp;&nbsp;', $rij['content'])) . "<BR><BR></div>";
        }
        // het aandachtspunten archief weergeven ....
        echo '<div class="infosection"><span class="infosectioncaption">' . get_lang ("captionAttentionArchive");
        if ($attent != 'archive')
        {
            echo '&nbsp;<a href="' . $this->get_url () . '&attent=archive&department_id=' . $department_id . '" title="' . get_lang ("tooltipShowAttentionArchive") . '"><img src="' . Theme::get_image_path('application\campus') . 'invisible.gif" border=0 align="middle"/></a></span>';
        }
        else
        {
            echo '</span>';
            echo $attentdata;
        }
        echo '</div>';
        // de huidige aandachtspunten weergeven ....
        echo '<div class="infosection"><span class="infosectioncaption">' . get_lang ("captionAttentionPoints");
        if ($attent != 'now')
        {
            echo '&nbsp;<a href="' . $this->get_url () . '&attent=now&department_id=' . $department_id . '" title="' . get_lang ("tooltipShowAttention") . '"><img src="' . Theme::get_image_path('application\campus') . 'invisible.gif" border=0 align="middle"/></a></span><ul class="infolist">';
        }
        else
        {
            echo '</span>';
            echo $attentdata;
        }
        echo '</div>';
    }
    echo '</div>';
    /*     * ******************************************************************************
     *
     * 	Berichten, nieuwtjes .... (Messageboard)
     *
     * ******************************************************************************* */
    echo '<div class="msgbrd">';
    if ($is_teacher) // de studenten mogen hier geen berichten plaatsen....
    { // de berichten voor de personeelsleden...
        echo '<div style="float:right"><br><A href="' . $this->get_url () . '&page=editmessage&action=list" title="' . get_lang ("tooltipManageMsg") . '">' . get_lang ("txt2MsgList") . '&nbsp;<img src="' . Theme::get_image_path('application\campus') . 'dropbox.gif" border=0 valign="top"/></a>&nbsp;&nbsp;</div>';
    }
    echo '
		<br><span class="msgbrdcaption">' . get_lang ("captionMsgBoard") . '</span>
		<div>
			<ul>
			</ul>
		</div>
	';

    if ((trim ($departmentStruc[$department_id]['student_course']) != '') || (trim ($departmentStruc[$department_id]['admin_course']) != ''))
    {
        echo '<div class="msgbrdsection">';
        if ($is_teacher)
        {
            // OBJECT FROM WEBLCMS.......
            $result = mysql_query ('SELECT `id` FROM `weblcms_course` WHERE `visual_code`="' . $departmentStruc[$department_id]['admin_course'] . '"');
            if (mysql_num_rows ($result) == 1)
            {
                list($course_id) = mysql_fetch_row ($result);
                //show_notification($my_course)
                echo '<div class="msgbrdlist">';
                echo '<a href="' . Path::get_web_application_path ('weblcms') . '&go=course_viewer&course=' . $course_id . '">' . $departmentStruc[$department_id]['name'] . ' ' . get_lang ('txtTeacherInfo') . '</a>';
                echo '</div>';
            }
            else
            {

                // not recognised as course code so assuming it is a URL
                echo '<div class="msgbrdlist">';
                echo '<a href="' . $departmentStruc[$department_id]['admin_course'] . '">' . $departmentStruc[$department_id]['name'] . ' ' . get_lang ('txtTeacherInfo') . '</a>';
                echo '</div>';
            }

        }

        // OBJECT FROM WEBLCMS.....
        // info for students is also available for teachers..
        $result = mysql_query ('SELECT `id` FROM `weblcms_course` WHERE `visual_code`="' . $departmentStruc[$department_id]['student_course'] . '"');
        if (mysql_num_rows ($result) == 1)
        {
            list($course_id) = mysql_fetch_row ($result);
            //show_notification($my_course)
            echo '<div class="msgbrdlist">';
            echo '<a href="' . Path::get_web_application_path ('weblcms') . '&go=course_viewer&course=' . $course_id . '">' . $departmentStruc[$department_id]['name'] . ' ' . get_lang ('txtStudentInfo') . '</a>';
            echo '</div>';
        }
        else
        {

            // not recognised as course code so assuming it is a URL
            echo '<div class="msgbrdlist">';
            echo '<a href="' . $departmentStruc[$department_id]['student_course'] . '">' . $departmentStruc[$department_id]['name'] . ' ' . get_lang ('txtStudentInfo') . '</a>';
            echo '</div>';
        }
        echo '</div>';
    }

    // =============================================================================
    // check for Trackingforms to be filled in by the student....
    // =============================================================================
    if (!$is_teacher)
    {
        $formclasses = "";
        foreach ($classes as $class_id => $code)
        {
            $formclasses .= "`campus_trackingform_rel_group`.`group_id` = " . $class_id . " OR ";
        }
        // display link to special form....
        $query = "SELECT `subject`, `campus_trackingform`.`id`, `form_type`, `formend` FROM `campus_trackingform`
					INNER JOIN `campus_trackingform_rel_group` ON `campus_trackingform_rel_group`.`trackingform_id`=`campus_trackingform`.`id`
 					INNER JOIN `campus_tracking_title` ON `campus_tracking_title`.`id`=`campus_trackingform`.`title_id`
					INNER JOIN `campus_tracking_category` ON `campus_tracking_category`.`id`=`campus_tracking_title`.`category_id`
				WHERE `campus_trackingform`.`department_id`=" . $department_id . "
 							AND (" . substr ($formclasses, 0, -3) . ")
 							AND (`formstart`<= " . time () . " OR `formstart` = 0)
 							AND (`formend` >= " . time () . " OR `formend` = 0)
 							AND (`form_type`=1 OR `form_type`=2)";
        $result = mysql_query ($query);
        if (mysql_num_rows ($result) > 0)
        {
            $formlink = "";
            while ($rij = mysql_fetch_array ($result, MYSQL_ASSOC))
            {
                if ($rij['form_type'] == 2)
                {
                    $query2 = "SELECT `campus_student_tracking`.`id`
	       			FROM `campus_student_tracking`
                                    INNER JOIN `campus_tracking_category`
					ON `campus_student_tracking`.`tracking_category`=`campus_tracking_category`.`tracking_category` AND `campus_tracking_category`.`department_id`=" . $department_id . "
                                    INNER JOIN `campus_tracking_title`
					ON `campus_tracking_category`.`id`=`campus_tracking_title`.`category_id` AND `campus_tracking_title`.`tracking_title`=`campus_student_tracking`.`tracking_title`
                                    INNER JOIN `campus_trackingform`
	                		ON `campus_tracking_title`.`id`=`campus_trackingform`.`title_id`
				WHERE `student_id`=" . $_uid . " AND `campus_trackingform`.`id`=" . $rij['id'] . " AND `department_code`='" . $departmentStruc[$department_id]['code'] . "'
								 AND `date` >=" . mktime (0, 0, 0, 7, 4, substr ($academicYear, 0, 4)) . " AND `date` <=" . mktime (0, 0, 0, 8, 31, substr ($academicYear, 5, 4)) . " ";
                    $result2 = mysql_query ($query2) or die(mysql_error ());
                    $numrows = mysql_num_rows ($result2);
                }
                if (($rij['form_type'] == 1) || ($numrows == 0))
                {
                    if ($rij['subject'] != 'Belangstellingstest')
                    {
                        $formlink .= '<div class="msgbrdlist">';
                        $formlink .= '<a href="' . $this->get_studenttracking_url () . '&page=studentform&trackingform_id=' . $rij['id'] . '" title="' . (($rij['formend'] != '0000-00-00') ? (get_lang ('tootlipAvailableTill') . ' ' . $rij['formend']) : '') . '">' . $rij['subject'] . '</a>';
                        $formlink .= '</div>';
                    }
                    else
                    {
                        $formlink .= '<div class="msgbrdlist">';
                        $formlink .= '<a href="' . $this->get_studenttracking_url () . '&page=belangstellingstest&trackingform_id=' . $rij['id'] . '" title="' . (($rij['formend'] != '0000-00-00') ? (get_lang ('tootlipAvailableTill') . ' ' . $rij['formend']) : '') . '">' . $rij['subject'] . '</a>';
                        $formlink .= '</div>';
                    }
                }
            }
            if ($formlink != "")
            {
                echo '<div class="msgbrdsection">';
                echo '<span class="msgbrdsectioncaption">' . get_lang ('captionForms') . '</span>';
                echo $formlink;
                echo '</div>';
            }
        }
    }


    // =============================================================================
    // Algemene berichten ophalen ....
    // =============================================================================
    $sql = "SELECT DISTINCT `user_id`, `date`, `title`, `content`
       FROM `campus_message_rel_group`
       LEFT JOIN `campus_messageboard`
                  ON `campus_messageboard`.`id` = `campus_message_rel_group`.`message_id`
       WHERE (";
    $filter = "";
    if ($is_teacher) // de studenten mogen hier geen berichten plaatsen....
    { // de berichten voor de personeelsleden...
        //echo ("<p>&nbsp;<A href=\"".$_SERVER['PHP_SELF']."?page=editmessage&action=list\" TITLE=\"".get_lang("tooltipManageMsg")."\">".get_lang("txt2MsgList")."</A></p>");
        echo '	<div class="msgbrdsection">
			<span class="msgbrdsectioncaption">' . get_lang ("captionMsg4Everyone") . '</span>
			<div class="msgbrdlist">';
        foreach ($classes as $class => $code)
        {
            $filter .= "`campus_message_rel_group`.`group_id` = " . $class . " OR ";
        }
    }
    else
    { // De berichten voor de klas
        echo '<div class="msgbrdsection">
				<span class="msgbrdsectioncaption">' . get_lang ("captionMsg") . '</span>
				<div class="msgbrdlist">';
        foreach ($classes as $class => $code)
        {
            $filter .= '`campus_message_rel_group`.`group_id` = ' . $class . ' OR ';
        }
    }
    $filter = substr ($filter, 0, -3) . ') AND date>=' . strtotime ('-2 week') . ' ORDER BY `date` DESC';

    $result = mysql_query ($sql . $filter);
    $i = 0;
    $visible = "display:;";
    while ($rij = mysql_fetch_array ($result, MYSQL_ASSOC))
    {
        $i++;
        $userinfo = campus::get_user_info ($rij['user_id']);
        echo "<p style='margin:3px 0px 2px 0px';><a href='#' onclick=\"javascript: toggleID('msg" . $i . "')\"><b title='" . get_lang ("txtMsgFrom") . " " . $userinfo['lastname'] . " " . substr ($userinfo['firstname'], 0, 1) . ".'>" . DatetimeUtilities::format_locale_date ('%A %d %m', $rij['date']) . "</b>: <i>" . $rij['title'] . "</i></a><br>" .
            "<div ID='msg" . $i . "' style='" . $visible . "'>" . get_lang ("txtMsgFrom") . " <i title='" . $userinfo['lastname'] . " " . substr ($userinfo['firstname'], 0, 1) . ".'>" . $userinfo['official_code'] . "</i><br>" .
            get_lang ("txtMsgTitle") . " <i>" . $rij['title'] . "</i><br>" . "<br>" .
            "<i>" . ereg_replace ("\r", '', ereg_replace ("\n", '<br>', ereg_replace ("  ", '&nbsp;&nbsp;', $rij['content']))) . "</i><br></div></p>";
        $visible = "display:none;";
    }
    echo "</div></div>";
    // =============================================================================
    // persoonlijke berichten ophalen ....
    // =============================================================================
    if ($is_teacher) // de studenten krijgen geen persoonlijke berichten....
    {
        echo '<div class="msgbrdsection">
					<span class="msgbrdsectioncaption">' . get_lang ("captionMsgPersonal") . '</span>
				<div class="msgbrdlist">';
        // voor elke department de lijst opstellen om de klas te selecteren.
        // de verschillende klassen die tot een bepaalde department behoren ophalen....
        $sql = 'SELECT DISTINCT `campus_messageboard`.`user_id`, `date`, `title`, `content`, `campus_messageboard`.`id` as message_id
			FROM `campus_message_rel_user`
        			LEFT JOIN `campus_messageboard`
                			ON `campus_messageboard`.`id` = `campus_message_rel_user`.`message_id`
			WHERE `campus_message_rel_user`.`user_id` = ' . $_uid . ' AND date>=' . strtotime ('-1 week') . ' ORDER BY `date` DESC';
        $result = mysql_query ($sql);
        $i = 0;
        $visible = "display:;";
        while ($rij = mysql_fetch_array ($result, MYSQL_ASSOC))
        {
            //OLLIE: ervoor zorgen dat het bericht pas getoond wordt vanaf een ingegegeven datum
            if ($rij['date'] <= time ())
            {
                $i++;
                $userinfo = campus::get_user_info ($rij['user_id']);
                echo '<p style="margin:3px 0px 2px 0px";><b title="' . get_lang ("txtMsgFrom") . ' ' . $userinfo['lastName'] . ' ' . substr ($userinfo['firstName'], 0, 1) . '.">' . DatetimeUtilities::format_locale_date ('%A %d %b', $rij['date']) . '</b>: <a href="#" onclick="javascript: toggleID(\'pmsg' . $i . '\')"><i>' . $rij['title'] . '</i></a><br>';
                echo '<div ID="pmsg' . $i . '" style="' . $visible . '"><a href="' . $this->get_url () . '&message_id=' . $rij['message_id'] . '&action=delete&department_id=' . $department_id . '" onclick="javascript:if(!confirm(\'' . get_lang ("msgboxConfirmDeleteMsg") . '\')) return false;" title="' . get_lang ("tooltipDeleteMsg") . '"><img align="right" src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 ></a>';
                echo '<a href="' . $this->get_url () . '&page=editmessage&to=' . $rij['user_id'] . '&title=RE: ' . $rij['title'] . '&action=new&department_id=' . $department_id . '" title=' . get_lang ("tooltipReplyMsg") . '"><img align="right" src="' . Theme::get_image_path('application\campus') . 'conf.gif" border=0 ></a>';
                echo '<a href="' . $this->get_url () . '&page=message2pdf&message_id=' . $rij['message_id'] . '" target="blank" title="' . get_lang ("tooltip2Pdf") . '"><img align="right" src="' . Theme::get_image_path('application\campus') . 'file_pdf.gif" border=0 ></a>';
                echo get_lang ("txtMsgFrom") . ' <i title="' . $userinfo['lastname'] . ' ' . substr ($userinfo['firstname'], 0, 1) . '.">' . $userinfo['official_code'] . '</i>';
                echo '<br>';
                echo get_lang ("txtMsgTitle") . ' <i>' . $rij['title'] . '</i><br>';
                echo ' <i>' . ereg_replace ("\r", '', ereg_replace ("\n", '<BR>', ereg_replace ("  ", '&nbsp;&nbsp;', $rij['content']))) . '</i><br></div></p>';
                $visible = 'display:none;';
            }
        }
        echo "</div></div>";
    }

//=============================================================================
// Vervangingen en leswissels
//=============================================================================

    /* 	if ($is_teacher) // de studenten krijgen geen persoonlijke berichten....
      {
      echo "
      <div class=\"msgbrdsection\">
      <span class=\"msgbrdsectioncaption\">Deze week: leswissels en vervangingen</span>
      <div class=\"msgbrdlist\">
      ";
      // Query van het gegevensbestand....
      $enddate=strftime("%Y-%m-%d", ($monday+604800));
      $query="SELECT DISTINCT `date`,`content`,`hour` FROM `".$campusDb."`.`campus_agenda` WHERE `teacher_id`='$_uid' AND `import_id` IS NOT NULL AND `date`>='$today' AND `date`<'$enddate'";
      //echo($query);
      $result =mysql_query($query);

      while (list($datum, $inhoud, $uur)= mysql_fetch_row($result))
      {
      echo("$datum, $uur: $inhoud <BR></BR>");
      }

      echo "</div></div>";
      }
     */
//=============================================================================
// verjaardagen ....
//=============================================================================
    echo '<div class="msgbrdsection">
			<span class="msgbrdsectioncaption">' . get_lang ("captionThisMonthBirthdays") . '</span>
			<div class="msgbrdlist">';
    // Query van het gegevensbestand....
    $query = "SELECT DISTINCT `lastname`, `firstname`, MONTH(`birth`),  DAYOFMONTH(`birth`)
            FROM `user_user`
                INNER JOIN `group_group_rel_user`
                   ON `user_user`.`id` = `group_group_rel_user`.`user_id`
                INNER JOIN `campus_user`
                   ON `user_user`.`id` = `campus_user`.`user_id`
            WHERE `birth`<>0 AND (";
    // de verschillende scholen toevoegen waarvan de gebruiker lid is....
    $filter = "";
    foreach ($classes as $class => $code)
    {
        $filter .= " `group_group_rel_user`.`group_id` = " . $class . " OR ";
    }
    $filter = substr ($filter, 0, -3);

    $sql = $query . $filter . ") ORDER BY DAYOFMONTH(`birth`),`lastname`,`firstname`";
    $result = mysql_query ($sql);
    // de jarigen toevoegen in de lijst op het scherm....
    while (list($naam, $voornaam, $maand, $dag) = mysql_fetch_row ($result))
    {
        if ($maand == strftime ("%m"))
        {
            echo $dag . '/' . $maand . ' ' . $voornaam . ' ' . $naam . '<br>';
        }
    }
    echo '</div></div>';

    echo '</div>';

    // -------------------------------------------------------------
}
?>