<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Display;
use common\libraries\DatetimeUtilities;
use common\libraries\Theme;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($departmentStruc) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Display::display_error_message(get_lang("msgNoDepartmentMember"), false);
}
else
{//only users assigned to a department and platform administrator is allowed here...


    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $action = campus::get_POST_GET("action");
    $submitmessage = campus::get_POST_GET("submitmessage");
    $message_id = intval(campus::get_POST_GET("message_id"));
    $date = intval(campus::get_POST_GET("date"));
    $title = ereg_replace("\"", "'", campus::get_POST_GET("title"));
    $content = campus::get_POST_GET("content", "", false);
    $from = campus::get_POST_GET("from");
    $list = campus::get_POST_GET("list", key($departmentStruc));
    $to = campus::get_POST_GET("to");
    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */
    if ($submitmessage == "")
    {
        switch ($action)
        {
            case "new" :
                {
                    $message_id = "";
                    //$title=;
                    $date = time();
                    $from = "";
                    if ($to != "")
                    {
                        $userinfo = campus::get_user_info(intval($to));
                        $list_to['user'][intval($to)] = $userinfo['official_code'];
                    }
                    $content = "";
                    $display = "form";
                }
                break;
            case "update" :
                {
                    // De gegevens van het bericht inlezen.
                    $query = 'select * FROM `campus_messageboard` WHERE `id`=' . $message_id . ' ';
                    $result = mysql_query($query);
                    list($message_id, $title, $date, $from, $content, $department_id) = mysql_fetch_row($result);
                    // de bestemmeling voor dit bericht uit de tabel halen...
                    $list_to = campus::get_message_to($message_id);
                    $display = "form";
                }
                break;
            case "delete" :
                {
                    // de geadresseerde klassen verwijderen...
                    $result = mysql_query('DELETE FROM `campus_message_rel_group` WHERE `message_id`=' . $message_id . '');
                    // de geadresseerde gebruikers verwijderen...
                    $result = mysql_query('DELETE FROM `campus_message_rel_user` WHERE `message_id`=' . $message_id . '');
                    // het bericht zelf verwijderen.....
                    $result = mysql_query('DELETE FROM `campus_messageboard` WHERE `id`=' . $message_id . '');
                    $message = get_lang("msgMsgDeleted");
                    $display = "list";
                }
                break;
            case "renew" :
                {
                    $query = 'UPDATE `campus_messageboard` SET
						`date`=' . time() . '
						WHERE `id`=' . $message_id;
                    $result = mysql_query($query);
                    $message = get_lang("msgMsgVisible");
                    $display = "list";
                }
                break;
            case "hide" :
                {
                    $query = 'UPDATE `campus_messageboard` SET
						`date`=' . strtotime('-2 week -1 day') . '
						WHERE `id`=' . $message_id;
                    $result = mysql_query($query);
                    $message = get_lang("msgMsgHidden");
                    $display = "list";
                }
                break;
            default:
                {
                    $display = "list";
                    $message = get_lang("msgMsgHint");
                }
                break;
        }
    }
    else
    {
        switch ($action)
        {
            case "new" :
                {
                    $query = 'INSERT `campus_messageboard` SET
						`title`="' . $title . '",
						`date`=' . $date . ',
						`user_id`=' . $from . ',
						`content`="' . addslashes($content) . '"';
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgMsgAddError");
                        $display = "form";
                    }
                    else
                    {
                        $message_id = mysql_insert_id();
                        campus::set_message_to($to, $message_id);
                        if ($result)
                        {
                            $message = get_lang("msgMsgAddSucces");
                            $display = "list";
                        }
                    }
                }
                break;
            case "update" :
                {
                    $query = 'UPDATE
					`campus_messageboard` SET
					`title`="' . $title . '",
					`date`=' . $date . ',
					`user_id`="' . $from . '",
					`content`="' . addslashes($content) . '"
					WHERE `id`=' . $message_id . '';
                    $result = mysql_query($query);
                    if (!$result)
                    {
                        $message = get_lang("msgMsgEditError");
                        $display = "form";
                    }
                    else
                    {
                        campus::set_message_to($to, $message_id);
                        $message = get_lang("msgMsgEditSucces");
                        $display = "list";
                    }
                }
                break;
        }
    }
    /*
      ==============================================================================
      DISPLAY
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }
    /*
      -----------------------------------------------------------
      Infoboard ....
      -----------------------------------------------------------
     */
    if ($display == 'form')
    {
        // ===============================================================
        // Het bericht formulier weergeven.........
        // ===============================================================
        echo '<script language="JavaScript" xml:space="preserve">
		<!-- 
		 function updateLeftChars()
		  {
		   max_len = 1024
		   msg_text = document.myform.content.value
		   msg_len = msg_text.length
		   if (msg_len > max_len)
		    {
		     document.myform.content.value = msg_text.substring(0, max_len)
		     document.myform.counter.value = 0
		    }
		   else
		    document.myform.counter.value = (max_len - msg_len)
		  }
		-->
		</script>';
        echo '<form method="post" action="' . $this->get_url() . '" name="myform">';
        echo '<input type="hidden" name="message_id" value="' . $message_id . '" >';
        echo '<input type="hidden" name="from" value="' . $_uid . '" >';
        echo '<input type="hidden" name="action" value="' . $action . '" >';
        echo '<input type="hidden" name="page" value="editmessage" >';
        echo '<table>
			<tr valign="top">
				<td colspan="2">
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
					' . get_lang("labelDate") . '
				</td>
				<td>
					<input type="hidden" name="date"  value="' . $date . '" readonly/>
					<input type="text" size="12" value="' . DatetimeUtilities::format_locale_date('%Y-%m-%d',$date) . '" readonly/>
					<br />
				</td>
				<td>
					' . get_lang("txtMsgIsVisible4") . '
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
					' . get_lang("labelSelect") . '
				</td>
				<td>
					<select name="list" OnChange="javascript:myform.submit();">
						<option value="complete" ' . (($list == "complete") ? "SELECTED" : "") . '>' . get_lang("txtAllTeachersAllDepartments") . '</option>';
        foreach ($departmentStruc as $department_id => $departmentinfo)
        {
            echo "<option value=\"" . $department_id . "\" " . (($list == $department_id) ? 'SELECTED' : '') . ">" . $departmentinfo['code'] . "</option>";
        }
        echo '			</select>
				</td>
				<td>
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
					' . get_lang("labelTo") . '
				</td>
				<td>
					<select name="to[]" multiple="multiple" SIZE="7" >';
        // De geselecteerde collega's vooraan in de lijst plaatsen.
        foreach ($list_to['user'] as $id => $value)
        {
            $userinfo = campus::get_user_info($id);
            echo "<option value=\"u" . $id . "\" SELECTED>" . $value . ": " . $userinfo['lastName'] . " " . $userinfo['firstName'] . "</option>";
        }
        // De geselecteerde klassen vooraan in de lijst plaatsen.
        foreach ($list_to['class'] as $id => $value)
        {
            echo "<option value=\"c" . $id . "\" SELECTED>" . $value . "</option>";
        }

        // de platform beheerder toevoegen als te adresseren persoon
        $query = "SELECT DISTINCT `user_user`.`id`,`lastname`, `firstname`, `official_code` FROM `user_user` WHERE `admin`=1 LIMIT 1 ";
        $result = mysql_query($query);
        $rij = mysql_fetch_array($result, MYSQL_ASSOC);
        echo "<option value=\"u" . $rij['id'] . "\">" . get_lang("txtPlatformAdmin") . ": " . $rij['lastname'] . " " . $rij['firstname'] . "</option>";

        // de teacher keuzelijst samenstellen, deze is afhankelijk van $list
        $query = "SELECT DISTINCT `user_user`.`id`,`lastname`, `firstname`, `official_code`
			FROM `group_group_rel_user`
       				INNER JOIN `user_user`
       					ON `user_user`.`id` = `group_group_rel_user`.`user_id`
              			INNER JOIN `group_group`
       					ON `group_group`.`id` = `group_group_rel_user`.`group_id`
   						WHERE (";
        $filter = "";
        if ($list == "complete")
        {
            echo "<option value=\"complete\" " . ((strpos($list_to, "complete") != false) ? "SELECTED" : "") . ">" . get_lang("txtAllTeachersAllDepartments") . "</option>";
            $query2 = "SELECT DISTINCT `group_id`,`code`	FROM `campus_department_rel_group`
               				INNER JOIN `group_group`
               					ON `group_group`.`id` = `campus_department_rel_group`.`group_id` AND `type`=1";
            $result2 = mysql_query($query2) or die(mysql_error());
            while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
            {
                echo "<option value=\"c" . $rij2['group_id'] . "\">" . get_lang("txtAllTeachers") . $rij2['code'] . "</option>";
                // volledige scholengemeenschap al de teachersclasses toevoegen...
                $filter.=" `group_group_rel_user`.`group_id` = " . $rij2['group_id'] . " OR ";
            }
            $filter = substr($filter, 0, -3);
            $sql = $query . $filter . ") ORDER BY  `group_group`.`code`,`lastname`,`firstname`";
            $result = mysql_query($sql) or die (mysql_error());
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                if (empty($list_to['user'][$rij['id']]))
                {
                    echo "<option value=\"u" . $rij['id'] . "\">" . $rij['official_code'] . ": " . $rij['lastname'] . " " . $rij['firstname'] . "</option>";
                }
            }
        }
        else
        {
            // al de personeels klassen van de department selecteren....
            $classes = campus::get_teacherclasses($list);
            foreach ($classes as $class_id => $classinfo)
            {

                echo "<optgroup label=\"" . $classinfo['code'] . "\">";
                echo "<option value=\"c" . $class_id . "\">" . get_lang("txtAllTeachers") . $classinfo['code'] . "</option>";
                $sql = $query . " `group_group_rel_user`.`group_id` = " . $class_id . ") ORDER BY  `group_group`.`code`,`lastname`,`firstname`";
                $result = mysql_query($sql);
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    if (empty($list_to['user'][$rij['id']]))
                    {
                        echo "<option value=\"u" . $rij['id'] . "\">" . $rij['official_code'] . ": " . $rij['lastname'] . " " . $rij['firstname'] . "</option>";
                    }
                }
                echo "</optgroup>";
            }
        }

        if ($list != "complete")
        { // als een bepaalde department is gekozen heeft men ook de mogelijkheid om een bepaalde klas van die department te kiezen.
            echo "<optgroup label=\"" . get_lang("txtStudents") . "\">";
            echo "<option value=\"l" . $list . "\" >" . get_lang("txtAllStudents") . $departmentStruc[$list]['code'] . "</option>";
            $query2 = "SELECT DISTINCT `group_id`,`code` FROM `campus_department_rel_group`
              				INNER JOIN `group_group`
               					ON `group_group`.`id` = `campus_department_rel_group`.`group_id`
       					WHERE `department_id`=" . $list;
            $result2 = mysql_query($query2);
            while ($rij = mysql_fetch_array($result2, MYSQL_ASSOC))
            {
                echo "<option value=\"c" . $rij['group_id'] . "\">" . get_lang("txtAllStudents") . $rij['code'] . "</option>";
            }
            echo "</optgroup>";
        }
        echo '			</select>
				</td>
				<td>
    			' . get_lang('txtMultipleSelect') . '
				</td>
			</tr>
			<tr valign="top">
				<td  align="right">
	   			' . get_lang('labelSubject') . '
				</td>
				<td colspan="2">
					<input type="text" name="title" size="32" maxlength="64" value="' . stripslashes($title) . '" />
					<br />
				</td>
			</tr>
			<tr valign="top">
				<td align="right">
					<br>' . get_lang('labelContent') . '<br><br><br>
					<br>' . get_lang('labelCharsLeft') . '<br>(<input readonly name="counter" size="2" style="border:none">)<br />
				</td>
				<td  colspan="2">
					<textarea name="content" onBlur="updateLeftChars()" onChange="updateLeftChars()" onFocus="updateLeftChars()" onKeyUp="updateLeftChars()" rows="7" cols="60" style="font-family: arial;font-size:12px;">' . $content . '</textarea>
			 	</td>
				<td >
				</td>
			</tr>
			<tr valign="top">
				<td>
				</td>
				<td colspan="2">
					<input type="submit" name="submitmessage" value="' . get_lang("buttonlabelOK") . '" >&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang("buttonlabelCancel") . '" onMouseDown="javascript:document.myform.action.value=\'list\';">
				</td>
			</tr>
			</table>
			</form>';
    }
    else
    {
        // ===============================================================
        // PERSOONLIJKE berichtenlijst weergeven........
        // ===============================================================
        $query = "select * FROM `campus_messageboard` WHERE `user_id`=" . $_uid . " order by date";
        $result = mysql_query($query);
        //echo "<b>".get_lang("txtMsg")."</b><br><br>";
        echo "<div style=\"float: right\">";
        echo "<a href=\"" . $this->get_url() . "&page=editmessage&action=new\">" . get_lang("txtAddMsg") . "</a>";
        echo "</div>";
        echo "<br clear=\"all\">";

        campus::display_complex_table_header($properties, array(get_lang("colheadDate"), get_lang("colheadTo"), get_lang("colheadSubject"), get_lang("colheadMsgState"), ""));
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $icon = ($rij['date'] >= strtotime('-2 week')) ? "visible" : "invisible";
            $data = array();
            $data[] = DatetimeUtilities::format_locale_date('%Y-%m-%d',$rij['date']);
            $to = campus::get_message_to($rij['id']);
            $list_to = "";
            foreach ($to['class'] as $key => $value)
            {
                $list_to.=" " . $value . ", ";
            }
            foreach ($to['user'] as $key => $value)
            {
                $list_to.=" " . $value . ", ";
            }
            $list_to = substr($list_to, 0, -2);
            $data[] = $list_to;
            $data[] = $rij['title'];
            $data[] = DatetimeUtilities::format_locale_date('%Y-%m-%d', ($rij['date'] + (2 * 7 * 24 * 3600))) . "&nbsp;/&nbsp;" . DatetimeUtilities::format_locale_date('%Y-%m-%d', ($rij['date'] + (4 * 7 * 24 * 3600)));
            if ($rij['date'] >= strtotime('-4 week'))
            {
                $data[] = '<a href="' . $this->get_url() . '&page=editmessage&message_id=' . $rij['id'] . '&action=' . (($icon == 'visible') ? 'hide' : 'renew') . '" title="' . (($icon == 'visible') ? get_lang("tooltipHideMsg") : get_lang("tooltipShowMsg")) . '"><img src="' . Theme::get_image_path('application\campus') . $icon . '.gif" border=0 align="absmiddle" ></a>' .
                        '&nbsp;<a href="' . $this->get_url() . '&page=editmessage&message_id=' . $rij['id'] . '&action=update" title="' . get_lang("tooltipEditMsg") . '"><img src="' . Theme::get_image_path('application\campus') . 'edit.gif" border=0 align="absmiddle"></a>' .
                        '&nbsp;<a href="' . $this->get_url() . '&page=editmessage&message_id=' . $rij['id'] . '&action=delete" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmDeleteMsg") . '\')) return false;"  title="' . get_lang("tooltipDeleteMsg") . '"><img src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="absmiddle"></a>' .
                        '&nbsp;<a href="' . $this->get_url() . '&page=message2pdf&message_id=' . $rij['id'] . '" title="' . get_lang("tooltip2Pdf") . '"><img src="' . Theme::get_image_path('application\campus') . 'file_pdf.gif\" border=0 align="absmiddle"></a>';
            }
            else
            {
                $data[] = "<b style=\"color: red;\">" . get_lang("txtDeleted") . "<b>";
            }
            campus::display_table_row($bgcolor, $data, true);
        }
        campus::display_table_footer();
        $result = mysql_query('DELETE `campus_messageboard`, `campus_message_rel_user`, `campus_message_rel_group` FROM `campus_messageboard` LEFT JOIN `campus_message_rel_user` ON `campus_messageboard`.`id`=`campus_message_rel_user`.`message_id` LEFT JOIN `campus_message_rel_group` ON `campus_messageboard`.`id`=`campus_message_rel_group`.`message_id` WHERE `campus_messageboard`.`user_id`=' . $_uid . ' AND `date`<' . strtotime("-4 week") . '');
    }
}
?>