<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Path;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) && !($is_teacher))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...

   include(Path :: get_web_application_path('campus') . '/old_php/php_pdf/class.ezpdf.php');
    /*
      ==============================================================================
      POST en GET vars inlezen...
      ==============================================================================
     */
    $department_id = intval(campus::get_SESSION("department_id"));
    $submitmessage = campus::get_POST_GET("submitmessage");
    /*
      ==============================================================================
      Info maken
      ==============================================================================
     */
    $monday = strtotime('Next Monday', strtotime('-1 Week', time()));
    // Pagina instellingen
    $pdf = & new \Cezpdf('a4', 'landscape');
    $pdf->ezSetCmMargins(2, 2, 2, 2);
    $pdf->selectFont(Path :: get_web_application_path('campus') . '/old_php/php_pdf/fonts/Times-Roman.afm');
    //koptekst en voettekst
    $pdf->ezStartPageNumbers(820, 575, 12, 'left', 'pagina {PAGENUM} van {TOTALPAGENUM}', 1);
    $pdf->ezStartPageNumbers(820, 15, 10, 'left', DatetimeUtilities::format_locale_date('%A %d %B %Y',time()), 1);
    $pdf->ezStartPageNumbers(40, 15, 10, 'right', 'ook op de website: http://www.de-spil.be', 1);
    //Titel samenstellen
    if ($submitmessage == "")
    {
        $query = "SELECT `pdfinfostart`, `pdfinfoend`, `pdfinfonumber`, `pdfinfofooter` FROM `campus_department` WHERE `id`=" . $department_id . " LIMIT 1";
        $result = mysql_query($query);
        list($pdfinfostart, $pdfinfoend, $pdfinfonumber, $pdfinfofooter) = mysql_fetch_row($result);
    }
    else
    {
        $pdfinfostart = intval(strtotime(campus::get_POST_GET('pdfinfostart')));
        $pdfinfoend = intval(strtotime(campus::get_POST_GET('pdfinfoend')));
        $pdfinfonumber = intval(campus::get_POST_GET('pdfinfonumber'));
        $pdfinfofooter = campus::get_POST_GET('pdfinfofooter');
        $result = mysql_query('UPDATE `campus_department` SET `pdfinfostart`=' . $pdfinfostart . ', `pdfinfoend`=' . $pdfinfoend . ', `pdfinfonumber`="' . $pdfinfonumber . '", `pdfinfofooter`="' . $pdfinfofooter . '" WHERE `id`=' . $department_id);
    }
    $pdf->ezStartPageNumbers(40, 575, 12, 'right', "<b>INFO " . $pdfinfonumber . ": van " . DatetimeUtilities::format_locale_date('%A %d %B', $pdfinfostart) . " tot en met " . DatetimeUtilities::format_locale_date('%A %d %B %Y', $pdfinfoend) . "</b>");

    //eigenlijke info
    $pdf->ezColumnsStart(array('num' => 2, 'gap' => 20));
    $query = "SELECT * FROM `campus_info` WHERE `date`>=" . $pdfinfostart . " AND `department_id`=" . $department_id . " ORDER BY `date`";
    $result = mysql_query($query);
    $aantal = mysql_num_rows($result);
    $vorige_datum = '';
    $kop1 = false;
    $kop2 = false;
    $kop3 = false;
    while (list($info_id, $date, $studentinfo, $teachersinfo) = mysql_fetch_row($result))
    {
        $tekst = "";
        $titel = "";
        if ($date >= $pdfinfostart)
        { //Info van deze week, header ��nmaal schrijven ...
            if ($vorige_datum != $date)
            { //nieuwe info?, nieuwe cel en datum schrijven...
                if ((strftime("%W", $date) == strftime("%W", $pdfinfostart)) AND !$kop1)
                { //Info van deze week, header ��nmaal schrijven ...
                    $titel = "<b><u>AGENDA </u></b>\n";
                    $kop1 = true;
                }
                else
                {
                    if ($date > $pdfinfoend AND !$kop3)
                    { //Info van vooruitzichten, header ��nmaal schrijven ...
                        $titel.="\n<b><u>VOORUITZICHTEN  </u></b>\n";
                        $kop3 = true;
                    }
                }
                $titel.="\n<b><u>" . DatetimeUtilities::format_locale_date('%a %d/%m', $date) . "</u></b>";
                $vorige_datum = $date;
            }
            $pdf->transaction('start');
            $pos = $pdf->ezPosY();
            if ($titel != "")
            {
                $pdf->ezText($titel);
            }
            $pdf->ezSetDy(-4);
            $pdf->addText(($pdf->ezPosX() - 5), ($pdf->ezPosY()) - 10, 50, ".");
            if ($studentinfo != "")
            {
                $tekst.=strip_tags($studentinfo);
                if ($teachersinfo != "")
                {
                    $tekst.="\n";
                }
            }
            if ($teachersinfo != "")
            {
                $tekst.=strip_tags($teachersinfo);
            }
            if ($pdf->ezText(utf8_decode($tekst), '', array('left' => 10)) > $pos)
            {
                $pdf->transaction('rewind');
                $pdf->ezNewPage();
                if ($titel != "")
                {
                    $pdf->ezText($titel);
                    $pdf->ezSetDy(-4);
                }
                $pdf->addText(($pdf->ezPosX() - 5), ($pdf->ezPosY()) - 10, 50, ".");
                $pdf->ezText(utf8_decode($tekst), '', array('left' => 10));
            }
            $pdf->transaction('commit');
        }
    }
    $pdf->ezText("\n");

    /*
      ==============================================================================
      Aandachtspunten maken
      ==============================================================================
     */

    $query = "SELECT * FROM `campus_attentionpoint` WHERE `display_order`>0 AND `department_id`=" . $department_id . " ORDER BY `display_order`";
    $result = mysql_query($query);
    $aantal = mysql_num_rows($result);
    $tekst = "<b><c:uline>AANDACHTSPUNTEN </c:uline></b>\n";
    while (list($attention_id, $order, $title, $content ) = mysql_fetch_row($result))
    {
        $tekst.="\n<b><u>" . $order . ": " . $title . "</u></b>\n";
        $tekst.=strip_tags($content);
        $pdf->transaction('start');
        $pos = $pdf->ezPosY();
        $pos2 = $pdf->ezText(utf8_decode($tekst));
        if (($pos2 > $pos))
        {
            $pdf->transaction('rewind');
            $pdf->ezNewPage();
            $pdf->ezText(utf8_decode($tekst));
        }
        $pdf->transaction('commit');
        $tekst = "";
    }
    $pdf->ezText("\n\n\n" . $pdfinfofooter, '', array('justification' => 'centre'));
    $pdf->ezStream();
}
?>