<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\PlatformSetting;
use common\libraries\Theme;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($is_teacher) && !$is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);
    $action = campus::get_POST_GET('action', 'objectivetrackinglist');
    $submitmessage = campus::get_POST_GET('submitmessage');
    $objective_tracking_id = intval(campus::get_POST_GET('objective_tracking_id'));
    $yeartab = campus::get_SESSION("yeartab", $academicYear); // store in session...

    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */

    if ($submitmessage == '')
    { //
        switch ($action)
        {
            case "deleteobjectivetracking" :
                {
                    // delete infos
                    $result = mysql_query("DELETE FROM `campus_objective_tracking_info` WHERE `objective_tracking_id`=" . $objective_tracking_id);
                    // delete objective relations
                    $result = mysql_query("DELETE FROM `campus_objective_tracking_rel_objective` WHERE `objective_tracking_id`=" . $objective_tracking_id);
                    // delete Teacherrelations
                    $result = mysql_query("DELETE FROM `campus_objective_tracking_rel_teacher` WHERE `objective_tracking_id`=" . $objective_tracking_id);

                    // 	Delete student trackings...
                    //******
                    $query = 'SELECT `user_id` FROM `campus_objective_tracking_rel_group`
				INNER JOIN `group_group` ON `group_code`=`group_group`.`code`
                                INNER JOIN `group_group_rel_user` ON  `group_group`.`id`=`group_group_rel_user`.`group_id`
					WHERE `objective_tracking_id`=' . $objective_tracking_id . ' ';
                    $result = mysql_query($query) or die(mysql_error());
                    while (list($student_id) = mysql_fetch_row($result))
                    {
                        // remove existing objective tracking
                        $result2 = mysql_query('DELETE FROM `campus_student_tracking` WHERE
						`student_id`=' . $student_id . ' AND
						`tracking_title`="objectivetracking" AND
						`content` like "' . $objective_tracking_id . ';%"');
                    }
                    // delete class relations
                    $result = mysql_query("DELETE FROM `campus_objective_tracking_rel_group` WHERE `objective_tracking_id`=" . $objective_tracking_id);

                    // delete objective tracking
                    $result = mysql_query("DELETE FROM `campus_objective_tracking` WHERE `id`=" . $objective_tracking_id);

                    $message = get_lang("msgItemDeleted");
                    $action = "objectivetrackinglist";
                }
                break;
        }
    }


    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }
    $classes = campus::get_studentclasses($department_id);

    echo "<br clear=\"all\"><div id='lvs_tabs'><ul>";
    $currentYear = $academicYear;
    $query = "SELECT DISTINCT IF(MONTH(FROM_UNIXTIME(`date`))<9,CONCAT_WS('-',YEAR(FROM_UNIXTIME(`date`))-1,YEAR(FROM_UNIXTIME(`date`))),CONCAT_WS('-',YEAR(FROM_UNIXTIME(`date`)),YEAR(FROM_UNIXTIME(`date`))+1)) as ac_year FROM `campus_objective_tracking`
						WHERE `department_id`=" . $department_id . " ORDER BY `date`";
    $result = mysql_query($query) or die(mysql_error());
    while (list ($ac_year) = mysql_fetch_row($result))
    {
         if ($yeartab != $ac_year)
        {
            echo "<li ><a href='" . $this->get_url() . "&yeartab=" . $ac_year . "' title='" . get_lang("tooltipShow") . "  " . $ac_year . "'>" . $ac_year . "</a></li>";
        }
        else
        {
            $currentYear = $ac_year;
            echo "<li id='current'><a href='#' title='" . get_lang("tooltipShow") . " " . $ac_year . "'>" . $ac_year . "</a></li>";
        }
        $lastYear = $ac_year;
    }
    // wenn a new academic year is startet, no entrance is written to the database, it is necessary to force the year selection.
    if ($academicYear > $lastYear)
    { // The active academic year is not found in database...
        if ($academicYear != $currentYear)
        { //
            echo "<li ><a href='" . $this->get_url() . "&yeartab=" . $academicYear . "' title='" . get_lang("tooltipShow") . " " . $academicYear . "'>" . $academicYear . "</a></li>";
        }
        else
        {
            echo "<li id='current'><a href='#' title='" . get_lang("tooltipShow") . " " . $academicYear . "'>" . $academicYear . "</a></li>";
        }
    }

    echo "</ul></div><br clear=\"all\">";

    // ===============================================================
    // show objective types
    // ===============================================================
    $query = 'SELECT `campus_objective_tracking`.`id`, `teacher_code`, `name`, `comment`, `date` , `content` as "sortdate" FROM `campus_objective_tracking`
							LEFT JOIN `campus_objective_tracking_info` ON `objective_tracking_id`=`campus_objective_tracking`.`id` AND `varname`="datum"
							WHERE `department_id`=' . $department_id . '
								AND `date` >=' . mktime(0, 0, 0, 7, 1, substr($currentYear, 0, 4)) . '
								AND `date` <=' . mktime(0, 0, 0, 8, 31, substr($currentYear, 5, 4)) . '
								ORDER BY `sortdate`';
    $result = mysql_query($query) or die(mysql_error());
    echo "<div style=\"float:right;\">";
    echo "&nbsp;";
    echo "</div>";
    echo "<div >";
    echo "<a href=\"" . $this->get_url() . "&page=editobjectivetracking&action=addobjectivetracking\">" . get_lang("txtAddobjectiveTracking") . "</a>&nbsp;";
    if ((isset($admin['objectiveTrackingLevel0']) && $admin['objectiveTrackingLevel0']) || ($is_platformadmin) || (isset($admin['objectiveTrackingLevel1']) && $admin['objectiveTrackingLevel1']))
    {
        echo '|&nbsp;<a href="' . $this->get_url() . '&page=objectivetrackingstats">' . get_lang('txtObjectiveTrackingStats') . '</a>&nbsp;';
    }
    echo "</div>";
    campus::display_complex_table_header($properties, array(get_lang("colheadDate"), get_lang("colheadObjectiveTracking"), get_lang("colheadTeacher"), get_lang("colheadClasses"), get_lang("colheadApproved"), get_lang("colheadEvaluated"), ""));
    $nbrLines = mysql_num_rows($result);
    $line = 0;
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        $line++;
        $data = array();
        $info = array();
        // get extra activity details...
        $query2 = "SELECT `varname`, `content`  FROM `campus_objective_tracking_info`
 							WHERE `objective_tracking_id`=" . $rij['id'] . " "; //***
        $result2 = mysql_query($query2);
        while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
        {
            $info[$rij2['varname']] = $rij2['content'];
        }
        // get groups
        $grouplist = '';
        $totaal = 0;
        $query2 = "SELECT `group_code` FROM `campus_objective_tracking_rel_group`
									WHERE `objective_tracking_id`=" . $rij['id'] . " ";
        $result2 = mysql_query($query2);
        while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
        {
            $grouplist.= $rij2['group_code'] . ', ';
        }
        if ($grouplist == ', ')
        {
            $selectgroups = get_lang("noGroupsSelected");
        }
        else
        {
            $selectgroups = substr($grouplist, 0, -2) . ' ';
        }
        $data['date'] = DatetimeUtilities::format_locale_date('%Y-%m-%d', $rij['date']);
        $data['name'] = '<a href="' . $this->get_url() . '&page=viewobjectivetracking&objective_tracking_id=' . $rij['id'] . '" title="' . $rij['comment'] . '">' . $rij['name'] . '&nbsp;<img src="' . Theme::get_image_path('application\campus') . 'info3.gif" border=0 align="absmiddle" /></a>';
        $data['teacher_code'] = $rij['teacher_code'];
        $data['groups'] = $selectgroups;
        $data['approved'] = ($info['approval'] == 'approved') ? '<div style="width:100%;text-align:center;"><img src="' . Theme::get_image_path('application\campus') . 'right.gif" border=0 align="absmiddle" /></div>' : '';
        $data['evaluate'] = ($info['evaluationdate'] != '') ? '<div style="width:100%;text-align:center;"><a href="' . $this->get_url() . '&page=viewobjectivetracking&objective_tracking_id=' . $rij['id'] . '" title="' . get_lang('tooltipViewObjectiveTracking') . '"><img src="' . Theme::get_image_path('application\campus') . 'right.gif" border=0 align="absmiddle" /></a></div>' : '&nbsp;';
        if (((($teacher['official_code'] == $rij['teacher_code']) || (isset($admin['objectiveTrackingLevel0']) && $admin['objectiveTrackingLevel0'])) && ($academicYear === $currentYear) && ($info['evaluationdate'] == '')) || ($is_platformadmin))
        {
            $data['link'] = '<pre style="margin:0px;padding:0px;"><a href="' . $this->get_url() . '&page=editobjectivetracking&objective_tracking_id=' . $rij['id'] . '&action=editobjectivetracking" title="' . get_lang('tooltipEditObjectiveTracking') . '"><img src="' . Theme::get_image_path('application\campus') . 'edit.gif" border=0 align="absmiddle" /></a>' .
                    '&nbsp;<a href="' . $this->get_url() . '&objective_tracking_id=' . $rij['id'] . '&action=deleteobjectivetracking" onclick="javascript:if(!confirm(\'' . get_lang('msgboxConfirmDeleteObjectiveTracking') . '\')) return false;" title="' . get_lang('tooltipDeleteObjectiveTracking') . '"><img src="' . Theme::get_image_path('application\campus') . 'delete.gif" border=0 align="absmiddle" /></a>' .
                    '</pre>';
        }
        else
        {
            $data['link'] = '&nbsp;';
        }
        campus::display_table_row($bgcolor, $data, true);
    }
    campus::display_table_footer();
}
?>