<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\DatetimeUtilities;
use common\libraries\PlatformSetting;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($is_teacher) && !$is_platformadmin))
{// not allowed here!
    Display::display_error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $submitmessage = campus::get_POST_GET('submitmessage');
    $objective_tracking_id = intval(campus::get_POST_GET('objective_tracking_id'));
    $objective_subtype_id = intval(campus::get_POST_GET('objective_subtype_id'));
    $teacher_code = campus::get_POST_GET('teacher_code', $teacher['official_code']);
    $name = campus::get_POST_GET('name');
    $comment = campus::get_POST_GET('comment');
    $selectobjectives = campus::get_POST_GET('selectobjectives');
    $selectgroups = campus::get_POST_GET('groups');
    $selectteachers = campus::get_POST_GET('selectteachers');
    $date = campus::get_POST_GET('date', DatetimeUtilities::format_locale_date('%Y-%m-%d', time()));
    $info = campus::get_POST_GET('info');
    $classes = campus::get_studentclasses($department_id);
    $teachers = campus::get_teachers($department_id);

    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */

    if ($submitmessage == '')
    { //
        switch ($action)
        {
            case 'addobjectivetracking' :
                {
                    
                }
                break;
            case 'copy2new' :
            case 'editobjectivetracking' :
                {
                    // read data
                    $query = "SELECT `id`, `teacher_code`, `name`, `comment`,`date`  FROM `campus_objective_tracking`
 						WHERE `id`=" . $objective_tracking_id . " "; //***
                    $result = mysql_query($query);
                    list($objective_tracking_id, $teacher_code, $name, $comment, $date) = mysql_fetch_row($result); //***
                    // read in info's.....
                    $date = DatetimeUtilities::format_locale_date('%Y-%m-%d', $date);
                    $info = array();
                    $query = "SELECT `varname`, `content`  FROM `campus_objective_tracking_info`
 						WHERE `objective_tracking_id`=" . $objective_tracking_id . " "; //***
                    $result = mysql_query($query);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $info[$rij['varname']] = $rij['content'];
                    }

                    $query = "SELECT `group_code` FROM `campus_objective_tracking_rel_group`
 						WHERE `objective_tracking_id`=" . $objective_tracking_id . " ";
                    $result = mysql_query($query);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $array[] = trim($rij['group_code']);
                    }
                    $selectgroups = implode(';', $array);
                    $array = array();
                    $query = "SELECT `teacher_id` FROM `campus_objective_tracking_rel_teacher`
 						WHERE `objective_tracking_id`=" . $objective_tracking_id . " ";
                    $result = mysql_query($query);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $array[] = $rij['teacher_id'];
                    }
                    $selectteachers = implode(';', $array);
                    $array = array();

                    $query = "SELECT `campus_objective`.`id`, `objective_curriculum_id` FROM `campus_objective_tracking_rel_objective`
							INNER JOIN `campus_objective` ON `campus_objective`.`id`= `campus_objective_tracking_rel_objective`.`objective_id`
 						WHERE `objective_tracking_id`=" . $objective_tracking_id . "";
                    $result = mysql_query($query);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $array[$rij['objective_curriculum_id']][] = $rij['id'];
                    }
                    foreach ($array as $objective_curriculum_id => $array2)
                    {
                        $selectobjectives[$objective_curriculum_id] = implode(';', $array2);
                    }
                    if ($action == 'copy2new')
                    {
                        $teacher_code = $teacher['official_code'];
                        $objective_tracking_id = '';
                        $selectteachers = '';
                        $action = 'addobjectivetracking';
                        $warningmessage = get_lang("msgAttentionCheckBeforeAdding");
                    }
                    else
                    {
                        $warningmessage = get_lang("msgAttentionEvaluationInfoDeletion");
                    }
                }
                break;
        }
    }
    elseif ($submitmessage == 1)
    {

        if (campus::get_POST_GET('Group2Sub') == 'all')
        {
            foreach ($classes as $classid => $clasinfo)
            {
                $clascodes[trim($clasinfo['code'])] = $clasinfo['name'];
            }
            $selectgroups = implode(';', array_keys($clascodes));
        }
        elseif (campus::get_POST_GET('Group2Sub') != "")
        {
            $selectgroups.= ( ($selectgroups == '') ? '' : ';') . campus::get_POST_GET('Group2Sub');
        }
        elseif (campus::get_POST_GET('Group2UnSub') == 'all')
        {
            $selectgroups = '';
        }
        elseif (campus::get_POST_GET('Group2UnSub') != "")
        {
            $selectgroups = substr(str_replace(';' . campus::get_POST_GET('Group2UnSub') . ';', ';', ';' . $selectgroups . ';'), 1, -1);
        }
        elseif (intval(campus::get_POST_GET('objective2Sub')) > 0)
        {
            $array = explode(';', campus::get_POST_GET('objective2Sub'));
            $selectobjectives[$array[0]].= ( ($selectobjectives[$array[0]] == '') ? '' : ';') . intval($array[1]);
        }
        elseif (intval(campus::get_POST_GET('objective2UnSub')) > 0)
        {
            $array = explode(';', campus::get_POST_GET('objective2UnSub'));
            $selectobjectives[$array[0]] = substr(str_replace(';' . intval($array[1]) . ';', ';', ';' . $selectobjectives[$array[0]] . ';'), 1, -1);
        }
        elseif (intval(campus::get_POST_GET('Teacher2Sub')) > 0)
        {
            $selectteachers.= ( ($selectteachers == '') ? '' : ';') . intval(campus::get_POST_GET('Teacher2Sub'));
        }
        elseif (intval(campus::get_POST_GET('Teacher2UnSub')) > 0)
        {
            $selectteachers = substr(str_replace(';' . intval(campus::get_POST_GET('Teacher2UnSub')) . ';', ';', ';' . $selectteachers . ';'), 1, -1);
        }
    }
    else
    {
        switch ($action)
        {
            case 'addobjectivetracking' :
                {
                    if (($name != '') && (substr($date, 4, 1) == '-') && (substr($date, 7, 1) == '-'))
                    {
                        $query = 'INSERT `campus_objective_tracking` SET
					`teacher_code`="' . $teacher_code . '",
					`name`="' . $name . '",
					`comment`="' . $comment . '",
					`date`=' . strtotime($date) . ',
					`department_id`=' . $department_id . ' '; //***
                        $result = mysql_query($query);
                        if (!$result)
                        {
                            $message = get_lang('msgItemAddError');
                        }
                        else
                        {
                            $objective_tracking_id = mysql_insert_id();
                            // add classes to objective tracking
                            $array = explode(";", $selectgroups);
                            foreach ($array as $group_code)
                            {
                                if ($group_code != "")
                                {
                                    $result = mysql_query('INSERT `campus_objective_tracking_rel_group` SET `objective_tracking_id`=' . $objective_tracking_id . ', `group_code`="' . trim($group_code) . '"');
                                }
                            }
                            // add Teachers to objective tracking
                            $array = explode(";", $selectteachers);
                            foreach ($array as $id)
                            {
                                if (intval($id) > 0)
                                {
                                    $result = mysql_query('INSERT`campus_objective_tracking_rel_teacher` SET `objective_tracking_id`=' . $objective_tracking_id . ', `teacher_id`=' . $id);
                                }
                            }
                            // add Teachers to objective tracking
                            foreach ($info as $varname => $content)
                            {
                                if ((trim($varname) != '') && (trim($content) != ''))
                                {
                                    $result = mysql_query('INSERT `campus_objective_tracking_info` SET `objective_tracking_id`=' . $objective_tracking_id . ', `varname`="' . trim($varname) . '", `content`="' . trim($content) . '"');
                                }
                            }
                            // add objectives to objective tracking
                            foreach ($selectobjectives as $objective_subtype_id => $selectobjectives2)
                            {
                                if ($selectobjectives2 != '')
                                {
                                    $array = explode(";", $selectobjectives2);
                                    foreach ($array as $id)
                                    {
                                        if (intval($id) > 0)
                                        {
                                            $result = mysql_query('INSERT `campus_objective_tracking_rel_objective` SET `objective_tracking_id`=' . $objective_tracking_id . ', `objective_id`=' . $id);
                                        }
                                    }
                                }
                            }
                            $action = 'objectivetrackinglist';
                            include ('viewobjectivetracking.php');
                        
                        }
                    }
                    else
                    {
                        if ($name != '')
                        {
                            $errormessage = get_lang("msgDateError");
                        }
                        else
                        {
                            $errormessage = get_lang("msgMissingName");
                        }
                    }
                }
                break;
            case "editobjectivetracking" :
                {
                    if (($name != '') && (substr($date, 4, 1) == '-') && (substr($date, 7, 1) == '-'))
                    {
                        $query = 'UPDATE `campus_objective_tracking` SET
						`teacher_code`="' . $teacher_code . '",
						`name`="' . $name . '",
					    `date`=' . strtotime($date) . ',
						`comment`="' . $comment . '"
						WHERE `id`=' . $objective_tracking_id . ' '; //***
                        $result = mysql_query($query) or die(mysql_error());
                        if (!$result)
                        {
                            $message = get_lang("msgItemEditError");
                        }
                        else
                        {
                            // delete existing form rel classes....
                            $result = mysql_query("DELETE FROM `campus_objective_tracking_rel_group` WHERE `objective_tracking_id`=" . $objective_tracking_id);
                            // add classes to objective tracking
                            $array = explode(";", $selectgroups);
                            foreach ($array as $group_code)
                            {
                                if ($group_code != "")
                                {
                                    $result = mysql_query('INSERT `campus_objective_tracking_rel_group` SET `objective_tracking_id`=' . $objective_tracking_id . ', `group_code`="' . $group_code . '"');
                                }
                            }

                            // delete existing form rel classes....
                            $result = mysql_query("DELETE FROM `campus_objective_tracking_rel_teacher` WHERE `objective_tracking_id`=" . $objective_tracking_id);
                            // add Teachers to objective tracking
                            $array = explode(";", $selectteachers);
                            foreach ($array as $id)
                            {
                                if (intval($id) > 0)
                                {
                                    $result = mysql_query('INSERT `campus_objective_tracking_rel_teacher` SET `objective_tracking_id`=' . $objective_tracking_id . ', `teacher_id`=' . $id);
                                }
                            }
                            // delete existing form rel classes....
                            $result = mysql_query("DELETE FROM `campus_objective_tracking_info` WHERE `objective_tracking_id`=" . $objective_tracking_id);

                            foreach ($info as $varname => $content)
                            {
                                if ($varname != '')
                                {
                                    $result = mysql_query('INSERT `campus_objective_tracking_info` SET `objective_tracking_id`=' . $objective_tracking_id . ', `varname`="' . $varname . '", `content`="' . $content . '"');
                                }
                            }
                            // delete existing form rel classes....
                            $result = mysql_query("DELETE FROM `campus_objective_tracking_rel_objective` WHERE `objective_tracking_id`=" . $objective_tracking_id);
                            // add objectives to objective tracking
                            foreach ($selectobjectives as $objective_subtype_id => $selectobjectives2)
                            {
                                if (intval($selectobjectives2) != '')
                                {
                                    $array = explode(";", $selectobjectives2);
                                    foreach ($array as $id)
                                    {
                                        if (intval($id) > 0)
                                        {
                                            $result = mysql_query('INSERT `campus_objective_tracking_rel_objective` SET `objective_tracking_id`=' . $objective_tracking_id . ', `objective_id`=' . $id);
                                        }
                                    }
                                }
                            }
                            $message = get_lang('msgItemEditSucces');
                            $action = 'objectivetrackinglist';
                            include ('viewobjectivetracking.php');
                        }
                    }
                    else
                    {
                        if ($name != '')
                        {
                            $errormessage = get_lang("msgDateError");
                        }
                        else
                        {
                            $errormessage = get_lang("msgMissingName");
                        }
                    }
                }
                break;
        }
    }

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */



    switch ($action)
    {
        case 'addobjectivetracking' :
        case 'editobjectivetracking' :
            {
                if (!empty($errormessage))
                {
                    Display::error_message($errormessage, false);
                }
                elseif (!empty($warningmessage))
                {
                    Display::warning_message($warningmessage, false);
                }
                elseif (!empty($message))
                {
                    Display::normal_message($message, false);
                }

                // ===============================================================
                // Form to add/edit objective tracking
                // ===============================================================
                echo '<sup>(1)</sup>: wordt weergeven op de brief voor de ouders....<br>';
                echo '<form method="post" action="' . $this->get_url() . '" name="myform">
				<input type="hidden" name="page" value="editobjectivetracking" >
				<input type="hidden" name="action" value="' . $action . '" >
				<input type="hidden" name="objective_tracking_id" value="' . $objective_tracking_id . '" >
				<input type="hidden" name="submitmessage" value="1">
				<table>
					<tr valign="top">
						<td colspan="2">
						</td>
					</tr>
					<tr valign="top">
						<td align="right">
						Aanvrager:
						</td>
						<td>
							<input type="text" name="teacher_code" size="32"  value="' . $teacher_code . '" READONLY/>
						</td>
					</tr>
					<tr valign="top">
						<td align="right">
						Naam van de activiteit:<sup>(1)</sup>
						</td>
						<td>
							<input type="text" name="name" size="32"  value="' . stripslashes($name) . '" OnChange="javascript:submit();"/><b style="color:red;font-weight:bold;font-size:18px;">*</b>
						</td>
			   		</tr>';
                echo '<tr valign="top">
				   		<td  align="right">
					    	Omschrijving van de activiteit:<sup>(1)</sup>
					   	</td>
					   	<td>
							<textarea name="comment" style ="height:36px;" cols="80" >' . stripslashes($comment) . '</textarea>
					   	</td>
					 </tr>';
                echo ' <tr valign="top" id="">
				   <td  align="right">
					    Datum van de activiteit:<sup>(1)</sup>
					   </td>
					   <td>
							<input type="text" name="date" size="10"  value="' . $date . '" /><b style="color:red;font-weight:bold;font-size:18px;">*</b>(jjjj-mm-dd)
					   </td>
					 </tr>';
                echo '<tr valign="top">
				   		<td  align="right">
					    	Bijkomende informatie (vakgroep, ...):
					   	</td>
					   	<td>
							<textarea name="info[opmerking]" style ="height:36px;" cols="80" >' . stripslashes($info['opmerking']) . '</textarea>
					   	</td>
					 </tr>';
                echo ' <tr valign="top">
				   		<td  align="right">
					    	Type activiteit
					   	</td>
					   	<td>
							<select name="info[type]" style="width:230px;" OnChange="javascript:submit();">
										<option value="" selected>maak een keuze</option>';
                $select = array('extra-muros' => 'Een activiteit die niet in de eigenschool georganiseerd wordt, dikwijls is er vervoer voor nodig.', 'intra-muros' => 'Een activiteit die in de eigenschool georganiseerd wordt, er is geen extra vervoer nodig.'); //,'vak'=>'Wanneer je tijdens het schooljaar in je vak bepaalde voeten bereikt, kan je dat hier registreren.');
                foreach ($select as $option => $tooltip)
                {
                    echo '<option value="' . $option . '" ' . (($info['type'] == $option) ? 'selected' : '') . ' title="' . $tooltip . '">' . $option . '</option>';
                }
                echo'	</select>
						</td>
					 </tr>';
                if (($name != '') && ($info['type'] != ''))
                {
                    // ===========

                    echo ' <tr valign="top">
					   	<td  align="right">
						    Plaats:<sup>(1)</sup>
					   	</td>
					   <td>
							<input type="text" name="info[locatie]" size="32"  value="' . stripslashes($info['locatie']) . '" />
					   </td>
					 </tr>';
                    if ($info['type'] == 'extra-muros')
                    {

                        echo ' <tr valign="top">
				   		<td  align="right">
					    	Vertrek uur:<sup>(1)</sup>
					   	</td>
					   	<td>
							<input type="text" name="info[begin]" size="32"  value="' . $info['begin'] . '" />
					   	</td>
					 	</tr>';
                        echo ' <tr valign="top">
					   <td  align="right">
					     	Uur van terugkeer:<sup>(1)</sup>
					   </td>
					   <td>
							<input type="text" name="info[einde]" size="32"  value="' . $info['einde'] . '" />
					   </td>
					 </tr>';
                        echo ' <tr valign="top">
				   		<td  align="right">
					    	Vervoer:
					   	</td>
					   	<td>
							<select name="info[vervoer]" style="width:230px;" OnChange="javascript:submit();">
								<option value="" selected>maak een keuze</option>';
                        $select = array('autobus', 'openbaar vervoer', 'schoolbus', 'auto', 'fiets', 'te voet');
                        foreach ($select as $option)
                        {
                            echo '<option value="' . $option . '" ' . (($info['vervoer'] == $option) ? 'selected' : '') . '>' . $option . '</option>';
                        }
                        echo'	</select>
						</td>
					 </tr>';
                    }
                    else
                    {
                        echo ' <tr valign="top">
				   		<td  align="right">
					    	Begin van de activiteit:<sup>(1)</sup>
					   	</td>
					   	<td>
							<input type="text" name="info[begin]" size="32"  value="' . $info['begin'] . '" />
					   	</td>
					 	</tr>';
                        echo ' <tr valign="top">
					   <td  align="right">
					     	Einde van de activiteit:<sup>(1)</sup>
					   </td>
					   <td>
							<input type="text" name="info[einde]" size="32"  value="' . $info['einde'] . '" />
					   </td>
					 </tr>';
                    }
                    echo ' <tr valign="top" id="">
				   <td  align="right">
					    Materiaal benodigdheden:
					   </td>
					   <td>
							<textarea type="text" name="info[materiaal]" style ="height:36px;" cols="80" >' . stripslashes($info['materiaal']) . '</textarea>
							</td>
					 </tr>';
                    echo '	<tr valign="top">
						<td align="right">
						Meebrengen:<sup>(1)</sup>
						</td>
						<td>
							<textarea type="text" name="info[meebrengen]" style ="height:52px;" cols="80" >' . stripslashes($info['meebrengen']) . '</textarea>
						</td>
				   		</tr>';
                    echo '	<tr valign="top">
						<td align="right">
						Onkosten van de activiteit:<sup>(1)</sup>
						</td>
						<td>
							<input type="text" name="info[kost]" size="32"  value="' . $info['kost'] . '"/>
						</td>
				   		</tr>';
                    echo ' 		<tr valign="top">
				   		<td  align="right">
					    	Beschrijving van deze onkosten:<sup>(1)</sup>
					   	</td>
					   	<td>
							<textarea name="info[kostenomschrijving]" style ="height:52px;"" cols="60" >' . stripslashes($info['kostenomschrijving']) . '</textarea>
					   	</td>
					 </tr>';
                    echo ' <tr valign="top">
				   		<td  align="right">
					    	Betaling:<sup>(1)</sup>
					   	</td>
					   	<td>
							<select name="info[betalingswijze]" OnChange="javascript:submit();">
										<option value="" selected>maak een keuze</option>';
                    $select = array('De onkosten worden afgerekend via de schoolrekening.', 'Het geld van de onkosten meebrengen op de dag zelf.', 'Het geld van de onkosten meebrengen ',);
                    foreach ($select as $option)
                    {
                        echo '<option value="' . $option . '" ' . (($info['betalingswijze'] == $option) ? 'selected' : '') . '>' . $option . '</option>';
                    }
                    echo'	</select>
						</td>
					 </tr>';
                    if ($info['betalingswijze'] == 'Het geld van de onkosten meebrengen ')
                    {
                        echo '<tr valign="top">
				   		<td  align="right">
					    	Geld meebrengen:<sup>(1)</sup>
					   	</td>
					   	<td>
							<input type="tekst" name="info[geldmeebrengen]"  size="32"  value="' . $info['geldmeebrengen'] . '"/>
					   	</td>
					 </tr>';
                    }
                    echo ' <tr valign="top">
				   <td  align="right">
					    Begeleidende leerkrachten:
					   </td>
					   <td>
						<table>
					  		<tr>
							<td>
								<input type="hidden" name="selectteachers" value="' . $selectteachers . '">
								<select name="Teacher2UnSub" size="5" style="width:230px;" OnChange="javascript:submit();">';
                    //echo '<option value=""> </OPTION>';
                    $array = explode(";", $selectteachers);
                    foreach ($array as $id)
                    {
                        if (intval($id) > 0)
                        {
                            echo '<option value="' . $id . '" >' . $teachers[$id]['official_code'] . '</option>';
                        }
                    }
                    echo '   </select>
					</td>
					<td valign="middle">
					<h1><</h1>
					</td>
					<td>
					 <select name="Teacher2Sub" size="5" style="width:230px;" OnChange="javascript:submit();">';
                    foreach ($teachers as $key => $value)
                    {
                        if (!in_array($key, $array))
                        {
                            echo '<option value="' . $key . '">' . $teachers[$key]['official_code'] . '</option>';
                        }
                    }
                    echo '			</select>
						</td>
						</tr>
					</table>
					</td>
					</tr>';
                    // ===========
                    echo '<tr valign="top">
						<td  align="right">
						' . get_lang('labelClasses') . ':<sup>(1)</sup>
					</td>
					<td>
						<table>
					  		<tr>
							<td valign="top">
								<input type="hidden" name="groups" value="' . $selectgroups . '">
								<b style="float:right;color:red;font-weight:bold;font-size:18px;">*</b><select name="Group2UnSub" size="5" style="width:230px;" OnChange="javascript:submit();">';
                    echo '<option value="all">Alle klassen verwijderen</OPTION>';
                    $array = explode(";", $selectgroups);
                    foreach ($array as $group_code)
                    {
                        if ($group_code != "")
                        {
                            echo '<option value="' . $group_code . '" >' . $group_code . '</option>';
                        }
                    }
                    echo '   </select>
						</td>
						<td valign="middle">
						<h1><</h1>
						</td>
						<td valign="top">
					 	<select name="Group2Sub" size="5" style="width:230px;" OnChange="javascript:submit();">';
                    echo '<option value="all">Alle klassen toevoegen</OPTION>';
                    foreach ($classes as $key => $value)
                    {
                        if (!in_array($value['code'], $array))
                        {
                            echo '<option value="' . $classes[$key]['code'] . '">' . $classes[$key]['code'] . '</option>';
                        }
                    }
                    echo '			</select>
						</td>
					</tr>
					</table>
					</td>
					</tr>';
                    if ($selectgroups != '')
                    {
                        $query = 'SELECT `id`, `code`, `name`, `comment` FROM `campus_objective_curriculum`
                                        WHERE  `type`=1 ORDER BY `display_order`'; //only select VOET
                        $result = mysql_query($query);
                        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                        {
                            $filter = '(`group_group`.`code`="' . str_replace(';', '" OR `group_group`.`code`="', $selectgroups) . '")';
                            // check if objectives are configured for the selected groups....
                            $query2 = 'SELECT * FROM `campus_objective_curriculum_rel_group`
                                            INNER JOIN `group_group` ON `id` = `group_id`
                                            INNER JOIN `campus_department_rel_group` ON `campus_objective_curriculum_rel_group`.`group_id`=`campus_department_rel_group`.`group_id` AND `type`= 2
					WHERE `department_id`= ' . $department_id . ' AND `objective_curriculum_id`=' . $rij['id'] . ' AND ' . $filter . ' ';
                            $result2 = mysql_query($query2);
                            if (mysql_num_rows($result2) > 0)
                            {
                                echo ' <tr valign="top">
				   				<td  align="right">
								<a name="' . $rij['id'] . '"></a>
										' . get_lang('labelObjectives') . '
								</td>
					   			<td>
									<b>' . $rij['code'] . ' ' . $rij['name'] . '</b>
					   			</td>
					 		</tr>';
                                $array = explode(";", $selectobjectives[$rij['id']]);
                                $query2 = 'SELECT * FROM `campus_objective`
                                              WHERE `objective_curriculum_id`=' . $rij['id'] . ' ORDER BY `campus_objective`.`display_order`';
                                $result2 = mysql_query($query2);
                                $group1 = '';
                                $group2 = '';
                                $options2Sub = '';
                                $options2UnSub = '';
                                while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                                {
                                    if (!in_array($rij2['id'], $array))
                                    {
                                        if ($rij2['objective_group'] != $group1)
                                        {
                                            $group1 = $rij2['objective_group'];
                                            $options2Sub.='<optgroup label="' . $rij2['objective_group'] . '">';
                                        }
                                        $options2Sub.='<option value="' . $rij['id'] . ';' . $rij2['id'] . '" title="' . $rij2['code'] . ': ' . $rij2['objective'] . ($rij2['comment'] == '' ? '' : ' (' . $rij2['comment'] . ')') . '">' . $rij2['code'] . ': ...' . substr($rij2['objective'], 13) . '</OPTION>';
                                    }
                                    else
                                    {
                                        if ($rij2['objective_group'] != $group2)
                                        {
                                            $group2 = $rij2['objective_group'];
                                            $options2UnSub.='<optgroup label="' . $rij2['objective_group'] . '">';
                                        }
                                        $options2UnSub.='<option value="' . $rij['id'] . ';' . $rij2['id'] . '" title="' . $rij2['code'] . ': ' . $rij2['objective'] . ($rij2['comment'] == '' ? '' : ' (' . $rij2['comment'] . ')') . '">' . $rij2['code'] . ': ...' . substr($rij2['objective'], 13) . '</OPTION>';
                                    }
                                }
                                echo '<tr>
								<td  align="center">
								</td>
								<td>
									<table>
					  					<tr>
											<td>
												<input type="hidden" name="selectobjectives[' . $rij['id'] . ']" value="' . $selectobjectives[$rij['id']] . '">
												<select name="objective2UnSub" size="3" style="width:400px;" OnChange="javascript:myform.action=\'' . $this->get_url() . '#' . $rij['id'] . '\';submit();">';
                                //	echo '<option value=""> </OPTION>';
                                echo $options2UnSub;
                                echo '   				</select>
											</td>
											<td valign="middle">
												<h1><</h1>
											</td>
											<td>
					 							<select name="objective2Sub" size="3" style="width:400px;" OnChange="javascript:myform.action=\'' . $this->get_url() . '#' . $rij['id'] . '\';submit();">';
                                echo $options2Sub;
                                echo '			</select>
											</td>
										</tr>
									</table>
								</td>
							</tr>';
                            }
                        }
                        echo ' <tr valign="top" id="">
				   <td  align="right">
					    Vakgebonden eindtermen behaald:
					   </td>
					   <td>
							<textarea type="text" name="info[vakgebondeneindtermen]" style ="height:36px;" cols="80" >' . stripslashes($info['vakgebondeneindtermen']) . '</textarea>
							</td>
					 </tr>';
                        echo '  <tr valign="top">
					  <td>
					  </td>
					  <td colspan="2">
					   <input type="submit" name="submitmessage" value="' . get_lang('buttonlabelOK') . '" />&nbsp;&nbsp;<input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.page.value=\'\';document.myform.action.value=\'\';">
					  </td>
					 </tr>';
                    }
                    else
                    {
                        echo '  <tr valign="top">
						  	<td>
					  	</td>
						  <td colspan="2">';
                        Display::warning_message(get_lang('msgSelectClass2Complete'), false);
                        echo '	  </td>
						 </tr>';
                        echo '  <tr valign="top">
					  <td>
					  </td>
					  <td colspan="2">
					   <input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.page.value=\'\';document.myform.action.value=\'\';">
					  </td>
					 </tr>';
                    }
                }
                else
                {
                    echo '  <tr valign="top">
					  <td>
					  </td>
					  <td colspan="2">';
                    Display::warning_message('Vul de naam in van de activiteit en kies het type van activiteit!', false);
                    echo '	  </td>
					 </tr>';
                    echo '  <tr valign="top">
					  <td>
					  </td>
					  <td colspan="2">
					   <input type="submit" name="cancel" value="' . get_lang('buttonlabelCancel') . '" onMouseDown="javascript:document.myform.page.value=\'\';document.myform.action.value=\'\';">
					  </td>
					 </tr>';
                }

                echo '		</table>
					</form>';
            }
            break;
    }
}
?>