<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($is_teacher) && !$is_platformadmin && (isset($admin['objectiveTrackingLevel0']) && $admin['objectiveTrackingLevel0']) && (isset($admin['objectiveTrackingLevel1']) && $admin['objectiveTrackingLevel1'])))
{// not allowed here!
    Display::display_error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...
    /*
      ==============================================================================
      display header & breadcrumb...
      ==============================================================================
     */
    header('Content-Type: html/text; charset=UTF-8');
    header("Content-Disposition: attachment; filename=objectivetracking.xls");
    header("Pragma: no-cache");
    header("Expires: 0");
    echo '<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />';
    echo pack(“CCC”,0xef,0xbb,0xbf);
    echo '<style>.text  { mso-number-format:\@; }.datum  { mso-number-format:"dd\\\.mm\\\.yyyy"; }</style>';

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);
    $department_id = intval(campus::get_SESSION('department_id', key($departmentStruc)));
    $display = campus::get_POST_GET('display', 'schooloverzicht');
    $filterlines = intval(campus::get_POST_GET('filterlines', 1));
    $currentYear = campus::get_POST_GET('currentYear', $academicYear);
    $filterclass = campus::get_POST_GET('filterclass');
    $filterdepartment = campus::get_POST_GET('filterdepartment', array(1 => $department_id));
    $filteryear = campus::get_POST_GET('filteryear', array(1 => $academicYear));


    switch ($display)
    {
        case 'schooloverzicht':
            {
                $subquery = ' (SELECT DISTINCT `campus_objective_tracking_rel_objective`.`objective_tracking_id`, `objective_id` FROM `campus_objective_tracking_rel_objective`
					INNER JOIN  `campus_objective_tracking`
                                            ON `campus_objective_tracking`.`id`=`campus_objective_tracking_rel_objective`.`objective_tracking_id`
					WHERE	(`department_id`=' . $department_id . ' AND `date` >=' . mktime(0, 0, 0, 7, 1, substr($currentYear, 0, 4)) . ' AND `date` <=' . mktime(0, 0, 0, 8, 31, substr($currentYear, 5, 4)) . ')
									)';
            }
            break;
        case 'VOET traject':
            {
                $subfilter = '';
                for ($t = 1; $t < ($filterlines + 1); $t++)
                {
                    if ((intval($filterclass[$t]) <> 0) && ($filteryear[$t] != '') && (intval($filterdepartment[$t]) > 0))
                    {
                        $filter = ' (`date` >=' . mktime(0, 0, 0, 7, 1, substr($filteryear[$t], 0, 4)) . ' AND `date` <=' . mktime(0, 0, 0, 8, 31, substr($filteryear[$t], 5, 4)) . ' AND ';
                        if ($filterclass[$t] > 0)
                        {
                            $filter.='`group_code`="' . $filterclass[$t] . '") OR ';
                        }
                        else
                        {
                            $filter.='`department_id`=' . $filterdepartment[$t] . ') OR ';
                        }
                        $subfilter.=$filter;
                        $subquery2[$t] = ' SELECT DISTINCT `campus_objective_tracking_rel_objective`.`objective_tracking_id`, `objective_id` FROM `campus_objective_tracking_rel_objective`
									INNER JOIN  `campus_objective_tracking`
										ON `campus_objective_tracking`.`id`=`campus_objective_tracking_rel_objective`.`objective_tracking_id`
									INNER JOIN  `campus_objective_tracking_rel_group`
										ON `campus_objective_tracking`.`id`=`campus_objective_tracking_rel_group`.`objective_tracking_id`
									WHERE ' . (($filter == '') ? 'null' : substr($filter, 0, -3)) . '
											';
                    }
                }
                $subquery = ' (SELECT DISTINCT `campus_objective_tracking_rel_objective`.`objective_tracking_id`, `objective_id` FROM `campus_objective_tracking_rel_objective`
									INNER JOIN  `campus_objective_tracking`
										ON `campus_objective_tracking`.`id`=`campus_objective_tracking_rel_objective`.`objective_tracking_id`
									INNER JOIN  `campus_objective_tracking_rel_group`
										ON `campus_objective_tracking`.`id`=`campus_objective_tracking_rel_group`.`objective_tracking_id`
									WHERE ' . (($subfilter == '') ? 'null' : substr($subfilter, 0, -3)) . '
											)';
            }
            break;
    }

    /*
      ==============================================================================
      Actualiseer de gegevens van het formulier en de database......
      ==============================================================================
     */
    $departments = campus::get_department ();


    switch ($display)
    {
        case 'VOET traject':
        case 'schooloverzicht':
            {
                echo '<table border=1 cellpadding=0 cellspacing=0>';
                $query = 'SELECT `name` as "objective_curriculum", `id` as "objective_curriculum_id" FROM `campus_objective_curriculum`
							 ORDER BY `display_order`';
                $result = mysql_query($query) or die(mysql_error());
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    echo ' <tr valign="top" style="background-color:#cccccc;">
				   				<th  align="left" colspan="32" >
                                                		<b>' . $rij['objective_curriculum'] . '</b>
					   			</th>
					 		</tr>';
                    $query2 = 'SELECT `campus_objective`.`id`, `objective_group`, `objective`, `code`,  COUNT(`objective_id`) as `aantal`, GROUP_CONCAT(`t1`.`objective_tracking_id` ) as `events`  FROM `campus_objective`
                                    LEFT JOIN ' . $subquery . '	as t1	ON `campus_objective`.`id`=`t1`.`objective_id`
									WHERE `objective_curriculum_id`=' . $rij['objective_curriculum_id'] . ' GROUP BY `campus_objective`.`id` ORDER BY `campus_objective`.`display_order`';
                    $result2 = mysql_query($query2) or die(mysql_error());
                    $group = '';
                    while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                    {
                        if ($rij2['objective_group'] != $group)
                        {
                            echo '<tr>
									<td  style="padding-left:36px;" colspan="32" >
									&nbsp;
										<b>' . $rij2['objective_group'] . '</b>
									</td>
								</tr>';
                            $group = $rij2['objective_group'];
                        }
                        echo '<tr>
								<td valign="top">
									<i style="height:36px; valign:top;">' . utf8_decode($rij2['code']) . '</i>
								</td>
								<td >
									' . utf8_decode($rij2['objective']) . '
								</td>
								<td  align="center" style="width:50px;height:36px;font-size:18px;">';
                        echo $rij2['aantal'];
                        echo '	</td>';
                        for ($t = 1; $t < ($filterlines + 1); $t++)
                        {
                            if ($subquery2[$t] != '')
                            {
                                $query3 = mysql_query($subquery2[$t] . ' AND `objective_id`=' . $rij2['id']);

                                $aantal3 = mysql_num_rows($query3);
                                echo '<td  align="center" style="width:50px;height:36px;font-size:18px;">';
                                echo $aantal3;
                                echo '	</td>';
                            }
                        }
                        echo'</tr>';
                    }
                }
                echo '	</table>';
            }
            break;
        case 'VOET link':
            {
                echo '<table border=1 cellpadding=0 cellspacing=0>';
                $query = 'SELECT `campus_objective`.`id`, `campus_objective`.`code`, `objective`,`campus_objective`.`objective_group`, `campus_objective_curriculum`.`name` as "objective_curriculum" FROM `campus_objective`
				INNER JOIN `campus_objective_curriculum` ON `campus_objective_curriculum`.`id`=`campus_objective`.`objective_curriculum_id`
                                    ORDER BY `campus_objective_curriculum`.`display_order`, `campus_objective`.`display_order`';
                $result = mysql_query($query);
                $width = mysql_num_rows($result);
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    echo ' <tr valign="top" style="background-color:#cccccc;">
				   				<td >
									<div title="' . $rij['objective'] . '">' . $rij['code'] . '</b>
					   			</td>';
                    $query2 = 'SELECT DISTINCT `campus_objective`.`id`, `campus_objective`.`code`, `objective`,`campus_objective`.`objective_group`, `campus_objective_curriculum`.`name` as "objective_curriculum" ,COUNT(`t0`.`id`) as `aantal`, GROUP_CONCAT(`t0`.`id` ) as `events` FROM `campus_objective`
					INNER JOIN `campus_objective_curriculum` ON `campus_objective_curriculum`.`id`=`campus_objective`.`objective_curriculum_id`
                                            LEFT JOIN (SELECT `campus_objective_tracking`.`id`,`t1`.`objective_id` FROM `campus_objective_tracking_rel_objective` as `t1`
		 						INNER JOIN `campus_objective_tracking_rel_objective` as `t2`
									ON `t1`.`objective_tracking_id` =`t2`.`objective_tracking_id` AND `t2`.`objective_id`=' . $rij['id'] . '
								INNER JOIN  `campus_objective_tracking`
									ON (`campus_objective_tracking`.`id`=`t1`.`objective_tracking_id` AND
										 `department_id`=' . $department_id . ' AND `date` >=' . mktime(0, 0, 0, 7, 1, substr($currentYear, 0, 4)) . ' AND `date` <=' . mktime(0, 0, 0, 8, 31, substr($currentYear, 5, 4)) . ')
										) as `t0` ON `t0`.`objective_id` =`campus_objective`.`id`
								 GROUP BY `campus_objective`.`id`
						 			ORDER BY `campus_objective_curriculum`.`display_order`, `campus_objective`.`display_order`';
                    $result2 = mysql_query($query2);
                    $col = 0;
                    while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                    {
                        $col++;
                        echo '<td  align="center" >';
                        if ($rij['id'] == $rij2['id'])
                        {
                            echo 'X';
                        }
                        else
                        {

                            if ($rij2['aantal'] != 0)
                            {
                                echo '' . $rij2['aantal'] . '';
                            }
                            else
                            {
                                echo '&nbsp;';
                            }
                        }

                        echo '	</td>';
                    }
                    echo '</tr>';
                }
                echo '		</table>';
            }
    }
    echo '	</form>';
}
echo '</div>';
?>