<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\DatetimeUtilities;
use common\libraries\PlatformSetting;
use common\libraries\ResourceManager;
use common\libraries\Path;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($is_teacher) && !$is_platformadmin))
{// not allowed here!
    Display::display_error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only departmentadmins and platform administrator is allowed here...
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $department_id = intval(campus::get_SESSION('department_id', key($departmentStruc)));
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);

// get rights of user in campus plugin .....
    $admin = campus::get_rights($_uid, $department_id);
    $display = campus::get_POST_GET('display', 'schooloverzicht');
    $filterlines = intval(campus::get_POST_GET('filterlines', 1));
    $currentYear = campus::get_POST_GET('currentYear', $academicYear);
    $filterclass = campus::get_POST_GET('filterclass');
    $filterdepartment = campus::get_POST_GET('filterdepartment');
    $filteryear = campus::get_POST_GET('filteryear');



    /*
      -----------------------------------------------------------
      Specials
      -----------------------------------------------------------
     */
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_PLUGIN_PATH) . 'jquery/jquery.tooltip.min.js');
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/javascript/campus_objective_ajax.js');
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/css/tooltip.css');

    /*
      ==============================================================================
      display header & breadcrumb...
      ==============================================================================
     */


    echo '<div >';


//check if user is allowed here...
    if ((intval($_uid) == 0) || (empty($is_teacher) && !$is_platformadmin && (isset($admin['objectiveTrackingLevel0']) && $admin['objectiveTrackingLevel0']) && (isset($admin['objectiveTrackingLevel1']) && $admin['objectiveTrackingLevel1'])))
    {// not allowed here!
        Display::display_error_message(get_lang("msgNoRights4ThisDepartment"), false);
    }
    else
    {//only departmentadmins and platform administrator is allowed here...

        /*
          ==============================================================================
          POST & GET vars, check for default value?.
          ==============================================================================
         */
        //new line....


        switch ($display)
        {
            case 'schooloverzicht':
                {
                    $subquery = ' (SELECT DISTINCT `campus_objective_tracking_rel_objective`.`objective_tracking_id`, `objective_id` FROM `campus_objective_tracking_rel_objective`
										INNER JOIN  `campus_objective_tracking`
											ON `campus_objective_tracking`.`id`=`campus_objective_tracking_rel_objective`.`objective_tracking_id`
										WHERE	(`department_id`=' . $department_id . ' AND `date` >=' . mktime(0, 0, 0, 7, 1, substr($currentYear, 0, 4)) . ' AND `date` <=' . mktime(0, 0, 0, 8, 31, substr($currentYear, 5, 4)) . ')
									)';
                }
                break;
            case 'VOET traject':
                {
                    $subfilter = '';
                    for ($t = 1; $t < ($filterlines + 1); $t++)
                    {
                        if (($filterclass[$t] != '') && ($filteryear[$t] != '') && (intval($filterdepartment[$t]) > 0))
                        {
                            $filter = ' (`date` >=' . mktime(0, 0, 0, 7, 1, substr($filteryear[$t], 0, 4)) . ' AND `date` <=' . mktime(0, 0, 0, 8, 31, substr($filteryear[$t], 5, 4)) . ' AND ';

                            if ($filterclass[$t] != '-1')
                            {
                                $filter.='`department_id`=' . $filterdepartment[$t] . ' AND `group_code`="' . trim($filterclass[$t]) . '") OR ';
                            }
                            else
                            {
                                $filter.='`department_id`=' . $filterdepartment[$t] . ') OR ';
                            }
                            $subfilter.=$filter;
                            $subquery2[$t] = ' SELECT DISTINCT `campus_objective_tracking_rel_objective`.`objective_tracking_id`, `objective_id` FROM `campus_objective_tracking_rel_objective`
									INNER JOIN  `campus_objective_tracking`
										ON `campus_objective_tracking`.`id`=`campus_objective_tracking_rel_objective`.`objective_tracking_id`
									INNER JOIN  `campus_objective_tracking_rel_group`
										ON `campus_objective_tracking`.`id`=`campus_objective_tracking_rel_group`.`objective_tracking_id`
									WHERE ' . (($filter == '') ? 'null' : substr($filter, 0, -3)) . ' ';
                        }
                    }
                    $subquery = ' (SELECT DISTINCT `campus_objective_tracking_rel_objective`.`objective_tracking_id`, `objective_id` FROM `campus_objective_tracking_rel_objective`
									INNER JOIN  `campus_objective_tracking`
										ON `campus_objective_tracking`.`id`=`campus_objective_tracking_rel_objective`.`objective_tracking_id`
									INNER JOIN  `campus_objective_tracking_rel_group`
										ON `campus_objective_tracking`.`id`=`campus_objective_tracking_rel_group`.`objective_tracking_id`
									WHERE ' . (($subfilter == '') ? 'null' : substr($subfilter, 0, -3)) . '	)';
                }
                break;
        }

        /*
          ==============================================================================
          Actualiseer de gegevens van het formulier en de database......
          ==============================================================================
         */
        $departments = campus::get_department ();


        /*
          ==============================================================================
          display ...
          ==============================================================================
         */



        if (!empty($errormessage))
        {
            Display::error_message($errormessage, false);
        }
        elseif (!empty($warningmessage))
        {
            Display::warning_message($warningmessage, false);
        }
        elseif (!empty($message))
        {
            Display::normal_message($message, false);
        }

        // ===============================================================
        // Form to add/edit objective tracking
        // ===============================================================
        echo '<form method="post" action="' . $this->get_url() . '" name="myform">';
        echo '<input type="hidden" name="page" value="objectivetrackingstats" >';

        echo 'Overzichten: <select name="display" style="width:230px;" OnChange="javascript:submit();">';
        $select = array('schooloverzicht' => 'Overzicht van de behaalde voeten van al de activiteiten van school gedurende dit schooljaar.', 'VOET traject' => 'Stel een virtueel traject samen om te bepalen of al de VOETen behaald worden.', 'VOET link' => 'Zoek verbanden tussen behaalde VOETen, welke Stam kan gelinkt worden aan welke Contexten.');
        foreach ($select as $option => $tooltip)
        {
            echo '<option value="' . $option . '" ' . (($display == $option) ? 'selected' : '') . ' title="' . $tooltip . '">' . $option . '</option>';
        }
        echo '</select>';
        echo '<input type="submit" name="letter" value="Export naar xls" onMouseDown="javascript:document.myform.page.value=\'objectivetracking2xls\';" onMouseOut="javascript:document.myform.page.value=\'objectivetrackingstats\';">';
        echo '<br>';
        switch ($display)
        {
            case 'VOET traject':
                {
                    for ($t = 1; $t < ($filterlines + 1); $t++)
                    {
                        // default department...
                        $line_departmentid = intval($filterdepartment[$t]) > 0 ? $filterdepartment[$t] : $department_id;
                        $line_acyear = ($filteryear[$t] != '') ? $filteryear[$t] : $academicYear;
                        //campus::show_arrays($filterdepartment
                        $extraline = ($t == $filterlines) ? 'document.myform.filterlines.value=\'' . ($filterlines + 1) . '\';' : '';
                        echo 'School :<select name="filterdepartment[' . $t . ']" OnChange="javascript:submit();">';
                        foreach ($departments as $departmentid => $departmentinfo)
                        {
                            echo '<option value="' . $departmentid . '" ' . (($line_departmentid == $departmentid) ? 'selected' : '') . ' >' . $departmentinfo['code'] . '</option>';
                        }
                        echo'	</select>';
                        echo 'Schooljaar :<select name="filteryear[' . $t . ']" style="width:100px;" OnChange="javascript:submit();">';
                        $query = "SELECT DISTINCT IF(MONTH(FROM_UNIXTIME(`date`))<9,CONCAT_WS('-',YEAR(FROM_UNIXTIME(`date`))-1,YEAR(FROM_UNIXTIME(`date`))),CONCAT_WS('-',YEAR(FROM_UNIXTIME(`date`)),YEAR(FROM_UNIXTIME(`date`))+1)) as ac_year FROM `campus_objective_tracking`
						WHERE `department_id`=" . $line_departmentid . " ORDER BY `date`";

                        $result = mysql_query($query);
                        while (list ($ac_year) = mysql_fetch_row($result))
                        {
                            echo '<option value="' . $ac_year . '" ' . (( $line_acyear == $ac_year) ? 'selected' : '') . ' >' . $ac_year . '</option>';
                        }
                        echo'	</select>';
                        echo 'Klas :<select name="filterclass[' . $t . ']"  OnChange="javascript:' . $extraline . 'submit();">';
                        echo '<option value="0" >Kies een klas</option>';
                        echo '<option value="-1" ' . (($filterclass[$t] == -1) ? 'selected' : '') . ' >Volledige school</option>';

                        $query = 'SELECT DISTINCT `group_code` FROM `campus_objective_tracking_rel_group`
                                                INNER JOIN `campus_objective_tracking`
                                                 ON `objective_tracking_id`=`id`
 						WHERE `department_id`=' . $line_departmentid . '
                                                    AND `date` >=' . mktime(0, 0, 0, 7, 1, substr($line_acyear, 0, 4)) . '
								AND `date` <=' . mktime(0, 0, 0, 8, 31, substr($line_acyear, 5, 4)) . '
							ORDER BY  `group_code`';
                        $result = mysql_query($query);
                        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                        {
                            echo '<option value="' . trim($rij['group_code']) . '" ' . (($filterclass[$t] == trim($rij['group_code'])) ? 'selected' : '') . ' >' . $rij['group_code'] . '</option>';
                        }
                        echo'	</select><br>';
                    }
                    echo '<input type="hidden" name="filterlines" value="' . $filterlines . '">';
                }
            case 'schooloverzicht':
                {
                    echo '<br><table border=1 cellpadding=0 cellspacing=0>';
                    $query = 'SELECT `name` as "objective_curriculum", `id` as "objective_curriculum_id" FROM `campus_objective_curriculum`
							 ORDER BY `display_order`';
                    $result = mysql_query($query) or die(mysql_error());
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        echo ' <tr valign="top" style="background-color:#cccccc;">
				   				<th  align="left" colspan="32" >
									<b>' . $rij['objective_curriculum'] . '</b>
					   			</th>
					 		</tr>';
                        $query2 = 'SELECT `campus_objective`.`id`, `objective_group`, `objective`, `code`,  COUNT(`objective_id`) as `aantal`, GROUP_CONCAT(`t1`.`objective_tracking_id` ) as `events`  FROM `campus_objective`
                                    LEFT JOIN ' . $subquery . '	as t1	ON `campus_objective`.`id`=`t1`.`objective_id`
									WHERE `objective_curriculum_id`=' . $rij['objective_curriculum_id'] . ' GROUP BY `campus_objective`.`id` ORDER BY `campus_objective`.`display_order`';
                        $result2 = mysql_query($query2);
                        $group = '';
                        while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                        {

                            if ($rij2['objective_group'] != $group)
                            {
                                echo '<tr>
									<td  style="padding-left:36px;" colspan="32" >
									&nbsp;
										<a><b>' . $rij2['objective_group'] . '</b></a>
									</td>
								</tr>';
                                $group = $rij2['objective_group'];
                            }
                            echo '<tr>
								<td valign="top">
									<i style="height:36px; valign:top;">' . $rij2['code'] . '</i>
								</td>
								<td >
									 <textarea cols="80" style="height:36px; border:none;" readonly>' . $rij2['objective'] . '</textarea>
								</td>
								<td  align="center" style="width:50px;height:36px;font-size:18px;">';
                            if ($rij2['aantal'] != 0)
                            {

                                echo '<div  class="campus_tooltip" objective_tracking_id="' . $rij2['code'] . ';' . $rij2['events'] . '" title="">';
                                echo $rij2['aantal'];
                                echo '</div>';
                            }
                            else
                            {
                                echo $rij2['aantal'];
                            }
                            echo '	</td>';
                            for ($t = 1; $t < ($filterlines + 1); $t++)
                            {
                                if ($subquery2[$t] != '')
                                {
                                    $result3 = mysql_query($subquery2[$t] . ' AND `objective_id`=' . $rij2['id']);
                                    $aantal3 = mysql_num_rows($result3);
                                    $rij3_events = array();
                                    while ($rij3 = mysql_fetch_array($result3, MYSQL_ASSOC))
                                    {
                                        $rij3_events[] = $rij3['objective_tracking_id'];
                                    }
                                    echo '<td  align="center" style="width:50px;height:36px;font-size:18px;">';
                                    if ($aantal3 != 0)
                                    {

                                        echo '<div  class="campus_tooltip" objective_tracking_id="<b>' . $departmentStruc[$filterdepartment[$t]]['code'] . ':</b>  ' . $rij2['code'] . ';' . implode(",", $rij3_events) . '" title="geen info">
                                                ' . $aantal3 . '
                                                    </div>';
                                    }
                                    else
                                    {
                                        //  echo $query3;
                                        echo $aantal3;
                                    }
                                    echo '	</td>';
                                }
                            }
                            echo'</tr>';
                        }
                    }
                    echo '		</table>';
                }
                break;
            case 'VOET link':
                {
                    echo '<br><table border=1 cellpadding=0 cellspacing=0>';
                    $query = 'SELECT `campus_objective`.`id`, `campus_objective`.`code`, `objective`,`campus_objective`.`objective_group`, `campus_objective_curriculum`.`name` as "objective_curriculum" FROM `campus_objective`
				INNER JOIN `campus_objective_curriculum` ON `campus_objective_curriculum`.`id`=`campus_objective`.`objective_curriculum_id`
                                    ORDER BY `campus_objective_curriculum`.`display_order`, `campus_objective`.`display_order`';
                    $result = mysql_query($query) or die(mysql_error());
                    $width = mysql_num_rows($result);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        echo ' <tr valign="top" style="background-color:#cccccc;">
				   				<td >
									<div title="' . $rij['objective'] . '">' . $rij['code'] . '</b>
					   			</td>';
                        $query2 = 'SELECT DISTINCT `campus_objective`.`id`, `campus_objective`.`code`, `objective`,`campus_objective`.`objective_group`, `campus_objective_curriculum`.`name` as "objective_curriculum" ,COUNT(`t0`.`id`) as `aantal`, GROUP_CONCAT(`t0`.`id` ) as `events` FROM `campus_objective`
					INNER JOIN `campus_objective_curriculum` ON `campus_objective_curriculum`.`id`=`campus_objective`.`objective_curriculum_id`
                                            LEFT JOIN (SELECT `campus_objective_tracking`.`id`,`t1`.`objective_id` FROM `campus_objective_tracking_rel_objective` as `t1`
		 						INNER JOIN `campus_objective_tracking_rel_objective` as `t2`
									ON `t1`.`objective_tracking_id` =`t2`.`objective_tracking_id` AND `t2`.`objective_id`=' . $rij['id'] . '
								INNER JOIN  `campus_objective_tracking`
									ON (`campus_objective_tracking`.`id`=`t1`.`objective_tracking_id` AND
										 `department_id`=' . $department_id . ' AND `date` >=' . mktime(0, 0, 0, 7, 1, substr($currentYear, 0, 4)) . ' AND `date` <=' . mktime(0, 0, 0, 8, 31, substr($currentYear, 5, 4)) . ')
										) as `t0` ON `t0`.`objective_id` =`campus_objective`.`id`
								 GROUP BY `campus_objective`.`id`
						 			ORDER BY `campus_objective_curriculum`.`display_order`, `campus_objective`.`display_order`';

                        $result2 = mysql_query($query2);
                        $col = 0;
                        while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                        {
                            $col++;
                            echo '<td  align="center" >';
                            if ($rij['id'] == $rij2['id'])
                            {
                                echo 'X';
                            }
                            else
                            {

                                if ($rij2['aantal'] != 0)
                                {
                                    echo '<div class="campus_tooltip" title="" objective_tracking_id="' . $rij2['code'] . '_' . $rij['code'] . ';' . $rij2['events'] . '">
									' . $rij2['aantal'] . '</div>';
                                }
                                else
                                {
                                    echo '&nbsp;';
                                }
                            }

                            echo '	</td>';
                        }
                        echo '</tr>';
                    }
                    echo '		</table>';
                }
        }
        echo '	</form>';
    }
    echo '</div>';
}
?>