<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Display;
use common\libraries\DatetimeUtilities;
use common\libraries\PlatformSetting;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($departmentStruc) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Display::display_error_message(get_lang("msgNoDepartmentMember"), false);
}
else
{//only teachers and platform administrator are allowed here...
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $week = DatetimeUtilities::get_days_long();
    // remove sunday and saturday from array...
    $week = array_slice($week, 1, 5, true);
    $week_key = array_change_key_case(array_flip($week));

    $teacher_id = intval(campus::get_POST_GET("teacher_id", $_uid));
    $resource_id = intval(campus::get_POST_GET("resource_id"));
    $reservation_id = intval(campus::get_POST_GET("reservation_id"));
    $dateselect = intval(campus::get_POST_GET("dateselect", mktime(0, 0, 0, date('m', time()), date('d', time()), date('Y', time()))));

    $period_id = intval(campus::get_POST_GET("period_id"));
    $action = campus::get_POST_GET("action");
    // extract user and code from resource file...
    $result = mysql_query('SELECT `user_id`,`code` from `campus_resource` WHERE `id`=' . $resource_id . ' ');
    list($user2warn, $resourcecode) = mysql_fetch_row($result);


    if ((strftime('%w', $dateselect) == 6) || (strftime('%w', $dateselect) == 0))
    {
        $dateselect = strtotime('next Monday', $dateselect);
    }

    $activeroster = campus::get_activeroster($department_id, $dateselect);

    // calculate monday
    $monday = strtotime('Next Monday', strtotime('-1 Week', $dateselect));

    $kw = strftime('%V', $monday); // iso weeknummer op server
    if ($kw == null)
    {
        $kw = strftime('%U', $monday) + 1;
    } // weeknummer lokaal
    $prevweek = strtotime('-1 week', $monday);
    $nextweek = strtotime('+1 week', $monday);

    $warningmsg = FALSE;

    switch ($action)
    {
        case "reserve":
            {
                // check if already reserved...
                $query = "SELECT * FROM `campus_reservation` WHERE
					`date`=" . $dateselect . " AND
	 				`period_id`=" . $period_id . " AND
					`user_id`=" . $teacher_id . " AND
					`resource_id`=" . $resource_id . "";
                $result = mysql_query($query);
                if (mysql_num_rows($result) == 0)
                { // if not already reserved, mark the resource as occupied...
                    // check for other reservations
                    $query = "SELECT `id`, `state` FROM `campus_reservation`
							WHERE `date`=" . $dateselect . " AND `period_id`=" . $period_id . " AND `user_id`=" . $teacher_id . " ORDER BY `state` DESC";
                    $result = mysql_query($query);
                    $reservation = mysql_fetch_array($result, MYSQL_ASSOC);
                    // reserve selected resource...
                    $query = 'INSERT `campus_reservation` SET
					`date`=' . $dateselect . ',
                                        `period_id`=' . $period_id . ',
					`user_id`=' . $teacher_id . ',
                                        `resource_id`=' . $resource_id . ',
                                        `state`=' . $this::RESOURCE_OCCUPIED . ' ';
                    $result = mysql_query($query);
                    if ($result)
                    {
                        $reservation_id = mysql_insert_id();
                        //  check if msg with same resource and date already exists.
                        $result = mysql_query("SELECT * FROM `campus_messageboard` WHERE `title`='" . get_lang("txtReservation") . "" . DatetimeUtilities::format_locale_date('%Y-%m-%d', $dateselect) . ": " . $resourcecode . "' AND `from`='" . $teacher_id . "' ");
                        $aantal = mysql_num_rows($result);
                        if (($aantal == 0) && ($user2warn != 0))
                        {//Wenn no message exists AND a user has to be warned, write one.
                            $userinfo = campus::get_user_info($teacher_id);
                            $content = $userinfo['firstname'] . ' ' . $userinfo['lastname'] . '(' . $userinfo['official_code'] . ')<br>' .
                                    get_lang("msgReservationResource") .
                                    '<a href="' . $this->get_url() . '&resource_id=' . $resource_id . '&dateselect=' . $dateselect . '">' . $resourcecode . '</a>' .
                                    get_lang("msgReservationDate") .
                                    DatetimeUtilities::format_locale_date('%A %d %B %Y', $dateselect) . '.';
                            $query = 'INSERT `campus_messageboard` SET
                                        `title`="RESERV.' . DatetimeUtilities::format_locale_date('%Y-%m-%d', $dateselect) . ': ' . $resourcecode . '",
                                        `date`=' . time() . ',
                                        `user_id`=' . $teacher_id . ',
                                        `content`="' . addslashes($content) . '" ';
                            $result = mysql_query($query);
                            if ($result)
                            {
                                $message_id = mysql_insert_id();
                                campus::set_message_to(array("u" . $user2warn), $message_id);
                            }
                        }
                        $message = get_lang("msgReservationOk") . $resourcecode . get_lang("msgReservationDate") . DatetimeUtilities::format_locale_date('%A %d %B %Y', $dateselect) . ".";
                        if ($reservation['state'] == $this::RESOURCE_OCCUPIED)
                        {
                            $warningmsg = TRUE;
                            $message.= '<br>' . get_lang("msgDeleteOtherReservations") . '<br><a href="' . $this->get_url() . '&dateselect=' . $dateselect . '&resource_id=' . $resource_id . '&reservation_id=' . $reservation_id . '&period_id=' . $period_id . '&teacher_id=' . $teacher_id . '&action=clear">' . get_lang("txtYes") . '</a>
                                        <a href="' . $this->get_url() . '&dateselect=' . $dateselect . '&resource_id=' . $resource_id . '">' . get_lang("txtNo") . '</a>';
                        }
                        elseif ($reservation['state'] != $this::RESOURCE_RELEASED)
                        {
                            // search for resources from roster that can be released.
                            $query = 'SELECT `resource_id`, `campus_period`.`id` as period_id, `duration`, t2.`period_id` as period_exists
                                        FROM `campus_period`
                                            LEFT JOIN ( SELECT  `campus_college`.`period_id`, `campus_college`.`roster_id`, `resource_id`, `duration` FROM `campus_college`
                                            INNER JOIN `campus_college_rel_resource`
                                                ON `campus_college`.`id`=`campus_college_rel_resource`.`college_id`
                                            INNER JOIN `campus_assignment_rel_teacher`
                                                ON `campus_assignment_rel_teacher`.`assignment_id`=`campus_college`.`assignment_id` AND `user_id`=' . $teacher_id . ') as t2
                                                ON `campus_period`.`id`=`t2`.`period_id`  AND t2.`roster_id`=' . $activeroster['roster_id'] . '
                                        WHERE `department_id`=' . $department_id . ' AND `weekday`=' . strftime('%w', $dateselect) . ' ORDER BY `display_order`';
                            $result = mysql_query($query);
                            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                            {
                                if ($rij['period_id'] == $rij['period_exists'])
                                { // there's a college record of this period
                                    $college_resource_id = $rij['resource_id'];
                                    $duration = $rij['duration'];
                                }
                                elseif ($duration > 1)
                                {
                                    $duration--;
                                }
                                else
                                {
                                    $duration = 0;
                                    $college_resource_id = 0;
                                }
                                if (($college_resource_id > 0) && ($period_id == $rij['period_id']))
                                {
                                    $warningmsg = TRUE;
                                    $message.= '<br>' . get_lang("msgReleaseResource") . '<br><a href="' . $this->get_url() . '&dateselect=' . $dateselect . '&resource_id=' . $resource_id . '&period_id=' . $period_id . '&teacher_id=' . $teacher_id . '&action=release">' . get_lang("txtYes") . '</a>
                                                    <a href="' . $this->get_url() . '&dateselect=' . $dateselect . '&resource_id=' . $resource_id . '">' . get_lang("txtNo") . '</a>';
                                    break;
                                }
                            }
                        }
                    }
                }
            }
            break;
        case "release":
            {// release resources from roster
                // search for resources from roster that can be released.
                $query = "SELECT `resource_id`, `campus_period`.`id` as period_id, `duration`, t2.`period_id` as period_exists
                                        FROM `campus_period`
                                            LEFT JOIN ( SELECT  `campus_college`.`period_id`, `campus_college`.`roster_id`, `resource_id`, `duration` FROM `campus_college`
                                            INNER JOIN `campus_college_rel_resource`
                                                ON `campus_college`.`id`=`campus_college_rel_resource`.`college_id`
                                            INNER JOIN `campus_assignment_rel_teacher`
                                                ON `campus_assignment_rel_teacher`.`assignment_id`=`campus_college`.`assignment_id` AND `user_id`=" . $teacher_id . ") as t2
                                                ON `campus_period`.`id`=`t2`.`period_id`  AND t2.`roster_id`=" . $activeroster['roster_id'] . "
                                        WHERE `weekday`=" . strftime('%w', $dateselect) . ' ORDER BY `display_order`';
                $result = mysql_query($query);
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    if ($rij['period_id'] == $rij['period_exists'])
                    { // there's a college record of this period
                        $college_resource_id = $rij['resource_id'];
                        $duration = $rij['duration'];
                    }
                    elseif ($duration > 1)
                    {
                        $duration--;
                    }
                    else
                    {
                        $duration = 0;
                        $college_resource_id = 0;
                    }
                    if (($college_resource_id > 0) && ($period_id == $rij['period_id']))
                    {

                        // check if already released...
                        $query2 = "SELECT * FROM `campus_reservation` 
                                            INNER JOIN `campus_period`
                                                ON `campus_period`.`id`=`campus_reservation`.`period_id`
                                            WHERE
					`date`=" . $dateselect . " AND
			 		`period_id`=" . $rij['period_id'] . " AND
					`user_id`=" . $teacher_id . " AND
					`resource_id`=" . $college_resource_id . "";
                        $result2 = mysql_query($query2);
                        if (mysql_num_rows($result2) == 0)
                        { // if not already released, mark the resource as released...
                            $query2 = 'INSERT `campus_reservation` SET
						`date`=' . $dateselect . ',
		 				`period_id`=' . $rij['period_id'] . ',
						`user_id`=' . $teacher_id . ',
						`resource_id`=' . $college_resource_id . ',
						`state`=' . $this::RESOURCE_RELEASED . ' ';
                            $result2 = mysql_query($query2);
                            if ($result2)
                            {
                                $message = get_lang("msgResourceReleased");
                            }
                        }

                        break;
                    }
                }
            }
            break;
        case "clear":
            { // clear other reservations from reservations..
                $result = mysql_query('DELETE FROM `campus_reservation` WHERE `date`=' . $dateselect . ' AND `period_id`=' . $period_id . ' AND `user_id`=' . $teacher_id . ' AND  `id`<>' . $reservation_id . ' AND `state`=' . $this::RESOURCE_OCCUPIED . '');
                $message = get_lang("msgReservationDeleted");
            }
            break;
        case "block":
            {
                $result = mysql_query("DELETE FROM `campus_reservation` WHERE `id`=" . $reservation_id . " ");
                $message = get_lang("msgReservationOk") . $resourcecode . get_lang("msgReservationDate") . DatetimeUtilities::format_locale_date('%A %d %B %Y', $dateselect) . ".";
                // check for other reservations
                $query = "SELECT `id`, `state` FROM `campus_reservation`
						WHERE `date`=" . $dateselect . " AND `period_id`=" . $period_id . " AND `user_id`=" . $teacher_id . " ORDER BY `state`";
                $result = mysql_query($query);
                if (mysql_num_rows($result) > 0)
                {
                    $warningmsg = TRUE;
                    $message.= '<br>' . get_lang("msgDeleteOtherReservations") . '<br><a href="' . $this->get_url() . '&dateselect=' . $dateselect . '&resource_id=' . $resource_id . '&reservation_id=&period_id=' . $period_id . '&action=clear">' . get_lang("txtYes") . '</a> /
                    <a href="' . $this->get_url() . '&dateselect=' . $dateselect . '&resource_id=' . $resource_id . '">' . get_lang("txtNo") . '</a>';
                }
            }
            break;
        case "free":
            {
                $result = mysql_query("DELETE FROM `campus_reservation` WHERE `id`=" . $reservation_id . " ");
                $message = get_lang("msgReservationDeleted");
            }
            break;
    }

    $reservationadmin = $is_platformadmin || $admin['roster'] || ($user2warn == $_uid);

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    if ($activeroster['roster_id'] > 0)
    {

        if (!empty($message))
        {
            if ($warningmsg)
            {
                Display::warning_message($message, false);
            }
            else
            {
                Display::normal_message($message, false);
            }
        }
        //Lijst van ALLE resources opzoeken....
        $query = "SELECT `code`, `id`, `comment` ,`reservable`
			FROM `campus_resource`
			WHERE (`department_id`=" . $department_id . " OR `department_id`=0) AND `reservable` > 0 ORDER BY `code`";
        $result = mysql_query($query);
        $resourcelinks = '<a href="' . $this->get_url() . '&resource_id=free" >' . get_lang("txtShowFreeResources") . '</a> ';
        $displayed_resource = ($resource_id == 'free') ? "<i>" . get_lang("txtFreeResources") . "</i>" : "";
        $resources = array();
        $reservable = 0;
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $resources[$rij['id']]['code'] = $rij['code'];
            if ($resource_id == $rij['id'])
            {
                $displayed_resource = "<i>" . $rij['code'] . ":" . $rij['comment'] . "</i>";
                $reservable = $rij['reservable'];
            }
            else
            {
                $resourcelinks.='<a href="' . $this->get_url() . '&resource_id=' . $rij['id'] . '" title="' . $rij['comment'] . '">' . $rij['code'] . '</a> ';
            }
        }
        echo "<div >";
        echo $resourcelinks;
        echo "</div>";

        echo "<div style=\"width:100%;\"></div>";
        echo "<span style=\" float:right; \">";
        if ($resource_id == 0)
        {
            if ((isset($admin['roster']) && $admin['roster']) || $is_platformadmin)
            {
                echo ' <a href="' . $this->get_roster_url() . '&page=roster2excel&rooster=resource&roster_id=' . $activeroster['roster_id'] . '" target="_blank" >' . get_lang("txtRoster2Excel") . '</a> |';
                echo ' <a href="' . $this->get_roster_url() . '&page=roster2pdf&compact=&rooster=resource&select=complete&roster_id=' . $activeroster['roster_id'] . '" target="_blank" >' . get_lang("txtAllRoster2Pdf") . '</a> |';
            }
            echo ' <a href="' . $this->get_roster_url() . '&page=roster2pdf&compact=on&rooster=resource&select=complete&roster_id=' . $activeroster['roster_id'] . '" target="_blank" >' . get_lang("txtAllRoster2PdfCompact") . '</a>';
        }
        else
        {
            if ($reservationadmin)
            {
                echo '<form method="post" action="' . $this->get_url() . '" name="formselectteacher" style="display:inline;">';
                echo '<input type="hidden" name="page" value="content" >';
                echo '<input type="hidden" name="resource_id" value="' . $resource_id . '" >';
                echo '<input type="hidden" name="dateselect" value="' . $dateselect . '" >';
                echo '<select name="teacher_id" SIZE="1" OnChange="javascript:document.formselectteacher.submit();" >';
                echo '<option value="">&nbsp;
                    </option>';
                $teachers = campus::get_teachers($department_id);
                foreach ($teachers as $teacherid => $value)
                {
                    echo '<option value="' . $teacherid . '" ' . (($teacher_id == $teacherid) ? 'SELECTED' : '') . '>' . $value['official_code'] . ': ' . $value['fullname'] . '</option>';
                }
                echo '</select></form> | ';
                $query = "SELECT `device_id` ";
                $query.="FROM `campus_it_device` ";
                $query.="WHERE `resource_id`='" . $resource_id . "' AND `department_id`=" . $department_id . "";
                $result = mysql_query($query);
                if (mysql_num_rows($result) > 0)
                {
                    echo ' <a href="' . $this->get_it_support_url() . '&resource_id=' . $resource_id . '" >' . get_lang("txtResourceITState") . '</a> | ';
                }
            }
            echo ' <a href="' . $this->get_roster_url() . '&page=roster2pdf&compact=&rooster=resource&select=' . $resource_id . '&roster_id=' . $activeroster['roster_id'] . '" target="_blank" >' . get_lang("txtRoster2Pdf") . '</a> ';
            echo ' | <a href="' . $this->get_url() . '&page=reservations2pdf&resource_id=' . $resource_id . '&roster_id=' . $activeroster['roster_id'] . '" target="_blank" >' . get_lang("txtReservations2Pdf") . '</a> ';
        }
        echo "</span>";
        echo "<b style=\"font-size: 15px;\"><i >" . $displayed_resource . "</i></b>";
        echo ("<div style=\"clear:both\"></div>");
//=============================================================================
//	 reserveringen .......
//=============================================================================
        $rooster = campus::get_rosterarray($department_id);

        echo "<div style='position:relative;
                    left: 0px;
                    top: 0px;
                    '>";
        echo ' <table align="center" style="width:100%;border: 1px #FFFFFF ">
                    <tr class="campus_middle">
                    <td >
                    <a href="' . $this->get_url() . '&dateselect=' . $prevweek . '&resource_id=' . $resource_id . '&teacher_id=' . $teacher_id . '" title="' . get_lang("tooltip1WeekBack") . '"><<<</a>
                    </td>
                    <td align="center" width="100%">
                    <b >De week van ' . DatetimeUtilities::format_locale_date('%A %d %B %Y', $monday) . ' (Week:' . $kw . ')' . '</b>
                    </td>
                    <td >
                    &nbsp;
                    &nbsp;
                    <a href="' . $this->get_url() . '&dateselect=' . $nextweek . '&resource_id=' . $resource_id . '&teacher_id=' . $teacher_id . '" title="' . get_lang("tooltip1WeekForward") . '">>>></a>
                    </td>
                    </tr>
                    </table>';
        if ($resource_id != "free")
        { // put resource occupation from roster in to array
            $query = "SELECT `assignment_id`, `weekday`,`display_order`, `duration`
				FROM `campus_college_rel_resource`
                                    INNER JOIN `campus_college`
					ON `campus_college`.`id`=`campus_college_rel_resource`.`college_id`
                                    INNER JOIN `campus_period`
                                        ON `campus_period`.`id`=`campus_college`.`period_id`
				WHERE `resource_id`=" . intval($resource_id) . " AND `roster_id`=" . $activeroster['roster_id'];
            $result = mysql_query($query);
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                while ($rij['duration'] > 0)
                {
                    $rooster[$rij['display_order']][$rij['weekday']]['state'] = $this::RESOURCE_ROSTERED;
                    $rooster[$rij['display_order']][$rij['weekday']]['teachers'] = campus::get_assignment2teacher($rij['assignment_id'], $activeroster['roster_id'], $rooster[$rij['display_order']][$rij['weekday']]['teachers']);
                    $rooster[$rij['display_order']][$rij['weekday']]['groups'] = campus::get_assignment2group($rij['assignment_id'], $rooster[$rij['display_order']][$rij['weekday']]['groups']);
                    $rooster[$rij['display_order']][$rij['weekday']]['disciplines'] = campus::get_assignment2discipline($rij['assignment_id'], $rooster[$rij['display_order']][$rij['weekday']]['disciplines']);
                    $rij['display_order']++;
                    $rij['duration']--;
                }
            }
        }
        else
        { // resource occupation from roster in to array
            $query = "SELECT `resource_id`, `weekday`,`display_order`, `duration`
				FROM `campus_college_rel_resource`
                                    INNER JOIN `campus_college`
					ON `campus_college`.`id`=`campus_college_rel_resource`.`college_id`
                                    INNER JOIN `campus_period`
                                        ON `campus_period`.`id`=`campus_college`.`period_id`
				WHERE `roster_id`=" . $activeroster['roster_id'];
            $result = mysql_query($query) or die(mysql_error());
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                while ($rij['duration'] > 0)
                {
                    $rooster[$rij['display_order']][$rij['weekday']]['resources'][$rij['resource_id']] = $this::RESOURCE_OCCUPIED;
                    $rij['display_order']++;
                    $rij['duration']--;
                }
            }
        }
// update resource roster .....
        foreach ($week as $day => $daylong)
        {
            $colheaderweek[] = $daylong . " " . DatetimeUtilities::format_locale_date('%d/%m', ($monday + ($day - 1) * 86400));
        }
        if ($resource_id > 0)
        { // read resource reservations of this week
            $query = "SELECT `campus_reservation`.`id` as reservation_id, `user_id`, `display_order`, `date`, `state` FROM `campus_reservation`
                            INNER JOIN `campus_period` ON `campus_period`.`id`= `period_id`
		WHERE `resource_id`=" . $resource_id . " AND `date`>=" . $monday . " AND `date` < " . $nextweek . " ORDER BY `date`,`resource_id`,`state` ASC";
            $result = mysql_query($query);
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $day = strftime('%w', $rij['date']);
                $rooster[$rij['display_order']][$day]['reservation_id'] = $rij['reservation_id'];
                $rooster[$rij['display_order']][$day]['state'] = $rij['state'];
                if (($rij['state'] == $this::RESOURCE_OCCUPIED) && ($teacher_id == $rij['user_id']))
                { //
                    $rooster[$rij['display_order']][$day]['state'] = $this::RESOURCE_RESERVED;
                }
                if ($rij['state'] == $this::RESOURCE_RELEASED)
                { // if resource is released and user is not owner
                    $rooster[$rij['display_order']][$day]['disciplines'] = array(); // clear roster data
                    $rooster[$rij['display_order']][$day]['teachers'] = array(); // clear roster data
                    $rooster[$rij['display_order']][$day]['groups'] = array(); // clear roster data
                    if ($teacher_id != $rij['user_id'])
                        $rooster[$rij['display_order']][$day]['state'] = $this::RESOURCE_FREE;
                }
                else
                {
                    $userinfo = campus::get_user_info($rij['user_id']);
                    $userinfo['name'] = $userinfo['lastname'] . ' ' . substr($userinfo['firstname'], 0, 1);
                    $rooster[$rij['display_order']][$day]['teachers'][$rij['user_id']] = $userinfo;
                    // select original hours.
                    $query2 = "SELECT `campus_assignment_rel_teacher`.`assignment_id`, `display_order`, `duration`
                                    FROM `campus_assignment_teacher`
                                        INNER JOIN `campus_college`
                                            ON `campus_college`.`roster_id` = `campus_assignment_rel_teacher`.`roster_id`
					INNER JOIN `campus_period`
                                            ON `campus_period`.`id`= `campus_college`.`period_id`
					WHERE `campus_assignment_rel_teacher`.`user_id`=" . $rij['user_id'] . " AND `campus_assignment_rel_teacher`.`roster_id`=" . $activeroster['roster_id'] . " AND `weekday`='" . $day . "'";
                    $result2 = mysql_query($query2);
                    while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                    {
                        while ($rij2['duration'] > 0)
                        {
                            if ($rij['display_order'] == $rij2['display_order'])
                            {
                                $rooster[$rij['display_order']][$day]['groups'] = campus::get_assignment2group($rij2['assignment_id'], $rooster[$rij['display_order']][$rij['weekday']]['groups']);
                                $rooster[$rij['display_order']][$day]['disciplines'] = campus::get_assignment2discipline($rij2['assignment_id'], $rooster[$rij['display_order']][$rij['weekday']]['disciplines']);
                            }
                            $rij2['display_order']++;
                            $rij2['duration']--;
                        }
                    }
                }
            }
        }
        if (($resource_id == 0) && ($resource_id != 'free'))
        {
            echo '<div style="position: absolute;left: 20%;top: 30%;text-align:center;width:60%;"><div style="text-align:left">';
            Display::normal_message(get_lang('msgReservationHint'), false);
            echo '</div></div>';
        }
// display roster....
        campus::display_complex_table_header($properties, array_merge(array(""), $colheaderweek));
        foreach ($rooster as $hourkey => $value1)
        {
            $row = array();
            foreach ($week as $day => $daylong)
            {
                $reservationdate = $monday + (($day - 1) * 86400);
                if ($resource_id > 0)
                {
                    $disciplines = "";
                    foreach ($rooster[$hourkey][$day]['disciplines'] as $id => $value)
                    {
                        $disciplines.="<i title=\"" . $value['name'] . "\">" . $value['code'] . "</i> ";
                    }
                    $groups = "";
                    foreach ($rooster[$hourkey][$day]['groups'] as $id => $value)
                    {
                        $groups.="<b title=\"" . $value['aantal'] . get_lang("tooltipStudents") . ".\">" . $value['code'] . "</b> ";
                    }
                    $teachers = "";
                    foreach ($rooster[$hourkey][$day]['teachers'] as $id => $value)
                    {
                        $teachers.="<i title=\"" . $value['name'] . ".\">" . $value['official_code'] . "</i> ";
                    }
                    switch ($rooster[$hourkey][$day]['state'])
                    {
                        case $this::RESOURCE_ROSTERED:
                            { //display resource occupation by roster
                                $cell = '<div align="left">' . $disciplines . '</div><div align="center">' . $groups . '</div><div align="right">' . $teachers . '</div>';
                            }
                            break;
                        case $this::RESOURCE_OCCUPIED:
                            { // occupied by reservation....
                                if ($reservationadmin)
                                { // only roster administrator can free resource...
                                    $cell = '<div>' . $disciplines . '&nbsp;
                                             </div><div align="center"><a href="' . $this->get_url() . '&dateselect=' . $reservationdate . '&resource_id=' . $resource_id . '&reservation_id=' . $rooster[$hourkey][$day]['reservation_id'] . '&action=free">' . get_lang("txtFree") . '</a></div><div><span style="float:right">' . $teachers . '</span><b>' . $groups . '</b></div>';
                                }
                                else
                                {
                                    $cell = '<div>' . $disciplines . '&nbsp;
                                             </div><div align="center" style="color:#BBBBBB;font-weight: bold;">' . get_lang("txtReservated") . '</div><div><b style="float:right" >' . $teachers . '</b>' . $groups . '</div>';
                                }
                            }
                            break;
                        case $this::RESOURCE_RESERVED:
                            { // occupied by owner ....
                                if ((($reservationdate + 30000 + $hourkey * 3600) > time()) || $reservationadmin)
                                { // only owner or administrator
                                    $cell = '<div>' . $disciplines . '&nbsp;
                                             </div><div align="center"><a href="' . $this->get_url() . '&dateselect=' . $reservationdate . '&resource_id=' . $resource_id . '&reservation_id=' . $rooster[$hourkey][$day]['reservation_id'] . '&action=free">' . get_lang("txtFree") . '</a></div><div><span style="float:right">' . $teachers . '</span><b>' . $groups . '</b></div>';
                                }
                                else
                                { // except for the rosteradministration it is not possible to free a resource in the past.
                                    $cell = '<div>' . $disciplines . '&nbsp;
                                             </div><div align="center" style="color:#BBBBBB;font-weight: bold;">' . get_lang("txtReservated") . '</div><div><b style="float:right" >' . $teachers . '</b>' . $groups . '</div>';
                                }
                            }
                            break;
                        case $this::RESOURCE_RELEASED:
                            { // released by owner ....
                                if ((($monday <= (time() + $reservable * 604800)) && (($reservationdate + 30000 + $hourkey * 3600) >= (time()))) || $reservationadmin)
                                { // only
                                    $cell = '<div>' . $disciplines . '&nbsp;
                                             </div><div align="center"><a href="' . $this->get_url() . '&dateselect=' . $reservationdate . '&resource_id=' . $resource_id . '&reservation_id=' . $rooster[$hourkey][$day]['reservation_id'] . '&period_id=' . $rooster[$hourkey][$day]['period_id'] . '&action=block">' . get_lang("txtReserv") . '</a></div><div><span style="float:right">' . $teachers . '</span><b>' . $groups . '</b></div>';
                                }
                                else
                                {
                                    $cell = '<div align="center" title="' . get_lang("tooltipReservationBlocked") . '" style="color:#BBBBBB;font-weight: bold;">&nbsp;
                                                &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</div>';
                                }
                            }
                            break;
                        default:
                            { // resource is free
                                if ((($monday <= (time() + $reservable * 604800)) && (($reservationdate + 30000 + $hourkey * 3600) >= (time()))) || $reservationadmin)
                                {
                                    $cell = '<div>&nbsp;
                                            </div><div align="center"><a href="' . $this->get_url() . '&dateselect=' . $reservationdate . '&resource_id=' . $resource_id . '&period_id=' . $rooster[$hourkey][$day]['period_id'] . '&action=reserve&teacher_id=' . $teacher_id . '" title="' . DatetimeUtilities::format_locale_date('%A %d %B %Y', $reservationdate) . ' ' . get_lang("txtHour") . ' ' . $hourkey . '">' . get_lang("txtReserv") . '</a></div>';
                                }
                                else
                                {
                                    $cell = '<div align="center" title="' . get_lang("tooltipReservationBlocked") . '" style="color:#BBBBBB;font-weight: bold;">&nbsp;
                                                &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</div>';
                                }
                            }
                    }
                }
                else
                {
                    if ($resource_id == 'free')
                    {
                        $free_resources = $resources;
                        if (!empty($rooster[$hourkey][$day]['period_id']))
                        {
                            $query = "SELECT `resource_id`, `period_id`,`date`,`state` FROM `campus_reservation`
							WHERE `date`=" . $reservationdate . " AND `period_id`=" . $rooster[$hourkey][$day]['period_id'] . " ORDER BY `state` DESC";
                            $result = mysql_query($query) or die(mysql_error());
                            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                            {
                                $free_resources[$rij['resource_id']]['state'] = $rij['state'];
                            }
                        }
                        $cell = '<div><form method="post" style="display:inline" action="' . $this->get_url() . '" name="myform' . $daylong . $hourkey . '">';
                        $cell.= '<input type="hidden" name="dateselect" value="' . $reservationdate . '" >';
                        $cell.= '<select OnChange="javascript:myform' . $daylong . $hourkey . '.submit();" name="resource_id" style="width:100%" SIZE="3" title="' . get_lang("tooltipShowFreeResource") . '">'; //<option value='' SELECTED>Kies een vrije</option>";
                        foreach ($free_resources as $res_id => $res)
                        {
                            if (($res['state'] == $this::RESOURCE_RELEASED) || (($res['state'] != $this::RESOURCE_OCCUPIED) && ($rooster[$hourkey][$day]['resources'][$res_id] != $this::RESOURCE_OCCUPIED)))
                            {
                                $cell.='<option value="' . $res_id . '"> ' . $res['code'] . '</option>';
                            }
                        }
                        $cell.='</select></form></div>';
                    }
                }
                $row = array_merge($row, array($cell));
            }
            campus::display_table_row($cellproperties, array_merge(array("<i style='font-size:8px'>" . DatetimeUtilities::format_locale_date("%H:%M", $rooster[$hourkey][$day]['start_time']) . "</i><br><b style=\"font-size:20px;\">" . $hourkey . "</b><br><i style='font-size:8px'>" . DatetimeUtilities::format_locale_date("%H:%M", $rooster[$hourkey][$day]['end_time']) . "</i>"), $row));
        }
        campus::display_table_footer();
        echo "</div> ";
    }
    else
    {
        Display::error_message(get_lang("msgNoRoster"), false);
    }
}
?>