<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Path;
use common\libraries\Theme;
use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;

$allowed = $is_teacher || ($rooster == "class") || $is_platformadmin;

//check if user is allowed here...
if ((intval($_uid) == 0) || !($allowed))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...


    /*
      ==============================================================================
      selecteren
      ==============================================================================
     */
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);
    $resource_id = intval(campus::get_POST_GET("resource_id"));
    $roster_id = intval(campus::get_POST_GET("roster_id"));
    $department_id = intval(campus::get_SESSION("department_id"));
    $departmentStruc = campus::get_department_info($department_id);
    $resource_info = campus::get_resource_info($resource_id);
    $query = "SELECT `lastname`,`firstname`, `official_code`, `date`, `campus_period`.`code`, `period_id`, `user_id`, `state`
					FROM `campus_reservation`
					    INNER JOIN `campus_period`
                                                ON `campus_period`.`id`=`campus_reservation`.`period_id`
					    INNER JOIN `user_user`
					    	ON `user_user`.`id`=`campus_reservation`.`user_id`
            			WHERE `resource_id`=" . $resource_id . " AND `date`>" . mktime(0, 0, 0, 9, 1, substr($academicYear, 0, 4)) . " ORDER BY `date`,`display_order`, `state` DESC";
    //echo $query;
    $result = mysql_query($query);
    // Pagina instellingen
    include(Path :: get_web_application_path('campus') . '/old_php/php_pdf/class.ezpdf.php');
    $pdf = & new \Cezpdf('a4', 'portrait');
    $pdf->ezSetMargins(95, 30, 30, 30);
    $pdf->selectFont(Path :: get_web_application_path('campus') . '/old_php/php_pdf/fonts/Helvetica.afm');
    //koptekst en voettekst
    $pdf->ezStartPageNumbers(550, 15, 10, 'left', 'pagina {PAGENUM} van {TOTALPAGENUM}', 1);
    $pdf->ezStartPageNumbers(40, 15, 10, 'right', $departmentStruc[key($departmentStruc)]['name'], 1);
    $pdf->ezStartPageNumbers(560, 775, 12, 'left', "Lokaal: " . $resource_info['code'], 1);
    $pdf->ezStartPageNumbers(560, 790, 12, 'left', "Reserveringen  " . $academicYear);
    $all = $pdf->openObject();
    $pdf->saveState();
    $pdf->setStrokeColor(0.6, 0.6, 0.6);
    $pdf->setLineStyle(2);
    $pdf->line(20, 765, 570, 765);
    $filename = "Reserveringen_" . $resource_info['code'];
    $ext = strtolower(substr($departmentStruc[$department_id]['logo'], -4));
    if ($ext == '.jpg')
    {
        $pdf->addJpegFromFile(THeme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 30, 770, 130);
    }
    elseif ($ext == '.png')
    {
        $pdf->addPngFromFile(THeme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 30, 770, 130);
    }
    $pdf->setColor(0, 0, 0);
    $pdf->addText(20, 750, 10, get_lang("colheadHour"));
    $pdf->addText(55, 750, 10, get_lang("colheadTeacher"));
    $pdf->addText(265, 750, 10, get_lang("colheadDiscipline") . " / " . get_lang("colheadClasses"));
    $pdf->setLineStyle(1);
    $pdf->line(20, 745, 570, 745);
    $pdf->line(50, 765, 50, 25);
    $pdf->line(255, 765, 255, 25);
    $pdf->line(475, 765, 475, 25);
    $pdf->restoreState();
    $pdf->closeObject();
    $pdf->addObject($all, 'all');
    $data = array();
    $prev_date = "";
    campus::document2pdf_footer($pdf, 595, 1.5);

    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        $date = DatetimeUtilities::format_locale_date("%A %d %B %Y", $rij['date']);
        if ($date <> $prev_date)
        {
            if ($pdf->ezPosY() < 100)
            {
                $pdf->ezNewPage();
                campus::document2pdf_footer($pdf, 595, 1.5);
            }
            $pdf->setStrokeColor(0.95, 0.95, 0.95);
            $pdf->setLineStyle(12);
            $pdf->line(20, $pdf->ezPosY() - 8, 570, $pdf->ezPosY() - 8);
            $pdf->setColor(0.3, 0.3, 0.55);
            $pdf->eZText($date, 10, array('aleft' => 55));
            $pdf->ezSetDy(-2);
        }
        $prev_date = $date;
        $disciplines_array = array();
        $classes_array = array();
        $query2 = 'SELECT t2.`assignment_id`, `display_order`, t2.`duration`, `campus_period`.`id` as period_id, t2.`period_id` as period_exists
			FROM `campus_period` LEFT JOIN (
                                SELECT `period_id`,`campus_assignment_rel_teacher`.`assignment_id`, `duration`, `campus_college`.`roster_id`,`user_id` FROM `campus_college`
                                    LEFT JOIN `campus_assignment_rel_teacher`
                                        ON `campus_college`.`assignment_id`=`campus_assignment_rel_teacher`.`assignment_id` ) as t2
				ON  `campus_period`.`id`= t2.`period_id` AND t2.`roster_id`=' . $roster_id . ' AND t2.`user_id`=' . $rij['user_id'] . '
			WHERE  `campus_period`.`department_id`=' . $department_id . ' AND `weekday`=' . strftime("%w", $rij['date']) . ' ORDER BY `display_order`';
        $result2 = mysql_query($query2);
        while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
        {
            // echo $rij2['display_order'].'=='.$rij2['period_id'].$rij2['assignment_id'].'<br>';
            if ($rij2['period_id'] == $rij2['period_exists'])
            { // there's a college record of this period
                $duration = $rij2['duration'];
                $assignment_id = $rij2['assignment_id'];
                $college_id = $rij2['college_id'];
            }
            elseif ($duration > 1)
            {
                $duration--;
            }
            else
            {
                $college_id = '';
                $assignment_id = '';
                $duration = 0;
            }
            if ($duration > 0)
            {
                if ($rij['period_id'] == $rij2['period_id'])
                {
                    $disciplines_array = campus::get_assignment2discipline($assignment_id, $disciplines_array);
                    $classes_array = campus::get_assignment2group($assignment_id, $classes_array);
                }
            }
        }
        $lijn1 = "";
        foreach ($disciplines_array as $id => $value)
        {
            $lijn1.=$value['code'] . " ";
        }
        $lijn2 = "";
        foreach ($classes_array as $id => $value)
        {
            $lijn2.=$value['code'] . " ";
        }
        $pdf->setColor(0, 0, 0);
        $pos = $pdf->ezPosY();
        $pdf->ezText("<i>" . $rij['lastname'] . " " . $rij['firstname'] . "(" . $rij['official_code'] . ")</i>", 10, array('aleft' => 60, 'aright' => 250), 0);
        $pdf->addText(25, $pdf->ezPosY(), 10, $rij['code'], 0);
        $pdf->ezSetY($pos);
        $pdf->ezText(get_lang("txtReservationState_" . $rij['state']), 8, array('aleft' => 480, 'aright' => 565), 0);
        $pdf->ezSetY($pos);
        $pdf->ezText("<i>" . $lijn1 . " " . $lijn2 . "</i>", 10, array('aleft' => 260, 'aright' => 460), 0);
    }
    $pdf->ezText("\n");
    $fileoption = array('Content-Disposition' => $filename . '.pdf');
    $pdf->ezStream($fileoption);
}
?>