<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($departmentStruc) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Display::display_error_message(get_lang("msgNoDepartmentMember"), false);
}
else
{//only teachers and platform administrator are allowed here...
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $week = DatetimeUtilities::get_days_long();
    // remove sunday and saturday from array...
    $week = array_slice($week, 1, 5, true);

    $user_id = intval(campus::get_POST_GET("user_id", $_uid));
    $action = campus::get_POST_GET("action");
    $dateselect = intval(campus::get_POST_GET("dateselect", mktime(0, 0, 0, date('m', time()), date('d', time()), date('Y', time()))));
    if ((strftime('%w', $dateselect) == 6) || (strftime('%w', $dateselect) == 0))
    {
        $dateselect = strtotime('next Monday', $dateselect);
    }
    // determin the active rosternumber...
    $activeroster = campus::get_activeroster($department_id, $dateselect);
    // read userinfo
    $user_info = campus::get_user_info($user_id);

    $reservationadmin = $is_platformadmin || $admin['roster']; //||($user2warn==$_uid);
    // calculate monday
    $monday = strtotime('Next Monday', strtotime('-1 Week', $dateselect));

    $kw = strftime('%V', $monday); // iso weeknummer op server
    if ($kw == null)
    {
        $kw = strftime('%U', $monday) + 1;
    } // weeknummer lokaal
    $prevweek = strtotime('-1 week', $monday);
    $nextweek = strtotime('+1 week', $monday);
    switch ($action)
    {
        case "release":
            {// release resources from roster
                // check if already released...
                $period_id = intval(campus::get_POST_GET("period_id"));
                $resource_id = intval(campus::get_POST_GET("resource_id"));

                $query = 'SELECT * FROM `campus_reservation` WHERE
						`date`=' . $dateselect . ' AND
 						`period_id`=' . $period_id . ' AND
						`user_id`=' . $user_id . ' AND
						`resource_id`=' . $resource_id . '';
                $result = mysql_query($query);
                if (mysql_num_rows($result) == 0)
                { // if not already released, mark the resource as released...
                    $query = 'INSERT `campus_reservation` SET
						`date`=' . $dateselect . ',
 						`period_id`=' . $period_id . ',
						`user_id`=' . $user_id . ',
						`resource_id`=' . $resource_id . ',
						`state`=' . $this::RESOURCE_RELEASED . '';
                    $result = mysql_query($query);
                    if ($result)
                    {
                        $message = get_lang("msgResourceReleased");
                    }
                }
            }
            break;
    }

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */


    if ($activeroster['roster_id'] > 0)
    {
        if ($message != '')
        {
            Display::normal_message($message, false);
        }
        $teacherslinks = "";
        $query = "SELECT DISTINCT `user_user`.`id`, `official_code`, `lastname`, `firstname`
   				    FROM `user_user`
				        INNER JOIN `campus_assignment_rel_teacher`
                                            ON `user_user`.`id`= `campus_assignment_rel_teacher`.`user_id`
				        INNER JOIN `campus_assignment`
                                            ON `campus_assignment`.`id`= `campus_assignment_rel_teacher`.`assignment_id`

		        WHERE `campus_assignment`.`curriculum_id`=" . $activeroster['curriculum_id'] . " ORDER BY `lastname`, `firstname`";
        $result = mysql_query($query);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            if ($user_id != $rij['id'])
            {
                $teacherslinks.="<a href=\"" . $this->get_url() . "&page=content&user_id=" . $rij['id'] . "\" title=\"" . $rij['firstname'] . " " . $rij['lastname'] . "\">" . $rij['official_code'] . "</a>  ";
            }
        }
        if (!empty($teacherslinks) || ($user_id > 0))
        {
            echo "<div >";
            echo $teacherslinks;
            echo "</div>";
            echo "<div style=\" float:right;\">";
            if ((isset($admin['roster']) && $admin['roster']) || $is_platformadmin)
            {
                echo ' <a href="' . $this->get_url() . '&page=roster2excel&rooster=teacher&roster_id=' . $activeroster['roster_id'] . '" target="_blank" >' . get_lang("txtRoster2Excel") . '</a> |';
                echo ' <a href="' . $this->get_url() . '&page=roster2pdf&compact=&rooster=teacher&select=complete&roster_id=' . $activeroster['roster_id'] . '" target="_blank" >' . get_lang("txtAllRoster2Pdf") . '</a> |';
            }
            echo ' <a href="' . $this->get_url() . '&page=roster2pdf&compact=on&rooster=teacher&select=complete&roster_id=' . $activeroster['roster_id'] . '" target="_blank" >' . get_lang("txtAllRoster2PdfCompact") . '</a> |';
            echo ' <a href="' . $this->get_url() . '&page=roster2pdf&compact=&rooster=teacher&select=' . $user_id . '&roster_id=' . $activeroster['roster_id'] . '" target="_blank" >' . get_lang("txtRoster2Pdf") . '</a> ';
            echo "</div>";
            echo "<b style=\"font-size: 18px;\"><i title=\"" . $user_info['firstname'] . " " . $user_info['lastname'] . "\">" . $user_info['official_code'] . "</i></b>";
            echo "<div style=\"clear:both\"></div>";
            //=============================================================================
            // UURROOSTER Leerkrachten.......
            //=============================================================================
            // De roosterstructuur bepalen...
            $rooster = campus::get_rosterarray($department_id);
            echo "
				<table align='center' style=\"width:100%;border: 1px #FFFFFF \">
					<tr class='campus_middle'>
						<td>
							<a  href=\"" . $this->get_url() . "&dateselect=" . $prevweek . "&user_id=" . $user_id . "\" title=\"" . get_lang("tooltip1WeekBack") . "\"><<<</a>
						</td>
						<td align='center' width='100%'>
							<b >De week van " . DatetimeUtilities::format_locale_date('%A %d %B %Y', $monday) . " (Week:" . $kw . ")" . "</b>
						</td>
						<td>
							&nbsp;&nbsp;<a  href=\"" . $this->get_url() . "&dateselect=" . $nextweek . "&user_id=" . $user_id . "\" title=\"" . get_lang("tooltip1WeekForward") . "\">>>></a>
						</td>
					</tr>
				</table>
			";

            $rooster = campus::get_rosterarray($department_id);

            //de uren selecteren van de gebruiker .
            // search for resources from roster that can be released.
            $query = 'SELECT `campus_assignment_rel_teacher`.`assignment_id`,`campus_college`.`id` as college_id, `weekday`,`code`, `display_order`,`duration`, `campus_period`.`id` as period_id
                                        FROM `campus_period`
                                            INNER JOIN `campus_college`
                                               ON `campus_period`.`id`=`campus_college`.`period_id`  AND `campus_college`.`roster_id`=' . $activeroster['roster_id'] . '
                                            INNER JOIN `campus_assignment_rel_teacher`
                                                ON `campus_assignment_rel_teacher`.`assignment_id`=`campus_college`.`assignment_id` AND `user_id`=' . $user_id . ' AND `campus_assignment_rel_teacher`.`roster_id`=' . $activeroster['roster_id'] . '
                                             WHERE `department_id`=' . $department_id . '
                                        ORDER BY `weekday`, `display_order` ';
            $result = mysql_query($query);
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                while ($rij['duration'] > 0)
                {
                    $rooster[$rij['display_order']][$rij['weekday']]['disciplines'] = campus::get_assignment2discipline($rij['assignment_id'], $rooster[$rij['display_order']][$rij['weekday']]['disciplines']);
                    $rooster[$rij['display_order']][$rij['weekday']]['groups'] = campus::get_assignment2group($rij['assignment_id'], $rooster[$rij['display_order']][$rij['weekday']]['groups']);
                    $rooster[$rij['display_order']][$rij['weekday']]['resources'] = campus::get_college2resource($rij['college_id'], $rooster[$rij['display_order']][$rij['weekday']]['resources']);
                    $rij['display_order']++;
                    $rij['duration']--;
                }
            }
            // Override resource with reservations ...
            $query = 'SELECT `resource_id`, `display_order`,`date`, `state`, `period_id` FROM `campus_reservation`
                            INNNER JOIN `campus_period` ON `campus_period`.`id`=`period_id`
						WHERE  `date`>=' . $monday . ' AND `date`<' . ($monday + 604800) . ' AND `user_id`=' . $user_id . '';
            $result = mysql_query($query) or die(mysql_error());
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $rooster[$rij['display_order']][strftime('%w', $rij['date'])][$rij['state']][$rij['resource_id']] = campus::get_resource_info($rij['resource_id']);
            }
            // uurrooster weergeven.....
            campus::display_complex_table_header($properties, array_merge(array(""), $week));
            foreach ($rooster as $hourkey => $value1)
            {
                $row = array();
                foreach ($week as $day => $daylong)
                {
                    $reservationdate = $monday + ($day - 1) * 86400;
                    $lijn1 = "";
                    foreach ($rooster[$hourkey][$day]['disciplines'] as $id => $value)
                    {
                        $lijn1.="<i title=\"" . $value['name'] . "\">" . $value['code'] . "</i> ";
                    }
                    $lijn2 = "";
                    foreach ($rooster[$hourkey][$day]['groups'] as $id => $value)
                    {
                        $lijn2.="<b title=\"" . $value['aantal'] . get_lang("tooltipStudents") . ".\">" . $value['code'] . "</b> ";
                    }
                    $lijn3 = "";
                    $original_resources = "";
                    if (array_key_exists($this::RESOURCE_OCCUPIED, $rooster[$hourkey][$day]))
                    {
                        foreach ($rooster[$hourkey][$day]['resources'] as $id => $value)
                        {
                            $original_resources.=$value['code'] . "&nbsp;";
                        }
                        foreach ($rooster[$hourkey][$day][$this::RESOURCE_OCCUPIED] as $id => $value)
                        {
                            $lijn3.="<i style=\"float:right;color:#FF5500;font-weight:bold;\" title=\"" . get_lang("tooltipOrgResources") . ": " . $original_resources . "\">" . $value['code'] . "&nbsp;</i>";
                        }
                    }
                    foreach ($rooster[$hourkey][$day]['resources'] as $id => $value)
                    {
                        if (!empty($rooster[$hourkey][$day][$this::RESOURCE_RELEASED][$id]))
                        {

                            if ($original_resources == "")
                            { // if $original_resource are empty there is no reservation of other resources..
                                $lijn3.="<i style=\"float:right;color:#999999;\" title=\"" . get_lang("tooltipResourceReleased") . "\">" . $value['code'] . "&nbsp;</i>";
                            }
                        }
                        else
                        {
                            if (($user_id == $_uid) || $reservationadmin)
                            {
                                $lijn3.='<i style="float:right" title="' . get_lang("tooltipReleaseResource") . '" ><a href="' . $this->get_url() . '&dateselect=' . $reservationdate . '&user_id=' . $user_id . '&resource_id=' . $id . '&period_id=' . $rooster[$hourkey][$day]['period_id'] . '&action=release" onclick="javascript:if(!confirm(\'' . get_lang("msgboxConfirmRelease") . '\')) return false;">' . $value['code'] . '</a>&nbsp;</i>';
                            }
                            else
                            {
                                $lijn3.="<i style=\"float:right\" title=\"" . $value['comment'] . "\" >" . $value['code'] . "&nbsp;</i>";
                            }
                        }
                    }
                    $row = array_merge($row, array("<div align=\"left\">" . $lijn1 . "</div><div align=\"center\">" . $lijn2 . "</div><div align=\"right\">" . $lijn3 . "</div>"));
                }
                campus::display_table_row($cellproperties, array_merge(array("<i style='font-size:8px'>" . DatetimeUtilities::format_locale_date("%H:%M", $rooster[$hourkey][$day]['start_time']) . "</i><br><b style=\"font-size:20px;\">" . $hourkey . "</b><br><i style='font-size:8px'>" . DatetimeUtilities::format_locale_date("%H:%M", $rooster[$hourkey][$day]['end_time']) . "</i>"), $row));
            }
            campus::display_table_footer();
        }
        else
        {
            Display::normal_message(get_lang('msgNoTeachersAssigned'), false);
        }
    }
    else
    {
        Display::error_message(get_lang("msgNoRoster"), false);
    }
}
?>