<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\DatetimeUtilities;
use common\libraries\PlatformSetting;

/*
  ==============================================================================
  INIT SECTION
  ==============================================================================
 */

//check if user is allowed here...
if ((intval($_uid) == 0) || !($is_teacher))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...

    /*
      ==============================================================================
      selecteren
      ==============================================================================
     */
    $week = DatetimeUtilities::get_days_long();
    // remove sunday and saturday from array...
    $week = array_slice($week, 1, 5, true);
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);
    $activeroster = campus::get_activeroster($department_id, $dateselect);
    $roster_id = intval(campus::get_POST_GET("roster_id", $activeroster['roster_id']));
    $title = $departmentStruc[$department_id]['code'];
    /*
      -----------------------------------------------------------
      Header
      -----------------------------------------------------------
     */
    header('Content-Type: html/text; charset=UTF-8');
    header("Content-Disposition: attachment; filename=" . $title . ".xls");
    header("Pragma: no-cache");
    header("Expires: 0");
    echo '<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />';
    echo pack(“CCC”,0xef,0xbb,0xbf);
    echo '		<style type="text/css">
				body         {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: normal; }
				TD.CEL       {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: NORMAL; border-left: 1px solid #000000;border-top: 1px solid #000000;border-right: 1px solid #000000;border-bottom: 1px solid #000000; }
				TD.KOLOMKOP  {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: bold;  border-left: 1px solid #000000;border-top: 1px solid #000000;border-right: 1px solid #000000;border-bottom: 1px solid #000000;}
				TD.KOLOMKOP1  {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: bold;  border-left: 1px solid #000000;border-top: 1px solid #000000;border-right: none;border-bottom: 1px solid #000000; padding-left: 3px;}
				TD.KOLOMKOP2  {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: bold;  border-left: none ;border-top: 1px solid #000000;border-right: 1px solid #000000;border-bottom: 1px solid #000000; padding-left: 3px;}
				TABLE        {border-left: 2px solid #000000;border-top: 2px solid #000000;border-right: 2px solid #000000;border-bottom: 2px solid #000000;}
			</style>
		';
    $roosterdata = campus::get_rosterarray($department_id);
    $query = "SELECT DISTINCT `campus_resource`.`id` FROM `campus_resource`
                                    INNER JOIN `campus_college_rel_resource`
                                        ON `campus_college_rel_resource`.`resource_id`=`campus_resource`.`id`
                                    INNER JOIN `campus_college`
                                        ON `campus_college_rel_resource`.`college_id`=`campus_college`.`id`
					WHERE  `roster_id` = " . $roster_id . " ORDER BY `display_order` ";
    $result = mysql_query($query) or die(mysql_error());
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        $array[] = $rij['id'];
    }
    foreach ($array as $key)
    {
        $query = 'SELECT t2.`assignment_id`,`college_id`, `weekday`,`code`, `display_order`,`duration`, `campus_period`.`id` as period_id, `duration`, t2.`period_id` as period_exists
                        FROM `campus_period`  LEFT JOIN (';
        $query.=' SELECT  `campus_college`.`id` as college_id, `campus_college`.`assignment_id`, `campus_college`.`period_id`, `campus_college`.`roster_id`, `duration`, `resource_id`
                        FROM `campus_college`
                            INNER JOIN `campus_college_rel_resource`
                                  ON `campus_college_rel_resource`.`college_id`=`campus_college`.`id` AND `resource_id`=' . $key;
        $query.=') as t2
                            ON `campus_period`.`id`=`t2`.`period_id`  AND t2.`roster_id`=' . $roster_id . '
                        WHERE `department_id`=' . $department_id . '
                     ORDER BY `weekday`, `display_order`';
        $result = mysql_query($query) or die(mysql_error());
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            if ($rij['period_id'] == $rij['period_exists'])
            { // there's a college record of this period
                $duration = $rij['duration'];
                $assignment_id = $rij['assignment_id'];
                $college_id = $rij['college_id'];
            }
            elseif ($duration > 1)
            {
                $duration--;
            }
            else
            {
                $college_id = '';
                $assignment_id = '';
                $duration = 0;
            }
            if ($duration > 0)
            {
                $roosterdata[$rij['display_order']][$rij['weekday']][$key]['period_id'] = $rij['period_id'];
                $roosterdata[$rij['display_order']][$rij['weekday']][$key]['teachers'] = campus::get_assignment2teacher($assignment_id, $activeroster['roster_id'], $roosterdata[$rij['display_order']][$rij['weekday']][$key]['teachers']);
                //$roosterdata[$rij['display_order']][$rij['weekday']]['disciplines'] = campus::get_assignment2discipline($assignment_id, $roosterdata[$rij['display_order']][$rij['weekday']]['disciplines']);
                $roosterdata[$rij['display_order']][$rij['weekday']][$key]['groups'] = campus::get_assignment2group($assignment_id, $roosterdata[$rij['display_order']][$rij['weekday']][$key]['groups']);
                $roosterdata[$rij['display_order']][$rij['weekday']][$key]['resources'] = campus::get_college2resource($college_id, $roosterdata[$rij['display_order']][$rij['weekday']][$key]['resources']);
            }
        }
    }
    // titels
    echo '<table  width=100% align="center" cellspacing="0" border="1" cellpadding="0">
			<tr> 
				<td class="KOLOMKOP1" colspan=3 height=25> 
					' . $title . '
				</td>
				<td class="KOLOMKOP2" colspan=2 align=RIGHT> 
					Schooljaar: ' . $academicYear . '
				</td>
			</tr> 
			<tr> 
				<td class="KOLOMKOP" width="250" VALIGN=BOTTOM> 
					Dag
				</td>
				<td class="KOLOMKOP" > 
					uur
				</td>
				<td class="KOLOMKOP" > 
					lokaal
				</td>
				<td class="KOLOMKOP" > 
					leerkracht
				</td>
				<td class="KOLOMKOP" > 
					klas
				</td>
			</tr>';

    $daynumber = 1;
    foreach ($week as $key => $day)
    {
        for ($key1 = 1; $key1 <= 8; $key1++)
        {
            $temp = $roosterdata[$key1][$key];

            foreach ($temp as $resource_id => $details)
            {
                if ($resource_id>0)
                {
                    echo "<tr>";
                    echo "<td Class='CEL'><b>" . $day . "</b></td>";
                    echo "<td Class='CEL'>" . $key1 . "</b></td>";
                    $resource = campus::get_resource_info($resource_id);
                    $lijn1 = $resource[$resource_id]['code'];
                    foreach ($details['resources'] as $id => $value)
                    {
                        if ($resource != $value['code'])
                        {
                            $lijn1.=" (" . $value['code'] . ")";
                        }
                    }
                    $lijn2 = "";
                    foreach ($details['teachers'] as $id => $value)
                    {
                        $lijn2.=$value['name'] . "(" . $value['official_code'] . ") ";
                    }
                    $lijn3 = "";
                    foreach ($details['groups'] as $id => $value)
                    {
                        $lijn3.=$value['code'] . "(" . $value['aantal'] . ") ";
                    }
                    echo "<td Class='CEL' align='left' width='200'>" . $lijn1 . "</td>";
                    echo "<td Class='CEL' align='left' width='200'>" . $lijn2 . "</td>";
                    echo "<td Class='CEL' align='left' width='200'>" . $lijn3 . "</td>";
                    $daynumber++;
                    echo "</tr>";
                }
            }
        }
    }

    echo "</table>";
}
?>