<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Theme;
use common\libraries\Path;

/*
  ==============================================================================
  INIT SECTION
  ==============================================================================
 */

//check if user is allowed here...
if (((intval($_uid) == 0) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...

    /* ==============================================================================
      Instellingen ophalen voor de geselecteerde dag department etc......
      ============================================================================== */
    $activeroster = campus::get_activeroster($department_id, $dateselect);
    $roster_id = intval(campus::get_POST_GET("roster_id", $activeroster['roster_id']));
    $curriculum_id= campus::get_roster2curriculum($roster_id);

    $title = "Vakoverzicht";
    // selecteer het department die bij het roosternummer hoort..
    $result = mysql_query('SELECT `department_id` FROM  `campus_curriculum` WHERE `id` = ' . $curriculum_id . ' LIMIT 1');
    $department_id = intval(mysql_result($result, 0, 0));
    $departmentStruc = campus::get_department_info($department_id);
    $classarray = campus::get_studentclasses($department_id);
    $roosterdata = campus::get_rosterarray($department_id);

    $marge_boven_cm = 3.5;
    $marge_links_cm = 2.0;
    $marge_onder_cm = 1.0;
    $marge_rechts_cm = 2.0;
    // Pagina instellingen
    include(Path :: get_web_application_path('campus') . '/old_php/php_pdf/class.ezpdf.php');
    $pdf = & new \Cezpdf('a4', 'portrait');
    $pdf->ezSetCmMargins($marge_boven_cm, $marge_onder_cm, $marge_links_cm, $marge_rechts_cm);
    $pdf->selectFont(Path :: get_web_application_path('campus') . '/old_php/php_pdf/fonts/Helvetica.afm');
    //koptekst en voettekst
    $pdf->ezStartPageNumbers(560, 20, 12, 'left', 'pagina {PAGENUM} van {TOTALPAGENUM}', 1);
    $pdf->ezStartPageNumbers(40, 20, 10, 'right', strftime('%A %d %B %Y'), 1);
    $pdf->ezStartPageNumbers(560, 780, 14, 'left', $title, 1);
    $pdf->ezStartPageNumbers(560, 800, 20, 'left', $departmentStruc[$department_id]['name'], 1);
    $all = $pdf->openObject();
    $pdf->saveState();
    $filename = $title;
    $ext = strtolower(substr($departmentStruc[$department_id]['logo'], -4));
    if ($ext == '.jpg')
    {
        $pdf->addJpegFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 30, 750, 130);
    }
    elseif ($ext == '.png')
    {
        $pdf->addPngFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 30, 750, 130);
    }
    $pdf->restoreState();
    $pdf->closeObject();
    $pdf->addObject($all, 'all');
    $marge_links = $marge_links_cm / 2.54 * 72;
    $marge_boven = $marge_boven_cm / 2.54 * 72;
    $i = 0;
    foreach ($classarray as $classid => $value)
    {
        $query = "SELECT DISTINCT `user_id`,`discipline_id`,concat(`user_id`,',',`discipline_id`) as assignment, SUM(`duration`) as `houres`";
        $query.=" FROM `campus_assignment_rel_group`
			INNER JOIN `campus_assignment`
                            ON `campus_assignment`.`id`=`campus_assignment_rel_group`.`assignment_id`
			INNER JOIN `campus_discipline`
                            ON `campus_assignment`.`discipline_id`=`campus_discipline`.`id`
			INNER JOIN `campus_assignment_rel_teacher`
                            ON `campus_assignment_rel_teacher`.`assignment_id`=`campus_assignment_rel_group`.`assignment_id` AND `campus_assignment_rel_teacher`.`roster_id`=" . $roster_id . "
			INNER JOIN `campus_college`
                            ON `campus_assignment_rel_group`.`assignment_id`=`campus_college`.`assignment_id`
				WHERE `group_id`=" . $classid . " AND `campus_college`.`roster_id`=" . $roster_id . " GROUP BY (assignment) ORDER BY display_order";
        $classinfo = campus::get_class_info($classid);
       campus::document2pdf_footer($pdf, 595, 1.5);
    $pdf->ezText("Klas: " . $classinfo[$classid]['code'] . "\n\n", 24);
        // uurrooster inlezen.
        $result = mysql_query($query);
        $line = array();
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $discipline_info = campus::get_discipline_info($rij['discipline_id']);
            $vak = $discipline_info[$rij['discipline_id']]['name'] . " (" . $discipline_info[$rij['discipline_id']]['code'] . ")";
            if ($rij['user_id'] != '')
            {
                $teacher_info = campus::get_user_info($rij['user_id']);
                $leerkracht = $teacher_info['lastname'] . " " . substr($teacher_info['firstname'], 0, 1) . ". (" . $teacher_info['official_code'] . ")";
            }
            else
            {
                $leerkracht = "";
            }
            $line[] = array('vak' => $vak, 'leerkracht' => $leerkracht, 'houres' => $rij['houres']);
            $i++;
        }
        $pdf->ezTable($line, array('vak' => 'VAK:', 'leerkracht' => 'LEERKRACHT:', 'houres' => ''), '', array('showHeadings' => 1, 'shaded' => 0, 'showLines' => 3, 'fontSize' => 14, 'width' => 500));
        $pdf->ezNewPage();
    }
    $fileoption = array('Content-Disposition' => $filename . '.pdf');
    $pdf->ezStream($fileoption);
}
?>
