<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\DatetimeUtilities;
use common\libraries\PlatformSetting;

/*
  ==============================================================================
  INIT SECTION
  ==============================================================================
 */

//check if user is allowed here...
if (((intval($_uid) == 0) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...

    /*
      ==============================================================================
      selecteren
      ==============================================================================
     */
    $week = DatetimeUtilities::get_days_long();
    // remove sunday and saturday from array...
    $week = array_slice($week, 1, 5, true);
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);
    $rooster = campus::get_POST_GET("rooster");
    $activeroster = campus::get_activeroster($department_id, $dateselect);
    $roster_id = intval(campus::get_POST_GET("roster_id", $activeroster['roster_id']));
    Switch ($rooster)
    {
        case "teacher" :
            {
                $title = get_lang('roster_report');
            }
            break;
        case "resource" :
            {
                $title = get_lang('reservationroster_report');
            }
            break;
        case "class" :
            {
                $title = get_lang('studentroster_report');
            }
            break;
    }
    // selecteer het department die bij het roosternummer hoort..

    $curriculum_id = campus::get_roster2curriculum($roster_id);
    $result = mysql_query('SELECT `department_id` FROM  `campus_curriculum` WHERE `id` = ' . $curriculum_id . ' LIMIT 1');
    $department_id = intval(mysql_result($result, 0, 0));
    $departmentStruc = campus::get_department_info($department_id);

    switch ($rooster)
    {
        case "teacher" :
            {
                // Query van het gegevensbestand....
                $query = "SELECT DISTINCT `user_id` FROM `campus_assignment`
            				INNER JOIN `campus_assignment_rel_teacher`
						ON `campus_assignment`.`id`=`campus_assignment_rel_teacher`.`assignment_id`
            				INNER JOIN `user_user`
						ON `user_user`.`id` = `campus_assignment_rel_teacher`.`user_id`
					WHERE  `roster_id` = " . $roster_id . " ORDER BY `lastname`,`firstname`";
                $result = mysql_query($query);
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    $array[] = $rij['user_id'];
                }
            }
            break;
        case "resource" :
            {
                // Query van het gegevensbestand....
                $query = "SELECT DISTINCT `campus_resource`.`id` FROM `campus_resource`
                                    INNER JOIN `campus_college_rel_resource`
                                        ON `campus_college_rel_resource`.`resource_id`=`campus_resource`.`id`
                                    INNER JOIN `campus_college`
                                        ON `campus_college_rel_resource`.`college_id`=`campus_college`.`id`
					WHERE  `roster_id` = " . $roster_id . " ORDER BY `display_order` ";
                $result = mysql_query($query) or die(mysql_error());
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    $array[] = $rij['id'];
                }
            }
            break;
        case "class" :
            {
                $classarray = campus::get_studentclasses($department_id);
                foreach ($classarray as $classid => $value)
                {
                    $array[] = $classid;
                }
            }
            break;
    }



    $i = 0;

    /*
      -----------------------------------------------------------
      Header
      -----------------------------------------------------------
     */
    header('Content-Type: html/text; charset=UTF-8');
    header("Content-Disposition: attachment; filename=" . $title . ".xls");
    header("Pragma: no-cache");
    header("Expires: 0");
    echo '<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />';
    echo pack(“CCC”,0xef,0xbb,0xbf);
    echo '		<style type="text/css">
				body         {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: normal; }
				TD.CEL       {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: NORMAL; border-left: 1px solid #000000;border-top: 1px solid #000000;border-right: 1px solid #000000;border-bottom: 1px solid #000000; }
				TD.KOLOMKOP  {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: bold;  border-left: 1px solid #000000;border-top: 1px solid #000000;border-right: 1px solid #000000;border-bottom: 1px solid #000000;}
				TD.KOLOMKOP1  {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: bold;  border-left: 1px solid #000000;border-top: 1px solid #000000;border-right: none;border-bottom: 1px solid #000000; padding-left: 3px;}
				TD.KOLOMKOP2  {text-decoration: none; color: #000000; font-family: arial, Helvetica, Verdana;font-size: 14px; font-weight: bold;  border-left: none ;border-top: 1px solid #000000;border-right: 1px solid #000000;border-bottom: 1px solid #000000; padding-left: 3px;}
				TABLE        {border-left: 2px solid #000000;border-top: 2px solid #000000;border-right: 2px solid #000000;border-bottom: 2px solid #000000;}
			</style>
		';
    foreach ($array as $key)
    {
        $roosterdata = campus::get_rosterarray($department_id);
        $query = 'SELECT `campus_college`.`assignment_id`, `campus_college`.`id` as college_id, `weekday`,`code`, `display_order`,`duration`, `campus_period`.`id` as period_id, `duration`
                        FROM `campus_period`
                            INNER JOIN `campus_college`
                                ON `campus_period`.`id`=`campus_college`.`period_id`  AND `campus_college`.`roster_id`=' . $roster_id;
        if ($key != '')
        {
            switch ($rooster)
            {
                case "teacher" :
                    {
                        $query.='       INNER JOIN `campus_assignment_rel_teacher`
                                            ON `campus_assignment_rel_teacher`.`assignment_id`=`campus_college`.`assignment_id` AND `user_id`=' . $key . ' AND `campus_assignment_rel_teacher`.`roster_id`=' . $roster_id;
                        $userinfo = campus::get_user_info($key);
                        $title = "Leerkracht: " . $userinfo['firstname'] . " " . $userinfo['lastname'];
                    }
                    break;
                case "resource" :
                    {
                        $query.='       INNER JOIN `campus_college_rel_resource`
                                            ON `campus_college_rel_resource`.`college_id`=`campus_college`.`id` AND `resource_id`=' . $key;
                        $resourceinfo = campus::get_resource_info($key);
                        $title = "Lokaal: " . $resourceinfo['code'];
                    }
                    break;
                case "class" :
                    {
                        $query.='      INNER JOIN `campus_assignment_rel_group`
                                                ON  `group_id`=' . $key . ' AND `campus_assignment_rel_group`.`assignment_id`=`campus_college`.`assignment_id`';
                        $classinfo = campus::get_class_info($key);
                        $title = "Klas: " . $classinfo[$key]['code'];
                    }
                    break;
            }

            $query.='  WHERE `department_id`=' . $department_id . '
                             ORDER BY `weekday`, `display_order`';

            echo '<table  width=100% ALIGN="center" CELLSPACING=0 BORDER=1 CELLPADDING=0>
				<TR> 
					<TD Class="KOLOMKOP1" COLSPAN=3 Height=25> 
						' . $title . '
					</TD>
					<TD Class="KOLOMKOP2" COLSPAN=3 ALIGN=RIGHT> 
						' . get_lang('AcademicYear') . ':' . $academicYear . '
					</TD>
				</TR> 
				<TR> 
					<TD Class="KOLOMKOP" WIDTH="250" VALIGN=BOTTOM> 
						&nbsp;
					</TD>
					<TD Class="KOLOMKOP" > 
						' . $week[1] . '
					</TD>
					<TD Class="KOLOMKOP" > 
						' . $week[2] . '
					</TD>
					<TD Class="KOLOMKOP" > 
						' . $week[3] . '
					</TD>
					<TD Class="KOLOMKOP" > 
						' . $week[4] . '
					</TD>
					<TD Class="KOLOMKOP" > 
						' . $week[5] . '
					</TD>
				</TR>';
            // uurrooster inlezen.
            $result = mysql_query($query) or die(mysql_error());
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                while ($rij['duration'] > 0)
                {
                    $roosterdata[$rij['display_order']][$rij['weekday']]['teachers'] = campus::get_assignment2teacher($rij['assignment_id'], $roster_id, $roosterdata[$rij['display_order']][$rij['weekday']]['teachers']);
                    $roosterdata[$rij['display_order']][$rij['weekday']]['disciplines'] = campus::get_assignment2discipline($rij['assignment_id'], $roosterdata[$rij['display_order']][$rij['weekday']]['disciplines']);
                    $roosterdata[$rij['display_order']][$rij['weekday']]['groups'] = campus::get_assignment2group($rij['assignment_id'], $roosterdata[$rij['display_order']][$rij['weekday']]['groups']);
                    $roosterdata[$rij['display_order']][$rij['weekday']]['resources'] = campus::get_college2resource($rij['college_id'], $roosterdata[$rij['display_order']][$rij['weekday']]['resources']);
                    $rij['display_order']++;
                    $rij['duration']--;
                }
            }
            $i++;
            // titels

            for ($key1 = 1; $key1 <= 8; $key1++)
            {
                echo "<tr>";
                echo "<td Class='CEL'><i style='font-size:8px'>" . DatetimeUtilities::format_locale_date("%H:%M", $roosterdata[$key1][1]['start_time']) . "<br></i><b style='font-size:24px'>" . $key1 . "<br></b><i style='font-size:8px'>" . DatetimeUtilities::format_locale_date("%H:%M", $roosterdata[$key1][1]['end_time']) . "</i></td>";
                $daynumber = 1;
                foreach ($week as $key => $day)
                {
                    switch ($rooster)
                    {
                        case "class" :
                            {
                                $lijn1 = "";
                                foreach ($roosterdata[$key1][$key]['teachers'] as $id => $value)
                                {
                                    $lijn1.=$value['official_code'] . " ";
                                }
                                $lijn2 = "";
                                foreach ($roosterdata[$key1][$key]['disciplines'] as $id => $value)
                                {
                                    $lijn2.=$value['code'] . " ";
                                }
                                $lijn3 = "";
                                foreach ($roosterdata[$key1][$key]['resources'] as $id => $value)
                                {
                                    $lijn3.=$value['code'] . " ";
                                }
                            }
                            break;
                        case "resource" :
                            {
                                $lijn1 = "";
                                foreach ($roosterdata[$key1][$key]['disciplines'] as $id => $value)
                                {
                                    $lijn1.=$value['code'] . " ";
                                }
                                $lijn2 = "";
                                foreach ($roosterdata[$key1][$key]['groups'] as $id => $value)
                                {
                                    $lijn2.=$value['code'] . " ";
                                }
                                $lijn3 = "";
                                foreach ($roosterdata[$key1][$key]['teachers'] as $id => $value)
                                {
                                    $lijn3.=$value['official_code'] . " ";
                                }
                            }
                            break;
                        case "teacher" :
                            {
                                $lijn1 = "";
                                foreach ($roosterdata[$key1][$key]['disciplines'] as $id => $value)
                                {
                                    $lijn1.=$value['code'] . " ";
                                }
                                $lijn2 = "";
                                foreach ($roosterdata[$key1][$key]['groups'] as $id => $value)
                                {
                                    $lijn2.=$value['code'] . " ";
                                }
                                $lijn3 = "";
                                foreach ($roosterdata[$key1][$key]['resources'] as $id => $value)
                                {
                                    $lijn3.=$value['code'] . " ";
                                }
                            }
                            break;
                    }
                    echo "<td Class='CEL'>";
                    echo $lijn1 . "<br>";
                    echo $lijn2 . "<br>";
                    echo $lijn3;
                    echo "</td>";
                    $daynumber++;
                }
                echo "</tr>";
            }
        }
        echo "</table>";
    }
}
?>