<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Theme;
use common\libraries\Path;
use common\libraries\DatetimeUtilities;
use common\libraries\PlatformSetting;

$compact = (campus::get_POST_GET("compact") == 'on') ? true : false;
$select = campus::get_POST_GET("select");

$allowed = $is_teacher || ($rooster == "class") || $is_platformadmin;

//check if user is allowed here...
if ((intval($_uid) == 0) || !($allowed))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...

    /*
      ==============================================================================
      selecteren
      ==============================================================================
     */
    $week = DatetimeUtilities::get_days_long();
    // remove sunday and saturday from array...
    $week = array_slice($week, 1, 5, true);
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);
    $rooster = campus::get_POST_GET("rooster");
    $activeroster = campus::get_activeroster($department_id, $dateselect);
    $roster_id = intval(campus::get_POST_GET("roster_id", $activeroster['roster_id']));
    switch ($rooster)
    {
        case "teacher" :
            {
                $title = get_lang('roster_report');
            }
            break;
        case "resource" :
            {
                $title = get_lang('reservationroster_report');
            }
            break;
        case "class" :
            {
                $title = get_lang('studentroster_report');
            }
            break;
    }
    // selecteer het department die bij het roosternummer hoort..
    $curriculum_id = campus::get_roster2curriculum($roster_id);
    $result = mysql_query('SELECT `department_id` FROM  `campus_curriculum` WHERE `id` = ' . $curriculum_id . ' LIMIT 1');
    $department_id = intval(mysql_result($result, 0, 0));
    $departmentStruc = campus::get_department_info($department_id);
    if ($select != "complete")
    {
        $array = explode("_", $select);
    }
    else
    {
        switch ($rooster)
        {
            case "teacher" :
                {
                    // Query van het gegevensbestand....
                    $query = "SELECT DISTINCT `id` FROM `user_user`
            				INNER JOIN `campus_assignment_rel_teacher`
						ON `user_user`.`id` = `campus_assignment_rel_teacher`.`user_id`
					WHERE  `roster_id` = " . $roster_id . " ORDER BY `lastname`,`firstname`";
                    $result = mysql_query($query);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $array[] = $rij['id'];
                    }
                }
                break;
            case "resource" :
                {
                    // Query van het gegevensbestand....
                    $query = "SELECT DISTINCT `campus_resource`.`id` FROM `campus_resource`
                                    INNER JOIN `campus_college_rel_resource`
                                        ON `campus_college_rel_resource`.`resource_id`=`campus_resource`.`id`
                                    INNER JOIN `campus_college`
                                        ON `campus_college_rel_resource`.`college_id`=`campus_college`.`id`
					WHERE  `roster_id` = " . $roster_id . " ORDER BY `display_order`,  `campus_resource`.`id`";
                    $result = mysql_query($query);
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $array[] = $rij['id'];
                    }
                }
                break;
            case "class" :
                {
                    $classarray = campus::get_studentclasses($department_id);
                    foreach ($classarray as $classid => $value)
                    {
                        $array[] = $classid;
                    }
                }
                break;
        }
    }

    if ($compact)
    {
        $marge_boven_cm = 2.5;
    }
    else
    {
        $marge_boven_cm = 2.5;
    }
    $marge_links_cm = 0.7;
    $marge_onder_cm = 1.0;
    $marge_rechts_cm = 2.0;
    // Pagina instellingen
    include(Path :: get_web_application_path('campus') . '/old_php/php_pdf/class.ezpdf.php');
    $pdf = & new \Cezpdf('a4', 'landscape');
    $pdf->ezSetCmMargins($marge_boven_cm, $marge_onder_cm, $marge_links_cm, $marge_rechts_cm);
    $pdf->selectFont(Path :: get_web_application_path('campus') . '/old_php/php_pdf/fonts/Helvetica.afm');
    //koptekst en voettekst
    $pdf->ezStartPageNumbers(820, 20, 12, 'left', 'pagina {PAGENUM} van {TOTALPAGENUM}', 1);
    $pdf->ezStartPageNumbers(40, 20, 10, 'right', DatetimeUtilities::format_locale_date('%A %d %B %Y', time()), 1);
    $pdf->ezStartPageNumbers(820, 535, 14, 'left', $title, 1);
    $pdf->ezStartPageNumbers(820, 555, 24, 'left', $departmentStruc[$department_id]['name'], 1);
    $all = $pdf->openObject();
    $pdf->saveState();
    $filename = $title;
    $ext = strtolower(substr($departmentStruc[$department_id]['logo'], -4));
    if ($ext == '.jpg')
    {
        $pdf->addJpegFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 20, 530, 100);
    }
    elseif ($ext == '.png')
    {
        $pdf->addPngFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 20, 530, 100);
    }
    $pdf->restoreState();
    $pdf->closeObject();
    $pdf->addObject($all, 'all');
    $marge_links = $marge_links_cm / 2.54 * 72;
    $marge_boven = $marge_boven_cm / 2.54 * 72;
    campus::document2pdf_footer($pdf, 842, 1.5);

    $i = 0;
    foreach ($array as $key)
    {
        $roosterdata = campus::get_rosterarray($department_id);
        $query = 'SELECT `campus_college`.`assignment_id`, `campus_college`.`id` as college_id, `weekday`,`code`, `display_order`,`duration`, `campus_period`.`id` as period_id, `duration`
                        FROM `campus_period`
                            INNER JOIN `campus_college`
                                ON `campus_period`.`id`=`campus_college`.`period_id`  AND `campus_college`.`roster_id`=' . $roster_id ;
        if ($key != '')
        {
            switch ($rooster)
            {
                case "teacher" :
                    {
                        $query.='       INNER JOIN `campus_assignment_rel_teacher`
                                            ON `campus_assignment_rel_teacher`.`assignment_id`=`campus_college`.`assignment_id` AND `user_id`=' . $key. ' AND `campus_assignment_rel_teacher`.`roster_id`=' . $roster_id;
                        $userinfo = campus::get_user_info($key);
                        $title = utf8_decode("Leerkracht: " . $userinfo['firstname'] . " " . $userinfo['lastname']);
                    }
                    break;
                case "resource" :
                    {
                        $query.='       INNER JOIN `campus_college_rel_resource`
                                            ON `campus_college_rel_resource`.`college_id`=`campus_college`.`id` AND `resource_id`=' . $key;
                        $resourceinfo = campus::get_resource_info($key);
                        $title = utf8_decode("Lokaal: " . $resourceinfo['code']);
                    }
                    break;
                case "class" :
                    {
                        $query.='      INNER JOIN `campus_assignment_rel_group`
                                                ON  `group_id`=' . $key . ' AND `campus_assignment_rel_group`.`assignment_id`=`campus_college`.`assignment_id`';
                        $classinfo = campus::get_class_info($key);
                        $title = utf8_decode("Klas: " . $classinfo[$key]['code']);
                    }
                    break;
            }

            $query.='  WHERE `department_id`=' . $department_id . '
                             ORDER BY `weekday`, `display_order`';

            $result = mysql_query($query) or die (mysql_error());
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                while ($rij['duration'] > 0)
                {
                    $roosterdata[$rij['display_order']][$rij['weekday']]['teachers'] = campus::get_assignment2teacher($rij['assignment_id'], $roster_id, $roosterdata[$rij['display_order']][$rij['weekday']]['teachers']);
                    $roosterdata[$rij['display_order']][$rij['weekday']]['disciplines'] = campus::get_assignment2discipline($rij['assignment_id'], $roosterdata[$rij['display_order']][$rij['weekday']]['disciplines']);
                    $roosterdata[$rij['display_order']][$rij['weekday']]['groups'] = campus::get_assignment2group($rij['assignment_id'], $roosterdata[$rij['display_order']][$rij['weekday']]['groups']);
                    $roosterdata[$rij['display_order']][$rij['weekday']]['resources'] = campus::get_college2resource($rij['college_id'], $roosterdata[$rij['display_order']][$rij['weekday']]['resources']);
                    $rij['display_order']++;
                    $rij['duration']--;
                }
            }

            if (!$compact && ($i >= 1))
            {
                $pdf->ezNewPage();
                campus::document2pdf_footer($pdf, 842, 1.5);
            }
            $i++;
            // initialisatie
            if ($compact)
            {
                if ($i == 1)
                {
                    $x = $marge_links;
                    $y = 595.28 - $marge_boven;
                }
                else
                {
                    $x = $marge_links;
                    if ($i <= 3)
                    {
                        $y = $y - 165;
                    }
                    else
                    {
                        $pdf->ezNewPage();
                        campus::document2pdf_footer($pdf, 842, 1.5);
                        $y = 595.28 - $marge_boven;
                        $i = 1;
                    }
                }
            }
            else
            {
                $x = $marge_links;
                $y = 595.28 - $marge_boven;
            }
            if ($compact)
            {
                // Achtergronden ....
                $pdf->setColor(0.85, 0.85, 0.85);
                $pdf->filledRectangle($x, $y - 20, 800, 20); // titelkader
                $pdf->filledRectangle($x, $y - 40, 800, 15); // Dagen
                $pdf->filledRectangle($x, $y - 160, 20, 120); // Uren
                // Kaders ....
                $pdf->setColor(0, 0, 0);
                $pdf->Rectangle($x, ($y - 20), 800, 20); // titelkader
                $pdf->Rectangle($x, ($y - 160), 800, 135); // Dagen
                // vertikale lijnen ....
                $pdf->line($x + 20, $y - 25, $x + 20, ($y - 160));
                $pdf->line($x + 20 + 156, $y - 25, $x + 20 + 156, ($y - 160));
                $pdf->line($x + 20 + 2 * 156, $y - 25, $x + 20 + 2 * 156, ($y - 160));
                $pdf->line($x + 20 + 3 * 156, $y - 25, $x + 20 + 3 * 156, ($y - 160));
                $pdf->line($x + 20 + 4 * 156, $y - 25, $x + 20 + 4 * 156, ($y - 160));
                // titels
                $pdf->addText($x + 5, $y - 15, 12, $title);
                $pdf->addText($x + 25, $y - 35, 10, $week[1]);
                $pdf->addText($x + 25 + 156, $y - 35, 10, $week[2]);
                $pdf->addText($x + 25 + 2 * 156, $y - 35, 10, $week[3]);
                $pdf->addText($x + 25 + 3 * 156, $y - 35, 10, $week[4]);
                $pdf->addText($x + 25 + 4 * 156, $y - 35, 10, $week[5]);
            }
            else
            {
                // Achtergronden ....
                $pdf->setColor(0.85, 0.85, 0.85);
                $pdf->filledRectangle($x, $y - 25, 800, 25); // titelkader
                $pdf->filledRectangle($x, $y - 45, 800, 15); // Dagen
                $pdf->filledRectangle($x, $y - 445, 20, 400); // Uren
                // Kaders ....
                $pdf->setColor(0, 0, 0);
                $pdf->Rectangle($x, ($y - 25), 800, 25); // titelkader
                $pdf->Rectangle($x, ($y - 445), 800, 415); // Dagen
                // vertikale lijnen ....
                $pdf->line($x + 20, $y - 30, $x + 20, ($y - 445));
                $pdf->line($x + 20 + 156, $y - 30, $x + 20 + 156, ($y - 445));
                $pdf->line($x + 20 + 2 * 156, $y - 30, $x + 20 + 2 * 156, ($y - 445));
                $pdf->line($x + 20 + 3 * 156, $y - 30, $x + 20 + 3 * 156, ($y - 445));
                $pdf->line($x + 20 + 4 * 156, $y - 30, $x + 20 + 4 * 156, ($y - 445));
                // titels
                $pdf->addText($x + 5, $y - 17, 14, $title);
                $pdf->addText($x + 25, $y - 40, 10, $week[1]);
                $pdf->addText($x + 25 + 156, $y - 40, 10, $week[2]);
                $pdf->addText($x + 25 + 2 * 156, $y - 40, 10, $week[3]);
                $pdf->addText($x + 25 + 3 * 156, $y - 40, 10, $week[4]);
                $pdf->addText($x + 25 + 4 * 156, $y - 40, 10, $week[5]);
            }
            for ($key1 = 1; $key1 <= 8; $key1++)
            {
                if ($compact)
                {
                    $pdf->addText(($x + 2), ($y + 15 - ($key1 * 15)) - 52, 11, $key1);
                }
                else
                {
                    $pdf->addText(($x + 2), ($y + 50 - ($key1 * 50)) - 52, 6, DatetimeUtilities::format_locale_date("%H:%M", $roosterdata[$key1][1]['start_time']));
                    $pdf->addText(($x + 2), ($y + 50 - ($key1 * 50)) - 80, 24, $key1);
                    $pdf->addText(($x + 2), ($y + 50 - ($key1 * 50)) - 91, 6, DatetimeUtilities::format_locale_date("%H:%M", $roosterdata[$key1][1]['end_time']));
                }
                if ($compact)
                {
                    $pdf->line($x, ($y - 25 - ($key1 * 15)), $x + 800, ($y - 25 - ($key1 * 15)));
                }
                else
                {
                    $pdf->line($x, ($y + 5 - ($key1 * 50)), $x + 800, ($y + 5 - ($key1 * 50)));
                }
                $daynumber = 1;
                foreach ($week as $day => $day_long)
                {
                    switch ($rooster)
                    {
                        case "class" :
                            {
                                $lijn1 = "";
                                foreach ($roosterdata[$key1][$day]['teachers'] as $id => $value)
                                {
                                    $lijn1.=$value['official_code'] . " ";
                                }
                                $lijn2 = "";
                                foreach ($roosterdata[$key1][$day]['disciplines'] as $id => $value)
                                {
                                    $lijn2.=$value['code'] . " ";
                                }
                                $lijn3 = "";
                                foreach ($roosterdata[$key1][$day]['resources'] as $id => $value)
                                {
                                    $lijn3.=$value['code'] . " ";
                                }
                            }
                            break;
                        case "resource" :
                            {
                                $lijn1 = "";
                                foreach ($roosterdata[$key1][$day]['disciplines'] as $id => $value)
                                {
                                    $lijn1.=$value['code'] . " ";
                                }
                                $lijn2 = "";
                                foreach ($roosterdata[$key1][$day]['groups'] as $id => $value)
                                {
                                    $lijn2.=$value['code'] . " ";
                                }
                                $lijn3 = "";
                                foreach ($roosterdata[$key1][$day]['teachers'] as $id => $value)
                                {
                                    $lijn3.=$value['official_code'] . " ";
                                }
                            }
                            break;
                        case "teacher" :
                            {
                                $lijn1 = "";
                                foreach ($roosterdata[$key1][$day]['disciplines'] as $id => $value)
                                {
                                    $lijn1.=$value['code'] . " ";
                                }
                                $lijn2 = "";
                                foreach ($roosterdata[$key1][$day]['groups'] as $id => $value)
                                {
                                    $lijn2.=$value['code'] . " ";
                                }
                                $lijn3 = "";
                                foreach ($roosterdata[$key1][$day]['resources'] as $id => $value)
                                {
                                    $lijn3.=$value['code'] . " ";
                                }
                            }
                            break;
                        case "discipline" :
                            {
                                $lijn1 = "";
                                foreach ($roosterdata[$key1][$day]['teachers'] as $id => $value)
                                {
                                    $lijn1.=$value['official_code'] . " ";
                                }
                                $lijn2 = "";
                                foreach ($roosterdata[$key1][$day]['groups'] as $id => $value)
                                {
                                    $lijn2.=$value['code'] . " ";
                                }
                                $lijn3 = "";
                                foreach ($roosterdata[$key1][$day]['resources'] as $id => $value)
                                {
                                    $lijn3.=$value['code'] . " ";
                                }
                            }
                            break;
                    }
                    if ($compact)
                    {
                        $pdf->addText(($x - 131 + ($daynumber * 156)), ($y - ($key1 * 15)) - 37, 10, utf8_decode($lijn1 . " " . $lijn2 . " " . $lijn3));
                    }
                    else
                    {
                        $pdf->addText(($x - 131 + ($daynumber * 156)), ($y - ($key1 * 50)) - 10, 11, utf8_decode($lijn1));
                        $pdf->addText(($x - 66 + ($daynumber * 156) - (($pdf->getTextWidth(11, utf8_decode($lijn2))) / 2)), ($y - ($key1 * 50)) - 25, 11, utf8_decode($lijn2));
                        $pdf->addText(($x - 1 + ($daynumber * 156) - ($pdf->getTextWidth(11, utf8_decode($lijn3)))), ($y - ($key1 * 50)) - 40, 11, utf8_decode($lijn3));
                    }
                    $daynumber++;
                }
            }
        }
    }
    $fileoption = array('Content-Disposition' => $filename . '.pdf');
    $pdf->ezStream($fileoption);
}
?>