<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Text;
use common\libraries\Display;
use common\libraries\PlatformSetting;
use common\libraries\Path;

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($departmentStruc) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoDepartmentMember"), false);
}
else
{//only teachers and platform administrator are allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */

    $activeroster = campus::get_activeroster($department_id);
    $teacher_id = intval(campus::get_POST_GET("teacher_id", $_uid));
    $assignment_id = intval(campus::get_POST_GET("assignment_id"));
    $reportcard_id = intval(campus::get_POST_GET("reportcard_id"));
    $report_id = intval(campus::get_POST_GET("report_id"));
    $search = campus::get_POST_GET("search");
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);

    // except for studenttracking level 3 select class from classteacher list...
    if (!($admin['studentTrackingLevel3']))
    {
        $sql = "SELECT `group_id` FROM `campus_teacher_rel_group` WHERE `teacher_id` = " . $_uid . " AND `department_id` = " . $department_id . " ";
        $result = mysql_query($sql);
    }
    list($defaultclass) = mysql_fetch_row($result);
    $selectie = campus::get_POST_GET("selectie");
    if ($selectie != "")
    {
        $select = explode(",", $selectie);
    }
    else
    {
        $select = campus::get_POST_GET("select", $defaultclass);
    }

    /*
      ==============================================================================
      Determin student tracking settings
      ==============================================================================
     */
    $trackingcategorys = campus::get_trackingcategorys($department_id);

    if (!empty($trackingcategorys))
    { //tracking enabled
         $tracking_enabled = TRUE;
        $defaulttabtitle = get_lang("txtStudentTracking");
        $classtracking = campus::get_trackingrights($_uid, $department_id);

        // hidden records and all schools visible
        $nolimit = (($admin['studentTrackingLevel3']) || ($is_platformadmin));
        // Permission to read records, only level0 is not allowed to read other...
        $permRead = $admin['studentTrackingLevel3'] || $admin['studentTrackingLevel2'] || $admin['studentTrackingLevel1'] || $is_platformadmin;
        // Permission to write records, only level1 is not allowed to write...
        $permWrite = $admin['studentTrackingLevel3'] || $admin['studentTrackingLevel2'] || $admin['studentTrackingLevel0'] || $is_platformadmin;
        // Permission to print
        $permPrint = $admin['studentTracking2Pdf'] || $is_platformadmin;
        // Only Current academic year
        $currentYearOnly = $admin['studentTrackingLevel1'] || $admin['studentTrackingLevel2'];
        $schoolreporting = $permPrint; // not for classcoach...
        // needed for printout confirmation of tracking info...
        $action = campus::get_POST_GET("action");
        $tracking_category = campus::get_POST_GET("tracking_category");
        $tracking_title = campus::get_POST_GET("tracking_title");
        // when printing newest tracking items display confirm message to mark records as printed....
        switch ($action)
        {
            case "message" :
                {
                    $message = get_lang("msgConfirmPrintout");
                    $message.= '<br><a href="' . $this->get_url() . '&selectie=' . $selectie . '&tracking_category=' . urlencode($tracking_category) . '&tracking_title=' . urlencode($tracking_title) . '&action=confirm">' . get_lang("txtYes") . '</a> /
							<a href="' . $this->get_url() . '&action=abort">' . get_lang("txtNo") . '</a>';
                }
                break;
            case "confirm" :
                { // confirm new records as 'printed' or as 'viewed'
                    //select students from class selection
                    $sql = "SELECT `user_user`.`id`
			            FROM `user_user`
			                LEFT JOIN `group_group_rel_user`
			                   ON `user_user`.`id` = `group_group_rel_user`.`user_id`
					LEFT JOIN `campus_department_rel_group`
                                            ON `group_group_rel_user`.`group_id` = `campus_department_rel_group`.`group_id`
							WHERE `type`=2 AND `department_id`=" . $department_id . " ";
                    if ($selectie != 0)
                    {
                        $sql.="AND (`group_group_rel_user`.`group_id`=" . ereg_replace(",", " OR `group_group_rel_user`.`group_id`=", $selectie) . ")";
                    }
                    $result = mysql_query($sql);
                    while ($student = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        //select all new trackingitems for the student
                        $sql = "SELECT `campus_student_tracking`.`id`
                                    FROM `campus_student_tracking`
                                        LEFT JOIN `campus_tracking_category`
                                            ON `campus_student_tracking`.`tracking_category`=`campus_tracking_category`.`tracking_category` AND `campus_tracking_category`.`department_id`=" . $department_id . "
					LEFT JOIN `campus_tracking_title`
                                            ON `campus_tracking_category`.`id`=`campus_tracking_title`.`category_id` AND `campus_tracking_title`.`tracking_title`=`campus_student_tracking`.`tracking_title`
					LEFT JOIN `campus_tracking_visited`
                                            ON `campus_student_tracking`.`id` = `campus_tracking_visited`.`tracking_id` AND `teacher_id`=" . $_uid . "
                                    WHERE ";
                        $sql .= "(`silent_tracking` is NULL OR `silent_tracking`=0) AND `student_id`=" . $student['id'];
                        if ($tracking_title != "")
                        { // confirm print...
                            $sql .= ( $tracking_category == 'all') ? "" : " AND `campus_student_tracking`.`tracking_category`='" . $tracking_category . "'";
                            $sql .= " AND `campus_student_tracking`.`tracking_title`='" . $tracking_title . "'";
                        }
                        $result2 = mysql_query($sql . " AND `teacher_id` is NULL") or die(mysql_error());
                        while ($rij = mysql_fetch_array($result2, MYSQL_ASSOC))
                        {
                            // insert campus_tracking printed or viewed record...
                            $query = "INSERT `campus_tracking_visited` SET `tracking_id`='" . $rij['id'] . "', `teacher_id`='" . $_uid . "', ";
                            $query.= ( $tracking_title != "") ? "`viewed`=0, `printed`=1" : "`viewed`=1, `printed`=0";
                            $result3 = mysql_query($query);
                        }
                        $result2 = mysql_query($sql . (($tracking_title != "") ? " AND `printed`=0" : " AND `viewed`=0"));
                        while ($rij = mysql_fetch_array($result2, MYSQL_ASSOC))
                        {
                            // update campus_tracking_printed record...
                            $query = "UPDATE `campus_tracking_visited` SET " . (($tracking_title != "") ? "`printed`=1" : "`viewed`=1") . "
										WHERE `tracking_id`='" . $rij['id'] . "' AND `teacher_id`='" . $_uid . "'";
                            $result3 = mysql_query($query);
                        }
                    }
                }
                break;
        }
    }
    else
    {
        $defaulttabtitle = get_lang("txtStudents");
        $tracking_enabled = FALSE;
    }
    if ($selectie == "")
    {
        if (is_array($select))
        {
            $selectie = "";
            foreach ($select as $key)
            {
                $selectie.=$key . ",";
            }
            $selectie = substr($selectie, 0, -1);
        }
        else
        {
            $selectie = intval($select);
        }
    }
    if ($classtracking[$selectie] == 'classTeacher')
    {
        $permPrint = TRUE;
    }


    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    // ======================================================================================
    $classes = campus::get_studentclasses($department_id);
    if (!empty($classes))
    {
        //* *** REPORT DISABLE ***
        // ============================= report select teacher.... ==============================
        if ($is_platformadmin)
        {
            echo "<form method=\"post\" action=\"" . $this->get_url() . "\" name=\"formselectteacher\">";
            echo "<input type=\"hidden\" name=\"page\" value=\"content\" >";
            echo "<input type=\"hidden\" name=\"action\" value=\"list\" >";
            echo "<input type=\"hidden\" name=\"select\" value=\"" . $select . "\" >";
            echo "<select name=\"teacher_id\" SIZE=\"1\" OnChange='javascript:document . formselectteacher . submit();
                    ' >";
            echo "<option value=\"\">&nbsp;</option>";
            $teachers = campus::get_teachers($department_id);
            foreach ($teachers as $teacherid => $value)
            {
                echo "<option value=\"" . $teacherid . "\" " . (($teacher_id == $teacherid) ? 'SELECTED' : '') . ">" . $value['official_code'] . ": " . $value['fullname'] . "</option>";
            }
            echo "</select></form>";
        }
        //*** REPORT DISABLE *** */
        $myclasses = campus::get_teacher2group($teacher_id, $activeroster['curriculum_id']);
        $grouplist = "";
        $mygrouplist = "";
        echo "<form action=\"" . $this->get_url() . "\" METHOD=\"POST\" NAME=\"Selectklas\">";
        echo "<input type=\"hidden\" name=\"teacher_id\" value=\"" . $teacher_id . "\" >";
        echo "<table border=0 cellspacing=0 cellpadding=0><tr>";
        foreach ($classes as $key => $value)
        {
            if ((!empty($classtracking[$key]) || $permRead) && ($tracking_enabled))
            { // if tracking allowed check for changed records in class...
                $query2 = 'SELECT `campus_student_tracking`.`id`
	       					FROM `campus_student_tracking`
		 			            INNER JOIN `group_group_rel_user`
                                                        ON `campus_student_tracking`.`student_id` = `group_group_rel_user`.`user_id`
                                                    LEFT JOIN `campus_tracking_category`
							ON `campus_student_tracking`.`tracking_category`=`campus_tracking_category`.`tracking_category` AND `campus_tracking_category`.`department_id`=' . $department_id . '
                                                    LEFT JOIN `campus_tracking_title`
							ON `campus_tracking_category`.`id`=`campus_tracking_title`.`category_id` AND `campus_tracking_title`.`tracking_title`=`campus_student_tracking`.`tracking_title`
                                                    LEFT JOIN `campus_tracking_visited`
                                                        ON `campus_student_tracking`.`id` = `campus_tracking_visited`.`tracking_id` AND `teacher_id`=' . $_uid . '
						WHERE `group_id`=' . $key . ' AND `override_id`=0 AND (`silent_tracking` is NULL OR `silent_tracking`=0) AND ( `teacher_id` is NULL OR  `viewed`=FALSE) ';
                // current year only...
                $query2 .= ' AND `date` >=' . mktime(0, 0, 0, 7, 1, substr($academicYear, 0, 4)) . '	AND `date` <=' . mktime(0, 0, 0, 8, 31, substr($academicYear, 5, 4)) . '';

                $query2 .= ( $nolimit) ? ' AND `department_code`<>""' : ' AND `department_code`="' . $departmentStruc[$department_id]['code'] . '" AND `public`=1 ';
                $query2 .= ' LIMIT 1';
                // echo $academicYear . $query2 . '<br>';
                $result2 = mysql_query($query2);
                $numrows = mysql_num_rows($result2);
                $changed = ($numrows > 0) ? '<a href="' . $this->get_studenttracking_url() . '&page=trackingnews&class_id=' . $key . '" style="font-decoration:bold; color:red;font-size:18px;" title="' . get_lang("tooltipShowNewComments") . $classes[$key]['code'] . '">*</a>' : '';
            }
            else
            {
                $changed = "";
            }
            if (array_key_exists($key, $myclasses))
            {
                if (($select == 0)&&(!$admin['studentTrackingLevel3']))
                {
                    $select = $key;
                    $selectie = $key;
                }
                $mygrouplist.=" <a href=\"" . $this->get_url() . "&select=" . $key . "&teacher_id=" . $teacher_id . "\" title=\"" . get_lang("tooltipShow") . " " . $classes[$key]['name'] . "\">" . $classes[$key]['code'] . "</a>" . $changed;
            }
            else
            {
                $grouplist.=" <a href=\"" . $this->get_url() . "&select=" . $key . "&teacher_id=" . $teacher_id . "\" title=\"" . get_lang("tooltipShow") . " " . $classes[$key]['name'] . "\">" . $classes[$key]['code'] . "</a>" . $changed;
            }
        }
        echo "<td valign='bottom'><b>" . get_lang("txtStudentClasses") . "</b></td>";
        echo "<td align=right><b>" . get_lang("Search") . ":</b> <input type='tekst' name='search' OnChange='javascript:Selectklas . submit();
                    ' style=\"width:200px;\" value='" . $search . "'></td>";
        echo "<td align=right style='width: 220px' rowspan=4><b>" . get_lang("txtMultiple") . "<BR></b>
	   				<SELECT name=\"select[]\" OnChange='javascript:document . Selectklas . submit();
                    ' multiple=\"multiple\" size=5 style=\"width:200px;\"> ";
        foreach ($classes as $key => $value)
        {
            echo "<OPTION VALUE=\"" . $key . "\" " . ((is_array($select)) ? ((in_array($key, $select)) ? 'SELECTED' : '') : (($select == $key) ? 'SELECTED' : '')) . ">" . $classes[$key]['code'] . " (" . $classes[$key]['aantal'] . " " . get_lang("txtStudents") . ")</OPTION>";
        }
        echo "</SELECT>";
        echo "</td>";
        echo "</tr>";
        echo "<tr><td colspan=2>";
        echo $grouplist;
        echo "</td></tr>";
        echo "<tr><td colspan=2  valign='bottom'>";
        if (!empty($myclasses))
        {
            echo "<b>" . get_lang("txtMyClasses") . "</b>";
            echo "</td></tr>";
            echo "<tr><td colspan=2>";
            echo $mygrouplist;
            echo "</td></tr>";
        }
        echo "</table></form>";
        if (($activeroster['curriculum_id'] > 0) && ($select != 0))
        {
            echo "<form method=\"post\" action=\"" . $this->get_url() . "\" name=\"frmreportcard\">";
            echo "<input type=\"hidden\" name=\"page\" value=\"content\" >";
            echo "<input type=\"hidden\" name=\"select\" value=\"" . $select . "\" >";
            echo "<input type=\"hidden\" name=\"action\" value=\"list\" >";
            echo "<input type=\"hidden\" name=\"teacher_id\" value=\"" . $teacher_id . "\" >";
            echo "<input type=\"hidden\" name=\"reportcard_id\" value=\"" . $reportcard_id . "\" >";
            echo "<input type=\"hidden\" name=\"report_id\" value=\"" . $report_id . "\" >";
            echo "<br clear=\"all\"><div id='lvs_tabs'><ul>";
            if ($teacher_id != 0)
            {
                if (($reportcard_id == 0) || ($report_id == 0))
                {
                    echo "<li id='current'><a href='#' title='" . get_lang('tooltipStudentTracking') . "'>" . $defaulttabtitle . "</a></li>";
                }
                else
                {
                    echo "<li ><a href='#' OnmouseDown='javascript:document.frmreportcard.report_id.value=0;document.frmreportcard.reportcard_id.value=0;' OnmouseUp='javascript:document.frmreportcard.submit();' >" . $defaulttabtitle . "</a></li>";
                }
                // ================ report =========================
                /*                 * ** REPORT DISABLE *** */
                if (!is_array($select))
                {
                    //select reportcards from selected class ....
                    $query = "SELECT DISTINCT `campus_assignment`.`id` as assignment_id,`campus_reportcard`.`id` as reportcard_id,`comment`, `title`, `report_id`,`user_id` FROM `campus_assignment`
					INNER JOIN `campus_reportcard`
						ON `campus_assignment`.`id`=`campus_reportcard`.`assignment_id`
					INNER JOIN `campus_report`
						ON `campus_report`.`id`=`campus_reportcard`.`report_id`
					INNER JOIN `campus_assignment_rel_group`
						ON `campus_assignment`.`id`=`campus_assignment_rel_group`.`assignment_id`
					INNER JOIN `campus_assignment_rel_teacher`
						ON `campus_assignment`.`id`=`campus_assignment_rel_teacher`.`assignment_id`
						WHERE `roster_id`=" . $activeroster['roster_id'] . " AND `group_id`=" . $select . " ORDER BY `display_order`";
                    $result = mysql_query($query);
                    if (mysql_num_rows($result) > 0)
                    {
                        $report_enable = TRUE;
                        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                        {
                            if ($rij['user_id'] == $teacher_id)
                            {
                                // ===============================================================
                                // generate Assignment list details........
                                // ===============================================================
                                // DISCIPLINE ARRAY...
                                $query2 = "SELECT `discipline_id`, `code`, `name`
							FROM `campus_assignment`
                                                            INNER JOIN `campus_discipline`
								ON `campus_discipline`.`id`=`campus_assignment`.`discipline_id`
							WHERE `campus_assignment`.`id`=" . $rij['assignment_id'] . " ORDER BY `code`";
                                $result2 = mysql_query($query2) or die(mysql_error());
                                $selectoption = "";
                                while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                                {
                                    $discipline = $rij2['code'];
                                    $disciplinetooltip = $rij2['name'];
                                }
                                // CLASSES ARRAY...
                                $group_array = array();
                                $query2 = "SELECT `id`, `code`, `name`
							FROM `campus_assignment_rel_group`
								INNER JOIN `group_group`
									ON `campus_assignment_rel_group`.`group_id` = `group_group`.`id`
								WHERE `assignment_id`=" . $rij['assignment_id'] . " ORDER BY `code`";
                                $result2 = mysql_query($query2);
                                $grouplist = '';
                                while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                                {
                                    $group_array[$rij2['id']]['code'] = $rij2['code'];
                                    $grouplist .= $rij2['code'] . " ";
                                }
                                if (($report_id == $rij['report_id']) && ($reportcard_id == $rij['reportcard_id']))
                                {
                                    echo '<li id="current"><a href="#" title="' . $disciplinetooltip . ' (' . $grouplist . '): ' . $rij['comment'] . '">' . $discipline . ': ' . $rij['title'] . '</a></li>';
                                    $report_id = $rij['report_id']; // in case $report_id = 0
                                    $reportcard_id = $rij['reportcard_id']; // in case $report_id = 0
                                    $groups = $group_array;
                                }
                                else
                                {
                                    echo '<li ><a href="#" OnmouseDown="javascript:document.frmreportcard.report_id.value=\'' . $rij['report_id'] . '\';document.frmreportcard.reportcard_id.value=\'' . $rij['reportcard_id'] . '\';" OnmouseUp="javascript:document.frmreportcard.submit();" title="' . $disciplinetooltip . ' (' . $grouplist . '): ' . $rij['comment'] . '">' . $discipline . ': ' . $rij['title'] . '</a></li>';
                                }
                            }
                        }
                    }
                    else
                    {
                        $report_enable = FALSE;
                    }
                }

                // =================================== END REPORT =========================
                /*                 * ** REPORT DISABLE *** */
                echo "</ul></div></form><br clear=\"all\">";
            }
        }
        if (!empty($message))
        {
            Display::warning_message($message, false);
        }
        if (($reportcard_id == 0) || ($report_id == 0))
        {
            include("studentlist.php");
        }
        else
        {
            // *** REPORT DISABLE ***
  
            include_once (Path :: get(SYS_APP_PATH).'campus/old_php/studentreport/teacherreport.php'); //REPORT
            
        }
    }
    else
    {
        Display::warning_message(get_lang('msgNoStudentclassAssigned'), false);
    }
}
?>