<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Theme;
use common\libraries\Path;
use common\libraries\PlatformSetting;

/*
  ==============================================================================
  This is a studentfotolist to Pdf Export utility.
  ==============================================================================
 */

//check if user is allowed here...
if (((intval($_uid) == 0) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);

    $select = campus::get_POST_GET("select");
    // de department van de klassen bepalen afhankelijk van de eerste klas van de selectie
    $sql = "SELECT `name`, `student_pics`, `logo`
        FROM `campus_department`
        LEFT JOIN `campus_department_rel_group`
                   ON `campus_department`.`id` = `campus_department_rel_group`.`department_id` AND  `type`=2
        WHERE `campus_department_rel_group`.`group_id` = " . strtok($select, ",") . " LIMIT 1";
    $result = mysql_query($sql);
    $department = mysql_fetch_array($result, MYSQL_ASSOC);
    /*
      ==============================================================================
      Klas selecteren
      ==============================================================================
     */

    // Query van het gegevensbestand....
    $query = "SELECT `display_order`, `lastname`, `firstname`, `official_code`, `email`, `group_group`.`code`, `username`, `picture_uri`
            FROM `group_group_rel_user`
                LEFT JOIN `user_user`
                   ON `user_user`.`id` = `group_group_rel_user`.`user_id`
                LEFT JOIN `group_group`
                   ON `group_group`.`id` = `group_group_rel_user`.`group_id` WHERE ";
    $filter = "`group_group_rel_user`.`group_id`=" . ereg_replace(",", " OR `group_group_rel_user`.`group_id`=", $select);
    $sql = $query . $filter . " ORDER BY `group_group`.`code`, `display_order`,`lastname`,`firstname`";
    $result = mysql_query($sql);
    $aantal = mysql_num_rows($result);

    /*
      ==============================================================================
      Leerlingen lijst maken
      ==============================================================================
     */
// Pagina instellingen
    include(Path :: get_web_application_path('campus') . '/old_php/php_pdf/class.ezpdf.php');
    $pdf = & new \Cezpdf('a4', 'landscape');
    $pdf->ezSetCmMargins(2, 2, 2, 2);
    $pdf->selectFont(Path :: get_web_application_path('campus') . '/old_php/php_pdf/fonts/Helvetica.afm');
    //koptekst en voettekst
    $pdf->ezStartPageNumbers(820, 15, 12, 'left', 'pagina {PAGENUM} van {TOTALPAGENUM}', 1);
    $pdf->ezStartPageNumbers(820, 550, 20, 'left', $department['name'], 1);
    $all = $pdf->openObject();
    $pdf->saveState();
    $pdf->setStrokeColor(0.8, 0.8, 0.8);
    $pdf->setLineStyle(5);
    $pdf->line(20, 490, 820, 490);
    if ((substr($department['logo'], -3) == 'jpg') || (substr($department['logo'], -3) == 'JPG'))
    {
        $pdf->addJpegFromFile(Theme::get_image_system_path('application/campus') . $department['logo'], 30, 495, 200);
    }
    elseif ((substr($department['logo'], -3) == 'png') || (substr($department['logo'], -3) == 'PNG'))
    {
        $pdf->addPngFromFile(Theme::get_image_system_path('application/campus') . $department['logo'], 30, 495, 200);
    }
    $pdf->restoreState();
    $pdf->closeObject();
    // note that object can be told to appear on just odd or even pages by changing 'all' to 'odd'
    // or 'even'.
    $pdf->addObject($all, 'all');

    //Titel samenstellen
    //eigenlijke info
    $x = -125;
    $y = 300;
    $vorige = "eerste";
    $filename = '';
    while (list($order, $naam, $voornaam, $stamnummer, $email, $klas, $username, $picture_uri ) = mysql_fetch_row($result))
    {
        if ($vorige != $klas)
        {
            $filename.=$klas . ' ';
            if ($vorige == "eerste")
            {
                $pdf->addTextWrap(20, 520, 800, 18, $klas, 'right');
            }
            else
            {
                $pdf->ezNewPage();
                $x = -125;
                $y = 300;
                $pdf->addTextWrap(20, 520, 800, 18, $klas, 'right');
            }
            $vorige = $klas;
            campus::document2pdf_footer($pdf, 842, 1.5);
        }
        $x = $x + 160;
        if ($x > 820)
        {
            $x = 35;
            $y = $y - 230;
            if ($y < 0)
            {
                $pdf->ezNewPage();
                $y = 300;
                $pdf->addTextWrap(20, 520, 800, 18, $klas, 'right');
                campus::document2pdf_footer($pdf, 842, 1.5);
            }
        }
        $pdf->setColor(0.8, 0.8, 0.8);
        $pdf->filledRectangle($x + 10, $y - 10, 120, 180);
        $pdf->setColor(0.9, 0.9, 0.9);
        $pdf->filledRectangle($x, $y, 120, 180);
        $pdf->setColor(0.8, 0.8, 0.8);
        $pdf->addText($x + 35, $y + 25, 24, "GEEN FOTO ", -55);
        $pdf->setColor(1, 1, 1);
        $pdf->addText($x + 30, $y + 25, 24, "GEEN FOTO ", -55);
        if ((!empty($picture_uri)) && (is_file(Path :: get(SYS_USER_PATH) . $picture_uri)))
        {
            if ((substr($picture_uri, -3) == 'jpg') || (substr($picture_uri, -3) == 'JPG'))
            {
                $pdf->addJpegFromFile(Path :: get(SYS_USER_PATH) . $picture_uri, $x, $y, 120);
            }
            elseif ((substr($picture_uri, -3) == 'png') || (substr($picture_uri, -3) == 'PNG'))
            {
                $pdf->addPngFromFile(Path :: get(SYS_USER_PATH) . $picture_uri, $x, $y, 120);
            }
        }
        $pdf->setColor(0, 0, 0);
        $pdf->addText($x, $y - 25, 14, utf8_decode($naam));
        $pdf->addText($x, $y - 40, 12, utf8_decode($voornaam));
        $pdf->addText(($x + 130 - ($pdf->getTextWidth(12, $klas))), $y - 25, 12, $klas);
        $pdf->addText(($x + 130 - ($pdf->getTextWidth(12, $stamnummer))), $y - 40, 12, $stamnummer);
        $pdf->setColor(0.2, 0.2, 0.2);
        $pdf->addText($x + 5, $y + 158, 24, $order);
        $pdf->setColor(0.8, 0.8, 0.8);
        $pdf->addText($x + 3, $y + 160, 24, $order);
        $pdf->setColor(0, 0, 0);
    }
    $pdf->ezText("\n");
    $fileoption = array('Content-Disposition' => substr($filename, 0, -1) . '.pdf');
    $pdf->ezStream($fileoption);
}
?>