<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Theme;
use common\libraries\Display;
use common\libraries\ResourceManager;
use common\libraries\Path;

/*
  ==============================================================================
  This is a content file included in the index.php file in this directory.
  ==============================================================================
 */

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($departmentStruc) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoDepartmentMember"), false);
}
else
{//only teachers and platform administrator are allowed here...

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    echo "<div style=\"clear:both\"></div>";
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/javascript/hide_show.js');

    /*
      -----------------------------------------------------------
      Geselecteerde lijst....
      -----------------------------------------------------------
     */
    if ((($select != "") || ($schoolreporting)) && ($search == ""))
    {
        // extra export functions...
        //echo ("<div style=\"clear:both\"></div>");
        $printMenu = "";
        if ($select != "")
        {
            $printMenu.= '<li>&nbsp;&nbsp;<a href="' . $this->get_url() . '&page=studentlist2excell&select=' . $selectie . '" target="_blank">' . get_lang("txt2Xls") . '</a></li>';
            $printMenu.= '<li>&nbsp;&nbsp;<a href="' . $this->get_url() . '&page=studentfotolistsmall2pdf&select=' . $selectie . '" target="_blank">' . get_lang("txtClass2PdfPhotos") . '(30)</a></li>';
            $printMenu.= '<li>&nbsp;&nbsp;<a href="' . $this->get_url() . '&page=studentfotolistbig2pdf&select=' . $selectie . '" target="_blank">' . get_lang("txtClass2PdfPhotos") . '(10)</a></li>';
            // $printMenu.= '<li>&nbsp;&nbsp;<a href="'. $this->get_campus_agenda_url() . '&page=calender2pdf&select=' . $selectie . '" target="_blank">' . get_lang("txtClassCalender2Pdf") . '</a></li>';
        }
        if ((!empty($classtracking[$selectie]) || $permRead) && ($tracking_enabled))
        {

            $sql = "SELECT `tracking_title` FROM `campus_tracking_title`
							INNER JOIN `campus_tracking_category`
								ON `campus_tracking_title`.`category_id`=`campus_tracking_category`.`id`
				  			 WHERE `department_id`=" . $department_id . " LIMIT 1";
            $result = mysql_query($sql);
            if (($select != "") || (mysql_numrows($result) > 0))
            {
                $printMenu.= '<li id="campus_pulldwnMnu_subtitle">';
                $printMenu.= '&nbsp;&nbsp;<b>' . get_lang("txtTrackingClassView") . '</b>';
                $printMenu.= '</li>';
                if (($permPrint))
                { // Build reports for the complete student tracking, only possible when one or more classes are selected
                    if ($select != "")
                    {
                        $printMenu.= '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_studenttracking_url() . '&page=projection&class_id=' . $selectie . '">' . get_lang("txtStudentTrackingProjection") . '</a></li>';
                    }
                    $printMenu.= '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_studenttracking_url() . '&page=studentfiche2pdf&select=' . $selectie . '" target="_blank">' . get_lang("txtStudentTracking2Pdf") . '</a></li>';
                    $printMenu.= $schoolreporting ? '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_studenttracking_url() . '&page=studentfiche2pdf&select=' . $selectie . '&filter=Complete" target="_blank">' . get_lang("txtStudentTracking2Pdf") . ' volledig</a></li>' : '';
                }
                $i = 1;
                foreach ($trackingcategorys as $key => $value)
                { // Build reports by category's
                    $printMenuTracking = "";
                    $sql = "SELECT `tracking_title` FROM `campus_tracking_title`
								INNER JOIN `campus_tracking_category`
									ON `campus_tracking_title`.`category_id`=`campus_tracking_category`.`id`
					  			 WHERE `tracking_category`='" . $value['name'] . "' AND `department_id`=" . $department_id . " ORDER BY `campus_tracking_title`.`display_order`";
                    $result = mysql_query($sql);
                    //if ((mysql_numrows($result)>0))
                    //{
                    $i++;
                    $printMenuTracking.= '<ul id="types' . $i . '" style="display:none; ">';
                    $j = 0;
                    //if ($select!="")
                    //{ // Build reports for complete category, only possible when one or more classes are selected
                    $printMenuTracking.= '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_studenttracking_url() . '&page=studentfiche2pdf&select=' . $selectie . '&tracking_category=' . urlencode($value['name']) . '" target="_blank">' . get_lang("txtStudentTracking2PdfCategory") . '</a></li>';
                    $j++;
                    //}
                    if (mysql_numrows($result) > 0)
                    {
                        while ($rijform = mysql_fetch_array($result, MYSQL_ASSOC))
                        {// Build reports for predefined titles from a category
                            $printMenuTracking.= '<li onmouseover="javascript: showID(\'types' . $i . '_' . $j . '\');" onmouseout="javascript: hideID(\'types' . $i . '_' . $j . '\');" style="z-index:' . (300 - $j) . ';">
							&nbsp;&nbsp;<b>' . $rijform['tracking_title'] . '</b>
							<ul  id="types' . $i . '_' . $j . '" style="display:none; Z-index: 1000;">
                                                            <li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_studenttracking_url() . '&page=trackingclasslist&select=' . $selectie . '&tracking_category=all&tracking_title=' . urlencode($rijform['tracking_title']) . '">' . get_lang('txtTrackingClasslist') . '</a></li>';
                            if ($permPrint)
                            { // Build all possible reports for studenttracking...
                                $printMenuTracking.= '      <li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_studenttracking_url() . '&page=classfiche2pdf&select=' . $selectie . '&tracking_category=' . urlencode($value['name']) . '&tracking_title=' . urlencode($rijform['tracking_title']) . '&photo=1" target="_blank">' . get_lang('txtClassOverviewPhoto2PdfTitle') . '</a></li>
                                                            <li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_studenttracking_url() . '&page=classfiche2pdf&select=' . $selectie . '&tracking_category=' . urlencode($value['name']) . '&tracking_title=' . urlencode($rijform['tracking_title']) . '" target="_blank">' . get_lang('txtClassOverview2PdfTitle') . '</a></li>
                                                            <li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_studenttracking_url() . '&page=classfiche2pdf&select=' . $selectie . '&tracking_category=' . urlencode($value['name']) . '&tracking_title=' . urlencode($rijform['tracking_title']) . '&filter=newest" onclick="javascript:(location.href=\'' . $this->get_url() . '&selectie=' . $selectie . '&tracking_category=' . urlencode($value['name']) . '&tracking_title=' . urlencode($rijform['tracking_title']) . '&action=message\')" target="_blank">' . get_lang('txtClassOverview2PdfTitleNewest') . '</a></li>
                                                            <li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_studenttracking_url() . '&page=studentfiche2pdf&select=' . $selectie . '&tracking_category=' . urlencode($value['name']) . '&tracking_title=' . urlencode($rijform['tracking_title']) . '" target="_blank">' . get_lang('txtStudentTracking2PdfTitle') . '</a></li>
                                                            <li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_studenttracking_url() . '&page=studentfiche2pdf&select=' . $selectie . '&tracking_category=' . urlencode($value['name']) . '&tracking_title=' . urlencode($rijform['tracking_title']) . '&filter=newest" onclick="javascript:(location.href=\'' . $this->get_url() . '&selectie=' . $selectie . '&tracking_category=' . urlencode($value['name']) . '&tracking_title=' . urlencode($rijform['tracking_title']) . '&action=message\')" target="_blank">' . get_lang('txtStudentTracking2PdfTitleNewest') . '</a></li>';
                            }

                            $printMenuTracking.= '</ul></li>
											';
                            $j++;
                        }
                    }
                    $printMenuTracking.= "</ul>";
                    //}
                    if ($printMenuTracking != "")
                    {
                        $printMenu.= "<li onmouseover=\"javascript: showID('types" . $i . "');\" onmouseout=\"javascript: hideID('types" . $i . "');\" style='Z-index:" . (200 - $i) . ";'>";
                        $printMenu.= "&nbsp;&nbsp;<b >" . $value['name'] . "</b>";
                        $printMenu.= $printMenuTracking;
                        $printMenu.= "</li>";
                    }
                }
                $printMenu.= "<li onmouseover=\"javascript: showID('titles');\" onmouseout=\"javascript: hideID('titles');\" style='Z-index: " . (200 - ($i + 1)) . ";'>";
                $printMenu.= "&nbsp;&nbsp;<b>" . get_lang("txtTrackingTitles") . "</b>";
                $printMenu.= "<ul id='titles' style='display:none;'>";
                $sql = "SELECT `tracking_title`, COUNT(*) as `number` FROM `campus_tracking_title`
								INNER JOIN `campus_tracking_category`
									ON `campus_tracking_category`.`id`= `campus_tracking_title`.`category_id`
					 			 WHERE `department_id`=" . $department_id . " GROUP BY `tracking_title` ORDER BY `tracking_title`";
                $result = mysql_query($sql);
                $j = 0;
                while ($rijform = mysql_fetch_array($result, MYSQL_ASSOC))
                {// Build reports for predefined titles from all category's
                    if ($rijform['number'] > 1)
                    {
                        $printMenu.= '<li onmouseover="javascript: showID(\'titles' . $j . '\');" onmouseout="javascript: hideID(\'titles' . $j . '\');" style="z-index:' . (300 - $j) . ';">
								&nbsp;&nbsp;<b>' . $rijform['tracking_title'] . '</b>
								<ul  id="titles' . $j . '" style="display:none; Z-index: 1000;">';
                        $printMenu.= '		<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_studenttracking_url() . '&page=trackingclasslist&select=' . $selectie . '&tracking_category=all&tracking_title=' . urlencode($rijform['tracking_title']) . '">' . get_lang('txtTrackingClasslist') . '</a></li>';
                        if ($permPrint)
                        {
                            $printMenu.= '	<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_studenttracking_url() . '&page=classfiche2pdf&select=' . $selectie . '&tracking_category=all&tracking_title=' . urlencode($rijform['tracking_title']) . '&photo=1" target="_blank">' . get_lang('txtClassOverviewPhoto2PdfTitle') . '</a></li>
						<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_studenttracking_url() . '&page=classfiche2pdf&select=' . $selectie . '&tracking_category=all&tracking_title=' . urlencode($rijform['tracking_title']) . '" target="_blank">' . get_lang("txtClassOverview2PdfTitle") . '</a></li>
						<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_studenttracking_url() . '&page=classfiche2pdf&select=' . $selectie . '&tracking_category=all&tracking_title=' . urlencode($rijform['tracking_title']) . '&filter=newest" onclick="javascript:(location.href=\'' . $this->get_url() . '&selectie=' . $selectie . '&tracking_category=all&tracking_title=' . urlencode($rijform['tracking_title']) . '&action=message\')" target="_blank">' . get_lang('txtClassOverview2PdfTitleNewest') . '</a></li>
						<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_studenttracking_url() . '&page=studentfiche2pdf&select=' . $selectie . '&tracking_category=all&tracking_title=' . urlencode($rijform['tracking_title']) . '" target="_blank">' . get_lang('txtStudentTracking2PdfTitle') . '</a></li>
						<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_studenttracking_url() . '&page=studentfiche2pdf&select=' . $selectie . '&tracking_category=all&tracking_title=' . urlencode($rijform['tracking_title']) . '&filter=newest" onclick="javascript:(location.href=\'' . $this->get_url() . '&selectie=' . $selectie . '&tracking_category=all&tracking_title=' . urlencode($rijform['tracking_title']) . '&action=message\')" target="_blank">' . get_lang('txtStudentTracking2PdfTitleNewest') . '</a></li>';
                        }
                        $printMenu.= '</ul></li>';
                        $j++;
                    }
                }
                $printMenu.= "</ul>";
                $printMenu.= "</li>";
            }
        }

        // afdruk mogelijkheden functies met de lijsten....
        echo '<span style="float:right; position: relative; left: 0px;top:0px;z-index: 1">';
        echo '<div class="campus_pulldwnMnu" >';
        if ($select != "")
        {
            /*             * ** REPORT DISABLE *** */
            if ((isset($admin['roster']) && $admin['roster']) || $permPrint || $is_platformadmin)
            { // build report print options...... has to be automated.....
                if (($department_id == 4) && (($_uid == 2213) || $is_platformadmin))
                {
                    echo '&nbsp;<a href="#" onclick="javascript: toggleID(\'Reports\');">' . get_lang("txtStudentReport2Pdf") . '</a>&nbsp;|';
                    echo '<ul id="Reports" style="left: auto;left:0px;top:15px;display:none; Z-index:1100;">';
                    echo '<li id="campus_pulldwnMnu_title" >';
                    echo '<a href="#" onclick="javascript: toggleID(\'Reports\');" style="float:right; border: 1px solid #FFFFFF;font-size: 10px;color: #FFFFFF">X</a>';
                    echo '&nbsp;&nbsp;<b>' . get_lang("txtStudentReport2Pdf") . '</b>';
                    echo '</li>';
                    //echo "<li>&nbsp;&nbsp;<a style='white-space: nowrap;' href=\"../studentreport/studentreport2pdf.php?select=".$selectie."&report_id=1&childreport_id=2\"  target='_blank'> - rapport 1 - </a>&nbsp<li>";
                    //echo "<li>&nbsp;&nbsp;<a style='white-space: nowrap;' href=\"../studentreport/studentreport2pdf.php?select=".$selectie."&report_id=1&childreport_id=3\"  target='_blank'> - rapport 2 - </a>&nbsp<li>";
                    //echo "<li>&nbsp;&nbsp;<a style='white-space: nowrap;' href=\"../studentreport/studentreport2pdf.php?select=".$selectie."&report_id=1&childreport_id=4\"  target='_blank'> - rapport 3 - </a>&nbsp<li>";
                    //echo "<li>&nbsp;&nbsp;<a style='white-space: nowrap;' href=\"../studentreport/studentreport2pdf.php?select=".$selectie."&report_id=1&childreport_id=5\"  target='_blank'> - rapport 4 - </a>&nbsp<li>";
                    echo '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="'.$this->get_studentreport_url() . '&page=studentreportMSJ2pdf&select=' . $selectie . '&report_id=1"  target="_blank"> - rapport overzicht - </a>&nbsp<li>';
                    echo '</ul>';
                }
                elseif (($department_id == 8) && (($_uid == 23) || ($_uid == 46) || $is_platformadmin))
                {
                    echo '&nbsp;<a href="#" onclick="javascript: toggleID(\'Reports\');">' . get_lang("txtStudentReport2Pdf") . '</a>&nbsp;|';
                    echo '<ul id="Reports" style="left: auto;left:0px;top:15px;display:none; Z-index:1100;">';
                    echo '<li id="campus_pulldwnMnu_title" >';
                    echo '<a href="#" onclick="javascript: toggleID(\'Reports\');" style="float:right; border: 1px solid #FFFFFF;font-size: 10px;color: #FFFFFF">X</a>';
                    echo '&nbsp;&nbsp;<b>' . get_lang("txtStudentReport2Pdf") . '</b>';
                    echo '</li>';
                    echo '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="'.$this->get_studentreport_url() . '&page=studentreportVTI2pdf&select=' . $selectie . '&report_id=6&childreport_id=7"  target="_blank"> - attitude rapport DW 1 - </a>&nbsp<li>';
                    //echo '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="'.$this->get_studentreport_url() . '&page=studentreportVTI2pdf&select=' . $selectie . '&report_id=6&childreport_id=8"  target="_blank"> - attitude rapport DW 2 - </a>&nbsp<li>';
                    echo '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="'.$this->get_studentreport_url() . '&page=studentreportVTI2pdf&select=' . $selectie . '&report_id=6&childreport_id=9"  target="_blank"> - attitude rapport KERST - </a>&nbsp<li>';
                    //echo '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="'.$this->get_studentreport_url() . '&page=studentreportVTI2pdf&select=' . $selectie . '&report_id=6&childreport_id=10"  target="_blank"> - attitude rapport DW 4 - </a>&nbsp<li>';
                    echo '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="'.$this->get_studentreport_url() . '&page=studentreportVTI2pdf&select=' . $selectie . '&report_id=6&childreport_id=11"  target="_blank"> - attitude rapport PASEN - </a>&nbsp<li>';
                    //echo '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="'.$this->get_studentreport_url() . '&page=studentreportVTI2pdf&select=' . $selectie . '&report_id=6&childreport_id=12"  target="_blank"> - attitude rapport DW 5/6 - </a>&nbsp<li>';
                    //echo '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="'.$this->get_studentreport_url() . '&page=studentreportVTI2pdf&select=' . $selectie . '&report_id=6&childreport_id=13"  target="_blank"> - attitude rapport JUNI - </a>&nbsp<li>';
                    echo '</ul>';
                }
            }
            /*             * ** REPORT DISABLE *** */
            echo '&nbsp;<a href="' . $this->get_url() . '&page=studentlist2pdf&select=' . $selectie . '&ori=landscape" target="_blank">' . get_lang("txtClass2PdfLandscape") . '</a>&nbsp;|';
            echo '&nbsp;<a href="' . $this->get_url() . '&page=studentlist2pdf&select=' . $selectie . '&ori=portrait" target="_blank">' . get_lang("txtClass2PdfPortrait") . '</a>&nbsp;|';
        }
        if ($printMenu != "")
        {
            echo '&nbsp;<a href="#" onclick="javascript: toggleID(\'Extra\');" >' . (($select != "") ? get_lang("txtClasslistExtra") : get_lang("txtDepartmentOverviews")) . '</a>';
            echo '<ul id="Extra" style="left: auto;right:60px;top:15px;display:none; Z-index:1100;">';
            echo '<li id="campus_pulldwnMnu_title" >';
            echo '<a href="#" onclick="javascript: toggleID(\'Extra\');" style="float:right; border: 1px solid #FFFFFF;font-size: 10px;color: #FFFFFF">X</a>';
            echo '&nbsp;&nbsp;<b>' . (($select != "") ? get_lang("txtClasslistExtra") : get_lang("txtDepartmentOverviews")) . '</b>';
            echo '</li>';
            echo $printMenu;
            echo '</ul>';
        }

        echo '</div></span>';
        echo '<div>';
        if (is_array($select))
        {
            foreach ($select as $key)
            {
                echo "<b><big>" . $classes[$key]['code'] . "</big></b> ";
            }
        }
        else
        {
            echo "<b><big>" . $classes[$select]['code'] . "</big></b> ";
        }
        echo "</div>";
    }
    if (($select != "") && ($search == ""))
    {
        // Query van het gegevensbestand....
        $query = 'SELECT DISTINCT `user_user`.`id` as "user_id", `display_order`, `lastname`, `firstname`, `username`,`email`,`address`, `phone`, `group_group`.`id` as "group_id"
		            FROM `group_group_rel_user`
		                INNER JOIN `user_user`
		                   ON `user_user`.`id` = `group_group_rel_user`.`user_id`
		                LEFT JOIN `campus_user`
                                    ON `user_user`.`id` = `campus_user`.`user_id`
                                INNER JOIN `group_group`
		                   ON `group_group`.`id` = `group_group_rel_user`.`group_id` WHERE ';
        if (is_array($select))
        {
            $filter = "";
            // meervoudige selectie doormiddel van array.
            foreach ($select as $conditie)
            {
                $filter.="`group_group_rel_user`.`group_id` = " . $conditie . " OR ";
            }
            $filter = substr($filter, 0, -3) . " ";
        }
        else
        {
            // enkelvoudige selectie.
            $filter = " `group_group_rel_user`.`group_id` = " . $select . " ";
        }
        $query.=$filter . " ORDER BY `group_group`.`code`, `display_order`, `lastname`, `firstname`";
    }
    if ($search != "")
    {
        // Query van het gegevensbestand....
        $query = 'SELECT DISTINCT `user_user`.`id` as "user_id", `display_order`, `lastname`, `firstname`, `username`,`email`,`address`, `phone`, `group_group`.`id` as "group_id"
	            FROM `user_user`
                        LEFT JOIN `campus_user`
                            ON `user_user`.`id` = `campus_user`.`user_id`
                        INNER JOIN `group_group_rel_user`
	                   ON `user_user`.`id` = `group_group_rel_user`.`user_id`
	                INNER JOIN `group_group`
	                   ON `group_group`.`id` = `group_group_rel_user`.`group_id`
			LEFT JOIN `campus_department_rel_group`
                            ON `group_group`.`id` = `campus_department_rel_group`.`group_id` AND  `type`=2
		WHERE (`lastname` like "%' . $search . '%" OR
			`firstname` like "%' . $search . '%" OR
			concat(`lastname`," ",`firstname`) like "%' . $search . '%" OR
			concat(`firstname`," ",`lastname`) like "%' . $search . '%") AND
			`department_id`=' . $department_id . '
		ORDER BY  `lastname`, `firstname`,`group_group`.`code`,`display_order` ';
    }
    if (($select != "") || ($search != ""))
    {
        $result = mysql_query($query) or die(mysql_error());
        $header = array(get_lang("colheadNr"), get_lang("colheadName"), get_lang("colheadFirstName"), get_lang("colheadEmail"), get_lang("colheadClass"), "");
        campus::display_complex_table_header($properties, $header);
        $prevStudent = "";
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            if ($prevStudent == $rij['user_id'])
            {
                $data[5].="<br>" . $rij['code'];
            }
            else
            {
                campus::display_table_row($bgcolor, $data, true);
                $data = array();
                $data[1] = $rij['display_order'];
                $data[2] = $rij['lastname'];
                $data[3] = $rij['firstname'];
                $data[4] = $rij['email'];
                $grouplist = "";
                $sql2 = "SELECT `code` FROM `group_group`
 	 		 	LEFT JOIN `group_group_rel_user`
                                    ON  `group_group`.`id`=`group_group_rel_user`.`group_id`
 	 		 						WHERE `user_id` = " . $rij['user_id'] . " ORDER BY `code`";
                $result2 = mysql_query($sql2);
                while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                {
                    $grouplist.=$rij2['code'] . " ";
                }
                $data[5] = $grouplist;
                $data[6] = '<a href="' . $this->get_studentroster_url() . '&student_id=' . $rij['user_id'] . '&class_id=' . $select . '" title="' . get_lang('tooltipStudentRoster') . '"><img src="' . Theme::get_image_path('application\campus') . '/agenda.gif" border=0 align="absmiddle" /></a>';
                if ($tracking_enabled)
                {
                    // Check for coach
                    $query2 = "SELECT * FROM `campus_coach_rel_student`	WHERE `student_id`=" . $rij['user_id'] . " AND `teacher_id`=" . $_uid;
                    $result2 = mysql_query($query2);
                    $numrows = mysql_num_rows($result2);
                    if (!empty($classtracking[$rij['group_id']]) || $permRead || ($numrows > 0))
                    {
                        $query2 = "SELECT `campus_student_tracking`.`id`
	            			FROM `campus_student_tracking`
                                            LEFT JOIN `campus_tracking_category`
                                                ON `campus_student_tracking`.`tracking_category`=`campus_tracking_category`.`tracking_category` AND `campus_tracking_category`.`department_id`=" . $department_id . "
                                            LEFT JOIN  `campus_tracking_title`
                                                ON `campus_tracking_category`.`id`=`campus_tracking_title`.`category_id` AND `campus_tracking_title`.`tracking_title`=`campus_student_tracking`.`tracking_title`
                                            LEFT JOIN `campus_tracking_visited`
                                                ON `campus_student_tracking`.`id` = `campus_tracking_visited`.`tracking_id` AND `teacher_id`=" . $_uid . "
                                        WHERE `override_id`=0 AND `student_id`=" . $rij['user_id'] . " AND (`silent_tracking` is NULL OR `silent_tracking`=0) AND ( `teacher_id` is NULL OR  `viewed`=0) ";
                        $query2 .= " AND `date` >=" . mktime(0, 0, 0, 7, 1, substr($academicYear, 0, 4)) . "	AND `date` <=" . mktime(0, 0, 0, 8, 31, substr($academicYear, 5, 4)) . " ";
                        $query2 .= ( $nolimit) ? " AND `department_code`<>''" : " AND `department_code`='" . $departmentStruc[$department_id]['code'] . "' AND `public`=1 ";
                        $query2 .= " ORDER BY `date` ASC LIMIT 1";
                        $result2 = mysql_query($query2) or die(mysql_error());
                        $numrows = mysql_num_rows($result2);
                        list ($tracking_id) = mysql_fetch_row($result2);
                        $changed = ($numrows > 0) ? "<b style='font-size:18px;color:red'>*</b>" : "";
                        $data[6] .= '&nbsp;<a href="' . $this->get_studenttracking_url() . '&student_id=' . $rij['user_id'] . '&class_id=' . $rij['group_id'] . '&action=open&tracking_id=' . $tracking_id . '"
					 				title="' . get_lang("tooltipStudentTracking") . '"><img src="' . Theme::get_image_path('application\campus') . '/studenttracking.gif" border=0 align="absmiddle" />' . $changed . '</a>'
                                . (($report_enable) ? '&nbsp;<a href="' . $this->get_studentreport_url() . '&page=studentreport&student_id=' . $rij['user_id'] . '&class_id=' . $rij['group_id'] . '"
					 				title="' . get_lang("tooltipStudentReport") . '"><img src="' . Theme::get_image_path('application\campus') . '/report.gif" border=0 align="absmiddle" /></a>' : '');
                    }
                    elseif (($permWrite) || ($permRead))
                    {
                        $data[6] .= '&nbsp;<a href="' . $this->get_studenttracking_url() . '&student_id=' . $rij['user_id'] . '&class_id=' . $rij['group_id'] . '&action=open&tracking_id=' . $tracking_id . '"
					 				title="' . get_lang("tooltipStudentTracking") . '"><img src="' . Theme::get_image_path('application\campus') . '/studenttracking.gif" border=0 align="absmiddle" /></a>';
                    }
                }
            }
            $prevStudent = $rij['user_id'];
        }
        campus::display_table_row($bgcolor, $data, true);
        campus::display_table_footer();
    }
    else
    {
        //echo "<div style=\"clear:both\"></div>";
        echo "<div style='margin-left: 10%;text-align:center;width:40%;'><div style='text-align:left'>";
        Display::normal_message(get_lang('msgStudentlistHint'), false);
        echo "</div></div>";
    }
}
?>