<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Theme;
use common\libraries\Path;

/*
  ==============================================================================
  This is a studentlist to Pdf Export utility.
  ==============================================================================
 */
/*
  ==============================================================================
  INIT SECTION
  ==============================================================================
 */

//check if user is allowed here...
if (((intval($_uid) == 0) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $select = campus::get_POST_GET("select");
    $hoge_rij = campus::get_POST_GET("rij1", "laag");
    $titel = campus::get_POST_GET("titel");
    $ori = campus::get_POST_GET("ori", "landscape");
    // de department van de klassen bepalen afhankelijk van de eerste klas van de selectie
    $sql = "SELECT `name`, `student_pics` ,`logo`
        FROM `campus_department`
        LEFT JOIN `campus_department_rel_group`
                   ON `campus_department`.`id` = `campus_department_rel_group`.`department_id` AND `type` = 2
        WHERE `campus_department_rel_group`.`group_id` = " . strtok($select, ",") . " LIMIT 1";
    $result = mysql_query($sql);
    $department = mysql_fetch_array($result, MYSQL_ASSOC);
    /*
      ==============================================================================
      Klas selecteren
      ==============================================================================
     */
    // Query van het gegevensbestand....
    $query = "SELECT `display_order`, `lastname`, `firstname`, `official_code`, `email`, `group_group`.`code`
            FROM `group_group_rel_user`
                LEFT JOIN `user_user`
                   ON `user_user`.`id` = `group_group_rel_user`.`user_id`
                LEFT JOIN `group_group`
                   ON `group_group`.`id` = `group_group_rel_user`.`group_id` WHERE ";
    $filter = "`group_group_rel_user`.`group_id`=" . ereg_replace(",", " OR `group_group_rel_user`.`group_id`=", $select);
    $sql = $query . $filter . " ORDER BY `group_group`.`code`, `display_order`,`lastname`,`firstname`";
    $result = mysql_query($sql);
    $aantal = mysql_num_rows($result);
    include(Path :: get_web_application_path('campus') . '/old_php/php_pdf/class.ezpdf.php');

    // Pagina instellingen
    if ($ori == 'landscape')
    {
        $pdf = & new \Cezpdf('a4', 'landscape');
        $phoogte = 595;
        $pbreedte = 802;
        $rightedge = 842;
        $kolommen = 25;
    }
    else
    {
        $pdf = & new \Cezpdf('a4', 'portrait');
        $phoogte = 842;
        $pbreedte = 575;
        $rightedge = 595;
        $kolommen = 15;
    }
    $pdf->ezSetCmMargins(2.0, 1.5, 2, 2);
    $pdf->selectFont(Path :: get_web_application_path('campus') . '/old_php/php_pdf/fonts/Helvetica.afm');
    //koptekst en voettekst
    $pdf->ezStartPageNumbers($pbreedte - 20, 15, 12, 'left', 'pagina {PAGENUM} van {TOTALPAGENUM}', 1);
    //$pdf ->ezStartPageNumbers((40+$pdf ->getTextWidth(18,$select)),$phoogte-45,18,'left',$select,1);
    $pdf->ezStartPageNumbers($pbreedte - 20, $phoogte - 45, 18, 'left', $department['name'], 1);
    // $pdf ->ezStartPageNumbers($pbreedte-150,$phoogte-55,16,'left', $lkrnaam,1);
    // $pdf ->ezStartPageNumbers(50,$phoogte-65,14,'right', $titel,1);
    $all = $pdf->openObject();
    $pdf->saveState();
    $pdf->setStrokeColor(0.8, 0.8, 0.8);
    $ext = strtolower(substr($department['logo'], -4));

    if ($ext == '.jpg')
    {
        $pdf->addJpegFromFile(Theme::get_image_system_path('application/campus') . $department['logo'], 40, $phoogte - 72, 130);
    }
    elseif ($ext == '.png')
    {
        $pdf->addPngFromFile(Theme::get_image_system_path('application/campus') . $department['logo'], 40, $phoogte - 72, 130);
    }
    $pdf->setStrokeColor(0.25, 0.25, 0.25);
    $pdf->restoreState();
    $pdf->closeObject();
    // note that object can be told to appear on just odd or even pages by changing 'all' to 'odd'
    // or 'even'.
    $pdf->addObject($all, 'all');
    $vorige = '';
    $data = array();
    $i = 0;
    $hooog = "\n\n\n\n";
    $cols['Nr'] = $hooog . "Nr";
    $cols['Naam'] = $hooog . utf8_decode("Naam ");
    $options = array('showHeadings' => 1, 'showLines' => 2, 'rowGap' => 3, 'shaded' => 0, 'titleFontSize' => 10, 'fontSize' => 11, 'cols' => array('Nr' => array('width' => 25), 'Naam' => array('width' => 200)));
    for ($n = 1; $n <= $kolommen; $n++)
    {
        $cols['c' . $n] = '';
        $options['cols']['c' . $n] = array('width' => ($pbreedte - 280) / $kolommen);
    }
    $hoofdingpos = $pbreedte - 20;
    $Filename = '';
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        $i++;
        if ($vorige != $rij['code'])
        {
            campus::document2pdf_footer($pdf, $rightedge, 1.5);

            // $pdf->ezStartPageNumbers($hoofdingpos, $phoogte - 75, 18, 'left', $rij['code'], 1);
            $hoofdingpos-=$pdf->getTextWidth(18, $rij['code']) + 10;
            $filename.=$rij['code'] . ' ';
            if (!empty($data))
            {
                $pdf->ezTable($data, $cols, '', $options);
                // titels niet meer verhoogd
                $cols['Nr'] = "Nr";
                $cols['Naam'] = "Naam";
                $options['showHeadings'] = 0;
            }
            unset($data);
            $pdf->ezText($rij['code'], 18, array('justification' => 'right'));
            $pdf->ezSetDy(-5);
            $vorige = $rij['code'];
        }
        $data[$i] = array('Nr' => $rij['display_order'], 'Naam' => utf8_decode($rij['lastname'] . " " . $rij['firstname']));
        for ($n = 1; $n <= $kolommen; $n++)
        {
            $data[$i]['c' . $n] = '';
        }
    }
    $pdf->ezTable($data, $cols, '', $options);
    $fileoption = array('Content-Disposition' => substr($filename, 0, -1) . '.pdf');
    $pdf->ezStream($fileoption);
}
?>