<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Theme;
use common\libraries\PlatformSetting;
use common\libraries\Path;
use common\libraries\Display;
use common\libraries\DatetimeUtilities;
use common\libraries\ResourceManager;

/*
  ==============================================================================
  POST & GET vars, check for default value?.
  ==============================================================================
 */
$department_id = intval(campus::get_SESSION("department_id", key($departmentStruc)));
// get rights of user in campus plugin .....
$admin = campus::get_rights($_uid, $department_id);
$tracking_category = campus::get_SESSION("tracking_category"); // store in session...
$action = campus::get_POST_GET("action", "list");
$tracking_title = campus::get_SESSION("tracking_title");
$teacher_code = trim(campus::get_SESSION("teacher_code"));
$department_code = $departmentStruc[$department_id]['code'];

$student_id = intval(campus::get_POST_GET("student_id")); // store in session...
$classtracking = campus::get_trackingrights($_uid, $department_id);
$class_id = intval(campus::get_SESSION("class_id")); // store in session...
$classcoach = ($classtracking[$class_id] == 'classTeacher') ? TRUE : FALSE;

// determin rights:
// Check for individual studentcoach
$trackingallowed = ((isset($admin['studentTrackingLevel2']) && $admin['studentTrackingLevel2']) || (isset($admin['studentTrackingLevel3']) && $admin['studentTrackingLevel3']) || $classcoach);

//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($departmentStruc) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Display::display_error_message(get_lang("msgNoDepartmentMember"), false);
}
else
{//only teachers and platform administrator are allowed here...
    include("report.inc.php");
    Display::small_header();
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/javascript/hide_show.js');

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $activeroster = campus::get_activeroster($department_id);
    $student_id = intval(campus::get_POST_GET("student_id", $_uid));
    $report_id = intval(campus::get_POST_GET("report_id"));
    $childreport_id = intval(campus::get_POST_GET("childreport_id"));

    $query = 'SELECT * FROM `campus_reportcard`
				INNER JOIN `campus_assignment`
					ON `campus_assignment`.`id`=`campus_reportcard`.`assignment_id`
				WHERE `curriculum_id`=' . $activeroster['curriculum_id'];
    $result = mysql_query($query);
    if (mysql_num_rows($result) == 0)
    {
        $message = get_lang("msgNoReportAvailable");
    }


    /*
      ==============================================================================
      Update query's execute actions...
      ==============================================================================
     */


    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    //campus::display_departments ($departmentStruc,$department_id);

    if (!empty($message))
    {
        Display::warning_message($message, false);
    }



    /*
      -----------------------------------------------------------
      List of reports....
      -----------------------------------------------------------
     */
    if ($activeroster['curriculum_id'] > 0)
    {
        if ($student_id > 0)
        {
            $groups = campus::get_classes($student_id);
            //Make prev student and next student link AND Get user details....
            $found = FALSE;
            $prev_student = "";
            $next_student = "";
            $query = 'SELECT `code`,`user_user`.`id`, `lastname`, `firstname`, `official_code`, `birth`, `address`, `phone`, `email`, `username`, `password`, `picture_uri`
			FROM `user_user`
                            INNER JOIN `campus_user`
				ON `user_user`.`id`=`campus_user`.`user_id`
                            INNER JOIN `group_group_rel_user`
				ON `user_user`.`id`=`group_group_rel_user`.`user_id`
                            INNER JOIN `group_group`
				ON  `group_group`.`id`=`group_group_rel_user`.`group_id`
			WHERE (';
            foreach ($groups as $group_id => $value)
            {
                $query.='`group_id`=' . $group_id . ' OR ';
            }
            $query = substr($query, 0, -3) . ')';
            $query.=' ORDER BY  `code`,`display_order`,`lastname`,`firstname`';
            $result = mysql_query($query);
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                if ($rij['id'] == $student_id)
                {
                    $student = $rij;
                    $found = TRUE;
                }
                else
                {
                    if ($found)
                    {
                        $next_student = '<span style="float: right;"><a href="' . $this->get_url() . '&page=studentreport&student_id=' . $rij['id'] . '" title="' . $rij['firstname'] . ' ' . $rij['lastname'] . '">' . get_lang("txtNextStudent") . '</a></span>';
                        break;
                    }
                    else
                    {
                        $prev_student = '<div>&nbsp;<a href="' . $this->get_url() . '&page=studentreport&student_id=' . $rij['id'] . '" title="' . $rij['firstname'] . ' ' . $rij['lastname'] . '">' . get_lang("txtPrevStudent") . '</a></div>';
                    }
                }
            }
            // ************* display student information ***
            echo '<table width="100%" cellpadding=0 cellspacing=0 align="center">';
            echo '<tr>';
            echo '<td Colspan=2>';
            if (!$individualcoach)
            {
                echo $next_student;
                echo $prev_student;
            }
            echo '</td></tr>';
            echo '<tr>';
            echo '<td valign="bottom" style="border:1px solid #999999">';
            echo '<table width=100% cellpadding=0 cellspacing=0><tr>';
            echo '<td align="right"><b>' . get_lang("labelFirstName") . ':</b></td>';
            echo '<td>' . $student['firstname'] . '</td>';
            echo '<td align="right"><b>' . get_lang("labelBirth") . ':</b></td>';
            echo '<td>' . $student['birth'] . '</td>';
            echo '</tr><tr>';
            echo '<td align="right"><b>' . get_lang("labelLastName") . ':</b></td>';
            echo '<td>' . $student['lastname'] . '</td>';
            echo '<td align="right"><b>' . get_lang("labelAdress") . ':</b></td>';
            echo '<td>' . $student['address'] . '</td>';
            echo '</tr><tr>';
            echo '<td align="right"><b>' . get_lang("labelStudentCode") . ':</b></td>';
            echo '<td>' . $student['official_code'] . '</td>';
            echo '<td align="right"><b>' . get_lang("labelPhone") . ':</b></td>';
            echo '<td>' . $student['phone'] . '</td>';
            echo '</tr><tr>';
            echo '<td align="right" valign="top"><b>' . get_lang("labelClasses") . ':</b></td>';
            echo '<td>';
            $groups = campus::get_classes($student_id);
            foreach ($groups as $group_id => $group_info)
            {
                echo '<a href="' . $this->get_studentlist_url() . '&select=' . $group_id . '" title="' . get_lang("tooltipShow") . ' ' . $group_info['name'] . '">' . $group_info['code'] . '</a> <b>' . get_lang("labelNr") . '</b> ' . $group_info['display_order'];
                echo '<br>';
            }
            echo '</td>';
            echo '<td align="right"><b>' . get_lang("labelEmail") . ':</b></td>';
            echo '<td>' . $student['email'] . '<td>';
            echo '</tr><tr>';
            echo '<td align="right"><b>' . get_lang("labelUsername") . ':</b></td>';
            echo '<td>' . $student['username'] . '</td>';
            echo '<td colspan=2 valign="bottom" align="right"></td>';
            echo '</tr></table>';
            echo '<table border=1 cellpadding=0 cellspacing=0 align="right" >';
            echo '<tr>';
            echo '<td style="border:1px solid #999999;">';
            echo '&nbsp;<b>' . get_lang("txtStudentReport") . '</b>&nbsp;';
            echo '</td>';
            echo '<td style="border:1px solid #999999;background-color:#ccc;">';
            echo '&nbsp;<a href="' . $this->get_studenttracking_url() . '&page=projection&student_id=' . $student['id'] . '">' . get_lang("txtStudentTracking") . '</a>&nbsp;';
            echo '</td></tr>';
            echo '</table>';
            echo '</td><td align="right" style="border:0px solid #999999">';
            if (is_file(Path :: get(SYS_USER_PATH) . $student['picture_uri']))
            {
                echo '<img src="' . Path :: get(WEB_USER_PATH) . $student['picture_uri'] . '" height="100">';
            }
            else
            {
                echo '<img src="' . Theme :: get_common_image_path() . 'unknown.jpg" height="100" >';
            }
            echo '</td></tr>';
            echo '</table>';

            echo '<span style="float:left; position: relative; right: 0px;top:0px;z-index:1000">';
            echo '<a style="white-space: nowrap;" href="' . $this->get_studentreport_url() . '&student_id=' . $student_id . '" >' . get_lang("txtBack2StudentReport") . '</a>';
            echo '</span>';
            echo '<br clear="all">';
            // ========================================================================
            //                        display reporttabs....
            // ========================================================================
            $report_enable = FALSE;
            if (!empty($groups))
            {
                //select assignments from teacher....
                $query = "SELECT DISTINCT `comment`, `title`, `report_id` FROM `campus_reportcard`
						INNER JOIN `campus_report`
							ON `campus_report`.`id`=`campus_reportcard`.`report_id`
						INNER JOIN `campus_assignment`
							ON  `campus_assignment`.`id`=`campus_reportcard`.`assignment_id`
						INNER JOIN `campus_assignment_rel_group`
							ON  `campus_assignment`.`id`=`campus_assignment_rel_group`.`assignment_id`
						WHERE  `curriculum_id`=" . $activeroster['curriculum_id'] . " AND `parent_id`=0 AND (";
                foreach ($groups as $group_id => $value)
                {
                    $query.="`group_id`=" . $group_id . " OR ";
                }
                $query = substr($query, 0, -3) . ") ORDER BY `display_order`";
                $result = mysql_query($query);
                if (mysql_num_rows($result) > 0)
                {
                    $report_enable = TRUE;
                    echo '<form method="post" action="' . $this->get_url() . '" name="formselecttab">';
                    echo '<input type="hidden" name="page" value="studentreport" >';
                    echo '<input type="hidden" name="action" value="list" >';
                    echo '<input type="hidden" name="student_id" value="' . $student_id . '" >';
                    echo '<input type="hidden" name="report_id" value="' . $report_id . '" >';
                    echo '<br clear="all"><div id="lvs_tabs"><ul>';
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        if (($report_id == $rij['report_id']) || ($report_id == 0))
                        {
                            echo '<li id="current"><a href="#" title="' . $rij['comment'] . '">' . $rij['title'] . '</a></li>';
                            $report_id = $rij['report_id']; // in case $report_id = 0
                            $reportcard_id = $rij['reportcard_id']; // in case $report_id = 0
                        }
                        else
                        {
                            echo '<li ><a href="#" OnmouseDown="javascript:document.formselecttab.report_id.value=\'' . $rij['report_id'] . '\';" OnmouseUp="javascript:document.formselecttab.submit();" title="' . $rij['comment'] . '">' . $rij['title'] . '</a></li>';
                        }
                    }
                    echo '</ul></div></form><br clear="all">';
                }
            }
        }
        if ($report_enable)
        {
            $reportcard = get_reportstruc($report_id);
            //campus::show_arrays($reportcard);
            $cols = array();
            // stijlen ver plaatsen naar style sheet....
            echo '<style>';
            echo '.pointcell { border: 1px solid #000;}';
            echo '.emptypointcell { border: 1px solid #000;background:#999;}';
            echo '.pointsheader { border: 1px solid #000;width:100px;text-align:center}';
            echo '.rowheader { border: 1px solid #000;width:270px;}';
            echo '</style>';

            // display report form starting with header...
            echo '<form method="post" action="' . $this->get_url() . '" name="formreport">';
            echo '<input type="hidden" name="page" value="studentreport" >';
            echo '<input type="hidden" name="student_id" value="' . $student_id . '" >';
            echo '<input type="hidden" name="report_id" value="' . $report_id . '" >';
            echo '<table cellspacing=0 cellpadding=0>';
            $cols_id = 0;
            foreach ($reportcard as $rows => $array)
            {
                if ($rows == 'lists')
                {//build selections....
                    foreach ($array as $list_id => $value)
                    {// put select list in array...
                        $query = "SELECT * FROM `campus_evaluation_constant`
                                                    INNER JOIN `campus_evaluation_constant_list`
                                                        ON `campus_evaluation_constant`.`list_id`= `campus_evaluation_constant_list`.`id`  WHERE `list_id`=" . $list_id . " ORDER BY `display_order`";
                        $result = mysql_query($query) or die(mysql_error());
                        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                        {
                            $list[$list_id][$rij['id']]['code'] = $rij['code'];
                            $list[$list_id][$rij['id']]['comment'] = $rij['comment'];
                        }
                    }
                }
                elseif (($rows != 'evaluations') && ($rows != 'reports'))
                { // put report columns in array...
                    echo "<tr>";
                    echo "<td></td>"; //row header...
                    $firstselect = TRUE; //used for report view='select'...
                    foreach ($array as $reportid => $reportcolumn)
                    {
                        if ($reportcolumn['visible'] == 1)
                        {
                            //build column header
                            if ($reportcolumn['view'] == 1)
                            { // column when score has to be assigned or tree_view is disabled...
                                $cols[$colid]['column'] = 'report';
                                $cols[$colid]['allow_score'] = $reports['reports'][$reportid]['allow_score'];
                                $cols[$colid]['report_id'] = $reportid;
                                $cols[$colid++]['evaluation_id'] = 0;
                                $colspan = 1;
                            }
                            else
                            {
                                $colspan = $reportcolumn['cols'];
                            }
                            if ($reportcolumn['view'] == 3)
                            {
                                $option = "";
                                if ($childreport_id == 0)
                                { // there's no report selected, select a report
                                    if (($today >= $reportcard['reports'][$reportid]['reportstart']) && ($today <= $reportcard['reports'][$reportid]['reportend']))
                                    { // a report within a start and end date is prefered and made 'active'....
                                        $childreport_id = $reportid; // make this report the selected report to show the correct columns...
                                        $option = "selected"; // select this option in the list....
                                    }
                                    elseif ($firstselect)
                                    { // consider this to be an option when no 'active' report is found...
                                        $option = "selected"; // select this option in the list....
                                        $suggestedreport_id = $reportid;
                                    }
                                    elseif ($today >= $reportcard['reports'][$reportid]['reportstart'])
                                    { // consider this to be better then select the first report when no 'active' report is found...
                                        $option = "selected";
                                        $suggestedreport_id = $reportid; // override the $reportid
                                    }
                                }
                                elseif ($childreport_id == $reportid)
                                { // when a report is selected this option has to be selected in the list....
                                    $option = "selected";
                                }
                                echo ($firstselect ? '<td colspan="' . $colspan . '"  class="pointsheader"><select name="childreport_id" OnChange="javascript:document.formreport.submit();">' : '');
                                $firstselect = FALSE;
                                echo '<option value="' . $reportid . '" ' . $option . '>' . $reportcolumn['title'] . '</option>';
                            }
                            else
                            {
                                echo '<td colspan="' . $colspan . '" class="pointsheader">' . $reportcolumn['title'] . '</td>';
                            }
                        }
                        if (is_array($reportcolumn['evaluation']) && (($childreport_id == 0) || ($childreport_id == $reportid)))
                        {
                            foreach ($reportcolumn['evaluation'] as $evaluationid => $evaluationcolumn)
                            {
                                if ($evaluationcolumn['visible'] == 1)
                                {
                                    //build column header
                                    //campus::show_arrays($reports['evaluations']);//['evaluations'][$evaluation_id]['allow_score'];
                                    if (($reportcard['evaluations'][$evaluationid]['allow_score'] == 1) || ($evaluationcolumn['tree_view'] == 0))
                                    { // column when score has to be assigned or tree_view is disabled...
                                        //$cols[$col_id][]=$rows['reports'][$report_id][''];
                                        $cols[$colid]['column'] = 'evaluation';
                                        $cols[$colid]['allow_score'] = $reportcard['evaluations'][$evaluationid]['allow_score'];
                                        $cols[$colid]['report_id'] = $reportid;
                                        $cols[$colid++]['evaluation_id'] = $evaluationid;
                                        $colspan = 1;
                                    }
                                    else
                                    {
                                        $colspan = $evaluationcolumn['cols'];
                                    }
                                    echo '<td colspan="' . $colspan . '" class="pointsheader" title="' . $evaluationcolumn['comment'] . '">' . $evaluationcolumn['title'] . '</td>';
                                }
                            }
                        }
                    }
                    echo $selectend; //used for report view='select'
                    if ($childreport_id == 0)
                    {
                        $childreport_id = $suggestedreport_id;
                    }
                    echo '</tr>';
                }
            }
            //read points......
            // discipline list....

            $query = "SELECT DISTINCT `campus_reportcard`.`id`, `discipline_id`, `campus_discipline`.`code`, `campus_discipline`.`name` FROM `campus_reportcard`
					INNER JOIN `campus_assignment`
						ON  `campus_assignment`.`id`=`campus_reportcard`.`assignment_id`
					INNER JOIN `campus_discipline`
						ON `campus_discipline`.`id`=`campus_assignment`.`discipline_id`
					INNER JOIN `campus_assignment_rel_group`
						ON  `campus_assignment`.`id`=`campus_assignment_rel_group`.`assignment_id`
					WHERE  `curriculum_id`=" . $activeroster['curriculum_id'] . " AND `report_id`=" . $report_id . " AND (";
            foreach ($groups as $group_id => $value)
            {
                $query.="`group_id`=" . $group_id . " OR ";
            }
            $query = substr($query, 0, -3) . ") ORDER BY `campus_discipline`.`display_order`";
            $result = mysql_query($query);
            if (mysql_num_rows($result) > 0)
            {
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    // ===============================================================
                    // generate Assignment list details........
                    // ===============================================================
                    // TEACHER ARRAY...
                    $query2 = "SELECT DISTINCT `report_id`, `user_id`, `official_code`, `lastname`, `firstname`
						FROM `campus_assignment_rel_teacher`
							INNER JOIN `user_user`
								ON `user_user`.`id`= `campus_assignment_rel_teacher`.`user_id`
							INNER JOIN `campus_assignment`
								ON `campus_assignment`.`id`= `campus_assignment_rel_teacher`.`assignment_id`
							INNER JOIN `campus_reportcard`
								ON `campus_assignment`.`id`=`campus_reportcard`.`assignment_id`
							WHERE `campus_reportcard`.`id`=" . $rij['id'] . " ORDER BY `lastname`";
                    $result2 = mysql_query($query2);
                    $teachers = "";
                    while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                    {
                        $teachers.='<span title="' . $rij2['lastname'] . ' ' . substr($rij2['firstname'], 0, 1) . '.">' . $rij2['official_code'] . '<span> ';
                    }
                    $selectoption = '<span title="' . $rij['code'] . '">' . $rij['name'] . ' (' . $teachers . ')</span>';
                    //read points from student......
                    $query2 = "SELECT * FROM `campus_evaluation_score` WHERE `reportcard_id`=" . $rij['reportcard_id'] . " AND `user_id`=" . $student_id;
                    $result2 = mysql_query($query2);
                    $points = array();
                    while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                    {
                        $points[$rij2['evaluation_id']][$rij2['id']]['score'] = $rij2['score'];
                        $points[$rij2['evaluation_id']][$rij2['id']]['comment'] = $rij2['comment'];
                        $points[$rij2['evaluation_id']][$rij2['id']]['constant_id'] = $rij2['constant_id'];
                        $points[$rij2['evaluation_id']][$rij2['id']]['date'] = $rij2['date'];
                    }
                    $data = array();
                    echo '<tr>';
                    echo '<td class="rowheader">' . $selectoption . '</td>';
                    foreach ($cols as $key => $column)
                    {
                        if ($column['column'] == 'report')
                        { // column is report
                            echo '<td class="emptypointcell">&nbsp;';
                            echo $column['report_id'] . '?';
                            echo '</td>';
                        }
                        else
                        { // column is evaluation
                            // get details from evaluation
                            $listid = intval($reportcard['evaluations'][$column['evaluation_id']]['list_id']);
                            //check if score exists.....
                            $found = FALSE;
                            $constantid = 0;
                            foreach ($points[$column['evaluation_id']] as $scoreid => $scoredetails)
                            {
                                if (($scoredetails['date'] >= $reportcard['reports'][$column['report_id']]['reportstart']) && ($scoredetails['date'] <= ($reportcard['reports'][$column['report_id']]['reportend'] + 86400)))
                                {
                                    $constantid = $points[$column['evaluation_id']][$scoreid]['constant_id'];
                                    $score = $points[$column['evaluation_id']][$scoreid]['score'];
                                    $comment = $points[$column['evaluation_id']][$scoreid]['comment'];
                                    $found = TRUE;
                                    break;
                                }
                            }
                            if (!$found)
                            { // no points found display emptypointcell...
                                echo '<td class="emptypointcell">';
                            }
                            else
                            {
                                echo '<td class="pointcell">';
                                if ($listid > 0)
                                { // if the evaluation has a select list....
                                    echo '<b title="' . $list[$listid][$constantid]['comment'] . '">' . $list[$listid][$constantid]['code'] . '</b>';
                                }
                                else
                                {
                                    echo '<b title="' . $comment . '">' . $score . '</b>';
                                }
                            }
                            echo '</td>';
                        }
                    }
                    echo '</tr>';
                }
            }
            echo '</table>';
            echo '</form>';
        }
    }
    else
    {
        Display::display_normal_message(get_lang("msgNoActiveRoster"), false);
    }
}
?>
