<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Theme;
use common\libraries\PlatformSetting;
use common\libraries\Path;
use common\libraries\Display;
use common\libraries\DatetimeUtilities;
use common\libraries\ResourceManager;

$classtracking = campus::get_trackingrights($_uid, $department_id);
$allowed = ((isset($admin['studentTrackingLevel2']) && $admin['studentTrackingLevel2']) || (isset($admin['studentTrackingLevel3']) && $admin['studentTrackingLevel3']) || $is_platformadmin || (!empty($classtracking)));
//check if user is allowed here...
if ((intval($_uid) == 0) || ($department_id == 0) || (!$allowed))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */

    $activeroster = campus::get_activeroster($department_id);
    $student_id = intval(campus::get_POST_GET("student_id", $_uid));
    $report_id = intval(campus::get_POST_GET("report_id"));
    $childreport_id = intval(campus::get_POST_GET("childreport_id"));
    $select = campus::get_POST_GET("select");
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);
    include("report.inc.php");
    // Pagina instellingen
    include(Path :: get_web_application_path('campus') . '/old_php/php_pdf/class.ezpdf.php');
    $pdf = & new \Cezpdf('a4', 'portrait');
    $phoogte = 842;
    $pbreedte = 575;

    $marge_boven_cm = 2.5;
    $marge_links_cm = 1.5;
    $marge_onder_cm = 1.0;
    $marge_rechts_cm = 1.5;
    $marge_links = $marge_links_cm / 2.54 * 72;
    $marge_boven = $marge_boven_cm / 2.54 * 72;

    // Pagina instellingen
    $pdf->ezSetCmMargins($marge_boven_cm, $marge_onder_cm, $marge_links_cm, $marge_rechts_cm);
    //$pdf ->ezSetCmMargins( 3.2,1.5,2,2);
    $pdf->selectFont(Path :: get_web_application_path('campus') . '/old_php/php_pdf/fonts/Helvetica.afm');
    //
    //$i=$pdf ->ezStartPageNumbers(553,15,12,'left','pagina {PAGENUM} van {TOTALPAGENUM}',1);
    $pdf->ezStartPageNumbers(360, 785, 15, 'right', "<b>" . $departmentStruc[$department_id]['name'] . "</b>", 1);
    $pdf->ezStartPageNumbers(360, 770, 10, 'right', "<b>3580 BERINGEN</b>", 1);
    $pdf->ezStartPageNumbers(360, 730, 10, 'right', "Schooljaar " . $academicYear, 1);
    $all = $pdf->openObject();
    $pdf->saveState();
    $pdf->setStrokeColor(0.8, 0.8, 0.8);

    $pdf->addPngFromFile(Theme::get_image_system_path('application/campus') . 'spectrumcollege_logo_zw.png', 20, 732, 200);

    $cellwidth = 70;
    $cellheight = 24;
    $x = $marge_links;
    $y = 700;

    // get evaluation structure.....
    $reportcard = get_reportstruc($report_id);

    // build column header
    $colheader[1] = array('height' => 28, 'fontsize' => 12, 'align' => 'left', 'border' => 0);
    $colheader[2] = array('height' => 1, 'fontsize' => 12, 'align' => 'left', 'border' => 0);
    $colheader[3] = array('height' => 20, 'fontsize' => 10, 'align' => 'center', 'border' => 1);
    $colheader[4] = array('height' => 45, 'fontsize' => 8, 'align' => 'left', 'border' => 1);

    foreach ($reportcard['lists'] as $list_id => $value)
    {// put select list in array...
        $query = "SELECT * FROM `campus_evaluation_constant`
                        INNER JOIN `campus_evaluation_constant_list`
                              ON `campus_evaluation_constant`.`list_id`= `campus_evaluation_constant_list`.`id`  WHERE `list_id`=" . $list_id . " ORDER BY `display_order`";
        $result = mysql_query($query);
        $num = mysql_num_rows($result);
        $n = 0;
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $n++;
            $list[$list_id][$rij['id']]['code'] = $rij['code'];
            $list[$list_id][$rij['id']]['comment'] = $rij['comment'];
            $pdf->ezStartPageNumbers(50 + (450 / $num) * $n, 35, 12, 'center', "<b>" . $rij['code'] . "</b> : " . $rij['comment'], 1);
        }
    }

    $pdf->line($x, 45, 550, 45);
    $pdf->ezStartPageNumbers(560, 130, 11, 'left', 'Handtekening ouder(s):', 1);

    $pdf->restoreState();
    $pdf->closeObject();
    // note that object can be told to appear on just odd or even pages by changing 'all' to 'odd'
    // or 'even'.
    $pdf->addObject($all, 'all');


    if ($select == "")
    {
        //read student detail info
        $query = "SELECT `id`, `official_code`, `lastname`, `firstname`, `birth`, `address`, `phone`, `email`, `username`, `password`, `picture_uri`
				FROM `user_user` LEFT JOIN `campus_user` ON `user_user`.`id`= `campus_user`.`user_id`WHERE `id` = " . $student_id . " ";
    }
    else
    {
        //read student detail info
        $query = 'SELECT `code`,`user_user`.`id`, `lastname`, `firstname`, `official_code`, `birth`, `address`, `phone`, `email`, `username`, `password`, `picture_uri`
			FROM `user_user`
                            INNER JOIN `campus_user`
				ON `user_user`.`id`=`campus_user`.`user_id`
                            INNER JOIN `group_group_rel_user`
				ON `user_user`.`id`=`group_group_rel_user`.`user_id`
                            INNER JOIN `group_group`
				ON  `group_group`.`id`=`group_group_rel_user`.`group_id`
			WHERE ';
        if ($select != 0)
        {
            $query.=" (`group_group_rel_user`.`group_id`=" . ereg_replace(",", " OR `group_group_rel_user`.`group_id`=", $select) . ")";
        }
        $query.=" ORDER BY `group_group`.`code`, `display_order`,`lastname`,`firstname`";
    }
    $result1 = mysql_query($query);
    $newpage = FALSE;
    while ($student = mysql_fetch_array($result1, MYSQL_ASSOC))
    {
        $cols = array();
        $y = 640;
        if ($newpage)
        { //newpage
            $pdf->ezStopPageNumbers(1, 1, $i);
            $pdf->ezNewPage();
            //$i=$pdf ->ezStartPageNumbers(553,15,12,'left','pagina {PAGENUM} van {TOTALPAGENUM}',1);
        }
        else
        { //this is first page, next student is to be placed on a new page.
            $newpage = TRUE;
        }
        campus::document2pdf_footer($pdf, 595, 1.5);


        $groups = campus::get_classes($student['id']);
        $grouplisting = "";
        foreach ($groups as $group_id => $group_info)
        {
            $grouplisting.=$group_info['code'] . " ";
        }

        if ($select == "")
        {
            $filename = $student['lastname'] . " " . $student['firstname'];
        }
        else
        {
            $filename = utf8_decode(substr($grouplisting, 0, -1));
        }

        $pdf->addText(60, 685, 14, utf8_decode("<b>" . $student['firstname'] . " " . $student['lastname'] . "</b>"), 0);
        $pdf->addText(60, 660, 11, utf8_decode($grouplisting), 0);


        // actual reports....
        //$pdf->ezSetY(700);

        foreach ($reportcard as $row => $array)
        {
            if ($row != 'lists')
            { // put evaluation columns in array...
                $y = $y - $colheader[$row]['height'];
                $n = 0;
                foreach ($array as $reportid => $reportcolumn)
                {
                    if (($childreport_id == 0) || ($childreport_id == $reportid))
                    {
                        if ($reportcolumn['visible'] == 1)
                        {
                            //build column header
                            if ($reportcolumn['view'] == 1)
                            { // column when score has to be assigned or tree_view is disabled...
                                $cols[$colid]['column'] = 'report';
                                $cols[$colid]['allow_score'] = $reports['reports'][$reportid]['allow_score'];
                                $cols[$colid]['report_id'] = $reportid;
                                $cols[$colid++]['evaluation_id'] = 0;
                                $colspan = 1;
                            }
                            else
                            {
                                $colspan = $reportcolumn['cols'];
                            }
                            //build column header
                            $restHeight = $colheader[$row]['height'] - $colheader[$row]['fontsize'];
                            $text = $reportcolumn['title'];
                            //$text=$columninfo['comment'];
                            while (($restHeight > 0) && ($text != ""))
                            {
                                if ($row == 1)
                                {
                                    $pdf->addTextWrap($x + 291, $y + $restHeight, $cellwidth * $colspan - 2, $colheader[$row]['fontsize'], "" . utf8_decode($text) . "", $colheader[$row]['align'], 0);
                                    $text = $pdf->addTextWrap($x + 170, $y + $restHeight, $cellwidth * $colspan - 2, 14, "<b>Attitudes</b>", 'left', 0);
                                }
                                elseif ($row == 2)
                                {
                                    $text = $pdf->addTextWrap($x + 91 + ($n * $cellwidth * $colspan), $y + $restHeight, $cellwidth * $colspan - 2, $colheader[$row]['fontsize'], "<b><i>" . utf8_decode($text) . "</i></b>", $colheader[$row]['align'], 0);
                                    $restHeight = $restHeight - $colheader[$row]['fontsize'];
                                }
                                else
                                {
                                    $text = $pdf->addTextWrap($x + 91 + ($n * $cellwidth * $colspan), $y + $restHeight, $cellwidth * $colspan - 2, $colheader[$row]['fontsize'], utf8_decode($text), $colheader[$row]['align'], 0);
                                    $restHeight = $restHeight - $colheader[$row]['fontsize'];
                                }
                            }
                            if ($colheader[$row]['border'] > 0)
                                $pdf->Rectangle($x + 90 + ($n * $cellwidth * $colspan), $y, $cellwidth * $colspan, $colheader[$row]['height']); // titelkader



                        }
                        if (is_array($reportcolumn['evaluation']))
                        {
                            foreach ($reportcolumn['evaluation'] as $evaluationid => $evaluationcolumn)
                            {
                                if ($evaluationcolumn['visible'] == 1)
                                {
                                    //build column header
                                    //campus::show_arrays($reports['evaluations']);//['evaluations'][$evaluation_id]['allow_score'];
                                    if (($reportcard['evaluations'][$evaluationid]['allow_score'] == 1) || ($evaluationcolumn['tree_view'] == 0))
                                    { // column when score has to be assigned or tree_view is disabled...
                                        //$cols[$col_id][]=$rows['reports'][$report_id][''];
                                        $cols[$colid]['column'] = 'evaluation';
                                        $cols[$colid]['allow_score'] = $reportcard['evaluations'][$evaluationid]['allow_score'];
                                        $cols[$colid]['report_id'] = $reportid;
                                        $cols[$colid++]['evaluation_id'] = $evaluationid;
                                        $colspan = 1;
                                    }
                                    else
                                    {
                                        $colspan = $evaluationcolumn['cols'];
                                    }
                                    //build column header
                                    $restHeight = $colheader[$row]['height'] - $colheader[$row]['fontsize'];
                                    $text = $evaluationcolumn['title'];
                                    //$text=$columninfo['comment'];
                                    while (($restHeight > 0) && ($text != ""))
                                    {
                                        if ($row == 1)
                                        {
                                            $pdf->addTextWrap($x + 291, $y + $restHeight, $cellwidth * $colspan - 2, 12, " - rapport 1 -", 'left', 0);
                                            $text = $pdf->addTextWrap($x + 170, $y + $restHeight, $cellwidth * $colspan - 2, $colheader[$row]['fontsize'], "<b>" . utf8_decode($text) . "</b>", $colheader[$row]['align'], 0);
                                        }
                                        elseif ($row == 2)
                                        {
                                            $text = $pdf->addTextWrap($x + 91 + ($n * $cellwidth * $colspan), $y + $restHeight, $cellwidth * $colspan - 2, $colheader[$row]['fontsize'], "<b><i>" . utf8_decode($text) . "</i></b>", $colheader[$row]['align'], 0);
                                            $restHeight = $restHeight - $colheader[$row]['fontsize'];
                                        }
                                        else
                                        {
                                            $text = $pdf->addTextWrap($x + 91 + ($n * $cellwidth * $colspan), $y + $restHeight, $cellwidth * $colspan - 2, $colheader[$row]['fontsize'], utf8_decode($text), $colheader[$row]['align'], 0);
                                            $restHeight = $restHeight - $colheader[$row]['fontsize'];
                                        }
                                    }
                                    if ($colheader[$row]['border'] > 0)
                                        $pdf->Rectangle($x + 90 + ($n * $cellwidth * $colspan), $y, $cellwidth * $colspan, $colheader[$row]['height']); // titelkader



                                }
                                $n++;
                            }
                        }
                        $n++;
                    }
                }
            }
        }

        // discipline list....

        $query = "SELECT DISTINCT `campus_reportcard`.`id`, `discipline_id`, `campus_discipline`.`code`, `campus_discipline`.`name` FROM `campus_reportcard`
					INNER JOIN `campus_assignment`
						ON  `campus_assignment`.`id`=`campus_reportcard`.`assignment_id`
					INNER JOIN `campus_discipline`
						ON `campus_discipline`.`id`=`campus_assignment`.`discipline_id`
					INNER JOIN `campus_assignment_rel_group`
						ON  `campus_assignment`.`id`=`campus_assignment_rel_group`.`assignment_id`
					WHERE  `curriculum_id`=" . $activeroster['curriculum_id'] . " AND `report_id`=" . $report_id . " AND (";
        foreach ($groups as $group_id => $value)
        {
            $query.="`group_id`=" . $group_id . " OR ";
        }
        $query = substr($query, 0, -3) . ") ORDER BY `campus_discipline`.`display_order`";
        $result = mysql_query($query);
        //$pdf->addTextWrap($x+2,$y+7,90,8,$report_id,'left',0);

        if (mysql_num_rows($result) > 0)
        {
            $row = 0;
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $row++;
                $y = $y - $cellheight;
                // ===============================================================
                // generate Assignment list details........
                // ===============================================================
                // TEACHER ARRAY...
                $query2 = "SELECT DISTINCT `report_id`, `user_id`, `official_code`, `lastname`, `firstname`
						FROM `campus_assignment_rel_teacher`
							INNER JOIN `user_user`
								ON `user_user`.`id`= `campus_assignment_rel_teacher`.`user_id`
							INNER JOIN `campus_assignment`
								ON `campus_assignment`.`id`= `campus_assignment_rel_teacher`.`assignment_id`
							INNER JOIN `campus_reportcard`
								ON `campus_assignment`.`id`=`campus_reportcard`.`assignment_id`
							WHERE `campus_reportcard`.`id`=" . $rij['id'] . " ORDER BY `lastname`";
                $result2 = mysql_query($query2);
                $teachers = "";
                while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                {
                    $teachers.=$rij2['official_code'];
                }

                $selectoption = $rij['name'] . " (" . $teachers . ")";
                $text = $pdf->addTextWrap($x + 2, $y + 15, 90, 8, utf8_decode($selectoption), 'left', 0);
                $pdf->addTextWrap($x + 2, $y + 7, 90, 8, utf8_decode($text), 'left', 0);
                $pdf->Rectangle($x, $y, 90, $cellheight); // titelkader
                //read points from student......
                $query2 = "SELECT * FROM `campus_evaluation_score` WHERE `reportcard_id`=" . $rij['id'] . " AND `user_id`=" . $student['id'];
                $result2 = mysql_query($query2);
                $points = array();
                while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
                {
                    $points[$rij2['evaluation_id']][$rij2['id']]['score'] = $rij2['score'];
                    $points[$rij2['evaluation_id']][$rij2['id']]['comment'] = $rij2['comment'];
                    $points[$rij2['evaluation_id']][$rij2['id']]['constant_id'] = $rij2['constant_id'];
                    $points[$rij2['evaluation_id']][$rij2['id']]['date'] = $rij2['date'];
                }

                $data[$i]['vak'] = $selectoption;
                $n = 0;
                foreach ($cols as $key => $column)
                {
                    if ($column['column'] == 'report')
                    { // column is report
                        //echo "<td class='emptypointcell'>&nbsp;";
                        //echo $column['report_id']."";
                        //echo "</td>\n";
                    }
                    else
                    { // column is evaluation
                        // get details from evaluation
                        $listid = intval($reportcard['evaluations'][$column['evaluation_id']]['list_id']);
                        //check if score exists.....
                        $found = FALSE;
                        $constantid = 0;
                        foreach ($points[$column['evaluation_id']] as $scoreid => $scoredetails)
                        {
                            if (($scoredetails['date'] >= $reportcard['reports'][$column['report_id']]['reportstart']) && ($scoredetails['date'] <= ($reportcard['reports'][$column['report_id']]['reportend'] + 86400)))
                            {
                                $constantid = $points[$column['evaluation_id']][$scoreid]['constant_id'];
                                $score = $points[$column['evaluation_id']][$scoreid]['score'];
                                $comment = $points[$column['evaluation_id']][$scoreid]['comment'];
                                $found = TRUE;
                                break;
                            }
                        }
                        if (!$found)
                        { // no points found display emptypointcell...
                            //echo "<td class='emptypointcell'>";
                        }
                        else
                        {
                            if ($listid > 0)
                            { // if the evaluation has a select list....
                                $pdf->addTextWrap($x + 90 + ($n * $cellwidth), $y + 5, $cellwidth, 16, $list[$listid][$constantid]['code'], 'center', 0);
                            }
                            else
                            {
                                $pdf->addTextWrap($x + 90 + ($n * $cellwidth), $y + 5, $cellwidth, 16, $score, 'center', 0);
                            }
                        }
                        $pdf->Rectangle($x + 90 + ($n * $cellwidth), $y, $cellwidth, $cellheight); // titelkader
                        $n++;
                    }
                }
            }
        }
    }
    $fileoption = array('Content-Disposition' => $filename . '.pdf');
    $pdf->ezStream($fileoption);
}
?>