<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\DatetimeUtilities;
    
//check if user is allowed here...
if ((intval($_uid) == 0) || (empty($departmentStruc) || empty($is_teacher)) && !($is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoDepartmentMember"), false);
}
else
{//only teachers and platform administrator are allowed here...
    include("report.inc.php");
 
    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */
    $childreport_id = intval(campus::get_POST_GET("childreport_id"));
    $evaluation_id = intval(campus::get_POST_GET("evaluation_id"));
    $action = campus::get_POST_GET("action", "list");

    /*
      ==============================================================================
      Update query's execute actions...
      ==============================================================================
     */

    if ($action == 'write')
    {
        $score_array = campus::get_POST_GET("score_array");
        $prev_reportid = 0;
        $prev_evaluationid = 0;
        foreach ($score_array as $scoreid => $score)
        {
            if (strstr($scoreid, ";") != FALSE)
            { // new score.....
                list($reportid, $evaluationid, $userid) = explode(";", $scoreid);
                if ($reportid != $prev_reportid)
                { // get details from parent report when not already read....
                    $prev_reportid = $reportid;
                    $result = mysql_query("SELECT * FROM `campus_report` WHERE `id`=" . $reportid . " ");
                    $reportdetails = mysql_fetch_array($result, MYSQL_ASSOC);
                }
                if ($evaluationid != $prev_evaluationid)
                { // get details from parent evaluation when not already read....
                    $prev_evaluationid = $evaluationid;
                    $result = mysql_query("SELECT * FROM `campus_evaluation` WHERE `id`=" . $evaluationid . " ");
                    $evaluationdetails = mysql_fetch_array($result, MYSQL_ASSOC);
                }
                if ((intval($reportid) != 0) && (intval($evaluationid) != 0) && (intval($userid) != 0))
                {
                    // select existing scores....
                    $result = mysql_query('SELECT * FROM `campus_evaluation_score` WHERE `date`>' . (time()-3600) . ' AND `reportcard_id`=' . $reportcard_id . ' AND `evaluation_id`=' . intval($evaluationid) . ' AND `user_id`= ' . intval($userid) );
                    if (mysql_num_rows($result) == 0)
                    {  // only when records is not all ready written, insert new score, preventing double writes when pressing RELOAD ON BROWSER......
                        $query = 'INSERT `campus_evaluation_score` SET' .
                                '`date`=' . time() . ',';
                        if ($evaluationdetails['list_id'] > 0)
                        {
                            $query.="`constant_id`=" . intval($score) . ",";
                            $query.="`score`= '',";
                            $query.="`comment`='',";
                        }
                        else
                        {
                            $query.="`constant_id`=0,";
                            $query.="`score`= " . (($score == '') ? 'NULL' : $score) . ",";
                            $query.="`comment`='',";
                        }
                        $query.="`reportcard_id`=" . $reportcard_id . "," .
                                "`evaluation_id`=" . intval($evaluationid) . "," .
                                "`user_id`= " . intval($userid) . "";
                        $result = mysql_query($query);
                    }
                    else
                    {
                     $message='allreadysaved';

                    }
                }
            }
            elseif (intval($scoreid) > 0)
            {
                $query = 'UPDATE `campus_evaluation_score` SET
					`date`=' . time() . ',
					`constant_id`=' . intval($score) . '
					WHERE `id`=' . intval($scoreid);
                $result = mysql_query($query);
            }
        }
        $action = "list";
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */

    if (!empty($message))
    {
        Display::warning_message($message, false);
    }
    // build table structure for report..
    $t = 1;
    $reportcard = get_reportstruc($report_id);
    //campus::show_arrays($reportcard);
    // report form
    echo '<form method="post" action="' . $this->get_url(). '" name="formreport">';
    echo '<input type="hidden" name="page" value="content" >';
    echo '<input type="hidden" name="action" value="' . $action . '" >';
    echo '<input type="hidden" name="select" value="' . $select . '" >';
    echo '<input type="hidden" name="teacher_id" value="' . $teacher_id . '" >';
    echo '<input type="hidden" name="reportcard_id" value="' . $reportcard_id . '" >';
    echo '<input type="hidden" name="report_id" value="' . $report_id . '" >';
    echo '<table cellspacing=0 cellpadding=0>';

    // stijlen verplaatsen naar style sheet....
    echo '<style>';
    echo '.pointcell { border: 1px solid #000;}';
    echo '.emptypointcell { border: 1px solid #000;background:#999;}';
    echo '.pointsheader { border: 1px solid #000;width:100px;text-align:center}';
    echo '.rowheader { border: 1px solid #000;width:270px;}';
    echo '</style>';
  
    $cols = array();
    $colid = 1;
    $editallowed = FALSE; // used when report view='select' ...
    // check reports ....
    foreach ($reportcard as $rows => $array)
    {
        if ($rows == 'lists')
        {//build selections....
            foreach ($array as $list_id => $value)
            {// put select list in array...
                $query = 'SELECT `campus_evaluation_constant`.`id`, `code` , `comment`, `default_id` FROM `campus_evaluation_constant` INNER JOIN `campus_evaluation_constant_list`
                                                        ON `campus_evaluation_constant`.`list_id`= `campus_evaluation_constant_list`.`id`  WHERE `list_id`=' . $list_id . ' ORDER BY `display_order`';
                $result = mysql_query($query);
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    $list[$list_id][$rij['id']]['code'] = $rij['code'];
                    $list[$list_id][$rij['id']]['comment'] = $rij['comment'];
                    $list[$list_id]['default_id'] = $rij['default_id'];
                }
            }
        }
        elseif (($rows != 'evaluations') && ($rows != 'reports'))
        { // put report columns in array...
            echo '<tr>';
            echo '<td><b><big>' . $grouplist . '</big></b></td>'; //row header...
            $grouplist = ""; // has to be written only once...
            $firstselect = TRUE; //used for report view='select'...
            $suggestedreport_id = 0;
            foreach ($array as $reportid => $reportcolumn)
            {
                if ($reportcolumn['visible'] == 1)
                {
                    //build column header
                    if ($reportcolumn['view'] == 'cols')
                    { // column when score has to be assigned or tree_view is disabled...
                        $cols[$colid]['column'] = 'report';
                        $cols[$colid]['allow_score'] = $reports['reports'][$reportid]['allow_score'];
                        $cols[$colid]['report_id'] = $reportid;
                        $cols[$colid++]['evaluation_id'] = 0;
                        $colspan = 1;
                    }
                    else
                    {
                        $colspan = $reportcolumn['cols'];
                    }
                    if ($reportcolumn['view'] == 3)
                    {
                        $option = "";
                        if ($childreport_id == 0)
                        { // there's no report selected, select a report
                            if ((time() >= $reportcard['reports'][$reportid]['reportstart']) && (time() <= $reportcard['reports'][$reportid]['reportend']+86400))
                            { // a report within a start and end date is prefered and made 'active'....
                                $childreport_id = $reportid; // make this report the selected report to show the correct columns...
                                $option = "selected"; // select this option in the list....
                                $editallowed = TRUE; //make the edit button visible
                            }
                            elseif ($firstselect)
                            { // consider this to be an option when no 'active' report is found...
                                $option = "selected"; // select this option in the list....
                                $suggestedreport_id = $reportid;
                            }
                            elseif (time() >= $reportcard['reports'][$reportid]['reportstart'])
                            { // consider this to be better then select the first report when no 'active' report is found...
                                $option = "selected";
                                $suggestedreport_id = $reportid; // override the $reportid
                            }
                        }
                        elseif ($childreport_id == $reportid)
                        { // when a report is selected this option has to be selected in the list....
                            $option = "selected";
                            if ((time() >= $reportcard['reports'][$reportid]['reportstart']) && (time() <= $reportcard['reports'][$reportid]['reportend']+86400))
                                $editallowed = TRUE; // when the actual date is within the report start and end date make the edit button visible

                        }
                        if ($action == 'list')
                        {
                            echo ($firstselect ? "<td colspan='" . $colspan . "'  class='pointsheader'><select name='childreport_id' OnChange='javascript:document.formreport.submit();'>" : "");
                            $firstselect = FALSE;
                            echo "<option value='" . $reportid . "' " . $option . ">" . $reportcolumn['title'] . "</option>\n";
                        }
                        elseif ($childreport_id == $reportid)
                        { // when action is not list, display the header for the selected report
                            echo "<td colspan='" . $colspan . "' class='pointsheader'>" . $reportcolumn['title'] . "</td>";
                        }
                    }
                    else
                    {
                        echo "<td colspan='" . $colspan . "' class='pointsheader'>" . $reportcolumn['title'] . "</td>\n";
                    }
                }
                if (is_array($reportcolumn['evaluation']) && ($childreport_id == $reportid))
                {
                    foreach ($reportcolumn['evaluation'] as $evaluationid => $evaluationcolumn)
                    {
                        if ($evaluationcolumn['visible'] == 1)
                        {
                            //build column header
                            //campus::show_arrays($reports['evaluations']);//['evaluations'][$evaluation_id]['allow_score'];
                            if (($reportcard['evaluations'][$evaluationid]['allow_score'] == 1) || ($evaluationcolumn['tree_view'] == 0))
                            { // column when score has to be assigned or tree_view is disabled...
                                //$cols[$col_id][]=$rows['reports'][$report_id][''];
                                $cols[$colid]['column'] = 'evaluation';
                                $cols[$colid]['allow_score'] = $reportcard['evaluations'][$evaluationid]['allow_score'];
                                $cols[$colid]['report_id'] = $reportid;
                                $cols[$colid++]['evaluation_id'] = $evaluationid;
                                $colspan = 1;
                            }
                            else
                            {
                                $colspan = $evaluationcolumn['cols'];
                            }
                            echo '<td colspan="' . $colspan . '" class="pointsheader" title="' . $evaluationcolumn['comment'] . '">' . $evaluationcolumn['title'] . '</td>';
                        }
                    }
                }
            }
            if (($action == 'list') && ($reportcolumn['view'] == 3))
            {
                echo "</select></td>"; //used for report view='select' in list view...
                if ($childreport_id == 0)
                {
                    $childreport_id = $suggestedreport_id;
                }
            }
            echo "</tr>\n";
        }
    }

    // studentlist....
    $query = "SELECT `user_user`.`id` as user_id, `display_order`, `lastname`, `firstname`, `group_group`.`code`, `group_group`.`id` as group_id
			            FROM `user_user`
			                INNER JOIN `group_group_rel_user`
			                   ON `user_user`.`id` = `group_group_rel_user`.`user_id`
			                INNER JOIN `group_group`
			                   ON `group_group`.`id` = `group_group_rel_user`.`group_id` WHERE (";
    foreach ($groups as $group_id => $groupinfo)
    {
        $filter.="`group_group_rel_user`.`group_id` = " . $group_id . " OR ";
    }
    $filter = substr($filter, 0, -3) . " ";
    $query.=$filter . ") ORDER BY `group_group`.`code`, `display_order`, `lastname`, `firstname`";
    $result = mysql_query($query);
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        //read points from student......
        $query2 = "SELECT * FROM `campus_evaluation_score` WHERE `reportcard_id`=" . $reportcard_id . " AND `user_id`=" . $rij['user_id'];
        $result2 = mysql_query($query2);
        $points = array();
        while ($rij2 = mysql_fetch_array($result2, MYSQL_ASSOC))
        {
            $points[$rij2['evaluation_id']][$rij2['id']]['score'] = $rij2['score'];
            $points[$rij2['evaluation_id']][$rij2['id']]['comment'] = $rij2['comment'];
            $points[$rij2['evaluation_id']][$rij2['id']]['constant_id'] = $rij2['constant_id'];
            $points[$rij2['evaluation_id']][$rij2['id']]['date'] = $rij2['date'];
        }
        $data = array();
        echo '<tr>';
        echo '<td class="rowheader">'
        . '<a href="'.$this->get_studentreport_url().'&page=studentreport&student_id=' . $rij['user_id'] . '" title="' . get_lang("tooltipStudentReport") . '">'
        . $rij['display_order'] . " " . $rij['lastname'] . " " . $rij['firstname'] . "</a>"
        . "</td>\n";
        foreach ($cols as $key => $column)
        {
            if ($column['column'] == 'report')
            { // column is report
                echo "<td class='emptypointcell'>&nbsp;";
                echo $column['report_id'] . "?";
                echo "</td>\n";
            }
            else
            { // column is evaluation
                // get details from evaluation
                $listid = intval($reportcard['evaluations'][$column['evaluation_id']]['list_id']);
                //check if score exists.....
                $found = FALSE;
                $constantid = 0;
                foreach ($points[$column['evaluation_id']] as $scoreid => $scoredetails)
                {

                    if (($scoredetails['date'] >= $reportcard['reports'][$column['report_id']]['reportstart']) && ($scoredetails['date'] <= $reportcard['reports'][$column['report_id']]['reportend']+86400))
                    {
                        $constantid = $points[$column['evaluation_id']][$scoreid]['constant_id'];
                        $score = $points[$column['evaluation_id']][$scoreid]['score'];
                        $comment = $points[$column['evaluation_id']][$scoreid]['comment'];
                        $found = TRUE;
                        break;
                    }
                }
                if ((!$found) && (($action == 'list') || (time() < $reportcard['reports'][$column['report_id']]['reportstart']) || (time() > $reportcard['reports'][$column['report_id']]['reportend']+86400)))
                { // no points found display emptypointcell...
                    echo "<td class='emptypointcell'>";
                }
                else
                {
                    echo "<td class='pointcell'>";
                    if (($action == 'edit') && (time() >= $reportcard['reports'][$column['report_id']]['reportstart']) && (time() <= $reportcard['reports'][$column['report_id']]['reportend']+86400))
                    {
                        if ($listid > 0)
                        { // if the evaluation has a select list....
                            if (intval($constantid) == 0)
                            {
                                $constantid = $list[$listid]['default_id'];
                                echo "<select name='score_array[" . $column['report_id'] . ";" . $column['evaluation_id'] . ";" . $rij['user_id'] . "]'>";
                            }
                            else
                            {
                                echo "<select name='score_array[" . $scoreid . "]'>";
                            }
                            foreach ($list[$listid] as $selectconstantid => $details)
                            {
                                if ($selectconstantid != 'default_id')
                                {
                                    echo "<option value='" . $selectconstantid . "' " . (($constantid == $selectconstantid) ? "selected" : "") . ">" . $details['code'] . "</option>";
                                }
                            }
                            echo "</select>";
                        }
                        else
                        {
                            if ($score == '')
                            {
                                echo "<input type='text' size='3' name='score_array[" . $column['report_id'] . ";" . $column['evaluation_id'] . ";" . $rij['user_id'] . "]' value=''>";
                            }
                            else
                            {
                                echo "<input type='text' size='3' name='score_array[" . $scoreid . "]' value='" . $score . "'>";
                            }
                        }
                    }
                    else
                    {
                        if ($listid > 0)
                        { // if the evaluation has a select list....
                            echo "<b title='" . $list[$listid][$constantid]['comment'] . "'>" . $list[$listid][$constantid]['code'] . "</b>";
                        }
                        else
                        {
                            echo "<b title='" . $comment . "'>" . $score . "</b>";
                        }
                    }
                }
                echo "</td>\n";
            }
        }
        echo "</tr>\n";
    }
    echo "</table>";

    switch ($action)
    {
        case 'list':
            {
                if (($editallowed) || ($childreport_id == 0))
                {
                    echo "<input type='submit' name='submitmessage' value='" . get_lang("buttonlabelEdit") . "' OnmouseDown=\"javascript:document.formreport.action.value='edit';\"/>";
                }
            }
            break;
        case 'edit':
            {
                echo "<input type='submit' name='submitmessage' value='" . get_lang("buttonlabelSave") . "' onMouseDown=\"javascript:document.formreport.action.value='write';\"/>&nbsp;&nbsp;<input type='submit' name='cancel' value='" . get_lang("buttonlabelCancel") . "' onMouseDown=\"javascript:document.formreport.action.value='list';\">";
            }
            break;
    }
    echo "</form>";
    echo "<div style=\"clear:both\"></div>";
}
?>