<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Display;
use common\libraries\DatetimeUtilities;

//check if user is allowed here...
if ((intval($_uid) == 0) || empty($departmentStruc) && !($is_platformadmin))
{// not allowed here!
    Display::error_message(get_lang("msgNoDepartmentMember"), false);
}
else
{//only teachers and platform administrator are allowed here...

    /*
      ==============================================================================
      POST & GET vars, check for default value?.
      ==============================================================================
     */

    $week = DatetimeUtilities::get_days_long();
    // remove sunday and saturday from array...
    $week = array_slice($week, 1, 5, true);
    $class_id = intval(campus::get_POST_GET("class_id", 0));
    $dateselect = intval(campus::get_POST_GET("dateselect", mktime(0, 0, 0, date('m', time()), date('d', time()), date('Y', time()))));
    $student_id = intval(campus::get_POST_GET("student_id", 0));

    if ((strftime('%w', $dateselect) == 6) || (strftime('%w', $dateselect) == 0))
    {
        $dateselect = strtotime('next Monday', $dateselect);
    }
   // het actieve uurrooster van de department bepalen...
    // het uurrooster bepalen wat bij de datum en de department hoort ...
    $activeroster = campus::get_activeroster($department_id, $dateselect);

    if ((($class_id == 0) && (!($is_teacher || $is_platformadmin))) || ($student_id != 0))
    {
        $student_id = ($student_id == 0) ? $_uid : $student_id;
        $classes = campus::get_classes($student_id);
    }

    // calculate monday
    $monday = strtotime('Next Monday', strtotime('-1 Week', $dateselect));

    $kw = strftime('%V', $monday); // iso weeknummer op server
    if ($kw == null)
    {
        $kw = strftime('%U', $monday) + 1;
    } // weeknummer lokaal
    $prevweek = strtotime('-1 week', $monday);
    $nextweek = strtotime('+1 week', $monday);
 
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */


    if ($activeroster['roster_id'] > 0)
    {
        $select = "";
        if (($is_teacher || $is_platformadmin) && ($student_id == 0))
        {
            $selectquery = "`campus_assignment_rel_group`.`group_id`=" . intval($class_id) . " ";
            $select = intval($class_id);
            $classeslinks = "";
            $classes = campus::get_studentclasses($department_id);
            foreach ($classes as $key => $value)
            {
                $classeslinks.='<a href="' . $this->get_url() . '&department_id=' . $department_id . '&class_id=' . $key . '" title="' . $value['name'] . '">' . $value['code'] . '</a>  ';
            }
            echo ("<div >");
            echo $classeslinks;
            echo ("</div>");
        }
        else
        {
            echo "<div>";
            $selectquery = "(";
            $query = "SELECT DISTINCT `user_user`.`id`, `lastname`, `firstname`
		            FROM `user_user`
		                INNER JOIN `campus_parent_rel_student`
		                   ON `user_user`.`id` = `campus_parent_rel_student`.`student_id`
		  		WHERE `campus_parent_rel_student`.`parent_id`=" . $_uid . "
					ORDER BY `lastname`,`firstname`";
            $result = mysql_query($query);
            if (mysql_num_rows($result) >= 1)
            { // is parent....
                $is_parent = TRUE;
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    echo ' <a href="' . $this->get_url() . '&student_id=' . $rij['id'] . '&department_id=' . $department_id . '&class_id=' . $id . '" title="' . get_lang("tooltipDisplay") . ' ' . $rij['lastname'] . ' ' . $rij['firstname'] . ".\">" . $rij['lastname'] . ' ' . $rij['firstname'] . '</a>';
                }
            }
            else
            {
                $is_parent = FALSE;
            }
            foreach ($classes as $id => $value)
            {
                echo "&nbsp;&nbsp;<b style=\"font-size: 18px;color:#4171b5;\" title=\"" . $classes[$id]['name'] . "\">" . $classes[$id]['code'] . "</b>";
                $selectquery.="`campus_assignment_rel_group`.`group_id`=" . $id . " OR ";
                $select.=$id . "_";
            }
            $selectquery = substr($selectquery, 0, -3) . ")";
            $select = substr($select, 0, -1);
            echo "</div>";
        }
        echo "<span style=\" float:right; padding-top: 10px;\">";
        if (($is_teacher || $is_platformadmin) && ($student_id == 0))
        {
            echo ' <a href="' . $this->get_roster_url() . '&page=klas2pdf&roster_id=' . $activeroster['roster_id'] . '" target="_blank" >' . get_lang("txtDiscipline2Pdf") . '</a> |';
            if ((isset($admin['roster']) && $admin['roster']) || $is_platformadmin)
            {
                echo ' <a href="' . $this->get_roster_url() . '&page=roster2excel&rooster=class&roster_id=' . $activeroster['roster_id'] . '" target="_blank" >' . get_lang("txtRoster2Excel") . '</a> |';
                echo ' <a href="' . $this->get_roster_url() . '&page=roster2pdf&compact=&rooster=class&select=complete&roster_id=' . $activeroster['roster_id'] . '" target="_blank" >' . get_lang("txtAllRoster2Pdf") . '</a> |';
            }
            echo ' <a href="' . $this->get_roster_url() . '&page=roster2pdf&compact=on&rooster=class&select=complete&roster_id=' . $activeroster['roster_id'] . '" target="_blank" >' . get_lang("txtAllRoster2PdfCompact") . '</a> |';
        }
        echo '<a href="' . $this->get_roster_url() . '&page=roster2pdf&compact=&rooster=class&select=' . $select . '&roster_id=' . $activeroster['roster_id'] . '" target="_blank" >' . get_lang("txtRoster2Pdf") . '</a> ';
        echo '</span>';
        if (($is_teacher || $is_platformadmin) && ($student_id == 0))
        {
            $class_info = campus::get_class_info($class_id);
            echo "<b style=\"font-size: 18px;\"><i title=\"" . $class_info[$class_id]['name'] . "\">" . $class_info[$class_id]['code'] . "</i></b>";
        }
        echo "<div style=\"clear:both\"></div>";
        echo "<div style='position:relative;left: 0px;top: 0px;'>";

        //=============================================================================
        // UURROOSTER klassen.......
        //=============================================================================
        $rooster = campus::get_rosterarray($department_id);
        echo '	<table align="center" style="width:100%;border: 1px #FFFFFF ">
                    <tr class="campus_middle">
                        <td >
                            <a  href="' . $this->get_url() . '&dateselect=' . $prevweek . '&class_id=' . $class_id . '" title="' . get_lang("tooltip1WeekBack") . '"><<<</a>
					</td>
					<td align="center" width="100%">
						<b >De week van ' . DatetimeUtilities::format_locale_date('%A %d %B %Y', $monday) . ' (Week:' . $kw . ')' . '</b>
					</td>
					<td >
						&nbsp;&nbsp;<a  href="' . $this->get_url() . '&dateselect=' . $nextweek . '&class_id=' . $class_id . '" title="' . get_lang("tooltip1WeekForward") . '">>>></a>
					</td>
				</tr>
			</table>
		';


        $query = 'SELECT `campus_college`.`assignment_id`,`group_id`, `campus_college`.`id` as college_id, `weekday`,`code`, `display_order`,`duration`, `campus_period`.`id` as period_id, `duration`
                                        FROM `campus_period`
                                            INNER JOIN `campus_college`
                                                ON `campus_period`.`id`=`campus_college`.`period_id`  AND `campus_college`.`roster_id`=' . $activeroster['roster_id'] . '
                                            INNER JOIN `campus_assignment_rel_group`
                                                ON  ' . $selectquery . ' AND `campus_assignment_rel_group`.`assignment_id`=`campus_college`.`assignment_id` 
                                             WHERE `department_id`=' . $department_id . '
                                          ORDER BY `weekday`, `display_order`';
        $result = mysql_query($query);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            while ($rij['duration'] > 0)
            {
                $rooster[$rij['display_order']][$rij['weekday']]['disciplines'] = campus::get_assignment2discipline($rij['assignment_id'], $rooster[$rij['display_order']][$rij['weekday']]['disciplines']);
                $rooster[$rij['display_order']][$rij['weekday']]['teachers'] = campus::get_assignment2teacher($rij['assignment_id'], $activeroster['roster_id'], $rooster[$rij['display_order']][$rij['weekday']]['teachers']);
                $rooster[$rij['display_order']][$rij['weekday']]['resources'] = campus::get_college2resource($rij['college_id'], $rooster[$rij['display_order']][$rij['weekday']]['resources']);
                $rij['display_order']++;
                $rij['duration']--;
            }
        }


        // uurrooster weergeven.....
        if (($is_teacher) && ($class_id == 0) && ($student_id == 0))
        {
            echo "<div style='position: absolute;left: 20%;top: 30%;text-align:center;width:60%;'><div style='text-align:left'>";
            Display::normal_message(get_lang('msgStudentRosterHint'), false);
            echo "</div></div>";
        }
        campus::display_complex_table_header($properties, array_merge(array(""), $week));
        foreach ($rooster as $hourkey => $value1)
        {
            $i = 0;
            $row = array();
            foreach ($week as $day => $daylong)
            {
                $lijn1 = "";
                foreach ($rooster[$hourkey][$day]['teachers'] as $id => $value)
                {
                    // Override resource with reservations ...
                    // Override resource with reservations ...
                    $query = 'SELECT `resource_id`, `display_order`,`date`, `state`, `period_id` FROM `campus_reservation`
                            INNNER JOIN `campus_period` ON `campus_period`.`id`=`period_id`
						WHERE  `date`=' . ($monday + (($day - 1) * 86400)) . ' AND `period_id` = ' . $rooster[$hourkey][$day]['period_id'] . ' AND `user_id`=' . $id . '';
                    $result = mysql_query($query) or die(mysql_error());
                    $t = "";
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        $rooster[$hourkey][$day][$rij['state']][$rij['resource_id']] = campus::get_resource_info($rij['resource_id']);
                        $t = $rij['state'];
                    }
                    $lijn1.="<i title=\"" . $value['name'] . ".\">" . $value['official_code'] . "</i> ";
                }
                $lijn2 = "";
                foreach ($rooster[$hourkey][$day]['disciplines'] as $id => $value)
                {
                    $lijn2.="<b title=\"" . $value['name'] . "\">" . $value['code'] . "</b> ";
                }
                $lijn3 = "";
                $original_resources = "";
                if (array_key_exists($this::RESOURCE_OCCUPIED, $rooster[$hourkey][$day]))
                {
                    foreach ($rooster[$hourkey][$day]['resources'] as $id => $value)
                    {
                        $original_resources.=$value['code'] . "&nbsp;";
                    }
                    foreach ($rooster[$hourkey][$day][$this::RESOURCE_OCCUPIED] as $id => $value)
                    {
                        $lijn3.="<i style=\"float:right;color:#FF5500;font-weight:bold;\" title=\"" . get_lang("tooltipOrgResources") . ": " . $original_resources . "\">" . $value['code'] . "&nbsp;</i>";
                    }
                }
                foreach ($rooster[$hourkey][$day]['resources'] as $id => $value)
                {
                    if (!empty($rooster[$hourkey][$day][$this::RESOURCE_RELEASED][$id]))
                    {
                        if ($original_resources == "")
                        { // if $original_resource are empty there is no reservation of other resources..
                            $lijn3.="<i style=\"float:right;color:#999999;\" title=\"" . get_lang("tooltipResourceReleased") . "\">" . $value['code'] . "&nbsp;</i>";
                        }
                    }
                    else
                    {
                        $lijn3.="<i style=\"float:right\" title=\"" . $value['comment'] . "\">" . $value['code'] . "&nbsp;</i>";
                    }
                }
                $row = array_merge($row, array("<div align=\"left\">" . $lijn1 . "</div><div align=\"center\">" . $lijn2 . "</div><div >" . $lijn3 . "</div>"));
                $i++;
            }
            campus::display_table_row($cellproperties, array_merge(array("<i style='font-size:8px'>" . DatetimeUtilities::format_locale_date("%H:%M", $rooster[$hourkey][1]['start_time']) . "</i><br><b style=\"font-size:20px;\">" . $hourkey . "</b><br><i style='font-size:8px'>" . DatetimeUtilities::format_locale_date("%H:%M", $rooster[$hourkey][1]['end_time']) . "</i>"), $row));
        }
        campus::display_table_footer();
        echo "</div>";
        if (($is_teacher || $is_platformadmin) && ($student_id != 0))
        {
            echo '<a href="' . $this->get_studentlist_url() . '&select=' . $class_id . '" title="">' . get_lang('txtBack') . '</a>';
        }
    }
    else
    {
        Display::error_message(get_lang("msgNoRoster"), false);
    }
}
?>