<?php

/*
  ==============================================================================
  Belangstellingstest van leerlingen van dehet tweede jaar van de 1e graad,
  als hulp bij de keuze van het eerste jaar van de 2e graad.

  Deze script is geïntegreerd in de leeromgeving DOKEOS met de campus plugin
  geïnstalleerd...

  by Ludwig Theunis (email: ludwig@tussen.be)
  ==============================================================================
 */
/*
  ==============================================================================
  Dokeos - elearning and course management software

  Copyright (c) 2004-2005 Dokeos S.A.
  Copyright (c) 2003 University of Ghent (UGent)
  Copyright (c) 2001 Universite catholique de Louvain (UCL)
  Copyright (c) various contributors

  For a full list of contributors, see "credits.txt".
  The full license can be read in "license.txt".

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  See the GNU General Public License for more details.

  Contact address: Dokeos, 44 rue des palais, B-1030 Brussels, Belgium
  Mail: info@dokeos.com
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Display;
use common\libraries\PlatformSetting;
use common\libraries\Theme;
use common\libraries\Path;
use common\libraries\ResourceManager;
use common\libraries\DatetimeUtilities;

/*
  ==============================================================================
  INIT SECTION
  ==============================================================================
 */
/*
  -----------------------------------------------------------
  Included libraries
  -----------------------------------------------------------
 */
include ('vragen_array.php');
// the section (for the tabs)

$classes = campus::get_classes($_uid);
$allowed = TRUE;
foreach ($classes as $class_id => $class)
{ // class teacher
    $query = "SELECT `teacher_id` FROM `campus_teacher_rel_group`
                WHERE `group_id`=" . $class_id . " ";
    $result = mysql_query($query);
    while ($rij = mysql_fetch_array($result))
    {
        $teacher_id = $rij['teacher_id'];
        $teacher = campus::get_user_info($teacher_id);
    }
}

/*
  ==============================================================================
  POST & GET vars, check for default value?.
  ==============================================================================
 */
$vraag_no = intval(campus::get_POST_GET("vraag_no", 1));
$antwoord = campus::get_POST_GET("antwoord");
$trackingform_id = intval(campus::get_POST_GET("trackingform_id"));


/*
  ==============================================================================
  display header & breadcrumb...
  ==============================================================================
 */
//$nameTools = get_lang("namecampusAdmin");


echo '<div style="font-size:14px;">';

//campus::display_departments ($departmentStruc,$department_id,$page);
//check if user is allowed here...
if (!($allowed))
{// not allowed here!
    Display::error_message("Enkel leeringen van het 2e jaar kunnen deze belangstellingstest doen", false);
}
else
{//only departmentadmins and platform administrator is allowed here...
    /*
      ==============================================================================
      database  ...
      ==============================================================================
     */
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);
    $student_id = intval($_uid);
    $student = campus::get_user_info($_uid);
    $departmentStruc = campus::get_department($_uid);
    $department_id = key($departmentStruc);
    $department_code = $departmentStruc[$department_id]['code'];
    $submitmessage = campus::get_POST_GET("submitmessage");

    // get info from tracking form...
    $query = "SELECT `subject`,`tracking_title`, `tracking_category`, `form_type` FROM `campus_trackingform`
				INNER JOIN `campus_tracking_title`
					ON `campus_tracking_title`.`id`=`campus_trackingform`.`title_id`
				INNER JOIN `campus_tracking_category`
					ON `campus_tracking_title`.`category_id`=`campus_tracking_category`.`id`
				WHERE `campus_trackingform`.`id`=" . $trackingform_id . "";
    $result = mysql_query($query);
    list($subject, $tracking_title, $tracking_category, $form_type) = mysql_fetch_row($result);

    if ($submitmessage != "")
    { //
        if ($trackingform_id > 0)
        {
            // only write once....	
            $query = "SELECT * FROM `campus_student_tracking` WHERE 
						`student_id`=" . $student_id . " AND `tracking_category`='" . $tracking_category . "' AND `tracking_title`='" . $tracking_title . "' AND `teacher_code`='" . $teacher['official_code'] . "' AND `department_code`='" . $department_code . "'
									 AND `date` >='" . substr($academicYear, 0, 4) . "-07-01' AND `date` <='" . substr($academicYear, 5, 4) . "-08-31'";
            $result = mysql_query($query);
            if (mysql_num_rows($result) == 0)
            {
                $content = "<b>Resultaat:</b>\n\n";
                $resultaat = "";
                foreach ($domein as $no => $array)
                {
                    $query = "SELECT `question_id` FROM `SG_belangstellingstest`.`2egraad`
                				WHERE `user_id`=" . $_uid . " AND `acyear`='" . $academicYear . "' AND SUBSTRING(`answer`,2)='" . $no . "'";
                    $result = mysql_query($query) or die(mysql_error());
                    $punten = (mysql_num_rows($result));
                    if ($punten < 5)
                    {
                        $score[$no] = "Zeer laag (" . $punten . ")";
                    }
                    elseif ($punten < 10)
                    {
                        $score[$no] = "Laag (" . $punten . ")";
                    }
                    elseif ($punten < 15)
                    {
                        $score[$no] = "Middelmatig (" . $punten . ")";
                    }
                    elseif ($punten < 19)
                    {
                        $score[$no] = "Hoog (" . $punten . ")";
                    }
                    else
                    {
                        $score[$no] = "Zeer hoog (" . $punten . ")";
                    }
                    $content.=" " . $array[0] . ": " . $score[$no] . "\n";
                }
                $lines = campus::get_POST_GET("nbrlines");
                for ($line = 1; $line <= $lines[$trackingform_id]; $line++)
                {
                    $begin = is_array(campus::get_POST_GET('F' . $trackingform_id . 'begin' . $line, '', false)) ? implode(", ", campus::get_POST_GET('F' . $trackingform_id . 'begin' . $line, '', false)) : campus::get_POST_GET('F' . $trackingform_id . 'begin' . $line, '', false);
                    $mid = is_array(campus::get_POST_GET('F' . $trackingform_id . 'mid' . $line, '', false)) ? implode(", ", campus::get_POST_GET('F' . $trackingform_id . 'mid' . $line, '', false)) : campus::get_POST_GET('F' . $trackingform_id . 'mid' . $line, '', false);
                    $end = is_array(campus::get_POST_GET('F' . $trackingform_id . 'end' . $line, '', false)) ? implode(", ", campus::get_POST_GET('F' . $trackingform_id . 'end' . $line, '', false)) : campus::get_POST_GET('F' . $trackingform_id . 'end' . $line, '', false);
                    $content.=$begin . " " . $mid . " " . $end . "\n";
                }
                $query = "INSERT `campus_student_tracking` SET
						`student_id`='" . $student_id . "',
						`tracking_category`='" . $tracking_category . "',
						`tracking_title`='" . $tracking_title . "',
						`date`=" . time() . ",
						`changed`=" . time() . ",
						`teacher_code`='" . $teacher['official_code'] . "',
						`grouplist`='" . $grouplist . "',
						`department_code`='" . $department_code . "',
						`public`=1,
						`attachment`='',
						`content`='" . $content . "'
					";

                $result = mysql_query($query);
                if (!$result)
                {
                    $message = "Je belangstellingstest is NIET bewaard, er was een fout";
                }
                else
                {
                    $tracking_id = mysql_insert_id();
                    $message = "Je belangstellingstest is bewaard.";
                }
            }
            else
            {
                $message = "Je belangstellingstest is al bewaard.";
            }
        }
    }
    $query = "SELECT `question_id` FROM `SG_belangstellingstest`.`2egraad`
                 WHERE `user_id`=" . $_uid . " AND `acyear`='" . $academicYear . "' ORDER BY `question_id` DESC";
    $result = mysql_query($query) or die("test".mysql_error());
    list($question_id) = mysql_fetch_row($result);
    if ($question_id >= $vraag_no)
    {
        $vraag_no = $question_id + 1;
    }
    elseif ($antwoord != "")
    {
        // schrijf antwoord in DB...	
        $query = "INSERT `SG_belangstellingstest`.`2egraad` SET 
					`user_id`=" . $_uid . ",
					`question_id`=" . $vraag_no . ",
					`answer`='" . $antwoord . "',
					`acyear`='" . $academicYear . "'";
        $result = mysql_query($query) or die(mysql_error());
        if ($result != false)
        {
            $writeLVS = TRUE;
            $vraag_no++;
        }
        else
        {
            $message = "Er is een fout gebeurd, probeer opnieuw...";
        }
    }

    $userinfo = campus::get_user_info($_uid);

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    //display messages
    if (!empty($message))
    {
        Display::normal_message($message, false);
    }
    // de verschillende klassen die tot een bepaalde department behoren ophalen....
    echo "<div style='width:800px; margin: 10px auto;'><b>Naam: </b>" . $userinfo['firstname'] . " " . $userinfo['lastname'] . "<br>";
    echo "<b>Klas: </b>";
    foreach ($classes as $class_id => $value)
    {
        echo "" . $value['code'] . " ";
        echo "";
    }
    echo "<br><b>Klasdirecteur: </b>" . $teacher['lastname'] . " " . substr($teacher['firstname'], 0, 1) . ".<br>";


    if ($vraag_no == 157)
    { //all vragen zijn ingevuld....
        $score = array();
        $content = "<b>Resultaat:</b>\n\n";
        $resultaat = "";
        foreach ($domein as $no => $array)
        {
            $query = "SELECT `question_id` FROM `SG_belangstellingstest`.`2egraad`
                 WHERE `user_id`=" . $_uid . " AND `acyear`='" . $academicYear . "' AND SUBSTRING(`answer`,2)='" . $no . "'";
            $result = mysql_query($query) or die(mysql_error());
            $punten = (mysql_num_rows($result));
            if ($punten < 5)
            {
                $score[$no] = "Zeer laag (" . $punten . ")";
            }
            elseif ($punten < 10)
            {
                $score[$no] = "Laag (" . $punten . ")";
            }
            elseif ($punten < 15)
            {
                $score[$no] = "Middelmatig (" . $punten . ")";
            }
            elseif ($punten < 19)
            {
                $score[$no] = "Hoog (" . $punten . ")";
            }
            else
            {
                $score[$no] = "Zeer hoog (" . $punten . ")";
            }
            $content.=" " . $array[0] . ": " . $score[$no] . "\n";
            $resultaat.="<li title='" . $array[1] . "'>" . $array[0] . ": " . $score[$no] . "</li>";
        }
        echo "<br><b >Resultaat van de belangstellingstest:</b><br>";
        echo "<ul>";
        echo $resultaat;
        echo "</ul>";
    }

    // check if the $result is already written in db
    $query = "SELECT `id` FROM `campus_student_tracking` WHERE 
						`student_id`=" . $student_id . " AND `tracking_category`='" . $tracking_category . "' AND `tracking_title`='" . $tracking_title . "' AND `teacher_code`='" . $teacher['official_code'] . "' AND `department_code`='" . $department_code . "'
									 AND `date` >= " .mktime(0,0,0,7,1, substr($academicYear, 0, 4)) . " AND `date` <=" . mktime(0,0,0,8,31,substr($academicYear, 5, 4)) . "";
    $result = mysql_query($query) or die(mysql_error());
    list($tracking_id) = mysql_fetch_row($result);
    if ($tracking_id > 0)
    {// het LVS is al ingevuld....
        echo '<br><br><p><a href="' . $this->get_url() . '&page=studentform2pdf&trackingform_id=' . $trackingform_id . '&tracking_id=' . $tracking_id . '" target="_blank">Het resultaat van deze belangstellingstest afdrukken</a></p>';
    }
    else
    {
        if ($vraag_no == 1)
        {
            echo "<br><div style='border: solid 1px #aa8; background-color: #ffa; padding:10px; font-size:14px;color:red;>";
            echo "<b style='font-size:16px;font-weight: bold;'><strong>LEES EERST DIT!</strong></b><br>";
            echo "<p><b>Belangstellingstest voor de leerlingen van het tweede jaar.</b></p>";
            echo "<p>Dit schooljaar moet je een studiekeuze maken voor jouw derde jaar secundair onderwijs.<br>
					Dit is een zeer belangrijke keuze. Je kiest immers voor een studierichting én een onderwijsvorm.<br>
					Deze keuze bepaalt in grote mate je verdere studieloopbaan in het secundair en hoger onderwijs.</p>";
            echo "<p>Je keuze moet dus verantwoord zijn. Hiervoor krijg je tijdens studiekeuzelessen informatie over de verschillende onderwijsvormen en studierichtingen.<br>
					Je hebt ook informatie nodig over jezelf, je belangstelling, prestaties en studiehouding.</p>";
            echo "<p><b>In welke mate ben je voor de verschillende studiegebieden geïnteresseerd? Dat kom je te weten met deze belangstellingstest.</b></p>";
            echo "<p>Je krijgt 156 vragen. Bij elke vraag staan steeds twee activiteiten, twee mogelijkheden waaruit je kan kiezen om te antwoorden. 
				Kies die activiteit of mogelijkheid die je het liefst doet of in de toekomst zou willen doen. Je kan alleen maar kiezen uit deze twee antwoorden en je <b>moet</b> er <b>één</b> kiezen.</p>";
            echo "<p><b>Denk goed na!</b> Je kan elke vraag maar één keer beantwoorden. Eenmaal gekozen kan je het antwoord niet meer veranderen.</p>";
            echo "<p><b>Antwoorden</b> doe je door het <b>juiste </b><span style='font-size:18px;'>O</span> aan te <b>klikken</b>.  <b>Bevestig</b> je antwoord door <b>op OK</b> te <b>klikken</b>.</p>";
            echo "<p>156 vragen... dat zijn er heel wat. Je kan deze belangstellingstest dan ook onderbreken en op een ander moment verder zetten.<br>Je zal dan merken dat je automatisch bij de volgende te beantwoorden vraag terecht komt.<br>Onderaan de pagina zie je een balkje. Dit kleurt blauw in wanneer je de vragen beantwoordt. Aan deze blauwe kleur ( en aan het procentcijfer) zie je hoever je al gevorderd bent. Bij 100% heb je alle vragen opgelost.</p>";
            echo "<p><b>Succes!</b></p>";
            echo "</div>";
        }
        elseif (($antwoord == '') && (campus::get_POST_GET("submitted") == '') && ($vraag_no < 157))
        {
            echo "<br><div style='border: solid 1px #aa8; background-color: #ffa; padding:10px; font-size:14px;color:red;>";
            echo "<b style='font-size:16px;font-weight: bold;'><strong>WELKOM TERUG</strong></b><br>";
            echo "<p>Nog " . (($vraag_no == 156) ? "1 vraag" : (157 - $vraag_no) . " vragen") . ". Bij elke vraag staan steeds twee activiteiten, twee mogelijkheden waaruit je kan kiezen om te antwoorden. 
				Kies die activiteit of mogelijkheid die je het liefst doet of in de toekomst zou willen doen. Je kan alleen maar kiezen uit deze twee antwoorden en je <b>moet</b> er <b>één</b> kiezen.</p>";
            echo "<p><b>Denk goed na!</b> Je kan elke vraag maar één keer beantwoorden. Eenmaal gekozen kan je het antwoord niet meer veranderen.</p>";
            echo "<p><b>Antwoorden</b> doe je door het <b>juiste </b><span style='font-size:18px;'>O</span> aan te <b>klikken</b>.  <b>Bevestig</b> je antwoord door <b>op OK</b> te <b>klikken</b>.</p>";
            echo "<p>156 vragen... dat zijn er heel wat. Je kan deze belangstellingstest dan ook onderbreken en op een ander moment verder zetten.<br>Je zal dan merken dat je automatisch bij de volgende te beantwoorden vraag terecht komt.<br>Onderaan de pagina zie je een balkje. Dit kleurt blauw in wanneer je de vragen beantwoordt. Aan deze blauwe kleur ( en aan het procentcijfer) zie je hoever je al gevorderd bent. Bij 100% heb je alle vragen opgelost.</p>";
            echo "<p><b>Succes!</b></p>";
            echo "</div>";
        }
        echo "<br><br>";
        if ($vraag_no == 157)
        { // na de laatste vraag het bijkomend formulier weergeven
            include ("tracking_specialform.php");
        }
        else
        {
            echo "<b >Vraag " . $vraag_no . ":</b><br>";

            echo "<form action=\"" . $this->get_url() . "\" method=\"POST\" name=\"myform\">";
            //	echo "<input type='tekst' name='search' OnChange='javascript:Selectklas.submit();' value='".$search."'>";
           echo "<input type='hidden' name='page' value='belangstellingstest'>";
            
            echo "<input type='hidden' name='trackingform_id' value='" . $trackingform_id . "'>";
            echo "<input type='hidden' name='vraag_no' value='" . $vraag_no . "'>";
            echo "<input type='radio' name='antwoord' value='" . $vraag[$vraag_no]['A'][1] . "'>" . $vraag[$vraag_no]['A'][0] . "</option><br>";
            echo "<input type='radio' name='antwoord' value='" . $vraag[$vraag_no]['B'][1] . "'>" . $vraag[$vraag_no]['B'][0] . "</option><br>";
            echo "<input type='submit'name='submitted' value='OK'>";
            echo "</form><br><br>";
            echo "<div><div style='float:left;height:20px;width:156px;border: solid 1px #000;'><div style='height:18px;width:" . $vraag_no . "px;border: solid 1px #99f;background:#aaf;'>&nbsp;</div></div>&nbsp;&nbsp;" . (round(($vraag_no / 156) * 100)) . "%</div><br><br>";
        }
    }
}
echo '</div></div>';
?>