<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Theme;
use common\libraries\Path;
use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;

/*
  ==============================================================================
  POST & GET vars, check for default value?.
  ==============================================================================
 */
$tracking_category = campus::get_POST_GET("tracking_category");
$tracking_title = campus::get_POST_GET("tracking_title");
$select = campus::get_POST_GET("select");
$filter = campus::get_POST_GET("filter");
$photo = intval(campus::get_POST_GET("photo", 0));
$academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);


// Get Rights...
$departmentStruc = campus::get_department_info($department_id);

$classtracking = campus::get_trackingrights($_uid, $department_id);
$allowed = ((isset($admin['studentTracking2Pdf']) && $admin['studentTracking2Pdf']) || $is_platformadmin || (!empty($classtracking)));
//check if user is allowed here...

if ((intval($_uid) == 0) || ($department_id == 0) || (!$allowed))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...
    //read student detail info
    $sql = "SELECT `user_user`.`id`,`display_order`, `lastname`, `firstname`, `official_code`, `email`, `group_group`.`name` as `classname`, `group_group`.`code`, `group_group_rel_user`.`group_id`, `picture_uri`
            FROM `user_user`
                LEFT JOIN `campus_user`
                    ON `user_user`.`id` = `campus_user`.`user_id`
                LEFT JOIN `group_group_rel_user`
                    ON `user_user`.`id` = `group_group_rel_user`.`user_id`
                INNER JOIN `group_group`
                    ON `group_group`.`id` = `group_group_rel_user`.`group_id`
		INNER JOIN `campus_department_rel_group`
			ON `group_group`.`id` = `campus_department_rel_group`.`group_id`
		WHERE `type`=2 AND `department_id`=" . $department_id . " ";
    if ($select != 0)
    {
        $sql.="AND (`group_group_rel_user`.`group_id`=" . ereg_replace(",", " OR `group_group_rel_user`.`group_id`=", $select) . ")";
    }
    $sql.=" ORDER BY `group_group`.`code`, `display_order`,`lastname`,`firstname`";
    $result = mysql_query($sql);
    $aantal = mysql_num_rows($result);
    // Pagina instellingen
    include(Path :: get_web_application_path('campus') . '/old_php/php_pdf/class.ezpdf.php');
    $pdf = & new \Cezpdf('a4', 'portrait');
    $phoogte = 842;
    $pbreedte = 575;
    $pdf->ezSetCmMargins(4.2, 1.5, 2, 2);
    $pdf->selectFont(Path :: get_web_application_path('campus') . '/old_php/php_pdf/fonts/Helvetica.afm');
    //koptekst en voettekst
    $pdf->ezStartPageNumbers(553, 15, 12, 'left', 'pagina {PAGENUM} van {TOTALPAGENUM}', 1);
    $pdf->ezStartPageNumbers(550, 785, 15, 'left', utf8_decode($departmentStruc[$department_id]['name']), 1);
    $pdf->ezStartPageNumbers(550, 760, 15, 'left', "<b>" . utf8_decode($tracking_category . ": " . $tracking_title) . "</b>\n", 1);
    $all = $pdf->openObject();
    $pdf->saveState();
    $pdf->setColor(0.4, 0.4, 0.4);
    $pdf->setStrokeColor(0.8, 0.8, 0.8);
    $ext = strtolower(substr($departmentStruc[$department_id]['logo'], -4));
    if ($ext == '.jpg')
    {
        $pdf->addJpegFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 40, 752, 130);
    }
    elseif ($ext == '.png')
    {
        $pdf->addPngFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 40, 752, 130);
    }
    $pdf->restoreState();
    $pdf->closeObject();
    // note that object can be told to appear on just odd or even pages by changing 'all' to 'odd'
    // or 'even'.
    $pdf->addObject($all, 'all');
    // Student Info on firstpage.....

    $override_records = array();
    $prev_title = '';
    $prev_class = '';
    campus::document2pdf_footer($pdf, 595, 1.5);
    while ($student = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        // get tracking info....
        $sql = 'SELECT `campus_student_tracking`.`id`, `tracking_category`,`tracking_title`,`date`,`teacher_code`,`grouplist`,`department_code`,`public`,`content`, `viewed`, `override_id`
					 FROM `campus_student_tracking`
		                LEFT JOIN `campus_tracking_visited`
		                   ON `campus_student_tracking`.`id` = `campus_tracking_visited`.`tracking_id` AND `teacher_id`=' . $_uid . '
					WHERE ';
        $sql .= '`student_id`=' . $student['id'];
        $sql .= ( $tracking_category == 'all') ? '' : ' AND `tracking_category`="' . $tracking_category . '"';
        $sql .= ( $tracking_title != '') ? ' AND `tracking_title`="' . $tracking_title . '"' : '';
        // allways	current year....
        $sql .= ' AND `date` >=' . mktime(0, 0, 0, 7, 1, substr($academicYear, 0, 4)) . '	AND `date` <=' . mktime(0, 0, 0, 8, 31, substr($academicYear, 5, 4));
        $sql .= ( $filter == 'newest') ? ' AND ( `teacher_id` is NULL OR  `printed`=FALSE)' : '';
        // allways	current department....
        $sql .= ' AND `department_code`="' . $departmentStruc[$department_id]['code'] . '"';
        $sql .= ' ORDER BY `date`';
        $result2 = mysql_query($sql);
        $numrows = mysql_num_rows($result2);
        if (($numrows > 0) OR ($filter != 'newest'))
        { //
            if (($prev_class != $student['code']) || ($filter == 'newpage'))
            {
                if ($prev_class != '')
                {
                    $pdf->ezNewPage();
                    campus::document2pdf_footer($pdf, 595, 1.5);
                }
                $pdf->setColor(0.3, 0.3, 0.55);
                $pdf->addText(60, 735, 15, "<b>" . utf8_decode($student['classname']) . "</b>", 0);
                $prev_class = $student['code'];
            }

            $prev_title = '';

            $title = utf8_decode($student['display_order'] . " " . $student['firstname'] . " " . $student['lastname']);
            $pdf->transaction('start');
            $pos1 = $pdf->ezPosY();
            $lus = true;
            while ($lus)
            {
                $pos1 = $pdf->ezPosY();
                $pdf->setColor(0.3, 0.3, 0.55);

                if ($title <> $prev_title)
                {
                    if (($numrows > 0) OR ($filter != 'newest'))
                    {
                        $pdf->setColor(0.96, 0.96, 0.96);
                        $pdf->filledRectangle(55, $pos1, 500, -$photo * 40 - 15);
                        $pdf->setColor(0.3, 0.3, 0.55);
                        $pdf->eZText($title, 12, array('aleft' => 57));
                        if ($photo == '1')
                        {
                            //============ foto =============
                            $pos2 = $pdf->ezPosY();
                            if (!empty($student['picture_uri']) && (strtolower(substr($student['picture_uri'], -3)) == 'jpg'))
                            {
                                $pdf->addJpegFromFile(Path :: get(SYS_USER_PATH) . $student['picture_uri'], 520, $pos2 - 40, 0, 55);
                            }
                            $pdf->setColor(0, 0, 0);
                            //======== end of foto ==========
                            $pdf->ezSetY($pos2 - 50);
                        }
                        $pdf->ezSetDy(-2);
                    }
                }
                $prev_title = $title;
                $result2 = mysql_query($sql);
                while ($rij = mysql_fetch_array($result2, MYSQL_ASSOC))
                {
                    $pos = $pdf->ezPosY();
                    if (!in_array($rij['id'], $override_records))
                    {
                        $trackingsubtitle = (($tracking_category == 'all') ? "<b>" . utf8_decode($rij['tracking_category']) . "=>" . utf8_decode($rij['tracking_title']) . "</b> " : (($tracking_title == '') ? "<b>" . utf8_decode($rij['tracking_title']) . "</b> " : "")) . " " . DatetimeUtilities::format_locale_date('%Y-%m-%d', $rij['date']);
                        if ($rij['override_id'] != 0)
                        {
                            $writer = "(" . utf8_decode($rij['teacher_code']) . "=>";
                            $sql3 = "SELECT * FROM `campus_student_tracking` WHERE `id`=" . $rij['override_id'];
                            $result3 = mysql_query($sql3);
                            $rij = mysql_fetch_array($result3, MYSQL_ASSOC);
                            $writer.=utf8_decode($rij['teacher_code']) . " <i>op " . DatetimeUtilities::format_locale_date('%Y-%m-%d', $rij['date']) . "</i>)";
                            $override_records[] = $rij['id']; // store override record in override_record list
                        }
                        else
                        {
                            $writer = "(" . utf8_decode($rij['teacher_code']) . ")";
                        }
                        if ($rij['public'] == 1)
                        { // only public records are shown
                            $pdf->ezText($trackingsubtitle, 10, array('aleft' => 75));
                            $align = 75 + $pdf->getTextWidth(10, $trackingsubtitle) + 5;
                            $pdf->ezSetY($pos - 2);
                            $pdf->ezText($writer, 8, array('aleft' => $align));
                            $align = $align + $pdf->getTextWidth(8, $writer) + 5;
                            $content = campus::remove_emptylines($rij['content']);
                            $pdf->ezText("<i>" . utf8_decode(str_replace("<br>", "\n", $content)) . "</i>\n", 10, array('aleft' => 115));
                        }
                    }
                }
                $pos2 = $pdf->ezPosY();
                if (($pos2 > $pos1))
                {
                    $pdf->transaction('rewind');
                    $pdf->ezNewPage();
                    campus::document2pdf_footer($pdf, 595, 1.5);
                    $prev_title = '';
                    //$prev_class='';
                }
                else
                {
                    $lus = false;
                }
            }
            $pdf->transaction('commit');
        }
    }
    $filename='overzicht';
    $fileoption = array('Content-Disposition' => $filename . '.pdf');
    $pdf->ezStream($fileoption);
    $pdf->ezStream();
}
?>