<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Display;
use common\libraries\PlatformSetting;
use common\libraries\Theme;
use common\libraries\Path;
use common\libraries\ResourceManager;
use common\libraries\DatetimeUtilities;

/*
  ==============================================================================
  POST & GET vars, check for default value?.
  ==============================================================================
 */
$academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);
$today = DatetimeUtilities::format_locale_date("%Y-%m-%d", time());
$submitmessage = campus::get_POST_GET("submitmessage");
$action = campus::get_POST_GET("action", "list");
$refresh = campus::get_POST_GET("refresh", "0");
$by = campus::get_SESSION("by", "type"); // store in session...
$grptab = campus::get_SESSION("grptab"); // store in session...
$yeartab = campus::get_SESSION("yeartab", $academicYear); // store in session...

$student_id = intval(campus::get_SESSION("student_id")); // store in session...
$class_id = intval(campus::get_SESSION("class_id")); // store in session...
// form data
$tracking_id = intval(campus::get_POST_GET("tracking_id"));
$tracking_category = campus::get_POST_GET("tracking_category");
$tracking_title = campus::get_POST_GET("tracking_title");
$trackingform_id = intval(campus::get_POST_GET("trackingform_id"));
$showtitle = campus::get_POST_GET("showtitle");
$date = campus::get_POST_GET("date");
$teacher_code = campus::get_POST_GET("teacher_code");
$grouplist = campus::get_POST_GET("grouplist");
$department_code = campus::get_POST_GET("department_code", $departmentStruc[$department_id]['code']);
$public = intval(campus::get_POST_GET("public"));
$content = campus::get_POST_GET("content", '', false);
$attachment = campus::get_POST_GET("attachment");
$override_id = campus::get_POST_GET("override_id");
// Get classes from student...
$classes = campus::get_classes($student_id);
$grouplist = "";
$classinfo = "";
$classcoach = false;
$classtracking = campus::get_trackingrights($_uid, $department_id);
foreach ($classes as $classid => $value)
{
    $classinfo .= $value['code'] . " (" . $value['order'] . ") ";
    $grouplist .= $value['code'] . "_";
    $classcoach = ($classtracking[$classid] == 'classTeacher') ? true : $classcoach;
    $classteacher = ($classtracking[$classid] == 'Teacher') ? true : $classteacher;
}
$grouplist = substr($grouplist, 0, - 1);
// determin rights:
// Check for individual studentcoach
$query = "SELECT * FROM `campus_coach_rel_student` WHERE `student_id`=" . $student_id . " AND `teacher_id`=" . $_uid;
$result = mysql_query($query);
$individualcoach = (mysql_num_rows($result) > 0) ? true : false;
$trackingallowed = ((isset($admin['studentTrackingLevel0']) && $admin['studentTrackingLevel0']) ||
    (isset($admin['studentTrackingLevel1']) && $admin['studentTrackingLevel1']) ||
    (isset($admin['studentTrackingLevel2']) && $admin['studentTrackingLevel2']) ||
    (isset($admin['studentTrackingLevel3']) && $admin['studentTrackingLevel3']) || $classcoach || $classteacher ||
    $individualcoach);

//check if user is allowed here...
if ((intval($_uid) == 0) || ((! $trackingallowed) && ! ($is_platformadmin)))
{ // not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{ //only teachers and platform administrator are allowed here...
    /*
      ==============================================================================
      Read, write and update database......
      ==============================================================================
     */

    if (($student_id == 0))
    { // ||($class_id==0))
        Display::error_message(get_lang("msgDataMissing"), false);
    }
    else
    {
        echo ResourceManager :: get_instance()->get_resource_html(
            Path :: get(WEB_APP_PATH) . 'campus/resources/javascript/hide_show.js'
        );
        // hidden records and all schools visible
        $nolimit = $admin['studentTrackingLevel3'] || $is_platformadmin;
        // hidden records and all schools visible
        $showhidden = $admin['studentTrackingLevel3'] || $is_platformadmin || $admin['studentTrackingShowHidden'];
        // Permission to read records, only level0 is not allowed to read other...
        $permRead =
            $admin['studentTrackingLevel3'] || $admin['studentTrackingLevel2'] || $admin['studentTrackingLevel1'] ||
            $individualcoach || $classcoach || $classteacher || $is_platformadmin;
        // Permission to write records, only level1 is not allowed to write...
        $permWrite =
            $admin['studentTrackingLevel3'] || $admin['studentTrackingLevel2'] || $admin['studentTrackingLevel0'] ||
            $individualcoach || $classcoach || $classteacher || $is_platformadmin;
        // Permission to overwrite records, only level3 and clascoach are permitted to overwrite...
        $permOverride = $admin['studentTrackingLevel3'] || $classcoach || $is_platformadmin;
        // Permission to print
        $permPrint = $admin['studentTracking2Pdf'] || $classcoach || $is_platformadmin;
        // Only Current academic year
        $currentYearOnly =
            ! ($admin['studentTrackingLevel3'] || $admin['studentTrackingLevel2'] || $individualcoach || $classcoach ||
                $classteacher || $is_platformadmin);
        //($admin['studentTrackingLevel0'] || $admin['studentTrackingLevel1']) && !$admin['studentTrackingLevel2'] && !$admin['studentTrackingLevel3'] && !$individualcoach && !$classcoach && !$classteacher && !$is_platformadmin;

        $trackingcategorys = campus::get_trackingcategorys($department_id);
        $teacher = campus::get_user_info($_uid);

        if ($tracking_id != "")
        {
            // determin tab
            $query = "SELECT `campus_student_tracking`.`tracking_category`
		       			FROM `campus_student_tracking` 
                                            INNER JOIN `campus_tracking_category` USING (`tracking_category`)
 					WHERE `campus_student_tracking`.`id`=" . $tracking_id . " AND `override_id`=0 LIMIT 1";
            $result = mysql_query($query);
            list ($grptab) = mysql_fetch_row($result);
        }
        else
        {
            if ($tracking_category != "")
            {
                $grptab = $tracking_category; // determin tab
            }
        }
        if ($submitmessage == "")
        { //
            //
            switch ($action)
            {
                case "new_next" :
                case "new" :
                {
                    if (! $refresh)
                    {
                        $tracking_id = "";
                        $tracking_title = "";
                        $content = "";
                        $attachment = "";
                        $override_id = "";
                    }
                    $teacher_code = $teacher['official_code'];
                    $department_code = $departmentStruc[$department_id]['code'];
                    $public = 1;
                    $display = "form";
                }
                    break;
                case "open":
                { // show tracking info
                    // check if record of visit exists
                    $result = mysql_query(
                        "SELECT * FROM `campus_tracking_visited` WHERE `tracking_id`=" . $tracking_id .
                        " AND `teacher_id`=" . $_uid . " LIMIT 1"
                    );
                    $numrows = mysql_num_rows($result);
                    if ($numrows > 0)
                    {
                        // update campus_tracking_visited record...
                        $result = mysql_query(
                            "UPDATE `campus_tracking_visited` SET `viewed`=1 WHERE `tracking_id`='" . $tracking_id .
                            "' AND `teacher_id`='" . $_uid . "'"
                        );
                    }
                    else
                    {
                        // insert campus_tracking_visited record...
                        $result = mysql_query(
                            "INSERT `campus_tracking_visited` SET `tracking_id`='" . $tracking_id .
                            "', `teacher_id`='" . $_uid . "', `viewed`=1, `printed`=0"
                        );
                    }
                    $display = "list";
                }
                    break;
                case "override":
                {
                    //
                }
                    break;
                case "edit" :
                { // check for special form information......
                    //$display="form";
                }
                    break;
                case "delete" :
                {
                    // delete tracking record...
                    $result = mysql_query("DELETE FROM `campus_student_tracking` WHERE `id`=" . $tracking_id . " ");
                    // delete campus_tracking_visited records...
                    $result =
                        mysql_query("DELETE FROM `campus_tracking_visited` WHERE `tracking_id`=" . $tracking_id . " ");

                    // delete all overrides pointing to this record
                    $result = mysql_query(
                        "UPDATE `campus_student_tracking` SET `override_id`=0 WHERE `override_id`=" . $tracking_id . "	"
                    );
                    $display = "list";
                }
                    break;
                case "hide" :
                {
                    $result =
                        mysql_query("UPDATE `campus_student_tracking` SET `public`=0 WHERE `id`=" . $tracking_id . " ");
                    $display = "list";
                    $action = "list";
                }
                    break;
                case "show" :
                {
                    $result = mysql_query(
                        "UPDATE `campus_student_tracking` SET `public`=1 WHERE `id`=" . $tracking_id . "	"
                    );
                    $display = "list";
                    $action = "list";
                }
                    break;
                default :
                    {
                    $display = "list";
                    }
                    break;
            }
        }
        else
        {

            switch ($action)
            {
                case "new_next" :
                case "new" :
                {
                    if ($trackingform_id > 0)
                    {
                        $trackingform_ids = campus::get_POST_GET("trackingform_ids");
                        $lines = campus::get_POST_GET("nbrlines");
                        $tracking_category = campus::get_POST_GET("tracking_category");
                        $tracking_title = campus::get_POST_GET("tracking_title");
                        $date = campus::get_POST_GET("date");
                        //campus::show_arrays($_POST);
                        foreach ($trackingform_ids as $trackingsubform_id)
                        {
                            $nbrlines = $lines[$trackingsubform_id];
                            $content = "";
                            for ($line = 1; $line <= $nbrlines; $line ++)
                            {
                                $begin = is_array(
                                    campus::get_POST_GET('F' . $trackingsubform_id . 'begin' . $line, '', false)
                                ) ? implode(
                                    ", ", campus::get_POST_GET('F' . $trackingsubform_id . 'begin' . $line, '', false)
                                ) : campus::get_POST_GET('F' . $trackingsubform_id . 'begin' . $line, '', false);
                                $mid = is_array(
                                    campus::get_POST_GET('F' . $trackingsubform_id . 'mid' . $line, '', false)
                                ) ? implode(
                                    ", ", campus::get_POST_GET('F' . $trackingsubform_id . 'mid' . $line, '', false)
                                ) : campus::get_POST_GET('F' . $trackingsubform_id . 'mid' . $line, '', false);
                                $end = is_array(
                                    campus::get_POST_GET('F' . $trackingsubform_id . 'end' . $line, '', false)
                                ) ? implode(
                                    ", ", campus::get_POST_GET('F' . $trackingsubform_id . 'end' . $line, '', false)
                                ) : campus::get_POST_GET('F' . $trackingsubform_id . 'end' . $line, '', false);
                                $content .= $begin . " " . $mid . " " . $end . "\n";
                            }
                            if ((substr($date[$trackingsubform_id], 4, 1) != '-') ||
                                (substr($date[$trackingsubform_id], 7, 1) != '-')
                            )
                            {
                                $message = get_lang("msgDateFormatError");
                                $display = "form";
                                break;
                            }
                            elseif (trim($content) != "")
                            {
                                $query = "INSERT
									`campus_student_tracking` SET
									`student_id`=" . $student_id . ",
									`tracking_category`='" . addslashes($tracking_category[$trackingsubform_id]) . "',
									`tracking_title`='" . addslashes($tracking_title[$trackingsubform_id]) . "',
									`date`=" . strtotime($date[$trackingsubform_id]) . ",
									`changed`='" . strtotime($changed) . "',
									`teacher_code`='" . $teacher_code . "',
									`grouplist`='" . $grouplist . "',
									`department_code`='" . $department_code . "',
									`public`=" . $public . ",
									`attachment`='',
									`content`='" . addslashes($content) . "'
								";
                                $result = mysql_query($query);
                                if (! $result)
                                {
                                    $message = get_lang("msgItemAddError");
                                    $display = "form";
                                }
                                else
                                {
                                    $tracking_id = mysql_insert_id();
                                    // insert campus_tracking_visited record...
                                    $query = "INSERT `campus_tracking_visited` SET
										`tracking_id`='" . $tracking_id . "',
										`teacher_id`='" . $_uid . "',
										`viewed`=1,
										`printed`=0
										";
                                    $result = mysql_query($query);
                                    $display = "list";
                                }
                            }
                            else
                            {
                                $display = "list";
                            }
                        }
                    }
                    else
                    {

                        $query = "SELECT `subject`, `campus_trackingform`.`id`, `campus_tracking_category`.`tracking_category` FROM `campus_trackingform`
										INNER JOIN `campus_tracking_title`
											ON `campus_tracking_title`.`id`=`campus_trackingform`.`title_id`		
										INNER JOIN `campus_tracking_category`
											ON `campus_tracking_category`.`id`=`campus_tracking_title`.`category_id`
						  			 WHERE `campus_tracking_title`.`tracking_title`='" . $tracking_title .
                            "' AND `tracking_category`='" . $tracking_category .
                            "' AND `campus_tracking_category`.`department_id`=" .
                            $department_id . " ORDER BY `campus_tracking_title`.`display_order`";
                        $result = mysql_query($query);
                        if (mysql_num_rows($result) > 0)
                        {
                            $rij = mysql_fetch_array($result, MYSQL_ASSOC);
                            $link = "<br><a href=\"" . $this->get_url() . "&action=new&trackingform_id=" . $rij['id'] .
                                "&refresh=1\" title='" . $rij['tracking_category'] . ">" . $rij['subject'] . "' >" .
                                $rij['subject'] . "</a>";
                            $message = get_lang("msgTitleNotAllowedUseForm") . $link;
                            $result = false;
                            $display = "form";
                        }
                        else
                        {
                            if ((substr($date, 4, 1) != '-') || (substr($date, 7, 1) != '-'))
                            {
                                $message = get_lang("msgDateFormatError");
                                $display = "form";
                                $result = false;
                            }
                            else //if (trim($content) != "")
                            {
                                $query = "INSERT
									`campus_student_tracking` SET
									`student_id`='" . $student_id . "',
									`tracking_category`='" . addslashes($tracking_category) . "',
									`tracking_title`='" . addslashes($tracking_title) . "',
									`date`=" . strtotime($date) . ",
									`changed`='" . time() . "',
									`teacher_code`='" . $teacher_code . "',
									`grouplist`='" . $grouplist . "',
									`department_code`='" . $department_code . "',
									`public`=" . $public . ",
									`attachment`='" . $attachment . "',
									`content`='" . addslashes($content) . "'
								";
                                $result = mysql_query($query);
                                if (! $result)
                                {
                                    $message = get_lang("msgItemAddError");
                                    $display = "form";
                                }
                                else
                                {
                                    $tracking_id = mysql_insert_id();
                                    // insert campus_tracking_visited record...
                                    $query = "INSERT `campus_tracking_visited` SET
										`tracking_id`='" . $tracking_id . "',
										`teacher_id`='" . $_uid . "',
										`viewed`=1,
										`printed`=0
										";
                                    $result = mysql_query($query);
                                    $display = "list";
                                }
                            }
                        }
                    }
                }
                    break;
                case "override" :
                {
                    if ($trackingform_id > 0)
                    {
                        $content = "";
                        for ($line = 1; $line <= campus::get_POST_GET("lines"); $line ++)
                        {
                            $begin =
                                is_array(campus::get_POST_GET('F' . $trackingform_id . 'begin' . $line, '', false)) ?
                                    implode(
                                        ", ", campus::get_POST_GET('F' . $trackingform_id . 'begin' . $line, '', false)
                                    ) : campus::get_POST_GET('F' . $trackingform_id . 'begin' . $line, '', false);
                            $mid = is_array(campus::get_POST_GET('F' . $trackingform_id . 'mid' . $line, '', false)) ?
                                implode(", ", campus::get_POST_GET('F' . $trackingform_id . 'mid' . $line, '', false)) :
                                campus::get_POST_GET('F' . $trackingform_id . 'mid' . $line, '', false);
                            $end = is_array(campus::get_POST_GET('F' . $trackingform_id . 'end' . $line, '', false)) ?
                                implode(", ", campus::get_POST_GET('F' . $trackingform_id . 'end' . $line, '', false)) :
                                campus::get_POST_GET('F' . $trackingform_id . 'end' . $line, '', false);
                            $content .= $begin . " " . $mid . " " . $end . "\n";
                        }
                        //$date=$date[$trackingform_id];
                        //$tracking_category=$tracking_category[$trackingform_id];
                        //$tracking_title=$tracking_title[$trackingform_id];
                    }
                    if ((substr($date, 4, 1) != '-') || (substr($date, 7, 1) != '-'))
                    {
                        $message = get_lang("msgDateFormatError");
                        $display = "list";
                    }
                    elseif (trim($content) != "")
                    {
                        $query = "INSERT
							`campus_student_tracking` SET
							`student_id`='" . $student_id . "',
							`tracking_category`='" . addslashes($tracking_category) . "',
							`tracking_title`='" . addslashes($tracking_title) . "',
							`date`=" . strtotime($date) . ",
							`changed`=" . time() . ",
							`teacher_code`='" . $teacher_code . "',
							`grouplist`='" . $grouplist . "',
							`department_code`='" . $department_code . "',
							`public`='" . $public . "',
							`attachment`='" . $attachment . "',
							`content`='" . addslashes($content) . "'
							";
                        $result = mysql_query($query) or die(mysql_error());
                        if (! $result)
                        {
                            $message = get_lang("msgItemAddError");
                            $display = "list";
                        }
                        else
                        {
                            $tracking_id = mysql_insert_id();
                            $query =
                                "UPDATE `campus_student_tracking` SET `override_id`=" . $tracking_id . " WHERE `id`=" .
                                $override_id . " ";
                            $result = mysql_query($query) or die(mysql_error());
                            // insert campus_tracking_visited record...
                            $query = "INSERT `campus_tracking_visited` SET
								`tracking_id`=" . $tracking_id . ",
								`teacher_id`=" . $_uid . ",
								`viewed`=1,
								`printed`=1
								";
                            $result = mysql_query($query);
                            $action = "list";
                            $display = "list";
                        }
                    }
                }
                    break;
                case "edit" :
                {
                    //date, teacher_code, grouplist and department have to be deleted and are only here for test purposes.

                    if ($trackingform_id > 0)
                    {
                        $content = "";
                        for ($line = 1; $line <= campus::get_POST_GET("lines"); $line ++)
                        {
                            $begin =
                                is_array(campus::get_POST_GET('F' . $trackingform_id . 'begin' . $line, '', false)) ?
                                    implode(
                                        ", ", campus::get_POST_GET('F' . $trackingform_id . 'begin' . $line, '', false)
                                    ) : campus::get_POST_GET('F' . $trackingform_id . 'begin' . $line, '', false);
                            $mid = is_array(campus::get_POST_GET('F' . $trackingform_id . 'mid' . $line, '', false)) ?
                                implode(", ", campus::get_POST_GET('F' . $trackingform_id . 'mid' . $line, '', false)) :
                                campus::get_POST_GET('F' . $trackingform_id . 'mid' . $line, '', false);
                            $end = is_array(campus::get_POST_GET('F' . $trackingform_id . 'end' . $line, '', false)) ?
                                implode(", ", campus::get_POST_GET('F' . $trackingform_id . 'end' . $line, '', false)) :
                                campus::get_POST_GET('F' . $trackingform_id . 'end' . $line, '', false);
                            $content .= $begin . " " . $mid . " " . $end . "\n";
                        }
                        //$date=$date[$trackingform_id];
                        //echo $date;
                        //$tracking_category=$tracking_category[$trackingform_id];
                        //$tracking_title=$tracking_title[$trackingform_id];
                    }
                    if ((substr($date, 4, 1) != '-') || (substr($date, 7, 1) != '-'))
                    {
                        $message = get_lang("msgDateFormatError");
                        $display = "list";
                    }
                    else
                    {
                        $query = "UPDATE
							`campus_student_tracking` SET
							`tracking_category`='" . addslashes($tracking_category) . "',
							`tracking_title`='" . addslashes($tracking_title) . "',
							`date`='" . strtotime($date) . "',
							`changed`='" . strtotime($today) . "',
							`teacher_code`='" . $teacher_code . "',
							`grouplist`='" . $grouplist . "',
							`department_code`='" . $department_code . "',
							`public`='" . $public . "',
							`attachment`='" . $attachment . "',
							`content`='" . addslashes($content) . "'
							WHERE `id`=" . $tracking_id . "
							";
                        $result = mysql_query($query) or die(mysql_error());
                        if (! $result)
                        {
                            $message = get_lang("msgItemEditError");
                            $display = "list";
                        }
                        else
                        {
                            // delete campus_tracking_visited records...
                            $result = mysql_query(
                                "DELETE FROM `campus_tracking_visited` WHERE `tracking_id`=" . $tracking_id . " "
                            );
                            // insert campus_tracking_visited record...
                            $query = "INSERT `campus_tracking_visited` SET
								`tracking_id`='" . $tracking_id . "',
								`teacher_id`='" . $_uid . "',
								`viewed`=1,
								`printed`=0
								";
                            $result = mysql_query($query);
                            $display = "list";
                        }
                        $action = "list";
                    }
                }
                    break;
                case "delete" :
                {
                    // delete tracking record...
                    $result = mysql_query("DELETE FROM `campus_student_tracking` WHERE `id`=" . $tracking_id . " ");
                    // delete campus_tracking_visited records...
                    $result =
                        mysql_query("DELETE FROM `campus_tracking_visited` WHERE `tracking_id`=" . $tracking_id . " ");

                    // delete all overrides pointing to this record
                    $result = mysql_query(
                        "UPDATE `campus_student_tracking` SET `override_id`=0 WHERE `override_id`=" . $tracking_id . "	"
                    );
                    $display = "list";
                }
                    break;
                default :
                    {
                    $display = "list";
                    }
                    break;
            }
        }
        //Make prev student and next student link AND Get user details....
        $found = false;
        $prev_student = "";
        $next_student = "";
        $filter = ($class_id > 0) ? "`group_group_rel_user`.`group_id`=" . $class_id . "" :
            "`user_user`.`id`=" . $student_id . "";
        $query = "SELECT `user_user`.`id`, `lastname`, `firstname`, `official_code`, `birth`, `address`, `phone`, `email`, `username`, `password`, `picture_uri`
				FROM `user_user`
                                    LEFT JOIN `campus_user`
                                        ON `user_user`.`id` = `campus_user`.`user_id`
                                    LEFT JOIN `group_group_rel_user`
					ON `user_user`.`id` = `group_group_rel_user`.`user_id`
					WHERE " . $filter . " ORDER BY  `display_order`,`lastname`,`firstname`";
        $result = mysql_query($query);
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            if ($rij['id'] == $student_id)
            {
                if (($action == "new_next") || ($action == "next"))
                {
                    $prev_student =
                        '<div>&nbsp;<a href="' . $this->get_url() . '&student_id=' . $rij['id'] . '" title="' .
                        $rij['firstname'] . ' ' . $rij['lastname'] . '">' . get_lang("txtPrevStudent") . '</a></div>';
                }
                else
                {
                    $student = $rij;
                }
                $found = true;
            }
            else
            {
                if ($found)
                {
                    if (($action == "new_next") || ($action == "next"))
                    {
                        $student_id = $rij['id'];
                        $_SESSION['_campus']['student_id'] = $student_id;
                        $student = $rij;
                        $display = "form";
                        $action = "new";
                    }
                    else
                    {
                        $next_student =
                            '<span style="float: right;"><a href="' . $this->get_url() . '&student_id=' . $rij['id'] .
                            '" title="' . $rij['firstname'] . ' ' . $rij['lastname'] . '">' .
                            get_lang("txtNextStudent") . '</a></span>';
                        break;
                    }
                }
                else
                {
                    $prev_student =
                        '<div>&nbsp;<a href="' . $this->get_url() . '&student_id=' . $rij['id'] . '" title="' .
                        $rij['firstname'] . ' ' . $rij['lastname'] . '">' . get_lang("txtPrevStudent") . '</a></div>';
                }
            }
        }
        // student not found in user table, fetching user detail information from archived record... reducing rights....
        if ($found == false)
        {
            $query = "SELECT * FROM `campus_student_tracking` WHERE `student_id`=" .
                $student_id . " AND `department_code`=''";
            $result = mysql_query($query);
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $values = explode(";", $rij['content']);
                $student['id'] = $student_id;
                $student['lastname'] = $values[0];
                $student['firstname'] = $values[1];
                $student['username'] = $values[2];
                $student['birth'] = $values[3];
                $student['address'] = $values[4];
                $student['phone'] = $values[5];
                $student['email'] = $values[6];
                $student['official_code'] = 'ARCHIVED';
            }
            if (! $is_platformadmin)
            {

                $showhidden = false;
                $nolimit = false;
                // Permission to read records, only level0 is not allowed to read other...
                $permRead = true;
                // Permission to write records, only level1 is not allowed to write...
                $permWrite = false;
                // Permission to overwrite records, only level3 and clascoach are permitted to overwrite...
                $permOverride = false;
                // Permission to print
                $permPrint = false;
                // Only Current academic year
                $currentYearOnly = false;
            }
        }

        /*
          ==============================================================================
          display ...
          ==============================================================================
         */
        //campus::display_departments ($departmentStruc,$department_id);
        // ************* display student information ***
        echo "<table width='100%' cellpadding=0 cellspacing=0 align='center'>";
        echo "<tr>";
        echo "<td Colspan=2>";
        if (! $individualcoach)
        {
            echo $next_student;
            echo $prev_student;
        }
        echo "</td></tr>";
        echo "<tr>";
        echo "<td valign='bottom' style='border:1px solid #999999'>";
        echo "<table width=100% cellpadding=0 cellspacing=0><tr>";
        echo "<td ><b>" . get_lang("labelFirstName") . ":</b></td>";
        echo "<td>" . $student['firstname'] . "</td>";
        echo "<td ><b>" . get_lang("labelBirth") . ":</b></td>";
        echo "<td>" . $student['birth'] . "</td>";
        echo "</tr><tr>";
        echo "<td ><b>" . get_lang("labelLastName") . ":</b></td>";
        echo "<td>" . $student['lastname'] . "</td>";
        echo "<td ><b>" . get_lang("labelAddress") . ":</b></td>";
        echo "<td>" . $student['address'] . "</td>";
        echo "</tr><tr>";
        echo "<td ><b>" . get_lang("labelStudentCode") . ":</b></td>";
        echo "<td>" . $student['official_code'] . "</td>";
        echo "<td ><b>" . get_lang("labelPhone") . ":</b></td>";
        echo "<td>" . $student['phone'] . "</td>";
        echo "</tr><tr>";
        echo "<td  valign='top'><b>" . get_lang("labelClasses") . ":</b></td>";
        echo "<td>";
        $classes = campus::get_classes($student_id);
        $formclasses = "";
        foreach ($classes as $class_id => $value)
        {
            echo '<a href="' . $this->get_studentlist_url() . '&select=' . $class_id . '" title="' .
                get_lang("tooltipShow") . ' ' . $value['name'] . '">' . $value['code'] . '</a> <b>' .
                get_lang("labelNr") . '</b> ' . $value['order'];
            echo '<br>';
            $formclasses .= '	`campus_trackingform_rel_group`.`group_id`=' . $class_id . ' OR';
        }
        echo '</td>';
        echo '<td ><b>' . get_lang("labelEmail") . ':</b></td>';
        echo '<td>' . $student['email'] . '<td>';
        echo '</tr><tr>';
        echo '<td ><b>' . get_lang("labelUsername") . ':</b></td>';
        echo '<td>' . $student['username'] . '</td>';
        echo '<td colspan=2>';
        foreach ($trackingcategorys as $key => $array)
        {
            if ($array['restricted']==2)
            {
                echo '<b>'.$array['name'].':</b>&nbsp;';

                // display student tracking tags
                $query = 'SELECT `campus_student_tracking`.`tracking_title`, `campus_student_tracking`.`id`
				    FROM `campus_student_tracking`
				        INNER JOIN `campus_tracking_title` ON `campus_student_tracking`.`tracking_title`=`campus_tracking_title`.`tracking_title`
				        INNER JOIN `campus_tracking_category` ON `campus_tracking_title`.`category_id`=`campus_tracking_category`.`id` AND `department_id`='.$department_id.' AND `campus_tracking_category`.`tracking_category`="'.$array['name'].'"
				    WHERE `campus_student_tracking`.`tracking_category`="'.$array['name'].'" AND `student_id`=' . $student['id'].' AND `department_code`="' . $department_code . '"';
                $result = mysql_query($query . ' ORDER BY `campus_tracking_title`.`display_order`') or die (mysql_error());
                if (mysql_num_rows($result) > 0)
                {
                    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                    {
                        echo '<div class="campus_label">';
                        echo (($is_platformadmin)|| ($admin['studentTrackingLevel3']))?'<a href="' . $this->get_url() . '&action=edit&tracking_id=' . $rij['id']. '" >':'';
                        echo $rij['tracking_title'];
                        echo (($is_platformadmin)|| ($admin['studentTrackingLevel3']))?'</a>':'';
                        echo '</div>&nbsp;';

                    }
                }
                echo(($is_platformadmin)|| ($admin['studentTrackingLevel3']))?'<strong style="font-size:15px"><a href="' . $this->get_url() . '&action=new&tracking_category=' . $array['name'] . '&refresh=1" >+</a></strong><br>':'<br>';


            }
        }

        echo '</td>';
        echo '</tr></table>';
        /*         * ** REPORT DISABLE *** */
        //==================== report ==================================
        echo "<table border=0 cellpadding=0 cellspacing=0 align='right' >";
        echo "<tr>";
        echo "<td style='border:1px solid #999999;background-color:#ccc;'>";
        echo '&nbsp;<a href="' . $this->get_studentreport_url() . '&student_id=' . $student['id'] . '">' .
            get_lang("txtStudentReport") . '</a>&nbsp;';
        echo '</td>';
        echo "<td style='border:1px solid #999999;'>";
        echo "&nbsp;<b>" . get_lang("txtStudentTracking") . "</b>&nbsp;";
        echo "</td></tr>";
        echo "</table>";
        // ========================================================
        /*         * ** REPORT DISABLE *** */
        echo "</td><td align='right' style='border:0px solid #999999'>";
        if (is_file(Path :: get(SYS_USER_PATH) . $student['picture_uri']))
        {
            echo '<img src="' . Path :: get(WEB_USER_PATH) . $student['picture_uri'] . '" height="100">';
        }
        else
        {
            echo '<img src="' . Theme :: get_common_image_path() . 'unknown.jpg" height="100" >';
        }
        echo "</td></tr>";
        echo "</table><br clear=\"all\">";
        // display tracking information.....
        echo "<span style=\"float:right; position: relative; left: 0px;top:0px;z-index:1000\">";
        echo "<div class='campus_pulldwnMnu' >";

        // classcoach and student adminstrator can use projection....
        echo ($permPrint) ?
            '&nbsp;<a href="' . $this->get_url() . '&page=projection&student_id=' . $student_id . '" >' .
            get_lang("txtStudentTrackingProjection") . '</a>&nbsp|' : '';
        if ($permWrite)
        {
            echo "&nbsp;<a href='#' onclick=\"javascript: toggleID('item_add');hideID('item_2pdf');\" >" .
                get_lang("txtAddTracking2Student") . "</a>";
            echo "<ul id='item_add' style='left: auto;right:60px;top:15px;display:none; Z-index:1100;'>";
            echo "<li id='campus_pulldwnMnu_title' >";
            echo "<a href='#' onclick=\"javascript: hideID('item_add');\" style='float:right; border: 1px solid #FFFFFF;font-size: 10px;color: #FFFFFF'>X</a>";
            echo "&nbsp;&nbsp;<b >" . get_lang("txtAddStudentTracking") . "</b>";
            echo "</li>";
            // ad new item in a particular category
            foreach ($trackingcategorys as $key => $value)
            {
                $i ++;
                echo '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_url() .
                    '&action=new&tracking_category=' . $value['name'] . '&refresh=1" >' . $value['name'] . '</a></li>';
            }
            // display link to special form....
            $query = "SELECT DISTINCT `subject`, `campus_trackingform`.`id`, `campus_tracking_category`.`tracking_category`,`title_id`
                                        FROM `campus_trackingform`
                                            INNER JOIN `campus_trackingform_rel_group` ON `campus_trackingform_rel_group`.`trackingform_id`=`campus_trackingform`.`id`
                                            LEFT JOIN `campus_tracking_title` ON `campus_tracking_title`.`id`=`campus_trackingform`.`title_id`
                                            LEFT JOIN `campus_tracking_category` ON `campus_tracking_category`.`id`=`campus_tracking_title`.`category_id`
					WHERE `campus_trackingform`.`department_id`=" . $department_id . "
							AND (`form_type` = 0 OR `form_type` = 3) ";
            $query .= ($formclasses == '') ? "" : "AND (" . substr($formclasses, 0, - 3) . ") ";
            $query .= "AND (`formstart`<= " . time() . " OR `formstart` = 0)
 							AND (`formend` >= " . time() . " OR `formend` = 0)";
            $result = mysql_query($query . ' ORDER BY `campus_trackingform`.`display_order`, `subject`');
            if (mysql_num_rows($result) > 0)
            {
                echo "<li><hr></li>";
                while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    $tooltip = ($rij['title_id'] == 0) ? get_lang("tooltipCombinedForm") :
                        $rij['tracking_category'] . ">" . $rij['subject'];
                    echo '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_url() .
                        '&action=new&trackingform_id=' . $rij['id'] . '&refresh=1" title="' . $tooltip . '" >' .
                        $rij['subject'] . '</a></li>';
                }
            }
            echo '</ul>';
        }
        echo "|&nbsp;<a href='#' onclick=\"javascript: toggleID('item_2pdf');hideID('item_add');\" title=''>" .
            get_lang("txtStudentTracking2Pdf") . "</a>&nbsp;";
        //echo "&nbsp;<a href='#' onclick=\"javascript: toggleID('help');\" title='".get_lang("tooltipAddStudentTracking")."'>".get_lang("txtAddTracking2Student")."</a>";
        echo "<ul id='item_2pdf' style='left: auto;right:0px;top:15px;display:none; Z-index:1100;'>";
        echo "<li  id='campus_pulldwnMnu_title' >";
        echo "<a href='#' onclick=\"javascript: hideID('item_2pdf');\" style='float:right; border: 1px solid #FFFFFF;font-size: 10px;color: #FFFFFF'>X</a>";
        echo "<b >" . get_lang("txtStudentTracking2Pdf") . "</b>";
        echo "</li>";
        echo '<li>&nbsp;&nbsp;<a href="' . $this->get_url() . '&page=studentfiche2pdf&teacher_code=' .
            $teacher['official_code'] . '" target="_blank">' . get_lang("txtStudentTrackingFile") . ': ' .
            get_lang("txtOwnRecords") . '</a></li>';
        if ($permPrint)
        {
            echo '<li>&nbsp;&nbsp;<a href="' . $this->get_url() . '&page=studentfiche2pdf&by=' . $by .
                '" target="_blank">' . get_lang("txtStudentTrackingFile") . ': ' . get_lang("txtCurrentAcYear") .
                '</a></li>';
            if ($nolimit)
            {
                echo '<li>&nbsp;&nbsp;<a href="' . $this->get_url() . '&page=studentfiche2pdf&by=' . $by .
                    '&filter=Complete" target="_blank">' . get_lang("txtStudentTrackingFile") . ': ' .
                    get_lang("txtComplete") . '</a></li>';
            }
            echo '<li><hr></li>';
            foreach ($trackingcategorys as $key => $value)
            {
                echo '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_url() .
                    '&page=studentfiche2pdf&tracking_category=' . $value['name'] . '" target="_blank">' .
                    $value['name'] . ' ' . get_lang("txtPdf") . '</a></li>';
            }
            echo
                "<li onmouseover=\"javascript: showID('titles');\" onmouseout=\"javascript: hideID('titles');\" style='Z-index:" .
                (100) . ";'>";
            echo "&nbsp;&nbsp;<b>" . get_lang("txtTrackingTitles") . "</b>";
            echo "<ul id='titles' style='display:none; '>";
            $sql = "SELECT DISTINCT `tracking_title` FROM `campus_tracking_title`
						INNER JOIN `campus_tracking_category`
                                                    ON `campus_tracking_title`.`category_id`=`campus_tracking_category`.`id`
					 	WHERE `department_id`=" . $department_id . " ORDER BY `tracking_title`";
            $result = mysql_query($sql);
            while ($rijform = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                echo '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_url() .
                    '&page=studentfiche2pdf&tracking_category=all&tracking_title=' .
                    urlencode($rijform['tracking_title']) . '" target="_blank">' . $rijform['tracking_title'] . ' ' .
                    get_lang("txtPdf") . '</a></li>';
            }
            echo "</ul>";
        }
        echo "</ul>";
        echo "</div>";
        echo "</span>";
        //  select academic year...
        if ((! $currentYearOnly) && ($display != 'form'))
        {
            $currentYear = $academicYear;
            $query2 = "SELECT DISTINCT IF(MONTH(FROM_UNIXTIME(`date`))<9,CONCAT_WS('-',YEAR(FROM_UNIXTIME(`date`))-1,YEAR(FROM_UNIXTIME(`date`))),CONCAT_WS('-',YEAR(FROM_UNIXTIME(`date`)),YEAR(FROM_UNIXTIME(`date`))+1)) as ac_year
                                        FROM `campus_student_tracking`
					WHERE `student_id`=" . $student['id'] . " ORDER BY `date`";
            $result2 = mysql_query($query2);
            while (list ($ac_year) = mysql_fetch_row($result2))
            {
                if ($yeartab != $ac_year)
                {
                    echo "&nbsp;<a href='" . $this->get_url() . "&yeartab=" . $ac_year . "' title='" .
                        get_lang("tooltipShow") . "  " . $ac_year . "'>" . $ac_year . "</a>&nbsp;|";
                }
                else
                {
                    $currentYear = $ac_year;
                    echo "&nbsp;<b id='current'>" . $ac_year . "</b>&nbsp;|";
                }
                $lastYear = $ac_year;
            }

            // wenn a new academic year is startet, no entrance is written to the database, it is necessary to force the year selection.
            if ($academicYear <> $lastYear)
            { // The active academic year is not found in database...
                if ($academicYear != $currentYear)
                { //
                    echo "&nbsp;<a href='" . $this->get_url() . "&yeartab=" . $academicYear . "' title='" .
                        get_lang("tooltipShow") . " " . $academicYear . "'>" . $academicYear . "</a>&nbsp;|";
                }
                else
                {
                    echo "&nbsp;<b id='current'>" . $academicYear . "</b>&nbsp;|";
                }
            }
        }
        else
        { // set current year to the active academic year...
            $currentYear = $academicYear;
            $_SESSION['_campus']['yeartab'] = $academicYear;
        }
        // if other year then current academic year is selected deny permission to write....
        $permWrite = ($currentYear == $academicYear) ? $permWrite : false;
        $permOverride = ($currentYear == $academicYear) ? $permOverride : false;
        //echo "<table width='100%' border='1'  cellspacing='0' style='border-right:4px #333333 solid;border-bottom:4px #333333 solid;'>";
        $sql = "SELECT t1.`id`, t1.`override_id`, t1.`student_id`, t1.`tracking_category`, t1.`tracking_title`, t1.`date`, t1.`teacher_code`, t1.`grouplist`, t1.`department_code`, t1.`public`, t1.`content`, `viewed`, `campus_tracking_category`.`id` as category_id, t1.`changed`, `campus_tracking_category`.`restricted`
				FROM `campus_student_tracking` as t1
                                    LEFT JOIN `campus_tracking_category`
					ON t1.`tracking_category`=`campus_tracking_category`.`tracking_category` AND `campus_tracking_category`.`department_id`=" .
            $department_id . "
		                LEFT JOIN `campus_tracking_visited`
		               		ON t1.`id` = `campus_tracking_visited`.`tracking_id` AND `teacher_id`=" . $_uid . "                                           
                                LEFT JOIN `campus_student_tracking` as t2
                                        ON t1.`id`=t2.`override_id`


				WHERE t2.`id` is null and t1.`student_id`=" . $student['id'];
        // Hide student info record..... only platform admin should see this....
        $sql .= ($is_platformadmin) ? "" : " AND t1.`department_code`<>''";
        // wenn neccesary limit to current year
        $sql .= ($currentYearOnly) ?
            " AND t1.`date` >=" . mktime(0, 0, 0, 7, 1, substr($academicYear, 0, 4)) . "	AND t1.`date` <=" .
            mktime(23, 59, 59, 8, 31, substr($academicYear, 5, 4)) . " " :
            " AND t1.`date` >=" . mktime(0, 0, 0, 7, 1, substr($currentYear, 0, 4)) . " AND t1.`date` <=" .
            mktime(23, 59, 59, 8, 31, substr($currentYear, 5, 4)) . " ";
        // wenn neccesary limit to current department
        $sql .= ($nolimit) ? "" : " AND t1.`department_code`='" . $department_code . "'";
        $sql .= ($showhidden || $nolimit) ? "" : " AND t1.`public`=1";
        // wenn ne permission to read limit read permission to own records...
        $sql .= (! $permRead && $permWrite) ? " AND t1.`teacher_code`='" . $teacher['official_code'] . "' " : "";
        echo "<br clear=\"all\"><div id='lvs_tabs'><ul>";
        if ($grptab != 'all')
        {
            echo "<li ><a href='" . $this->get_url() . "&grptab=all' style='width:30px;' title='" .
                get_lang("tooltipShowAllCategorys") . "'>" . get_lang("txtAll") . "</a></li>";
        }
        else
        {
            echo "<li id='current'><a href='#' style='width: 30px;' title='" . get_lang("tooltipShowAllCategorys") .
                "'>" . get_lang("txtAll") . "</a></li>";
        }
        $categorytabs = $trackingcategorys;
        $resulttab = mysql_query(
            "SELECT DISTINCT `tracking_category` FROM `campus_student_tracking` WHERE `student_id`=" . $student['id'] .
            " AND `date` >=" . mktime(0, 0, 0, 7, 1, substr($currentYear, 0, 4)) . "	AND `date` <=" .
            mktime(23, 59, 59, 8, 31, substr($currentYear, 5, 4)) . " "
        ) or die (mysql_error());

        while ($rij = mysql_fetch_array($resulttab, MYSQL_ASSOC))
        {
            $found = 0;
            foreach ($categorytabs as $key => $array)
            {
                if ($rij['tracking_category'] == $array['name'])
                {
                    $found = 1;
                }
            }
            if ((! $found) && ($rij['tracking_category'] != ''))
            {
                $categorytabs[]['name'] = $rij['tracking_category'];
            }
        }
        foreach ($categorytabs as $key => $array)
        {
            if ($array['restricted'] < 2)
            {

                if ($grptab != $array['name'])
                {
                    echo "<li ><a href='" . $this->get_url() . "&grptab=" . $array['name'] . "' title='" .
                        get_lang("tooltipShow") . " " . $array['name'] . "'>" . $array['name'] . "</a></li>";
                }
                else
                {
                    $sql .= " AND t1.`tracking_category`='" . $array['name'] . "'";
                    echo
                        "<li id='current'><a href='#' title='" . get_lang("tooltipShow") . " " . $array['name'] . "'>" .
                        $array['name'] . "</a></li>";
                }
            }

        }
        echo "</ul></div><br clear=\"all\">";
        $sql .= " ORDER BY t1.`date`,t1.`changed`";

        if (! empty($message))
        {
            Display::error_message($message, false);
        }

        if ($display == 'form')
        {
            if ($trackingform_id == 0)
            {
                include("tracking_form.php");
            }
            else
            {
                include("tracking_specialform.php");
            }
        }
        else
        {
            $result = mysql_query($sql) or die (mysql_error());
            $t = 0;
            $i = 0;
            $override_records = array();
            $prevtitle = "";
            echo "<ul>";
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                if (! in_array($rij['id'], $override_records))
                {
                    $date = DatetimeUtilities::format_locale_date('%Y-%m-%d', $rij['date']);
                    $subtitle = "<i style='color:#666666'>(" . $rij['teacher_code'];
                    if ($rij['override_id'] != 0)
                    {
                        $sql2 = "SELECT  `campus_student_tracking`.`id`,`override_id`, `student_id`,`tracking_category`,`tracking_title`,`date`,`teacher_code`,`grouplist`,`department_code`,`public`,`content`, `viewed`, `changed`
                                                                    FROM `campus_student_tracking`
                                                                        LEFT JOIN `campus_tracking_visited`
                                                                            ON `campus_student_tracking`.`id` = `campus_tracking_visited`.`tracking_id` AND `teacher_id`=" .
                            $_uid . "
                                                                    WHERE `campus_student_tracking`.`id`=" .
                            $rij['override_id'] . " ORDER BY `date`";
                        $result2 = mysql_query($sql2) or die (mysql_error());
                        $rij = mysql_fetch_array($result2, MYSQL_ASSOC);
                        $subtitle .=
                            "=>" . $rij['teacher_code'] . " <i style='font-size:10px;'>" . get_lang("txtOn") . " " .
                            DatetimeUtilities::format_locale_date(
                                '%Y-%m-%d', $rij['changed']
                            ) . "</i>)</i>"; //overwrite values... with those from override record...
                        $date = DatetimeUtilities::format_locale_date('%Y-%m-%d', $rij['date']);
                        $override_active = true; // override already active no override allowed.
                        $override_records[] = $rij['id']; // store override record in override_record list
                    }
                    else
                    {
                        $subtitle .= ")</i>";
                        $override_active = false; // no override active, so override is allowed
                    }
                    $subtitle = (($grptab == 'all') ? "<b>" . $rij['tracking_category'] . ":</b> " : "") .
                        $rij['tracking_title'] . $subtitle;

                    if (($rij['public'] == 1) ||
                        (($rij['department_code'] == $department_code) && ($nolimit || $showhidden)) ||
                        $is_platformadmin
                    ) // always show public records, when allowed show hidden records...
                    {
                        // restricted records are only shown within the department for the level3 administrator...
                        if (($rij['date'] > mktime(0, 0, 0, 9, 1, substr($academicYear, 0, 4))) ||
                            ($trackingcategorys[$rij['category_id']]['restricted'] != 1) ||
                            (($rij['department_code'] == $department_code) && ($nolimit))
                        )
                        {
                            $t ++;
                            echo "<div style='border: 1px solid #777777'>";
                            if (($tracking_id == $rij['id']) && (($action == 'edit') || ($action == 'override')))
                            {
                                // show form...
                                if (! $refresh)
                                {
                                    $student_id = $rij['student_id'];
                                    $tracking_category = $rij['tracking_category'];
                                    $tracking_title = $rij['tracking_title'];
                                    $date = DatetimeUtilities::format_locale_date('%Y-%m-%d', $rij['date']);
                                    $grouplist = $rij['grouplist'];
                                    $teacher_code = $rij['teacher_code'];
                                    $department_code = $rij['department_code'];
                                    $public = $rij['public'];
                                    $content = $rij['content'];
                                    $attachment = $rij['attachment'];
                                }
                                if ($action == 'override')
                                {
                                    $override_id = $tracking_id;
                                    $tracking_id = "";
                                    //$date=$today;
                                    $teacher_code = $teacher['official_code'];
                                }
                                // check if specialform exists....
                                $query3 = "SELECT `campus_trackingform`.`id` FROM `campus_trackingform`
										INNER JOIN `campus_trackingform_rel_group` ON `campus_trackingform_rel_group`.`trackingform_id`=`campus_trackingform`.`id`
 			 							INNER JOIN `campus_tracking_title` ON `campus_tracking_title`.`id`=`campus_trackingform`.`title_id`
										INNER JOIN `campus_tracking_category` ON `campus_tracking_category`.`id`=`campus_tracking_title`.`category_id`
										WHERE `campus_trackingform`.`department_id`=" . $department_id . "
											AND `tracking_title` = '" . $rij['tracking_title'] .
                                    "'  and `tracking_category`='" . $rij['tracking_category'] . "'";
                                $query3 .= ($formclasses == '') ? "" : " AND (" . substr($formclasses, 0, - 3) . ") ";
                                $result3 = mysql_query($query3 . " ORDER BY `campus_trackingform`.`display_order`");
                                if ((mysql_num_rows($result3) > 0) && ($trackingform_id != - 1))
                                {
                                    list($trackingform_id) = mysql_fetch_row($result3);
                                    include("tracking_editspecialform.php");
                                }
                                else
                                {
                                    include("tracking_form.php");
                                }
                            }
                            else
                            {

                                $displaymode = ($tracking_id == $rij['id']) ? false : true;
                                echo "<a name='t_" . $t . "'></a>";
                                // show title
                                $icon = ($rij['public'] == 1) ? "visible" : "invisible";
                                $visibilityicon = '<img src="' . Theme::get_image_path('application\campus') .
                                    $icon . '.gif" border=0 align="absmiddle" />';
                                if ($displaymode)
                                {
                                    echo "<a href='" . $this->get_url() . "&action=open&tracking_id=" . $rij['id'] .
                                        "#t_" . $t . "' style='font-weight: normal;'  title='" .
                                        get_lang("txtLastChange") . " " . $rij['changed'] . "'>" . $date . " " .
                                        $subtitle . "</i>" . $visibilityicon . ((! $rij['viewed'] &&
                                            ($rij['date'] >= mktime(0, 0, 0, 7, 1, substr($academicYear, 0, 4))) &&
                                            ($rij['date'] <= mktime(0, 0, 0, 8, 31, substr($academicYear, 5, 4)))) ?
                                            "<b style='font-size:18px;color:red'>*</b>" : "") . "</a>";
                                }
                                else
                                {
                                    echo "<a href='" . $this->get_url() . "&action=open&tracking_id=" . $rij['id'] .
                                        "#t_" . $t . "' style='font-weight: normal;'  title='" .
                                        get_lang("txtLastChange") . " " . $rij['changed'] . "'>" . $date . " " .
                                        $subtitle . "</i>" . $visibilityicon . "</a>";
                                    echo "<div ID='item" . $t . "'>";
                                    echo "<div style='float:right'>";
                                    if (($permWrite && ($rij['teacher_code'] == $teacher['official_code'])) ||
                                        ($is_platformadmin)|| (($rij['restricted'] == 2) && ($admin['studentTrackingLevel3']))
                                    )
                                    { // check if user is allowed to edit own records...
                                        // is alowed to edit this record...
                                        echo "<a href=\"" . $this->get_url() . "&tracking_id=" . $rij['id'] .
                                            "&action=edit\" title=\"" . get_lang("tooltipEditComment") .
                                            "\"><img src=\"" . Theme::get_image_path('application\campus') .
                                            "edit.gif\" border=0 align=\"absmiddle\" ></a>";
                                    }
                                    elseif ((($permOverride) && (! $override_active)) ||
                                        (($rij['teacher_code'] == '') &&
                                            ($admin['studentTrackingLevel3'] || $admin['studentTrackingLevel2'])) ||
                                        ($is_platformadmin)
                                    )
                                    { // only tracking level 3 and the class
                                        echo "<a href=\"" . $this->get_url() . "&tracking_id=" . $rij['id'] .
                                            "&action=override\" title=\"" . get_lang("tooltipOverrideComment") .
                                            "\"><img src=\"" . Theme::get_image_path('application\campus') .
                                            "edit.gif\" border=0 align=\"absmiddle\" ></a>";
                                    }
                                    if (($rij['teacher_code'] == $teacher['official_code']) ||
                                        (($rij['teacher_code'] == '') && ($admin['studentTrackingLevel3'])) ||
                                        ($is_platformadmin)|| (($rij['restricted'] == 2) && ($admin['studentTrackingLevel3']))
                                    )
                                    { // check if user is allowed to edit own records...
                                        echo '&nbsp;<a href="' . $this->get_url() . '&tracking_id=' . $rij['id'] .
                                            '&action=delete" onclick="javascript:if(!confirm(\'' .
                                            get_lang("msgboxConfirmDeleteComment") . '\')) return false;" title="' .
                                            get_lang("tooltipDeleteComment") . '"><img src="' .
                                            Theme::get_image_path('application\campus') .
                                            'delete.gif" border=0 align="absmiddle" /></a>';
                                        echo(($nolimit) ?
                                            '&nbsp;<a href="' . $this->get_url() . '&tracking_id=' . $rij['id'] .
                                            '&action=' . (($icon == 'visible') ? 'hide' : 'show') . '">' .
                                            $visibilityicon . '</a>' : $visibilityicon);
                                        echo '&nbsp;<a href="' . $this->get_url() .
                                            '&page=studentfiche2pdf&tracking_id=' . $rij['id'] .
                                            '" target="_blank" title="' . get_lang("tooltip2Pdf") . '"><img src="' .
                                            Theme::get_image_path('application\campus') .
                                            'file_pdf.gif" border=0 align="absmiddle" /></a>';
                                    }
                                    echo "</div>";
                                    echo "<div style='padding-bottom: 0px;'>" . get_lang("labelStatus") . ": " .
                                        get_lang('labelDepartment') . "=" . $rij['department_code'] . ",  " .
                                        get_lang('labelClass') . "=" . $rij['grouplist'] . "</div>";
                                    echo
                                        "<span style='position: relative; top: 12px; left: 15px; background-color: #FFFFFF;'>" .
                                        get_lang("labelTrackingInfo") . "</span>";
                                    echo "<hr width='98%' Align='center' size='1' NOSHADE>";
                                    //echo "<pre COLS=60 style='width:600px'>".$rij['content']."</pre>";
                                    $content = campus::remove_emptylines($rij['content']);
                                    echo "<pre>" . wordwrap($content, 90) . "</pre>";
                                    echo "</div>";
                                }
                            }
                            echo "</div>";
                        }
                    }
                }
            }
            echo "</ul>";
            if ($subtitle == "")
            {
                Display::normal_message(get_lang("msgStudentTrackingHint"), false);
            }
        }
    }
}
?>