<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Theme;
use common\libraries\PlatformSetting;
use common\libraries\Path;
use common\libraries\Display;
use common\libraries\DatetimeUtilities;
use common\libraries\ResourceManager;

//	$charset = 'ISO-8859-1';
//	include_once('../../../main/inc/reduced_header.inc.php');
/*
  ==============================================================================
  POST & GET vars, check for default value?.
  ==============================================================================
 */
$academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);
$department_id = intval(campus::get_SESSION("department_id", key($departmentStruc)));
// get rights of user in campus plugin .....
$admin = campus::get_rights($_uid, $department_id);
$tracking_category = campus::get_SESSION("tracking_category", 'all'); // store in session...
$action = campus::get_POST_GET("action", "list");
$tracking_title = campus::get_SESSION("tracking_title");
$teacher_code = trim(campus::get_SESSION("teacher_code"));
$department_code = $departmentStruc[$department_id]['code'];

$student_id = intval(campus::get_POST_GET("student_id")); // store in session...
$classtracking = campus::get_trackingrights($_uid, $department_id);
$class_id = intval(campus::get_SESSION("class_id")); // store in session...
$classcoach = ($classtracking[$class_id] == 'classTeacher') ? TRUE : FALSE;

// determin rights:
// Check for individual studentcoach
$trackingallowed = ((isset($admin['studentTracking2Pdf']) && $admin['studentTracking2Pdf']) || $classcoach);

//check if user is allowed here...
if ((intval($_uid) == 0) || ((!$trackingallowed) && !($is_platformadmin)))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only teachers and platform administrator are allowed here...
    Display::small_header();
    echo ResourceManager :: get_instance()->get_resource_html(Path :: get(WEB_APP_PATH) . 'campus/resources/javascript/hide_show.js');
     /*
      ==============================================================================
      Read, write and update database......
      ==============================================================================
     */

    $trackingcategorys = campus::get_trackingcategorys($department_id);
    $teacher = campus::get_user_info($_uid);

    //Make prev student and next student link AND Get user details....
    $found = FALSE;
    $prev_student = "";
    $next_student = "";
    $filter = "`group_group_rel_user`.`group_id`=" . $class_id . "";
    $query = "SELECT `user_user`.`id`, `lastname`, `firstname`, `official_code`, `birth`, `address`, `phone`, `email`, `username`, `password`, `picture_uri`
			FROM `user_user`
                            LEFT JOIN `campus_user`
                                ON `user_user`.`id` = `campus_user`.`user_id`
                            LEFT JOIN `group_group_rel_user`
                        	ON `user_user`.`id` = `group_group_rel_user`.`user_id`
                            WHERE " . $filter . " ORDER BY  `display_order`,`lastname`,`firstname`";
    $result = mysql_query($query);
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        if (($rij['id'] == $student_id) || ($student_id == 0))
        {
            if ($action == "next")
            {
                $prev_student = '<div>&nbsp;<a href="' . $this->get_url() . '&page=projection&student_id=' . $rij['id'] . '" title="' . $rij['firstname'] . ' ' . $rij['lastname'] . '">' . get_lang("txtPrevStudent") . '</a></div>';
            }
            else
            {
                $student = $rij;
                $student_id = $rij['id'];
            }
            $found = TRUE;
        }
        else
        {
            if ($found)
            {
                if ($action == "next")
                {
                    $student_id = $rij['id'];
                    $_SESSION['_campus']['student_id'] = $student_id;
                    $student = $rij;
                    $display = "form";
                    $action = "new";
                }
                else
                {
                    $next_student = '<span style="float: right;"><a href="' . $this->get_url() . '&page=projection&student_id=' . $rij['id'] . '" title="' . $rij['firstname'] . ' ' . $rij['lastname'] . '">' . get_lang("txtNextStudent") . '</a></span>';
                    break;
                }
            }
            else
            {
                $prev_student = '<div>&nbsp;<a href="' . $this->get_url() . '&page=projection&student_id=' . $rij['id'] . '" title="' . $rij['firstname'] . ' ' . $rij['lastname'] . '">' . get_lang("txtPrevStudent") . '</a></div>';
            }
        }
    }
    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    //campus::display_departments ($departmentStruc,$department_id);
    if (!empty($message))
    {
        Display::error_message($message, false);
    }

    // ************* display student information ***
    echo "<table width='100%' cellpadding=0 cellspacing=0 align='center'>";
    echo "<tr>";
    echo "<td Colspan=2>";
    if (!$individualcoach)
    {
        echo $next_student;
        echo $prev_student;
    }
    echo '</td></tr>';
    echo '<tr>';
    echo '<td valign="bottom" style="border:1px solid #999999">';
    echo '<table width=100% cellpadding=0 cellspacing=0><tr>';
    echo '<td align="right"><b>' . get_lang('labelFirstName') . ':</b></td>';
    echo '<td>' . $student['firstname'] . '</td>';
    echo '<td align="right"><b>' . get_lang('labelBirth') . ':</b></td>';
    echo '<td>' . $student['birth'] . '</td>';
    echo '</tr><tr>';
    echo '<td align="right"><b>' . get_lang('labelLastName') . ':</b></td>';
    echo '<td>' . $student['lastname'] . '</td>';
    echo '<td align="right"><b>' . get_lang('labelAddress') . ':</b></td>';
    echo '<td>' . $student['address'] . '</td>';
    echo '</tr><tr>';
    echo '<td align="right"><b>' . get_lang('labelStudentCode') . ':</b></td>';
    echo '<td>' . $student['official_code'] . '</td>';
    echo '<td align="right"><b>' . get_lang('labelPhone') . ':</b></td>';
    echo '<td>' . $student['phone'] . '</td>';
    echo '</tr><tr>';
    echo '<td align="right" valign="top"><b>' . get_lang('labelClasses') . ':</b></td>';
    echo '<td>';
    $classes = campus::get_classes($student_id);
    $formclasses = "";
    foreach ($classes as $class_id => $value)
    {
        echo '<a href="' . $this->get_studentlist_url() . '&select=' . $class_id . '" title="' . get_lang("tooltipShow") . ' ' . $value['name'] . '">' . $value['code'] . '</a> <b>' . get_lang("labelNr") . '</b> ' . $value['order'];
        echo '<br>';
        $formclasses.='	`campus_trackingform_rel_group`.`group_id`=' . $class_id . ' OR';
    }
    echo '</td>';
    echo '<td align="right"><b>' . get_lang("labelEmail") . ':</b></td>';
    echo '<td>' . $student['email'] . '<td>';
    echo '</tr><tr>';
    echo '<td align="right"><b>' . get_lang("labelUsername") . ':</b></td>';
    echo '<td>' . $student['username'] . '</td>';
    echo '<td colspan=2 valign="bottom" align="right"></td>';
    echo '</tr></table>';
    echo '<table border=0 cellpadding=0 cellspacing=0 align="right" >';
    echo '<tr>';
    echo '<td style="border:1px solid #999999;background-color:#ccc;">';
    echo '&nbsp;<a href="' . $this->get_studentreport_url() . '&page=projection&student_id=' . $student['id'] . '">' . get_lang("txtStudentReport") . '</a>&nbsp;';
    echo '</td>';
    echo '<td style="border:1px solid #999999;">';
    echo '&nbsp;<b>' . get_lang("txtStudentTracking") . '</b>&nbsp;';
    echo '</td></tr>';
    echo '</table>';
    echo '</td><td align="right" style="border:0px solid #999999">';
    if (is_file(Path :: get(SYS_USER_PATH) . $student['picture_uri']))
    {
        echo '<img src="' . Path :: get(WEB_USER_PATH) . $student['picture_uri'] . '" height="100">';
    }
    else
    {
        echo '<img src="' . Theme :: get_common_image_path() . 'unknown.jpg" height="100" >';
    }
    echo "</td></tr>";
    echo "</table><br clear=\"all\">";


// display tracking information.....
    $sql = 'SELECT DISTINCT `teacher_code` FROM `campus_student_tracking` WHERE `student_id`=' . $student['id'];
    $sql .= ' AND `date` >=' . mktime(0, 0, 0, 7, 1, substr($academicYear, 0, 4)) . '	AND `date` <=' . mktime(0, 0, 0, 31, 8, substr($academicYear, 5, 4));
    $sql .= ' AND `department_code`="' . $department_code . '" AND `public`=1';
    $result = mysql_query($sql);
    echo '<form ACTION="' . $this->get_url() . '" METHOD="POST" NAME="myform" STYLE="display: inline;float: right;">';
    echo '<input type="hidden" name="student_id" value="' . $student_id . '">';
    echo '<input type="hidden" name="page" value="projection">';
    echo get_lang("txtFilter") . '&nbsp;';
    $sqlform = 'SELECT `tracking_title` FROM `campus_tracking_title`
			INNER JOIN `campus_tracking_category`
                            ON `campus_tracking_title`.`category_id`=`campus_tracking_category`.`id`
	  		WHERE ' . (($tracking_category == 'all') ? '' : '`tracking_category`="' . $tracking_category . '" AND') . ' `department_id`=' . $department_id . ' ORDER BY `campus_tracking_title`.`display_order`';
    $resultform = mysql_query($sqlform) or die (mysql_error());
    if (mysql_num_rows($resultform) > 0)
    {
        echo '<select name="tracking_title" STYLE="width:250px;" OnChange="javascript:myform.submit();">';
        echo '<option value=" " ' . (($tracking_title == "") ? 'SELECTED' : '') . '>' . get_lang("txtComplete") . '</option>';
        while ($rijform = mysql_fetch_array($resultform, MYSQL_ASSOC))
        {
            echo '<option value="' . $rijform['tracking_title'] . '" ' . (($rijform['tracking_title'] == $tracking_title) ? 'SELECTED' : '') . '>' . $rijform['tracking_title'] . '</option>';
        }
        echo '</select>';
    }
    echo '<select name="teacher_code" STYLE="width:250px;" OnChange="javascript:myform.submit();">';
    echo '<option value=" " ' . (($teacher_code == "") ? 'SELECTED' : '') . '>' . get_lang("txtAllContributors") . '</option>';
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        echo '<option value="' . $rij['teacher_code'] . '" ' . (($rij['teacher_code'] == $teacher_code) ? 'SELECTED' : '') . '>' . $rij['teacher_code'] . '</option>';
    }
    echo '</select>';

    echo '</form>';
    echo '<span style="float:left; position: relative; right: 0px;top:0px;z-index:1000">';
    echo '<a style="white-space: nowrap;" href="' . $this->get_url() . '&student_id=' . $student_id . '" >' . get_lang("txtBack2StudentTracking") . '</a>';
    echo '&nbsp|&nbsp;<a href="#" onclick="javascript: toggleID(\'item_add\');" >' . get_lang("txtAddTracking2Student") . '</a>';
    echo '<ul id="item_add" style="position:absolute; left: 0px;top:15px;border: solid 1px #2a2a7b; background-color: #b3b3eb;	list-style-type: none; margin:0px; padding: 0px; width: 225px;display:none; Z-index:1100;">';

    echo '<li id="campus_pulldwnMnu_title" >';
    echo '<a href="#" onclick="javascript: hideID(\'item_add\');" style="float:right; border: 1px solid #FFFFFF;font-size: 10px;color: #FFFFFF">X</a>';
    echo '&nbsp;&nbsp;<b >' . get_lang("txtAddStudentTracking") . '</b>';
    echo '</li>';
    // ad new item in a particular category
    foreach ($trackingcategorys as $key => $value)
    {
        $i++;
        echo '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_url() . '&action=new&tracking_category=' . $value['name'] . '&refresh=1" >' . $value['name'] . '</a></li>';
    }
    // display link to special form....

    $query = 'SELECT DISTINCT `subject`, `campus_trackingform`.`id`, `campus_tracking_category`.`tracking_category`,`title_id` FROM `campus_trackingform`
							INNER JOIN `campus_trackingform_rel_group` ON `campus_trackingform`.`id`=`campus_trackingform_rel_group`.`trackingform_id`
                                                        LEFT JOIN `campus_tracking_title` ON `campus_tracking_title`.`id`= `campus_trackingform`.`title_id`
                                                	LEFT JOIN `campus_tracking_category` ON `campus_tracking_category`.`id`=`campus_tracking_title`.`category_id`
 						WHERE `campus_trackingform`.`department_id`=' . $department_id . '
							AND (`form_type` = 0 OR `form_type` = 3) ';
    $query .= ( $formclasses == '') ? '' : 'AND (' . substr($formclasses, 0, -3) . ') ';
    $query .='AND (`formstart`<= ' . time() . ' OR `formstart` = 0)
 		AND (`formend` >= ' . time() . ' OR `formend` = 0)';
    echo '<li>';
    $result = mysql_query($query . ' ORDER BY `campus_trackingform`.`display_order`, `subject`');
    echo '</li>';
    if (mysql_num_rows($result) > 0)
    {
        echo '<li><hr></li>';
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $tooltip = ($rij['title_id'] == 0) ? get_lang("tooltipCombinedForm") : $rij['tracking_category'] . '>' . $rij['subject'];
            echo '<li>&nbsp;&nbsp;<a style="white-space: nowrap;" href="' . $this->get_url() . '&action=new&trackingform_id=' . $rij['id'] . '&refresh=1" title="' . $tooltip . '" >' . $rij['subject'] . '</a></li>';
        }
    }
    echo '</ul>';
    echo '</span>';
    echo '<br clear="all">';
    $sql = 'SELECT `campus_student_tracking`.`id`,`override_id`, `student_id`,`campus_student_tracking`.`tracking_category`,`tracking_title`,`date`,`teacher_code`,`grouplist`,`department_code`,`public`,`content`, `viewed`, `campus_tracking_category`.`id` as category_id, `changed`
		FROM `campus_student_tracking`
                    LEFT JOIN `campus_tracking_category`
			ON `campus_student_tracking`.`tracking_category`=`campus_tracking_category`.`tracking_category` AND `campus_tracking_category`.`department_id`=' . $department_id . '
	            LEFT JOIN `campus_tracking_visited`
	               	ON `campus_student_tracking`.`id` = `campus_tracking_visited`.`tracking_id` AND `teacher_id`=' . $_uid . '
		WHERE `student_id`=' . $student['id'];
    // allways limit to current year
    $sql .= ' AND `date` >=' . mktime(0, 0, 0, 9, 1, substr($academicYear, 0, 4)) . ' AND `date` <=' . mktime(0, 0, 0, 8, 31, substr($academicYear, 5, 4));
    // allways  limit to current department public records..
    $sql .= ' AND `department_code`="' . $department_code . '" ';
    $sql .= ( $teacher_code == "") ? '' : ' AND `teacher_code`="' . $teacher_code . '"';

    echo '<div id="lvs_tabs" style="background: #FFFFFF;"><ul>';
    if ($tracking_category != 'all')
    {
        echo '<li ><a href="' . $this->get_url() . '&page=projection&tracking_category=all" style="width: 50px;" title="' . get_lang("tooltipShowAllCategorys") . '">' . get_lang("txtAll") . '</a></li>';
    }
    else
    {
        echo '<li id="current"><a href="#" style="width: 50px;" title="' . get_lang("tooltipShowAllCategorys") . '">' . get_lang("txtAll") . '</a></li>';
    }
    $categorytabs = $trackingcategorys;
    $resulttab = mysql_query('SELECT DISTINCT `tracking_category` FROM `campus_student_tracking` WHERE `student_id`=' . $student['id'] . ' AND `department_code`="' . $department_code . '" AND `date` >=' . mktime(0, 0, 0, 9, 1, substr($academicYear, 0, 4)) . '	AND `date` <=' . mktime(0, 0, 0, 8, 31, substr($academicYear, 5, 4)));
    while ($rij = mysql_fetch_array($resulttab, MYSQL_ASSOC))
    {
        $found = FALSE;
        foreach ($categorytabs as $key => $array)
        {
            if ($rij['tracking_category'] == $array['name'])
                $found = TRUE;
        }
        if (!$found)
            $categorytabs[]['name'] = $rij['tracking_category'];
    }
    foreach ($categorytabs as $key => $array)
    {
        if ($tracking_category != $array['name'])
        {
            echo '<li ><a href="' . $this->get_url() . '&page=projection&tracking_category=' . $array['name'] . '&student_id=' . $student_id . '" title="' . get_lang("tooltipShow") . ' ' . $array['name'] . '">' . $array['name'] . '</a></li>';
        }
        else
        {
            $sql .= ' AND `campus_student_tracking`.`tracking_category`="' . $array['name'] . '"';
            echo '<li id="current"><a href="#" title="' . get_lang("tooltipShow") . ' ' . $array['name'] . '">' . $array['name'] . '</a></li>';
        }
    }
    echo '</ul></div><br clear="all">';
    $sql .= ( trim($tracking_title) != '') ? ' AND `tracking_title`="' . $tracking_title . '"' : '';
    $sql .= ' ORDER BY `date`';
    $result = mysql_query($sql);
    $t = 0;
    $i = 0;
    $override_records = array();
    $prevtitle = "";
    while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        if (!in_array($rij['id'], $override_records))
        {
            $date = DatetimeUtilities::format_locale_date('%Y-%m-%d', $rij['date']);
            $subtitle = '<i style="color:#666666">(' . $rij['teacher_code'];
            if ($rij['override_id'] != 0)
            {
                $sql2 = 'SELECT  `campus_student_tracking`.`id`,`override_id`, `student_id`,`tracking_category`,`tracking_title`,`date`,`teacher_code`,`grouplist`,`department_code`,`public`,`content`, `viewed`
				FROM `campus_student_tracking`
                                    LEFT JOIN `campus_tracking_visited`
                                        ON `campus_student_tracking`.`id` = `campus_tracking_visited`.`tracking_id` AND `teacher_id`=' . $_uid . '
	                   WHERE `campus_student_tracking`.`id`=' . $rij['override_id'];
                $result2 = mysql_query($sql2);
                $rij = mysql_fetch_array($result2, MYSQL_ASSOC);
                $subtitle.='=>' . $rij['teacher_code'] . ' <i style="font-size:10px;">' . get_lang("txtOn") . ' ' . $rij['date'] . '</i>)</i>'; //overwrite values... with those from override record...
                $override_active = TRUE; // override already active no override allowed.
                $override_records[] = $rij['id']; // store override record in override_record list
            }
            else
            {
                $subtitle.=')</i>';
                $override_active = FALSE; // no override active, so override is allowed
            }
            //$subtitle= $rij['tracking_title'].$subtitle;
            $subtitle = (($tracking_category == 'all') ? '<b>' . $rij['tracking_category'] . ':</b> ' : '') . $rij['tracking_title'] . $subtitle;

            if ($rij['public'] == 1) // only show public records,
            {
                $t++;
                echo '<div style="border: 1px solid #777777">';
                $displaymode = FALSE; //($tracking_id==$rij['id'])?FALSE:TRUE;
                echo '<a name="t_' . $t . '"></a>';
                // show title
                $icon = ($rij['public'] == 1) ? "visible" : "invisible";
                $visibilityicon = '<img src="' . Theme::get_image_path('application\campus') . $icon . '.gif" border=0 align="absmiddle" />';
                if ($displaymode)
                {
                    echo '<a href="' . $this->get_url() . '&page=projection&action=open&tracking_id=' . $rij['id'] . '#t_' . $t . '" style="font-weight: normal;" title="' . get_lang("txtLastChange") . ' ' . $rij['changed'] . '">' . $date . ' ' . $subtitle . '</i>' . $visibilityicon . '</a>';
                }
                else
                {
                    echo '<b style="color:#333366;" title="' . get_lang('txtLastChange') . ' ' . $rij['changed'] . '">' . $date . ' ' . $subtitle . '</i>' . $visibilityicon . '</b>';
                    echo '<div ID="item' . $t . '">';
                    echo '<div style="padding-bottom: 0px;">' . get_lang('labelStatus') . ': ' . get_lang('labelDepartment') . '=' . $rij['department_code'] . ',  ' . get_lang('labelClass') . '=' . $rij['grouplist'] . '</div>';
                    echo '<span style="position: relative; top: 12px; left: 15px; background-color: #FFFFFF;">' . get_lang('labelTrackingInfo') . '</span>';
                    echo '<hr width="98%" Align="center" size="1" NOSHADE>';
                    //echo '<pre COLS=60 style='width:600px'>'.$rij['content'].'</pre>';
                    $content = campus::remove_emptylines($rij['content']);
                    echo '<pre>' . wordwrap($content, 90) . '</pre>';
                    echo '</div>';
                }
                echo "</div>";
            }
        }
    }
    if ($subtitle == "")
    {
        echo '<br><br><br><br><br>';
        Display::normal_message(get_lang("msgProjectionHint"), false);
        echo '<br><br><br><br><br>';
    }
    echo '</body></html>';
}
?>