<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Theme;
use common\libraries\Path;
use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;

/*
  ==============================================================================
  POST & GET vars, check for default value?.
  ==============================================================================
 */
$academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);
$student_id = intval(campus::get_SESSION("student_id"));
$tracking_id = intval(campus::get_POST_GET("tracking_id"));
$tracking_category = campus::get_POST_GET("tracking_category");
$tracking_title = campus::get_POST_GET("tracking_title");
$select = campus::get_POST_GET("select");
$filter = campus::get_POST_GET("filter");

$by = campus::get_POST_GET("by", "type");
$teacher_code = campus::get_POST_GET("teacher_code");

$departmentStruc = campus::get_department_info($department_id);

// get rights of user in campus plugin .....
$classtracking = campus::get_trackingrights($_uid, $department_id);
$allowed = ($is_teacher || $is_platformadmin || (!empty($classtracking)));
//check if user is allowed here...
if ((intval($_uid) == 0) || ($department_id == 0) || (!$allowed))
{// not allowed here!
    Echo "NOT ALLOWED!!!";
}
else
{//only teachers and platform administrator are allowed here...
    $showCurrentDepartment =$is_platformadmin?FALSE: TRUE; // only export own department

    if ((isset($admin['studentTrackingLevel3']) && $admin['studentTrackingLevel3']) || ($is_platformadmin))
    {
        // the superviser can see all records, from all academic years within every department
        $showCurrentYear = ($filter == 'Complete') ? FALSE : TRUE;
        $showPublicOnly = FALSE;
    }
    else
    {
        $showCurrentYear = TRUE;
        if (isset($admin['studentTrackingShowHidden']) && $admin['studentTrackingShowHidden'])
        {
            $showPublicOnly = FALSE;
        }
        else
        {
            $showPublicOnly = TRUE; // only export public records
        }
    }
    if (!empty($tracking_id))
    {
        $showPublicOnly = FALSE;
    }
    // Pagina instellingen
    include(Path :: get_web_application_path('campus') . '/old_php/php_pdf/class.ezpdf.php');
    $pdf = & new \Cezpdf('a4', 'portrait');
    $phoogte = 842;
    $pbreedte = 575;
    $pdf->ezSetCmMargins(3.2, 1.5, 2, 2);
    $pdf->selectFont(Path :: get_web_application_path('campus') . '/old_php/php_pdf/fonts/Helvetica.afm');
    //koptekst en voettekst
    $pdf->ezStartPageNumbers(60, 15, 12, 'right', 'Handtekening ouders:', 1);
    //$i=$pdf ->ezStartPageNumbers(553,15,12,'left','pagina {PAGENUM} van {TOTALPAGENUM}',1);
    //$j=$pdf ->ezStartPageNumbers(160,760,15,'right',$student['firstname']." ".$student['lastname'],1);
    $pdf->ezStartPageNumbers(550, 785, 15, 'left',utf8_decode( $departmentStruc[$department_id]['name']), 1);
    if ($showCurrentYear)
    {
        $pdf->ezStartPageNumbers(550, 760, 15, 'left', $academicYear, 1);
    }
    $all = $pdf->openObject();
    $pdf->saveState();
    $pdf->setStrokeColor(0.8, 0.8, 0.8);
    $ext = strtolower(substr($departmentStruc[$department_id]['logo'], -4));
    if ($ext == '.jpg')
    {
        $pdf->addJpegFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 40, 752, 130);
    }
    elseif ($ext == '.png')
    {
        $pdf->addPngFromFile(Theme::get_image_system_path('application/campus') . $departmentStruc[$department_id]['logo'], 40, 752, 130);
    }
    $pdf->restoreState();
    $pdf->closeObject();
    // note that object can be told to appear on just odd or even pages by changing 'all' to 'odd'
    // or 'even'.
    $pdf->addObject($all, 'all');


    if ($select == "")
    {
        //read student detail info
        $sql = "SELECT `id`, `official_code`, `lastname`, `firstname`, `birth`, `address`, `phone`, `email`, `username`, `password`, `picture_uri`
                    FROM `user_user`
                        LEFT JOIN `campus_user`
                            ON `user_user`.`id` = `campus_user`.`user_id`
             		WHERE `id` = " . $student_id . " ";
    }
    else
    {
        //read student detail info
        $sql = "SELECT `user_user`.`id`,`official_code`, `lastname`, `firstname`, `birth`, `address`, `phone`, `email`, `username`, `password`, `picture_uri`
                FROM `group_group_rel_user`
                    INNER JOIN `user_user`
                        ON `user_user`.`id` = `group_group_rel_user`.`user_id`
                   LEFT JOIN `campus_user`
                            ON `user_user`.`id` = `campus_user`.`user_id`
             	  INNER JOIN `group_group`
                        ON `group_group`.`id` = `group_group_rel_user`.`group_id`
                    LEFT JOIN `campus_department_rel_group`
                        ON `group_group`.`id` = `campus_department_rel_group`.`group_id` AND `type`= 2
		WHERE `department_id`=" . $department_id . " ";
        if ($select != 0)
        {
            $sql.="AND (`group_group_rel_user`.`group_id`=" . ereg_replace(",", " OR `group_group_rel_user`.`group_id`=", $select) . ")";
        }
        $sql.=" ORDER BY `group_group`.`code`, `display_order`,`lastname`,`firstname`";
    }
    $result1 = mysql_query($sql);
    $newpage = FALSE;
    while ($student = mysql_fetch_array($result1, MYSQL_ASSOC))
    {
        campus::document2pdf_footer($pdf, 595, 1.5);
        $pdf->setColor(0, 0, 0);
        if ($newpage)
        { //newpage
            $pdf->ezStopPageNumbers(1, 1, $j);
            $pdf->ezStopPageNumbers(1, 1, $i);
            $pdf->ezNewPage();
        }
        else
        { //this is first page, next student is to be placed on a new page.
            $newpage = TRUE;
        }
        $j = $pdf->ezStartPageNumbers(260, 760, 12, 'right', utf8_decode($student['firstname'] . ' ' . $student['lastname']), 1);
        $i = $pdf->ezStartPageNumbers(553, 15, 12, 'left', 'pagina {PAGENUM} van {TOTALPAGENUM}', 1);

        $groups = campus::get_classes($student['id']);
        $grouplist = "";
        foreach ($groups as $group_id => $groupinfo)
        {
            $grouplist.=$groupinfo['code'] . ' ';
        }
        $grouplist = trim($grouplist);

        if ($select == "")
    {
                $filename = utf8_decode($student['firstname'] . " " . $student['lastname']);
        }
        else
        {
            $filename =utf8_decode(str_replace(' ','_', $grouplist));
        }

        // Student Info on firstpage.....

        $pdf->Rectangle(55, 605, 395, 125);
        $pdf->Rectangle(455, 605, 85, 125);
        $pdf->addText(60, 710, 14, utf8_decode($student['firstname'] . " " . $student['lastname']), 0);
        $pdf->addText(60, 690, 12, "<i>Klas: </i>", 0);
        $pdf->addText(120, 690, 14, utf8_decode($grouplist), 0);
        $pdf->addText(60, 675, 11, "<i>Stamnummer: </i>" . $student['official_code'], 0);
        $pdf->addText(60, 655, 10, "Contact gegevens:", 0);
        $pdf->addText(70, 640, 10, utf8_decode($student['address']), 0);
        $pdf->addText(70, 625, 10, utf8_decode($student['phone']), 0);
        $pdf->addText(70, 610, 10, utf8_decode($student['email']), 0);

        //============ foto =============
        $x = 460;
        $y = 610;
        $pdf->setColor(0.8, 0.8, 0.8);
        $pdf->addText($x + 15, $y + 10, 16, "GEEN FOTO ", -55);
        $pdf->setColor(0.2, 0.2, 0.2);
        $pdf->addText($x + 12, $y + 10, 16, "GEEN FOTO ", -55);
        if (is_file(Path :: get(SYS_USER_PATH) . $student['picture_uri']))
        {
            $pdf->addJpegFromFile(Path :: get(SYS_USER_PATH) . $student['picture_uri'], $x, $y, 75);
        }
        $pdf->setColor(0, 0, 0);
        //======== end of foto ==========

        $pdf->ezSetY(600);
        $sql = 'SELECT `campus_student_tracking`.`id`, `tracking_category`,`tracking_title`,`date`,`teacher_code`,`grouplist`,`department_code`,`public`,`content`, `viewed`, `override_id`
                    FROM `campus_student_tracking`
                        LEFT JOIN `campus_tracking_visited`
                            ON `campus_student_tracking`.`id` = `campus_tracking_visited`.`tracking_id` AND `teacher_id`=' . $_uid . '
			WHERE ';
        if ($tracking_id != 0)
        {
            $sql .= '`campus_student_tracking`.`id`=' . $tracking_id;
        }
        else
        {
            $sql .= '`student_id`=' . $student['id'];
            $sql .= ( ($tracking_category != 'all') && ($tracking_category != '')) ? ' AND `tracking_category`="' . $tracking_category . '"' : '';
            $sql .= ( $filter == 'newest') ? ' AND ( `teacher_id` is NULL OR  `printed`=0)' : '';
            $sql .= ( $tracking_title != '') ? ' AND `tracking_title`="' . $tracking_title . '"' : '';
            $sql .= ( $showCurrentYear) ? ' AND `date` >=' . mktime(0, 0, 0, 7, 1, substr($academicYear, 0, 4)) . ' AND `date` <=' . mktime(0, 0, 0, 8, 31, substr($academicYear, 5, 4)) : '';
            $sql .= ( $showCurrentDepartment) ? ' AND `department_code`="' . $departmentStruc[$department_id]['code'] . '"' : '';
            $sql .= ( $showPublicOnly) ? ' AND `public`=1' : '';
            $sql .= ( $teacher_code != '') ? ' AND `teacher_code`="' . $teacher_code . '"' : '';
            $sql .= ( $by == 'date') ? ' ORDER BY `date`' : ' ORDER BY `tracking_category`, `date`';
        }
        $result = mysql_query($sql);
        $override_records = array();
        $prev_title = '';
        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $pdf->setColor(0, 0, 0);
            if (!in_array($rij['id'], $override_records)&&($rij['tracking_title']!='objectivetracking'))
            {
                $trackingdate = DatetimeUtilities::format_locale_date('%Y-%m-%d', $rij['date']);
                if ($rij['override_id'] != 0)
                {
                    $trackingcategory = " <b>" . utf8_decode($rij['tracking_category']) . "</b>";
                    $writer = "(" . utf8_decode($rij['teacher_code']) . "=>";
                    $sql2 = "SELECT * FROM `campus_student_tracking` WHERE `id`=" . $rij['override_id'];
                    $result2 = mysql_query($sql2) or die(mysql_error());
                    $rij = mysql_fetch_array($result2, MYSQL_ASSOC);
                    $writer.=utf8_decode($rij['teacher_code']) . " <i>op " . DatetimeUtilities::format_locale_date('%Y-%m-%d',$rij['date']) . "</i>)";
                    $override_records[] = $rij['id']; // store override record in override_record list
                }
                else
                {
                    $trackingcategory = " <b>" . utf8_decode($rij['tracking_category']) . "</b>";
                    $writer = "(" . utf8_decode($rij['teacher_code']) . ")";
                }
                if ($by == 'date')
                {
                    $title = $trackingdate;
                    $subtitle = $trackingcategory;
                }
                else
                {
                    $title = $trackingcategory;
                    $subtitle = $trackingdate;
                }
                if (($rij['public'] == 1) || (!$showPublicOnly))
                {
                    //$pdf ->transaction('start');
                    $pos1 = $pdf->ezPosY();
                    $lus = true;
                    //while ($lus)
                    //{
                    $pos1 = $pdf->ezPosY();
                    if ($title <> $prev_title)
                    {
                        $pdf->setColor(0.96, 0.96, 0.96);
                        $pdf->filledRectangle(55, $pos1, 500, -15);
                        $pdf->setColor(0.3, 0.3, 0.55);
                        $pdf->eZText(utf8_decode($title), 12, array('aleft' => 57));
                        $pdf->setColor(0, 0, 0);
                        $pdf->ezSetDy(-2);
                    }
                    $prev_title = $title;
                    $pos = $pdf->ezPosY();
                    $pdf->setColor(0.3, 0.3, 0.55);
                    $pdf->ezText($subtitle . ": " . utf8_decode($rij['tracking_title']) . " " . $writer . " " . "Status: school=" . $rij['department_code'] . ",  klas=" . utf8_decode($rij['grouplist']) . (($rij['public'] == 1) ? "" : " =>" . get_lang("txtHidden")), 10, array('aleft' => 75));
                    /* $pdf->ezText($subtitle.": ".$rij['tracking_title'],10,array('aleft'=>75));
                      $align=75+$pdf ->getTextWidth(10,$subtitle.": ".$rij['tracking_title'])+5;
                      $pdf->ezSetY($pos-2);
                      $pdf->ezText($writer,8,array('aleft'=>$align));
                      $align=$align+$pdf ->getTextWidth(8,$writer)+5;
                      $pdf->ezSetY($pos-2);
                      $pdf->setColor(0.6,0.6,0.6);
                      $pdf->ezText("Status: school=".$rij['department_code'].",  klas=".$rij['grouplist'].(($rij['public']=='on')?"":" =>".get_lang("txtHidden")),8,array('aleft'=>$align));

                     */
                    $pdf->setColor(0, 0, 0);
                    $content = campus::remove_emptylines($rij['content']);
                    $pdf->ezText("<i>" . utf8_decode(str_replace("<br>", "\n", $content)) . "</i>\n", 10, array('aleft' => 115));
                    $pos2 = $pdf->ezPosY();
                    /* 	if (($pos2>$pos1))
                      {
                      $pdf ->transaction('rewind');
                      $pdf ->ezNewPage ();
                      $prev_title='';
                      }
                      else
                      {
                      $lus=false;
                      }
                      }
                      $pdf ->transaction('commit'); */
                }
            }
        }
    }
    $pdf->ezStopPageNumbers(1, 0, $j);
    $fileoption = array('Content-Disposition' => $filename . '.pdf');
    $pdf->ezStream($fileoption);
    $pdf->ezStream();
}
?>