<?php
/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\DatetimeUtilities;
use common\libraries\Display;
use common\libraries\PlatformSetting;


//check if user is allowed here...
if (intval($_uid)==0)
{// not allowed here!
	Display::display_error_message(get_lang("msgNoRights4ThisDepartment"),false);
}
else
{//

/*
============================================================================== 
		POST & GET vars, check for default value?.
============================================================================== 
*/
	$student_id=intval($_uid);
	$student=campus::get_user_info($_uid);
	$submitmessage=campus::get_POST_GET("submitmessage");
	$class_id=intval(campus::get_SESSION("class_id")); // store in session...
	// form data
	$tracking_category=campus::get_POST_GET("tracking_category");
	$tracking_title=campus::get_POST_GET("tracking_title");
	$trackingform_id=intval(campus::get_POST_GET("trackingform_id"));
	$date=campus::get_POST_GET("date",$today);
	$teacher_code="";
	$grouplist=campus::get_POST_GET("grouplist");
	$department_code=campus::get_POST_GET("department_code",$departmentStruc[$department_id]['code']);
	$content=campus::get_POST_GET("content");
   $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);
	// Get classes from student...
	$classes=campus::get_classes ($student_id);
	$grouplist="";
	$classinfo="";
	$classtracking=campus::get_trackingrights ($_uid,$department_id);
	foreach ($classes as $classid => $value)
	{
		$classinfo.=$value['code']." (".$value['display_order'].") ";
		$grouplist.=$value['code']."_";
	}
	$grouplist=substr($grouplist,0,-1);

echo '<div class="maincontent" id="content">';
	
/*
============================================================================== 
		Read, write and update database......
============================================================================== 
*/ 

	if (($student_id==0))
	{// ||($class_id==0))
		Display::display_error_message(get_lang("msgDataMissing"),false);
	}
	else
	{
		if ($submitmessage=="")
		{ //
			// 
			$teacher_code="";
			$department_code=$departmentStruc[$department_id]['code'];
			$display="form";
		}
		else
		{
			if ($trackingform_id>0)
			{	
				// display link to special form....
				$query = "SELECT `form_type` FROM `campus_trackingform` WHERE `id`=".$trackingform_id."";
 				$result = mysql_query($query);
				list($form_type)= mysql_fetch_row($result);

				if ($form_type==2)
				{
					$query='SELECT * FROM `campus_student_tracking` WHERE
						`student_id`="'.$student_id.'" AND `tracking_category`="'.$tracking_category[$trackingform_id].'" AND `tracking_title`="'.$tracking_title[$trackingform_id].'" AND `teacher_code`="'.$teacher_code.'" AND `department_code`="'.$department_code.'"
									 AND `date` >='.mktime(0,0,0,'7','1',substr($academicYear,0,4))." AND `date` <=".mktime(0,0,0,'8','31',substr($academicYear,5,4)).'';
					$result=mysql_query($query) ;
					if (mysql_num_rows($result)>0)
					{
						$write=false;
					}
					else
					{
						$write=true;
					}
				}
				elseif ($form_type==1)
				{
					$write=true;
				}
				else
				{	
					$write=false;
				}
				if ($write)
				{
					$content="";
					$lines=campus::get_POST_GET("nbrlines");
	 				for ($line=1; $line<=$lines[$trackingform_id]; $line++) 
					{
						$begin=is_array(campus::get_POST_GET('F'.$trackingform_id.'begin'.$line,'',false))?implode(", ",campus::get_POST_GET('F'.$trackingform_id.'begin'.$line,'',false)):campus::get_POST_GET('F'.$trackingform_id.'begin'.$line,'',false);
						$mid=is_array(campus::get_POST_GET('F'.$trackingform_id.'mid'.$line,'',false))?implode(", ",campus::get_POST_GET('F'.$trackingform_id.'mid'.$line,'',false)):campus::get_POST_GET('F'.$trackingform_id.'mid'.$line,'',false);
						$end=is_array(campus::get_POST_GET('F'.$trackingform_id.'end'.$line,'',false))?implode(", ",campus::get_POST_GET('F'.$trackingform_id.'end'.$line,'',false)):campus::get_POST_GET('F'.$trackingform_id.'end'.$line,'',false);
						$content.=$begin." ".$mid." ".$end."\n";
					}	
					$query='INSERT `campus_student_tracking` SET
							`student_id`='.$student_id.',
								`tracking_category`="'.$tracking_category[$trackingform_id].'",
								`tracking_title`="'.$tracking_title[$trackingform_id].'",
								`date`='.time().',
							`changed`='.time().',
							`teacher_code`="'.$teacher_code.'",
							`grouplist`="'.$grouplist.'",
							`department_code`="'.$department_code.'",
							`public`=1,
							`attachment`="",
							`content`="'.$content.'" ';
					$result=mysql_query($query);
					if (!$result)
					{
						$message = get_lang("msgItemAddError");
						$display="form";
					}
					else
					{
						$tracking_id=mysql_insert_id();
						$message = get_lang("msgItemAddSucces").'<br><a href="'.$this->get_url().'&page=studentform2pdf&trackingform_id='.$trackingform_id.'&tracking_id='.$tracking_id.'">'.get_lang("msg2Pdf").'</a>';
						$display="list";
					}
				}
				else
				{
						$message = get_lang("msgAllReadyFilledIn");
						$display="list";
				}
			}
		} 
		//Make prev student and next student link AND Get user details....
		$prev_student="";
		$next_student="";
/*
============================================================================== 
		display ...
============================================================================== 
*/
		echo "<h1>".$student['firstname']."&nbsp;".$student['lastname']."</h1><br>";
		if ($display=='form')
		{
			if (!empty($message))
			{		
				Display::error_message($message,false);
			}
			echo "<br clear=\"all\">";
			include ("tracking_specialform.php");
		}
		else
		{
			if ($write)
			{
				Display::normal_message($message,false);
			}
			else
			{
				Display::error_message($message,false);
			}
		}
		echo "<a href=\"".$this->get_infoboard_url()."\" >".get_lang('txtBack2InfoBoard')."</a>";
	}
}
echo '</div>';
?>