<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Path;
use common\libraries\Theme;
use common\libraries\PlatformSetting;
use common\libraries\DatetimeUtilities;
/*
  ==============================================================================
  POST & GET vars, check for default value?.
  ==============================================================================
 */
$submitmessage = campus::get_POST_GET("submitmessage");
// form data
$classtracking = campus::get_trackingrights($_uid, $department_id);
$tracking_category = campus::get_POST_GET("tracking_category");
$tracking_title = campus::get_POST_GET("tracking_title");

$department_code = $departmentStruc[$department_id]['code'];
// determin rights:
$selectie = campus::get_POST_GET("select");
if ($admin['studentTrackingLevel3'] || $admin['studentTrackingLevel2'] || $is_platformadmin)
{
    $trackingallowed = TRUE;
}
else
{
    $trackingallowed = FALSE;
    $select = explode(",", $selectie);
    foreach ($select as $classid)
    {
        if (($classtracking[$classid] == 'classTeacher') || ($classtracking[$classid] == 'Teacher'))
        {
            $trackingallowed = TRUE;
            $selectie = $classid . ',';
        }
    }
    $selectie = substr($selectie, 0, -1);
}


//check if user is allowed here...
if ((intval($_uid) == 0) || ((!$trackingallowed) && !($is_platformadmin)))
{// not allowed here!
    Display::display_error_message(get_lang("msgNoRights4ThisClass"), false);
}
else
{//only teachers and platform administrator are allowed here...

    /*
      ==============================================================================
      Read, write and update database......
      ==============================================================================
     */

    // hidden records and all schools visible
    $nolimit = $admin['studentTrackingLevel3'] || $is_platformadmin;
    // Permission to read records, only level0 is not allowed to read other...
    $permRead = $admin['studentTrackingLevel3'] || $admin['studentTrackingLevel2'] || $admin['studentTrackingLevel1'] || $individualcoach || $classcoach || $classteacher || $is_platformadmin;
    // Permission to write records, only level1 is not allowed to write...
    $permWrite = $admin['studentTrackingLevel3'] || $admin['studentTrackingLevel2'] || $admin['studentTrackingLevel0'] || $individualcoach || $classcoach || $classteacher || $is_platformadmin;
    // Permission to overwrite records, only level3 and clascoach are permitted to overwrite...
    $permOverride = $admin['studentTrackingLevel3'] || $classcoach || $is_platformadmin;
    // Permission to print
    $permPrint = $admin['studentTrackingLevel3'] || $admin['studentTrackingLevel2'] || $classcoach || $is_platformadmin;
    // Only Current academic year
    $currentYearOnly = $admin['studentTrackingLevel1'] || $admin['studentTrackingLevel2'];

    $trackingcategorys = campus::get_trackingcategorys($department_id);
    $teacher = campus::get_user_info($_uid);
    $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);

    /*
      ==============================================================================
      display ...
      ==============================================================================
     */
    //campus::display_departments ($departmentStruc,$department_id);
    echo "<table width='100%' align='center'>";
    // ************* display student information ***
    echo "<tr>";
    echo "<td>";
    echo "<b style='font-size:28px;' title='" . $classinfo[$class_id]['name'] . "'>" . $classinfo[$class_id]['code'] . "</b>";
    echo "</td><td>";
    echo "</td></tr>";
    // Query van het gegevensbestand....
    $query = "SELECT `user_user`.`id`, `display_order`, `lastname`, `firstname`, `username`,`email`,`address`, `phone`, `group_group`.`code`, `group_group_rel_user`.`group_id`,`group_group`.`name` as 'classname', `picture_uri`
	            FROM `user_user`
                        LEFT JOIN `campus_user`
                            ON `user_user`.`id` = `campus_user`.`user_id`
                        LEFT JOIN `group_group_rel_user`
                            ON `user_user`.`id` = `group_group_rel_user`.`user_id`
	                INNER JOIN `group_group`
                            ON `group_group`.`id` = `group_group_rel_user`.`group_id`
			INNER JOIN `campus_department_rel_group`
				ON `group_group`.`id` = `campus_department_rel_group`.`group_id` AND `type`=2
		WHERE `department_id`=" . $department_id . " ";
    if ($selectie != 0)
    {
        $query.="AND (`group_group_rel_user`.`group_id`=" . ereg_replace(",", " OR `group_group_rel_user`.`group_id`=", $selectie) . ")";
    }
    $query.=" ORDER BY `group_group`.`code`, `display_order`, `lastname`, `firstname`";
    $prevclass = "";
    $result = mysql_query($query) or die(mysql_error());
    while ($student = mysql_fetch_array($result, MYSQL_ASSOC))
    {
        if ($student['code'] != $prevclass)
        {
            echo "<tr>";
            echo "<td style='background-color: #999999;'>";
            echo "<b style='font-size:24px;' >" . $student['classname'] . "</b>";
            echo "</td><td style='background-color: #999999;'>";
            $message = get_lang("msgConfirmViewed");
            $message.= "<br><a href=\"../studentlistbyklas/index.php?selectie=" . $class_id . "&action=confirm\">" . get_lang("txtYes") . "</a> /
							<a href=\"../studentlistbyklas/index.php?select=" . $class_id . "\">" . get_lang("txtNo") . "</a>";
            //Display::display_warning_message($message,false);
            echo "&nbsp;</td></tr>";
            $prevclass = $student['code'];
        }

        $sql = "SELECT `campus_student_tracking`.`id`, `campus_student_tracking`.`tracking_category`,`tracking_title`,`date`,`teacher_code`,`grouplist`,`department_code`,`public`,`content`, `override_id`,`campus_tracking_category`.`id` as category_id
					FROM `campus_student_tracking`
                                            LEFT JOIN `campus_tracking_category`
					 	ON `campus_student_tracking`.`tracking_category`=`campus_tracking_category`.`tracking_category` AND `campus_tracking_category`.`department_id`=" . $department_id . "
						WHERE ";
        $sql .= "`student_id`=" . $student['id'];
        $sql .= ( $tracking_category == 'all') ? "" : " AND `tracking_category`='" . $tracking_category . "'";
        $sql .= ( $tracking_title != '') ? " AND `tracking_title`='" . $tracking_title . "'" : "";
        // allways	current year....
        //$sql .= " AND `date` >='".substr($academicYear,0,4)."-07-01'	AND `date` <='".substr($academicYear,5,4)."-08-31'";
        $sql .= ( $filter == 'newest') ? " AND ( `teacher_id` is NULL OR  `printed`=FALSE)" : "";
        // allways	current department....
        $sql .= " AND `department_code`='" . $departmentStruc[$department_id]['code'] . "'";
        $sql .= " ORDER BY `date`";
        $result2 = mysql_query($sql) or die(mysql_error());
        $override_records = array();
        if (mysql_num_rows($result2) > 0)
        {
            echo "<tr>";
            echo "<td valign='top' >";
            if (is_file(Path :: get(SYS_USER_PATH) . $student['picture_uri']))
            {
                echo '<img src="'.Path :: get(WEB_USER_PATH) . $student['picture_uri'] . '" height="120" style="border:1px solid #999999">';
            }
            else
            {
                echo '<img src="' . Theme :: get_common_image_path() . 'unknown.jpg" height="120" style="border:1px solid #999999">';
            }
            echo "<br><b>" . $student['firstname'] . " " . $student['lastname'] . "</b>";
            echo "</td>";
            echo "<td valign='top'>";
            while ($rij = mysql_fetch_array($result2, MYSQL_ASSOC))
            {
                if (!in_array($rij['id'], $override_records))
                {
                    $date = $rij['date'];
                    $subtitle = "<i style='color:#666666'>(" . $rij['teacher_code'];
                    if ($rij['override_id'] != 0)
                    {
                        $sql3 = 'SELECT  `campus_student_tracking`.`id`,`override_id`, `student_id`,`campus_student_tracking`.`tracking_category`,`tracking_title`,`date`,`teacher_code`,`grouplist`,`department_code`,`public`,`content`,`campus_tracking_category`.`id` as category_id
                                    FROM `campus_student_tracking`
                                        LEFT JOIN `campus_tracking_category`
                                            ON `campus_student_tracking`.`tracking_category`=`campus_tracking_category`.`tracking_category` AND `campus_tracking_category`.`department_id`=' . $department_id . '
				    WHERE `campus_student_tracking`.`id`=' . $rij['override_id'];
                        $result3 = mysql_query($sql3);
                        $rij = mysql_fetch_array($result3, MYSQL_ASSOC);
                        $subtitle.="=>" . $rij['teacher_code'] . " <i style='font-size:10px;'>" . get_lang("txtOn") . " " . $rij['date'] . "</i>)</i>"; //overwrite values... with those from override record...
                        $override_active = TRUE; // override already active no override allowed.
                        $override_records[] = $rij['id']; // store override record in override_record list
                    }
                    else
                    {
                        $subtitle.=")</i>";
                        $override_active = FALSE; // no override active, so override is allowed
                    }
                    $subtitle = '<b>' . $rij['tracking_category'] . ':</b> ' . $rij['tracking_title'] . $subtitle . '&nbsp;<img src="' . Theme::get_image_path('application\campus') . '/' . (($rij['public'] == 1) ? "visible" : "invisible") . '.gif" border=0 align="absmiddle" />';
                    // restricted records are only shown within the department for the level3 administrator...
                    if (($rij['date'] > mktime(0,0,0,9,1,substr($academicYear, 0, 4))) || ($trackingcategorys[$rij['category_id']]['restricted'] != 1)) //||($nolimit)
                    {
                        echo "<div style='border: 1px solid #777777'>";
                        echo "<span style='color:#999999;font-weight: normal;' >" . DatetimeUtilities::format_locale_date('%Y-%m-%d',$date) . " " . $subtitle . "</span>";
                        echo "<div >";
                        echo "<div style='padding-bottom: 0px;'>" . get_lang("labelStatus") . ": " . get_lang('labelDepartment') . "=" . $rij['department_code'] . ",  " . get_lang('labelClass') . "=" . $rij['grouplist'] . "</div>";
                        echo "<span style='position: relative; top: 12px; left: 15px; background-color: #FFFFFF;'>" . get_lang("labelTrackingInfo") . "</span>";
                        echo "<hr width='98%' Align='center' size='1' NOSHADE>";
                        echo "<pre>" . wordwrap($rij['content'], 90) . "</pre>";
                        echo "</div>";
                        echo "</div>";
                    }
                }
            }
            echo "</td></tr>";
        }
    }

    echo "</table>";
}
?>