<?php

/*
  ==============================================================================
  plugin: campus for Chamilo 2.0.X
  by Ludwig Theunis (email: ludwig@openelo.be)
  ==============================================================================
 */

namespace application\campus;

use common\libraries\Translation;
use common\libraries\Text;
use common\libraries\Display;
use common\libraries\PlatformSetting;
use common\libraries\Theme;
use common\libraries\Path;
use common\libraries\ResourceManager;
use common\libraries\DatetimeUtilities;

$submitmessage = campus::get_POST_GET("submitmessage");
$class_id = intval(campus::get_POST_GET("class_id")); // store in session...
// form data
$classinfo = campus::get_class_info($class_id);
$classtracking = campus::get_trackingrights($_uid, $department_id);
$department_code = $departmentStruc[$department_id]['code'];
// determin rights:
$classcoach = ($classtracking[$class_id] == 'classTeacher') ? TRUE : FALSE;
$classteacher = ($classtracking[$class_id] == 'Teacher') ? TRUE : FALSE;
$trackingallowed = ((isset($admin['studentTrackingLevel0']) && $admin['studentTrackingLevel0']) || (isset($admin['studentTrackingLevel1']) && $admin['studentTrackingLevel1']) || (isset($admin['studentTrackingLevel2']) && $admin['studentTrackingLevel2']) || (isset($admin['studentTrackingLevel3']) && $admin['studentTrackingLevel3']) || $classcoach || $classteacher );

//check if user is allowed here...
if ((intval($_uid) == 0) || ((!$trackingallowed) && !($is_platformadmin)))
{// not allowed here!
    Display::error_message(get_lang("msgNoRights4ThisDepartment"), false);
}
else
{//only teachers and platform administrator are allowed here...

    /*
      ==============================================================================
      Read, write and update database......
      ==============================================================================
     */

    if ($class_id == 0)
    {
        Display::error_message(get_lang("msgDataMissing"), false);
    }
    else
    {
        $academicYear = PlatformSetting::get('active_academic_year', __NAMESPACE__);
        // hidden records and all schools visible
        $nolimit = $admin['studentTrackingLevel3'] || $is_platformadmin;
        // Permission to read records, only level0 is not allowed to read other...
        $permRead = $admin['studentTrackingLevel3'] || $admin['studentTrackingLevel2'] || $admin['studentTrackingLevel1'] || $individualcoach || $classcoach || $classteacher || $is_platformadmin;
        // Permission to write records, only level1 is not allowed to write...
        $permWrite = $admin['studentTrackingLevel3'] || $admin['studentTrackingLevel2'] || $admin['studentTrackingLevel0'] || $individualcoach || $classcoach || $classteacher || $is_platformadmin;
        // Permission to overwrite records, only level3 and clascoach are permitted to overwrite...
        $permOverride = $admin['studentTrackingLevel3'] || $classcoach || $is_platformadmin;
        // Permission to print
        $permPrint = $admin['studentTrackingLevel3'] || $admin['studentTrackingLevel2'] || $classcoach || $is_platformadmin;
        // Only Current academic year
        $currentYearOnly = $admin['studentTrackingLevel1'] || $admin['studentTrackingLevel2'];

        $trackingcategorys = campus::get_trackingcategorys($department_id);
        $teacher = campus::get_user_info($_uid);

        /*
          ==============================================================================
          display ...
          ==============================================================================
         */
        //campus::display_departments ($departmentStruc,$department_id);
        echo "<table width='100%' align='center'>";
        // ************* display student information ***
        echo "<tr>";
        echo "<td>";
        echo "<b style='font-size:28px;' title='" . $classinfo[$class_id]['name'] . "'>" . $classinfo[$class_id]['code'] . "</b>";
        echo "</td><td>";
        $message = get_lang("msgConfirmViewed");
        $message.= '<br><a href="' . $this->get_studentlist_url() . '&selectie=' . $class_id . '&action=confirm">' . get_lang("txtYes") . '</a> /
						<a href="' . $this->get_studentlist_url() . '&select=' . $class_id . '">' . get_lang("txtNo") . '</a>';
        Display::warning_message($message, false);
        echo "</td></tr>";
        $query = "SELECT `user_user`.`id`, `lastname`, `firstname`, `official_code`, `birth`, `address`, `phone`, `email`, `username`, `password`, `picture_uri`
                    FROM `user_user`
                        LEFT JOIN `campus_user`
                            ON `user_user`.`id`=`campus_user`.`user_id`
                        LEFT JOIN `group_group_rel_user`
                            ON `user_user`.`id` = `group_group_rel_user`.`user_id`
                    WHERE `group_group_rel_user`.`group_id`=" . $class_id . " ORDER BY  `display_order`,`lastname`,`firstname`";
        $result = mysql_query($query) or die(mysql_error());
        while ($student = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            //echo "<table width='100%' border='1'  cellspacing='0' style='border-right:4px #333333 solid;border-bottom:4px #333333 solid;'>";
            $sql2 = "SELECT `campus_student_tracking`.`id`,`override_id`, `student_id`,`campus_student_tracking`.`tracking_category`,`campus_student_tracking`.`tracking_title`,`date`,`teacher_code`,`grouplist`,`department_code`,`public`,`content`, `viewed`, `campus_tracking_category`.`id` as category_id,`silent_tracking`
					 FROM `campus_student_tracking`
					 	LEFT JOIN `campus_tracking_category`
					 		ON `campus_student_tracking`.`tracking_category`=`campus_tracking_category`.`tracking_category` AND `campus_tracking_category`.`department_id`=" . $department_id . "
						LEFT JOIN `campus_tracking_title`
					 		ON `campus_tracking_category`.`id`=`campus_tracking_title`.`category_id` AND `campus_tracking_title`.`tracking_title`=`campus_student_tracking`.`tracking_title`
						LEFT JOIN `campus_tracking_visited`
		               		ON `campus_student_tracking`.`id` = `campus_tracking_visited`.`tracking_id` AND `teacher_id`=" . $_uid . "
						WHERE `student_id`=" . $student['id'];
            $sql2 .= " AND (`silent_tracking` is NULL OR `silent_tracking`=0) AND (`viewed` is NULL OR `viewed` = 0) ";
            // wenn neccesary limit to current year
            $sql2 .= " AND `date` >=" . mktime(0, 0, 0, 7, 1, substr($academicYear, 0, 4)) . "	AND `date` <=" . mktime(0, 0, 0, 8, 31, substr($academicYear, 5, 4)) . "";
            // wenn neccesary limit to current department
            $sql2 .= ( $nolimit) ? " AND `department_code`<>''" : " AND `department_code`='" . $department_code . "' AND `public`=1";
            $sql2 .= " ORDER BY  `date`";
            $result2 = mysql_query($sql2) or die(mysql_error());
            $override_records = array();
            $prevtitle = "";
            if (mysql_num_rows($result2) > 0)
            {
                echo "<tr>";
                echo "<td valign='top'>";
                if (is_file(Path :: get(SYS_USER_PATH) . $student['picture_uri']))
                {
                    echo '<img src="' . Path :: get(WEB_USER_PATH) . $student['picture_uri'] . '" height="100">';
                }
                else
                {
                    echo '<img src="' . Theme :: get_common_image_path() . 'unknown.jpg" height="100" >';
                }
                echo "<br><b>" . $student['firstname'] . " " . $student['lastname'] . "</b>";
                echo "</td>";
                echo "<td valign='top'>";
                while ($rij = mysql_fetch_array($result2, MYSQL_ASSOC))
                {
                    if (!in_array($rij['id'], $override_records))
                    {
                        $date = $rij['date'];
                        $subtitle = "<i style='color:#666666'>(" . $rij['teacher_code'];
                        if ($rij['override_id'] != 0)
                        {
                            $sql3 = "SELECT  `campus_student_tracking`.`id`,`override_id`, `student_id`,`tracking_category`,`tracking_title`,`date`,`teacher_code`,`grouplist`,`department_code`,`public`,`content`, `viewed`
                                        FROM `campus_student_tracking`
                                            LEFT JOIN `campus_tracking_visited`
                                                ON `campus_student_tracking`.`id` = `campus_tracking_visited`.`tracking_id` AND `teacher_id`=" . $_uid . "
				        WHERE `campus_student_tracking`.`id`=" . $rij['override_id'];
                            $result3 = mysql_query($sql3);
                            $rij = mysql_fetch_array($result3, MYSQL_ASSOC);
                            $subtitle.="=>" . $rij['teacher_code'] . " <i style='font-size:10px;'>" . get_lang("txtOn") . " " . DatetimeUtilities::format_locale_date("%Y-%m-%d",$rij['date']) . "</i>)</i>"; //overwrite values... with those from override record...
                            $override_active = TRUE; // override already active no override allowed.
                            $override_records[] = $rij['id']; // store override record in override_record list
                        }
                        else
                        {
                            $subtitle.=")</i>";
                            $override_active = FALSE; // no override active, so override is allowed
                        }
                        $subtitle = '<b>' . $rij['tracking_category'] . ':</b> ' . $rij['tracking_title'] . $subtitle . '&nbsp;<img src="' . Theme::get_image_path('application\campus') . (($rij['public'] == 1) ? "visible" : "invisible") . '.gif" border=0 align="absmiddle" />';
                        // restricted records are only shown within the department for the level3 administrator...
                        if (($rij['date'] > mktime(0, 0, 0, 9, 1, substr($academicYear, 0, 4))) || ($trackingcategorys[$rij['category_id']]['restricted'] != 1) || (($rij['department_code'] == $department_code) && ($nolimit)))
                        {
                            echo "<div style='border: 1px solid #777777'>";
                            echo "<span style='color:#999999;font-weight: normal;' >" . DatetimeUtilities::format_locale_date("%Y-%m-%d",$date). " " . $subtitle . "</span>";
                            echo "<div >";
                            echo "<div style='padding-bottom: 0px;'>" . get_lang("labelStatus") . ": " . get_lang('labelDepartment') . "=" . $rij['department_code'] . ",  " . get_lang('labelClass') . "=" . $rij['grouplist'] . "</div>";
                            echo "<span style='position: relative; top: 12px; left: 15px; background-color: #FFFFFF;'>" . get_lang("labelTrackingInfo") . "</span>";
                            echo "<hr width='98%' Align='center' size='1' NOSHADE>";
                            echo "<pre>" . wordwrap($rij['content'], 90) . "</pre>";
                            echo "</div>";
                            echo "</div>";
                        }
                    }
                }
                echo "</td></tr>";
            }
        }
        echo "<tr>";
        echo "<td>";
        echo "<b style='font-size:28px;' title='" . $classinfo[$class_id]['name'] . "'>" . $classinfo[$class_id]['code'] . "</b>";
        echo "</td><td>";
        Display::warning_message($message, false);
        echo "</td></tr>";

        echo "</table>";
    }
}
?>