<?php

namespace application\campus;

use common\libraries\AjaxManager;
use common\libraries\JsonAjaxResult;
use common\libraries\Request;
use common\libraries\DatetimeUtilities;

/**
 * Feed to return the course groups of this course
 *
 * @author Sven Vanpoucke
 * @package application.weblcms
 */
class CampusAjaxAgendaInfo extends AjaxManager
{

    function required_parameters()
    {
        return array('sendid');
    }

    /**
     * Runs this ajax component
     */
    function run()
    {
        $ajax_result = new JsonAjaxResult(200);

        $groups = campus::get_agenda2group($this->get_parameter('sendid'));

        $students = campus::get_agenda2student($this->get_parameter('sendid'));

        $grouplist = '';
        $newContent = "<b>" . get_lang("txtClasses") . ":</b><br>";
        foreach ($groups as $key => $value)
        {
            $newContent .= str_replace(" ", "&nbsp;", htmlentities(utf8_decode($value['name']))) . "<br>";
            $grouplist .= ';' . $key;
        }
        if (! empty($students))
        {
            $newContent .= "<br><b>" . get_lang("txtStudents") . ":</b><br>";
            foreach ($students as $student_id => $student)
            {
                $newContent .= str_replace(
                        " ", "&nbsp;", htmlentities(utf8_decode($student['firstname'] . " " . $student['lastname']))
                    ) . "<br>";
            }
        }

        $groupfilter = str_replace(';', ' OR `campus_agenda_rel_group`.`group_id`=', substr($grouplist, 1));
        $query = 'SELECT DISTINCT  `campus_agenda`.`id`,`campus_discipline`.`code`,`campus_discipline`.`name`,`date`,`tasks`
			FROM `campus_agenda`
                            INNER JOIN `campus_assignment` ON `campus_assignment`.`id`=`campus_agenda`.`assignment_id`
                            INNER JOIN `campus_discipline` ON `campus_discipline`.`id`=`campus_assignment`.`discipline_id`
                            INNER JOIN `campus_agenda_rel_group` ON `campus_agenda`.`id`=`campus_agenda_rel_group`.`agenda_id`
                        WHERE  (`campus_agenda_rel_group`.`group_id`=' . $groupfilter . ') AND date>=' .
            time() . ' AND `tasks` <>"" ORDER BY `date`';
        $result = mysql_query($query);
        $newContent .= '<br><b>' . get_lang("txtTasks") . ':</b><br>';

        while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
        {
            $newContent .= htmlentities(DatetimeUtilities::format_locale_date('%e %B', $rij['date'])) . ':&nbsp;';
            $newContent .= '<div style="display:inline;" >' . htmlentities($rij['code']) . '</div>&nbsp;';
            $newContent .= '<div style="display:inline;" >' .
                str_replace(' ', '&nbsp;', substr(htmlentities(utf8_decode($rij['tasks'])), 0, 25)) .
                (strlen(htmlentities(utf8_decode($rij['tasks']))) > 25 ? '...' : '') . '</div><br>';
        }

        $ajax_result->set_property("ajaxid", $newContent);

        $ajax_result->display();
    }
}

?>