<?php

namespace application\campus;

use common\libraries\AjaxManager;
use common\libraries\JsonAjaxResult;
use common\libraries\Request;
use common\libraries\DatetimeUtilities;
use common\libraries\Translation;


/**
 * Feed to return the course groups of this course
 *
 * @author Sven Vanpoucke
 * @package application.weblcms
 */
class CampusAjaxDeviceInfo extends AjaxManager
{

    function required_parameters()
    {
        return array('sendid');
    }

    /**
     * Runs this ajax component
     */
    function run()
    {
        $ajax_result = new JsonAjaxResult(200);
        campus::connect_db();

        $device_id=$this->get_parameter('sendid');
        $newContent = '';
        $query =  'SELECT `code`, `comment`, `resource_id`, `position`, `macid`, `purchase_date`, `purchase_info` , `type`, `state` FROM `campus_it_device` WHERE `id`=' . $device_id ;
        $result = mysql_query($query);// or die(mysql_error());
        list($code, $comment, $resource_id, $position, $macid, $purchase_date, $purchase_info, $devicetype, $devicestate) = mysql_fetch_row($result);

        $newContent .= '<table border=0 cellspacing="0" cellpadding="0">
          	<tr>
                <td align="right">
                    ' . Translation::get('labelUniqueID') . ':
                </td>
                <td>
                    ' . htmlentities($device_id) . '
                </td>
            </tr>
            <tr>
                <td align="right">
                    ' . Translation::get('labelDeviceType') . ':
                </td>
                <td>';
         $subquery = 'SELECT `info` FROM `campus_it_device_info` WHERE `id`=' . $devicetype;
         $subresult = mysql_query($subquery);
         list($info) = mysql_fetch_row($subresult);
         $newContent .= $info . ' (' . Translation::get('txtDeviceType_' . $devicetype) . ')';
         $newContent .= '</td>
             </tr>
             <tr>
                 <td align="right">
                     ' . Translation::get('labelDeviceIdentification') . ':
                 </td>
                 <td>
                     ' . htmlentities($code) . '
                 </td>
             </tr>
             <tr>
                 <td align="right">
                     ' . Translation::get('labelResource') . ':
                 </td>
                 <td>';
         $subquery = "SELECT `code`, `comment` FROM `campus_resources` WHERE `resource_id`=" . $resource_id . " ";
         $subresult = mysql_query($subquery);
         list($code, $resource_comment) = mysql_fetch_row($subresult);
         $newContent .= htmlentities($code . " (" . $resource_comment . ")");
         $newContent .= '</td>
             </tr>
             <tr>
                 <td align="right" valign="top">
                     ' . Translation::get('labelPosition') . ':
                 </td>
                 <td>';
         $newContent .= $position;
         $newContent .= '
                 </td>
             </tr>
             <tr>
                 <td align="right">
                     ' . Translation::get('labelComment') . ':
                 </td>
                 <td>
                     ' . htmlentities($comment) . '
                 </td>
             </tr>
             <tr>
                 <td align="right">
                     ' . Translation::get('labelPurchaseDate') . ':
                 </td>
                 <td >
                     ' . DatetimeUtilities::format_locale_date('%Y-%m-%d', $purchase_date) . '
                 </td>
             </tr>
             <tr>
                 <td align="right">
                     ' . Translation::get('labelPurchaseInfo') . ':
                 </td>
                 <td >
                 ' . htmlentities($purchase_info) . '
                 </td>
             </tr>
             <tr>
                 <td align="right">
                     ' . Translation::get('labelmacid') . ':
                 </td>
                 <td >
                     ' .htmlentities( $macid). '
                 </td>
             </tr>
             <tr>
                 <td  align="right">
                     ' . Translation::get('labelDeviceState') . ':
                 </td>
                 <td>
                     ' . Translation::get('devicestate_' . $devicestate) . '
                 </td>
             </tr>
                 ';

       // GET existing device info

         $query = 'SELECT DISTINCT t1.`id`, `category`, `readonly`, `system`,`multiple`, `type`,t2.`category_id` as device_info_exists FROM `campus_it_device_info_category` t1
                         LEFT JOIN (`campus_it_device_info` as t2
                                 INNER JOIN `campus_it_device_rel_info` t3
                                     ON t2.`id` = t3.`info_id` AND t3.`device_id`=' . $device_id . ')
                                 ON t2.`category_id` = t1.`id` AND t2.`category_id` > 0
                         WHERE `type`=0 OR `type`=' . $devicetype . '   ORDER BY t1.`display_order`';
         $result = mysql_query($query) or die(mysql_error());
         while (list($infocategory_id, $infocategory, $readonly, $system, $multiple, $type, $device_info_exists) = mysql_fetch_row($result))
         {
             if (($device_info_exists > 0) || (array_key_exists($infocategory_id, $info_id)))
             {
                 $newContent .= '<tr>
                     <td  align="right" valign="top">
                         ' . htmlentities($infocategory) . ':
                     </td>
                     <td>';
                 $subquery = 'SELECT t1.`id`, `info` FROM `campus_it_device_info` t1
                                 INNER JOIN `campus_it_device_rel_info` t2 ON t1.`id` = t2.`info_id` AND t2.`device_id`=
                                 ' . $device_id . '
                                 WHERE `category_id`=' . $infocategory_id . ' ORDER BY t1.`info`';
                 $subresult = mysql_query($subquery);
                 while ($rij = mysql_fetch_array($subresult, MYSQL_ASSOC))
                 {
                     $newContent .=  htmlentities($rij['info']) . '<br>';
                 }
                 $newContent .=  '
                     </td>
                    </tr>';

             }
         }



        $newContent .= "</table>";


        $ajax_result->set_property("ajaxid", $newContent);

        $ajax_result->display();
    }
}

?>