<?php

namespace application\campus;

use common\libraries\AjaxManager;
use common\libraries\JsonAjaxResult;
use common\libraries\Request;
use common\libraries\DatetimeUtilities;

/**
 * Feed to return the course groups of this course
 *
 * @author Sven Vanpoucke
 * @package application.weblcms
 */
class CampusAjaxDisciplineInfo extends AjaxManager
{

    function required_parameters()
    {
        return array('sendid');
    }

    /**
     * Runs this ajax component
     */
    function run()
    {
        $ajax_result = new JsonAjaxResult(200);

        $department_id = intval(campus::get_SESSION("department_id"));

        $activeroster = campus::get_activeroster($department_id, $dateselect);
        if ($activeroster['curriculum_id'] > 0)
        {
            // do some stuff based on $arg like query data from a database and
            // put it into a variable like $newContent
            $newContent = '';
            $sql = "SELECT DISTINCT `official_code`, `lastname`, `firstname`, `group_group`.`code`
                    FROM `campus_assignment`
                        INNER JOIN `campus_assignment_rel_teacher`
                            ON `campus_assignment`.`id`=`campus_assignment_rel_teacher`.`assignment_id`
                        INNER JOIN `user_user`
                            ON `user_user`.`id`=`campus_assignment_rel_teacher`.`user_id`
                        INNER JOIN `campus_assignment_rel_group`
                            ON `campus_assignment_rel_teacher`.`assignment_id`=`campus_assignment_rel_group`.`assignment_id`
                        INNER JOIN `group_group`
                            ON `campus_assignment_rel_group`.`group_id` = `group_group`.`id`
                    WHERE `campus_assignment`.`curriculum_id`=" . $activeroster['curriculum_id'] . " AND `campus_assignment`.`discipline_id`=" . $this->get_parameter('sendid') . " ORDER BY `official_code`,`code`";
            $result = mysql_query($sql);
            while ($rij = mysql_fetch_array($result, MYSQL_ASSOC))
            {
                $newContent .= htmlentities($rij['official_code'] . " " . $rij['code']) . '<br />';
            }
            if ($newContent == '')
            {
                $newContent = get_lang('msgNoAssignment');
            }
        }
        else
        {
            $newContent = get_lang('msgNoRoster');
        }

        $ajax_result->set_property("ajaxid", $newContent);



        $ajax_result->display();
    }

}

?>