<?php

namespace application\campus;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
    private static $map = array(
        'Autoloader' => '/autoloader.class.php',
        'DataManager' => '/package/install/data_manager/data_manager.class.php',
        'DoctrineDataManager' => '/package/install/data_manager/implementation/doctrine.class.php',
        'Installer' => '/package/install/installer.class.php',

        'Manager' => '/lib/manager/manager.class.php',
        'AgendaComponent' => '/lib/manager/component/agenda.class.php',
        'BrowserComponent' => '/lib/manager/component/browser.class.php',
        'CampusAdminComponent' => '/lib/manager/component/campus_admin.class.php',
        'InfoboardComponent' => '/lib/manager/component/infoboard.class.php',
        'ItSupportComponent' => '/lib/manager/component/it_support.class.php',
        'ObjectivetrackingComponent' => '/lib/manager/component/objectivetracking.class.php',
        'ReservationrosterComponent' => '/lib/manager/component/reservationroster.class.php',
        'RosterComponent' => '/lib/manager/component/roster.class.php',
        'StudentlistComponent' => '/lib/manager/component/studentlist.class.php',
        'StudentreportComponent' => '/lib/manager/component/studentreport.class.php',
        'StudentrosterComponent' => '/lib/manager/component/studentroster.class.php',
        'StudenttrackingComponent' => '/lib/manager/component/studenttracking.class.php',
        'TeacherlistComponent' => '/lib/manager/component/teacherlist.class.php',
        'CampusAjaxAgendaInfo' => '/ajax/agenda_info.class.php',
        'CampusAjaxAgendaTasks' => '/ajax/agenda_tasks.class.php',
        'CampusAjaxAgendaPersonalInfo' => '/ajax/agenda_personal_info.class.php',
        'CampusAjaxDisciplineInfo' => '/ajax/discipline_info.class.php',
        'CampusAjaxDeviceInfo' => '/ajax/device_info.class.php',
        'CampusAjaxItInfoStat' => '/ajax/it_info_stat.class.php',
        'CampusAjaxObjectiveInfo' => '/ajax/objective_info.class.php',
        'CampusAjaxUserInfo' => '/ajax/user_info.class.php',
        'campus' => '/../old_php/inc/campus.lib.php',
        'Activator' => '/package/activate/activator.class.php',
        'Deactivator' => '/package/deactivate/deactivator.class.php'
  
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}

?>