<?php

namespace application\campus;

use common\libraries\Path;
use common\libraries\Translation;
use common\libraries\Application;
use common\libraries\ActionBarRenderer;
use common\libraries\ToolbarItem;
use common\libraries\Theme;
use common\libraries\Display;
use common\libraries\Utilities;
use common\libraries\BreadcrumbTrail;
use common\libraries\Breadcrumb;
use common\libraries\PlatformSetting;

/**
 * @package application.campus.campus.component
 */

/**
 * Campus component which allows the user to browse the campus application
 * @author Sven Vanpoucke
 * @author Theunis Ludwig
 */
class MailComponent extends Manager
{

    function run()
    {
        $_uid = $this->get_user_id();
        if (intval($_uid) > 0)
        {

            $googleappsdomain = PlatformSetting::get('mail_domain', 'application\google_sso');
            $id = intval(campus::get_POST_GET("id"));
            if ($id > 0)
            {
                $emails = campus::get_emailoverride($this->get_user_id());
                if ($emails[$id]['user_id'] == $_uid)
                {
                    $email_override = $emails[$id]['email'];
                    $loginUser = explode('@', $email_override);
                    if ($loginUser[1] == $googleappsdomain)
                    {
                        $_SESSION['email_override'] = $email_override;
                        //Display::normal_message($loginUser[0] . '[AT]' . $loginUser[1]);
                        header("location: http://mail.google.com/a/" . $googleappsdomain . "/asc");
                    }
                 }
            }
            $this->display_header();
            Display :: warning_message(Translation :: get('NotAllowedHere'));
            $this->display_footer();
            exit();
        }
        else
        {

            $this->display_header();
            Display :: warning_message(Translation :: get('NotAllowedHere'));
            $this->display_footer();
            exit();
        }
    }

}

?>