<?php

namespace application\campus;

use common\libraries\Path;
use common\libraries\Translation;
use common\libraries\Application;
use common\libraries\ActionBarRenderer;
use common\libraries\ToolbarItem;
use common\libraries\Theme;
use common\libraries\ConditionProperty;
use common\libraries\Utilities;
use common\libraries\BreadcrumbTrail;
use common\libraries\Breadcrumb;

/**
 * @package application.campus.campus.component
 */

/**
 * Campus component which allows the user to browse the campus application
 * @author Sven Vanpoucke
 * @author Theunis Ludwig
 */
class StudentreportComponent extends Manager
{
    const REPORT_COLUMN_VIEW = 1;
    const REPORT_TREE_VIEW = 2;
    const REPORT_SELECT_VIEW = 3;

    function run()
    {
        // === old ===
        // login required...
        $_uid = $this->get_user_id();
        if (intval($_uid) == 0)
        {
            $this->display_header();
            Display :: warning_message(Translation :: get('NotAllowedHere'));
            $this->display_footer();
            exit();
        }
        //$is_teacher = campus::is_department_teacher($_uid);
        $is_platformadmin = $this->get_user()->is_platform_admin();
        // get department from user
        $departmentStruc = campus::get_department($_uid);

        $is_teacher = campus::is_department_teacher($_uid);

        /*
          ==============================================================================
          POST & GET vars, check for default value?.
          ==============================================================================
         */
        $department_id = intval(campus::get_SESSION("department_id", key($departmentStruc)));
        $page = campus::get_POST_GET("page", "studentreport");
        // get rights of user in campus plugin .....
        $admin = campus::get_rights($_uid, $department_id);

        if ((substr($page, -4) == '2csv') || (substr($page, -4) == '2pdf') || (substr($page, -7) == '2excell') || ($page == 'projection'))
        {
            // no html arround content
            include Path :: get_web_application_path('campus') . '/old_php/studentreport/' . $page . '.php';
        }
        else
        {
            //$trail = BreadcrumbTrail :: get_instance();
            //$trail->add(new Breadcrumb($this->get_url(array('page' => $page)), Translation :: get('page_' . $page)));
            //$trail->add_help('dynamic form general');
            $this->display_header($trail, null);

            echo '<div class="clear"></div>';
            echo $this->display_menu();

            echo '<div id="tool_browser_right">';
            //  echo $this->display_campus_tabs();
            echo campus :: Display_departments($departmentStruc, $department_id, $page);
            include ( Path :: get_web_application_path('campus') . '/old_php/studentreport/' . $page . '.php');
            echo '</div>';


            $this->display_footer();
        }
    }

}

?>