<?php

namespace application\campus;

use common\libraries\WebApplicationInstaller;
use common\libraries\WebApplication;

/**
 * @package campus.install
 */

/**
 * This installer can be used to create the storage structure for the
 * campus application.
 *
 * @author Sven Vanpoucke
 * @author Theunis Ludwig
 */
class Installer extends WebApplicationInstaller
{

    /**
     * Constructor
     */
    function __construct($values)
    {
        parent :: __construct($values, DataManager :: get_instance());
    }

    /**
     * Runs the install-script.
     */
    function install_extra()
    {
        if (!parent :: install_extra())
        {
            return false;
        }
        create_it();
        return true;
    }

    function get_path()
    {
        return parent :: get_path();
    }

}

function create_it()
{
    campus::connect_db();
    mysql_query("INSERT INTO `campus_it_device_info_category` VALUES
					 (1,'devicename_type_1',0,1,0,1,1),
					 (2,'devicename_type_2',0,1,0,2,2),
					 (3,'devicename_type_3',0,1,0,3,3),
					 (4,'devicename_type_4',0,1,0,4,4),
					 (5,'devicename_type_5',0,1,0,5,5),
					 (6,'devicename_type_6',0,1,0,6,6),
					 (7,'devicename_type_7',0,1,0,7,7),
					 (8,'devicename_type_8',0,1,0,8,8),
					 (9,'devicename_type_9',0,1,0,9,9),
					 (10,'netwerkverbinding',1,0,0,1,0),
					 (11,'moederbord',0,0,0,2,0),
					 (12,'processor',0,0,1,3,0),
					 (13,'geheugen',0,0,1,4,0),
					 (14,'beeldschermkaart',0,0,1,5,0),
					 (15,'netwerkkaart',0,0,1,6,0),
					 (16,'opslagmedia',0,0,1,7,0),
					 (17,'OS',0,0,1,8,0),
					 (18,'software',0,0,1,9,0),
					 (19,'licentie type',1,0,0,10,0),
					 (20,'gebruik',1,0,0,11,0),
					 (21,'generatie',1,0,0,12,0),
					 (26,'PC beveiliging',1,0,0,13,0),
					 (27,'antivirus',1,0,0,14,0)");
    mysql_query("INSERT INTO `campus_it_device_info` VALUES
					 (1,'PC',0,1),
					 (2,'LT',0,2),
					 (3,'DP',0,3),
					 (4,'PR',0,4),
					 (5,'BM',0,5),
					 (6,'SW',0,6),
					 (7,'SC',0,7),
					 (8,'TC',0,8),
					 (9,'DV',0,9),
                                         (10,'G5: Intel Pentium, Pentium MMX, AMD K5, Cyrix 6X86 (M1) en ouder',21,1),
					 (11,'G6: Intel Pentium Pro, Pentium II, Celeron(MMX), AMD K6, Cyrix 6x86M(M2)',21,2),
					 (12,'G7: (< 1 GHz), Intel Pentium III, Celeron, AMD K7 (Athlon), Duron, VIA Cyrix III',21,3),
					 (13,'G8: (>= 1 GHz en < 3GHz), Intel Pentium IV, Celeron II, AMD Athlon XP, Duron',21,4),
					 (14,'G9: (>= 3 GHz), Intel Pentium IV, Pentium D, Celeron, Centrino, AMD K8 (Athlon64, Sempron, Opteron)',21,5),
					 (15,'G10: Core 2 duo, Core 2 extreme en Core 2 Quad, Core I7, Core I5, AMD K10(Phenom, Opteron, Athlon64 X2)',21,6),
					 (17,'MAC: Macintosh van Apple',21,7),
					 (18,'andere: vb: minicomputers met terminals',21,8),
					 (19,'in computerklassen voor leerlingen',20,1),
					 (20,'in vaklokalen voor leerlingen',20,2),
					 (21,'in leslokalen voor leerlingen',20,3),
					 (22,'in OLC, mediatheek,bib enz. voor leerlingen',20,4),
					 (23,'mobiel voor leerlingen (uitlenen)',20,5),
					 (24,'voor leerkrachten',20,6)");

    mysql_query("INSERT INTO `campus_it_device_info` VALUES
					 (26,'voor administratie',20,7),
					 (28,'servers',20,8),
					 (29,'mobiel voor leerkrachten (uitlenen)',20,9),
					 (30,'Network enabled',10,1),
					 (31,'Network disabled',10,2),
					 (32,'MS-KIS',19,1),
					 (33,'OEM',19,2),
					 (34,'geen',26,1),
					 (35,'illusion',26,2),
					 (36,'deepFreeze',26,2),
					 (37,'geen',27,1),
					 (38,'unmanaged',27,2),
					 (39,'managed',27,3)");

    mysql_query("INSERT INTO `campus_it_defect_category` VALUES
					 (1,'Het toestel is terug in orde (zonder interventie).'),
					 (2,'Het toestel is hersteld.'),
 					 (3,'Er is een probleem met de computer'),
					 (4,'Er is een probleem met toetsenbord of muis'),
					 (5,'Er is een probleem met het scherm.'),
					 (6,'Er is een probleem met het afdrukken.'),
					 (7,'Er is een probleem met de data projector.'),
					 (8,'Er is een probleem met het diskette apparaat.'),
					 (9,'Er is een probleem met de USB poort.'),
					 (10,'Er is een probleem met de netwerkverbinding.'),
					 (11,'Er is een probleem met internet'),
					 (12,'De computer moet nog geïnstalleerd worden.')");
}

?>